/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(oe){for(var t=[],v=0,T=oe.length;v<T;v++)t[v]=$e[oe[v]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:jt,setPrototypeOf:zt,isFrozen:ei,getPrototypeOf:ti,getOwnPropertyDescriptor:ii}=Object;let{freeze:it,seal:ht,create:ni}=Object,{apply:Nt,construct:Ft}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,v,T){return t.apply(v,T)}),it||(it=function(t){return t}),ht||(ht=function(t){return t}),Ft||(Ft=function(t,v){return new t(...v)});const si=lt(Array.prototype.forEach),Ht=lt(Array.prototype.pop),pt=lt(Array.prototype.push),At=lt(String.prototype.toLowerCase),Tt=lt(String.prototype.toString),ri=lt(String.prototype.match),ut=lt(String.prototype.replace),oi=lt(String.prototype.indexOf),li=lt(String.prototype.trim),ot=lt(RegExp.prototype.test),wt=ai(TypeError);function lt(oe){return function(t){for(var v=arguments.length,T=new Array(v>1?v-1:0),i=1;i<v;i++)T[i-1]=arguments[i];return Nt(oe,t,T)}}function ai(oe){return function(){for(var t=arguments.length,v=new Array(t),T=0;T<t;T++)v[T]=arguments[T];return Ft(oe,v)}}function He(oe,t,v){var T;v=(T=v)!==null&&T!==void 0?T:At,zt&&zt(oe,null);let i=t.length;for(;i--;){let U=t[i];if(typeof U=="string"){const w=v(U);w!==U&&(ei(t)||(t[i]=w),U=w)}oe[U]=!0}return oe}function mt(oe){const t=ni(null);for(const[v,T]of jt(oe))t[v]=T;return t}function kt(oe,t){for(;oe!==null;){const T=ii(oe,t);if(T){if(T.get)return lt(T.get);if(typeof T.value=="function")return lt(T.value)}oe=ti(oe)}function v(T){return console.warn("fallback value for",T),null}return v}const Ut=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ot=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),hi=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ui=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=it(["#text"]),_t=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Rt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ci=ht(/\{\{[\w\W]*|[\w\W]*\}\}/gm),fi=ht(/<%[\w\W]*|[\w\W]*%>/gm),di=ht(/\${[\w\W]*}/gm),gi=ht(/^data-[\-\w.\u00B7-\uFFFF]/),mi=ht(/^aria-[\-\w]+$/),Qt=ht(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),bi=ht(/^(?:\w+script|data):/i),$i=ht(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=ht(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:ci,ERB_EXPR:fi,TMPLIT_EXPR:di,DATA_ATTR:gi,ARIA_ATTR:mi,IS_ALLOWED_URI:Qt,IS_SCRIPT_OR_DATA:bi,ATTR_WHITESPACE:$i,DOCTYPE_NAME:Vt});const pi=()=>typeof window>"u"?null:window,wi=function(t,v){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let T=null;const i="data-tt-policy-suffix";v&&v.hasAttribute(i)&&(T=v.getAttribute(i));const U="dompurify"+(T?"#"+T:"");try{return t.createPolicy(U,{createHTML(w){return w},createScriptURL(w){return w}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function xt(){let oe=arguments.length>0&&arguments[0]!==void 0?arguments[0]:pi();const t=Ie=>xt(Ie);if(t.version="3.0.5",t.removed=[],!oe||!oe.document||oe.document.nodeType!==9)return t.isSupported=!1,t;const v=oe.document,T=v.currentScript;let{document:i}=oe;const{DocumentFragment:U,HTMLTemplateElement:w,Node:A,Element:u,NodeFilter:c,NamedNodeMap:m=oe.NamedNodeMap||oe.MozNamedAttrMap,HTMLFormElement:O,DOMParser:s,trustedTypes:l}=oe,e=u.prototype,a=kt(e,"cloneNode"),h=kt(e,"nextSibling"),g=kt(e,"childNodes"),n=kt(e,"parentNode");if(typeof w=="function"){const Ie=i.createElement("template");Ie.content&&Ie.content.ownerDocument&&(i=Ie.content.ownerDocument)}let r,b="";const{implementation:f,createNodeIterator:o,createDocumentFragment:F,getElementsByTagName:j}=i,{importNode:L}=v;let d={};t.isSupported=typeof jt=="function"&&typeof n=="function"&&f&&f.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:D,ERB_EXPR:B,TMPLIT_EXPR:z,DATA_ATTR:_,ARIA_ATTR:I,IS_SCRIPT_OR_DATA:N,ATTR_WHITESPACE:Z}=Kt;let{IS_ALLOWED_URI:ee}=Kt,ue=null;const ae=He({},[...Ut,...Ot,...Lt,...It,...Wt]);let se=null;const re=He({},[..._t,...Rt,...qt,...St]);let be=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Se=null,Oe=null,Te=!0,de=!0,ie=!1,fe=!0,Y=!1,q=!1,X=!1,S=!1,Q=!1,$=!1,W=!1,V=!0,p=!1;const y="user-content-";let E=!0,M=!1,k={},R=null;const C=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let P=null;const H=He({},["audio","video","img","source","image","track"]);let x=null;const te=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ne="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",ve="http://www.w3.org/1999/xhtml";let Ce=ve,Ae=!1,De=null;const Re=He({},[ne,ge,ve],Tt);let Fe;const Qe=["application/xhtml+xml","text/html"],ze="text/html";let Me,Ke=null;const J=i.createElement("form"),he=function(ce){return ce instanceof RegExp||ce instanceof Function},we=function(ce){if(!(Ke&&Ke===ce)){if((!ce||typeof ce!="object")&&(ce={}),ce=mt(ce),Fe=Qe.indexOf(ce.PARSER_MEDIA_TYPE)===-1?Fe=ze:Fe=ce.PARSER_MEDIA_TYPE,Me=Fe==="application/xhtml+xml"?Tt:At,ue="ALLOWED_TAGS"in ce?He({},ce.ALLOWED_TAGS,Me):ae,se="ALLOWED_ATTR"in ce?He({},ce.ALLOWED_ATTR,Me):re,De="ALLOWED_NAMESPACES"in ce?He({},ce.ALLOWED_NAMESPACES,Tt):Re,x="ADD_URI_SAFE_ATTR"in ce?He(mt(te),ce.ADD_URI_SAFE_ATTR,Me):te,P="ADD_DATA_URI_TAGS"in ce?He(mt(H),ce.ADD_DATA_URI_TAGS,Me):H,R="FORBID_CONTENTS"in ce?He({},ce.FORBID_CONTENTS,Me):C,Se="FORBID_TAGS"in ce?He({},ce.FORBID_TAGS,Me):{},Oe="FORBID_ATTR"in ce?He({},ce.FORBID_ATTR,Me):{},k="USE_PROFILES"in ce?ce.USE_PROFILES:!1,Te=ce.ALLOW_ARIA_ATTR!==!1,de=ce.ALLOW_DATA_ATTR!==!1,ie=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,fe=ce.ALLOW_SELF_CLOSE_IN_ATTR!==!1,Y=ce.SAFE_FOR_TEMPLATES||!1,q=ce.WHOLE_DOCUMENT||!1,Q=ce.RETURN_DOM||!1,$=ce.RETURN_DOM_FRAGMENT||!1,W=ce.RETURN_TRUSTED_TYPE||!1,S=ce.FORCE_BODY||!1,V=ce.SANITIZE_DOM!==!1,p=ce.SANITIZE_NAMED_PROPS||!1,E=ce.KEEP_CONTENT!==!1,M=ce.IN_PLACE||!1,ee=ce.ALLOWED_URI_REGEXP||Qt,Ce=ce.NAMESPACE||ve,be=ce.CUSTOM_ELEMENT_HANDLING||{},ce.CUSTOM_ELEMENT_HANDLING&&he(ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(be.tagNameCheck=ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&he(ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(be.attributeNameCheck=ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&typeof ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(be.allowCustomizedBuiltInElements=ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),Y&&(de=!1),$&&(Q=!0),k&&(ue=He({},[...Wt]),se=[],k.html===!0&&(He(ue,Ut),He(se,_t)),k.svg===!0&&(He(ue,Ot),He(se,Rt),He(se,St)),k.svgFilters===!0&&(He(ue,Lt),He(se,Rt),He(se,St)),k.mathMl===!0&&(He(ue,It),He(se,qt),He(se,St))),ce.ADD_TAGS&&(ue===ae&&(ue=mt(ue)),He(ue,ce.ADD_TAGS,Me)),ce.ADD_ATTR&&(se===re&&(se=mt(se)),He(se,ce.ADD_ATTR,Me)),ce.ADD_URI_SAFE_ATTR&&He(x,ce.ADD_URI_SAFE_ATTR,Me),ce.FORBID_CONTENTS&&(R===C&&(R=mt(R)),He(R,ce.FORBID_CONTENTS,Me)),E&&(ue["#text"]=!0),q&&He(ue,["html","head","body"]),ue.table&&(He(ue,["tbody"]),delete Se.tbody),ce.TRUSTED_TYPES_POLICY){if(typeof ce.TRUSTED_TYPES_POLICY.createHTML!="function")throw wt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ce.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw wt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=ce.TRUSTED_TYPES_POLICY,b=r.createHTML("")}else r===void 0&&(r=wi(l,T)),r!==null&&typeof b=="string"&&(b=r.createHTML(""));it&&it(ce),Ke=ce}},ye=He({},["mi","mo","mn","ms","mtext"]),Pe=He({},["foreignobject","desc","title","annotation-xml"]),Be=He({},["title","style","font","a","script"]),Ue=He({},Ot);He(Ue,Lt),He(Ue,hi);const Ze=He({},It);He(Ze,ui);const Je=function(ce){let ke=n(ce);(!ke||!ke.tagName)&&(ke={namespaceURI:Ce,tagName:"template"});const Ne=At(ce.tagName),_e=At(ke.tagName);return De[ce.namespaceURI]?ce.namespaceURI===ge?ke.namespaceURI===ve?Ne==="svg":ke.namespaceURI===ne?Ne==="svg"&&(_e==="annotation-xml"||ye[_e]):!!Ue[Ne]:ce.namespaceURI===ne?ke.namespaceURI===ve?Ne==="math":ke.namespaceURI===ge?Ne==="math"&&Pe[_e]:!!Ze[Ne]:ce.namespaceURI===ve?ke.namespaceURI===ge&&!Pe[_e]||ke.namespaceURI===ne&&!ye[_e]?!1:!Ze[Ne]&&(Be[Ne]||!Ue[Ne]):!!(Fe==="application/xhtml+xml"&&De[ce.namespaceURI]):!1},xe=function(ce){pt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{ce.remove()}},We=function(ce,ke){try{pt(t.removed,{attribute:ke.getAttributeNode(ce),from:ke})}catch{pt(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(ce),ce==="is"&&!se[ce])if(Q||$)try{xe(ke)}catch{}else try{ke.setAttribute(ce,"")}catch{}},tt=function(ce){let ke,Ne;if(S)ce="<remove></remove>"+ce;else{const rt=ri(ce,/^[\r\n\t ]+/);Ne=rt&&rt[0]}Fe==="application/xhtml+xml"&&Ce===ve&&(ce='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ce+"</body></html>");const _e=r?r.createHTML(ce):ce;if(Ce===ve)try{ke=new s().parseFromString(_e,Fe)}catch{}if(!ke||!ke.documentElement){ke=f.createDocument(Ce,"template",null);try{ke.documentElement.innerHTML=Ae?b:_e}catch{}}const et=ke.body||ke.documentElement;return ce&&Ne&&et.insertBefore(i.createTextNode(Ne),et.childNodes[0]||null),Ce===ve?j.call(ke,q?"html":"body")[0]:q?ke.documentElement:et},nt=function(ce){return o.call(ce.ownerDocument||ce,ce,c.SHOW_ELEMENT|c.SHOW_COMMENT|c.SHOW_TEXT,null,!1)},dt=function(ce){return ce instanceof O&&(typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof m)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"||typeof ce.hasChildNodes!="function")},ft=function(ce){return typeof A=="object"?ce instanceof A:ce&&typeof ce=="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},ct=function(ce,ke,Ne){d[ce]&&si(d[ce],_e=>{_e.call(t,ke,Ne,Ke)})},Ct=function(ce){let ke;if(ct("beforeSanitizeElements",ce,null),dt(ce))return xe(ce),!0;const Ne=Me(ce.nodeName);if(ct("uponSanitizeElement",ce,{tagName:Ne,allowedTags:ue}),ce.hasChildNodes()&&!ft(ce.firstElementChild)&&(!ft(ce.content)||!ft(ce.content.firstElementChild))&&ot(/<[/\w]/g,ce.innerHTML)&&ot(/<[/\w]/g,ce.textContent))return xe(ce),!0;if(!ue[Ne]||Se[Ne]){if(!Se[Ne]&&vt(Ne)&&(be.tagNameCheck instanceof RegExp&&ot(be.tagNameCheck,Ne)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Ne)))return!1;if(E&&!R[Ne]){const _e=n(ce)||ce.parentNode,et=g(ce)||ce.childNodes;if(et&&_e){const rt=et.length;for(let Ge=rt-1;Ge>=0;--Ge)_e.insertBefore(a(et[Ge],!0),h(ce))}}return xe(ce),!0}return ce instanceof u&&!Je(ce)||(Ne==="noscript"||Ne==="noembed"||Ne==="noframes")&&ot(/<\/no(script|embed|frames)/i,ce.innerHTML)?(xe(ce),!0):(Y&&ce.nodeType===3&&(ke=ce.textContent,ke=ut(ke,D," "),ke=ut(ke,B," "),ke=ut(ke,z," "),ce.textContent!==ke&&(pt(t.removed,{element:ce.cloneNode()}),ce.textContent=ke)),ct("afterSanitizeElements",ce,null),!1)},gt=function(ce,ke,Ne){if(V&&(ke==="id"||ke==="name")&&(Ne in i||Ne in J))return!1;if(!(de&&!Oe[ke]&&ot(_,ke))){if(!(Te&&ot(I,ke))){if(!se[ke]||Oe[ke]){if(!(vt(ce)&&(be.tagNameCheck instanceof RegExp&&ot(be.tagNameCheck,ce)||be.tagNameCheck instanceof Function&&be.tagNameCheck(ce))&&(be.attributeNameCheck instanceof RegExp&&ot(be.attributeNameCheck,ke)||be.attributeNameCheck instanceof Function&&be.attributeNameCheck(ke))||ke==="is"&&be.allowCustomizedBuiltInElements&&(be.tagNameCheck instanceof RegExp&&ot(be.tagNameCheck,Ne)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Ne))))return!1}else if(!x[ke]){if(!ot(ee,ut(Ne,Z,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&ce!=="script"&&oi(Ne,"data:")===0&&P[ce])){if(!(ie&&!ot(N,ut(Ne,Z,"")))){if(Ne)return!1}}}}}}return!0},vt=function(ce){return ce.indexOf("-")>0},Dt=function(ce){let ke,Ne,_e,et;ct("beforeSanitizeAttributes",ce,null);const{attributes:rt}=ce;if(!rt)return;const Ge={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:se};for(et=rt.length;et--;){ke=rt[et];const{name:at,namespaceURI:bt}=ke;if(Ne=at==="value"?ke.value:li(ke.value),_e=Me(at),Ge.attrName=_e,Ge.attrValue=Ne,Ge.keepAttr=!0,Ge.forceKeepAttr=void 0,ct("uponSanitizeAttribute",ce,Ge),Ne=Ge.attrValue,Ge.forceKeepAttr||(We(at,ce),!Ge.keepAttr))continue;if(!fe&&ot(/\/>/i,Ne)){We(at,ce);continue}Y&&(Ne=ut(Ne,D," "),Ne=ut(Ne,B," "),Ne=ut(Ne,z," "));const yt=Me(ce.nodeName);if(gt(yt,_e,Ne)){if(p&&(_e==="id"||_e==="name")&&(We(at,ce),Ne=y+Ne),r&&typeof l=="object"&&typeof l.getAttributeType=="function"&&!bt)switch(l.getAttributeType(yt,_e)){case"TrustedHTML":{Ne=r.createHTML(Ne);break}case"TrustedScriptURL":{Ne=r.createScriptURL(Ne);break}}try{bt?ce.setAttributeNS(bt,at,Ne):ce.setAttribute(at,Ne),Ht(t.removed)}catch{}}}ct("afterSanitizeAttributes",ce,null)},Mt=function Ie(ce){let ke;const Ne=nt(ce);for(ct("beforeSanitizeShadowDOM",ce,null);ke=Ne.nextNode();)ct("uponSanitizeShadowNode",ke,null),!Ct(ke)&&(ke.content instanceof U&&Ie(ke.content),Dt(ke));ct("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Ie){let ce=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Ne,_e,et;if(Ae=!Ie,Ae&&(Ie="<!-->"),typeof Ie!="string"&&!ft(Ie))if(typeof Ie.toString=="function"){if(Ie=Ie.toString(),typeof Ie!="string")throw wt("dirty is not a string, aborting")}else throw wt("toString is not a function");if(!t.isSupported)return Ie;if(X||we(ce),t.removed=[],typeof Ie=="string"&&(M=!1),M){if(Ie.nodeName){const at=Me(Ie.nodeName);if(!ue[at]||Se[at])throw wt("root node is forbidden and cannot be sanitized in-place")}}else if(Ie instanceof A)ke=tt("<!---->"),Ne=ke.ownerDocument.importNode(Ie,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?ke=Ne:ke.appendChild(Ne);else{if(!Q&&!Y&&!q&&Ie.indexOf("<")===-1)return r&&W?r.createHTML(Ie):Ie;if(ke=tt(Ie),!ke)return Q?null:W?b:""}ke&&S&&xe(ke.firstChild);const rt=nt(M?Ie:ke);for(;_e=rt.nextNode();)Ct(_e)||(_e.content instanceof U&&Mt(_e.content),Dt(_e));if(M)return Ie;if(Q){if($)for(et=F.call(ke.ownerDocument);ke.firstChild;)et.appendChild(ke.firstChild);else et=ke;return(se.shadowroot||se.shadowrootmode)&&(et=L.call(v,et,!0)),et}let Ge=q?ke.outerHTML:ke.innerHTML;return q&&ue["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&ot(Vt,ke.ownerDocument.doctype.name)&&(Ge="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+Ge),Y&&(Ge=ut(Ge,D," "),Ge=ut(Ge,B," "),Ge=ut(Ge,z," ")),r&&W?r.createHTML(Ge):Ge},t.setConfig=function(Ie){we(Ie),X=!0},t.clearConfig=function(){Ke=null,X=!1},t.isValidAttribute=function(Ie,ce,ke){Ke||we({});const Ne=Me(Ie),_e=Me(ce);return gt(Ne,_e,ke)},t.addHook=function(Ie,ce){typeof ce=="function"&&(d[Ie]=d[Ie]||[],pt(d[Ie],ce))},t.removeHook=function(Ie){if(d[Ie])return Ht(d[Ie])},t.removeHooks=function(Ie){d[Ie]&&(d[Ie]=[])},t.removeAllHooks=function(){d={}},t}var vi=xt();define("vs/base/browser/dompurify/dompurify",function(){return vi}),define($e[40],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oQ=t.$nQ=void 0;class v{constructor(w){this.domNode=w,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(w){const A=T(w);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(w){const A=T(w);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(w){const A=T(w);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(w){const A=T(w);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(w){const A=T(w);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(w){const A=T(w);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(w){const A=T(w);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(w){const A=T(w);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(w){const A=T(w);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(w){const A=T(w);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(w){const A=T(w);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(w){this.l!==w&&(this.l=w,this.domNode.style.fontFamily=this.l)}setFontWeight(w){this.m!==w&&(this.m=w,this.domNode.style.fontWeight=this.m)}setFontSize(w){const A=T(w);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(w){this.o!==w&&(this.o=w,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(w){this.p!==w&&(this.p=w,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(w){this.q!==w&&(this.q=w,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(w){this.r!==w&&(this.r=w,this.domNode.style.textDecoration=this.r)}setLineHeight(w){const A=T(w);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(w){const A=T(w);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(w){this.u!==w&&(this.u=w,this.domNode.className=this.u)}toggleClassName(w,A){this.domNode.classList.toggle(w,A),this.u=this.domNode.className}setDisplay(w){this.v!==w&&(this.v=w,this.domNode.style.display=this.v)}setPosition(w){this.w!==w&&(this.w=w,this.domNode.style.position=this.w)}setVisibility(w){this.x!==w&&(this.x=w,this.domNode.style.visibility=this.x)}setColor(w){this.y!==w&&(this.y=w,this.domNode.style.color=this.y)}setBackgroundColor(w){this.z!==w&&(this.z=w,this.domNode.style.backgroundColor=this.z)}setLayerHinting(w){this.A!==w&&(this.A=w,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this.C!==w&&(this.C=w,this.domNode.style.boxShadow=w)}setContain(w){this.B!==w&&(this.B=w,this.domNode.style.contain=this.B)}setAttribute(w,A){this.domNode.setAttribute(w,A)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.$nQ=v;function T(U){return typeof U=="number"?`${U}px`:U}function i(U){return new v(U)}t.$oQ=i}),define($e[68],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KO=t.$JO=void 0;let v=!1,T=null;function i(u){if(!u.parent||u.parent===u)return null;try{const c=u.location,m=u.parent.location;if(c.origin!=="null"&&m.origin!=="null"&&c.origin!==m.origin)return v=!0,null}catch{return v=!0,null}return u.parent}class U{static getSameOriginWindowChain(){if(!T){T=[];let c=window,m;do m=i(c),m?T.push({window:c,iframeElement:c.frameElement||null}):T.push({window:c,iframeElement:null}),c=m;while(c)}return T.slice(0)}static hasDifferentOriginAncestor(){return T||this.getSameOriginWindowChain(),v}static getPositionOfChildWindowRelativeToAncestorWindow(c,m){if(!m||c===m)return{top:0,left:0};let O=0,s=0;const l=this.getSameOriginWindowChain();for(const e of l){if(O+=e.window.scrollY,s+=e.window.scrollX,e.window===m||!e.iframeElement)break;const a=e.iframeElement.getBoundingClientRect();O+=a.top,s+=a.left}return{top:O,left:s}}}t.$JO=U;async function w(u,c){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const m=JSON.stringify({parentOrigin:u,salt:c}),s=new TextEncoder().encode(m),l=await crypto.subtle.digest("sha-256",s);return A(l)}t.$KO=w;function A(u){const m=Array.from(new Uint8Array(u)).map(O=>O.toString(16).padStart(2,"0")).join("");return BigInt(`0x${m}`).toString(32).padStart(52,"0")}}),define($e[69],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XQ=t.$WQ=t.$VQ=t.ListDragOverEffect=void 0;var v;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(v||(t.ListDragOverEffect=v={})),t.$VQ={reject(){return{accept:!1}},accept(){return{accept:!0}}};class T extends Error{constructor(w,A){super(`ListError [${w}] ${A}`)}}t.$WQ=T;class i{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,A){A>0&&this.c.set(w,A)}}t.$XQ=i}),define($e[70],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UQ=void 0;class v{constructor(i){this.a=i}splice(i,U,w){this.a.forEach(A=>A.splice(i,U,w))}}t.$UQ=v}),define($e[41],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tQ=void 0;const v=20;class T{constructor(U,w,A,u,c,m){this.a=Math.round(w),this.b=Math.round(A),this.c=Math.round(U),this.d=u,this.e=c,this.f=m,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new T(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const w=Math.round(U);return this.d!==w?(this.d=w,this.m(),!0):!1}setScrollSize(U){const w=Math.round(U);return this.e!==w?(this.e=w,this.m(),!0):!1}setScrollPosition(U){const w=Math.round(U);return this.f!==w?(this.f=w,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,w,A,u,c){const m=Math.max(0,A-U),O=Math.max(0,m-2*w),s=u>0&&u>A;if(!s)return{computedAvailableSize:Math.round(m),computedIsNeeded:s,computedSliderSize:Math.round(O),computedSliderRatio:0,computedSliderPosition:0};const l=Math.round(Math.max(v,Math.floor(A*O/u))),e=(O-l)/(u-A),a=c*e;return{computedAvailableSize:Math.round(m),computedIsNeeded:s,computedSliderSize:Math.round(l),computedSliderRatio:e,computedSliderPosition:Math.round(a)}}m(){const U=T.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const w=U-this.c-this.i/2;return Math.round(w/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const w=U-this.c;let A=this.f;return w<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const w=this.k+U;return Math.round(w/this.j)}}t.$tQ=T}),define($e[24],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RS=t.$QS=t.$PS=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var v;(function(u){u[u.Hidden=0]="Hidden",u[u.Visible=1]="Visible",u[u.Recurse=2]="Recurse"})(v||(t.TreeVisibility=v={}));var T;(function(u){u[u.Expanded=0]="Expanded",u[u.Collapsed=1]="Collapsed",u[u.PreserveOrExpanded=2]="PreserveOrExpanded",u[u.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(T||(t.ObjectTreeElementCollapseState=T={}));var i;(function(u){u[u.Unknown=0]="Unknown",u[u.Twistie=1]="Twistie",u[u.Element=2]="Element",u[u.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var U;(function(u){u[u.Down=0]="Down",u[u.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$PS={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(u=!1){return{accept:!0,bubble:0,autoExpand:u}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(u=!1){return{accept:!0,bubble:0,effect:0,autoExpand:u}}};class w extends Error{constructor(c,m){super(`TreeError [${c}] ${m}`)}}t.$QS=w;class A{constructor(c){this.a=c,this.b=new WeakMap}map(c){let m=this.b.get(c);return m||(m=this.a(c),this.b.set(c,m)),m}}t.$RS=A}),define($e[71],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function v(a,h,g){const n=T(a,h);if(n!==-1)return a[n]}t.$eb=v;function T(a,h,g=a.length-1){for(let n=g;n>=0;n--){const r=a[n];if(h(r))return n}return-1}t.$fb=T;function i(a,h){const g=U(a,h);return g===-1?void 0:a[g]}t.$gb=i;function U(a,h,g=0,n=a.length){let r=g,b=n;for(;r<b;){const f=Math.floor((r+b)/2);h(a[f])?r=f+1:b=f}return r-1}t.$hb=U;function w(a,h){const g=A(a,h);return g===a.length?void 0:a[g]}t.$ib=w;function A(a,h,g=0,n=a.length){let r=g,b=n;for(;r<b;){const f=Math.floor((r+b)/2);h(a[f])?b=f:r=f+1}return r}t.$jb=A;function u(a,h,g=0,n=a.length){const r=A(a,h,g,n);return r===a.length?-1:r}t.$kb=u;class c{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(c.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!h(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const g=U(this.e,h,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}t.$lb=c;function m(a,h){if(a.length===0)return;let g=a[0];for(let n=1;n<a.length;n++){const r=a[n];h(r,g)>0&&(g=r)}return g}t.$mb=m;function O(a,h){if(a.length===0)return;let g=a[0];for(let n=1;n<a.length;n++){const r=a[n];h(r,g)>=0&&(g=r)}return g}t.$nb=O;function s(a,h){return m(a,(g,n)=>-h(g,n))}t.$ob=s;function l(a,h){if(a.length===0)return-1;let g=0;for(let n=1;n<a.length;n++){const r=a[n];h(r,a[g])>0&&(g=n)}return g}t.$pb=l;function e(a,h){for(const g of a){const n=h(g);if(n!==void 0)return n}}t.$qb=e}),define($e[72],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function v(w,A){const u=Object.create(null);for(const c of w){const m=A(c);let O=u[m];O||(O=u[m]=[]),O.push(c)}return u}t.$J=v;function T(w,A){const u=[],c=[];for(const m of w)A.has(m)||u.push(m);for(const m of A)w.has(m)||c.push(m);return{removed:u,added:c}}t.$K=T;function i(w,A){const u=[],c=[];for(const[m,O]of w)A.has(m)||u.push(O);for(const[m,O]of A)w.has(m)||c.push(O);return{removed:u,added:c}}t.$L=i;function U(w,A){const u=new Set;for(const c of A)w.has(c)&&u.add(c);return u}t.$M=U}),define($e[73],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ys=t.$Xs=t.$Ws=t.$Vs=void 0;function v(A,u){const c=Math.pow(10,u);return Math.round(A*c)/c}class T{constructor(u,c,m,O=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=v(Math.max(Math.min(1,O),0),3)}static equals(u,c){return u.r===c.r&&u.g===c.g&&u.b===c.b&&u.a===c.a}}t.$Vs=T;class i{constructor(u,c,m,O){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=v(Math.max(Math.min(1,c),0),3),this.l=v(Math.max(Math.min(1,m),0),3),this.a=v(Math.max(Math.min(1,O),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.l===c.l&&u.a===c.a}static fromRGBA(u){const c=u.r/255,m=u.g/255,O=u.b/255,s=u.a,l=Math.max(c,m,O),e=Math.min(c,m,O);let a=0,h=0;const g=(e+l)/2,n=l-e;if(n>0){switch(h=Math.min(g<=.5?n/(2*g):n/(2-2*g),1),l){case c:a=(m-O)/n+(m<O?6:0);break;case m:a=(O-c)/n+2;break;case O:a=(c-m)/n+4;break}a*=60,a=Math.round(a)}return new i(a,h,g,s)}static i(u,c,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?u+(c-u)*6*m:m<1/2?c:m<2/3?u+(c-u)*(2/3-m)*6:u}static toRGBA(u){const c=u.h/360,{s:m,l:O,a:s}=u;let l,e,a;if(m===0)l=e=a=O;else{const h=O<.5?O*(1+m):O+m-O*m,g=2*O-h;l=i.i(g,h,c+1/3),e=i.i(g,h,c),a=i.i(g,h,c-1/3)}return new T(Math.round(l*255),Math.round(e*255),Math.round(a*255),s)}}t.$Ws=i;class U{constructor(u,c,m,O){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=v(Math.max(Math.min(1,c),0),3),this.v=v(Math.max(Math.min(1,m),0),3),this.a=v(Math.max(Math.min(1,O),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.v===c.v&&u.a===c.a}static fromRGBA(u){const c=u.r/255,m=u.g/255,O=u.b/255,s=Math.max(c,m,O),l=Math.min(c,m,O),e=s-l,a=s===0?0:e/s;let h;return e===0?h=0:s===c?h=((m-O)/e%6+6)%6:s===m?h=(O-c)/e+2:h=(c-m)/e+4,new U(Math.round(h*60),a,s,u.a)}static toRGBA(u){const{h:c,s:m,v:O,a:s}=u,l=O*m,e=l*(1-Math.abs(c/60%2-1)),a=O-l;let[h,g,n]=[0,0,0];return c<60?(h=l,g=e):c<120?(h=e,g=l):c<180?(g=l,n=e):c<240?(g=e,n=l):c<300?(h=e,n=l):c<=360&&(h=l,n=e),h=Math.round((h+a)*255),g=Math.round((g+a)*255),n=Math.round((n+a)*255),new T(h,g,n,s)}}t.$Xs=U;class w{static fromHex(u){return w.Format.CSS.parseHex(u)||w.red}static equals(u,c){return!u&&!c?!0:!u||!c?!1:u.equals(c)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof T)this.rgba=u;else if(u instanceof i)this.i=u,this.rgba=i.toRGBA(u);else if(u instanceof U)this.j=u,this.rgba=U.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&T.equals(this.rgba,u.rgba)&&i.equals(this.hsla,u.hsla)&&U.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=w.k(this.rgba.r),c=w.k(this.rgba.g),m=w.k(this.rgba.b),O=.2126*u+.7152*c+.0722*m;return v(O,4)}static k(u){const c=u/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(u){const c=this.getRelativeLuminance(),m=u.getRelativeLuminance();return c>m?(c+.05)/(m+.05):(m+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const c=this.getRelativeLuminance(),m=u.getRelativeLuminance();return c>m}isDarkerThan(u){const c=this.getRelativeLuminance(),m=u.getRelativeLuminance();return c<m}lighten(u){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:c,g:m,b:O,a:s}=this.rgba;return new w(new T(c,m,O,s*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const c=u.rgba,m=this.rgba.a,O=c.a,s=m+O*(1-m);if(s<1e-6)return w.transparent;const l=this.rgba.r*m/s+c.r*O*(1-m)/s,e=this.rgba.g*m/s+c.g*O*(1-m)/s,a=this.rgba.b*m/s+c.b*O*(1-m)/s;return new w(new T(l,e,a,s))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:c,g:m,b:O,a:s}=this.rgba;return new w(new T(u.rgba.r-s*(u.rgba.r-c),u.rgba.g-s*(u.rgba.g-m),u.rgba.b-s*(u.rgba.b-O),1))}flatten(...u){const c=u.reduceRight((m,O)=>w.o(O,m));return w.o(this,c)}static o(u,c){const m=1-u.rgba.a;return new w(new T(m*c.rgba.r+u.rgba.a*u.rgba.r,m*c.rgba.g+u.rgba.a*u.rgba.g,m*c.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(u,c,m){if(u.isLighterThan(c))return u;m=m||.5;const O=u.getRelativeLuminance(),s=c.getRelativeLuminance();return m=m*(s-O)/s,u.lighten(m)}static getDarkerColor(u,c,m){if(u.isDarkerThan(c))return u;m=m||.5;const O=u.getRelativeLuminance(),s=c.getRelativeLuminance();return m=m*(O-s)/O,u.darken(m)}static{this.white=new w(new T(255,255,255,1))}static{this.black=new w(new T(0,0,0,1))}static{this.red=new w(new T(255,0,0,1))}static{this.blue=new w(new T(0,0,255,1))}static{this.green=new w(new T(0,255,0,1))}static{this.cyan=new w(new T(0,255,255,1))}static{this.lightgrey=new w(new T(211,211,211,1))}static{this.transparent=new w(new T(0,0,0,0))}}t.$Ys=w,function(A){let u;(function(c){let m;(function(O){function s(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:A.Format.CSS.formatRGBA(o)}O.formatRGB=s;function l(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}O.formatRGBA=l;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(o)}O.formatHSL=e;function a(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}O.formatHSLA=a;function h(o){const F=o.toString(16);return F.length!==2?"0"+F:F}function g(o){return`#${h(o.rgba.r)}${h(o.rgba.g)}${h(o.rgba.b)}`}O.formatHex=g;function n(o,F=!1){return F&&o.rgba.a===1?A.Format.CSS.formatHex(o):`#${h(o.rgba.r)}${h(o.rgba.g)}${h(o.rgba.b)}${h(Math.round(o.rgba.a*255))}`}O.formatHexA=n;function r(o){return o.isOpaque()?A.Format.CSS.formatHex(o):A.Format.CSS.formatRGBA(o)}O.format=r;function b(o){const F=o.length;if(F===0||o.charCodeAt(0)!==35)return null;if(F===7){const j=16*f(o.charCodeAt(1))+f(o.charCodeAt(2)),L=16*f(o.charCodeAt(3))+f(o.charCodeAt(4)),d=16*f(o.charCodeAt(5))+f(o.charCodeAt(6));return new A(new T(j,L,d,1))}if(F===9){const j=16*f(o.charCodeAt(1))+f(o.charCodeAt(2)),L=16*f(o.charCodeAt(3))+f(o.charCodeAt(4)),d=16*f(o.charCodeAt(5))+f(o.charCodeAt(6)),D=16*f(o.charCodeAt(7))+f(o.charCodeAt(8));return new A(new T(j,L,d,D/255))}if(F===4){const j=f(o.charCodeAt(1)),L=f(o.charCodeAt(2)),d=f(o.charCodeAt(3));return new A(new T(16*j+j,16*L+L,16*d+d))}if(F===5){const j=f(o.charCodeAt(1)),L=f(o.charCodeAt(2)),d=f(o.charCodeAt(3)),D=f(o.charCodeAt(4));return new A(new T(16*j+j,16*L+L,16*d+d,(16*D+D)/255))}return null}O.parseHex=b;function f(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=c.CSS||(c.CSS={}))})(u=A.Format||(A.Format={}))}(w||(t.$Ys=w={}))}),define($e[25],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kh=t.$jh=t.$ih=void 0;function v(w){return(A,u,c)=>{let m=null,O=null;if(typeof c.value=="function"?(m="value",O=c.value):typeof c.get=="function"&&(m="get",O=c.get),!O)throw new Error("not supported");c[m]=w(O,u)}}function T(w,A,u){let c=null,m=null;if(typeof u.value=="function"?(c="value",m=u.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",m=u.get),!m)throw new Error("not supported");const O=`$memoize$${A}`;u[c]=function(...s){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,s)}),this[O]}}t.$ih=T;function i(w,A,u){return v((c,m)=>{const O=`$debounce$${m}`,s=`$debounce$result$${m}`;return function(...l){this[s]||(this[s]=u?u():void 0),clearTimeout(this[O]),A&&(this[s]=A(this[s],...l),l=[this[s]]),this[O]=setTimeout(()=>{c.apply(this,l),this[s]=u?u():void 0},w)}})}t.$jh=i;function U(w,A,u){return v((c,m)=>{const O=`$throttle$timer$${m}`,s=`$throttle$result$${m}`,l=`$throttle$lastRun$${m}`,e=`$throttle$pending$${m}`;return function(...a){if(this[s]||(this[s]=u?u():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),A&&(this[s]=A(this[s],...a)),this[e])return;const h=this[l]+w;h<=Date.now()?(this[l]=Date.now(),c.apply(this,[this[s]]),this[s]=u?u():void 0):(this[e]=!0,this[O]=setTimeout(()=>{this[e]=!1,this[l]=Date.now(),c.apply(this,[this[s]]),this[s]=u?u():void 0},h-Date.now()))}})}t.$kh=U}),define($e[74],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xs=void 0;class v{constructor(i,U,w,A){this.originalStart=i,this.originalLength=U,this.modifiedStart=w,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$xs=v}),define($e[6],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class v{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?r.isErrorNoTelemetry(o)?new r(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(F=>{F(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$V=v,t.$W=new v;function T(f){t.$W.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=T;function i(f){if(!f||typeof f!="object")return!1;const o=f;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}t.$Y=i;function U(f){c(f)||t.$W.onUnexpectedError(f)}t.$Z=U;function w(f){c(f)||t.$W.onUnexpectedExternalError(f)}t.$1=w;function A(f){if(f instanceof Error){const{name:o,message:F}=f,j=f.stacktrace||f.stack;return{$isError:!0,name:o,message:F,stack:j,noTelemetry:r.isErrorNoTelemetry(f)}}return f}t.$2=A;const u="Canceled";function c(f){return f instanceof m?!0:f instanceof Error&&f.name===u&&f.message===u}t.$3=c;class m extends Error{constructor(){super(u),this.name=this.message}}t.$4=m;function O(){const f=new Error(u);return f.name=f.message,f}t.$5=O;function s(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.$6=s;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.$7=l;class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function a(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.$9=a;class h extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$0=h;class g extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$$=g;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=n;class r extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof r)return o;const F=new r;return F.message=o.message,F.stack=o.stack,F}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$ab=r;class b extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$bb=b}),define($e[11],pe([1,0,6,71]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function i(p,y=0){return p[p.length-(1+y)]}t.$rb=i;function U(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}t.$sb=U;function w(p,y,E=(M,k)=>M===k){if(p===y)return!0;if(!p||!y||p.length!==y.length)return!1;for(let M=0,k=p.length;M<k;M++)if(!E(p[M],y[M]))return!1;return!0}t.$tb=w;function A(p,y){const E=p.length-1;y<E&&(p[y]=p[E]),p.pop()}t.$ub=A;function u(p,y,E){return c(p.length,M=>E(p[M],y))}t.$vb=u;function c(p,y){let E=0,M=p-1;for(;E<=M;){const k=(E+M)/2|0,R=y(k);if(R<0)E=k+1;else if(R>0)M=k-1;else return k}return-(E+1)}t.$wb=c;function m(p,y,E){if(p=p|0,p>=y.length)throw new TypeError("invalid index");const M=y[Math.floor(y.length*Math.random())],k=[],R=[],C=[];for(const P of y){const H=E(P,M);H<0?k.push(P):H>0?R.push(P):C.push(P)}return p<k.length?m(p,k,E):p<k.length+C.length?C[0]:m(p-(k.length+C.length),R,E)}t.$xb=m;function O(p,y){const E=[];let M;for(const k of p.slice(0).sort(y))!M||y(M[0],k)!==0?(M=[k],E.push(M)):M.push(k);return E}t.$yb=O;function*s(p,y){let E,M;for(const k of p)M!==void 0&&y(M,k)?E.push(k):(E&&(yield E),E=[k]),M=k;E&&(yield E)}t.$zb=s;function l(p,y){for(let E=0;E<=p.length;E++)y(E===0?void 0:p[E-1],E===p.length?void 0:p[E])}t.$Ab=l;function e(p,y){for(let E=0;E<p.length;E++)y(E===0?void 0:p[E-1],p[E],E+1===p.length?void 0:p[E+1])}t.$Bb=e;function a(p,y,E){const M=[];function k(P,H,x){if(H===0&&x.length===0)return;const te=M[M.length-1];te&&te.start+te.deleteCount===P?(te.deleteCount+=H,te.toInsert.push(...x)):M.push({start:P,deleteCount:H,toInsert:x})}let R=0,C=0;for(;;){if(R===p.length){k(R,0,y.slice(C));break}if(C===y.length){k(R,p.length-R,[]);break}const P=p[R],H=y[C],x=E(P,H);x===0?(R+=1,C+=1):x<0?(k(R,1,[]),R+=1):x>0&&(k(R,0,[H]),C+=1)}return M}t.$Cb=a;function h(p,y,E){const M=a(p,y,E),k=[],R=[];for(const C of M)k.push(...p.slice(C.start,C.start+C.deleteCount)),R.push(...C.toInsert);return{removed:k,added:R}}t.$Db=h;function g(p,y,E){if(E===0)return[];const M=p.slice(0,E).sort(y);return r(p,y,M,E,p.length),M}t.top=g;function n(p,y,E,M,k){return E===0?Promise.resolve([]):new Promise((R,C)=>{(async()=>{const P=p.length,H=p.slice(0,E).sort(y);for(let x=E,te=Math.min(E+M,P);x<P;x=te,te=Math.min(te+M,P)){if(x>E&&await new Promise(ne=>setTimeout(ne)),k&&k.isCancellationRequested)throw new v.$4;r(p,y,H,x,te)}return H})().then(R,C)})}t.$Fb=n;function r(p,y,E,M,k){for(const R=E.length;M<k;M++){const C=p[M];if(y(C,E[R-1])<0){E.pop();const P=(0,T.$jb)(E,H=>y(C,H)<0);E.splice(P,0,C)}}}function b(p){return p.filter(y=>!!y)}t.$Gb=b;function f(p){let y=0;for(let E=0;E<p.length;E++)p[E]&&(p[y]=p[E],y+=1);p.length=y}t.$Hb=f;function o(p,y,E){p.splice(E,0,p.splice(y,1)[0])}t.$Ib=o;function F(p){return!Array.isArray(p)||p.length===0}t.$Jb=F;function j(p){return Array.isArray(p)&&p.length>0}t.$Kb=j;function L(p,y=E=>E){const E=new Set;return p.filter(M=>{const k=y(M);return E.has(k)?!1:(E.add(k),!0)})}t.$Lb=L;function d(p){const y=new Set;return E=>{const M=p(E);return y.has(M)?!1:(y.add(M),!0)}}t.$Mb=d;function D(p,y){return p.length>0?p[0]:y}t.$Nb=D;function B(p,y){return p.length>0?p[p.length-1]:y}t.$Ob=B;function z(p,y,E=(M,k)=>M===k){let M=0;for(let k=0,R=Math.min(p.length,y.length);k<R&&E(p[k],y[k]);k++)M++;return M}t.$Pb=z;function _(p){return[].concat(...p)}t.$Qb=_;function I(p,y){let E=typeof y=="number"?p:0;typeof y=="number"?E=p:(E=0,y=p);const M=[];if(E<=y)for(let k=E;k<y;k++)M.push(k);else for(let k=E;k>y;k--)M.push(k);return M}t.$Rb=I;function N(p,y,E){return p.reduce((M,k)=>(M[y(k)]=E?E(k):k,M),Object.create(null))}t.$Sb=N;function Z(p,y){return p.push(y),()=>ee(p,y)}t.$Tb=Z;function ee(p,y){const E=p.indexOf(y);if(E>-1)return p.splice(E,1),y}t.$Ub=ee;function ue(p,y,E){const M=p.slice(0,y),k=p.slice(y);return M.concat(E,k)}t.$Vb=ue;function ae(p,y){let E;if(typeof y=="number"){let M=y;E=()=>{const k=Math.sin(M++)*179426549;return k-Math.floor(k)}}else E=Math.random;for(let M=p.length-1;M>0;M-=1){const k=Math.floor(E()*(M+1)),R=p[M];p[M]=p[k],p[k]=R}}t.$Wb=ae;function se(p,y){const E=p.indexOf(y);E>-1&&(p.splice(E,1),p.unshift(y))}t.$Xb=se;function re(p,y){const E=p.indexOf(y);E>-1&&(p.splice(E,1),p.push(y))}t.$Yb=re;function be(p,y){for(const E of y)p.push(E)}t.$Zb=be;function Se(p,y){return Array.isArray(p)?p.map(y):y(p)}t.$1b=Se;function Oe(p){return Array.isArray(p)?p:[p]}t.$2b=Oe;function Te(p){return p[Math.floor(Math.random()*p.length)]}t.$3b=Te;function de(p,y,E){const M=fe(p,y),k=p.length,R=E.length;p.length=k+R;for(let C=k-1;C>=M;C--)p[C+R]=p[C];for(let C=0;C<R;C++)p[C+M]=E[C]}t.$4b=de;function ie(p,y,E,M){const k=fe(p,y);let R=p.splice(k,E);return R===void 0&&(R=[]),de(p,k,M),R}t.$5b=ie;function fe(p,y){return y<0?Math.max(y+p.length,0):Math.min(y,p.length)}var Y;(function(p){function y(R){return R<0}p.isLessThan=y;function E(R){return R<=0}p.isLessThanOrEqual=E;function M(R){return R>0}p.isGreaterThan=M;function k(R){return R===0}p.isNeitherLessOrGreaterThan=k,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(Y||(t.CompareResult=Y={}));function q(p,y){return(E,M)=>y(p(E),p(M))}t.$6b=q;function X(...p){return(y,E)=>{for(const M of p){const k=M(y,E);if(!Y.isNeitherLessOrGreaterThan(k))return k}return Y.neitherLessOrGreaterThan}}t.$7b=X;const S=(p,y)=>p-y;t.$8b=S;const Q=(p,y)=>(0,t.$8b)(p?1:0,y?1:0);t.$9b=Q;function $(p){return(y,E)=>-p(y,E)}t.$0b=$;class W{constructor(y){this.g=y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(y){let E=this.c;for(;E<this.g.length&&y(this.g[E]);)E++;const M=E===this.c?null:this.g.slice(this.c,E);return this.c=E,M}takeFromEndWhile(y){let E=this.d;for(;E>=0&&y(this.g[E]);)E--;const M=E===this.d?null:this.g.slice(E+1,this.d+1);return this.d=E,M}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const y=this.g[this.c];return this.c++,y}removeLast(){const y=this.g[this.d];return this.d--,y}takeCount(y){const E=this.g.slice(this.c,this.c+y);return this.c+=y,E}}t.$$b=W;class V{static{this.empty=new V(y=>{})}constructor(y){this.iterate=y}forEach(y){this.iterate(E=>(y(E),!0))}toArray(){const y=[];return this.iterate(E=>(y.push(E),!0)),y}filter(y){return new V(E=>this.iterate(M=>y(M)?E(M):!0))}map(y){return new V(E=>this.iterate(M=>E(y(M))))}some(y){let E=!1;return this.iterate(M=>(E=y(M),!E)),E}findFirst(y){let E;return this.iterate(M=>y(M)?(E=M,!1):!0),E}findLast(y){let E;return this.iterate(M=>(y(M)&&(E=M),!0)),E}findLastMaxBy(y){let E,M=!0;return this.iterate(k=>((M||Y.isGreaterThan(y(k,E)))&&(M=!1,E=k),!0)),E}}t.$_b=V}),define($e[75],pe([1,0,6]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.$4c=t.$3c=t.ok=void 0;function T(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}t.ok=T;function i(u,c="Unreachable"){throw new Error(c)}t.$3c=i;function U(u){if(!u)throw new v.$bb("Assertion Failed")}t.$4c=U;function w(u){if(!u()){debugger;u(),(0,v.$Z)(new v.$bb("Assertion Failed"))}}t.$5c=w;function A(u,c){let m=0;for(;m<u.length-1;){const O=u[m],s=u[m+1];if(!c(O,s))return!1;m++}return!0}t.$6c=A}),define($e[42],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function v(T){const i=this;let U=!1,w;return function(){return U||(U=!0,w=T.apply(i,arguments)),w}}t.$cb=v}),define($e[76],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AM=t.$zM=void 0;class v{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$zM=v,t.$AM=new v("id#")}),define($e[26],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(T){function i(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}T.is=i;const U=Object.freeze([]);function w(){return U}T.empty=w;function*A(f){yield f}T.single=A;function u(f){return i(f)?f:A(f)}T.wrap=u;function c(f){return f||U}T.from=c;function*m(f){for(let o=f.length-1;o>=0;o--)yield f[o]}T.reverse=m;function O(f){return!f||f[Symbol.iterator]().next().done===!0}T.isEmpty=O;function s(f){return f[Symbol.iterator]().next().value}T.first=s;function l(f,o){for(const F of f)if(o(F))return!0;return!1}T.some=l;function e(f,o){for(const F of f)if(o(F))return F}T.find=e;function*a(f,o){for(const F of f)o(F)&&(yield F)}T.filter=a;function*h(f,o){let F=0;for(const j of f)yield o(j,F++)}T.map=h;function*g(...f){for(const o of f)for(const F of o)yield F}T.concat=g;function n(f,o,F){let j=F;for(const L of f)j=o(j,L);return j}T.reduce=n;function*r(f,o,F=f.length){for(o<0&&(o+=f.length),F<0?F+=f.length:F>f.length&&(F=f.length);o<F;o++)yield f[o]}T.slice=r;function b(f,o=Number.POSITIVE_INFINITY){const F=[];if(o===0)return[F,f];const j=f[Symbol.iterator]();for(let L=0;L<o;L++){const d=j.next();if(d.done)return[F,T.empty()];F.push(d.value)}return[F,{[Symbol.iterator](){return j}}]}T.consume=b})(v||(t.Iterable=v={}))}),define($e[43],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gq=t.KeyMod=t.KeyCodeUtils=t.$Fq=t.$Eq=t.$Dq=t.$Cq=t.$Bq=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(v||(t.KeyCode=v={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T||(t.ScanCode=T={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,h){this._keyCodeToStr[a]=h,this._strToKeyCode[h.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const U=new i,w=new i,A=new i;t.$Bq=new Array(230),t.$Cq={};const u=[],c=Object.create(null),m=Object.create(null);t.$Dq={lowerCaseToEnum:e=>m[e]||0,toEnum:e=>c[e]||0,toString:e=>u[e]||"None"},t.$Eq=[],t.$Fq=[];for(let e=0;e<=193;e++)t.$Eq[e]=-1;for(let e=0;e<=132;e++)t.$Fq[e]=-1;(function(){const e="",a=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],h=[],g=[];for(const n of a){const[r,b,f,o,F,j,L,d,D]=n;if(g[b]||(g[b]=!0,u[b]=f,c[f]=b,m[f.toLowerCase()]=b,r&&(t.$Eq[b]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$Fq[o]=b))),!h[o]){if(h[o]=!0,!F)throw new Error(`String representation missing for key code ${o} around scan code ${f}`);U.define(o,F),w.define(o,d||F),A.define(o,D||d||F)}j&&(t.$Bq[j]=o),L&&(t.$Cq[L]=o)}t.$Fq[3]=46})();var O;(function(e){function a(f){return U.keyCodeToStr(f)}e.toString=a;function h(f){return U.strToKeyCode(f)}e.fromString=h;function g(f){return w.keyCodeToStr(f)}e.toUserSettingsUS=g;function n(f){return A.keyCodeToStr(f)}e.toUserSettingsGeneral=n;function r(f){return w.strToKeyCode(f)||A.strToKeyCode(f)}e.fromUserSettings=r;function b(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(f)}e.toElectronAccelerator=b})(O||(t.KeyCodeUtils=O={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function l(e,a){const h=(a&65535)<<16>>>0;return(e|h)>>>0}t.$Gq=l}),define($e[77],pe([1,0,6]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nq=t.$Mq=t.$Lq=t.$Kq=t.$Jq=t.$Iq=t.$Hq=void 0;var T;(function(O){O[O.CtrlCmd=2048]="CtrlCmd",O[O.Shift=1024]="Shift",O[O.Alt=512]="Alt",O[O.WinCtrl=256]="WinCtrl",O[O.KeyCode=255]="KeyCode"})(T||(T={}));function i(O,s){if(typeof O=="number"){if(O===0)return null;const l=(O&65535)>>>0,e=(O&4294901760)>>>16;return e!==0?new u([U(l,s),U(e,s)]):new u([U(l,s)])}else{const l=[];for(let e=0;e<O.length;e++)l.push(U(O[e],s));return new u(l)}}t.$Hq=i;function U(O,s){const l=!!(O&2048),e=!!(O&256),a=s===2?e:l,h=!!(O&1024),g=!!(O&512),n=s===2?l:e,r=O&255;return new w(a,h,g,n,r)}t.$Iq=U;class w{constructor(s,l,e,a,h){this.ctrlKey=s,this.shiftKey=l,this.altKey=e,this.metaKey=a,this.keyCode=h}equals(s){return s instanceof w&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`K${s}${l}${e}${a}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new u([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Jq=w;class A{constructor(s,l,e,a,h){this.ctrlKey=s,this.shiftKey=l,this.altKey=e,this.metaKey=a,this.scanCode=h}equals(s){return s instanceof A&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`S${s}${l}${e}${a}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Kq=A;class u{constructor(s){if(s.length===0)throw(0,v.$6)("chords");this.chords=s}getHashCode(){let s="";for(let l=0,e=this.chords.length;l<e;l++)l!==0&&(s+=";"),s+=this.chords[l].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let l=0;l<this.chords.length;l++)if(!this.chords[l].equals(s.chords[l]))return!1;return!0}}t.$Lq=u;class c{constructor(s,l,e,a,h,g){this.ctrlKey=s,this.shiftKey=l,this.altKey=e,this.metaKey=a,this.keyLabel=h,this.keyAriaLabel=g}}t.$Mq=c;class m{}t.$Nq=m}),define($e[27],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class v{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=v}),define($e[44],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;class v{static{this.Undefined=new v(void 0)}constructor(U){this.element=U,this.next=v.Undefined,this.prev=v.Undefined}}class T{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let U=this.a;for(;U!==v.Undefined;){const w=U.next;U.prev=v.Undefined,U.next=v.Undefined,U=w}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,w){const A=new v(U);if(this.a===v.Undefined)this.a=A,this.b=A;else if(w){const c=this.b;this.b=A,A.prev=c,c.next=A}else{const c=this.a;this.a=A,A.next=c,c.prev=A}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(A))}}shift(){if(this.a!==v.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==v.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==v.Undefined&&U.next!==v.Undefined){const w=U.prev;w.next=U.next,U.next.prev=w}else U.prev===v.Undefined&&U.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):U.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):U.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==v.Undefined;)yield U.element,U=U.next}}t.$1c=T}),define($e[31],pe([1,0]),function(oe,t){"use strict";var v,T,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function U(n,r,b){let f=n.get(r);return f===void 0&&(f=b,n.set(r,f)),f}t.$wc=U;function w(n){const r=[];return n.forEach((b,f)=>{r.push(`${f} => ${b}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$xc=w;function A(n){const r=[];return n.forEach(b=>{r.push(b)}),`Set(${n.size}) {${r.join(", ")}}`}t.$yc=A;class u{constructor(r,b){this.uri=r,this.value=b}}function c(n){return Array.isArray(n)}class m{static{this.a=r=>r.toString()}constructor(r,b){if(this[v]="ResourceMap",r instanceof m)this.b=new Map(r.b),this.c=b??m.a;else if(c(r)){this.b=new Map,this.c=b??m.a;for(const[f,o]of r)this.set(f,o)}else this.b=new Map,this.c=r??m.a}set(r,b){return this.b.set(this.c(r),new u(r,b)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,b){typeof b<"u"&&(r=r.bind(b));for(const[f,o]of this.b)r(o.value,o.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$zc=m;class O{constructor(r,b){this[T]="ResourceSet",!r||typeof r=="function"?this.a=new m(r):(this.a=new m(b),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,b){this.a.forEach((f,o)=>r.call(b,o,o,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=O;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class l{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,b=0){const f=this.a.get(r);if(f)return b!==0&&this.j(f,b),f.value}set(r,b,f=0){let o=this.a.get(r);if(o)o.value=b,f!==0&&this.j(o,f);else{switch(o={key:r,value:b,next:void 0,previous:void 0},f){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(r,o),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const b=this.a.get(r);if(b)return this.a.delete(r),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,b){const f=this.e;let o=this.b;for(;o;){if(b?r.bind(b)(o.value,o.key,this):r(o.value,o.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const r=this,b=this.e;let f=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(f){const F={value:f.key,done:!1};return f=f.next,F}else return{value:void 0,done:!0}}};return o}values(){const r=this,b=this.e;let f=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(f){const F={value:f.value,done:!1};return f=f.next,F}else return{value:void 0,done:!0}}};return o}entries(){const r=this,b=this.e;let f=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(f){const F={value:[f.key,f.value],done:!1};return f=f.next,F}else return{value:void 0,done:!0}}};return o}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let b=this.b,f=this.size;for(;b&&f>r;)this.a.delete(b.key),b=b.next,f--;this.b=b,this.d=f,b&&(b.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const b=r.next,f=r.previous;if(!b||!f)throw new Error("Invalid list");b.previous=f,f.next=b}r.next=void 0,r.previous=void 0,this.e++}j(r,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(r===this.b)return;const f=r.next,o=r.previous;r===this.c?(o.next=void 0,this.c=o):(f.previous=o,o.next=f),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(b===2){if(r===this.c)return;const f=r.next,o=r.previous;r===this.b?(f.previous=void 0,this.b=f):(f.previous=o,o.next=f),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((b,f)=>{r.push([f,b])}),r}fromJSON(r){this.clear();for(const[b,f]of r)this.set(b,f)}}t.$Bc=l;class e extends l{constructor(r,b=1){super(),this.k=r,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,b=2){return super.get(r,b)}peek(r){return super.get(r,0)}set(r,b){return super.set(r,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class a{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let b=this.a.get(r)||0;return b===0?!1:(b--,b===0?this.a.delete(r):this.a.set(r,b),!0)}has(r){return this.a.has(r)}}t.$Dc=a;class h{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[b,f]of r)this.set(b,f)}clear(){this.a.clear(),this.b.clear()}set(r,b){this.a.set(r,b),this.b.set(b,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const b=this.a.get(r);return b===void 0?!1:(this.a.delete(r),this.b.delete(b),!0)}forEach(r,b){this.a.forEach((f,o)=>{r.call(b,f,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=h;class g{constructor(){this.a=new Map}add(r,b){let f=this.a.get(r);f||(f=new Set,this.a.set(r,f)),f.add(b)}delete(r,b){const f=this.a.get(r);f&&(f.delete(b),f.size===0&&this.a.delete(r))}forEach(r,b){const f=this.a.get(r);f&&f.forEach(b)}get(r){const b=this.a.get(r);return b||new Set}}t.$Fc=g}),define($e[2],pe([1,0,11,72,31,42,26]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const A=!1;let u=null;class c{constructor(){this.b=new Map}static{this.a=0}c(N){let Z=this.b.get(N);return Z||(Z={parent:null,source:null,isSingleton:!1,value:N,idx:c.a++},this.b.set(N,Z)),Z}trackDisposable(N){const Z=this.c(N);Z.source||(Z.source=new Error().stack)}setParent(N,Z){const ee=this.c(N);ee.parent=Z}markAsDisposed(N){this.b.delete(N)}markAsSingleton(N){this.c(N).isSingleton=!0}f(N,Z){const ee=Z.get(N);if(ee)return ee;const ue=N.parent?this.f(this.c(N.parent),Z):N;return Z.set(N,ue),ue}getTrackedDisposables(){const N=new Map;return[...this.b.entries()].filter(([,ee])=>ee.source!==null&&!this.f(ee,N).isSingleton).flatMap(([ee])=>ee)}computeLeakingDisposables(N=10,Z){let ee;if(Z)ee=Z;else{const be=new Map,Se=[...this.b.values()].filter(Te=>Te.source!==null&&!this.f(Te,be).isSingleton);if(Se.length===0)return;const Oe=new Set(Se.map(Te=>Te.value));if(ee=Se.filter(Te=>!(Te.parent&&Oe.has(Te.parent))),ee.length===0)throw new Error("There are cyclic diposable chains!")}if(!ee)return;function ue(be){function Se(Te,de){for(;Te.length>0&&de.some(ie=>typeof ie=="string"?ie===Te[0]:Te[0].match(ie));)Te.shift()}const Oe=be.source.split(`
`).map(Te=>Te.trim().replace("at ","")).filter(Te=>Te!=="");return Se(Oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Oe.reverse()}const ae=new i.$Fc;for(const be of ee){const Se=ue(be);for(let Oe=0;Oe<=Se.length;Oe++)ae.add(Se.slice(0,Oe).join(`
`),be)}ee.sort((0,v.$6b)(be=>be.idx,v.$8b));let se="",re=0;for(const be of ee.slice(0,N)){re++;const Se=ue(be),Oe=[];for(let Te=0;Te<Se.length;Te++){let de=Se[Te];de=`(shared with ${ae.get(Se.slice(0,Te+1).join(`
`)).size}/${ee.length} leaks) at ${de}`;const fe=ae.get(Se.slice(0,Te).join(`
`)),Y=(0,T.$J)([...fe].map(q=>ue(q)[Te]),q=>q);delete Y[Se[Te]];for(const[q,X]of Object.entries(Y))Oe.unshift(`    - stacktraces of ${X.length} other leaks continue with ${q}`);Oe.unshift(de)}se+=`


==================== Leaking disposable ${re}/${ee.length}: ${be.value.constructor.name} ====================
${Oe.join(`
`)}
============================================================

`}return ee.length>N&&(se+=`


... and ${ee.length-N} more leaking disposables

`),{leaks:ee,details:se}}}t.$Gc=c;function m(I){u=I}if(t.$Hc=m,A){const I="__is_disposable_tracked__";m(new class{trackDisposable(N){const Z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{N[I]||console.log(Z)},3e3)}setParent(N,Z){if(N&&N!==o.None)try{N[I]=!0}catch{}}markAsDisposed(N){if(N&&N!==o.None)try{N[I]=!0}catch{}}markAsSingleton(N){}})}function O(I){return u?.trackDisposable(I),I}t.$Ic=O;function s(I){u?.markAsDisposed(I)}t.$Jc=s;function l(I,N){u?.setParent(I,N)}function e(I,N){if(u)for(const Z of I)u.setParent(Z,N)}function a(I){return u?.markAsSingleton(I),I}t.$Kc=a;function h(I){return typeof I.dispose=="function"&&I.dispose.length===0}t.$Lc=h;function g(I){if(w.Iterable.is(I)){const N=[];for(const Z of I)if(Z)try{Z.dispose()}catch(ee){N.push(ee)}if(N.length===1)throw N[0];if(N.length>1)throw new AggregateError(N,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}t.$Mc=g;function n(I){for(const N of I)h(N)&&N.dispose();return[]}t.$Nc=n;function r(...I){const N=b(()=>g(I));return e(I,N),N}t.$Oc=r;function b(I){const N=O({dispose:(0,U.$cb)(()=>{s(N),I()})});return N}t.$Pc=b;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,O(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(N){if(!N)return N;if(N===this)throw new Error("Cannot register a disposable on itself!");return l(N,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(N),N}delete(N){if(N){if(N===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(N),N.dispose()}}deleteAndLeak(N){N&&this.f.has(N)&&(this.f.delete(N),l(N,null))}}t.$Qc=f;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,O(this),l(this.q,this)}dispose(){s(this),this.q.dispose()}B(N){if(N===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(N)}}t.$Rc=o;class F{constructor(){this.b=!1,O(this)}get value(){return this.b?void 0:this.a}set value(N){this.b||N===this.a||(this.a?.dispose(),N&&l(N,this),this.a=N)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const N=this.a;return this.a=void 0,N&&l(N,null),N}}t.$Sc=F;class j{constructor(N){this.b=N,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Tc=j;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,O(this)}set(N){let Z=N;return this.unset=()=>Z=void 0,this.isset=()=>Z!==void 0,this.dispose=()=>{Z&&(Z(),Z=void 0,s(this))},this}}t.$Uc=L;class d{constructor(){this.a=new Map}acquire(N,...Z){let ee=this.a.get(N);ee||(ee={counter:0,object:this.b(N,...Z)},this.a.set(N,ee));const{object:ue}=ee,ae=(0,U.$cb)(()=>{--ee.counter===0&&(this.c(N,ee.object),this.a.delete(N))});return ee.counter++,{object:ue,dispose:ae}}}t.$Vc=d;class D{constructor(N){this.a=N}async acquire(N,...Z){const ee=this.a.acquire(N,...Z);try{return{object:await ee.object,dispose:()=>ee.dispose()}}catch(ue){throw ee.dispose(),ue}}}t.$Wc=D;class B{constructor(N){this.object=N}dispose(){}}t.$Xc=B;function z(I){const N=new f;try{I(N)}finally{N.dispose()}}t.$Yc=z;class _{constructor(){this.a=new Map,this.b=!1,O(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(N){return this.a.has(N)}get size(){return this.a.size}get(N){return this.a.get(N)}set(N,Z,ee=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ee||this.a.get(N)?.dispose(),this.a.set(N,Z)}deleteAndDispose(N){this.a.get(N)?.dispose(),this.a.delete(N)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Zc=_}),function(oe,t){typeof define=="function"&&define.amd?define($e[78],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,t(oe.marked={}))}(this,function(oe){"use strict";function t(y,E){for(var M=0;M<E.length;M++){var k=E[M];k.enumerable=k.enumerable||!1,k.configurable=!0,"value"in k&&(k.writable=!0),Object.defineProperty(y,k.key,k)}}function v(y,E,M){return E&&t(y.prototype,E),M&&t(y,M),Object.defineProperty(y,"prototype",{writable:!1}),y}function T(y,E){if(y){if(typeof y=="string")return i(y,E);var M=Object.prototype.toString.call(y).slice(8,-1);if(M==="Object"&&y.constructor&&(M=y.constructor.name),M==="Map"||M==="Set")return Array.from(y);if(M==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(M))return i(y,E)}}function i(y,E){(E==null||E>y.length)&&(E=y.length);for(var M=0,k=new Array(E);M<E;M++)k[M]=y[M];return k}function U(y,E){var M=typeof Symbol<"u"&&y[Symbol.iterator]||y["@@iterator"];if(M)return(M=M.call(y)).next.bind(M);if(Array.isArray(y)||(M=T(y))||E&&y&&typeof y.length=="number"){M&&(y=M);var k=0;return function(){return k>=y.length?{done:!0}:{done:!1,value:y[k++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=w();function A(y){oe.defaults=y}var u=/[&<>"']/,c=/[&<>"']/g,m=/[<>"']|&(?!#?\w+;)/,O=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(E){return s[E]};function e(y,E){if(E){if(u.test(y))return y.replace(c,l)}else if(m.test(y))return y.replace(O,l);return y}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(y){return y.replace(a,function(E,M){return M=M.toLowerCase(),M==="colon"?":":M.charAt(0)==="#"?M.charAt(1)==="x"?String.fromCharCode(parseInt(M.substring(2),16)):String.fromCharCode(+M.substring(1)):""})}var g=/(^|[^\[])\^/g;function n(y,E){y=typeof y=="string"?y:y.source,E=E||"";var M={replace:function(R,C){return C=C.source||C,C=C.replace(g,"$1"),y=y.replace(R,C),M},getRegex:function(){return new RegExp(y,E)}};return M}var r=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(y,E,M){if(y){var k;try{k=decodeURIComponent(h(M)).replace(r,"").toLowerCase()}catch{return null}if(k.indexOf("javascript:")===0||k.indexOf("vbscript:")===0||k.indexOf("data:")===0)return null}E&&!b.test(M)&&(M=d(E,M));try{M=encodeURI(M).replace(/%25/g,"%")}catch{return null}return M}var o={},F=/^[^:]+:\/*[^/]*$/,j=/^([^:]+:)[\s\S]*$/,L=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(y,E){o[" "+y]||(F.test(y)?o[" "+y]=y+"/":o[" "+y]=_(y,"/",!0)),y=o[" "+y];var M=y.indexOf(":")===-1;return E.substring(0,2)==="//"?M?E:y.replace(j,"$1")+E:E.charAt(0)==="/"?M?E:y.replace(L,"$1")+E:y+E}var D={exec:function(){}};function B(y){for(var E=1,M,k;E<arguments.length;E++){M=arguments[E];for(k in M)Object.prototype.hasOwnProperty.call(M,k)&&(y[k]=M[k])}return y}function z(y,E){var M=y.replace(/\|/g,function(C,P,H){for(var x=!1,te=P;--te>=0&&H[te]==="\\";)x=!x;return x?"|":" |"}),k=M.split(/ \|/),R=0;if(k[0].trim()||k.shift(),k.length>0&&!k[k.length-1].trim()&&k.pop(),k.length>E)k.splice(E);else for(;k.length<E;)k.push("");for(;R<k.length;R++)k[R]=k[R].trim().replace(/\\\|/g,"|");return k}function _(y,E,M){var k=y.length;if(k===0)return"";for(var R=0;R<k;){var C=y.charAt(k-R-1);if(C===E&&!M)R++;else if(C!==E&&M)R++;else break}return y.slice(0,k-R)}function I(y,E){if(y.indexOf(E[1])===-1)return-1;for(var M=y.length,k=0,R=0;R<M;R++)if(y[R]==="\\")R++;else if(y[R]===E[0])k++;else if(y[R]===E[1]&&(k--,k<0))return R;return-1}function N(y){y&&y.sanitize&&!y.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Z(y,E){if(E<1)return"";for(var M="";E>1;)E&1&&(M+=y),E>>=1,y+=y;return M+y}function ee(y,E,M,k){var R=E.href,C=E.title?e(E.title):null,P=y[1].replace(/\\([\[\]])/g,"$1");if(y[0].charAt(0)!=="!"){k.state.inLink=!0;var H={type:"link",raw:M,href:R,title:C,text:P,tokens:k.inlineTokens(P)};return k.state.inLink=!1,H}return{type:"image",raw:M,href:R,title:C,text:e(P)}}function ue(y,E){var M=y.match(/^(\s+)(?:```)/);if(M===null)return E;var k=M[1];return E.split(`
`).map(function(R){var C=R.match(/^\s+/);if(C===null)return R;var P=C[0];return P.length>=k.length?R.slice(k.length):R}).join(`
`)}var ae=function(){function y(M){this.options=M||oe.defaults}var E=y.prototype;return E.space=function(k){var R=this.rules.block.newline.exec(k);if(R&&R[0].length>0)return{type:"space",raw:R[0]}},E.code=function(k){var R=this.rules.block.code.exec(k);if(R){var C=R[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:R[0],codeBlockStyle:"indented",text:this.options.pedantic?C:_(C,`
`)}}},E.fences=function(k){var R=this.rules.block.fences.exec(k);if(R){var C=R[0],P=ue(C,R[3]||"");return{type:"code",raw:C,lang:R[2]?R[2].trim():R[2],text:P}}},E.heading=function(k){var R=this.rules.block.heading.exec(k);if(R){var C=R[2].trim();if(/#$/.test(C)){var P=_(C,"#");(this.options.pedantic||!P||/ $/.test(P))&&(C=P.trim())}return{type:"heading",raw:R[0],depth:R[1].length,text:C,tokens:this.lexer.inline(C)}}},E.hr=function(k){var R=this.rules.block.hr.exec(k);if(R)return{type:"hr",raw:R[0]}},E.blockquote=function(k){var R=this.rules.block.blockquote.exec(k);if(R){var C=R[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:R[0],tokens:this.lexer.blockTokens(C,[]),text:C}}},E.list=function(k){var R=this.rules.block.list.exec(k);if(R){var C,P,H,x,te,ne,ge,ve,Ce,Ae,De,Re,Fe=R[1].trim(),Qe=Fe.length>1,ze={type:"list",raw:"",ordered:Qe,start:Qe?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=Qe?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=Qe?Fe:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");k&&(Re=!1,!(!(R=Me.exec(k))||this.rules.block.hr.test(k)));){if(C=R[0],k=k.substring(C.length),ve=R[2].split(`
`,1)[0],Ce=k.split(`
`,1)[0],this.options.pedantic?(x=2,De=ve.trimLeft()):(x=R[2].search(/[^ ]/),x=x>4?1:x,De=ve.slice(x),x+=R[1].length),ne=!1,!ve&&/^ *$/.test(Ce)&&(C+=Ce+`
`,k=k.substring(Ce.length+1),Re=!0),!Re)for(var Ke=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),J=new RegExp("^ {0,"+Math.min(3,x-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:```|~~~)"),we=new RegExp("^ {0,"+Math.min(3,x-1)+"}#");k&&(Ae=k.split(`
`,1)[0],ve=Ae,this.options.pedantic&&(ve=ve.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(ve)||we.test(ve)||Ke.test(ve)||J.test(k)));){if(ve.search(/[^ ]/)>=x||!ve.trim())De+=`
`+ve.slice(x);else if(!ne)De+=`
`+ve;else break;!ne&&!ve.trim()&&(ne=!0),C+=Ae+`
`,k=k.substring(Ae.length+1)}ze.loose||(ge?ze.loose=!0:/\n *\n *$/.test(C)&&(ge=!0)),this.options.gfm&&(P=/^\[[ xX]\] /.exec(De),P&&(H=P[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:C,task:!!P,checked:H,loose:!1,text:De}),ze.raw+=C}ze.items[ze.items.length-1].raw=C.trimRight(),ze.items[ze.items.length-1].text=De.trimRight(),ze.raw=ze.raw.trimRight();var ye=ze.items.length;for(te=0;te<ye;te++){this.lexer.state.top=!1,ze.items[te].tokens=this.lexer.blockTokens(ze.items[te].text,[]);var Pe=ze.items[te].tokens.filter(function(Ue){return Ue.type==="space"}),Be=Pe.every(function(Ue){for(var Ze=Ue.raw.split(""),Je=0,xe=U(Ze),We;!(We=xe()).done;){var tt=We.value;if(tt===`
`&&(Je+=1),Je>1)return!0}return!1});!ze.loose&&Pe.length&&Be&&(ze.loose=!0,ze.items[te].loose=!0)}return ze}},E.html=function(k){var R=this.rules.block.html.exec(k);if(R){var C={type:"html",raw:R[0],pre:!this.options.sanitizer&&(R[1]==="pre"||R[1]==="script"||R[1]==="style"),text:R[0]};if(this.options.sanitize){var P=this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]);C.type="paragraph",C.text=P,C.tokens=this.lexer.inline(P)}return C}},E.def=function(k){var R=this.rules.block.def.exec(k);if(R){R[3]&&(R[3]=R[3].substring(1,R[3].length-1));var C=R[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:C,raw:R[0],href:R[2],title:R[3]}}},E.table=function(k){var R=this.rules.block.table.exec(k);if(R){var C={type:"table",header:z(R[1]).map(function(ge){return{text:ge}}),align:R[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:R[3]&&R[3].trim()?R[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(C.header.length===C.align.length){C.raw=R[0];var P=C.align.length,H,x,te,ne;for(H=0;H<P;H++)/^ *-+: *$/.test(C.align[H])?C.align[H]="right":/^ *:-+: *$/.test(C.align[H])?C.align[H]="center":/^ *:-+ *$/.test(C.align[H])?C.align[H]="left":C.align[H]=null;for(P=C.rows.length,H=0;H<P;H++)C.rows[H]=z(C.rows[H],C.header.length).map(function(ge){return{text:ge}});for(P=C.header.length,x=0;x<P;x++)C.header[x].tokens=this.lexer.inline(C.header[x].text);for(P=C.rows.length,x=0;x<P;x++)for(ne=C.rows[x],te=0;te<ne.length;te++)ne[te].tokens=this.lexer.inline(ne[te].text);return C}}},E.lheading=function(k){var R=this.rules.block.lheading.exec(k);if(R)return{type:"heading",raw:R[0],depth:R[2].charAt(0)==="="?1:2,text:R[1],tokens:this.lexer.inline(R[1])}},E.paragraph=function(k){var R=this.rules.block.paragraph.exec(k);if(R){var C=R[1].charAt(R[1].length-1)===`
`?R[1].slice(0,-1):R[1];return{type:"paragraph",raw:R[0],text:C,tokens:this.lexer.inline(C)}}},E.text=function(k){var R=this.rules.block.text.exec(k);if(R)return{type:"text",raw:R[0],text:R[0],tokens:this.lexer.inline(R[0])}},E.escape=function(k){var R=this.rules.inline.escape.exec(k);if(R)return{type:"escape",raw:R[0],text:e(R[1])}},E.tag=function(k){var R=this.rules.inline.tag.exec(k);if(R)return!this.lexer.state.inLink&&/^<a /i.test(R[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(R[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(R[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(R[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:R[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]):R[0]}},E.link=function(k){var R=this.rules.inline.link.exec(k);if(R){var C=R[2].trim();if(!this.options.pedantic&&/^</.test(C)){if(!/>$/.test(C))return;var P=_(C.slice(0,-1),"\\");if((C.length-P.length)%2===0)return}else{var H=I(R[2],"()");if(H>-1){var x=R[0].indexOf("!")===0?5:4,te=x+R[1].length+H;R[2]=R[2].substring(0,H),R[0]=R[0].substring(0,te).trim(),R[3]=""}}var ne=R[2],ge="";if(this.options.pedantic){var ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ne);ve&&(ne=ve[1],ge=ve[3])}else ge=R[3]?R[3].slice(1,-1):"";return ne=ne.trim(),/^</.test(ne)&&(this.options.pedantic&&!/>$/.test(C)?ne=ne.slice(1):ne=ne.slice(1,-1)),ee(R,{href:ne&&ne.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},R[0],this.lexer)}},E.reflink=function(k,R){var C;if((C=this.rules.inline.reflink.exec(k))||(C=this.rules.inline.nolink.exec(k))){var P=(C[2]||C[1]).replace(/\s+/g," ");if(P=R[P.toLowerCase()],!P||!P.href){var H=C[0].charAt(0);return{type:"text",raw:H,text:H}}return ee(C,P,C[0],this.lexer)}},E.emStrong=function(k,R,C){C===void 0&&(C="");var P=this.rules.inline.emStrong.lDelim.exec(k);if(P&&!(P[3]&&C.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=P[1]||P[2]||"";if(!H||H&&(C===""||this.rules.inline.punctuation.exec(C))){var x=P[0].length-1,te,ne,ge=x,ve=0,Ce=P[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ce.lastIndex=0,R=R.slice(-1*k.length+x);(P=Ce.exec(R))!=null;)if(te=P[1]||P[2]||P[3]||P[4]||P[5]||P[6],!!te){if(ne=te.length,P[3]||P[4]){ge+=ne;continue}else if((P[5]||P[6])&&x%3&&!((x+ne)%3)){ve+=ne;continue}if(ge-=ne,!(ge>0)){if(ne=Math.min(ne,ne+ge+ve),Math.min(x,ne)%2){var Ae=k.slice(1,x+P.index+ne);return{type:"em",raw:k.slice(0,x+P.index+ne+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var De=k.slice(2,x+P.index+ne-1);return{type:"strong",raw:k.slice(0,x+P.index+ne+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},E.codespan=function(k){var R=this.rules.inline.code.exec(k);if(R){var C=R[2].replace(/\n/g," "),P=/[^ ]/.test(C),H=/^ /.test(C)&&/ $/.test(C);return P&&H&&(C=C.substring(1,C.length-1)),C=e(C,!0),{type:"codespan",raw:R[0],text:C}}},E.br=function(k){var R=this.rules.inline.br.exec(k);if(R)return{type:"br",raw:R[0]}},E.del=function(k){var R=this.rules.inline.del.exec(k);if(R)return{type:"del",raw:R[0],text:R[2],tokens:this.lexer.inlineTokens(R[2])}},E.autolink=function(k,R){var C=this.rules.inline.autolink.exec(k);if(C){var P,H;return C[2]==="@"?(P=e(this.options.mangle?R(C[1]):C[1]),H="mailto:"+P):(P=e(C[1]),H=P),{type:"link",raw:C[0],text:P,href:H,tokens:[{type:"text",raw:P,text:P}]}}},E.url=function(k,R){var C;if(C=this.rules.inline.url.exec(k)){var P,H;if(C[2]==="@")P=e(this.options.mangle?R(C[0]):C[0]),H="mailto:"+P;else{var x;do x=C[0],C[0]=this.rules.inline._backpedal.exec(C[0])[0];while(x!==C[0]);P=e(C[0]),C[1]==="www."?H="http://"+P:H=P}return{type:"link",raw:C[0],text:P,href:H,tokens:[{type:"text",raw:P,text:P}]}}},E.inlineText=function(k,R){var C=this.rules.inline.text.exec(k);if(C){var P;return this.lexer.state.inRawBlock?P=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):e(C[0]):C[0]:P=e(this.options.smartypants?R(C[0]):C[0]),{type:"text",raw:C[0],text:P}}},y}(),se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=n(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=n(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=n(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=n(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=n(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=n(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=B({},se),se.gfm=B({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=n(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.gfm.paragraph=n(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",se.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=B({},se.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:n(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=n(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=n(se._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=n(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=n(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=n(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=n(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=n(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=n(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=n(re.reflink).replace("label",re._label).replace("ref",se._label).getRegex(),re.nolink=n(re.nolink).replace("ref",se._label).getRegex(),re.reflinkSearch=n(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=B({},re),re.pedantic=B({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=B({},re.normal,{escape:n(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),re.gfm.url=n(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=B({},re.gfm,{br:n(re.br).replace("{2,}","*").getRegex(),text:n(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function be(y){return y.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Se(y){var E="",M,k,R=y.length;for(M=0;M<R;M++)k=y.charCodeAt(M),Math.random()>.5&&(k="x"+k.toString(16)),E+="&#"+k+";";return E}var Oe=function(){function y(M){this.tokens=[],this.tokens.links=Object.create(null),this.options=M||oe.defaults,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var k={block:se.normal,inline:re.normal};this.options.pedantic?(k.block=se.pedantic,k.inline=re.pedantic):this.options.gfm&&(k.block=se.gfm,this.options.breaks?k.inline=re.breaks:k.inline=re.gfm),this.tokenizer.rules=k}y.lex=function(k,R){var C=new y(R);return C.lex(k)},y.lexInline=function(k,R){var C=new y(R);return C.inlineTokens(k)};var E=y.prototype;return E.lex=function(k){k=k.replace(/\r\n|\r/g,`
`),this.blockTokens(k,this.tokens);for(var R;R=this.inlineQueue.shift();)this.inlineTokens(R.src,R.tokens);return this.tokens},E.blockTokens=function(k,R){var C=this;R===void 0&&(R=[]),this.options.pedantic?k=k.replace(/\t/g,"    ").replace(/^ +$/gm,""):k=k.replace(/^( *)(\t+)/gm,function(ge,ve,Ce){return ve+"    ".repeat(Ce.length)});for(var P,H,x,te;k;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(P=ge.call({lexer:C},k,R))?(k=k.substring(P.raw.length),R.push(P),!0):!1}))){if(P=this.tokenizer.space(k)){k=k.substring(P.raw.length),P.raw.length===1&&R.length>0?R[R.length-1].raw+=`
`:R.push(P);continue}if(P=this.tokenizer.code(k)){k=k.substring(P.raw.length),H=R[R.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+P.raw,H.text+=`
`+P.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):R.push(P);continue}if(P=this.tokenizer.fences(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.heading(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.hr(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.blockquote(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.list(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.html(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.def(k)){k=k.substring(P.raw.length),H=R[R.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+P.raw,H.text+=`
`+P.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[P.tag]||(this.tokens.links[P.tag]={href:P.href,title:P.title});continue}if(P=this.tokenizer.table(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.lheading(k)){k=k.substring(P.raw.length),R.push(P);continue}if(x=k,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,ve=k.slice(1),Ce=void 0;C.options.extensions.startBlock.forEach(function(Ae){Ce=Ae.call({lexer:this},ve),typeof Ce=="number"&&Ce>=0&&(ge=Math.min(ge,Ce))}),ge<1/0&&ge>=0&&(x=k.substring(0,ge+1))}(),this.state.top&&(P=this.tokenizer.paragraph(x))){H=R[R.length-1],te&&H.type==="paragraph"?(H.raw+=`
`+P.raw,H.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):R.push(P),te=x.length!==k.length,k=k.substring(P.raw.length);continue}if(P=this.tokenizer.text(k)){k=k.substring(P.raw.length),H=R[R.length-1],H&&H.type==="text"?(H.raw+=`
`+P.raw,H.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):R.push(P);continue}if(k){var ne="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return this.state.top=!0,R},E.inline=function(k,R){return R===void 0&&(R=[]),this.inlineQueue.push({src:k,tokens:R}),R},E.inlineTokens=function(k,R){var C=this;R===void 0&&(R=[]);var P,H,x,te=k,ne,ge,ve;if(this.tokens.links){var Ce=Object.keys(this.tokens.links);if(Ce.length>0)for(;(ne=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)Ce.includes(ne[0].slice(ne[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,ne.index)+"["+Z("a",ne[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ne=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,ne.index)+"["+Z("a",ne[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ne=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,ne.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;k;)if(ge||(ve=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(P=De.call({lexer:C},k,R))?(k=k.substring(P.raw.length),R.push(P),!0):!1}))){if(P=this.tokenizer.escape(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.tag(k)){k=k.substring(P.raw.length),H=R[R.length-1],H&&P.type==="text"&&H.type==="text"?(H.raw+=P.raw,H.text+=P.text):R.push(P);continue}if(P=this.tokenizer.link(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.reflink(k,this.tokens.links)){k=k.substring(P.raw.length),H=R[R.length-1],H&&P.type==="text"&&H.type==="text"?(H.raw+=P.raw,H.text+=P.text):R.push(P);continue}if(P=this.tokenizer.emStrong(k,te,ve)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.codespan(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.br(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.del(k)){k=k.substring(P.raw.length),R.push(P);continue}if(P=this.tokenizer.autolink(k,Se)){k=k.substring(P.raw.length),R.push(P);continue}if(!this.state.inLink&&(P=this.tokenizer.url(k,Se))){k=k.substring(P.raw.length),R.push(P);continue}if(x=k,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Re=k.slice(1),Fe=void 0;C.options.extensions.startInline.forEach(function(Qe){Fe=Qe.call({lexer:this},Re),typeof Fe=="number"&&Fe>=0&&(De=Math.min(De,Fe))}),De<1/0&&De>=0&&(x=k.substring(0,De+1))}(),P=this.tokenizer.inlineText(x,be)){k=k.substring(P.raw.length),P.raw.slice(-1)!=="_"&&(ve=P.raw.slice(-1)),ge=!0,H=R[R.length-1],H&&H.type==="text"?(H.raw+=P.raw,H.text+=P.text):R.push(P);continue}if(k){var Ae="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return R},v(y,null,[{key:"rules",get:function(){return{block:se,inline:re}}}]),y}(),Te=function(){function y(M){this.options=M||oe.defaults}var E=y.prototype;return E.code=function(k,R,C){var P=(R||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(k,P);H!=null&&H!==k&&(C=!0,k=H)}return k=k.replace(/\n$/,"")+`
`,P?'<pre><code class="'+this.options.langPrefix+e(P,!0)+'">'+(C?k:e(k,!0))+`</code></pre>
`:"<pre><code>"+(C?k:e(k,!0))+`</code></pre>
`},E.blockquote=function(k){return`<blockquote>
`+k+`</blockquote>
`},E.html=function(k){return k},E.heading=function(k,R,C,P){if(this.options.headerIds){var H=this.options.headerPrefix+P.slug(C);return"<h"+R+' id="'+H+'">'+k+"</h"+R+`>
`}return"<h"+R+">"+k+"</h"+R+`>
`},E.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},E.list=function(k,R,C){var P=R?"ol":"ul",H=R&&C!==1?' start="'+C+'"':"";return"<"+P+H+`>
`+k+"</"+P+`>
`},E.listitem=function(k){return"<li>"+k+`</li>
`},E.checkbox=function(k){return"<input "+(k?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},E.paragraph=function(k){return"<p>"+k+`</p>
`},E.table=function(k,R){return R&&(R="<tbody>"+R+"</tbody>"),`<table>
<thead>
`+k+`</thead>
`+R+`</table>
`},E.tablerow=function(k){return`<tr>
`+k+`</tr>
`},E.tablecell=function(k,R){var C=R.header?"th":"td",P=R.align?"<"+C+' align="'+R.align+'">':"<"+C+">";return P+k+("</"+C+`>
`)},E.strong=function(k){return"<strong>"+k+"</strong>"},E.em=function(k){return"<em>"+k+"</em>"},E.codespan=function(k){return"<code>"+k+"</code>"},E.br=function(){return this.options.xhtml?"<br/>":"<br>"},E.del=function(k){return"<del>"+k+"</del>"},E.link=function(k,R,C){if(k=f(this.options.sanitize,this.options.baseUrl,k),k===null)return C;var P='<a href="'+e(k)+'"';return R&&(P+=' title="'+R+'"'),P+=">"+C+"</a>",P},E.image=function(k,R,C){if(k=f(this.options.sanitize,this.options.baseUrl,k),k===null)return C;var P='<img src="'+k+'" alt="'+C+'"';return R&&(P+=' title="'+R+'"'),P+=this.options.xhtml?"/>":">",P},E.text=function(k){return k},y}(),de=function(){function y(){}var E=y.prototype;return E.strong=function(k){return k},E.em=function(k){return k},E.codespan=function(k){return k},E.del=function(k){return k},E.html=function(k){return k},E.text=function(k){return k},E.link=function(k,R,C){return""+C},E.image=function(k,R,C){return""+C},E.br=function(){return""},y}(),ie=function(){function y(){this.seen={}}var E=y.prototype;return E.serialize=function(k){return k.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},E.getNextSafeSlug=function(k,R){var C=k,P=0;if(this.seen.hasOwnProperty(C)){P=this.seen[k];do P++,C=k+"-"+P;while(this.seen.hasOwnProperty(C))}return R||(this.seen[k]=P,this.seen[C]=0),C},E.slug=function(k,R){R===void 0&&(R={});var C=this.serialize(k);return this.getNextSafeSlug(C,R.dryrun)},y}(),fe=function(){function y(M){this.options=M||oe.defaults,this.options.renderer=this.options.renderer||new Te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ie}y.parse=function(k,R){var C=new y(R);return C.parse(k)},y.parseInline=function(k,R){var C=new y(R);return C.parseInline(k)};var E=y.prototype;return E.parse=function(k,R){R===void 0&&(R=!0);var C="",P,H,x,te,ne,ge,ve,Ce,Ae,De,Re,Fe,Qe,ze,Me,Ke,J,he,we,ye=k.length;for(P=0;P<ye;P++){if(De=k[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(we=this.options.extensions.renderers[De.type].call({parser:this},De),we!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){C+=we||"";continue}switch(De.type){case"space":continue;case"hr":{C+=this.renderer.hr();continue}case"heading":{C+=this.renderer.heading(this.parseInline(De.tokens),De.depth,h(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{C+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Ce="",ve="",te=De.header.length,H=0;H<te;H++)ve+=this.renderer.tablecell(this.parseInline(De.header[H].tokens),{header:!0,align:De.align[H]});for(Ce+=this.renderer.tablerow(ve),Ae="",te=De.rows.length,H=0;H<te;H++){for(ge=De.rows[H],ve="",ne=ge.length,x=0;x<ne;x++)ve+=this.renderer.tablecell(this.parseInline(ge[x].tokens),{header:!1,align:De.align[x]});Ae+=this.renderer.tablerow(ve)}C+=this.renderer.table(Ce,Ae);continue}case"blockquote":{Ae=this.parse(De.tokens),C+=this.renderer.blockquote(Ae);continue}case"list":{for(Re=De.ordered,Fe=De.start,Qe=De.loose,te=De.items.length,Ae="",H=0;H<te;H++)Me=De.items[H],Ke=Me.checked,J=Me.task,ze="",Me.task&&(he=this.renderer.checkbox(Ke),Qe?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=he+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=he+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:he}):ze+=he),ze+=this.parse(Me.tokens,Qe),Ae+=this.renderer.listitem(ze,J,Ke);C+=this.renderer.list(Ae,Re,Fe);continue}case"html":{C+=this.renderer.html(De.text);continue}case"paragraph":{C+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ae=De.tokens?this.parseInline(De.tokens):De.text;P+1<ye&&k[P+1].type==="text";)De=k[++P],Ae+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);C+=R?this.renderer.paragraph(Ae):Ae;continue}default:{var Pe='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return C},E.parseInline=function(k,R){R=R||this.renderer;var C="",P,H,x,te=k.length;for(P=0;P<te;P++){if(H=k[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(x=this.options.extensions.renderers[H.type].call({parser:this},H),x!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){C+=x||"";continue}switch(H.type){case"escape":{C+=R.text(H.text);break}case"html":{C+=R.html(H.text);break}case"link":{C+=R.link(H.href,H.title,this.parseInline(H.tokens,R));break}case"image":{C+=R.image(H.href,H.title,H.text);break}case"strong":{C+=R.strong(this.parseInline(H.tokens,R));break}case"em":{C+=R.em(this.parseInline(H.tokens,R));break}case"codespan":{C+=R.codespan(H.text);break}case"br":{C+=R.br();break}case"del":{C+=R.del(this.parseInline(H.tokens,R));break}case"text":{C+=R.text(H.text);break}default:{var ne='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return C},y}();function Y(y,E,M){if(typeof y>"u"||y===null)throw new Error("marked(): input parameter is undefined or null");if(typeof y!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(y)+", string expected");if(typeof E=="function"&&(M=E,E=null),E=B({},Y.defaults,E||{}),N(E),M){var k=E.highlight,R;try{R=Oe.lex(y,E)}catch(te){return M(te)}var C=function(ne){var ge;if(!ne)try{E.walkTokens&&Y.walkTokens(R,E.walkTokens),ge=fe.parse(R,E)}catch(ve){ne=ve}return E.highlight=k,ne?M(ne):M(null,ge)};if(!k||k.length<3||(delete E.highlight,!R.length))return C();var P=0;Y.walkTokens(R,function(te){te.type==="code"&&(P++,setTimeout(function(){k(te.text,te.lang,function(ne,ge){if(ne)return C(ne);ge!=null&&ge!==te.text&&(te.text=ge,te.escaped=!0),P--,P===0&&C()})},0))}),P===0&&C();return}function H(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(te.message+"",!0)+"</pre>";throw te}try{var x=Oe.lex(y,E);if(E.walkTokens){if(E.async)return Promise.all(Y.walkTokens(x,E.walkTokens)).then(function(){return fe.parse(x,E)}).catch(H);Y.walkTokens(x,E.walkTokens)}return fe.parse(x,E)}catch(te){H(te)}}Y.options=Y.setOptions=function(y){return B(Y.defaults,y),A(Y.defaults),Y},Y.getDefaults=w,Y.defaults=oe.defaults,Y.use=function(){for(var y=arguments.length,E=new Array(y),M=0;M<y;M++)E[M]=arguments[M];var k=B.apply(void 0,[{}].concat(E)),R=Y.defaults.extensions||{renderers:{},childTokens:{}},C;E.forEach(function(P){if(P.extensions&&(C=!0,P.extensions.forEach(function(x){if(!x.name)throw new Error("extension name required");if(x.renderer){var te=R.renderers?R.renderers[x.name]:null;te?R.renderers[x.name]=function(){for(var ne=arguments.length,ge=new Array(ne),ve=0;ve<ne;ve++)ge[ve]=arguments[ve];var Ce=x.renderer.apply(this,ge);return Ce===!1&&(Ce=te.apply(this,ge)),Ce}:R.renderers[x.name]=x.renderer}if(x.tokenizer){if(!x.level||x.level!=="block"&&x.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");R[x.level]?R[x.level].unshift(x.tokenizer):R[x.level]=[x.tokenizer],x.start&&(x.level==="block"?R.startBlock?R.startBlock.push(x.start):R.startBlock=[x.start]:x.level==="inline"&&(R.startInline?R.startInline.push(x.start):R.startInline=[x.start]))}x.childTokens&&(R.childTokens[x.name]=x.childTokens)})),P.renderer&&function(){var x=Y.defaults.renderer||new Te,te=function(ve){var Ce=x[ve];x[ve]=function(){for(var Ae=arguments.length,De=new Array(Ae),Re=0;Re<Ae;Re++)De[Re]=arguments[Re];var Fe=P.renderer[ve].apply(x,De);return Fe===!1&&(Fe=Ce.apply(x,De)),Fe}};for(var ne in P.renderer)te(ne);k.renderer=x}(),P.tokenizer&&function(){var x=Y.defaults.tokenizer||new ae,te=function(ve){var Ce=x[ve];x[ve]=function(){for(var Ae=arguments.length,De=new Array(Ae),Re=0;Re<Ae;Re++)De[Re]=arguments[Re];var Fe=P.tokenizer[ve].apply(x,De);return Fe===!1&&(Fe=Ce.apply(x,De)),Fe}};for(var ne in P.tokenizer)te(ne);k.tokenizer=x}(),P.walkTokens){var H=Y.defaults.walkTokens;k.walkTokens=function(x){var te=[];return te.push(P.walkTokens.call(this,x)),H&&(te=te.concat(H.call(this,x))),te}}C&&(k.extensions=R),Y.setOptions(k)})},Y.walkTokens=function(y,E){for(var M=[],k=function(){var H=C.value;switch(M=M.concat(E.call(Y,H)),H.type){case"table":{for(var x=U(H.header),te;!(te=x()).done;){var ne=te.value;M=M.concat(Y.walkTokens(ne.tokens,E))}for(var ge=U(H.rows),ve;!(ve=ge()).done;)for(var Ce=ve.value,Ae=U(Ce),De;!(De=Ae()).done;){var Re=De.value;M=M.concat(Y.walkTokens(Re.tokens,E))}break}case"list":{M=M.concat(Y.walkTokens(H.items,E));break}default:Y.defaults.extensions&&Y.defaults.extensions.childTokens&&Y.defaults.extensions.childTokens[H.type]?Y.defaults.extensions.childTokens[H.type].forEach(function(Fe){M=M.concat(Y.walkTokens(H[Fe],E))}):H.tokens&&(M=M.concat(Y.walkTokens(H.tokens,E)))}},R=U(y),C;!(C=R()).done;)k();return M},Y.parseInline=function(y,E){if(typeof y>"u"||y===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof y!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(y)+", string expected");E=B({},Y.defaults,E||{}),N(E);try{var M=Oe.lexInline(y,E);return E.walkTokens&&Y.walkTokens(M,E.walkTokens),fe.parseInline(M,E)}catch(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}},Y.Parser=fe,Y.parser=fe.parse,Y.Renderer=Te,Y.TextRenderer=de,Y.Lexer=Oe,Y.lexer=Oe.lex,Y.Tokenizer=ae,Y.Slugger=ie,Y.parse=Y;var q=Y.options,X=Y.setOptions,S=Y.use,Q=Y.walkTokens,$=Y.parseInline,W=Y,V=fe.parse,p=Oe.lex;oe.Lexer=Oe,oe.Parser=fe,oe.Renderer=Te,oe.Slugger=ie,oe.TextRenderer=de,oe.Tokenizer=ae,oe.getDefaults=w,oe.lexer=p,oe.marked=Y,oe.options=q,oe.parse=W,oe.parseInline=$,oe.parser=V,oe.setOptions=X,oe.use=S,oe.walkTokens=Q,Object.defineProperty(oe,"__esModule",{value:!0})}),define($e[79],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9R=void 0;class v{constructor(i,U=0,w=i.length,A=U-1){this.a=i,this.b=U,this.c=w,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$9R=v}),define($e[80],pe([1,0,79]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$R=t.$0R=void 0;class T{constructor(w=[],A=10){this.h(w),this.b=A,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new v.$9R(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const A of w)this.a.add(A)}get j(){const w=[];return this.a.forEach(A=>w.push(A)),w}}t.$0R=T;class i{get size(){return this.f}constructor(w,A=10){if(this.g=A,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new Set([w[0]]);for(let u=1;u<w.length;u++)this.add(w[u])}add(w){const A={value:w,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(w)?this.h(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.c.value===w)return w;const A=this.c.value;return this.a.delete(A),this.c.value=w,this.a.has(w)?this.h(w):this.a.add(w),A}prepend(w){if(this.f===this.g||this.a.has(w))return;const A={value:w,previous:void 0,next:this.b};this.b.previous=A,this.b=A,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}h(w){let A=this.b;for(;A!==this.c;)A.value===w&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.$$R=i}),define($e[45],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tl=t.$Sl=t.$Rl=t.rot=t.$Pl=void 0;function v(A,u,c){return Math.min(Math.max(A,u),c)}t.$Pl=v;function T(A,u){return(u+A%u)%u}t.rot=T;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Rl=i;class U{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Sl=U;class w{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Tl=w}),define($e[46],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(T){function i(u,c){if(u.start>=c.end||c.start>=u.end)return{start:0,end:0};const m=Math.max(u.start,c.start),O=Math.min(u.end,c.end);return O-m<=0?{start:0,end:0}:{start:m,end:O}}T.intersect=i;function U(u){return u.end-u.start<=0}T.isEmpty=U;function w(u,c){return!U(i(u,c))}T.intersects=w;function A(u,c){const m=[],O={start:u.start,end:Math.min(c.start,u.end)},s={start:Math.max(c.end,u.start),end:u.end};return U(O)||m.push(O),U(s)||m.push(s),m}T.relativeComplement=A})(v||(t.Range=v={}))}),define($e[81],pe([1,0,46]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Q=t.$1Q=t.$ZQ=t.$YQ=void 0;function T(u,c){const m=[];for(const O of c){if(u.start>=O.range.end)continue;if(u.end<O.range.start)break;const s=v.Range.intersect(u,O.range);v.Range.isEmpty(s)||m.push({range:s,size:O.size})}return m}t.$YQ=T;function i({start:u,end:c},m){return{start:u+m,end:c+m}}t.$ZQ=i;function U(u){const c=[];let m=null;for(const O of u){const s=O.range.start,l=O.range.end,e=O.size;if(m&&e===m.size){m.range.end=l;continue}m={range:{start:s,end:l},size:e},c.push(m)}return c}t.$1Q=U;function w(...u){return U(u.reduce((c,m)=>c.concat(m),[]))}class A{get paddingTop(){return this.c}set paddingTop(c){this.b=this.b+c-this.c,this.c=c}constructor(c){this.a=[],this.b=0,this.c=0,this.c=c??0,this.b=this.c}splice(c,m,O=[]){const s=O.length-m,l=T({start:0,end:c},this.a),e=T({start:c+m,end:Number.POSITIVE_INFINITY},this.a).map(h=>({range:i(h.range,s),size:h.size})),a=O.map((h,g)=>({range:{start:c+g,end:c+g+1},size:h.size}));this.a=w(l,a,e),this.b=this.c+this.a.reduce((h,g)=>h+g.size*(g.range.end-g.range.start),0)}get count(){const c=this.a.length;return c?this.a[c-1].range.end:0}get size(){return this.b}indexAt(c){if(c<0)return-1;if(c<this.c)return 0;let m=0,O=this.c;for(const s of this.a){const l=s.range.end-s.range.start,e=O+l*s.size;if(c<e)return m+Math.floor((c-O)/s.size);m+=l,O=e}return m}indexAfter(c){return Math.min(this.indexAt(c)+1,this.count)}positionAt(c){if(c<0)return-1;let m=0,O=0;for(const s of this.a){const l=s.range.end-s.range.start,e=O+l;if(c<e)return this.c+m+(c-O)*s.size;m+=l*s.size,O=e}return-1}}t.$2Q=A}),define($e[82],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jd=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(U){return new T(U)}constructor(U){this.c=v&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Jd=T}),define($e[4],pe([1,0,6,42,2,44,82]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.Event=void 0;const A=!1,u=!1;var c;(function(_){_.None=()=>i.$Rc.None;function I(R){if(u){const{onDidAddListener:C}=R,P=e.create();let H=0;R.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),P.print()),C?.()}}}function N(R,C){return Te(R,()=>{},0,void 0,!0,void 0,C)}_.defer=N;function Z(R){return(C,P=null,H)=>{let x=!1,te;return te=R(ne=>{if(!x)return te?te.dispose():x=!0,C.call(P,ne)},null,H),x&&te.dispose(),te}}_.once=Z;function ee(R,C,P){return Se((H,x=null,te)=>R(ne=>H.call(x,C(ne)),null,te),P)}_.map=ee;function ue(R,C,P){return Se((H,x=null,te)=>R(ne=>{C(ne),H.call(x,ne)},null,te),P)}_.forEach=ue;function ae(R,C,P){return Se((H,x=null,te)=>R(ne=>C(ne)&&H.call(x,ne),null,te),P)}_.filter=ae;function se(R){return R}_.signal=se;function re(...R){return(C,P=null,H)=>{const x=(0,i.$Oc)(...R.map(te=>te(ne=>C.call(P,ne))));return Oe(x,H)}}_.any=re;function be(R,C,P,H){let x=P;return ee(R,te=>(x=C(x,te),x),H)}_.reduce=be;function Se(R,C){let P;const H={onWillAddFirstListener(){P=R(x.fire,x)},onDidRemoveLastListener(){P?.dispose()}};C||I(H);const x=new r(H);return C?.add(x),x.event}function Oe(R,C){return C instanceof Array?C.push(R):C&&C.add(R),R}function Te(R,C,P=100,H=!1,x=!1,te,ne){let ge,ve,Ce,Ae=0,De;const Re={leakWarningThreshold:te,onWillAddFirstListener(){ge=R(Qe=>{Ae++,ve=C(ve,Qe),H&&!Ce&&(Fe.fire(ve),ve=void 0),De=()=>{const ze=ve;ve=void 0,Ce=void 0,(!H||Ae>1)&&Fe.fire(ze),Ae=0},typeof P=="number"?(clearTimeout(Ce),Ce=setTimeout(De,P)):Ce===void 0&&(Ce=0,queueMicrotask(De))})},onWillRemoveListener(){x&&Ae>0&&De?.()},onDidRemoveLastListener(){De=void 0,ge.dispose()}};ne||I(Re);const Fe=new r(Re);return ne?.add(Fe),Fe.event}_.debounce=Te;function de(R,C=0,P){return _.debounce(R,(H,x)=>H?(H.push(x),H):[x],C,void 0,!0,void 0,P)}_.accumulate=de;function ie(R,C=(H,x)=>H===x,P){let H=!0,x;return ae(R,te=>{const ne=H||!C(te,x);return H=!1,x=te,ne},P)}_.latch=ie;function fe(R,C,P){return[_.filter(R,C,P),_.filter(R,H=>!C(H),P)]}_.split=fe;function Y(R,C=!1,P=[],H){let x=P.slice(),te=R(ve=>{x?x.push(ve):ge.fire(ve)});H&&H.add(te);const ne=()=>{x?.forEach(ve=>ge.fire(ve)),x=null},ge=new r({onWillAddFirstListener(){te||(te=R(ve=>ge.fire(ve)),H&&H.add(te))},onDidAddFirstListener(){x&&(C?setTimeout(ne):ne())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return H&&H.add(ge),ge.event}_.buffer=Y;function q(R,C){return(H,x,te)=>{const ne=C(new S);return R(function(ge){const ve=ne.evaluate(ge);ve!==X&&H.call(x,ve)},void 0,te)}}_.chain=q;const X=Symbol("HaltChainable");class S{constructor(){this.f=[]}map(C){return this.f.push(C),this}forEach(C){return this.f.push(P=>(C(P),P)),this}filter(C){return this.f.push(P=>C(P)?P:X),this}reduce(C,P){let H=P;return this.f.push(x=>(H=C(H,x),H)),this}latch(C=(P,H)=>P===H){let P=!0,H;return this.f.push(x=>{const te=P||!C(x,H);return P=!1,H=x,te?x:X}),this}evaluate(C){for(const P of this.f)if(C=P(C),C===X)break;return C}}function Q(R,C,P=H=>H){const H=(...ge)=>ne.fire(P(...ge)),x=()=>R.on(C,H),te=()=>R.removeListener(C,H),ne=new r({onWillAddFirstListener:x,onDidRemoveLastListener:te});return ne.event}_.fromNodeEventEmitter=Q;function $(R,C,P=H=>H){const H=(...ge)=>ne.fire(P(...ge)),x=()=>R.addEventListener(C,H),te=()=>R.removeEventListener(C,H),ne=new r({onWillAddFirstListener:x,onDidRemoveLastListener:te});return ne.event}_.fromDOMEventEmitter=$;function W(R){return new Promise(C=>Z(R)(C))}_.toPromise=W;function V(R){const C=new r;return R.then(P=>{C.fire(P)},()=>{C.fire(void 0)}).finally(()=>{C.dispose()}),C.event}_.fromPromise=V;function p(R,C,P){return C(P),R(H=>C(H))}_.runAndSubscribe=p;function y(R,C){let P=null;function H(te){P?.dispose(),P=new i.$Qc,C(te,P)}H(void 0);const x=R(te=>H(te));return(0,i.$Pc)(()=>{x.dispose(),P?.dispose()})}_.runAndSubscribeWithStore=y;class E{constructor(C,P){this._observable=C,this.f=0,this.g=!1;const H={onWillAddFirstListener:()=>{C.addObserver(this)},onDidRemoveLastListener:()=>{C.removeObserver(this)}};P||I(H),this.emitter=new r(H),P&&P.add(this.emitter)}beginUpdate(C){this.f++}handlePossibleChange(C){}handleChange(C,P){this.g=!0}endUpdate(C){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function M(R,C){return new E(R,C).emitter.event}_.fromObservable=M;function k(R){return C=>{let P=0,H=!1;const x={beginUpdate(){P++},endUpdate(){P--,P===0&&(R.reportChanges(),H&&(H=!1,C()))},handlePossibleChange(){},handleChange(){H=!0}};return R.addObserver(x),R.reportChanges(),{dispose(){R.removeObserver(x)}}}}_.fromObservableLight=k})(c||(t.Event=c={}));class m{static{this.all=new Set}static{this.f=0}constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${m.f++}`,m.all.add(this)}start(I){this.g=new w.$Jd,this.listenerCount=I}stop(){if(this.g){const I=this.g.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.g=void 0}}}t.$Ld=m;let O=-1;function s(_){const I=O;return O=_,{dispose(){O=I}}}t.$Md=s;class l{constructor(I,N=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=N,this.g=0}dispose(){this.f?.clear()}check(I,N){const Z=this.threshold;if(Z<=0||N<Z)return;this.f||(this.f=new Map);const ee=this.f.get(I.value)||0;if(this.f.set(I.value,ee+1),this.g-=1,this.g<=0){this.g=Z*.5;let ue,ae=0;for(const[se,re]of this.f)(!ue||ae<re)&&(ue=se,ae=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${N} listeners already. MOST frequent listener (${ae}):`),console.warn(ue)}return()=>{const ue=this.f.get(I.value)||0;this.f.set(I.value,ue-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let a=0;class h{constructor(I){this.value=I,this.id=a++}}const g=2,n=(_,I)=>{if(_ instanceof h)I(_);else for(let N=0;N<_.length;N++){const Z=_[N];Z&&I(Z)}};class r{constructor(I){this.w=0,this.f=I,this.g=O>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??O):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(A){const I=this.t;queueMicrotask(()=>{n(I,N=>N.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(I,N,Z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Rc.None;if(this.m)return i.$Rc.None;N&&(I=I.bind(N));const ee=new h(I);let ue,ae;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=e.create(),ue=this.g.check(ee.stack,this.w+1)),A&&(ee.stack=ae??e.create()),this.t?this.t instanceof h?(this.u??=new f,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const se=(0,i.$Pc)(()=>{ue?.(),this.x(ee)});return Z instanceof i.$Qc?Z.add(se):Array.isArray(Z)&&Z.push(se),se},this.q}x(I){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const N=this.t,Z=N.indexOf(I);if(Z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,N[Z]=void 0;const ee=this.u.current===this;if(this.w*g<=N.length){let ue=0;for(let ae=0;ae<N.length;ae++)N[ae]?N[ue++]=N[ae]:ee&&(this.u.end--,ue<this.u.i&&this.u.i--);N.length=ue}}y(I,N){if(!I)return;const Z=this.f?.onListenerError||v.$Z;if(!Z){I.value(N);return}try{I.value(N)}catch(ee){Z(ee)}}z(I){const N=I.current.t;for(;I.i<I.end;)this.y(N[I.i++],I.value);I.reset()}fire(I){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,I);else{const N=this.u;N.enqueue(this,I,this.t.length),this.z(N)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Nd=r;const b=()=>new f;t.$Od=b;class f{constructor(){this.i=-1,this.end=0}enqueue(I,N,Z){this.i=0,this.end=Z,this.current=I,this.value=N}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(I,N,Z){if(this.t)for(this.h||(this.h=new U.$1c),n(this.t,ee=>this.h.push([ee.value,I]));this.h.size>0&&!N.isCancellationRequested;){const[ee,ue]=this.h.shift(),ae=[],se={...ue,token:N,waitUntil:re=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");Z&&(re=Z(re,ee)),ae.push(re)}};try{ee(se)}catch(re){(0,v.$Z)(re);continue}Object.freeze(ae),await Promise.allSettled(ae).then(re=>{for(const be of re)be.status==="rejected"&&(0,v.$Z)(be.reason)})}}}t.$Pd=o;class F extends r{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new U.$1c,this.A=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.A(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.w&&(this.h!==0?this.s.push(I):super.fire(I))}}t.$Qd=F;class j extends F{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}t.$Rd=j;class L extends r{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(N=>super.fire(N)),this.h=[]}))}}t.$Sd=L;class d{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(I){const N={event:I,listener:null};this.h.push(N),this.g&&this.m(N);const Z=()=>{this.g&&this.o(N);const ee=this.h.indexOf(N);this.h.splice(ee,1)};return(0,i.$Pc)((0,T.$cb)(Z))}j(){this.g=!0,this.h.forEach(I=>this.m(I))}k(){this.g=!1,this.h.forEach(I=>this.o(I))}m(I){I.listener=I.event(N=>this.f.fire(N))}o(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.f.dispose()}}t.$Td=d;class D{constructor(I,N,Z,ee){this.f=new i.$Qc;const ue=this.f.add(new d),ae=this.f.add(new i.$Zc);function se(re){ae.set(re,ue.add(ee(re)))}for(const re of I)se(re);this.f.add(N(re=>{se(re)})),this.f.add(Z(re=>{ae.deleteAndDispose(re)})),this.event=ue.event}dispose(){this.f.dispose()}}t.$Ud=D;class B{constructor(){this.f=[]}wrapEvent(I){return(N,Z,ee)=>I(ue=>{const ae=this.f[this.f.length-1];ae?ae.push(()=>N.call(Z,ue)):N.call(Z,ue)},void 0,ee)}bufferEvents(I){const N=[];this.f.push(N);const Z=I();return this.f.pop(),N.forEach(ee=>ee()),Z}}t.$Vd=B;class z{constructor(){this.f=!1,this.g=c.None,this.h=i.$Rc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(I){this.g=I,this.f&&(this.h.dispose(),this.h=I(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Wd=z}),define($e[16],pe([1,0,4,2]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=t.$uO=t.$tO=t.$sO=t.$rO=t.$qO=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new v.$Nd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new i}getZoomLevel(){return this.a}setZoomLevel(b){this.a!==b&&(this.a=b)}getZoomFactor(){return this.b}setZoomFactor(b){this.b=b}setFullscreen(b){this.c!==b&&(this.c=b,this.d.fire())}isFullscreen(){return this.c}}class U extends T.$Rc{constructor(){super(),this.a=this.B(new v.$Nd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(b){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),b&&this.a.fire()}}class w extends T.$Rc{get value(){return this.b}constructor(){super(),this.a=this.B(new v.$Nd),this.onDidChange=this.a.event,this.b=this.c();const b=this.B(new U);this.B(b.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const b=document.createElement("canvas").getContext("2d"),f=window.devicePixelRatio||1,o=b.webkitBackingStorePixelRatio||b.mozBackingStorePixelRatio||b.msBackingStorePixelRatio||b.oBackingStorePixelRatio||b.backingStorePixelRatio||1;return f/o}}class A{constructor(){this.a=null}b(){return this.a||(this.a=(0,T.$Kc)(new w)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function u(r,b){typeof r=="string"&&(r=window.matchMedia(r)),r.addEventListener("change",b)}t.$qO=u,t.$rO=new A;function c(r){i.INSTANCE.setZoomLevel(r)}t.$sO=c;function m(){return i.INSTANCE.getZoomLevel()}t.$tO=m;function O(){return i.INSTANCE.getZoomFactor()}t.$uO=O;function s(r){i.INSTANCE.setZoomFactor(r)}t.$vO=s;function l(r){i.INSTANCE.setFullscreen(r)}t.$wO=l;function e(){return i.INSTANCE.isFullscreen()}t.$xO=e,t.$yO=i.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.$zO=a.indexOf("Firefox")>=0,t.$AO=a.indexOf("AppleWebKit")>=0,t.$BO=a.indexOf("Chrome")>=0,t.$CO=!t.$BO&&a.indexOf("Safari")>=0,t.$DO=!t.$BO&&!t.$CO&&t.$AO,t.$EO=a.indexOf("Electron/")>=0,t.$FO=a.indexOf("Android")>=0;let h=!1;if(window.matchMedia){const r=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),b=window.matchMedia("(display-mode: fullscreen)");h=r.matches,u(r,({matches:f})=>{h&&b.matches||(h=f)})}function g(){return h}t.$GO=g;function n(){return navigator?.windowControlsOverlay?.visible}t.$HO=n}),define($e[21],pe([1,0,4]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QQ=void 0;class T{get event(){return this.a.event}constructor(U,w,A){const u=c=>this.a.fire(c);this.a=new v.$Nd({onWillAddFirstListener:()=>U.addEventListener(w,u,A),onDidRemoveLastListener:()=>U.removeEventListener(w,u,A)})}dispose(){this.a.dispose()}}t.$QQ=T}),define($e[28],pe([1,0,4]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xd=t.CancellationToken=void 0;const T=Object.freeze(function(A,u){const c=setTimeout(A.bind(u),0);return{dispose(){clearTimeout(c)}}});var i;(function(A){function u(c){return c===A.None||c===A.Cancelled||c instanceof U?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}A.isCancellationToken=u,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(i||(t.CancellationToken=i={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new v.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(u){this.f=void 0,this.g=void 0,this.g=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=i.Cancelled}dispose(u=!1){u&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=i.None}}t.$Xd=w}),define($e[83],pe([1,0,28]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.$we=void 0;class T{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new v.$Xd,u=this.b(A.token);return this.a={promise:u,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}t.$we=T;class i{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const u=JSON.stringify(A);return this.b!==u&&(this.b=u,this.a=this.c(A)),this.a}}t.$xe=i;class U{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const u=this.b(A);return this.a.set(A,u),u}}t.$ye=U}),define($e[47],pe([1,0,4,2]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yr=t.$Xr=t.$Wr=t.$Vr=t.ScrollbarVisibility=void 0;var i;(function(l){l[l.Auto=1]="Auto",l[l.Hidden=2]="Hidden",l[l.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class U{constructor(e,a,h,g,n,r,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(a=a|0,h=h|0,g=g|0,n=n|0,r=r|0,b=b|0),this.rawScrollLeft=g,this.rawScrollTop=b,a<0&&(a=0),g+a>h&&(g=h-a),g<0&&(g=0),n<0&&(n=0),b+n>r&&(b=r-n),b<0&&(b=0),this.width=a,this.scrollWidth=h,this.scrollLeft=g,this.height=n,this.scrollHeight=r,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,a){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,a){const h=this.width!==e.width,g=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,f=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:a,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:h,scrollWidthChanged:g,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:b,scrollTopChanged:f}}}t.$Vr=U;class w extends T.$Rc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$Nd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,a){const h=this.g.withScrollDimensions(e,a);this.n(h,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const a=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(e,a){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const h=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===h.scrollLeft&&this.h.to.scrollTop===h.scrollTop)return;let g;a?g=new m(this.h.from,h,this.h.startTime,this.h.duration):g=this.h.combine(this.g,h,this.c),this.h.dispose(),this.h=g}else{const h=this.g.withScrollPosition(e);this.h=m.start(this.g,h,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),a=this.g.withScrollPosition(e);if(this.n(a,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,a){const h=this.g;h.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(h,a)))}}t.$Wr=w;class A{constructor(e,a,h){this.scrollLeft=e,this.scrollTop=a,this.isDone=h}}t.$Xr=A;function u(l,e){const a=e-l;return function(h){return l+a*s(h)}}function c(l,e,a){return function(h){return h<a?l(h/a):e((h-a)/(1-a))}}class m{constructor(e,a,h,g){this.from=e,this.to=a,this.duration=g,this.startTime=h,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,a,h){if(Math.abs(e-a)>2.5*h){let n,r;return e<a?(n=e+.75*h,r=a-.75*h):(n=e-.75*h,r=a+.75*h),c(u(e,n),u(r,a),.33)}return u(e,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const a=(e-this.startTime)/this.duration;if(a<1){const h=this.c(a),g=this.d(a);return new A(h,g,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,a,h){return m.start(e,a,h)}static start(e,a,h){h=h+10;const g=Date.now()-10;return new m(e,a,g,h)}}t.$Yr=m;function O(l){return Math.pow(l,3)}function s(l){return 1-O(1-l)}}),define($e[84],pe([1,0,6,2]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=void 0;function i(b){const f=b;return f?typeof f.read=="function":!1}t.$Yd=i;function U(b){const f=b;return f?[f.on,f.pause,f.resume,f.destroy].every(o=>typeof o=="function"):!1}t.$Zd=U;function w(b){const f=b;return f?U(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}t.$1d=w;function A(b,f){return new u(b,f)}t.$2d=A;class u{constructor(f,o){this.e=f,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(o=>o(f))}h(f){this.c.error.length===0?(0,v.$Z)(f):this.c.error.slice(0).forEach(o=>o(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,o){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(f,o){if(this.a.destroyed)return;let F;switch(f){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const j=F.indexOf(o);j>=0&&F.splice(j,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(b,f){const o=[];let F;for(;(F=b.read())!==null;)o.push(F);return f(o)}t.$3d=c;function m(b,f,o){const F=[];let j;for(;(j=b.read())!==null&&F.length<o;)F.push(j);return j===null&&F.length>0?f(F):{read:()=>{if(F.length>0)return F.shift();if(typeof j<"u"){const L=j;return j=void 0,L}return b.read()}}}t.$4d=m;function O(b,f){return new Promise((o,F)=>{const j=[];s(b,{onData:L=>{f&&j.push(L)},onError:L=>{f?F(L):o(void 0)},onEnd:()=>{o(f?f(j):void 0)}})})}t.$5d=O;function s(b,f,o){b.on("error",F=>{o?.isCancellationRequested||f.onError(F)}),b.on("end",()=>{o?.isCancellationRequested||f.onEnd()}),b.on("data",F=>{o?.isCancellationRequested||f.onData(F)})}t.$6d=s;function l(b,f){return new Promise((o,F)=>{const j=new T.$Qc,L=[],d=z=>{if(L.push(z),L.length>f)return j.dispose(),b.pause(),o({stream:b,buffer:L,ended:!1})},D=z=>(j.dispose(),F(z)),B=()=>(j.dispose(),o({stream:b,buffer:L,ended:!0}));j.add((0,T.$Pc)(()=>b.removeListener("error",D))),b.on("error",D),j.add((0,T.$Pc)(()=>b.removeListener("end",B))),b.on("end",B),j.add((0,T.$Pc)(()=>b.removeListener("data",d))),b.on("data",d)})}t.$7d=l;function e(b,f){const o=A(f);return o.end(b),o}t.$8d=e;function a(){const b=A(()=>{throw new Error("not supported")});return b.end(),b}t.$9d=a;function h(b){let f=!1;return{read:()=>f?null:(f=!0,b)}}t.$0d=h;function g(b,f,o){const F=A(o);return s(b,{onData:j=>F.write(f.data(j)),onError:j=>F.error(f.error?f.error(j):j),onEnd:()=>F.end()}),F}t.$$d=g;function n(b,f,o){let F=!1;return{read:()=>{const j=f.read();return F?j:(F=!0,j!==null?o([b,j]):b)}}}t.$_d=n;function r(b,f,o){let F=!1;const j=A(o);return s(f,{onData:L=>F?j.write(L):(F=!0,j.write(o([b,L]))),onError:L=>j.error(L),onEnd:()=>{F||(F=!0,j.write(b)),j.end()}}),j}t.$ae=r}),define($e[32],pe([1,0,27,84]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=void 0;const i=typeof Buffer<"u",U=new v.$U(()=>new Uint8Array(256));let w,A;class u{static alloc(N){return i?new u(Buffer.allocUnsafe(N)):new u(new Uint8Array(N))}static wrap(N){return i&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new u(N)}static fromString(N,Z){return!(Z?.dontUseNodeBuffer||!1)&&i?new u(Buffer.from(N)):(w||(w=new TextEncoder),new u(w.encode(N)))}static fromByteArray(N){const Z=u.alloc(N.length);for(let ee=0,ue=N.length;ee<ue;ee++)Z.buffer[ee]=N[ee];return Z}static concat(N,Z){if(typeof Z>"u"){Z=0;for(let ae=0,se=N.length;ae<se;ae++)Z+=N[ae].byteLength}const ee=u.alloc(Z);let ue=0;for(let ae=0,se=N.length;ae<se;ae++){const re=N[ae];ee.set(re,ue),ue+=re.byteLength}return ee}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=u.alloc(this.byteLength);return N.set(this),N}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(N,Z){return new u(this.buffer.subarray(N,Z))}set(N,Z){if(N instanceof u)this.buffer.set(N.buffer,Z);else if(N instanceof Uint8Array)this.buffer.set(N,Z);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),Z);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),Z);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return s(this.buffer,N)}writeUInt32BE(N,Z){l(this.buffer,N,Z)}readUInt32LE(N){return e(this.buffer,N)}writeUInt32LE(N,Z){a(this.buffer,N,Z)}readUInt8(N){return h(this.buffer,N)}writeUInt8(N,Z){g(this.buffer,N,Z)}indexOf(N,Z=0){return c(this.buffer,N instanceof u?N.buffer:N,Z)}}t.$be=u;function c(I,N,Z=0){const ee=N.byteLength,ue=I.byteLength;if(ee===0)return 0;if(ee===1)return I.indexOf(N[0]);if(ee>ue-Z)return-1;const ae=U.value;ae.fill(N.length);for(let Se=0;Se<N.length;Se++)ae[N[Se]]=N.length-Se-1;let se=Z+N.length-1,re=se,be=-1;for(;se<ue;)if(I[se]===N[re]){if(re===0){be=se;break}se--,re--}else se+=Math.max(N.length-re,ae[I[se]]),re=N.length-1;return be}t.$ce=c;function m(I,N){return I[N+0]<<0>>>0|I[N+1]<<8>>>0}t.$de=m;function O(I,N,Z){I[Z+0]=N&255,N=N>>>8,I[Z+1]=N&255}t.$ee=O;function s(I,N){return I[N]*2**24+I[N+1]*2**16+I[N+2]*2**8+I[N+3]}t.$fe=s;function l(I,N,Z){I[Z+3]=N,N=N>>>8,I[Z+2]=N,N=N>>>8,I[Z+1]=N,N=N>>>8,I[Z]=N}t.$ge=l;function e(I,N){return I[N+0]<<0>>>0|I[N+1]<<8>>>0|I[N+2]<<16>>>0|I[N+3]<<24>>>0}t.$he=e;function a(I,N,Z){I[Z+0]=N&255,N=N>>>8,I[Z+1]=N&255,N=N>>>8,I[Z+2]=N&255,N=N>>>8,I[Z+3]=N&255}t.$ie=a;function h(I,N){return I[N]}t.$je=h;function g(I,N,Z){I[Z]=N}t.$ke=g;function n(I){return T.$3d(I,N=>u.concat(N))}t.$le=n;function r(I){return T.$0d(I)}t.$me=r;function b(I){return T.$5d(I,N=>u.concat(N))}t.$ne=b;async function f(I){return I.ended?u.concat(I.buffer):u.concat([...I.buffer,await b(I.stream)])}t.$oe=f;function o(I){return T.$8d(I,N=>u.concat(N))}t.$pe=o;function F(I){return T.$$d(I,{data:N=>typeof N=="string"?u.fromString(N):u.wrap(N)},N=>u.concat(N))}t.$qe=F;function j(I){return T.$2d(N=>u.concat(N),I)}t.$re=j;function L(I,N){return T.$_d(I,N,Z=>u.concat(Z))}t.$se=L;function d(I,N){return T.$ae(I,N,Z=>u.concat(Z))}t.$te=d;function D(I){let N=0,Z=0,ee=0;const ue=new Uint8Array(Math.floor(I.length/4*3)),ae=re=>{switch(Z){case 3:ue[ee++]=N|re,Z=0;break;case 2:ue[ee++]=N|re>>>2,N=re<<6,Z=3;break;case 1:ue[ee++]=N|re>>>4,N=re<<4,Z=2;break;default:N=re<<2,Z=1}};for(let re=0;re<I.length;re++){const be=I.charCodeAt(re);if(be>=65&&be<=90)ae(be-65);else if(be>=97&&be<=122)ae(be-97+26);else if(be>=48&&be<=57)ae(be-48+52);else if(be===43||be===45)ae(62);else if(be===47||be===95)ae(63);else{if(be===61)break;throw new SyntaxError(`Unexpected base64 character ${I[re]}`)}}const se=ee;for(;Z>0;)ae(0);return u.wrap(ue).slice(0,se)}t.$ue=D;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function _({buffer:I},N=!0,Z=!1){const ee=Z?z:B;let ue="";const ae=I.byteLength%3;let se=0;for(;se<I.byteLength-ae;se+=3){const re=I[se+0],be=I[se+1],Se=I[se+2];ue+=ee[re>>>2],ue+=ee[(re<<4|be>>>4)&63],ue+=ee[(be<<2|Se>>>6)&63],ue+=ee[Se&63]}if(ae===1){const re=I[se+0];ue+=ee[re>>>2],ue+=ee[re<<4&63],N&&(ue+="==")}else if(ae===2){const re=I[se+0],be=I[se+1];ue+=ee[re>>>2],ue+=ee[(re<<4|be>>>4)&63],ue+=ee[be<<2&63],N&&(ue+="=")}return ue}t.$ve=_}),define($e[12],pe([1,0,83,27]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xf=t.$wf=t.$vf=t.$uf=t.GraphemeBreakType=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=void 0;function i(J){return!J||typeof J!="string"?!0:J.trim().length===0}t.$Be=i;const U=/{(\d+)}/g;function w(J,...he){return he.length===0?J:J.replace(U,function(we,ye){const Pe=parseInt(ye,10);return isNaN(Pe)||Pe<0||Pe>=he.length?we:he[Pe]})}t.$Ce=w;const A=/{([^}]+)}/g;function u(J,he){return Object.keys(he).length===0?J:J.replace(A,(we,ye)=>he[ye]??we)}t.$De=u;function c(J){return J.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$Ee=c;function m(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Fe=m;function O(J,he){let we=0;const ye=he.charCodeAt(0);for(let Pe=J.length-1;Pe>=0;Pe--)J.charCodeAt(Pe)===ye&&we++;return we}t.$Ge=O;function s(J,he,we="\u2026"){return J.length<=he?J:`${J.substr(0,he)}${we}`}t.$He=s;function l(J,he=" "){const we=e(J,he);return a(we,he)}t.$Ie=l;function e(J,he){if(!J||!he)return J;const we=he.length;if(we===0||J.length===0)return J;let ye=0;for(;J.indexOf(he,ye)===ye;)ye=ye+we;return J.substring(ye)}t.$Je=e;function a(J,he){if(!J||!he)return J;const we=he.length,ye=J.length;if(we===0||ye===0)return J;let Pe=ye,Be=-1;for(;Be=J.lastIndexOf(he,Pe-1),!(Be===-1||Be+we!==Pe);){if(Be===0)return"";Pe=Be}return J.substring(0,Pe)}t.$Ke=a;function h(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Le=h;function g(J){return J.replace(/\*/g,"")}t.$Me=g;function n(J,he,we={}){if(!J)throw new Error("Cannot create regex from empty string");he||(J=m(J)),we.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let ye="";return we.global&&(ye+="g"),we.matchCase||(ye+="i"),we.multiline&&(ye+="m"),we.unicode&&(ye+="u"),new RegExp(J,ye)}t.$Ne=n;function r(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}t.$Oe=r;function b(J){return J.split(/\r\n|\r|\n/)}t.$Pe=b;function f(J){for(let he=0,we=J.length;he<we;he++){const ye=J.charCodeAt(he);if(ye!==32&&ye!==9)return he}return-1}t.$Qe=f;function o(J,he=0,we=J.length){for(let ye=he;ye<we;ye++){const Pe=J.charCodeAt(ye);if(Pe!==32&&Pe!==9)return J.substring(he,ye)}return J.substring(he,we)}t.$Re=o;function F(J,he=J.length-1){for(let we=he;we>=0;we--){const ye=J.charCodeAt(we);if(ye!==32&&ye!==9)return we}return-1}t.$Se=F;function j(J,he,we){const ye=[];let Pe=0;for(const Be of J.matchAll(he)){if(ye.push(J.slice(Pe,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Pe=Be.index+Be[0].length,ye.push(we(Be[0],...Be.slice(1),Be.index,J,Be.groups))}return ye.push(J.slice(Pe)),Promise.all(ye).then(Be=>Be.join(""))}t.$Te=j;function L(J,he){return J<he?-1:J>he?1:0}t.$Ue=L;function d(J,he,we=0,ye=J.length,Pe=0,Be=he.length){for(;we<ye&&Pe<Be;we++,Pe++){const Je=J.charCodeAt(we),xe=he.charCodeAt(Pe);if(Je<xe)return-1;if(Je>xe)return 1}const Ue=ye-we,Ze=Be-Pe;return Ue<Ze?-1:Ue>Ze?1:0}t.$Ve=d;function D(J,he){return B(J,he,0,J.length,0,he.length)}t.$We=D;function B(J,he,we=0,ye=J.length,Pe=0,Be=he.length){for(;we<ye&&Pe<Be;we++,Pe++){let Je=J.charCodeAt(we),xe=he.charCodeAt(Pe);if(Je===xe)continue;if(Je>=128||xe>=128)return d(J.toLowerCase(),he.toLowerCase(),we,ye,Pe,Be);_(Je)&&(Je-=32),_(xe)&&(xe-=32);const We=Je-xe;if(We!==0)return We}const Ue=ye-we,Ze=Be-Pe;return Ue<Ze?-1:Ue>Ze?1:0}t.$Xe=B;function z(J){return J>=48&&J<=57}t.$Ye=z;function _(J){return J>=97&&J<=122}t.$Ze=_;function I(J){return J>=65&&J<=90}t.$1e=I;function N(J,he){return J.length===he.length&&B(J,he)===0}t.$2e=N;function Z(J,he){const we=he.length;return he.length>J.length?!1:B(J,he,0,we)===0}t.$3e=Z;function ee(J,he){const we=Math.min(J.length,he.length);let ye;for(ye=0;ye<we;ye++)if(J.charCodeAt(ye)!==he.charCodeAt(ye))return ye;return we}t.$4e=ee;function ue(J,he){const we=Math.min(J.length,he.length);let ye;const Pe=J.length-1,Be=he.length-1;for(ye=0;ye<we;ye++)if(J.charCodeAt(Pe-ye)!==he.charCodeAt(Be-ye))return ye;return we}t.$5e=ue;function ae(J){return 55296<=J&&J<=56319}t.$6e=ae;function se(J){return 56320<=J&&J<=57343}t.$7e=se;function re(J,he){return(J-55296<<10)+(he-56320)+65536}t.$8e=re;function be(J,he,we){const ye=J.charCodeAt(we);if(ae(ye)&&we+1<he){const Pe=J.charCodeAt(we+1);if(se(Pe))return re(ye,Pe)}return ye}t.$9e=be;function Se(J,he){const we=J.charCodeAt(he-1);if(se(we)&&he>1){const ye=J.charCodeAt(he-2);if(ae(ye))return re(ye,we)}return we}class Oe{get offset(){return this.e}constructor(he,we=0){this.c=he,this.d=he.length,this.e=we}setOffset(he){this.e=he}prevCodePoint(){const he=Se(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=be(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$0e=Oe;class Te{get offset(){return this.c.offset}constructor(he,we=0){this.c=new Oe(he,we)}nextGraphemeLength(){const he=Ae.getInstance(),we=this.c,ye=we.offset;let Pe=he.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Be=we.offset,Ue=he.getGraphemeBreakType(we.nextCodePoint());if(ve(Pe,Ue)){we.setOffset(Be);break}Pe=Ue}return we.offset-ye}prevGraphemeLength(){const he=Ae.getInstance(),we=this.c,ye=we.offset;let Pe=he.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Be=we.offset,Ue=he.getGraphemeBreakType(we.prevCodePoint());if(ve(Ue,Pe)){we.setOffset(Be);break}Pe=Ue}return ye-we.offset}eol(){return this.c.eol()}}t.$$e=Te;function de(J,he){return new Te(J,he).nextGraphemeLength()}t.$_e=de;function ie(J,he){return new Te(J,he).prevGraphemeLength()}t.$af=ie;function fe(J,he){he>0&&se(J.charCodeAt(he))&&he--;const we=he+de(J,he);return[we-ie(J,we),we]}t.$bf=fe;function Y(J){const he=new Te(J);let we=0;for(;!he.eol();)we++,he.nextGraphemeLength();return we}t.$cf=Y;let q;function X(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function S(J){return q||(q=X()),q.test(J)}t.$df=S;const Q=/^[\t\n\r\x20-\x7E]*$/;function $(J){return Q.test(J)}t.$ef=$,t.$ff=/[\u2028\u2029]/;function W(J){return t.$ff.test(J)}t.$gf=W;function V(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}t.$hf=V;function p(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}t.$if=p;function y(J,he){if(J.length<he)return J;const we=/\b/g;let ye=0;for(;we.test(J)&&!(J.length-we.lastIndex<he);)ye=we.lastIndex,we.lastIndex+=1;return J.substring(ye).replace(/^\s/,"")}t.$jf=y;const E=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,M=/\x1b\].*?\x07/g;function k(J){return J&&(J=J.replace(E,"").replace(M,"")),J}t.$kf=k,t.$lf=String.fromCharCode(65279);function R(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}t.$mf=R;function C(J){return R(J)?J.substr(1):J}t.$nf=C;function P(J,he){if(!J||!he||J.length<he.length)return!1;const we=he.length,ye=J.toLowerCase();let Pe=0,Be=-1;for(;Pe<we;){const Ue=ye.indexOf(he[Pe],Be+1);if(Ue<0)return!1;Be=Ue,Pe++}return!0}t.$of=P;function H(J,he=!1){return J?(he&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}t.$pf=H;function x(J){return J.charAt(0).toUpperCase()+J.slice(1)}t.$qf=x;function te(J,he=1){if(he===0)return"";let we=-1;do we=J.indexOf(`
`,we+1),he--;while(he>0&&we>=0);return we===-1?J:(J[we-1]==="\r"&&we--,J.substr(0,we))}t.$rf=te;function ne(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}t.$sf=ne;function ge(J){return Ae.getInstance().getGraphemeBreakType(J)}t.$tf=ge;function ve(J,he){return J===0?he!==5&&he!==7:J===2&&he===3?!1:J===4||J===2||J===3||he===4||he===2||he===3?!0:!(J===8&&(he===8||he===9||he===11||he===12)||(J===11||J===9)&&(he===9||he===10)||(J===12||J===10)&&he===10||he===5||he===13||he===7||J===1||J===13&&he===14||J===6&&he===6)}var Ce;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(t.GraphemeBreakType=Ce={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const we=this.d,ye=we.length/3;let Pe=1;for(;Pe<=ye;)if(he<we[3*Pe])Pe=2*Pe;else if(he>we[3*Pe+1])Pe=2*Pe+1;else return we[3*Pe+2];return 0}}function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(J,he){if(J===0)return 0;const we=Fe(J,he);if(we!==void 0)return we;const ye=new Oe(he,J);return ye.prevCodePoint(),ye.offset}t.$uf=Re;function Fe(J,he){const we=new Oe(he,J);let ye=we.prevCodePoint();for(;Qe(ye)||ye===65039||ye===8419;){if(we.offset===0)return;ye=we.prevCodePoint()}if(!p(ye))return;let Pe=we.offset;return Pe>0&&we.prevCodePoint()===8205&&(Pe=we.offset),Pe}function Qe(J){return 127995<=J&&J<=127999}var ze;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),t.$vf="\xA0";class Me{static{this.c=new T.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new v.$xe(he=>{function we(We){const tt=new Map;for(let nt=0;nt<We.length;nt+=2)tt.set(We[nt],We[nt+1]);return tt}function ye(We,tt){const nt=new Map(We);for(const[dt,ft]of tt)nt.set(dt,ft);return nt}function Pe(We,tt){if(!We)return tt;const nt=new Map;for(const[dt,ft]of We)tt.has(dt)&&nt.set(dt,ft);return nt}const Be=this.c.value;let Ue=he.filter(We=>!We.startsWith("_")&&We in Be);Ue.length===0&&(Ue=["_default"]);let Ze;for(const We of Ue){const tt=we(Be[We]);Ze=Pe(Ze,tt)}const Je=we(Be._common),xe=ye(Je,Ze);return new Me(xe)})}static getInstance(he){return Me.d.get(Array.from(he))}static{this.e=new T.$U(()=>Object.keys(Me.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Me.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$wf=Me;class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(he){return Ke.e().has(he)}static get codePoints(){return Ke.e()}}t.$xf=Ke}),define($e[33],pe([1,0,31,12]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.FuzzyScore=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.or=void 0;function i(...C){return function(P,H){for(let x=0,te=C.length;x<te;x++){const ne=C[x](P,H);if(ne)return ne}return null}}t.or=i,t.$Dj=U.bind(void 0,!1),t.$Ej=U.bind(void 0,!0);function U(C,P,H){if(!H||H.length<P.length)return null;let x;return C?x=T.$3e(H,P):x=H.indexOf(P)===0,x?P.length>0?[{start:0,end:P.length}]:[]:null}function w(C,P){const H=P.toLowerCase().indexOf(C.toLowerCase());return H===-1?null:[{start:H,end:H+C.length}]}t.$Fj=w;function A(C,P){return u(C.toLowerCase(),P.toLowerCase(),0,0)}t.$Gj=A;function u(C,P,H,x){if(H===C.length)return[];if(x===P.length)return null;if(C[H]===P[x]){let te=null;return(te=u(C,P,H+1,x+1))?g({start:x,end:x+1},te):null}return u(C,P,H,x+1)}function c(C){return 97<=C&&C<=122}function m(C){return 65<=C&&C<=90}t.$Hj=m;function O(C){return 48<=C&&C<=57}function s(C){return C===32||C===9||C===10||C===13}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(C=>l.add(C.charCodeAt(0)));function e(C){return s(C)||l.has(C)}function a(C,P){return C===P||e(C)&&e(P)}function h(C){return c(C)||m(C)||O(C)}function g(C,P){return P.length===0?P=[C]:C.end===P[0].start?P[0].start=C.start:P.unshift(C),P}function n(C,P){for(let H=P;H<C.length;H++){const x=C.charCodeAt(H);if(m(x)||O(x)||H>0&&!h(C.charCodeAt(H-1)))return H}return C.length}function r(C,P,H,x){if(H===C.length)return[];if(x===P.length)return null;if(C[H]!==P[x].toLowerCase())return null;{let te=null,ne=x+1;for(te=r(C,P,H+1,x+1);!te&&(ne=n(P,ne))<P.length;)te=r(C,P,H+1,ne),ne++;return te===null?null:g({start:x,end:x+1},te)}}function b(C){let P=0,H=0,x=0,te=0,ne=0;for(let De=0;De<C.length;De++)ne=C.charCodeAt(De),m(ne)&&P++,c(ne)&&H++,h(ne)&&x++,O(ne)&&te++;const ge=P/C.length,ve=H/C.length,Ce=x/C.length,Ae=te/C.length;return{upperPercent:ge,lowerPercent:ve,alphaPercent:Ce,numericPercent:Ae}}function f(C){const{upperPercent:P,lowerPercent:H}=C;return H===0&&P>.6}function o(C){const{upperPercent:P,lowerPercent:H,alphaPercent:x,numericPercent:te}=C;return H>.2&&P<.8&&x>.6&&te<.2}function F(C){let P=0,H=0,x=0,te=0;for(let ne=0;ne<C.length;ne++)x=C.charCodeAt(ne),m(x)&&P++,c(x)&&H++,s(x)&&te++;return(P===0||H===0)&&te===0?C.length<=30:P<=5}function j(C,P){if(!P||(P=P.trim(),P.length===0)||!F(C)||P.length>60)return null;const H=b(P);if(!o(H)){if(!f(H))return null;P=P.toLowerCase()}let x=null,te=0;for(C=C.toLowerCase();te<P.length&&(x=r(C,P,0,te))===null;)te=n(P,te+1);return x}t.$Ij=j;function L(C,P,H=!1){if(!P||P.length===0)return null;let x=null,te=0;for(C=C.toLowerCase(),P=P.toLowerCase();te<P.length&&(x=d(C,P,0,te,H))===null;)te=D(P,te+1);return x}t.$Jj=L;function d(C,P,H,x,te){if(H===C.length)return[];if(x===P.length)return null;if(a(C.charCodeAt(H),P.charCodeAt(x))){let ne=null,ge=x+1;if(ne=d(C,P,H+1,x+1,te),!te)for(;!ne&&(ge=D(P,ge))<P.length;)ne=d(C,P,H+1,ge,te),ge++;return ne?C.charCodeAt(H)!==P.charCodeAt(x)?ne:g({start:x,end:x+1},ne):null}else return null}function D(C,P){for(let H=P;H<C.length;H++)if(e(C.charCodeAt(H))||H>0&&e(C.charCodeAt(H-1)))return H;return C.length}const B=i(t.$Ej,j,w),z=i(t.$Ej,j,A),_=new v.$Cc(1e4);function I(C,P,H=!1){if(typeof C!="string"||typeof P!="string")return null;let x=_.get(C);x||(x=new RegExp(T.$Le(C),"i"),_.set(C,x));const te=x.exec(P);return te?[{start:te.index,end:te.index+te[0].length}]:H?z(C,P):B(C,P)}t.$Kj=I;function N(C,P){const H=V(C,C.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?ee(H):null}t.$Lj=N;function Z(C,P,H,x,te,ne){const ge=Math.min(13,C.length);for(;H<ge;H++){const ve=V(C,P,H,x,te,ne,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ve)return ve}return[0,ne]}t.$Mj=Z;function ee(C){if(typeof C>"u")return[];const P=[],H=C[1];for(let x=C.length-1;x>1;x--){const te=C[x]+H,ne=P[P.length-1];ne&&ne.end===te?ne.end=te+1:P.push({start:te,end:te+1})}return P}t.$Nj=ee;const ue=128;function ae(){const C=[],P=[];for(let H=0;H<=ue;H++)P[H]=0;for(let H=0;H<=ue;H++)C.push(P.slice(0));return C}function se(C){const P=[];for(let H=0;H<=C;H++)P[H]=0;return P}const re=se(2*ue),be=se(2*ue),Se=ae(),Oe=ae(),Te=ae(),de=!1;function ie(C,P,H,x,te){function ne(ve,Ce,Ae=" "){for(;ve.length<Ce;)ve=Ae+ve;return ve}let ge=` |   |${x.split("").map(ve=>ne(ve,3)).join("|")}
`;for(let ve=0;ve<=H;ve++)ve===0?ge+=" |":ge+=`${P[ve-1]}|`,ge+=C[ve].slice(0,te+1).map(Ce=>ne(Ce.toString(),3)).join("|")+`
`;return ge}function fe(C,P,H,x){C=C.substr(P),H=H.substr(x),console.log(ie(Oe,C,C.length,H,H.length)),console.log(ie(Te,C,C.length,H,H.length)),console.log(ie(Se,C,C.length,H,H.length))}function Y(C,P){if(P<0||P>=C.length)return!1;const H=C.codePointAt(P);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$if(H)}}function q(C,P){if(P<0||P>=C.length)return!1;switch(C.charCodeAt(P)){case 32:case 9:return!0;default:return!1}}function X(C,P,H){return P[C]!==H[C]}function S(C,P,H,x,te,ne,ge=!1){for(;P<H&&te<ne;)C[P]===x[te]&&(ge&&(re[P]=te),P+=1),te+=1;return P===H}t.$Oj=S;var Q;(function(C){C[C.Diag=1]="Diag",C[C.Left=2]="Left",C[C.LeftLeft=3]="LeftLeft"})(Q||(Q={}));var $;(function(C){C.Default=[-100,0];function P(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}C.isDefault=P})($||(t.FuzzyScore=$={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(P,H){this.firstMatchCanBeWeak=P,this.boostFullMatch=H}}t.$Pj=W;function V(C,P,H,x,te,ne,ge=W.default){const ve=C.length>ue?ue:C.length,Ce=x.length>ue?ue:x.length;if(H>=ve||ne>=Ce||ve-H>Ce-ne||!S(P,H,ve,te,ne,Ce,!0))return;p(ve,Ce,H,ne,P,te);let Ae=1,De=1,Re=H,Fe=ne;const Qe=[!1];for(Ae=1,Re=H;Re<ve;Ae++,Re++){const he=re[Re],we=be[Re],ye=Re+1<ve?be[Re+1]:Ce;for(De=he-ne+1,Fe=he;Fe<ye;De++,Fe++){let Pe=Number.MIN_SAFE_INTEGER,Be=!1;Fe<=we&&(Pe=y(C,P,Re,H,x,te,Fe,Ce,ne,Se[Ae-1][De-1]===0,Qe));let Ue=0;Pe!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ue=Pe+Oe[Ae-1][De-1]);const Ze=Fe>he,Je=Ze?Oe[Ae][De-1]+(Se[Ae][De-1]>0?-5:0):0,xe=Fe>he+1&&Se[Ae][De-1]>0,We=xe?Oe[Ae][De-2]+(Se[Ae][De-2]>0?-5:0):0;if(xe&&(!Ze||We>=Je)&&(!Be||We>=Ue))Oe[Ae][De]=We,Te[Ae][De]=3,Se[Ae][De]=0;else if(Ze&&(!Be||Je>=Ue))Oe[Ae][De]=Je,Te[Ae][De]=2,Se[Ae][De]=0;else if(Be)Oe[Ae][De]=Ue,Te[Ae][De]=1,Se[Ae][De]=Se[Ae-1][De-1]+1;else throw new Error("not possible")}}if(de&&fe(C,H,x,ne),!Qe[0]&&!ge.firstMatchCanBeWeak)return;Ae--,De--;const ze=[Oe[Ae][De],ne];let Me=0,Ke=0;for(;Ae>=1;){let he=De;do{const we=Te[Ae][he];if(we===3)he=he-2;else if(we===2)he=he-1;else break}while(he>=1);Me>1&&P[H+Ae-1]===te[ne+De-1]&&!X(he+ne-1,x,te)&&Me+1>Se[Ae][he]&&(he=De),he===De?Me++:Me=1,Ke||(Ke=he),Ae--,De=he-1,ze.push(De)}Ce===ve&&ge.boostFullMatch&&(ze[0]+=2);const J=Ke-ve;return ze[0]-=J,ze}t.$Qj=V;function p(C,P,H,x,te,ne){let ge=C-1,ve=P-1;for(;ge>=H&&ve>=x;)te[ge]===ne[ve]&&(be[ge]=ve,ge--),ve--}function y(C,P,H,x,te,ne,ge,ve,Ce,Ae,De){if(P[H]!==ne[ge])return Number.MIN_SAFE_INTEGER;let Re=1,Fe=!1;return ge===H-x?Re=C[H]===te[ge]?7:5:X(ge,te,ne)&&(ge===0||!X(ge-1,te,ne))?(Re=C[H]===te[ge]?7:5,Fe=!0):Y(ne,ge)&&(ge===0||!Y(ne,ge-1))?Re=5:(Y(ne,ge-1)||q(ne,ge-1))&&(Re=5,Fe=!0),Re>1&&H===x&&(De[0]=!0),Fe||(Fe=X(ge,te,ne)||Y(ne,ge-1)||q(ne,ge-1)),H===x?ge>Ce&&(Re-=Fe?3:5):Ae?Re+=Fe?2:0:Re+=Fe?0:1,ge+1===ve&&(Re-=Fe?3:5),Re}function E(C,P,H,x,te,ne,ge){return k(C,P,H,x,te,ne,!0,ge)}t.$Rj=E;function M(C,P,H,x,te,ne,ge){return k(C,P,H,x,te,ne,!1,ge)}t.$Sj=M;function k(C,P,H,x,te,ne,ge,ve){let Ce=V(C,P,H,x,te,ne,ve);if(Ce&&!ge)return Ce;if(C.length>=3){const Ae=Math.min(7,C.length-1);for(let De=H+1;De<Ae;De++){const Re=R(C,De);if(Re){const Fe=V(Re,Re.toLowerCase(),H,x,te,ne,ve);Fe&&(Fe[0]-=3,(!Ce||Fe[0]>Ce[0])&&(Ce=Fe))}}}return Ce}function R(C,P){if(P+1>=C.length)return;const H=C[P],x=C[P+1];if(H!==x)return C.slice(0,P)+x+H+C.slice(P+2)}}),define($e[48],pe([1,0,12]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ki=t.$Ji=t.$Ii=t.$Hi=t.$Gi=t.$Fi=t.$Ei=void 0;function T(g){return i(g,0)}t.$Ei=T;function i(g,n){switch(typeof g){case"object":return g===null?U(349,n):Array.isArray(g)?u(g,n):c(g,n);case"string":return A(g,n);case"boolean":return w(g,n);case"number":return U(g,n);case"undefined":return U(937,n);default:return U(617,n)}}t.$Fi=i;function U(g,n){return(n<<5)-n+g|0}t.$Gi=U;function w(g,n){return U(g?433:863,n)}function A(g,n){n=U(149417,n);for(let r=0,b=g.length;r<b;r++)n=U(g.charCodeAt(r),n);return n}t.$Hi=A;function u(g,n){return n=U(104579,n),g.reduce((r,b)=>i(b,r),n)}function c(g,n){return n=U(181387,n),Object.keys(g).sort().reduce((r,b)=>(r=A(b,r),i(g[b],r)),n)}class m{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Ii=m;var O;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function s(g,n,r=32){const b=r-n,f=~((1<<b)-1);return(g<<n|(f&g)>>>b)>>>0}function l(g,n=0,r=g.byteLength,b=0){for(let f=0;f<r;f++)g[n+f]=b}function e(g,n,r="0"){for(;g.length<n;)g=r+g;return g}function a(g,n=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((g>>>0).toString(16),n/4)}t.$Ji=a;class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const b=this.p;let f=this.r,o=this.u,F,j;for(o!==0?(F=o,j=-1,o=0):(F=n.charCodeAt(0),j=0);;){let L=F;if(v.$6e(F))if(j+1<r){const d=n.charCodeAt(j+1);v.$7e(d)?(j++,L=v.$8e(F,d)):L=65533}else{o=F;break}else v.$7e(F)&&(L=65533);if(f=this.w(b,f,L),j++,j<r)F=n.charCodeAt(j);else break}this.r=f,this.u=o}w(n,r,b){return b<128?n[r++]=b:b<2048?(n[r++]=192|(b&1984)>>>6,n[r++]=128|(b&63)>>>0):b<65536?(n[r++]=224|(b&61440)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0):(n[r++]=240|(b&1835008)>>>18,n[r++]=128|(b&258048)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=h.g,r=this.q;for(let B=0;B<64;B+=4)n.setUint32(B,r.getUint32(B,!1),!1);for(let B=64;B<320;B+=4)n.setUint32(B,s(n.getUint32(B-12,!1)^n.getUint32(B-32,!1)^n.getUint32(B-56,!1)^n.getUint32(B-64,!1),1),!1);let b=this.h,f=this.l,o=this.m,F=this.n,j=this.o,L,d,D;for(let B=0;B<80;B++)B<20?(L=f&o|~f&F,d=1518500249):B<40?(L=f^o^F,d=1859775393):B<60?(L=f&o|f&F|o&F,d=2400959708):(L=f^o^F,d=3395469782),D=s(b,5)+L+j+d+n.getUint32(B*4,!1)&4294967295,j=F,F=o,o=s(f,30),f=b,b=D;this.h=this.h+b&4294967295,this.l=this.l+f&4294967295,this.m=this.m+o&4294967295,this.n=this.n+F&4294967295,this.o=this.o+j&4294967295}}t.$Ki=h}),define($e[85],pe([1,0,74,48]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$As=t.$zs=t.$ys=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,l=new Int32Array(s.length);for(let e=0,a=s.length;e<a;e++)l[e]=s.charCodeAt(e);return l}}t.$ys=i;function U(O,s,l){return new m(new i(O),new i(s)).ComputeDiff(l).changes}t.$zs=U;class w{static Assert(s,l){if(!s)throw new Error(l)}}class A{static Copy(s,l,e,a,h){for(let g=0;g<h;g++)e[a+g]=s[l+g]}static Copy2(s,l,e,a,h){for(let g=0;g<h;g++)e[a+g]=s[l+g]}}var u;(function(O){O[O.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class c{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.$xs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,l){this.b=Math.min(this.b,s),this.c=Math.min(this.c,l),this.d++}AddModifiedElement(s,l){this.b=Math.min(this.b,s),this.c=Math.min(this.c,l),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class m{constructor(s,l,e=null){this.a=e,this.b=s,this.c=l;const[a,h,g]=m.o(s),[n,r,b]=m.o(l);this.d=g&&b,this.e=a,this.f=h,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const l=s.getElements();if(m.n(l)){const e=new Int32Array(l.length);for(let a=0,h=l.length;a<h;a++)e[a]=(0,T.$Hi)(l[a],0);return[l,e,!0]}return l instanceof Int32Array?[[],l,!1]:[[],new Int32Array(l),!1]}p(s,l){return this.f[s]!==this.h[l]?!1:this.d?this.e[s]===this.g[l]:!0}q(s,l){if(!this.p(s,l))return!1;const e=m.r(this.b,s),a=m.r(this.c,l);return e===a}static r(s,l){return typeof s.getStrictElement=="function"?s.getStrictElement(l):null}s(s,l){return this.f[s]!==this.f[l]?!1:this.d?this.e[s]===this.e[l]:!0}u(s,l){return this.h[s]!==this.h[l]?!1:this.d?this.g[s]===this.g[l]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,l,e,a,h){const g=[!1];let n=this.w(s,l,e,a,g);return h&&(n=this.z(n)),{quitEarly:g[0],changes:n}}w(s,l,e,a,h){for(h[0]=!1;s<=l&&e<=a&&this.p(s,e);)s++,e++;for(;l>=s&&a>=e&&this.p(l,a);)l--,a--;if(s>l||e>a){let o;return e<=a?(w.Assert(s===l+1,"originalStart should only be one more than originalEnd"),o=[new v.$xs(s,0,e,a-e+1)]):s<=l?(w.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),o=[new v.$xs(s,l-s+1,e,0)]):(w.Assert(s===l+1,"originalStart should only be one more than originalEnd"),w.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const g=[0],n=[0],r=this.y(s,l,e,a,g,n,h),b=g[0],f=n[0];if(r!==null)return r;if(!h[0]){const o=this.w(s,b,e,f,h);let F=[];return h[0]?F=[new v.$xs(b+1,l-(b+1)+1,f+1,a-(f+1)+1)]:F=this.w(b+1,l,f+1,a,h),this.H(o,F)}return[new v.$xs(s,l-s+1,e,a-e+1)]}x(s,l,e,a,h,g,n,r,b,f,o,F,j,L,d,D,B,z){let _=null,I=null,N=new c,Z=l,ee=e,ue=j[0]-D[0]-a,ae=-1073741824,se=this.k.length-1;do{const re=ue+s;re===Z||re<ee&&b[re-1]<b[re+1]?(o=b[re+1],L=o-ue-a,o<ae&&N.MarkNextChange(),ae=o,N.AddModifiedElement(o+1,L),ue=re+1-s):(o=b[re-1]+1,L=o-ue-a,o<ae&&N.MarkNextChange(),ae=o-1,N.AddOriginalElement(o,L+1),ue=re-1-s),se>=0&&(b=this.k[se],s=b[0],Z=1,ee=b.length-1)}while(--se>=-1);if(_=N.getReverseChanges(),z[0]){let re=j[0]+1,be=D[0]+1;if(_!==null&&_.length>0){const Se=_[_.length-1];re=Math.max(re,Se.getOriginalEnd()),be=Math.max(be,Se.getModifiedEnd())}I=[new v.$xs(re,F-re+1,be,d-be+1)]}else{N=new c,Z=g,ee=n,ue=j[0]-D[0]-r,ae=1073741824,se=B?this.m.length-1:this.m.length-2;do{const re=ue+h;re===Z||re<ee&&f[re-1]>=f[re+1]?(o=f[re+1]-1,L=o-ue-r,o>ae&&N.MarkNextChange(),ae=o+1,N.AddOriginalElement(o+1,L+1),ue=re+1-h):(o=f[re-1],L=o-ue-r,o>ae&&N.MarkNextChange(),ae=o,N.AddModifiedElement(o+1,L+1),ue=re-1-h),se>=0&&(f=this.m[se],h=f[0],Z=1,ee=f.length-1)}while(--se>=-1);I=N.getChanges()}return this.H(_,I)}y(s,l,e,a,h,g,n){let r=0,b=0,f=0,o=0,F=0,j=0;s--,e--,h[0]=0,g[0]=0,this.k=[],this.m=[];const L=l-s+(a-e),d=L+1,D=new Int32Array(d),B=new Int32Array(d),z=a-e,_=l-s,I=s-e,N=l-a,ee=(_-z)%2===0;D[z]=s,B[_]=l,n[0]=!1;for(let ue=1;ue<=L/2+1;ue++){let ae=0,se=0;f=this.J(z-ue,ue,z,d),o=this.J(z+ue,ue,z,d);for(let be=f;be<=o;be+=2){be===f||be<o&&D[be-1]<D[be+1]?r=D[be+1]:r=D[be-1]+1,b=r-(be-z)-I;const Se=r;for(;r<l&&b<a&&this.p(r+1,b+1);)r++,b++;if(D[be]=r,r+b>ae+se&&(ae=r,se=b),!ee&&Math.abs(be-_)<=ue-1&&r>=B[be])return h[0]=r,g[0]=b,Se<=B[be]&&1447>0&&ue<=1447+1?this.x(z,f,o,I,_,F,j,N,D,B,r,l,h,b,a,g,ee,n):null}const re=(ae-s+(se-e)-ue)/2;if(this.a!==null&&!this.a(ae,re))return n[0]=!0,h[0]=ae,g[0]=se,re>0&&1447>0&&ue<=1447+1?this.x(z,f,o,I,_,F,j,N,D,B,r,l,h,b,a,g,ee,n):(s++,e++,[new v.$xs(s,l-s+1,e,a-e+1)]);F=this.J(_-ue,ue,_,d),j=this.J(_+ue,ue,_,d);for(let be=F;be<=j;be+=2){be===F||be<j&&B[be-1]>=B[be+1]?r=B[be+1]-1:r=B[be-1],b=r-(be-_)-N;const Se=r;for(;r>s&&b>e&&this.p(r,b);)r--,b--;if(B[be]=r,ee&&Math.abs(be-z)<=ue&&r<=D[be])return h[0]=r,g[0]=b,Se>=D[be]&&1447>0&&ue<=1447+1?this.x(z,f,o,I,_,F,j,N,D,B,r,l,h,b,a,g,ee,n):null}if(ue<=1447){let be=new Int32Array(o-f+2);be[0]=z-f+1,A.Copy2(D,f,be,1,o-f+1),this.k.push(be),be=new Int32Array(j-F+2),be[0]=_-F+1,A.Copy2(B,F,be,1,j-F+1),this.m.push(be)}}return this.x(z,f,o,I,_,F,j,N,D,B,r,l,h,b,a,g,ee,n)}z(s){for(let l=0;l<s.length;l++){const e=s[l],a=l<s.length-1?s[l+1].originalStart:this.f.length,h=l<s.length-1?s[l+1].modifiedStart:this.h.length,g=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<a&&e.modifiedStart+e.modifiedLength<h&&(!g||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const r=[null];if(l<s.length-1&&this.I(s[l],s[l+1],r)){s[l]=r[0],s.splice(l+1,1),l--;continue}}for(let l=s.length-1;l>=0;l--){const e=s[l];let a=0,h=0;if(l>0){const o=s[l-1];a=o.originalStart+o.originalLength,h=o.modifiedStart+o.modifiedLength}const g=e.originalLength>0,n=e.modifiedLength>0;let r=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const F=e.originalStart-o,j=e.modifiedStart-o;if(F<a||j<h||g&&!this.s(F,F+e.originalLength)||n&&!this.u(j,j+e.modifiedLength))break;const d=(F===a&&j===h?5:0)+this.G(F,e.originalLength,j,e.modifiedLength);d>b&&(b=d,r=o)}e.originalStart-=r,e.modifiedStart-=r;const f=[null];if(l>0&&this.I(s[l-1],s[l],f)){s[l-1]=f[0],s.splice(l,1),l++;continue}}if(this.d)for(let l=1,e=s.length;l<e;l++){const a=s[l-1],h=s[l],g=h.originalStart-a.originalStart-a.originalLength,n=a.originalStart,r=h.originalStart+h.originalLength,b=r-n,f=a.modifiedStart,o=h.modifiedStart+h.modifiedLength,F=o-f;if(g<5&&b<20&&F<20){const j=this.A(n,b,f,F,g);if(j){const[L,d]=j;(L!==a.originalStart+a.originalLength||d!==a.modifiedStart+a.modifiedLength)&&(a.originalLength=L-a.originalStart,a.modifiedLength=d-a.modifiedStart,h.originalStart=L+g,h.modifiedStart=d+g,h.originalLength=r-h.originalStart,h.modifiedLength=o-h.modifiedStart)}}}return s}A(s,l,e,a,h){if(l<h||a<h)return null;const g=s+l-h+1,n=e+a-h+1;let r=0,b=0,f=0;for(let o=s;o<g;o++)for(let F=e;F<n;F++){const j=this.B(o,F,h);j>0&&j>r&&(r=j,b=o,f=F)}return r>0?[b,f]:null}B(s,l,e){let a=0;for(let h=0;h<e;h++){if(!this.p(s+h,l+h))return 0;a+=this.e[s+h].length}return a}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,l){if(this.C(s)||this.C(s-1))return!0;if(l>0){const e=s+l;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,l){if(this.E(s)||this.E(s-1))return!0;if(l>0){const e=s+l;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,l,e,a){const h=this.D(s,l)?1:0,g=this.F(e,a)?1:0;return h+g}H(s,l){const e=[];if(s.length===0||l.length===0)return l.length>0?l:s;if(this.I(s[s.length-1],l[0],e)){const a=new Array(s.length+l.length-1);return A.Copy(s,0,a,0,s.length-1),a[s.length-1]=e[0],A.Copy(l,1,a,s.length,l.length-1),a}else{const a=new Array(s.length+l.length);return A.Copy(s,0,a,0,s.length),A.Copy(l,0,a,s.length,l.length),a}}I(s,l,e){if(w.Assert(s.originalStart<=l.originalStart,"Left change is not less than or equal to right change"),w.Assert(s.modifiedStart<=l.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=l.originalStart||s.modifiedStart+s.modifiedLength>=l.modifiedStart){const a=s.originalStart;let h=s.originalLength;const g=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=l.originalStart&&(h=l.originalStart+l.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=l.modifiedStart&&(n=l.modifiedStart+l.modifiedLength-s.modifiedStart),e[0]=new v.$xs(a,h,g,n),!0}else return e[0]=null,!1}J(s,l,e,a){if(s>=0&&s<a)return s;const h=e,g=a-e-1,n=l%2===0;if(s<0){const r=h%2===0;return n===r?0:1}else{const r=g%2===0;return n===r?a-1:a-2}}}t.$As=m}),define($e[49],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0,t.$Kd=Symbol("MicrotaskDelay")}),define($e[86],pe([1,0,11,12]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wh=t.$Vh=t.$Uh=t.$Th=t.$Sh=void 0;class i{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const e=l.charCodeAt(0),a=this.b.charCodeAt(this.c);return e-a}value(){return this.b[this.c]}}t.$Sh=i;class U{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,T.$Ve)(l,this.b,0,l.length,this.c,this.d):(0,T.$Xe)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Th=U;class w{constructor(l=!0,e=!0){this.f=l,this.g=e}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let e=l.length-1;e>=0;e--,this.c--){const a=this.b.charCodeAt(e);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,T.$Ve)(l,this.b,0,l.length,this.d,this.e):(0,T.$Xe)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Uh=w;var A;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(A||(A={}));class u{constructor(l,e){this.f=l,this.g=e,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new w(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,T.$We)(l,this.c.scheme);if(this.d[this.e]===2)return(0,T.$We)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,T.$Ue)(l,this.c.query);if(this.d[this.e]===5)return(0,T.$Ue)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Vh=u;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(m||(m={}));class O{static forUris(l=()=>!1,e=()=>!1){return new O(new u(l,e))}static forPaths(l=!1){return new O(new w(void 0,!l))}static forStrings(){return new O(new i)}static forConfigKeys(){return new O(new U)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,e){if(e){const a=e.slice(0);(0,v.$Wb)(a);for(const h of a)this.set(h,l)}else{const a=l.slice(0);(0,v.$Wb)(a);for(const h of a)this.set(h[0],h[1])}}set(l,e){const a=this.b.reset(l);let h;this.c||(this.c=new c,this.c.segment=a.value());const g=[];for(h=this.c;;){const r=a.cmp(h.segment);if(r>0)h.left||(h.left=new c,h.left.segment=a.value()),g.push([-1,h]),h=h.left;else if(r<0)h.right||(h.right=new c,h.right.segment=a.value()),g.push([1,h]),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new c,h.mid.segment=a.value()),g.push([0,h]),h=h.mid;else break}const n=h.value;h.value=e,h.key=l;for(let r=g.length-1;r>=0;r--){const b=g[r][1];b.updateHeight();const f=b.balanceFactor();if(f<-1||f>1){const o=g[r][0],F=g[r+1][0];if(o===1&&F===1)g[r][1]=b.rotateLeft();else if(o===-1&&F===-1)g[r][1]=b.rotateRight();else if(o===1&&F===-1)b.right=g[r+1][1]=g[r+1][1].rotateRight(),g[r][1]=b.rotateLeft();else if(o===-1&&F===1)b.left=g[r+1][1]=g[r+1][1].rotateLeft(),g[r][1]=b.rotateRight();else throw new Error;if(r>0)switch(g[r-1][0]){case-1:g[r-1][1].left=g[r][1];break;case 1:g[r-1][1].right=g[r][1];break;case 0:g[r-1][1].mid=g[r][1];break}else this.c=g[0][1]}}return n}get(l){return this.d(l)?.value}d(l){const e=this.b.reset(l);let a=this.c;for(;a;){const h=e.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(e.hasNext())e.next(),a=a.mid;else break}return a}has(l){const e=this.d(l);return!(e?.value===void 0&&e?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,e){const a=this.b.reset(l),h=[];let g=this.c;for(;g;){const n=a.cmp(g.segment);if(n>0)h.push([-1,g]),g=g.left;else if(n<0)h.push([1,g]),g=g.right;else if(a.hasNext())a.next(),h.push([0,g]),g=g.mid;else break}if(g){if(e?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const n=this.f(g.right);if(n.key){const{key:r,value:b,segment:f}=n;this.e(n.key,!1),g.key=r,g.value=b,g.segment=f}}else{const n=g.left??g.right;if(h.length>0){const[r,b]=h[h.length-1];switch(r){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=h.length-1;n>=0;n--){const r=h[n][1];r.updateHeight();const b=r.balanceFactor();if(b>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),h[n][1]=r.rotateLeft()):b<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),h[n][1]=r.rotateRight()),n>0)switch(h[n-1][0]){case-1:h[n-1][1].left=h[n][1];break;case 1:h[n-1][1].right=h[n][1];break;case 0:h[n-1][1].mid=h[n][1];break}else this.c=h[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const e=this.b.reset(l);let a=this.c,h;for(;a;){const g=e.cmp(a.segment);if(g>0)a=a.left;else if(g<0)a=a.right;else if(e.hasNext())e.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(l){return this.g(l,!1)}g(l,e){const a=this.b.reset(l);let h=this.c;for(;h;){const g=a.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(a.hasNext())a.next(),h=h.mid;else return h.mid?this.h(h.mid):e?h.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[e,a]of this)l(a,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const e=[];return this.j(l,e),e[Symbol.iterator]()}j(l,e){l&&(l.left&&this.j(l.left,e),l.value&&e.push([l.key,l.value]),l.mid&&this.j(l.mid,e),l.right&&this.j(l.right,e))}_isBalanced(){const l=e=>{if(!e)return!0;const a=e.balanceFactor();return a<-1||a>1?!1:l(e.left)&&l(e.right)};return l(this.c)}}t.$Wh=O}),define($e[7],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=void 0;function v(f){return typeof f=="string"}t.$yf=v;function T(f){return Array.isArray(f)&&f.every(o=>v(o))}t.$zf=T;function i(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}t.$Af=i;function U(f){const o=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof o}t.$Bf=U;function w(f){return typeof f=="number"&&!isNaN(f)}t.$Cf=w;function A(f){return!!f&&typeof f[Symbol.iterator]=="function"}t.$Df=A;function u(f){return f===!0||f===!1}t.$Ef=u;function c(f){return typeof f>"u"}t.$Ff=c;function m(f){return!O(f)}t.$Gf=m;function O(f){return c(f)||f===null}t.$Hf=O;function s(f,o){if(!f)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.$If=s;function l(f){if(O(f))throw new Error("Assertion Failed: argument is undefined or null");return f}t.$Jf=l;function e(...f){const o=[];for(let F=0;F<f.length;F++){const j=f[F];if(O(j))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);o.push(j)}return o}t.$Kf=e;const a=Object.prototype.hasOwnProperty;function h(f){if(!i(f))return!1;for(const o in f)if(a.call(f,o))return!1;return!0}t.$Lf=h;function g(f){return typeof f=="function"}t.$Mf=g;function n(...f){return f.length>0&&f.every(g)}t.$Nf=n;function r(f,o){const F=Math.min(f.length,o.length);for(let j=0;j<F;j++)b(f[j],o[j])}t.$Of=r;function b(f,o){if(v(o)){if(typeof f!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(g(o)){try{if(f instanceof o)return}catch{}if(!O(f)&&f.constructor===o||o.length===1&&o.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Pf=b}),define($e[17],pe([1,0,7]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vj=t.$Uj=t.$Tj=void 0;const T=Object.create(null);function i(A,u){if((0,v.$yf)(u)){const c=T[u];if(c===void 0)throw new Error(`${A} references an unknown codicon: ${u}`);u=c}return T[A]=u,{id:A}}function U(){return T}t.$Tj=U;function w(){return Object.values(t.$Vj)}t.$Uj=w,t.$Vj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),thumbsDownFilled:i("thumbsdown-filled",60435),thumbsUpFilled:i("thumbsup-filled",60436),coffee:i("coffee",60437),snake:i("snake",60438),game:i("game",60439),vr:i("vr",60440),chip:i("chip",60441),piano:i("piano",60442),music:i("music",60443),micFilled:i("mic-filled",60444),gitFetch:i("git-fetch",60445),copilot:i("copilot",60446),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define($e[50],pe([1,0,7]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gn=t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=t.$_m=t.$$m=t.$0m=t.$9m=t.$8m=void 0;function T(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const n=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([r,b])=>{n[r]=b&&typeof b=="object"?T(b):b}),n}t.$8m=T;function i(g){if(!g||typeof g!="object")return g;const n=[g];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const b in r)if(U.call(r,b)){const f=r[b];typeof f=="object"&&!Object.isFrozen(f)&&!(0,v.$Bf)(f)&&n.push(f)}}return g}t.$9m=i;const U=Object.prototype.hasOwnProperty;function w(g,n){return A(g,n,new Set)}t.$0m=w;function A(g,n,r){if((0,v.$Hf)(g))return g;const b=n(g);if(typeof b<"u")return b;if(Array.isArray(g)){const f=[];for(const o of g)f.push(A(o,n,r));return f}if((0,v.$Af)(g)){if(r.has(g))throw new Error("Cannot clone recursive data-structure");r.add(g);const f={};for(const o in g)U.call(g,o)&&(f[o]=A(g[o],n,r));return r.delete(g),f}return g}function u(g,n,r=!0){return(0,v.$Af)(g)?((0,v.$Af)(n)&&Object.keys(n).forEach(b=>{b in g?r&&((0,v.$Af)(g[b])&&(0,v.$Af)(n[b])?u(g[b],n[b],r):g[b]=n[b]):g[b]=n[b]}),g):n}t.$$m=u;function c(g,n){if(g===n)return!0;if(g==null||n===null||n===void 0||typeof g!=typeof n||typeof g!="object"||Array.isArray(g)!==Array.isArray(n))return!1;let r,b;if(Array.isArray(g)){if(g.length!==n.length)return!1;for(r=0;r<g.length;r++)if(!c(g[r],n[r]))return!1}else{const f=[];for(b in g)f.push(b);f.sort();const o=[];for(b in n)o.push(b);if(o.sort(),!c(f,o))return!1;for(r=0;r<f.length;r++)if(!c(g[f[r]],n[f[r]]))return!1}return!0}t.$_m=c;function m(g){const n=new Set;return JSON.stringify(g,(r,b)=>{if((0,v.$Af)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}t.$an=m;function O(g,n){const r=Object.create(null);return!g||!n||Object.keys(n).forEach(f=>{const o=g[f],F=n[f];c(o,F)||(r[f]=F)}),r}t.$bn=O;function s(g,n){const r=n.toLowerCase(),b=Object.keys(g).find(f=>f.toLowerCase()===r);return b?g[b]:g[n]}t.$cn=s;function l(g,n){const r=Object.create(null);for(const[b,f]of Object.entries(g))n(b,f)&&(r[b]=f);return r}t.$dn=l;function e(g){let n=[];for(;Object.prototype!==g;)n=n.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return n}t.$en=e;function a(g){const n=[];for(const r of e(g))typeof g[r]=="function"&&n.push(r);return n}t.$fn=a;function h(g,n){const r=f=>function(){const o=Array.prototype.slice.call(arguments,0);return n(f,o)},b={};for(const f of g)b[f]=r(f);return b}t.$gn=h}),define($e[18],pe([1,0,17]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Wj=t.ThemeColor=void 0;var T;(function(w){function A(u){return u&&typeof u=="object"&&typeof u.id=="string"}w.isThemeColor=A})(T||(t.ThemeColor=T={}));function i(w){return{id:w}}t.$Wj=i;var U;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function u(n){const r=A.exec(n.id);if(!r)return u(v.$Vj.error);const[,b,f]=r,o=["codicon","codicon-"+b];return f&&o.push("codicon-modifier-"+f.substring(1)),o}w.asClassNameArray=u;function c(n){return u(n).join(" ")}w.asClassName=c;function m(n){return"."+u(n).join(".")}w.asCSSSelector=m;function O(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}w.isThemeIcon=O;const s=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function l(n){const r=s.exec(n);if(!r)return;const[,b]=r;return{id:b}}w.fromString=l;function e(n){return{id:n}}w.fromId=e;function a(n,r){let b=n.id;const f=b.lastIndexOf("~");return f!==-1&&(b=b.substring(0,f)),r&&(b=`${b}~${r}`),{id:b}}w.modify=a;function h(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}w.getModifier=h;function g(n,r){return n.id===r.id&&n.color?.id===r.color?.id}w.isEqual=g})(U||(t.ThemeIcon=U={}))}),define($e[34],pe([1,0,33,12,18]),function(oe,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=void 0;const U="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${w.source}`,"g");function u(g){return g.replace(A,(n,r)=>r?n:`\\${n}`)}t.$Xj=u;const c=new RegExp(`\\\\${w.source}`,"g");function m(g){return g.replace(c,n=>`\\${n}`)}t.$Yj=m;const O=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function s(g){return g.indexOf(U)===-1?g:g.replace(O,(n,r,b,f)=>b?n:r||f||"")}t.$Zj=s;function l(g){return g?g.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$1j=l;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(g){e.lastIndex=0;let n="";const r=[];let b=0;for(;;){const f=e.lastIndex,o=e.exec(g),F=g.substring(f,o?.index);if(F.length>0){n+=F;for(let j=0;j<F.length;j++)r.push(b)}if(!o)break;b+=o[0].length}return{text:n,iconOffsets:r}}t.$2j=a;function h(g,n,r=!1){const{text:b,iconOffsets:f}=n;if(!f||f.length===0)return(0,v.$Kj)(g,b,r);const o=(0,T.$Je)(b," "),F=b.length-o.length,j=(0,v.$Kj)(g,o,r);if(j)for(const L of j){const d=f[L.start+F]+F;L.start+=d,L.end+=d}return j}t.$3j=h}),define($e[87],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GT=t.$FT=void 0,t.$FT="vscode:contextmenu",t.$GT="vscode:onCloseContextMenu"}),define($e[88],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NT=void 0;class v{constructor(i,U){this.a=i,this.onMessage=U}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$NT=v}),define($e[51],pe([8]),{}),define($e[89],pe([8]),{}),define($e[90],pe([8]),{}),define($e[91],pe([8]),{}),define($e[92],pe([1,0,90,91]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define($e[93],pe([8]),{}),define($e[94],pe([8]),{}),define($e[95],pe([8]),{}),define($e[96],pe([8]),{}),define($e[97],pe([8]),{}),define($e[98],pe([8]),{}),define($e[99],pe([8]),{}),define($e[100],pe([8]),{}),define($e[101],pe([8]),{}),define($e[102],pe([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define($e[103],pe([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInput",t)}),define($e[104],pe([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define($e[105],pe([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define($e[106],pe([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/inputbox/inputBox",t)}),define($e[107],pe([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define($e[108],pe([13,10]),function(oe,t){return oe.create("vs/base/browser/ui/tree/abstractTree",t)}),define($e[109],pe([13,10]),function(oe,t){return oe.create("vs/base/common/actions",t)}),define($e[35],pe([1,0,4,2,109]),function(oe,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ai=t.$zi=t.$yi=t.$xi=t.$wi=t.$vi=void 0;class U extends T.$Rc{constructor(s,l="",e="",a=!0,h){super(),this.h=this.B(new v.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=l,this.u=e,this.w=a,this.C=h}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,l){this.C&&await this.C(s)}}t.$vi=U;class w extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new v.$Nd),this.onWillRun=this.f.event,this.m=this.B(new v.$Nd),this.onDidRun=this.m.event}async run(s,l){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,l)}catch(a){e=a}this.m.fire({action:s,error:e})}async u(s,l){await s.run(l)}}t.$wi=w;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let l=[];for(const e of s)e.length&&(l.length?l=[...l,new A,...e]:l=e);return l}static{this.ID="vs.actions.separator"}async run(){}}t.$xi=A;class u{get actions(){return this.a}constructor(s,l,e,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=l,this.class=a,this.a=e}async run(){}}t.$yi=u;class c extends U{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,i.localize(0,null),void 0,!1)}}t.$zi=c;function m(O){return{id:O.id,label:O.label,class:void 0,enabled:O.enabled??!0,checked:O.checked??!1,run:async(...s)=>O.run(...s),tooltip:O.label}}t.$Ai=m}),define($e[110],pe([13,10]),function(oe,t){return oe.create("vs/base/common/platform",t)}),define($e[5],pe([1,0,110]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$h=t.$g=void 0,t.$g="en";let T=!1,i=!1,U=!1,w=!1,A=!1,u=!1,c=!1,m=!1,O=!1,s=!1,l,e=t.$g,a=t.$g,h,g;t.$h=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.$h.vscode<"u"&&typeof t.$h.vscode.process<"u"?n=t.$h.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",b=r&&n?.type==="renderer";if(typeof navigator=="object"&&!b)g=navigator.userAgent,T=g.indexOf("Windows")>=0,i=g.indexOf("Macintosh")>=0,m=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=g.indexOf("Linux")>=0,s=g?.indexOf("Mobi")>=0,u=!0,l=v.getConfiguredDefaultLocale(v.localize(0,null))||t.$g,e=l,a=navigator.language;else if(typeof n=="object"){T=n.platform==="win32",i=n.platform==="darwin",U=n.platform==="linux",w=U&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,c=r,O=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=t.$g,e=t.$g;const z=n.env.VSCODE_NLS_CONFIG;if(z)try{const _=JSON.parse(z),I=_.availableLanguages["*"];l=_.locale,a=_.osLocale,e=I||t.$g,h=_._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var f;(function(z){z[z.Web=0]="Web",z[z.Mac=1]="Mac",z[z.Linux=2]="Linux",z[z.Windows=3]="Windows"})(f||(t.Platform=f={}));function o(z){switch(z){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$i=o;let F=0;i?F=1:T?F=3:U&&(F=2),t.$j=T,t.$k=i,t.$l=U,t.$m=w,t.$n=A,t.$o=c,t.$p=u,t.$q=u&&typeof t.$h.importScripts=="function",t.$r=m,t.$s=s,t.$t=O,t.$u=F,t.$v=g,t.$w=e;var j;(function(z){function _(){return t.$w}z.value=_;function I(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}z.isDefaultVariant=I;function N(){return t.$w==="en"}z.isDefault=N})(j||(t.Language=j={})),t.$x=l,t.$y=a,t.$z=h,t.$A=typeof t.$h.postMessage=="function"&&!t.$h.importScripts,t.$B=(()=>{if(t.$A){const z=[];t.$h.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let N=0,Z=z.length;N<Z;N++){const ee=z[N];if(ee.id===I.data.vscodeScheduleAsyncWork){z.splice(N,1),ee.callback();return}}});let _=0;return I=>{const N=++_;z.push({id:N,callback:I}),t.$h.postMessage({vscodeScheduleAsyncWork:N},"*")}}return z=>setTimeout(z)})();var L;(function(z){z[z.Windows=1]="Windows",z[z.Macintosh=2]="Macintosh",z[z.Linux=3]="Linux"})(L||(t.OperatingSystem=L={})),t.OS=i||m?2:T?1:3;let d=!0,D=!1;function B(){if(!D){D=!0;const z=new Uint8Array(2);z[0]=1,z[1]=2,d=new Uint16Array(z.buffer)[0]===(2<<8)+1}return d}t.$D=B,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define($e[111],pe([1,0,16,5]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IO=t.KeyboardSupport=void 0;var i;(function(U){U[U.Always=0]="Always",U[U.FullScreen=1]="FullScreen",U[U.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.$IO={clipboard:{writeText:T.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:T.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>T.$n||v.$GO()?0:navigator.keyboard||v.$CO?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define($e[14],pe([1,0,16,43,77,5]),function(oe,t,v,T,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QO=t.$PO=t.$OO=void 0;function w(e){if(e.charCode){const h=String.fromCharCode(e.charCode).toUpperCase();return T.KeyCodeUtils.fromString(h)}const a=e.keyCode;if(a===3)return 7;if(v.$zO)switch(a){case 59:return 85;case 60:if(U.$l)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$k)return 57;break}else if(v.$AO){if(U.$k&&a===93)return 57;if(!U.$k&&a===92)return 57}return T.$Bq[a]||0}const A=U.$k?256:2048,u=512,c=1024,m=U.$k?2048:256;function O(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$OO=O;function s(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${T.KeyCodeUtils.toString(e.keyCode)}')`}t.$PO=s;class l{constructor(a){this._standardKeyboardEventBrand=!0;const h=a;this.browserEvent=h,this.target=h.target,this.ctrlKey=h.ctrlKey,this.shiftKey=h.shiftKey,this.altKey=h.altKey,this.metaKey=h.metaKey,this.altGraphKey=h.getModifierState("AltGraph"),this.keyCode=w(h),this.code=h.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(a){return this.a===a}c(){let a=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode);let h=0;return this.ctrlKey&&(h|=A),this.altKey&&(h|=u),this.shiftKey&&(h|=c),this.metaKey&&(h|=m),h|=a,h}d(){let a=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode),new i.$Jq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,a)}}t.$QO=l}),define($e[19],pe([1,0,16,68,5]),function(oe,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NO=t.$MO=t.$LO=void 0;class U{constructor(c){this.timestamp=Date.now(),this.browserEvent=c,this.leftButton=c.button===0,this.middleButton=c.button===1,this.rightButton=c.button===2,this.buttons=c.buttons,this.target=c.target,this.detail=c.detail||1,c.type==="dblclick"&&(this.detail=2),this.ctrlKey=c.ctrlKey,this.shiftKey=c.shiftKey,this.altKey=c.altKey,this.metaKey=c.metaKey,typeof c.pageX=="number"?(this.posx=c.pageX,this.posy=c.pageY):(this.posx=c.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=c.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const m=T.$JO.getPositionOfChildWindowRelativeToAncestorWindow(window,c.view);this.posx-=m.left,this.posy-=m.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$LO=U;class w extends U{constructor(c){super(c),this.dataTransfer=c.dataTransfer}}t.$MO=w;class A{constructor(c,m=0,O=0){if(this.browserEvent=c||null,this.target=c?c.target||c.targetNode||c.srcElement:null,this.deltaY=O,this.deltaX=m,c){const s=c,l=c;if(typeof s.wheelDeltaY<"u")this.deltaY=s.wheelDeltaY/120;else if(typeof l.VERTICAL_AXIS<"u"&&l.axis===l.VERTICAL_AXIS)this.deltaY=-l.detail/3;else if(c.type==="wheel"){const e=c;e.deltaMode===e.DOM_DELTA_LINE?v.$zO&&!i.$k?this.deltaY=-c.deltaY/3:this.deltaY=-c.deltaY:this.deltaY=-c.deltaY/40}if(typeof s.wheelDeltaX<"u")v.$CO&&i.$j?this.deltaX=-(s.wheelDeltaX/120):this.deltaX=s.wheelDeltaX/120;else if(typeof l.HORIZONTAL_AXIS<"u"&&l.axis===l.HORIZONTAL_AXIS)this.deltaX=-c.detail/3;else if(c.type==="wheel"){const e=c;e.deltaMode===e.DOM_DELTA_LINE?v.$zO&&!i.$k?this.deltaX=-c.deltaX/3:this.deltaX=-c.deltaX:this.deltaX=-c.deltaX/40}this.deltaY===0&&this.deltaX===0&&c.wheelDelta&&(this.deltaY=c.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$NO=A}),define($e[112],pe([1,0,5]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let T;if(typeof v.$h.vscode<"u"&&typeof v.$h.vscode.process<"u"){const i=v.$h.vscode.process;T={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return v.$j?"win32":v.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.$cc=T.platform,t.$dc=T.arch}),define($e[22],pe([1,0,112]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const T=65,i=97,U=90,w=122,A=46,u=47,c=92,m=58,O=63;class s extends Error{constructor(F,j,L){let d;typeof j=="string"&&j.indexOf("not ")===0?(d="must not be",j=j.replace(/^not /,"")):d="must be";const D=F.indexOf(".")!==-1?"property":"argument";let B=`The "${F}" ${D} ${d} of type ${j}`;B+=`. Received type ${typeof L}`,super(B),this.code="ERR_INVALID_ARG_TYPE"}}function l(o,F){if(o===null||typeof o!="object")throw new s(F,"Object",o)}function e(o,F){if(typeof o!="string")throw new s(F,"string",o)}const a=v.$cc==="win32";function h(o){return o===u||o===c}function g(o){return o===u}function n(o){return o>=T&&o<=U||o>=i&&o<=w}function r(o,F,j,L){let d="",D=0,B=-1,z=0,_=0;for(let I=0;I<=o.length;++I){if(I<o.length)_=o.charCodeAt(I);else{if(L(_))break;_=u}if(L(_)){if(!(B===I-1||z===1))if(z===2){if(d.length<2||D!==2||d.charCodeAt(d.length-1)!==A||d.charCodeAt(d.length-2)!==A){if(d.length>2){const N=d.lastIndexOf(j);N===-1?(d="",D=0):(d=d.slice(0,N),D=d.length-1-d.lastIndexOf(j)),B=I,z=0;continue}else if(d.length!==0){d="",D=0,B=I,z=0;continue}}F&&(d+=d.length>0?`${j}..`:"..",D=2)}else d.length>0?d+=`${j}${o.slice(B+1,I)}`:d=o.slice(B+1,I),D=I-B-1;B=I,z=0}else _===A&&z!==-1?++z:z=-1}return d}function b(o,F){l(F,"pathObject");const j=F.dir||F.root,L=F.base||`${F.name||""}${F.ext||""}`;return j?j===F.root?`${j}${L}`:`${j}${o}${L}`:L}t.$ec={resolve(...o){let F="",j="",L=!1;for(let d=o.length-1;d>=-1;d--){let D;if(d>=0){if(D=o[d],e(D,"path"),D.length===0)continue}else F.length===0?D=v.cwd():(D=v.env[`=${F}`]||v.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==F.toLowerCase()&&D.charCodeAt(2)===c)&&(D=`${F}\\`));const B=D.length;let z=0,_="",I=!1;const N=D.charCodeAt(0);if(B===1)h(N)&&(z=1,I=!0);else if(h(N))if(I=!0,h(D.charCodeAt(1))){let Z=2,ee=Z;for(;Z<B&&!h(D.charCodeAt(Z));)Z++;if(Z<B&&Z!==ee){const ue=D.slice(ee,Z);for(ee=Z;Z<B&&h(D.charCodeAt(Z));)Z++;if(Z<B&&Z!==ee){for(ee=Z;Z<B&&!h(D.charCodeAt(Z));)Z++;(Z===B||Z!==ee)&&(_=`\\\\${ue}\\${D.slice(ee,Z)}`,z=Z)}}}else z=1;else n(N)&&D.charCodeAt(1)===m&&(_=D.slice(0,2),z=2,B>2&&h(D.charCodeAt(2))&&(I=!0,z=3));if(_.length>0)if(F.length>0){if(_.toLowerCase()!==F.toLowerCase())continue}else F=_;if(L){if(F.length>0)break}else if(j=`${D.slice(z)}\\${j}`,L=I,I&&F.length>0)break}return j=r(j,!L,"\\",h),L?`${F}\\${j}`:`${F}${j}`||"."},normalize(o){e(o,"path");const F=o.length;if(F===0)return".";let j=0,L,d=!1;const D=o.charCodeAt(0);if(F===1)return g(D)?"\\":o;if(h(D))if(d=!0,h(o.charCodeAt(1))){let z=2,_=z;for(;z<F&&!h(o.charCodeAt(z));)z++;if(z<F&&z!==_){const I=o.slice(_,z);for(_=z;z<F&&h(o.charCodeAt(z));)z++;if(z<F&&z!==_){for(_=z;z<F&&!h(o.charCodeAt(z));)z++;if(z===F)return`\\\\${I}\\${o.slice(_)}\\`;z!==_&&(L=`\\\\${I}\\${o.slice(_,z)}`,j=z)}}}else j=1;else n(D)&&o.charCodeAt(1)===m&&(L=o.slice(0,2),j=2,F>2&&h(o.charCodeAt(2))&&(d=!0,j=3));let B=j<F?r(o.slice(j),!d,"\\",h):"";return B.length===0&&!d&&(B="."),B.length>0&&h(o.charCodeAt(F-1))&&(B+="\\"),L===void 0?d?`\\${B}`:B:d?`${L}\\${B}`:`${L}${B}`},isAbsolute(o){e(o,"path");const F=o.length;if(F===0)return!1;const j=o.charCodeAt(0);return h(j)||F>2&&n(j)&&o.charCodeAt(1)===m&&h(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let F,j;for(let D=0;D<o.length;++D){const B=o[D];e(B,"path"),B.length>0&&(F===void 0?F=j=B:F+=`\\${B}`)}if(F===void 0)return".";let L=!0,d=0;if(typeof j=="string"&&h(j.charCodeAt(0))){++d;const D=j.length;D>1&&h(j.charCodeAt(1))&&(++d,D>2&&(h(j.charCodeAt(2))?++d:L=!1))}if(L){for(;d<F.length&&h(F.charCodeAt(d));)d++;d>=2&&(F=`\\${F.slice(d)}`)}return t.$ec.normalize(F)},relative(o,F){if(e(o,"from"),e(F,"to"),o===F)return"";const j=t.$ec.resolve(o),L=t.$ec.resolve(F);if(j===L||(o=j.toLowerCase(),F=L.toLowerCase(),o===F))return"";let d=0;for(;d<o.length&&o.charCodeAt(d)===c;)d++;let D=o.length;for(;D-1>d&&o.charCodeAt(D-1)===c;)D--;const B=D-d;let z=0;for(;z<F.length&&F.charCodeAt(z)===c;)z++;let _=F.length;for(;_-1>z&&F.charCodeAt(_-1)===c;)_--;const I=_-z,N=B<I?B:I;let Z=-1,ee=0;for(;ee<N;ee++){const ae=o.charCodeAt(d+ee);if(ae!==F.charCodeAt(z+ee))break;ae===c&&(Z=ee)}if(ee!==N){if(Z===-1)return L}else{if(I>N){if(F.charCodeAt(z+ee)===c)return L.slice(z+ee+1);if(ee===2)return L.slice(z+ee)}B>N&&(o.charCodeAt(d+ee)===c?Z=ee:ee===2&&(Z=3)),Z===-1&&(Z=0)}let ue="";for(ee=d+Z+1;ee<=D;++ee)(ee===D||o.charCodeAt(ee)===c)&&(ue+=ue.length===0?"..":"\\..");return z+=Z,ue.length>0?`${ue}${L.slice(z,_)}`:(L.charCodeAt(z)===c&&++z,L.slice(z,_))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const F=t.$ec.resolve(o);if(F.length<=2)return o;if(F.charCodeAt(0)===c){if(F.charCodeAt(1)===c){const j=F.charCodeAt(2);if(j!==O&&j!==A)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(n(F.charCodeAt(0))&&F.charCodeAt(1)===m&&F.charCodeAt(2)===c)return`\\\\?\\${F}`;return o},dirname(o){e(o,"path");const F=o.length;if(F===0)return".";let j=-1,L=0;const d=o.charCodeAt(0);if(F===1)return h(d)?o:".";if(h(d)){if(j=L=1,h(o.charCodeAt(1))){let z=2,_=z;for(;z<F&&!h(o.charCodeAt(z));)z++;if(z<F&&z!==_){for(_=z;z<F&&h(o.charCodeAt(z));)z++;if(z<F&&z!==_){for(_=z;z<F&&!h(o.charCodeAt(z));)z++;if(z===F)return o;z!==_&&(j=L=z+1)}}}}else n(d)&&o.charCodeAt(1)===m&&(j=F>2&&h(o.charCodeAt(2))?3:2,L=j);let D=-1,B=!0;for(let z=F-1;z>=L;--z)if(h(o.charCodeAt(z))){if(!B){D=z;break}}else B=!1;if(D===-1){if(j===-1)return".";D=j}return o.slice(0,D)},basename(o,F){F!==void 0&&e(F,"ext"),e(o,"path");let j=0,L=-1,d=!0,D;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===m&&(j=2),F!==void 0&&F.length>0&&F.length<=o.length){if(F===o)return"";let B=F.length-1,z=-1;for(D=o.length-1;D>=j;--D){const _=o.charCodeAt(D);if(h(_)){if(!d){j=D+1;break}}else z===-1&&(d=!1,z=D+1),B>=0&&(_===F.charCodeAt(B)?--B===-1&&(L=D):(B=-1,L=z))}return j===L?L=z:L===-1&&(L=o.length),o.slice(j,L)}for(D=o.length-1;D>=j;--D)if(h(o.charCodeAt(D))){if(!d){j=D+1;break}}else L===-1&&(d=!1,L=D+1);return L===-1?"":o.slice(j,L)},extname(o){e(o,"path");let F=0,j=-1,L=0,d=-1,D=!0,B=0;o.length>=2&&o.charCodeAt(1)===m&&n(o.charCodeAt(0))&&(F=L=2);for(let z=o.length-1;z>=F;--z){const _=o.charCodeAt(z);if(h(_)){if(!D){L=z+1;break}continue}d===-1&&(D=!1,d=z+1),_===A?j===-1?j=z:B!==1&&(B=1):j!==-1&&(B=-1)}return j===-1||d===-1||B===0||B===1&&j===d-1&&j===L+1?"":o.slice(j,d)},format:b.bind(null,"\\"),parse(o){e(o,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return F;const j=o.length;let L=0,d=o.charCodeAt(0);if(j===1)return h(d)?(F.root=F.dir=o,F):(F.base=F.name=o,F);if(h(d)){if(L=1,h(o.charCodeAt(1))){let Z=2,ee=Z;for(;Z<j&&!h(o.charCodeAt(Z));)Z++;if(Z<j&&Z!==ee){for(ee=Z;Z<j&&h(o.charCodeAt(Z));)Z++;if(Z<j&&Z!==ee){for(ee=Z;Z<j&&!h(o.charCodeAt(Z));)Z++;Z===j?L=Z:Z!==ee&&(L=Z+1)}}}}else if(n(d)&&o.charCodeAt(1)===m){if(j<=2)return F.root=F.dir=o,F;if(L=2,h(o.charCodeAt(2))){if(j===3)return F.root=F.dir=o,F;L=3}}L>0&&(F.root=o.slice(0,L));let D=-1,B=L,z=-1,_=!0,I=o.length-1,N=0;for(;I>=L;--I){if(d=o.charCodeAt(I),h(d)){if(!_){B=I+1;break}continue}z===-1&&(_=!1,z=I+1),d===A?D===-1?D=I:N!==1&&(N=1):D!==-1&&(N=-1)}return z!==-1&&(D===-1||N===0||N===1&&D===z-1&&D===B+1?F.base=F.name=o.slice(B,z):(F.name=o.slice(B,D),F.base=o.slice(B,z),F.ext=o.slice(D,z))),B>0&&B!==L?F.dir=o.slice(0,B-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(a){const o=/\\/g;return()=>{const F=v.cwd().replace(o,"/");return F.slice(F.indexOf("/"))}}return()=>v.cwd()})();t.$fc={resolve(...o){let F="",j=!1;for(let L=o.length-1;L>=-1&&!j;L--){const d=L>=0?o[L]:f();e(d,"path"),d.length!==0&&(F=`${d}/${F}`,j=d.charCodeAt(0)===u)}return F=r(F,!j,"/",g),j?`/${F}`:F.length>0?F:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const F=o.charCodeAt(0)===u,j=o.charCodeAt(o.length-1)===u;return o=r(o,!F,"/",g),o.length===0?F?"/":j?"./":".":(j&&(o+="/"),F?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===u},join(...o){if(o.length===0)return".";let F;for(let j=0;j<o.length;++j){const L=o[j];e(L,"path"),L.length>0&&(F===void 0?F=L:F+=`/${L}`)}return F===void 0?".":t.$fc.normalize(F)},relative(o,F){if(e(o,"from"),e(F,"to"),o===F||(o=t.$fc.resolve(o),F=t.$fc.resolve(F),o===F))return"";const j=1,L=o.length,d=L-j,D=1,B=F.length-D,z=d<B?d:B;let _=-1,I=0;for(;I<z;I++){const Z=o.charCodeAt(j+I);if(Z!==F.charCodeAt(D+I))break;Z===u&&(_=I)}if(I===z)if(B>z){if(F.charCodeAt(D+I)===u)return F.slice(D+I+1);if(I===0)return F.slice(D+I)}else d>z&&(o.charCodeAt(j+I)===u?_=I:I===0&&(_=0));let N="";for(I=j+_+1;I<=L;++I)(I===L||o.charCodeAt(I)===u)&&(N+=N.length===0?"..":"/..");return`${N}${F.slice(D+_)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const F=o.charCodeAt(0)===u;let j=-1,L=!0;for(let d=o.length-1;d>=1;--d)if(o.charCodeAt(d)===u){if(!L){j=d;break}}else L=!1;return j===-1?F?"/":".":F&&j===1?"//":o.slice(0,j)},basename(o,F){F!==void 0&&e(F,"ext"),e(o,"path");let j=0,L=-1,d=!0,D;if(F!==void 0&&F.length>0&&F.length<=o.length){if(F===o)return"";let B=F.length-1,z=-1;for(D=o.length-1;D>=0;--D){const _=o.charCodeAt(D);if(_===u){if(!d){j=D+1;break}}else z===-1&&(d=!1,z=D+1),B>=0&&(_===F.charCodeAt(B)?--B===-1&&(L=D):(B=-1,L=z))}return j===L?L=z:L===-1&&(L=o.length),o.slice(j,L)}for(D=o.length-1;D>=0;--D)if(o.charCodeAt(D)===u){if(!d){j=D+1;break}}else L===-1&&(d=!1,L=D+1);return L===-1?"":o.slice(j,L)},extname(o){e(o,"path");let F=-1,j=0,L=-1,d=!0,D=0;for(let B=o.length-1;B>=0;--B){const z=o.charCodeAt(B);if(z===u){if(!d){j=B+1;break}continue}L===-1&&(d=!1,L=B+1),z===A?F===-1?F=B:D!==1&&(D=1):F!==-1&&(D=-1)}return F===-1||L===-1||D===0||D===1&&F===L-1&&F===j+1?"":o.slice(F,L)},format:b.bind(null,"/"),parse(o){e(o,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return F;const j=o.charCodeAt(0)===u;let L;j?(F.root="/",L=1):L=0;let d=-1,D=0,B=-1,z=!0,_=o.length-1,I=0;for(;_>=L;--_){const N=o.charCodeAt(_);if(N===u){if(!z){D=_+1;break}continue}B===-1&&(z=!1,B=_+1),N===A?d===-1?d=_:I!==1&&(I=1):d!==-1&&(I=-1)}if(B!==-1){const N=D===0&&j?1:D;d===-1||I===0||I===1&&d===B-1&&d===D+1?F.base=F.name=o.slice(N,B):(F.name=o.slice(N,d),F.base=o.slice(N,B),F.ext=o.slice(d,B))}return D>0?F.dir=o.slice(0,D-1):j&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=a?t.$ec.normalize:t.$fc.normalize,t.$hc=a?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=a?t.$ec.join:t.$fc.join,t.$jc=a?t.$ec.resolve:t.$fc.resolve,t.$kc=a?t.$ec.relative:t.$fc.relative,t.$lc=a?t.$ec.dirname:t.$fc.dirname,t.$mc=a?t.$ec.basename:t.$fc.basename,t.$nc=a?t.$ec.extname:t.$fc.extname,t.$oc=a?t.$ec.format:t.$fc.format,t.$pc=a?t.$ec.parse:t.$fc.parse,t.$qc=a?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=a?t.$ec.sep:t.$fc.sep,t.$sc=a?t.$ec.delimiter:t.$fc.delimiter}),define($e[113],pe([1,0,22,5,12,7]),function(oe,t,v,T,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=void 0;function w(D){return D===47||D===92}t.$Qf=w;function A(D){return D.replace(/[\\/]/g,v.$fc.sep)}t.$Rf=A;function u(D){return D.indexOf("/")===-1&&(D=A(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}t.$Sf=u;function c(D,B=v.$fc.sep){if(!D)return"";const z=D.length,_=D.charCodeAt(0);if(w(_)){if(w(D.charCodeAt(1))&&!w(D.charCodeAt(2))){let N=3;const Z=N;for(;N<z&&!w(D.charCodeAt(N));N++);if(Z!==N&&!w(D.charCodeAt(N+1))){for(N+=1;N<z;N++)if(w(D.charCodeAt(N)))return D.slice(0,N+1).replace(/[\\/]/g,B)}}return B}else if(g(_)&&D.charCodeAt(1)===58)return w(D.charCodeAt(2))?D.slice(0,2)+B:D.slice(0,2);let I=D.indexOf("://");if(I!==-1){for(I+=3;I<z;I++)if(w(D.charCodeAt(I)))return D.slice(0,I+1)}return""}t.$Tf=c;function m(D){if(!T.$j||!D||D.length<5)return!1;let B=D.charCodeAt(0);if(B!==92||(B=D.charCodeAt(1),B!==92))return!1;let z=2;const _=z;for(;z<D.length&&(B=D.charCodeAt(z),B!==92);z++);return!(_===z||(B=D.charCodeAt(z+1),isNaN(B)||B===92))}t.$Uf=m;const O=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(D,B=T.$j){const z=B?O:s;return!(!D||D.length===0||/^\s+$/.test(D)||(z.lastIndex=0,z.test(D))||B&&l.test(D)||D==="."||D===".."||B&&D[D.length-1]==="."||B&&D.length!==D.trim().length||D.length>255)}t.$Vf=e;function a(D,B,z){const _=D===B;return!z||_?_:!D||!B?!1:(0,i.$2e)(D,B)}t.$Wf=a;function h(D,B,z,_=v.sep){if(D===B)return!0;if(!D||!B||B.length>D.length)return!1;if(z){if(!(0,i.$3e)(D,B))return!1;if(B.length===D.length)return!0;let N=B.length;return B.charAt(B.length-1)===_&&N--,D.charAt(N)===_}return B.charAt(B.length-1)!==_&&(B+=_),D.indexOf(B)===0}t.$Xf=h;function g(D){return D>=65&&D<=90||D>=97&&D<=122}t.$Yf=g;function n(D,B){return T.$j&&D.endsWith(":")&&(D+=v.sep),(0,v.$hc)(D)||(D=(0,v.$ic)(B,D)),D=(0,v.$gc)(D),T.$j?(D=(0,i.$Ke)(D,v.sep),D.endsWith(":")&&(D+=v.sep)):(D=(0,i.$Ke)(D,v.sep),D||(D=v.sep)),D}t.$Zf=n;function r(D){const B=(0,v.$gc)(D);return T.$j?D.length>3?!1:b(B)&&(D.length===2||B.charCodeAt(2)===92):B===v.$fc.sep}t.$1f=r;function b(D,B=T.$j){return B?g(D.charCodeAt(0))&&D.charCodeAt(1)===58:!1}t.$2f=b;function f(D,B=T.$j){return b(D,B)?D[0]:void 0}t.$3f=f;function o(D,B,z){return B.length>D.length?-1:D===B?0:(z&&(D=D.toLowerCase(),B=B.toLowerCase()),D.indexOf(B))}t.$4f=o;function F(D){const B=D.split(":");let z,_,I;for(const N of B){const Z=Number(N);(0,U.$Cf)(Z)?_===void 0?_=Z:I===void 0&&(I=Z):z=z?[z,N].join(":"):N}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:_!==void 0?_:void 0,column:I!==void 0?I:_!==void 0?1:void 0}}t.$5f=F;const j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function d(D,B,z=8){let _="";for(let N=0;N<z;N++){let Z;N===0&&T.$j&&!B&&(z===3||z===4)?Z=L:Z=j,_+=Z.charAt(Math.floor(Math.random()*Z.length))}let I;return B?I=`${B}-${_}`:I=_,D?(0,v.$ic)(D,I):I}t.$6f=d}),define($e[114],pe([1,0,22]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ur=t.$Tr=t.$Sr=t.$Rr=t.$Qr=void 0,t.$Qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(m){const O=(0,v.$nc)(m),s=T[O.toLowerCase()];return s!==void 0?s:w(m)}t.$Rr=U;function w(m){const O=(0,v.$nc)(m);return i[O.toLowerCase()]}t.$Sr=w;function A(m){for(const O in i)if(i[O]===m)return O}t.$Tr=A;const u=/^(.+)\/(.+?)(;.+)?$/;function c(m,O){const s=u.exec(m);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:O?void 0:m}t.$Ur=c}),define($e[15],pe([1,0,22,5]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,U=/^\//,w=/^\/\//;function A(L,d){if(!L.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!i.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!U.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(L,d){return!L&&!d?"file":L}function c(L,d){switch(L){case"https":case"http":case"file":d?d[0]!==O&&(d=O+d):d=O;break}return d}const m="",O="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(d){return d instanceof l?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,D,B,z,_,I=!1){typeof d=="object"?(this.scheme=d.scheme||m,this.authority=d.authority||m,this.path=d.path||m,this.query=d.query||m,this.fragment=d.fragment||m):(this.scheme=u(d,I),this.authority=D||m,this.path=c(this.scheme,B||m),this.query=z||m,this.fragment=_||m,A(this,I))}get fsPath(){return b(this,!1)}with(d){if(!d)return this;let{scheme:D,authority:B,path:z,query:_,fragment:I}=d;return D===void 0?D=this.scheme:D===null&&(D=m),B===void 0?B=this.authority:B===null&&(B=m),z===void 0?z=this.path:z===null&&(z=m),_===void 0?_=this.query:_===null&&(_=m),I===void 0?I=this.fragment:I===null&&(I=m),D===this.scheme&&B===this.authority&&z===this.path&&_===this.query&&I===this.fragment?this:new h(D,B,z,_,I)}static parse(d,D=!1){const B=s.exec(d);return B?new h(B[2]||m,j(B[4]||m),j(B[5]||m),j(B[7]||m),j(B[9]||m),D):new h(m,m,m,m,m)}static file(d){let D=m;if(T.$j&&(d=d.replace(/\\/g,O)),d[0]===O&&d[1]===O){const B=d.indexOf(O,2);B===-1?(D=d.substring(2),d=O):(D=d.substring(2,B),d=d.substring(B)||O)}return new h("file",D,d,m,m)}static from(d,D){return new h(d.scheme,d.authority,d.path,d.query,d.fragment,D)}static joinPath(d,...D){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let B;return T.$j&&d.scheme==="file"?B=l.file(v.$ec.join(b(d,!0),...D)).path:B=v.$fc.join(d.path,...D),d.with({path:B})}toString(d=!1){return f(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof l)return d;{const D=new h(d);return D._formatted=d.external??null,D._fsPath=d._sep===a?d.fsPath??null:null,D}}else return d}}t.URI=l;function e(L){return!L||typeof L!="object"?!1:typeof L.scheme=="string"&&(typeof L.authority=="string"||typeof L.authority>"u")&&(typeof L.path=="string"||typeof L.path>"u")&&(typeof L.query=="string"||typeof L.query>"u")&&(typeof L.fragment=="string"||typeof L.fragment>"u")}t.$uc=e;const a=T.$j?1:void 0;class h extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(d=!1){return d?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=a),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(L,d,D){let B,z=-1;for(let _=0;_<L.length;_++){const I=L.charCodeAt(_);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||d&&I===47||D&&I===91||D&&I===93||D&&I===58)z!==-1&&(B+=encodeURIComponent(L.substring(z,_)),z=-1),B!==void 0&&(B+=L.charAt(_));else{B===void 0&&(B=L.substr(0,_));const N=g[I];N!==void 0?(z!==-1&&(B+=encodeURIComponent(L.substring(z,_)),z=-1),B+=N):z===-1&&(z=_)}}return z!==-1&&(B+=encodeURIComponent(L.substring(z))),B!==void 0?B:L}function r(L){let d;for(let D=0;D<L.length;D++){const B=L.charCodeAt(D);B===35||B===63?(d===void 0&&(d=L.substr(0,D)),d+=g[B]):d!==void 0&&(d+=L[D])}return d!==void 0?d:L}function b(L,d){let D;return L.authority&&L.path.length>1&&L.scheme==="file"?D=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?d?D=L.path.substr(1):D=L.path[1].toLowerCase()+L.path.substr(2):D=L.path,T.$j&&(D=D.replace(/\//g,"\\")),D}t.$vc=b;function f(L,d){const D=d?r:n;let B="",{scheme:z,authority:_,path:I,query:N,fragment:Z}=L;if(z&&(B+=z,B+=":"),(_||z==="file")&&(B+=O,B+=O),_){let ee=_.indexOf("@");if(ee!==-1){const ue=_.substr(0,ee);_=_.substr(ee+1),ee=ue.lastIndexOf(":"),ee===-1?B+=D(ue,!1,!1):(B+=D(ue.substr(0,ee),!1,!1),B+=":",B+=D(ue.substr(ee+1),!1,!0)),B+="@"}_=_.toLowerCase(),ee=_.lastIndexOf(":"),ee===-1?B+=D(_,!1,!0):(B+=D(_.substr(0,ee),!1,!0),B+=_.substr(ee))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const ee=I.charCodeAt(1);ee>=65&&ee<=90&&(I=`/${String.fromCharCode(ee+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const ee=I.charCodeAt(0);ee>=65&&ee<=90&&(I=`${String.fromCharCode(ee+32)}:${I.substr(2)}`)}B+=D(I,!0,!1)}return N&&(B+="?",B+=D(N,!1,!1)),Z&&(B+="#",B+=d?Z:n(Z,!1,!1)),B}function o(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+o(L.substr(3)):L}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function j(L){return L.match(F)?L.replace(F,d=>o(d)):L}}),define($e[52],pe([1,0,32,15]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nh=t.$mh=t.$lh=void 0;function i(u){return JSON.stringify(u,w)}t.$lh=i;function U(u){let c=JSON.parse(u);return c=A(c),c}t.$mh=U;function w(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function A(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return T.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof v.$be||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let m=0;m<u.length;++m)u[m]=A(u[m],c+1);else for(const m in u)Object.hasOwnProperty.call(u,m)&&(u[m]=A(u[m],c+1))}return u}t.$nh=A}),define($e[29],pe([1,0,6,5,15]),function(oe,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.Schemas=void 0;var U;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(U||(t.Schemas=U={})),t.$7f="vscode-tkn",t.$8f="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${U.vscodeRemoteResource}`}set(m,O,s){this.a[m]=O,this.b[m]=s}setConnectionToken(m,O){this.c[m]=O}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(h){return v.$Z(h),m}const O=m.authority;let s=this.a[O];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const l=this.b[O],e=this.c[O];let a=`path=${encodeURIComponent(m.path)}`;return typeof e=="string"&&(a+=`&${t.$8f}=${encodeURIComponent(e)}`),i.URI.from({scheme:T.$p?this.d:U.vscodeRemoteResource,authority:`${s}:${l}`,path:this.f,query:a})}}t.$9f=new w,t.$0f="vs/../../extensions",t.$$f="vs/../../node_modules",t.$_f="vs/../../node_modules.asar",t.$ag="vs/../../node_modules.asar.unpacked",t.$bg="vscode-app";class A{static{this.a=t.$bg}asBrowserUri(m){const O=this.b(m,oe);return this.uriToBrowserUri(O)}uriToBrowserUri(m){return m.scheme===U.vscodeRemote?t.$9f.rewrite(m):m.scheme===U.file&&(T.$n||T.$q&&T.$h.origin===`${U.vscodeFileResource}://${A.a}`)?m.with({scheme:U.vscodeFileResource,authority:m.authority||A.a,query:null,fragment:null}):m}asFileUri(m){const O=this.b(m,oe);return this.uriToFileUri(O)}uriToFileUri(m){return m.scheme===U.vscodeFileResource?m.with({scheme:U.file,authority:m.authority!==A.a?m.authority:null,query:null,fragment:null}):m}b(m,O){return i.URI.isUri(m)?m:i.URI.parse(O.toUrl(m))}}t.$cg=new A;var u;(function(c){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(m.get("3"));const O="vscode-coi";function s(e){let a;typeof e=="string"?a=new URL(e).searchParams:e instanceof URL?a=e.searchParams:i.URI.isUri(e)&&(a=new URL(e.toString(!0)).searchParams);const h=a?.get(O);if(h)return m.get(h)}c.getHeadersFromQuery=s;function l(e,a,h){if(!globalThis.crossOriginIsolated)return;const g=a&&h?"3":h?"2":"1";e instanceof URLSearchParams?e.set(O,g):e[O]=g}c.addSearchParam=l})(u||(t.COI=u={}))}),define($e[36],pe([1,0,113,29,22,5,12,15]),function(oe,t,v,T,i,U,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fg=t.DataUri=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=void 0;function u(l){return(0,A.$vc)(l,!0)}t.$jg=u;class c{constructor(e){this.a=e}compare(e,a,h=!1){return e===a?0:(0,w.$Ue)(this.getComparisonKey(e,h),this.getComparisonKey(a,h))}isEqual(e,a,h=!1){return e===a?!0:!e||!a?!1:this.getComparisonKey(e,h)===this.getComparisonKey(a,h)}getComparisonKey(e,a=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,a,h=!1){if(e.scheme===a.scheme){if(e.scheme===T.Schemas.file)return v.$Xf(u(e),u(a),this.a(e))&&e.query===a.query&&(h||e.fragment===a.fragment);if((0,t.$Ag)(e.authority,a.authority))return v.$Xf(e.path,a.path,this.a(e),"/")&&e.query===a.query&&(h||e.fragment===a.fragment)}return!1}joinPath(e,...a){return A.URI.joinPath(e,...a)}basenameOrAuthority(e){return(0,t.$sg)(e)||e.authority}basename(e){return i.$fc.basename(e.path)}extname(e){return i.$fc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let a;return e.scheme===T.Schemas.file?a=A.URI.file(i.$lc(u(e))).path:(a=i.$fc.dirname(e.path),e.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),a="/")),e.with({path:a})}normalizePath(e){if(!e.path.length)return e;let a;return e.scheme===T.Schemas.file?a=A.URI.file(i.$gc(u(e))).path:a=i.$fc.normalize(e.path),e.with({path:a})}relativePath(e,a){if(e.scheme!==a.scheme||!(0,t.$Ag)(e.authority,a.authority))return;if(e.scheme===T.Schemas.file){const n=i.$kc(u(e),u(a));return U.$j?v.$Rf(n):n}let h=e.path||"/";const g=a.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(h.length,g.length);n<r&&!(h.charCodeAt(n)!==g.charCodeAt(n)&&h.charAt(n).toLowerCase()!==g.charAt(n).toLowerCase());n++);h=g.substr(0,n)+h.substr(n)}return i.$fc.relative(h,g)}resolvePath(e,a){if(e.scheme===T.Schemas.file){const h=A.URI.file(i.$jc(u(e),a));return e.with({authority:h.authority,path:h.path})}return a=v.$Sf(a),e.with({path:i.$fc.resolve(e.path,a)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,a){return e===a||e!==void 0&&a!==void 0&&(0,w.$2e)(e,a)}hasTrailingPathSeparator(e,a=i.sep){if(e.scheme===T.Schemas.file){const h=u(e);return h.length>v.$Tf(h).length&&h[h.length-1]===a}else{const h=e.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,a=i.sep){return(0,t.$Bg)(e,a)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,a=i.sep){let h=!1;if(e.scheme===T.Schemas.file){const g=u(e);h=g!==void 0&&g.length===v.$Tf(g).length&&g[g.length-1]===a}else{a="/";const g=e.path;h=g.length===1&&g.charCodeAt(g.length-1)===47}return!h&&!(0,t.$Bg)(e,a)?e.with({path:e.path+"/"}):e}}t.$kg=c,t.$lg=new c(()=>!1),t.$mg=new c(l=>l.scheme===T.Schemas.file?!U.$l:!0),t.$ng=new c(l=>!0),t.$og=t.$lg.isEqual.bind(t.$lg),t.$pg=t.$lg.isEqualOrParent.bind(t.$lg),t.$qg=t.$lg.getComparisonKey.bind(t.$lg),t.$rg=t.$lg.basenameOrAuthority.bind(t.$lg),t.$sg=t.$lg.basename.bind(t.$lg),t.$tg=t.$lg.extname.bind(t.$lg),t.$ug=t.$lg.dirname.bind(t.$lg),t.$vg=t.$lg.joinPath.bind(t.$lg),t.$wg=t.$lg.normalizePath.bind(t.$lg),t.$xg=t.$lg.relativePath.bind(t.$lg),t.$yg=t.$lg.resolvePath.bind(t.$lg),t.$zg=t.$lg.isAbsolutePath.bind(t.$lg),t.$Ag=t.$lg.isEqualAuthority.bind(t.$lg),t.$Bg=t.$lg.hasTrailingPathSeparator.bind(t.$lg),t.$Cg=t.$lg.removeTrailingPathSeparator.bind(t.$lg),t.$Dg=t.$lg.addTrailingPathSeparator.bind(t.$lg);function m(l,e){const a=[];for(let h=0;h<l.length;h++){const g=e(l[h]);l.some((n,r)=>r===h?!1:(0,t.$pg)(g,e(n)))||a.push(l[h])}return a}t.$Eg=m;var O;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function e(a){const h=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(r=>{const[b,f]=r.split(":");b&&f&&h.set(b,f)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&h.set(l.META_DATA_MIME,n),h}l.parseMetaData=e})(O||(t.DataUri=O={}));function s(l,e,a){if(e){let h=l.path;return h&&h[0]!==i.$fc.sep&&(h=i.$fc.sep+h),l.with({scheme:a,authority:e,path:h})}return l.with({scheme:a})}t.$Fg=s}),define($e[9],pe([1,0,28,6,4,2,36,5,49]),function(oe,t,v,T,i,U,w,A,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hh=t.$gh=t.$fh=t.$eh=t.Promises=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=void 0;function c(V){return!!V&&typeof V.then=="function"}t.$Gg=c;function m(V){const p=new v.$Xd,y=V(p.token),E=new Promise((M,k)=>{const R=p.token.onCancellationRequested(()=>{R.dispose(),p.dispose(),k(new T.$4)});Promise.resolve(y).then(C=>{R.dispose(),p.dispose(),M(C)},C=>{R.dispose(),p.dispose(),k(C)})});return new class{cancel(){p.cancel()}then(M,k){return E.then(M,k)}catch(M){return this.then(void 0,M)}finally(M){return E.finally(M)}}}t.$Hg=m;function O(V,p,y){return new Promise((E,M)=>{const k=p.onCancellationRequested(()=>{k.dispose(),E(y)});V.then(E,M).finally(()=>k.dispose())})}t.$Ig=O;function s(V,p){return new Promise((y,E)=>{const M=p.onCancellationRequested(()=>{M.dispose(),E(new T.$4)});V.then(y,E).finally(()=>M.dispose())})}t.$Jg=s;async function l(V){let p=-1;const y=V.map((E,M)=>E.then(k=>(p=M,k)));try{return await Promise.race(y)}finally{V.forEach((E,M)=>{M!==p&&E.cancel()})}}t.$Kg=l;function e(V,p,y){let E;const M=setTimeout(()=>{E?.(void 0),y?.()},p);return Promise.race([V.finally(()=>clearTimeout(M)),new Promise(k=>E=k)])}t.$Lg=e;function a(V){return new Promise((p,y)=>{const E=V();c(E)?E.then(p,y):p(E)})}t.$Mg=a;class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const y=()=>{if(this.b=null,this.f)return;const E=this.queue(this.d);return this.d=null,E};this.b=new Promise(E=>{this.a.then(y,y).then(E)})}return new Promise((y,E)=>{this.b.then(y,E)})}return this.a=p(),new Promise((y,E)=>{this.a.then(M=>{this.a=null,y(M)},M=>{this.a=null,E(M)})})}dispose(){this.f=!0}}t.$Ng=h;class g{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Og=g;class n{constructor(){this.a=new Map}queue(p,y){const M=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(p)===M&&this.a.delete(p)});return this.a.set(p,M),M}}t.$Pg=n;const r=(V,p)=>{let y=!0;const E=setTimeout(()=>{y=!1,p()},V);return{isTriggered:()=>y,dispose:()=>{clearTimeout(E),y=!1}}},b=V=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,V())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class f{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,y=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((M,k)=>{this.d=M,this.f=k}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const E=()=>{this.a=null,this.d?.(null)};return this.a=y===u.$Kd?b(E):r(y,E),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Qg=f;class o{constructor(p){this.a=new f(p),this.b=new h}trigger(p,y){return this.a.trigger(()=>this.b.queue(p),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Rg=o;class F{constructor(){this.a=!1,this.b=new Promise((p,y)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Sg=F;class j extends F{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Tg=j;function L(V,p){return p?new Promise((y,E)=>{const M=setTimeout(()=>{k.dispose(),y()},V),k=p.onCancellationRequested(()=>{clearTimeout(M),k.dispose(),E(new T.$4)})}):m(y=>L(V,y))}t.$Ug=L;function d(V,p=0,y){const E=setTimeout(()=>{V(),y&&M.dispose()},p),M=(0,U.$Pc)(()=>{clearTimeout(E),y?.deleteAndLeak(M)});return y?.add(M),M}t.$Vg=d;function D(V,p,y){let E=0;const M=setInterval(()=>{E++,(E>=y||V())&&k.dispose()},p),k=(0,U.$Pc)(()=>{clearInterval(M)});return k}t.$Wg=D;function B(V){const p=[];let y=0;const E=V.length;function M(){return y<E?V[y++]():null}function k(R){R!=null&&p.push(R);const C=M();return C?C.then(k):Promise.resolve(p)}return Promise.resolve(null).then(k)}t.$Xg=B;function z(V,p=E=>!!E,y=null){let E=0;const M=V.length,k=()=>{if(E>=M)return Promise.resolve(y);const R=V[E++];return Promise.resolve(R()).then(P=>p(P)?Promise.resolve(P):k())};return k()}t.$Yg=z;function _(V,p=E=>!!E,y=null){if(V.length===0)return Promise.resolve(y);let E=V.length;const M=()=>{E=-1;for(const k of V)k.cancel?.()};return new Promise((k,R)=>{for(const C of V)C.then(P=>{--E>=0&&p(P)?(M(),k(P)):E===0&&k(y)}).catch(P=>{--E>=0&&(M(),R(P))})})}t.$Zg=_;class I{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((y,E)=>{this.f.push({factory:p,c:y,e:E}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const y=p.factory();y.then(p.c,p.e),y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$1g=I;class N extends I{constructor(){super(1)}}t.$2g=N;class Z{constructor(){this.a=new de,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$3g=Z;class ee{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new Y;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,y=w.$lg){const E=y.getComparisonKey(p);let M=this.a.get(E);if(!M){M=new N;const k=this.f++,R=i.Event.once(M.onDrained)(()=>{M?.dispose(),this.a.delete(E),this.h(),this.d?.deleteAndDispose(k),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$Zc),this.d.set(k,R),this.a.set(E,M)}return M}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$4g=ee;class ue{constructor(p,y){this.a=-1,typeof p=="function"&&typeof y=="number"&&this.setIfNotSet(p,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},y)}setIfNotSet(p,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},y))}}t.$5g=ue;class ae{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(p,y){this.cancel(),this.a=setInterval(()=>{p()},y)}}t.$6g=ae;class se{constructor(p,y){this.b=-1,this.a=p,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$7g=se;class re{constructor(p,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=p,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$8g=re;class be extends se{constructor(p,y){super(p,y),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$9g=be;class Se extends U.$Rc{constructor(p,y){super(),this.g=p,this.h=y,this.a=[],this.b=this.B(new U.$Sc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of p)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$0g=Se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$$g=V=>{(0,A.$B)(()=>{if(p)return;const y=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,y-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$$g=(V,p)=>{const y=requestIdleCallback(V,typeof p=="number"?{timeout:p}:void 0);let E=!1;return{dispose(){E||(E=!0,cancelIdleCallback(y))}}}}();class Oe{constructor(p){this.d=!1,this.a=()=>{try{this.f=p()}catch(y){this.g=y}finally{this.d=!0}},this.b=(0,t.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$_g=Oe;async function Te(V,p,y){let E;for(let M=0;M<y;M++)try{return await V()}catch(k){E=k,await L(p)}throw E}t.$ah=Te;class de{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,y,E){return this.a={taskId:p,cancel:()=>E?.(),promise:y},y.then(()=>this.d(p),()=>this.d(p)),y}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let y,E;const M=new Promise((k,R)=>{y=k,E=R});this.b={run:p,promise:M,promiseResolve:y,promiseReject:E}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$bh=de;class ie{constructor(p,y=()=>Date.now()){this.d=p,this.f=y,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$ch=ie;var fe;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(fe||(fe={}));class Y{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,y)=>{this.a=p,this.b=y})}complete(p){return new Promise(y=>{this.a(p),this.d={outcome:0,value:p},y()})}error(p){return new Promise(y=>{this.b(p),this.d={outcome:1,value:p},y()})}cancel(){return this.error(new T.$4)}}t.$dh=Y;var q;(function(V){async function p(E){let M;const k=await Promise.all(E.map(R=>R.then(C=>C,C=>{M||(M=C)})));if(typeof M<"u")throw M;return k}V.settled=p;function y(E){return new Promise(async(M,k)=>{try{await E(M,k)}catch(R){k(R)}})}V.withAsyncBody=y})(q||(t.Promises=q={}));var X;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(X||(X={}));class S{static fromArray(p){return new S(y=>{y.emitMany(p)})}static fromPromise(p){return new S(async y=>{y.emitMany(await p)})}static fromPromises(p){return new S(async y=>{await Promise.all(p.map(async E=>y.emitOne(await E)))})}static merge(p){return new S(async y=>{await Promise.all(p.map(async E=>{for await(const M of E)y.emitOne(M)}))})}static{this.EMPTY=S.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$Nd,queueMicrotask(async()=>{const y={emitOne:E=>this.g(E),emitMany:E=>this.h(E),reject:E=>this.k(E)};try{await Promise.resolve(p(y)),this.j()}catch(E){this.k(E)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,y){return new S(async E=>{for await(const M of p)E.emitOne(y(M))})}map(p){return S.map(this,p)}static filter(p,y){return new S(async E=>{for await(const M of p)y(M)&&E.emitOne(M)})}filter(p){return S.filter(this,p)}static coalesce(p){return S.filter(p,y=>!!y)}coalesce(){return S.coalesce(this)}static async toPromise(p){const y=[];for await(const E of p)y.push(E);return y}toPromise(){return S.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$eh=S;class Q extends S{constructor(p,y){super(y),this.l=p}cancel(){this.l.cancel()}}t.$fh=Q;function $(V){const p=new v.$Xd,y=V(p.token);return new Q(p,async E=>{const M=p.token.onCancellationRequested(()=>{M.dispose(),p.dispose(),E.reject(new T.$4)});try{for await(const k of y){if(p.token.isCancellationRequested)return;E.emitOne(k)}M.dispose(),p.dispose()}catch(k){M.dispose(),p.dispose(),E.reject(k)}})}t.$gh=$;class W{constructor(){this.a=new Y,this.b=new S(E=>{if(p){E.reject(p);return}return y&&E.emitMany(y),this.d=M=>E.reject(M),this.f=M=>E.emitOne(M),this.a.p});let p,y;this.f=E=>{y||(y=[]),y.push(E)},this.d=E=>{p||(p=E)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(p){this.d(p),this.a.complete()}emitOne(p){this.f(p)}}t.$hh=W}),define($e[3],pe([1,0,16,111,14,19,9,6,4,115,2,29,5,15,48]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s,l,e){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.$iQ=t.$hQ=t.h=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.DetectedFullscreenMode=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$=t.Namespace=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.getWindowId=t.getWindowsCount=t.getWindows=t.registerWindow=void 0,a=function(){const K=new Map,G=window;typeof G.vscodeWindowId!="number"&&Object.defineProperty(window,"vscodeWindowId",{get:()=>1}),K.set(G.vscodeWindowId,{window:G,disposables:new m.$Qc});const le=new u.$Nd,me=new u.$Nd,Ee=new u.$Nd;return{onDidRegisterWindow:le.event,onWillUnregisterWindow:Ee.event,onDidUnregisterWindow:me.event,registerWindow(Le){if(K.has(Le.vscodeWindowId))return m.$Rc.None;const je=new m.$Qc,Ve={window:Le,disposables:je.add(new m.$Qc)};return K.set(Le.vscodeWindowId,Ve),je.add((0,m.$Pc)(()=>{K.delete(Le.vscodeWindowId),me.fire(Le)})),je.add(n(Le,t.$IP.BEFORE_UNLOAD,()=>{Ee.fire(Le)})),le.fire(Ve),je},getWindows(){return K.values()},getWindowsCount(){return K.size},getWindowId(Le){return Le.vscodeWindowId}}}(),t.registerWindow=a.registerWindow,t.getWindows=a.getWindows,t.getWindowsCount=a.getWindowsCount,t.getWindowId=a.getWindowId,t.onDidRegisterWindow=a.onDidRegisterWindow,t.onWillUnregisterWindow=a.onWillUnregisterWindow,t.onDidUnregisterWindow=a.onDidUnregisterWindow;function h(K){for(;K.firstChild;)K.firstChild.remove()}t.$SO=h;class g{constructor(G,le,me,Ee){this.f=G,this.g=le,this.d=me,this.j=Ee||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function n(K,G,le,me){return new g(K,G,le,me)}t.$TO=n;function r(K){return function(G){return K(new U.$LO(G))}}function b(K){return function(G){return K(new i.$QO(G))}}const f=function(G,le,me,Ee){let Le=me;return le==="click"||le==="mousedown"?Le=r(me):(le==="keydown"||le==="keypress"||le==="keyup")&&(Le=b(me)),n(G,le,Le,Ee)};t.$UO=f;const o=function(G,le,me){const Ee=r(le);return j(G,Ee,me)};t.$VO=o;const F=function(G,le,me){const Ee=r(le);return d(G,Ee,me)};t.$WO=F;function j(K,G,le){return n(K,s.$r&&T.$IO.pointerEvents?t.$IP.POINTER_DOWN:t.$IP.MOUSE_DOWN,G,le)}t.$XO=j;function L(K,G,le){return n(K,s.$r&&T.$IO.pointerEvents?t.$IP.POINTER_MOVE:t.$IP.MOUSE_MOVE,G,le)}t.$YO=L;function d(K,G,le){return n(K,s.$r&&T.$IO.pointerEvents?t.$IP.POINTER_UP:t.$IP.MOUSE_UP,G,le)}t.$ZO=d;class D{constructor(G,le=0){this.d=G,this.priority=le,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(G){(0,A.$Z)(G)}}static sort(G,le){return le.priority-G.priority}}(function(){const K=new Map,G=new Map,le=new Map,me=new Map,Ee=Le=>{le.set(Le,!1);const je=K.get(Le)??[];for(G.set(Le,je),K.set(Le,[]),me.set(Le,!0);je.length>0;)je.sort(D.sort),je.shift().execute();me.set(Le,!1)};t.$2O=(Le,je,Ve=0)=>{const Xe=(0,t.getWindowId)(je),qe=new D(Le,Ve);let st=K.get(Xe);return st||(st=[],K.set(Xe,st)),st.push(qe),le.get(Xe)||(le.set(Xe,!0),je.requestAnimationFrame(()=>Ee(Xe))),qe},t.$1O=(Le,je,Ve)=>{const Xe=(0,t.getWindowId)(je);if(me.get(Xe)){const qe=new D(Le,Ve);let st=G.get(Xe);return st||(st=[],G.set(Xe,st)),st.push(qe),qe}else return(0,t.$2O)(Le,je,Ve)}})();function B(K,G){return(0,t.$2O)(K,G,1e4)}t.$3O=B;function z(K,G){return(0,t.$2O)(K,G,-1e4)}t.$4O=z;const _=8,I=function(K,G){return G};class N extends m.$Rc{constructor(G,le,me,Ee=I,Le=_){super();let je=null,Ve=0;const Xe=this.B(new w.$5g),qe=()=>{Ve=new Date().getTime(),me(je),je=null};this.B(n(G,le,st=>{je=Ee(je,st);const Pt=new Date().getTime()-Ve;Pt>=Le?(Xe.cancel(),qe()):Xe.setIfNotSet(qe,Le-Pt)}))}}function Z(K,G,le,me,Ee){return new N(K,G,le,me,Ee)}t.$5O=Z;function ee(K){return K.ownerDocument.defaultView.getComputedStyle(K,null)}t.$6O=ee;function ue(K){const G=K.ownerDocument,le=G.defaultView?.window;if(K!==G.body)return new se(K.clientWidth,K.clientHeight);if(s.$r&&le?.visualViewport)return new se(le.visualViewport.width,le.visualViewport.height);if(le?.innerWidth&&le.innerHeight)return new se(le.innerWidth,le.innerHeight);if(G.body&&G.body.clientWidth&&G.body.clientHeight)return new se(G.body.clientWidth,G.body.clientHeight);if(G.documentElement&&G.documentElement.clientWidth&&G.documentElement.clientHeight)return new se(G.documentElement.clientWidth,G.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$7O=ue;class ae{static d(G,le){return parseFloat(le)||0}static f(G,le,me){const Ee=ee(G),Le=Ee?Ee.getPropertyValue(le):"0";return ae.d(G,Le)}static getBorderLeftWidth(G){return ae.f(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return ae.f(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return ae.f(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return ae.f(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return ae.f(G,"padding-left","paddingLeft")}static getPaddingRight(G){return ae.f(G,"padding-right","paddingRight")}static getPaddingTop(G){return ae.f(G,"padding-top","paddingTop")}static getPaddingBottom(G){return ae.f(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return ae.f(G,"margin-left","marginLeft")}static getMarginTop(G){return ae.f(G,"margin-top","marginTop")}static getMarginRight(G){return ae.f(G,"margin-right","marginRight")}static getMarginBottom(G){return ae.f(G,"margin-bottom","marginBottom")}}class se{static{this.None=new se(0,0)}constructor(G,le){this.width=G,this.height=le}with(G=this.width,le=this.height){return G!==this.width||le!==this.height?new se(G,le):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof se?G:new se(G.width,G.height)}static equals(G,le){return G===le?!0:!G||!le?!1:G.width===le.width&&G.height===le.height}}t.$8O=se;function re(K){let G=K.offsetParent,le=K.offsetTop,me=K.offsetLeft;for(;(K=K.parentNode)!==null&&K!==K.ownerDocument.body&&K!==K.ownerDocument.documentElement;){le-=K.scrollTop;const Ee=M(K)?null:ee(K);Ee&&(me-=Ee.direction!=="rtl"?K.scrollLeft:-K.scrollLeft),K===G&&(me+=ae.getBorderLeftWidth(K),le+=ae.getBorderTopWidth(K),le+=K.offsetTop,me+=K.offsetLeft,G=K.offsetParent)}return{left:me,top:le}}t.$9O=re;function be(K,G,le){typeof G=="number"&&(K.style.width=`${G}px`),typeof le=="number"&&(K.style.height=`${le}px`)}t.$0O=be;function Se(K,G,le,me,Ee,Le="absolute"){typeof G=="number"&&(K.style.top=`${G}px`),typeof le=="number"&&(K.style.right=`${le}px`),typeof me=="number"&&(K.style.bottom=`${me}px`),typeof Ee=="number"&&(K.style.left=`${Ee}px`),K.style.position=Le}t.$$O=Se;function Oe(K){const G=K.getBoundingClientRect();return{left:G.left+(K.ownerDocument.defaultView?.scrollX??0),top:G.top+(K.ownerDocument.defaultView?.scrollY??0),width:G.width,height:G.height}}t.$_O=Oe;function Te(K){let G=K,le=1;do{const me=ee(G).zoom;me!=null&&me!=="1"&&(le*=me),G=G.parentElement}while(G!==null&&G!==G.ownerDocument.documentElement);return le}t.$aP=Te;function de(K){const G=ae.getMarginLeft(K)+ae.getMarginRight(K);return K.offsetWidth+G}t.$bP=de;function ie(K){const G=ae.getBorderLeftWidth(K)+ae.getBorderRightWidth(K),le=ae.getPaddingLeft(K)+ae.getPaddingRight(K);return K.offsetWidth-G-le}t.$cP=ie;function fe(K){const G=ae.getMarginLeft(K)+ae.getMarginRight(K);return K.scrollWidth+G}t.$dP=fe;function Y(K){const G=ae.getBorderTopWidth(K)+ae.getBorderBottomWidth(K),le=ae.getPaddingTop(K)+ae.getPaddingBottom(K);return K.offsetHeight-G-le}t.$eP=Y;function q(K){const G=ae.getMarginTop(K)+ae.getMarginBottom(K);return K.offsetHeight+G}t.$fP=q;function X(K,G){if(K===null)return 0;const le=re(K),me=re(G);return le.left-me.left}function S(K,G){const le=G.map(Ee=>Math.max(fe(Ee),de(Ee))+X(Ee,K)||0);return Math.max(...le)}t.$gP=S;function Q(K,G){return!!G?.contains(K)}t.$hP=Q;const $="parentFlowToElementId";function W(K,G){K.dataset[$]=G.id}t.$iP=W;function V(K){const G=K.dataset[$];return typeof G=="string"?K.ownerDocument.getElementById(G):null}function p(K,G){let le=K;for(;le;){if(le===G)return!0;if(le instanceof HTMLElement){const me=V(le);if(me){le=me;continue}}le=le.parentNode}return!1}t.$jP=p;function y(K,G,le){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K.classList.contains(G))return K;if(le){if(typeof le=="string"){if(K.classList.contains(le))return null}else if(K===le)return null}K=K.parentNode}return null}t.$kP=y;function E(K,G,le){return!!y(K,G,le)}t.$lP=E;function M(K){return K&&!!K.host&&!!K.mode}t.$mP=M;function k(K){return!!R(K)}t.$nP=k;function R(K){for(;K.parentNode;){if(K===K.ownerDocument?.body)return null;K=K.parentNode}return M(K)?K:null}t.$oP=R;function C(){let K=te().activeElement;for(;K?.shadowRoot;)K=K.shadowRoot.activeElement;return K}t.$pP=C;function P(K){return K.ownerDocument.activeElement===K}t.$qP=P;function H(K){return Q(K.ownerDocument.activeElement,K)}t.$rP=H;function x(K){return K.ownerDocument===te()}t.$sP=x;function te(){return(0,t.getWindowsCount)()<=1?document:Array.from((0,t.getWindows)()).map(({window:G})=>G.document).find(G=>G.hasFocus())??document}t.$tP=te;function ne(){return te().defaultView?.window??window}t.$uP=ne;function ge(K){const G=K;if(G?.ownerDocument?.defaultView)return G.ownerDocument.defaultView.window;const le=K;return le?.view?le.view.window:window}t.$vP=ge;function ve(K){const G=ge(K);G!==ne()&&G.focus()}t.$wP=ve;function Ce(K=document.head,G,le){const me=document.createElement("style");if(me.type="text/css",me.media="screen",G?.(me),K.appendChild(me),le&&le.add((0,m.$Pc)(()=>K.removeChild(me))),K===document.head)for(const{window:Ee,disposables:Le}of(0,t.getWindows)()){if(Ee===window)continue;const je=Le.add(Fe(me,Ee));le?.add(je)}return me}t.$xP=Ce;const Ae=new Map;function De(K){return Ae.has(K)}t.$yP=De;function Re(K){const G=new m.$Qc;for(const[le]of Ae)G.add(Fe(le,K));return G}t.$zP=Re;function Fe(K,G){const le=new m.$Qc,me=K.cloneNode(!0);G.document.head.appendChild(me),le.add((0,m.$Pc)(()=>G.document.head.removeChild(me)));for(const Le of Ke(K))me.sheet?.insertRule(Le.cssText,me.sheet?.cssRules.length);le.add(t.$AP.observe(K,le,{childList:!0})(()=>{me.textContent=K.textContent}));let Ee=Ae.get(K);return Ee||(Ee=new Set,Ae.set(K,Ee)),Ee.add(me),le.add((0,m.$Pc)(()=>Ee?.delete(me))),le}t.$AP=new class{constructor(){this.mutationObservers=new Map}observe(K,G,le){let me=this.mutationObservers.get(K);me||(me=new Map,this.mutationObservers.set(K,me));const Ee=(0,e.$Ei)(le);let Le=me.get(Ee);if(Le)Le.users+=1;else{const je=new u.$Nd,Ve=new MutationObserver(qe=>je.fire(qe));Ve.observe(K,le);const Xe=Le={users:1,observer:Ve,onDidMutate:je.event};G.add((0,m.$Pc)(()=>{Xe.users-=1,Xe.users===0&&(je.dispose(),Ve.disconnect(),me?.delete(Ee),me?.size===0&&this.mutationObservers.delete(K))})),me.set(Ee,Le)}return Le.onDidMutate}};function Qe(K=document.head){const G=document.createElement("meta");return K.appendChild(G),G}t.$BP=Qe;let ze=null;function Me(){return ze||(ze=Ce()),ze}function Ke(K){return K?.sheet?.rules?K.sheet.rules:K?.sheet?.cssRules?K.sheet.cssRules:[]}function J(K,G,le=Me()){if(!(!le||!G)){le.sheet?.insertRule(`${K} {${G}}`,0);for(const me of Ae.get(le)??[])J(K,G,me)}}t.$CP=J;function he(K,G=Me()){if(!G)return;const le=Ke(G),me=[];for(let Ee=0;Ee<le.length;Ee++){const Le=le[Ee];we(Le)&&Le.selectorText.indexOf(K)!==-1&&me.push(Ee)}for(let Ee=me.length-1;Ee>=0;Ee--)G.sheet?.deleteRule(me[Ee]);for(const Ee of Ae.get(G)??[])he(K,Ee)}t.$DP=he;function we(K){return typeof K.selectorText=="string"}function ye(K){return K instanceof MouseEvent||K instanceof ge(K).MouseEvent}t.$EP=ye;function Pe(K){return K instanceof KeyboardEvent||K instanceof ge(K).KeyboardEvent}t.$FP=Pe;function Be(K){return K instanceof PointerEvent||K instanceof ge(K).PointerEvent}t.$GP=Be;function Ue(K){return K instanceof DragEvent||K instanceof ge(K).DragEvent}t.$HP=Ue,t.$IP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.$AO?"webkitAnimationStart":"animationstart",ANIMATION_END:v.$AO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.$AO?"webkitAnimationIteration":"animationiteration"};function Ze(K){const G=K;return!!(G&&typeof G.preventDefault=="function"&&typeof G.stopPropagation=="function")}t.$JP=Ze,t.$KP={stop:(K,G)=>(K.preventDefault(),G&&K.stopPropagation(),K)};function Je(K){const G=[];for(let le=0;K&&K.nodeType===K.ELEMENT_NODE;le++)G[le]=K.scrollTop,K=K.parentNode;return G}t.$LP=Je;function xe(K,G){for(let le=0;K&&K.nodeType===K.ELEMENT_NODE;le++)K.scrollTop!==G[le]&&(K.scrollTop=G[le]),K=K.parentNode}t.$MP=xe;class We extends m.$Rc{static m(G){if(G instanceof HTMLElement){const le=R(G),me=le?le.activeElement:G.ownerDocument.activeElement;return Q(me,G)}else{const le=G;return Q(le.document.activeElement,le.document)}}constructor(G){super(),this.f=this.B(new u.$Nd),this.onDidFocus=this.f.event,this.g=this.B(new u.$Nd),this.onDidBlur=this.g.event;let le=We.m(G),me=!1;const Ee=()=>{me=!1,le||(le=!0,this.f.fire())},Le=()=>{le&&(me=!0,window.setTimeout(()=>{me&&(me=!1,le=!1,this.g.fire())},0))};this.j=()=>{We.m(G)!==le&&(le?Le():Ee())},this.B(n(G,t.$IP.FOCUS,Ee,!0)),this.B(n(G,t.$IP.BLUR,Le,!0)),G instanceof HTMLElement&&(this.B(n(G,t.$IP.FOCUS_IN,()=>this.j())),this.B(n(G,t.$IP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function tt(K){return new We(K)}t.$NP=tt;function nt(K,G){return K.after(G),G}t.$OP=nt;function dt(K,...G){if(K.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.$PP=dt;function ft(K,G){return K.insertBefore(G,K.firstChild),G}t.$QP=ft;function ct(K,...G){K.innerText="",dt(K,...G)}t.$RP=ct;const Ct=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var gt;(function(K){K.HTML="http://www.w3.org/1999/xhtml",K.SVG="http://www.w3.org/2000/svg"})(gt||(t.Namespace=gt={}));function vt(K,G,le,...me){const Ee=Ct.exec(G);if(!Ee)throw new Error("Bad use of emmet");const Le=Ee[1]||"div";let je;return K!==gt.HTML?je=document.createElementNS(K,Le):je=document.createElement(Le),Ee[3]&&(je.id=Ee[3]),Ee[4]&&(je.className=Ee[4].replace(/\./g," ").trim()),le&&Object.entries(le).forEach(([Ve,Xe])=>{typeof Xe>"u"||(/^on\w+$/.test(Ve)?je[Ve]=Xe:Ve==="selected"?Xe&&je.setAttribute(Ve,"true"):je.setAttribute(Ve,Xe))}),je.append(...me),je}function Dt(K,G,...le){return vt(gt.HTML,K,G,...le)}t.$=Dt,Dt.SVG=function(K,G,...le){return vt(gt.SVG,K,G,...le)};function Mt(K,G){const le=[];return K.forEach((me,Ee)=>{Ee>0&&(G instanceof Node?le.push(G.cloneNode()):le.push(document.createTextNode(G))),le.push(me)}),le}t.$TP=Mt;function Ie(K,...G){K?ce(...G):ke(...G)}t.$UP=Ie;function ce(...K){for(const G of K)G.style.display="",G.removeAttribute("aria-hidden")}t.$VP=ce;function ke(...K){for(const G of K)G.style.display="none",G.setAttribute("aria-hidden","true")}t.$WP=ke;function Ne(K,G){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K instanceof HTMLElement&&K.hasAttribute(G))return K;K=K.parentNode}return null}function _e(K){!K||!K.hasAttribute("tabIndex")||(K.ownerDocument.activeElement===K&&Ne(K.parentElement,"tabIndex")?.focus(),K.removeAttribute("tabindex"))}t.$XP=_e;function et(K){return G=>{G.preventDefault(),G.stopPropagation(),K(G)}}t.$YP=et;function rt(K){return new Promise(G=>{if(K.document.readyState==="complete"||K.document&&K.document.body!==null)G(void 0);else{const me=()=>{K.window.removeEventListener("DOMContentLoaded",me,!1),G()};K.window.addEventListener("DOMContentLoaded",me,!1)}})}t.$ZP=rt;function Ge(K,G){const le=K.devicePixelRatio*G;return Math.max(1,Math.floor(le))/K.devicePixelRatio}t.$1P=Ge;function at(K){window.open(K,"_blank","noopener")}t.$2P=at;const bt=780,yt=640;function Gt(K){const G=Math.floor(window.screenLeft+window.innerWidth/2-bt/2),le=Math.floor(window.screenTop+window.innerHeight/2-yt/2);window.open(K,"_blank",`width=${bt},height=${yt},top=${le},left=${G}`)}t.$3P=Gt;function yi(K,G=!0){const le=window.open();return le?(G&&(le.opener=null),le.location.href=K,!0):!1}t.$4P=yi;function Ei(K,G){const le=()=>{K(),me=(0,t.$2O)(le,G)};let me=(0,t.$2O)(le,G);return(0,m.$Pc)(()=>me.dispose())}t.$5P=Ei,O.$9f.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Ai(K){return K?`url('${O.$cg.uriToBrowserUri(K).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$6P=Ai;function ki(K){return`'${K.replace(/'/g,"%27")}'`}t.$7P=ki;function Xt(K,G){if(K!==void 0){const le=K.match(/^\s*var\((.+)\)$/);if(le){const me=le[1].split(",",2);return me.length===2&&(G=Xt(me[1].trim(),G)),`var(${me[0]}, ${G})`}return K}return G}t.$8P=Xt;function Si(K,G){let le;if(l.URI.isUri(K))le=K.toString(!0);else{const Ee=new Blob([K]);le=URL.createObjectURL(Ee),setTimeout(()=>URL.revokeObjectURL(le))}const me=document.createElement("a");document.body.appendChild(me),me.download=G,me.href=le,me.click(),setTimeout(()=>document.body.removeChild(me))}t.$9P=Si;function Ci(){return new Promise(K=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,u.Event.once(u.Event.fromDOMEventEmitter(G,"input"))(()=>{K(G.files??void 0)}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.$0P=Ci;var Et;(function(K){K[K.DOCUMENT=1]="DOCUMENT",K[K.BROWSER=2]="BROWSER"})(Et||(t.DetectedFullscreenMode=Et={}));function Pi(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:Et.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:Et.BROWSER,guess:!1}:(s.$k||s.$l)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:Et.BROWSER,guess:!0}:null}t.$$P=Pi;function Yt(K,G=!1){const le=document.createElement("a");return c.addHook("afterSanitizeAttributes",me=>{for(const Ee of["href","src"])if(me.hasAttribute(Ee)){const Le=me.getAttribute(Ee);if(Ee==="href"&&Le.startsWith("#"))continue;if(le.href=Le,!K.includes(le.protocol.replace(/:$/,""))){if(G&&Ee==="src"&&le.href.startsWith("data:"))continue;me.removeAttribute(Ee)}}}),(0,m.$Pc)(()=>{c.removeHook("afterSanitizeAttributes")})}t.$_P=Yt;const Ni=[O.Schemas.http,O.Schemas.https,O.Schemas.command];t.$aQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Fi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Ti(K,G){const le=Yt(Ni);try{const me=c.sanitize(G,Fi);K.innerHTML=me}finally{le.dispose()}}t.$bQ=Ti;function Oi(K){const G=new Uint16Array(K.length);for(let Ee=0;Ee<G.length;Ee++)G[Ee]=K.charCodeAt(Ee);let le="";const me=new Uint8Array(G.buffer);for(let Ee=0;Ee<me.length;Ee++)le+=String.fromCharCode(me[Ee]);return le}function Li(K){return btoa(Oi(K))}t.$cQ=Li;class $t extends u.$Nd{constructor(){super(),this.o=new m.$Qc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(u.Event.runAndSubscribe(t.onDidRegisterWindow,({window:G,disposables:le})=>this.B(G,le),{window,disposables:this.o}))}B(G,le){le.add(n(G,"keydown",me=>{if(me.defaultPrevented)return;const Ee=new i.$QO(me);if(!(Ee.keyCode===6&&me.repeat)){if(me.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(me.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(me.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(me.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(Ee.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=me.altKey,this.s.ctrlKey=me.ctrlKey,this.s.metaKey=me.metaKey,this.s.shiftKey=me.shiftKey,this.s.lastKeyPressed&&(this.s.event=me,this.fire(this.s))}},!0)),le.add(n(G,"keyup",me=>{me.defaultPrevented||(!me.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!me.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!me.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!me.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=me.altKey,this.s.ctrlKey=me.ctrlKey,this.s.metaKey=me.metaKey,this.s.shiftKey=me.shiftKey,this.s.lastKeyReleased&&(this.s.event=me,this.fire(this.s)))},!0)),le.add(n(G.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),le.add(n(G.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),le.add(n(G.document.body,"mousemove",me=>{me.buttons&&(this.s.lastKeyPressed=void 0)},!0)),le.add(n(G,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return $t.A||($t.A=new $t),$t.A}dispose(){super.dispose(),this.o.dispose()}}t.$dQ=$t;function Ii(K){const G=document.cookie.match("(^|[^;]+)\\s*"+K+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.$eQ=Ii;class Ri extends m.$Rc{constructor(G,le){super(),this.j=G,this.m=le,this.f=0,this.g=0,this.n()}n(){this.B(n(this.j,t.$IP.DRAG_ENTER,G=>{this.f++,this.g=G.timeStamp,this.m.onDragEnter(G)})),this.B(n(this.j,t.$IP.DRAG_OVER,G=>{G.preventDefault(),this.m.onDragOver?.(G,G.timeStamp-this.g)})),this.B(n(this.j,t.$IP.DRAG_LEAVE,G=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(G))})),this.B(n(this.j,t.$IP.DRAG_END,G=>{this.f=0,this.g=0,this.m.onDragEnd(G)})),this.B(n(this.j,t.$IP.DROP,G=>{this.f=0,this.g=0,this.m.onDrop(G)}))}}t.$fQ=Ri;const Mi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Bi(K,...G){let le,me;Array.isArray(G[0])?(le={},me=G[0]):(le=G[0]||{},me=G[1]);const Ee=Mi.exec(K);if(!Ee||!Ee.groups)throw new Error("Bad use of h");const Le=Ee.groups.tag||"div",je=document.createElement(Le);Ee.groups.id&&(je.id=Ee.groups.id);const Ve=[];if(Ee.groups.class)for(const qe of Ee.groups.class.split("."))qe!==""&&Ve.push(qe);if(le.className!==void 0)for(const qe of le.className.split("."))qe!==""&&Ve.push(qe);Ve.length>0&&(je.className=Ve.join(" "));const Xe={};if(Ee.groups.name&&(Xe[Ee.groups.name]=je),me)for(const qe of me)qe instanceof HTMLElement?je.appendChild(qe):typeof qe=="string"?je.append(qe):"root"in qe&&(Object.assign(Xe,qe),je.appendChild(qe.root));for(const[qe,st]of Object.entries(le))if(qe!=="className")if(qe==="style")for(const[Pt,Bt]of Object.entries(st))je.style.setProperty(Zt(Pt),typeof Bt=="number"?Bt+"px":""+Bt);else qe==="tabIndex"?je.tabIndex=st:je.setAttribute(Zt(qe),st.toString());return Xe.root=je,Xe}t.h=Bi;function Zt(K){return K.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function Jt(K,G){for(const{name:le,value:me}of K.attributes)G.setAttribute(le,me)}t.$hQ=Jt;function ji(K,G,le){const me=K.getAttribute(le);me?G.setAttribute(le,me):G.removeAttribute(le)}function zi(K,G,le){Jt(K,G);const me=new m.$Qc;return me.add(t.$AP.observe(K,me,{attributes:!0,attributeFilter:le})(Ee=>{for(const Le of Ee)Le.type==="attributes"&&Le.attributeName&&ji(K,G,Le.attributeName)})),me}t.$iQ=zi}),define($e[53],pe([1,0,3,2,114]),function(oe,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lQ=t.$kQ=t.$jQ=void 0;class U extends T.$Rc{constructor(u,c){super(),this.B((0,v.$TO)(u,"dragover",m=>{m.preventDefault(),this.a||(this.a=setTimeout(()=>{c(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(m=>{this.B((0,v.$TO)(u,m,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$jQ=U,t.$kQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Qr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(A,u,c,m,O){const s=document.createElement("div");if(s.className=c,s.textContent=u,O&&(s.style.color=O),m&&(s.style.background=m),A.dataTransfer){const l=(0,v.$vP)(A).document;l.body.appendChild(s),A.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>l.body.removeChild(s),0)}}t.$lQ=w}),define($e[54],pe([1,0,3]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PQ=t.$OQ=t.$NQ=void 0;function T(s,l={}){const e=U(l);return e.textContent=s,e}t.$NQ=T;function i(s,l={}){const e=U(l);return u(e,c(s,!!l.renderCodeSegments),l.actionHandler,l.renderCodeSegments),e}t.$OQ=i;function U(s){const l=s.inline?"span":"div",e=document.createElement(l);return s.className&&(e.className=s.className),e}t.$PQ=U;class w{constructor(l){this.b=l,this.c=0}eos(){return this.c>=this.b.length}next(){const l=this.peek();return this.advance(),l}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(A||(A={}));function u(s,l,e,a){let h;if(l.type===2)h=document.createTextNode(l.content||"");else if(l.type===3)h=document.createElement("b");else if(l.type===4)h=document.createElement("i");else if(l.type===7&&a)h=document.createElement("code");else if(l.type===5&&e){const g=document.createElement("a");e.disposables.add(v.$UO(g,"click",n=>{e.callback(String(l.index),n)})),h=g}else l.type===8?h=document.createElement("br"):l.type===1&&(h=s);h&&s!==h&&s.appendChild(h),h&&Array.isArray(l.children)&&l.children.forEach(g=>{u(h,g,e,a)})}function c(s,l){const e={type:1,children:[]};let a=0,h=e;const g=[],n=new w(s);for(;!n.eos();){let r=n.next();const b=r==="\\"&&O(n.peek(),l)!==0;if(b&&(r=n.next()),!b&&m(r,l)&&r===n.peek()){n.advance(),h.type===2&&(h=g.pop());const f=O(r,l);if(h.type===f||h.type===5&&f===6)h=g.pop();else{const o={type:f,children:[]};f===5&&(o.index=a,a++),h.children.push(o),g.push(h),h=o}}else if(r===`
`)h.type===2&&(h=g.pop()),h.children.push({type:8});else if(h.type!==2){const f={type:2,content:r};h.children.push(f),g.push(h),h=f}else h.content+=r}return h.type===2&&(h=g.pop()),g.length,e}function m(s,l){return O(s,l)!==0}function O(s,l){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return l?7:0;default:return 0}}}),define($e[55],pe([1,0,3,2]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pQ=void 0;class i{constructor(){this.a=new T.$Qc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(w,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const u=this.c;this.c=null,w&&u&&u(A)}isMonitoring(){return!!this.b}startMonitoring(w,A,u,c,m){this.isMonitoring()&&this.stopMonitoring(!1),this.b=c,this.c=m;let O=w;try{w.setPointerCapture(A),this.a.add((0,T.$Pc)(()=>{try{w.releasePointerCapture(A)}catch{}}))}catch{O=v.$vP(w)}this.a.add(v.$TO(O,v.$IP.POINTER_MOVE,s=>{if(s.buttons!==u){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(v.$TO(O,v.$IP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$pQ=i});var Ye=this&&this.__decorate||function(oe,t,v,T){var i=arguments.length,U=i<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,v):T,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(oe,t,v,T);else for(var A=oe.length-1;A>=0;A--)(w=oe[A])&&(U=(i<3?w(U):i>3?w(t,v,U):w(t,v))||U);return i>3&&U&&Object.defineProperty(t,v,U),U};define($e[23],pe([1,0,3,11,25,4,2,44]),function(oe,t,v,T,i,U,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mQ=t.EventType=void 0;var u;(function(m){m.Tap="-monaco-gesturetap",m.Change="-monaco-gesturechange",m.Start="-monaco-gesturestart",m.End="-monaco-gesturesend",m.Contextmenu="-monaco-gesturecontextmenu"})(u||(t.EventType=u={}));class c extends w.$Rc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new A.$1c,this.h=new A.$1c,this.m={},this.j=null,this.n=0,this.B(U.Event.runAndSubscribe(v.onDidRegisterWindow,({window:O,disposables:s})=>{s.add(v.$TO(O.document,"touchstart",l=>this.s(l),{passive:!1})),s.add(v.$TO(O.document,"touchend",l=>this.u(O,l))),s.add(v.$TO(O.document,"touchmove",l=>this.D(l),{passive:!1}))},{window,disposables:this.q}))}static addTarget(O){if(!c.isTouchDevice())return w.$Rc.None;c.b||(c.b=(0,w.$Kc)(new c));const s=c.b.g.push(O);return(0,w.$Pc)(s)}static ignoreTarget(O){if(!c.isTouchDevice())return w.$Rc.None;c.b||(c.b=(0,w.$Kc)(new c));const s=c.b.h.push(O);return(0,w.$Pc)(s)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(O){const s=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let l=0,e=O.targetTouches.length;l<e;l++){const a=O.targetTouches.item(l);this.m[a.identifier]={id:a.identifier,initialTarget:a.target,initialTimeStamp:s,initialPageX:a.pageX,initialPageY:a.pageY,rollingTimestamps:[s],rollingPageX:[a.pageX],rollingPageY:[a.pageY]};const h=this.w(u.Start,a.target);h.pageX=a.pageX,h.pageY=a.pageY,this.z(h)}this.f&&(O.preventDefault(),O.stopPropagation(),this.f=!1)}u(O,s){const l=Date.now(),e=Object.keys(this.m).length;for(let a=0,h=s.changedTouches.length;a<h;a++){const g=s.changedTouches.item(a);if(!this.m.hasOwnProperty(String(g.identifier))){console.warn("move of an UNKNOWN touch",g);continue}const n=this.m[g.identifier],r=Date.now()-n.initialTimeStamp;if(r<c.c&&Math.abs(n.initialPageX-T.$rb(n.rollingPageX))<30&&Math.abs(n.initialPageY-T.$rb(n.rollingPageY))<30){const b=this.w(u.Tap,n.initialTarget);b.pageX=T.$rb(n.rollingPageX),b.pageY=T.$rb(n.rollingPageY),this.z(b)}else if(r>=c.c&&Math.abs(n.initialPageX-T.$rb(n.rollingPageX))<30&&Math.abs(n.initialPageY-T.$rb(n.rollingPageY))<30){const b=this.w(u.Contextmenu,n.initialTarget);b.pageX=T.$rb(n.rollingPageX),b.pageY=T.$rb(n.rollingPageY),this.z(b)}else if(e===1){const b=T.$rb(n.rollingPageX),f=T.$rb(n.rollingPageY),o=T.$rb(n.rollingTimestamps)-n.rollingTimestamps[0],F=b-n.rollingPageX[0],j=f-n.rollingPageY[0],L=[...this.g].filter(d=>n.initialTarget instanceof Node&&d.contains(n.initialTarget));this.C(O,L,l,Math.abs(F)/o,F>0?1:-1,b,Math.abs(j)/o,j>0?1:-1,f)}this.z(this.w(u.End,n.initialTarget)),delete this.m[g.identifier]}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}w(O,s){const l=document.createEvent("CustomEvent");return l.initEvent(O,!1,!0),l.initialTarget=s,l.tapCount=0,l}z(O){if(O.type===u.Tap){const s=new Date().getTime();let l=0;s-this.n>c.r?l=1:l=2,this.n=s,O.tapCount=l}else(O.type===u.Change||O.type===u.Contextmenu)&&(this.n=0);if(O.initialTarget instanceof Node){for(const s of this.h)if(s.contains(O.initialTarget))return;for(const s of this.g)s.contains(O.initialTarget)&&(s.dispatchEvent(O),this.f=!0)}}C(O,s,l,e,a,h,g,n,r){this.j=v.$2O(()=>{const b=Date.now(),f=b-l;let o=0,F=0,j=!0;e+=c.a*f,g+=c.a*f,e>0&&(j=!1,o=a*e*f),g>0&&(j=!1,F=n*g*f);const L=this.w(u.Change);L.translationX=o,L.translationY=F,s.forEach(d=>d.dispatchEvent(L)),j||this.C(O,s,b,e,a,h+o,g,n,r+F)},O)}D(O){const s=Date.now();for(let l=0,e=O.changedTouches.length;l<e;l++){const a=O.changedTouches.item(l);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("end of an UNKNOWN touch",a);continue}const h=this.m[a.identifier],g=this.w(u.Change,h.initialTarget);g.translationX=a.pageX-T.$rb(h.rollingPageX),g.translationY=a.pageY-T.$rb(h.rollingPageY),g.pageX=a.pageX,g.pageY=a.pageY,this.z(g),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(a.pageX),h.rollingPageY.push(a.pageY),h.rollingTimestamps.push(s)}this.f&&(O.preventDefault(),O.stopPropagation(),this.f=!1)}}t.$mQ=c,Ye([i.$ih],c,"isTouchDevice",null)}),define($e[56],pe([1,0,3,89]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=t.$SQ=t.$RQ=void 0;const T=2e4;let i,U,w,A,u;function c(l){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const h=document.createElement("div");return h.className="monaco-alert",h.setAttribute("role","alert"),h.setAttribute("aria-atomic","true"),i.appendChild(h),h};U=e(),w=e();const a=()=>{const h=document.createElement("div");return h.className="monaco-status",h.setAttribute("aria-live","polite"),h.setAttribute("aria-atomic","true"),i.appendChild(h),h};A=a(),u=a(),l.appendChild(i)}t.$RQ=c;function m(l){i&&(U.textContent!==l?(v.$SO(w),s(U,l)):(v.$SO(U),s(w,l)))}t.$SQ=m;function O(l){i&&(A.textContent!==l?(v.$SO(u),s(A,l)):(v.$SO(A),s(u,l)))}t.$TQ=O;function s(l,e){v.$SO(l),e.length>T&&(e=e.substr(0,T)),l.textContent=e,l.style.visibility="hidden",l.style.visibility="visible"}}),define($e[116],pe([1,0,3,18]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=t.$fR=void 0;const i=new RegExp(`(\\\\)?\\$\\((${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(A){const u=new Array;let c,m=0,O=0;for(;(c=i.exec(A))!==null;){O=c.index||0,m<O&&u.push(A.substring(m,O)),m=(c.index||0)+c[0].length;const[,s,l]=c;u.push(s?`$(${l})`:w({id:l}))}return m<A.length&&u.push(A.substring(m)),u}t.$fR=U;function w(A){const u=v.$("span");return u.classList.add(...T.ThemeIcon.asClassNameArray(A)),u}t.$gR=w}),define($e[117],pe([1,0,3]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=void 0;function T(U){try{U.parentElement?.removeChild(U)}catch{}}class i{constructor(w){this.d=w,this.a=new Map,this.b=new Set,this.c=!1}alloc(w){let A=this.h(w).pop(),u=!1;if(A)u=this.b.has(A.domNode),u&&this.b.delete(A.domNode);else{const c=(0,v.$)(".monaco-list-row"),O=this.i(w).renderTemplate(c);A={domNode:c,templateId:w,templateData:O}}return{row:A,isReusingConnectedDomNode:u}}release(w){w&&this.f(w)}transact(w){if(this.c)throw new Error("Already in transaction");this.c=!0;try{w()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(w){const{domNode:A,templateId:u}=w;A&&(this.c?this.b.add(A):this.g(A)),this.h(u).push(w)}g(w){w.classList.remove("scrolling"),T(w)}h(w){let A=this.a.get(w);return A||(A=[],this.a.set(w,A)),A}dispose(){this.a.forEach((w,A)=>{for(const u of w)this.i(A).disposeTemplate(u.templateData),u.templateData=null}),this.a.clear(),this.b.clear()}i(w){const A=this.d.get(w);if(!A)throw new Error(`No renderer found for ${w}`);return A}}t.$3Q=i}),define($e[118],pe([1,0,9,2]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uQ=void 0;class i extends T.$Rc{constructor(w,A,u){super(),this.a=w,this.b=A,this.c=u,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new v.$5g)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$uQ=i}),define($e[119],pe([1,0,3,23,11,4,2,5]),function(oe,t,v,T,i,U,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nR=void 0;class u extends w.$Rc{constructor(m,O,s,l){super(),this.f=0,this.b=l||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Nd),this.h=s,this.j(),this.setOptions(m,O)}j(){this.B(T.$mQ.addTarget(this.a)),[T.EventType.Tap].forEach(m=>{this.B(v.$TO(this.a,m,O=>{this.a.focus()}))}),this.B(v.$UO(this.a,"click",m=>{v.$KP.stop(m,!0)})),this.B(v.$UO(this.a,"change",m=>{this.a.title=m.target.value,this.g.fire({index:m.target.selectedIndex,selected:m.target.value})})),this.B(v.$UO(this.a,"keydown",m=>{let O=!1;A.$k?(m.keyCode===18||m.keyCode===16||m.keyCode===10)&&(O=!0):(m.keyCode===18&&m.altKey||m.keyCode===10||m.keyCode===3)&&(O=!0),O&&m.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(m,O){(!this.c||!i.$tb(this.c,m))&&(this.c=m,this.a.options.length=0,this.c.forEach((s,l)=>{this.a.add(this.m(s.text,l,s.isDisabled))})),O!==void 0&&this.select(O)}select(m){this.c.length===0?this.f=0:m>=0&&m<this.c.length?this.f=m:m>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(m){this.b.ariaLabel=m,this.a.setAttribute("aria-label",m)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(m){this.a.tabIndex=m?0:-1}render(m){m.classList.add("select-container"),m.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(m){this.h=m,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(m,O,s){const l=document.createElement("option");return l.value=m,l.text=m,l.disabled=!!s,l}}t.$nR=u}),define($e[57],pe([1,0,24,11,9,49,85,4,26]),function(oe,t,v,T,i,U,w,A,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$US=t.$TS=t.$SS=void 0;function c(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.$SS=c;function m(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.$TS=m;function O(l){return typeof l.collapsible=="boolean"}class s{constructor(e,a,h,g={}){this.o=e,this.p=a,this.rootRef=[],this.d=new A.$Vd,this.f=new A.$Nd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.$Nd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new A.$Nd,this.onDidSplice=this.l.event,this.m=new i.$Qg(U.$Kd),this.h=typeof g.collapseByDefault>"u"?!1:g.collapseByDefault,this.j=g.filter,this.k=typeof g.autoExpandSingleChildren>"u"?!1:g.autoExpandSingleChildren,this.c={parent:void 0,element:h,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,a,h=u.Iterable.empty(),g={}){if(e.length===0)throw new v.$QS(this.o,"Invalid tree location");g.diffIdentityProvider?this.q(g.diffIdentityProvider,e,a,h,g):this.s(e,a,h,g)}q(e,a,h,g=u.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:b}=this.G(a);if(!b.lastDiffIds)return this.s(a,h,g,n);const f=[...g],o=a[a.length-1],F=new w.$As({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,o),...f,...b.children.slice(o+h)].map(B=>e.getId(B.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return b.lastDiffIds=void 0,this.s(a,h,f,n);const j=a.slice(0,-1),L=(B,z,_)=>{if(r>0)for(let I=0;I<_;I++)B--,z--,this.q(e,[...j,B,0],Number.MAX_SAFE_INTEGER,f[z].children,n,r-1)};let d=Math.min(b.children.length,o+h),D=f.length;for(const B of F.changes.sort((z,_)=>_.originalStart-z.originalStart))L(d,D,d-(B.originalStart+B.originalLength)),d=B.originalStart,D=B.modifiedStart-o,this.s([...j,d],B.originalLength,u.Iterable.slice(f,D,D+B.modifiedLength),n);L(d,D,d)}s(e,a,h=u.Iterable.empty(),{onDidCreateNode:g,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:b,listIndex:f,revealed:o,visible:F}=this.G(e),j=[],L=u.Iterable.map(h,ae=>this.w(ae,b,b.visible?1:0,o,j,g)),d=e[e.length-1],D=b.children.length>0;let B=0;for(let ae=d;ae>=0&&ae<b.children.length;ae--){const se=b.children[ae];if(se.visible){B=se.visibleChildIndex;break}}const z=[];let _=0,I=0;for(const ae of L)z.push(ae),I+=ae.renderNodeCount,ae.visible&&(ae.visibleChildIndex=B+_++);const N=(0,T.$5b)(b.children,d,a,z);r?b.lastDiffIds?(0,T.$5b)(b.lastDiffIds,d,a,z.map(ae=>r.getId(ae.element).toString())):b.lastDiffIds=b.children.map(ae=>r.getId(ae.element).toString()):b.lastDiffIds=void 0;let Z=0;for(const ae of N)ae.visible&&Z++;if(Z!==0)for(let ae=d+z.length;ae<b.children.length;ae++){const se=b.children[ae];se.visible&&(se.visibleChildIndex-=Z)}if(b.visibleChildrenCount+=_-Z,o&&F){const ae=N.reduce((se,re)=>se+(re.visible?re.renderNodeCount:0),0);this.B(b,I-ae),this.p.splice(f,ae,j)}if(N.length>0&&n){const ae=se=>{n(se),se.children.forEach(ae)};N.forEach(ae)}this.l.fire({insertedNodes:z,deletedNodes:N});const ee=b.children.length>0;D!==ee&&this.setCollapsible(e.slice(0,-1),ee);let ue=b;for(;ue;){if(ue.visibility===2){this.m.trigger(()=>this.refilter());break}ue=ue.parent}}rerender(e){if(e.length===0)throw new v.$QS(this.o,"Invalid tree location");const{node:a,listIndex:h,revealed:g}=this.F(e);a.visible&&g&&this.p.splice(h,1,[a])}updateElementHeight(e,a){if(e.length===0)throw new v.$QS(this.o,"Invalid tree location");const{listIndex:h}=this.F(e);this.p.updateElementHeight(h,a)}has(e){return this.D(e)}getListIndex(e){const{listIndex:a,visible:h,revealed:g}=this.F(e);return h&&g?a:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,a){const h=this.E(e);typeof a>"u"&&(a=!h.collapsible);const g={collapsible:a};return this.d.bufferEvents(()=>this.t(e,g))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,a,h){const g=this.E(e);typeof a>"u"&&(a=!g.collapsed);const n={collapsed:a,recursive:h||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,a){const{node:h,listIndex:g,revealed:n}=this.F(e),r=this.u(h,g,n,a);if(h!==this.c&&this.k&&r&&!O(a)&&h.collapsible&&!h.collapsed&&!a.recursive){let b=-1;for(let f=0;f<h.children.length;f++)if(h.children[f].visible)if(b>-1){b=-1;break}else b=f;b>-1&&this.t([...e,b],a)}return r}u(e,a,h,g){const n=this.v(e,g,!1);if(!h||!e.visible||!n)return n;const r=e.renderNodeCount,b=this.x(e),f=r-(a===-1?0:1);return this.p.splice(a+1,f,b.slice(1)),n}v(e,a,h){let g;if(e===this.c?g=!1:(O(a)?(g=e.collapsible!==a.collapsible,e.collapsible=a.collapsible):e.collapsible?(g=e.collapsed!==a.collapsed,e.collapsed=a.collapsed):g=!1,g&&this.f.fire({node:e,deep:h})),!O(a)&&a.recursive)for(const n of e.children)g=this.v(n,a,!0)||g;return g}expandTo(e){this.d.bufferEvents(()=>{let a=this.E(e);for(;a.parent;)a=a.parent,e=e.slice(0,e.length-1),a.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,a=this.z(this.c);this.p.splice(0,e,a),this.m.cancel()}w(e,a,h,g,n,r){const b={parent:a,element:e.element,children:[],depth:a.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},f=this.C(b,h);b.visibility=f,g&&n.push(b);const o=e.children||u.Iterable.empty(),F=g&&f!==0&&!b.collapsed;let j=0,L=1;for(const d of o){const D=this.w(d,b,f,F,n,r);b.children.push(D),L+=D.renderNodeCount,D.visible&&(D.visibleChildIndex=j++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=j,b.visible=f===2?j>0:f===1,b.visible?b.collapsed||(b.renderNodeCount=L):(b.renderNodeCount=0,g&&n.pop()),r?.(b),b}x(e){const a=e.renderNodeCount,h=[];return this.y(e,h),this.B(e.parent,h.length-a),h}y(e,a){if(e.visible===!1)return 0;if(a.push(e),e.renderNodeCount=1,!e.collapsed)for(const h of e.children)e.renderNodeCount+=this.y(h,a);return this.g.fire(e),e.renderNodeCount}z(e){const a=e.renderNodeCount,h=[];return this.A(e,e.visible?1:0,h),this.B(e.parent,h.length-a),h}A(e,a,h,g=!0){let n;if(e!==this.c){if(n=this.C(e,a),n===0)return e.visible=!1,e.renderNodeCount=0,!1;g&&h.push(e)}const r=h.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||n!==0){let f=0;for(const o of e.children)b=this.A(o,n,h,g&&!e.collapsed)||b,o.visible&&(o.visibleChildIndex=f++);e.visibleChildrenCount=f}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?b:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=h.length-r):(e.renderNodeCount=0,g&&h.pop()),this.g.fire(e),e.visible}B(e,a){if(a!==0)for(;e;)e.renderNodeCount+=a,this.g.fire(e),e=e.parent}C(e,a){const h=this.j?this.j.filter(e.element,a):1;return typeof h=="boolean"?(e.filterData=void 0,h?1:0):c(h)?(e.filterData=h.data,m(h.visibility)):(e.filterData=void 0,m(h))}D(e,a=this.c){if(!e||e.length===0)return!0;const[h,...g]=e;return h<0||h>a.children.length?!1:this.D(g,a.children[h])}E(e,a=this.c){if(!e||e.length===0)return a;const[h,...g]=e;if(h<0||h>a.children.length)throw new v.$QS(this.o,"Invalid tree location");return this.E(g,a.children[h])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:a,listIndex:h,revealed:g,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>a.children.length)throw new v.$QS(this.o,"Invalid tree location");const b=a.children[r];return{node:b,listIndex:h,revealed:g,visible:n&&b.visible}}G(e,a=this.c,h=0,g=!0,n=!0){const[r,...b]=e;if(r<0||r>a.children.length)throw new v.$QS(this.o,"Invalid tree location");for(let f=0;f<r;f++)h+=a.children[f].renderNodeCount;return g=g&&!a.collapsed,n=n&&a.visible,b.length===0?{parentNode:a,listIndex:h,revealed:g,visible:n}:this.G(b,a.children[r],h+1,g,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const a=[];let h=e;for(;h.parent;)a.push(h.parent.children.indexOf(h)),h=h.parent;return a.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,T.$sb)(e)[0]}getFirstElementChild(e){const a=this.E(e);if(a.children.length!==0)return a.children[0].element}getLastElementAncestor(e=[]){const a=this.E(e);if(a.children.length!==0)return this.H(a)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$US=s}),define($e[120],pe([1,0,57,24,26]),function(oe,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1S=void 0;class U{get size(){return this.d.size}constructor(A,u,c={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.$US(A,u,null,c),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,c.sorter&&(this.j={compare(m,O){return c.sorter.compare(m.element,O.element)}}),this.h=c.identityProvider}setChildren(A,u=i.Iterable.empty(),c={}){const m=this.o(A);this.l(m,this.m(u),c)}l(A,u=i.Iterable.empty(),c){const m=new Set,O=new Set,s=e=>{if(e.element===null)return;const a=e;if(m.add(a.element),this.d.set(a.element,a),this.h){const h=this.h.getId(a.element).toString();O.add(h),this.f.set(h,a)}c.onDidCreateNode?.(a)},l=e=>{if(e.element===null)return;const a=e;if(m.has(a.element)||this.d.delete(a.element),this.h){const h=this.h.getId(a.element).toString();O.has(h)||this.f.delete(h)}c.onDidDeleteNode?.(a)};this.c.splice([...A,0],Number.MAX_VALUE,u,{...c,onDidCreateNode:s,onDidDeleteNode:l})}m(A=i.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),i.Iterable.map(A,u=>{let c=this.d.get(u.element);if(!c&&this.h){const s=this.h.getId(u.element).toString();c=this.f.get(s)}if(!c){let s;return typeof u.collapsed>"u"?s=void 0:u.collapsed===T.ObjectTreeElementCollapseState.Collapsed||u.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:u.collapsed===T.ObjectTreeElementCollapseState.Expanded||u.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!u.collapsed,{...u,children:this.m(u.children),collapsed:s}}const m=typeof u.collapsible=="boolean"?u.collapsible:c.collapsible;let O;return typeof u.collapsed>"u"||u.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed||u.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?O=c.collapsed:u.collapsed===T.ObjectTreeElementCollapseState.Collapsed?O=!0:u.collapsed===T.ObjectTreeElementCollapseState.Expanded?O=!1:O=!!u.collapsed,{...u,collapsible:m,collapsed:O,children:this.m(u.children)}})}rerender(A){const u=this.o(A);this.c.rerender(u)}updateElementHeight(A,u){const c=this.o(A);this.c.updateElementHeight(c,u)}resort(A=null,u=!0){if(!this.j)return;const c=this.o(A),m=this.c.getNode(c);this.l(c,this.n(m,u),{})}n(A,u,c=!0){let m=[...A.children];return(u||c)&&(m=m.sort(this.j.compare.bind(this.j))),i.Iterable.map(m,O=>({element:O.element,collapsible:O.collapsible,collapsed:O.collapsed,children:this.n(O,u,!1)}))}getFirstElementChild(A=null){const u=this.o(A);return this.c.getFirstElementChild(u)}getLastElementAncestor(A=null){const u=this.o(A);return this.c.getLastElementAncestor(u)}has(A){return this.d.has(A)}getListIndex(A){const u=this.o(A);return this.c.getListIndex(u)}getListRenderCount(A){const u=this.o(A);return this.c.getListRenderCount(u)}isCollapsible(A){const u=this.o(A);return this.c.isCollapsible(u)}setCollapsible(A,u){const c=this.o(A);return this.c.setCollapsible(c,u)}isCollapsed(A){const u=this.o(A);return this.c.isCollapsed(u)}setCollapsed(A,u,c){const m=this.o(A);return this.c.setCollapsed(m,u,c)}expandTo(A){const u=this.o(A);this.c.expandTo(u)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const u=this.d.get(A);if(!u)throw new T.$QS(this.k,`Tree element not found: ${A}`);return u}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new T.$QS(this.k,"Invalid getParentNodeLocation call");const u=this.d.get(A);if(!u)throw new T.$QS(this.k,`Tree element not found: ${A}`);const c=this.c.getNodeLocation(u),m=this.c.getParentNodeLocation(c);return this.c.getNode(m).element}o(A){if(A===null)return[];const u=this.d.get(A);if(!u)throw new T.$QS(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(u)}}t.$1S=U}),define($e[20],pe([1,0,3,14,19,23,2]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qQ=void 0;class A extends w.$Rc{f(c,m){this.B(v.$TO(c,v.$IP.CLICK,O=>m(new i.$LO(O))))}j(c,m){this.B(v.$TO(c,v.$IP.MOUSE_DOWN,O=>m(new i.$LO(O))))}m(c,m){this.B(v.$TO(c,v.$IP.MOUSE_OVER,O=>m(new i.$LO(O))))}u(c,m){this.B(v.$TO(c,v.$IP.MOUSE_LEAVE,O=>m(new i.$LO(O))))}z(c,m){this.B(v.$TO(c,v.$IP.KEY_DOWN,O=>m(new T.$QO(O))))}C(c,m){this.B(v.$TO(c,v.$IP.KEY_UP,O=>m(new T.$QO(O))))}D(c,m){this.B(v.$TO(c,v.$IP.INPUT,m))}F(c,m){this.B(v.$TO(c,v.$IP.BLUR,m))}G(c,m){this.B(v.$TO(c,v.$IP.FOCUS,m))}H(c,m){this.B(v.$TO(c,v.$IP.CHANGE,m))}I(c){return U.$mQ.ignoreTarget(c)}}t.$qQ=A}),define($e[37],pe([1,0,55,20,9,18,3]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sQ=t.$rQ=void 0,t.$rQ=11;class A extends T.$qQ{constructor(c){super(),this.a=c.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=c.bgWidth+"px",this.bgDomNode.style.height=c.bgHeight+"px",typeof c.top<"u"&&(this.bgDomNode.style.top="0px"),typeof c.left<"u"&&(this.bgDomNode.style.left="0px"),typeof c.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof c.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=c.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(c.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$rQ+"px",this.domNode.style.height=t.$rQ+"px",typeof c.top<"u"&&(this.domNode.style.top=c.top+"px"),typeof c.left<"u"&&(this.domNode.style.left=c.left+"px"),typeof c.bottom<"u"&&(this.domNode.style.bottom=c.bottom+"px"),typeof c.right<"u"&&(this.domNode.style.right=c.right+"px"),this.g=this.B(new v.$pQ),this.B(w.$UO(this.bgDomNode,w.$IP.POINTER_DOWN,m=>this.h(m))),this.B(w.$UO(this.domNode,w.$IP.POINTER_DOWN,m=>this.h(m))),this.b=this.B(new i.$6g),this.c=this.B(new i.$5g)}h(c){if(!c.target||!(c.target instanceof Element))return;const m=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(m,200),this.g.startMonitoring(c.target,c.pointerId,c.buttons,O=>{},()=>{this.b.cancel(),this.c.cancel()}),c.preventDefault()}}t.$sQ=A}),define($e[58],pe([1,0,3,40,55,37,118,20,5]),function(oe,t,v,T,i,U,w,A,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vQ=void 0;const c=140;class m extends A.$qQ{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new w.$uQ(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$pQ),this.s=!0,this.domNode=(0,T.$oQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.$TO(this.domNode.domNode,v.$IP.POINTER_DOWN,l=>this.M(l)))}t(s){const l=this.B(new U.$sQ(s));this.domNode.domNode.appendChild(l.bgDomNode),this.domNode.domNode.appendChild(l.domNode)}w(s,l,e,a){this.slider=(0,T.$oQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(l),typeof e=="number"&&this.slider.setWidth(e),typeof a=="number"&&this.slider.setHeight(a),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.$TO(this.slider.domNode,v.$IP.POINTER_DOWN,h=>{h.button===0&&(h.preventDefault(),this.O(h))})),this.f(this.slider.domNode,h=>{h.leftButton&&h.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const l=this.domNode.domNode.getClientRects()[0].top,e=l+this.h.getSliderPosition(),a=l+this.h.getSliderPosition()+this.h.getSliderSize(),h=this.U(s);e<=h&&h<=a?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let l,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")l=s.offsetX,e=s.offsetY;else{const h=v.$_O(this.domNode.domNode);l=s.pageX-h.left,e=s.pageY-h.top}const a=this.S(l,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(a):this.h.getDesiredScrollPositionFromOffset(a)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const l=this.U(s),e=this.W(s),a=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,h=>{const g=this.W(h),n=Math.abs(g-e);if(u.$j&&n>c){this.P(a.getScrollPosition());return}const b=this.U(h)-l;this.P(a.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const l={};this.writeScrollPosition(l,s),this.b.setScrollPositionNow(l)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$vQ=m}),define($e[121],pe([1,0,19,58,37,41,17]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wQ=void 0;class A extends T.$vQ{constructor(c,m,O){const s=c.getScrollDimensions(),l=c.getCurrentScrollPosition();if(super({lazyRender:m.lazyRender,host:O,scrollbarState:new U.$tQ(m.horizontalHasArrows?m.arrowSize:0,m.horizontal===2?0:m.horizontalScrollbarSize,m.vertical===2?0:m.verticalScrollbarSize,s.width,s.scrollWidth,l.scrollLeft),visibility:m.horizontal,extraScrollbarClassName:"horizontal",scrollable:c,scrollByPage:m.scrollByPage}),m.horizontalHasArrows){const e=(m.arrowSize-i.$rQ)/2,a=(m.horizontalScrollbarSize-i.$rQ)/2;this.t({className:"scra",icon:w.$Vj.scrollbarButtonLeft,top:a,left:e,bottom:void 0,right:void 0,bgWidth:m.arrowSize,bgHeight:m.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$NO(null,1,0))}),this.t({className:"scra",icon:w.$Vj.scrollbarButtonRight,top:a,left:void 0,bottom:void 0,right:e,bgWidth:m.arrowSize,bgHeight:m.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$NO(null,-1,0))})}this.w(Math.floor((m.horizontalScrollbarSize-m.horizontalSliderSize)/2),0,void 0,m.horizontalSliderSize)}R(c,m){this.slider.setWidth(c),this.slider.setLeft(m)}Q(c,m){this.domNode.setWidth(c),this.domNode.setHeight(m),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(c){return this.s=this.J(c.scrollWidth)||this.s,this.s=this.L(c.scrollLeft)||this.s,this.s=this.y(c.width)||this.s,this.s}S(c,m){return c}U(c){return c.pageX}W(c){return c.pageY}X(c){this.slider.setHeight(c)}writeScrollPosition(c,m){c.scrollLeft=m}updateOptions(c){this.updateScrollbarSize(c.horizontal===2?0:c.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(c.vertical===2?0:c.verticalScrollbarSize),this.n.setVisibility(c.horizontal),this.c=c.scrollByPage}}t.$wQ=A}),define($e[122],pe([1,0,19,58,37,41,17]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xQ=void 0;class A extends T.$vQ{constructor(c,m,O){const s=c.getScrollDimensions(),l=c.getCurrentScrollPosition();if(super({lazyRender:m.lazyRender,host:O,scrollbarState:new U.$tQ(m.verticalHasArrows?m.arrowSize:0,m.vertical===2?0:m.verticalScrollbarSize,0,s.height,s.scrollHeight,l.scrollTop),visibility:m.vertical,extraScrollbarClassName:"vertical",scrollable:c,scrollByPage:m.scrollByPage}),m.verticalHasArrows){const e=(m.arrowSize-i.$rQ)/2,a=(m.verticalScrollbarSize-i.$rQ)/2;this.t({className:"scra",icon:w.$Vj.scrollbarButtonUp,top:e,left:a,bottom:void 0,right:void 0,bgWidth:m.verticalScrollbarSize,bgHeight:m.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$NO(null,0,1))}),this.t({className:"scra",icon:w.$Vj.scrollbarButtonDown,top:void 0,left:a,bottom:e,right:void 0,bgWidth:m.verticalScrollbarSize,bgHeight:m.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$NO(null,0,-1))})}this.w(0,Math.floor((m.verticalScrollbarSize-m.verticalSliderSize)/2),m.verticalSliderSize,void 0)}R(c,m){this.slider.setHeight(c),this.slider.setTop(m)}Q(c,m){this.domNode.setWidth(m),this.domNode.setHeight(c),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(c){return this.s=this.J(c.scrollHeight)||this.s,this.s=this.L(c.scrollTop)||this.s,this.s=this.y(c.height)||this.s,this.s}S(c,m){return m}U(c){return c.pageY}W(c){return c.pageX}X(c){this.slider.setWidth(c)}writeScrollPosition(c,m){c.scrollTop=m}updateOptions(c){this.updateScrollbarSize(c.vertical===2?0:c.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(c.vertical),this.c=c.scrollByPage}}t.$xQ=A}),define($e[59],pe([1,0,16,3,40,19,121,122,20,9,4,2,5,47,96]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CQ=t.$BQ=t.$AQ=t.$zQ=t.$yQ=void 0;const e=500,a=50,h=!0;class g{constructor(L,d,D){this.timestamp=L,this.deltaX=d,this.deltaY=D,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let L=1,d=0,D=1,B=this.d;do{const z=B===this.c?L:Math.pow(2,-D);if(L-=z,d+=this.b[B].score*z,B===this.c)break;B=(this.a+B-1)%this.a,D++}while(!0);return d<=.5}acceptStandardWheelEvent(L){const d=T.$vP(L.browserEvent).devicePixelRatio/(0,v.$uO)();s.$j||s.$l?this.accept(Date.now(),L.deltaX/d,L.deltaY/d):this.accept(Date.now(),L.deltaX,L.deltaY)}accept(L,d,D){const B=new g(L,d,D);B.score=this.f(B),this.c===-1&&this.d===-1?(this.b[0]=B,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=B)}f(L){if(Math.abs(L.deltaX)>0&&Math.abs(L.deltaY)>0)return 1;let d=.5;const D=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(L.deltaX)||!this.g(L.deltaY))&&(d+=.25),Math.min(Math.max(d,0),1)}g(L){return Math.abs(Math.round(L)-L)<.01}}t.$yQ=n;class r extends u.$qQ{get options(){return this.a}constructor(L,d,D){super(),this.O=this.B(new m.$Nd),this.onScroll=this.O.event,this.P=this.B(new m.$Nd),this.onWillScroll=this.P.event,L.style.overflow="hidden",this.a=F(d),this.b=D,this.B(this.b.onScroll(z=>{this.P.fire(z),this.S(z),this.O.fire(z)}));const B={onMouseWheel:z=>this.R(z),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new A.$xQ(this.b,this.a,B)),this.g=this.B(new w.$wQ(this.b,this.a,B)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(L),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$oQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$oQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$oQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,z=>this.Z(z)),this.u(this.t,z=>this.Y(z)),this.L=this.B(new c.$5g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,O.$Mc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(L){this.c.delegatePointerDown(L)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(L){this.b.setScrollDimensions(L,!1)}updateClassName(L){this.a.className=L,s.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(L){typeof L.handleMouseWheel<"u"&&(this.a.handleMouseWheel=L.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof L.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=L.mouseWheelScrollSensitivity),typeof L.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=L.fastScrollSensitivity),typeof L.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=L.scrollPredominantAxis),typeof L.horizontal<"u"&&(this.a.horizontal=L.horizontal),typeof L.vertical<"u"&&(this.a.vertical=L.vertical),typeof L.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=L.horizontalScrollbarSize),typeof L.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=L.verticalScrollbarSize),typeof L.scrollByPage<"u"&&(this.a.scrollByPage=L.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(L){this.N=L}delegateScrollFromMouseWheelEvent(L){this.R(new U.$NO(L))}Q(L){if(this.w.length>0!==L&&(this.w=(0,O.$Mc)(this.w),L)){const D=B=>{this.R(new U.$NO(B))};this.w.push(T.$TO(this.t,T.$IP.MOUSE_WHEEL,D,{passive:!1}))}}R(L){if(L.browserEvent?.defaultPrevented)return;const d=n.INSTANCE;h&&d.acceptStandardWheelEvent(L);let D=!1;if(L.deltaY||L.deltaX){let z=L.deltaY*this.a.mouseWheelScrollSensitivity,_=L.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&_+z===0?_=z=0:Math.abs(z)>=Math.abs(_)?_=0:z=0),this.a.flipAxes&&([z,_]=[_,z]);const I=!s.$k&&L.browserEvent&&L.browserEvent.shiftKey;(this.a.scrollYToX||I)&&!_&&(_=z,z=0),L.browserEvent&&L.browserEvent.altKey&&(_=_*this.a.fastScrollSensitivity,z=z*this.a.fastScrollSensitivity);const N=this.b.getFutureScrollPosition();let Z={};if(z){const ee=a*z,ue=N.scrollTop-(ee<0?Math.floor(ee):Math.ceil(ee));this.c.writeScrollPosition(Z,ue)}if(_){const ee=a*_,ue=N.scrollLeft-(ee<0?Math.floor(ee):Math.ceil(ee));this.g.writeScrollPosition(Z,ue)}Z=this.b.validateScrollPosition(Z),(N.scrollLeft!==Z.scrollLeft||N.scrollTop!==Z.scrollTop)&&(h&&this.a.mouseWheelSmoothScroll&&d.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Z):this.b.setScrollPositionNow(Z),D=!0)}let B=D;!B&&this.a.alwaysConsumeMouseWheel&&(B=!0),!B&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(B=!0),B&&(L.preventDefault(),L.stopPropagation())}S(L){this.M=this.g.onDidScroll(L)||this.M,this.M=this.c.onDidScroll(L)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const L=this.b.getCurrentScrollPosition(),d=L.scrollTop>0,D=L.scrollLeft>0,B=D?" left":"",z=d?" top":"",_=D||d?" top-left-corner":"";this.n.setClassName(`shadow${B}`),this.r.setClassName(`shadow${z}`),this.s.setClassName(`shadow${_}${z}${B}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(L){this.J=!1,this.ab()}Z(L){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$zQ=r;class b extends r{constructor(L,d){d=d||{},d.mouseWheelSmoothScroll=!1;const D=new l.$Wr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>T.$2O(B,T.$vP(L))});super(L,d,D),this.B(D)}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$AQ=b;class f extends r{constructor(L,d,D){super(L,d,D)}setScrollPosition(L){L.reuseAnimation?this.b.setScrollPositionSmooth(L,L.reuseAnimation):this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$BQ=f;class o extends r{constructor(L,d){d=d||{},d.mouseWheelSmoothScroll=!1;const D=new l.$Wr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>T.$2O(B,T.$vP(L))});super(L,d,D),this.B(D),this.cb=L,this.B(this.onScroll(B=>{B.scrollTopChanged&&(this.cb.scrollTop=B.scrollTop),B.scrollLeftChanged&&(this.cb.scrollLeft=B.scrollLeft)})),this.scanDomNode()}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$CQ=o;function F(j){const L={lazyRender:typeof j.lazyRender<"u"?j.lazyRender:!1,className:typeof j.className<"u"?j.className:"",useShadows:typeof j.useShadows<"u"?j.useShadows:!0,handleMouseWheel:typeof j.handleMouseWheel<"u"?j.handleMouseWheel:!0,flipAxes:typeof j.flipAxes<"u"?j.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof j.consumeMouseWheelIfScrollbarIsNeeded<"u"?j.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof j.alwaysConsumeMouseWheel<"u"?j.alwaysConsumeMouseWheel:!1,scrollYToX:typeof j.scrollYToX<"u"?j.scrollYToX:!1,mouseWheelScrollSensitivity:typeof j.mouseWheelScrollSensitivity<"u"?j.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof j.fastScrollSensitivity<"u"?j.fastScrollSensitivity:5,scrollPredominantAxis:typeof j.scrollPredominantAxis<"u"?j.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof j.mouseWheelSmoothScroll<"u"?j.mouseWheelSmoothScroll:!0,arrowSize:typeof j.arrowSize<"u"?j.arrowSize:11,listenOnDomNode:typeof j.listenOnDomNode<"u"?j.listenOnDomNode:null,horizontal:typeof j.horizontal<"u"?j.horizontal:1,horizontalScrollbarSize:typeof j.horizontalScrollbarSize<"u"?j.horizontalScrollbarSize:10,horizontalSliderSize:typeof j.horizontalSliderSize<"u"?j.horizontalSliderSize:0,horizontalHasArrows:typeof j.horizontalHasArrows<"u"?j.horizontalHasArrows:!1,vertical:typeof j.vertical<"u"?j.vertical:1,verticalScrollbarSize:typeof j.verticalScrollbarSize<"u"?j.verticalScrollbarSize:10,verticalHasArrows:typeof j.verticalHasArrows<"u"?j.verticalHasArrows:!1,verticalSliderSize:typeof j.verticalSliderSize<"u"?j.verticalSliderSize:0,scrollByPage:typeof j.scrollByPage<"u"?j.scrollByPage:!1};return L.horizontalSliderSize=typeof j.horizontalSliderSize<"u"?j.horizontalSliderSize:L.horizontalScrollbarSize,L.verticalSliderSize=typeof j.verticalSliderSize<"u"?j.verticalSliderSize:L.verticalScrollbarSize,s.$k&&(L.className+=" mac"),L}}),define($e[60],pe([1,0,53,3,21,23,59,11,9,25,4,2,46,47,81,117,6]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s,l,e,a,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=t.$6Q=t.$5Q=t.$4Q=void 0;const g={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(L){return[L]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(d){this.d=d}constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$4Q=r;class b{constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$5Q=b;class f{constructor(){this.types=[],this.files=[]}update(d){if(d.types&&this.types.splice(0,this.types.length,...d.types),d.files){this.files.splice(0,this.files.length);for(let D=0;D<d.files.length;D++){const B=d.files.item(D);B&&(B.size||B.type)&&this.files.push(B)}}}getData(){return{types:this.types,files:this.files}}}t.$6Q=f;function o(L,d){return Array.isArray(L)&&Array.isArray(d)?(0,A.$tb)(L,d):L===d}class F{constructor(d){d?.getSetSize?this.getSetSize=d.getSetSize.bind(d):this.getSetSize=(D,B,z)=>z,d?.getPosInSet?this.getPosInSet=d.getPosInSet.bind(d):this.getPosInSet=(D,B)=>B+1,d?.getRole?this.getRole=d.getRole.bind(d):this.getRole=D=>"listitem",d?.isChecked?this.isChecked=d.isChecked.bind(d):this.isChecked=D=>{}}}class j{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(d){if(d!==this.O){if(d&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=d,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const D of this.d)this.Y(D);this.V(),this.q.setScrollDimensions({width:(0,T.$cP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(d,D,B,z=n){if(this.Q=D,this.domId=`list_id_${++j.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new u.$Qg(50),this.v=!1,this.x=O.$Rc.None,this.y=0,this.G=!1,this.J=O.$Rc.None,this.K=O.$Rc.None,this.L=new O.$Qc,this.M=new m.$Nd,this.N=new m.$Nd,this.onDidChangeContentHeight=m.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=m.Event.latch(this.N.event,void 0,this.L),this.O=!1,z.horizontalScrolling&&z.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$2Q(z.paddingTop??0);for(const I of B)this.j.set(I.templateId,I);this.h=this.L.add(new a.$3Q(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof z.mouseSupport=="boolean"?z.mouseSupport:!0),this.O=z.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof z.paddingBottom>"u"?0:z.paddingBottom,this.D=new F(z.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(z.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.$mQ.addTarget(this.o)),this.p=this.L.add(new l.$Wr({forceIntegerValues:!0,smoothScrollDuration:z.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:I=>(0,T.$2O)(I,(0,T.$vP)(this.domNode))})),this.q=this.L.add(new w.$BQ(this.o,{alwaysConsumeMouseWheel:z.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:z.verticalScrollMode??n.verticalScrollMode,useShadows:z.useShadows??n.useShadows,mouseWheelScrollSensitivity:z.mouseWheelScrollSensitivity,fastScrollSensitivity:z.fastScrollSensitivity,scrollByPage:z.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),d.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,T.$TO)(this.o,U.EventType.Change,I=>this.hb(I))),this.L.add((0,T.$TO)(this.q.getDomNode(),"scroll",I=>I.target.scrollTop=0)),this.L.add((0,T.$TO)(this.domNode,"dragover",I=>this.jb(this.fb(I)))),this.L.add((0,T.$TO)(this.domNode,"drop",I=>this.lb(this.fb(I)))),this.L.add((0,T.$TO)(this.domNode,"dragleave",I=>this.kb(this.fb(I)))),this.L.add((0,T.$TO)(this.domNode,"dragend",I=>this.mb(I))),this.z=z.setRowLineHeight??n.setRowLineHeight,this.A=z.setRowHeight??n.setRowHeight,this.B=z.supportDynamicHeights??n.supportDynamicHeights,this.F=z.dnd??this.L.add(n.dnd),this.layout(z.initialSize?.height,z.initialSize?.width)}updateOptions(d){d.paddingBottom!==void 0&&(this.C=d.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),d.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(d.smoothScrolling?125:0),d.horizontalScrolling!==void 0&&(this.P=d.horizontalScrolling);let D;if(d.scrollByPage!==void 0&&(D={...D??{},scrollByPage:d.scrollByPage}),d.mouseWheelScrollSensitivity!==void 0&&(D={...D??{},mouseWheelScrollSensitivity:d.mouseWheelScrollSensitivity}),d.fastScrollSensitivity!==void 0&&(D={...D??{},fastScrollSensitivity:d.fastScrollSensitivity}),D&&this.q.updateOptions(D),d.paddingTop!==void 0&&d.paddingTop!==this.g.paddingTop){const B=this.sb(this.k,this.m),z=d.paddingTop-this.g.paddingTop;this.g.paddingTop=d.paddingTop,this.W(B,Math.max(0,this.k+z),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(d){this.q.delegateScrollFromMouseWheelEvent(d)}delegateVerticalScrollbarPointerDown(d){this.q.delegateVerticalScrollbarPointerDown(d)}updateElementHeight(d,D,B){if(d<0||d>=this.d.length)return;const z=this.d[d].size;if(typeof D>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[d].lastDynamicHeightWidth=void 0,D=z+this.ub(d)}if(z===D)return;const _=this.sb(this.k,this.m);let I=0;d<_.start||B!==null&&B>d&&B<_.end?I=D-z:I=0,this.g.splice(d,1,[{size:D}]),this.d[d].size=D,this.W(_,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(d,D,B=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(d,D,B)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(d,D,B=[]){const z=this.sb(this.k,this.m),_={start:d,end:d+D},I=s.Range.intersect(z,_),N=new Map;for(let q=I.end-1;q>=I.start;q--){const X=this.d[q];if(X.dragStartDisposable.dispose(),X.checkedDisposable.dispose(),X.row){let S=N.get(X.templateId);S||(S=[],N.set(X.templateId,S));const Q=this.j.get(X.templateId);Q&&Q.disposeElement&&Q.disposeElement(X.element,q,X.row.templateData,X.size),S.push(X.row)}X.row=null}const Z={start:d+D,end:this.d.length},ee=s.Range.intersect(Z,z),ue=s.Range.relativeComplement(Z,z),ae=B.map(q=>({id:String(this.f++),element:q,templateId:this.Q.getTemplateId(q),size:this.Q.getHeight(q),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(q),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:O.$Rc.None,checkedDisposable:O.$Rc.None}));let se;d===0&&D>=this.d.length?(this.g=new e.$2Q(this.g.paddingTop),this.g.splice(0,0,ae),se=this.d,this.d=ae):(this.g.splice(d,D,ae),se=this.d.splice(d,D,...ae));const re=B.length-D,be=this.sb(this.k,this.m),Se=(0,e.$ZQ)(ee,re),Oe=s.Range.intersect(be,Se);for(let q=Oe.start;q<Oe.end;q++)this.Z(this.d[q],q);const Te=s.Range.relativeComplement(Se,be);for(const q of Te)for(let X=q.start;X<q.end;X++)this.ab(X);const de=ue.map(q=>(0,e.$ZQ)(q,re)),fe=[{start:d,end:d+B.length},...de].map(q=>s.Range.intersect(be,q)),Y=this.vb(fe);for(const q of fe)for(let X=q.start;X<q.end;X++){const S=this.d[X],$=N.get(S.templateId)?.pop();this.X(X,Y,$)}for(const q of N.values())for(const X of q)this.h.release(X);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),se.map(q=>q.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,T.$2O)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null},(0,T.$vP)(this.domNode)))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let d=0;for(const D of this.d)typeof D.width<"u"&&(d=Math.max(d,D.width));this.E=d,this.q.setScrollDimensions({scrollWidth:d===0?0:d+10}),this.N.fire(this.E)}updateWidth(d){if(!this.P||typeof this.E>"u")return;const D=this.d[d];this.Y(D),typeof D.width<"u"&&D.width>this.E&&(this.E=D.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const d of this.d)d.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const d=this.sb(this.k,this.m),D=this.g.positionAt(d.start),B=this.g.positionAt(d.start+1);return B!==-1&&(B-D)/2+D<this.scrollTop?d.start+1:d.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(d){return this.d[d].element}indexOf(d){return this.d.findIndex(D=>D.element===d)}domElement(d){const D=this.d[d].row;return D&&D.domNode}elementHeight(d){return this.d[d].size}elementTop(d){return this.g.positionAt(d)}indexAt(d){return this.g.indexAt(d)}indexAfter(d){return this.g.indexAfter(d)}layout(d,D){const B={height:typeof d=="number"?d:(0,T.$eP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,B.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(B),typeof D<"u"&&(this.n=D,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof D=="number"?D:(0,T.$cP)(this.domNode)})}W(d,D,B,z,_,I=!1){const N=this.sb(D,B),Z=s.Range.relativeComplement(N,d),ee=s.Range.relativeComplement(d,N),ue=this.vb(Z);if(I){const ae=s.Range.intersect(d,N);for(let se=ae.start;se<ae.end;se++)this.Z(this.d[se],se)}this.h.transact(()=>{for(const ae of ee)for(let se=ae.start;se<ae.end;se++)this.ab(se);for(const ae of Z)for(let se=ae.start;se<ae.end;se++)this.X(se,ue)}),z!==void 0&&(this.o.style.left=`-${z}px`),this.o.style.top=`-${D}px`,this.P&&_!==void 0&&(this.o.style.width=`${Math.max(_,this.n)}px`),this.k=D,this.m=B}X(d,D,B){const z=this.d[d];let _=!1;if(!z.row)if(B)z.row=B;else{const ue=this.h.alloc(z.templateId);z.row=ue.row,_=ue.isReusingConnectedDomNode}const I=this.D.getRole(z.element)||"listitem";z.row.domNode.setAttribute("role",I);const N=this.D.isChecked(z.element);if(typeof N=="boolean")z.row.domNode.setAttribute("aria-checked",String(!!N));else if(N){const ue=ae=>z.row.domNode.setAttribute("aria-checked",String(!!ae));ue(N.value),z.checkedDisposable=N.onDidChange(ue)}(_||!z.row.domNode.parentElement)&&(D?this.o.insertBefore(z.row.domNode,D):this.o.appendChild(z.row.domNode)),this.Z(z,d);const Z=this.j.get(z.templateId);if(!Z)throw new Error(`No renderer found for template id ${z.templateId}`);Z?.renderElement(z.element,d,z.row.templateData,z.size);const ee=this.F.getDragURI(z.element);z.dragStartDisposable.dispose(),z.row.domNode.draggable=!!ee,ee&&(z.dragStartDisposable=(0,T.$TO)(z.row.domNode,"dragstart",ue=>this.ib(z.element,ee,ue))),this.P&&(this.Y(z),this.U())}Y(d){if(!d.row||!d.row.domNode)return;d.row.domNode.style.width="fit-content",d.width=(0,T.$cP)(d.row.domNode);const D=window.getComputedStyle(d.row.domNode);D.paddingLeft&&(d.width+=parseFloat(D.paddingLeft)),D.paddingRight&&(d.width+=parseFloat(D.paddingRight)),d.row.domNode.style.width=""}Z(d,D){d.row.domNode.style.top=`${this.elementTop(D)}px`,this.A&&(d.row.domNode.style.height=`${d.size}px`),this.z&&(d.row.domNode.style.lineHeight=`${d.size}px`),d.row.domNode.setAttribute("data-index",`${D}`),d.row.domNode.setAttribute("data-last-element",D===this.length-1?"true":"false"),d.row.domNode.setAttribute("data-parity",D%2===0?"even":"odd"),d.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(d.element,D,this.length))),d.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(d.element,D))),d.row.domNode.setAttribute("id",this.getElementDomId(D)),d.row.domNode.classList.toggle("drop-target",d.dropTarget)}ab(d){const D=this.d[d];if(D.dragStartDisposable.dispose(),D.checkedDisposable.dispose(),D.row){const B=this.j.get(D.templateId);B&&B.disposeElement&&B.disposeElement(D.element,d,D.row.templateData,D.size),this.h.release(D.row),D.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(d,D){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:d,reuseAnimation:D})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(d){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:d})}get scrollTop(){return this.getScrollTop()}set scrollTop(d){this.setScrollTop(d)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return m.Event.map(this.L.add(new i.$QQ(this.domNode,"click")).event,d=>this.bb(d),this.L)}get onMouseDblClick(){return m.Event.map(this.L.add(new i.$QQ(this.domNode,"dblclick")).event,d=>this.bb(d),this.L)}get onMouseMiddleClick(){return m.Event.filter(m.Event.map(this.L.add(new i.$QQ(this.domNode,"auxclick")).event,d=>this.bb(d),this.L),d=>d.browserEvent.button===1,this.L)}get onMouseUp(){return m.Event.map(this.L.add(new i.$QQ(this.domNode,"mouseup")).event,d=>this.bb(d),this.L)}get onMouseDown(){return m.Event.map(this.L.add(new i.$QQ(this.domNode,"mousedown")).event,d=>this.bb(d),this.L)}get onMouseOver(){return m.Event.map(this.L.add(new i.$QQ(this.domNode,"mouseover")).event,d=>this.bb(d),this.L)}get onMouseMove(){return m.Event.map(this.L.add(new i.$QQ(this.domNode,"mousemove")).event,d=>this.bb(d),this.L)}get onMouseOut(){return m.Event.map(this.L.add(new i.$QQ(this.domNode,"mouseout")).event,d=>this.bb(d),this.L)}get onContextMenu(){return m.Event.any(m.Event.map(this.L.add(new i.$QQ(this.domNode,"contextmenu")).event,d=>this.bb(d),this.L),m.Event.map(this.L.add(new i.$QQ(this.domNode,U.EventType.Contextmenu)).event,d=>this.eb(d),this.L))}get onTouchStart(){return m.Event.map(this.L.add(new i.$QQ(this.domNode,"touchstart")).event,d=>this.db(d),this.L)}get onTap(){return m.Event.map(this.L.add(new i.$QQ(this.o,U.EventType.Tap)).event,d=>this.eb(d),this.L)}bb(d){const D=this.rb(d.target||null),B=typeof D>"u"?void 0:this.d[D],z=B&&B.element;return{browserEvent:d,index:D,element:z}}db(d){const D=this.rb(d.target||null),B=typeof D>"u"?void 0:this.d[D],z=B&&B.element;return{browserEvent:d,index:D,element:z}}eb(d){const D=this.rb(d.initialTarget||null),B=typeof D>"u"?void 0:this.d[D],z=B&&B.element;return{browserEvent:d,index:D,element:z}}fb(d){const D=this.rb(d.target||null),B=typeof D>"u"?void 0:this.d[D],z=B&&B.element;return{browserEvent:d,index:D,element:z}}gb(d){try{const D=this.sb(this.k,this.m);this.W(D,d.scrollTop,d.height,d.scrollLeft,d.scrollWidth),this.B&&this.tb(d.scrollTop,d.height,d.inSmoothScrolling)}catch(D){throw console.error("Got bad scroll event:",d),D}}hb(d){d.preventDefault(),d.stopPropagation(),this.scrollTop-=d.translationY}ib(d,D,B){if(!B.dataTransfer)return;const z=this.F.getDragElements(d);if(B.dataTransfer.effectAllowed="copyMove",B.dataTransfer.setData(v.$kQ.TEXT,D),B.dataTransfer.setDragImage){let _;this.F.getDragLabel&&(_=this.F.getDragLabel(z,B)),typeof _>"u"&&(_=String(z.length));const I=(0,T.$)(".monaco-drag-image");I.textContent=_;const Z=(ee=>{for(;ee&&!ee.classList.contains("monaco-workbench");)ee=ee.parentElement;return ee||this.domNode.ownerDocument})(this.domNode);Z.appendChild(I),B.dataTransfer.setDragImage(I,-10,-10),setTimeout(()=>Z.removeChild(I),0)}this.domNode.classList.add("dragging"),this.H=new r(z),g.CurrentDragAndDropData=new b(z),this.F.onDragStart?.(this.H,B)}jb(d){if(d.browserEvent.preventDefault(),this.K.dispose(),g.CurrentDragAndDropData&&g.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(d.browserEvent),!d.browserEvent.dataTransfer))return!1;if(!this.H)if(g.CurrentDragAndDropData)this.H=g.CurrentDragAndDropData;else{if(!d.browserEvent.dataTransfer.types)return!1;this.H=new f}const D=this.F.onDragOver(this.H,d.element,d.index,d.browserEvent);if(this.G=typeof D=="boolean"?D:D.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;d.browserEvent.dataTransfer.dropEffect=typeof D!="boolean"&&D.effect===0?"copy":"move";let B;if(typeof D!="boolean"&&D.feedback?B=D.feedback:typeof d.index>"u"?B=[-1]:B=[d.index],B=(0,A.$Lb)(B).filter(z=>z>=-1&&z<this.length).sort((z,_)=>z-_),B=B[0]===-1?[-1]:B,o(this.I,B))return!0;if(this.I=B,this.J.dispose(),B[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,O.$Pc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const z of B){const _=this.d[z];_.dropTarget=!0,_.row?.domNode.classList.add("drop-target")}this.J=(0,O.$Pc)(()=>{for(const z of B){const _=this.d[z];_.dropTarget=!1,_.row?.domNode.classList.remove("drop-target")}})}return!0}kb(d){this.K.dispose(),this.K=(0,u.$Vg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,d.element,d.index,d.browserEvent)}lb(d){if(!this.G)return;const D=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,!(!D||!d.browserEvent.dataTransfer)&&(d.browserEvent.preventDefault(),D.update(d.browserEvent.dataTransfer),this.F.drop(D,d.element,d.index,d.browserEvent))}mb(d){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,g.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(d)}nb(){this.I=void 0,this.J.dispose(),this.J=O.$Rc.None}ob(d){if(!this.w){const D=(0,T.$9O)(this.domNode).top;this.w=(0,T.$5P)(this.pb.bind(this,D),(0,T.$vP)(this.domNode))}this.x.dispose(),this.x=(0,u.$Vg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=d.pageY}pb(d){if(this.y===void 0)return;const D=this.y-d,B=this.renderHeight-35;D<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(D-35))):D>B&&(this.scrollTop+=Math.min(14,Math.floor(.3*(D-B))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(d){const D=this.q.getDomNode();let B=d;for(;B instanceof HTMLElement&&B!==this.o&&D.contains(B);){const z=B.getAttribute("data-index");if(z){const _=Number(z);if(!isNaN(_))return _}B=B.parentElement}}sb(d,D){return{start:this.g.indexAt(d),end:this.g.indexAfter(d+D-1)}}tb(d,D,B){const z=this.sb(d,D);let _,I;d===this.elementTop(z.start)?(_=z.start,I=0):z.end-z.start>1&&(_=z.start+1,I=this.elementTop(_)-d);let N=0;for(;;){const Z=this.sb(d,D);let ee=!1;for(let ue=Z.start;ue<Z.end;ue++){const ae=this.ub(ue);ae!==0&&this.g.splice(ue,1,[this.d[ue]]),N+=ae,ee=ee||ae!==0}if(!ee){N!==0&&this.S();const ue=s.Range.relativeComplement(z,Z);for(const se of ue)for(let re=se.start;re<se.end;re++)this.d[re].row&&this.ab(re);const ae=s.Range.relativeComplement(Z,z);for(const se of ae)for(let re=se.start;re<se.end;re++){const be=re+1,Se=be<this.d.length?this.d[be].row:null,Oe=Se?Se.domNode:null;this.X(re,Oe)}for(let se=Z.start;se<Z.end;se++)this.d[se].row&&this.Z(this.d[se],se);if(typeof _=="number"){const se=this.p.getFutureScrollPosition().scrollTop-d,re=this.elementTop(_)-I+se;this.setScrollTop(re,B)}this.M.fire(this.contentHeight);return}}}ub(d){const D=this.d[d];if(this.Q.getDynamicHeight){const I=this.Q.getDynamicHeight(D.element);if(I!==null){const N=D.size;return D.size=I,D.lastDynamicHeightWidth=this.n,I-N}}if(!D.hasDynamicHeight||D.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(D.element))return 0;const B=D.size;if(D.row)return D.row.domNode.style.height="",D.size=D.row.domNode.offsetHeight,D.lastDynamicHeightWidth=this.n,D.size-B;const{row:z}=this.h.alloc(D.templateId);z.domNode.style.height="",this.o.appendChild(z.domNode);const _=this.j.get(D.templateId);if(!_)throw new h.$bb("Missing renderer for templateId: "+D.templateId);return _.renderElement(D.element,d,z.templateData,void 0),D.size=z.domNode.offsetHeight,_.disposeElement?.(D.element,d,z.templateData,void 0),this.Q.setDynamicHeight?.(D.element,D.size),D.lastDynamicHeightWidth=this.n,this.o.removeChild(z.domNode),this.h.release(z),D.size-B}vb(d){const D=d[d.length-1];if(!D)return null;const B=this.d[D.end];return!B||!B.row?null:B.row.domNode}getElementDomId(d){return`${this.domId}_${d}`}dispose(){for(const d of this.d)if(d.dragStartDisposable.dispose(),d.checkedDisposable.dispose(),d.row){const D=this.j.get(d.row.templateId);D&&(D.disposeElement?.(d.element,-1,d.row.templateData,void 0),D.disposeTemplate(d.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$7Q=j,Ye([c.$ih],j.prototype,"onMouseClick",null),Ye([c.$ih],j.prototype,"onMouseDblClick",null),Ye([c.$ih],j.prototype,"onMouseMiddleClick",null),Ye([c.$ih],j.prototype,"onMouseUp",null),Ye([c.$ih],j.prototype,"onMouseDown",null),Ye([c.$ih],j.prototype,"onMouseOver",null),Ye([c.$ih],j.prototype,"onMouseMove",null),Ye([c.$ih],j.prototype,"onMouseOut",null),Ye([c.$ih],j.prototype,"onContextMenu",null),Ye([c.$ih],j.prototype,"onTouchStart",null),Ye([c.$ih],j.prototype,"onTap",null)}),define($e[38],pe([1,0,3,21,14,23,56,70,11,9,73,25,4,33,2,45,5,7,69,60,19,95]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s,l,e,a,h,g,n,r,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=t.$dR=t.$cR=t.$bR=t.$aR=t.$_Q=t.$$Q=t.TypeNavigationMode=t.$0Q=t.$9Q=t.$8Q=void 0;class f{constructor(S){this.d=S,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(S){return S}renderElement(S,Q,$){const W=this.c.findIndex(V=>V.templateData===$);if(W>=0){const V=this.c[W];this.d.unrender($),V.index=Q}else{const V={index:Q,templateData:$};this.c.push(V)}this.d.renderIndex(Q,$)}splice(S,Q,$){const W=[];for(const V of this.c)V.index<S?W.push(V):V.index>=S+Q&&W.push({index:V.index+$-Q,templateData:V.templateData});this.c=W}renderIndexes(S){for(const{index:Q,templateData:$}of this.c)S.indexOf(Q)>-1&&this.d.renderIndex(Q,$)}disposeTemplate(S){const Q=this.c.findIndex($=>$.templateData===S);Q<0||this.c.splice(Q,1)}}class o{get name(){return this.h}get renderer(){return new f(this)}constructor(S){this.h=S,this.c=0,this.d=[],this.f=[],this.g=new s.$Nd,this.onChange=this.g.event}splice(S,Q,$){Q=Math.max(0,Math.min(Q,this.c-S));const W=$.length-Q,V=S+Q,p=[];let y=0;for(;y<this.f.length&&this.f[y]<S;)p.push(this.f[y++]);for(let M=0;M<$.length;M++)$[M]&&p.push(M+S);for(;y<this.f.length&&this.f[y]>=V;)p.push(this.f[y++]+W);const E=this.c+W;if(this.f.length>0&&p.length===0&&E>0){const M=this.f.find(k=>k>=S)??E-1;p.push(Math.min(M,E-1))}this.renderer.splice(S,Q,$.length),this.k(p,p),this.c=E}renderIndex(S,Q){Q.classList.toggle(this.h,this.contains(S))}unrender(S){S.classList.remove(this.h)}set(S,Q){return this.k(S,[...S].sort(de),Q)}k(S,Q,$){const W=this.d,V=this.f;this.d=S,this.f=Q;const p=Oe(V,S);return this.renderer.renderIndexes(p),this.g.fire({indexes:S,browserEvent:$}),W}get(){return this.d}contains(S){return(0,u.$vb)(this.f,S,de)>=0}dispose(){(0,e.$Mc)(this.g)}}Ye([O.$ih],o.prototype,"renderer",null);class F extends o{constructor(S){super("selected"),this.l=S}renderIndex(S,Q){super.renderIndex(S,Q),this.l&&(this.contains(S)?Q.setAttribute("aria-selected","true"):Q.setAttribute("aria-selected","false"))}}class j{constructor(S,Q,$){this.c=S,this.d=Q,this.f=$}splice(S,Q,$){if(!this.f)return this.c.splice(S,Q,new Array($.length).fill(!1));const W=this.c.get().map(y=>this.f.getId(this.d.element(y)).toString());if(W.length===0)return this.c.splice(S,Q,new Array($.length).fill(!1));const V=new Set(W),p=$.map(y=>V.has(this.f.getId(y).toString()));this.c.splice(S,Q,p)}}function L(X){return X.tagName==="INPUT"||X.tagName==="TEXTAREA"}t.$8Q=L;function d(X){return X.classList.contains("monaco-editor")?!0:X.classList.contains("monaco-list")||!X.parentElement?!1:d(X.parentElement)}t.$9Q=d;function D(X){return X.tagName==="A"&&X.classList.contains("monaco-button")||X.tagName==="DIV"&&X.classList.contains("monaco-button-dropdown")?!0:X.classList.contains("monaco-list")||!X.parentElement?!1:D(X.parentElement)}t.$0Q=D;class B{get g(){return s.Event.chain(this.c.add(new T.$QQ(this.k.domNode,"keydown")).event,S=>S.filter(Q=>!L(Q.target)).map(Q=>new i.$QO(Q)))}constructor(S,Q,$){this.h=S,this.k=Q,this.c=new e.$Qc,this.d=new e.$Qc,this.f=$.multipleSelectionSupport,this.c.add(this.g(W=>{switch(W.keyCode){case 3:return this.l(W);case 16:return this.o(W);case 18:return this.p(W);case 11:return this.q(W);case 12:return this.s(W);case 9:return this.u(W);case 31:this.f&&(h.$k?W.metaKey:W.ctrlKey)&&this.t(W)}}))}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.f=S.multipleSelectionSupport)}l(S){S.preventDefault(),S.stopPropagation(),this.h.setSelection(this.h.getFocus(),S.browserEvent)}o(S){S.preventDefault(),S.stopPropagation(),this.h.focusPrevious(1,!1,S.browserEvent);const Q=this.h.getFocus()[0];this.h.setAnchor(Q),this.h.reveal(Q),this.k.domNode.focus()}p(S){S.preventDefault(),S.stopPropagation(),this.h.focusNext(1,!1,S.browserEvent);const Q=this.h.getFocus()[0];this.h.setAnchor(Q),this.h.reveal(Q),this.k.domNode.focus()}q(S){S.preventDefault(),S.stopPropagation(),this.h.focusPreviousPage(S.browserEvent);const Q=this.h.getFocus()[0];this.h.setAnchor(Q),this.h.reveal(Q),this.k.domNode.focus()}s(S){S.preventDefault(),S.stopPropagation(),this.h.focusNextPage(S.browserEvent);const Q=this.h.getFocus()[0];this.h.setAnchor(Q),this.h.reveal(Q),this.k.domNode.focus()}t(S){S.preventDefault(),S.stopPropagation(),this.h.setSelection((0,u.$Rb)(this.h.length),S.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(S){this.h.getSelection().length&&(S.preventDefault(),S.stopPropagation(),this.h.setSelection([],S.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ye([O.$ih],B.prototype,"g",null);var z;(function(X){X[X.Automatic=0]="Automatic",X[X.Trigger=1]="Trigger"})(z||(t.TypeNavigationMode=z={}));var _;(function(X){X[X.Idle=0]="Idle",X[X.Typing=1]="Typing"})(_||(_={})),t.$$Q=new class{mightProducePrintableCharacter(X){return X.ctrlKey||X.metaKey||X.altKey?!1:X.keyCode>=31&&X.keyCode<=56||X.keyCode>=21&&X.keyCode<=30||X.keyCode>=98&&X.keyCode<=107||X.keyCode>=85&&X.keyCode<=95}};class I{constructor(S,Q,$,W,V){this.o=S,this.p=Q,this.q=$,this.s=W,this.t=V,this.c=!1,this.d=_.Idle,this.f=z.Automatic,this.g=!1,this.h=-1,this.k=new e.$Qc,this.l=new e.$Qc,this.updateOptions(S.options)}updateOptions(S){S.typeNavigationEnabled??!0?this.u():this.v(),this.f=S.typeNavigationMode??z.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let S=!1;const Q=s.Event.chain(this.k.add(new T.$QQ(this.p.domNode,"keydown")).event,V=>V.filter(p=>!L(p.target)).filter(()=>this.f===z.Automatic||this.g).map(p=>new i.$QO(p)).filter(p=>S||this.s(p)).filter(p=>this.t.mightProducePrintableCharacter(p)).forEach(p=>v.$KP.stop(p,!0)).map(p=>p.browserEvent.key)),$=s.Event.debounce(Q,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(Q,$),(V,p)=>p===null?null:(V||"")+p,void 0,this.k)(this.x,this,this.k),$(this.w,this,this.k),Q(()=>S=!0,void 0,this.k),$(()=>S=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const S=this.o.getFocus();if(S.length>0&&S[0]===this.h){const Q=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(S[0]));Q&&(0,w.$SQ)(Q)}this.h=-1}x(S){if(!S){this.d=_.Idle,this.g=!1;return}const Q=this.o.getFocus(),$=Q.length>0?Q[0]:0,W=this.d===_.Idle?1:0;this.d=_.Typing;for(let V=0;V<this.o.length;V++){const p=($+V+W)%this.o.length,y=this.q.getKeyboardNavigationLabel(this.p.element(p)),E=y&&y.toString();if(this.o.options.typeNavigationEnabled){if(typeof E<"u"){if((0,l.$Ej)(S,E)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}const M=(0,l.$Lj)(S,E);if(M&&M[0].end-M[0].start>1&&M.length===1){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}else if(typeof E>"u"||(0,l.$Ej)(S,E)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class N{constructor(S,Q){this.d=S,this.f=Q,this.c=new e.$Qc;const $=s.Event.chain(this.c.add(new T.$QQ(Q.domNode,"keydown")).event,V=>V.filter(p=>!L(p.target)).map(p=>new i.$QO(p)));s.Event.chain($,V=>V.filter(p=>p.keyCode===2&&!p.ctrlKey&&!p.metaKey&&!p.shiftKey&&!p.altKey))(this.g,this,this.c)}g(S){if(S.target!==this.f.domNode)return;const Q=this.d.getFocus();if(Q.length===0)return;const $=this.f.domElement(Q[0]);if(!$)return;const W=$.querySelector("[tabIndex]");if(!W||!(W instanceof HTMLElement)||W.tabIndex===-1)return;const V=window.getComputedStyle(W);V.visibility==="hidden"||V.display==="none"||(S.preventDefault(),S.stopPropagation(),W.focus())}dispose(){this.c.dispose()}}function Z(X){return h.$k?X.browserEvent.metaKey:X.browserEvent.ctrlKey}t.$_Q=Z;function ee(X){return X.browserEvent.shiftKey}t.$aR=ee;function ue(X){return(0,v.$EP)(X)&&X.button===2}const ae={isSelectionSingleChangeEvent:Z,isSelectionRangeChangeEvent:ee};class se{constructor(S){this.k=S,this.f=new e.$Qc,this.g=new s.$Nd,this.onPointer=this.g.event,S.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ae),this.d=typeof S.options.mouseSupport>"u"||!!S.options.mouseSupport,this.d&&(S.onMouseDown(this.s,this,this.f),S.onContextMenu(this.t,this,this.f),S.onMouseDblClick(this.v,this,this.f),S.onTouchStart(this.s,this,this.f),this.f.add(U.$mQ.addTarget(S.getHTMLElement()))),s.Event.any(S.onMouseClick,S.onMouseMiddleClick,S.onTap)(this.u,this,this.f)}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.c=void 0,S.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ae))}o(S){return this.c?this.c.isSelectionSingleChangeEvent(S):!1}p(S){return this.c?this.c.isSelectionRangeChangeEvent(S):!1}q(S){return this.o(S)||this.p(S)}s(S){d(S.browserEvent.target)||(0,v.$pP)()!==S.browserEvent.target&&this.k.domFocus()}t(S){if(L(S.browserEvent.target)||d(S.browserEvent.target))return;const Q=typeof S.index>"u"?[]:[S.index];this.k.setFocus(Q,S.browserEvent)}u(S){if(!this.d||L(S.browserEvent.target)||d(S.browserEvent.target)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const Q=S.index;if(typeof Q>"u"){this.k.setFocus([],S.browserEvent),this.k.setSelection([],S.browserEvent),this.k.setAnchor(void 0);return}if(this.q(S))return this.w(S);this.k.setFocus([Q],S.browserEvent),this.k.setAnchor(Q),ue(S.browserEvent)||this.k.setSelection([Q],S.browserEvent),this.g.fire(S)}v(S){if(L(S.browserEvent.target)||d(S.browserEvent.target)||this.q(S)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const Q=this.k.getFocus();this.k.setSelection(Q,S.browserEvent)}w(S){const Q=S.index;let $=this.k.getAnchor();if(this.p(S)){typeof $>"u"&&($=this.k.getFocus()[0]??Q,this.k.setAnchor($));const W=Math.min($,Q),V=Math.max($,Q),p=(0,u.$Rb)(W,V+1),y=this.k.getSelection(),E=Se(Oe(y,[$]),$);if(E.length===0)return;const M=Oe(p,Te(y,E));this.k.setSelection(M,S.browserEvent),this.k.setFocus([Q],S.browserEvent)}else if(this.o(S)){const W=this.k.getSelection(),V=W.filter(p=>p!==Q);this.k.setFocus([Q]),this.k.setAnchor(Q),W.length===V.length?this.k.setSelection([...V,Q],S.browserEvent):this.k.setSelection(V,S.browserEvent)}}dispose(){this.f.dispose()}}t.$bR=se;class re{constructor(S,Q){this.c=S,this.d=Q}style(S){const Q=this.d&&`.${this.d}`,$=[];S.listBackground&&$.push(`.monaco-list${Q} .monaco-list-rows { background: ${S.listBackground}; }`),S.listFocusBackground&&($.push(`.monaco-list${Q}:focus .monaco-list-row.focused { background-color: ${S.listFocusBackground}; }`),$.push(`.monaco-list${Q}:focus .monaco-list-row.focused:hover { background-color: ${S.listFocusBackground}; }`)),S.listFocusForeground&&$.push(`.monaco-list${Q}:focus .monaco-list-row.focused { color: ${S.listFocusForeground}; }`),S.listActiveSelectionBackground&&($.push(`.monaco-list${Q}:focus .monaco-list-row.selected { background-color: ${S.listActiveSelectionBackground}; }`),$.push(`.monaco-list${Q}:focus .monaco-list-row.selected:hover { background-color: ${S.listActiveSelectionBackground}; }`)),S.listActiveSelectionForeground&&$.push(`.monaco-list${Q}:focus .monaco-list-row.selected { color: ${S.listActiveSelectionForeground}; }`),S.listActiveSelectionIconForeground&&$.push(`.monaco-list${Q}:focus .monaco-list-row.selected .codicon { color: ${S.listActiveSelectionIconForeground}; }`),S.listFocusAndSelectionBackground&&$.push(`
				.monaco-drag-image,
				.monaco-list${Q}:focus .monaco-list-row.selected.focused { background-color: ${S.listFocusAndSelectionBackground}; }
			`),S.listFocusAndSelectionForeground&&$.push(`
				.monaco-drag-image,
				.monaco-list${Q}:focus .monaco-list-row.selected.focused { color: ${S.listFocusAndSelectionForeground}; }
			`),S.listInactiveFocusForeground&&($.push(`.monaco-list${Q} .monaco-list-row.focused { color:  ${S.listInactiveFocusForeground}; }`),$.push(`.monaco-list${Q} .monaco-list-row.focused:hover { color:  ${S.listInactiveFocusForeground}; }`)),S.listInactiveSelectionIconForeground&&$.push(`.monaco-list${Q} .monaco-list-row.focused .codicon { color:  ${S.listInactiveSelectionIconForeground}; }`),S.listInactiveFocusBackground&&($.push(`.monaco-list${Q} .monaco-list-row.focused { background-color:  ${S.listInactiveFocusBackground}; }`),$.push(`.monaco-list${Q} .monaco-list-row.focused:hover { background-color:  ${S.listInactiveFocusBackground}; }`)),S.listInactiveSelectionBackground&&($.push(`.monaco-list${Q} .monaco-list-row.selected { background-color:  ${S.listInactiveSelectionBackground}; }`),$.push(`.monaco-list${Q} .monaco-list-row.selected:hover { background-color:  ${S.listInactiveSelectionBackground}; }`)),S.listInactiveSelectionForeground&&$.push(`.monaco-list${Q} .monaco-list-row.selected { color: ${S.listInactiveSelectionForeground}; }`),S.listHoverBackground&&$.push(`.monaco-list${Q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${S.listHoverBackground}; }`),S.listHoverForeground&&$.push(`.monaco-list${Q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${S.listHoverForeground}; }`);const W=(0,v.$8P)(S.listFocusAndSelectionOutline,(0,v.$8P)(S.listSelectionOutline,S.listFocusOutline??""));W&&$.push(`.monaco-list${Q}:focus .monaco-list-row.focused.selected { outline: 1px solid ${W}; outline-offset: -1px;}`),S.listFocusOutline&&$.push(`
				.monaco-drag-image,
				.monaco-list${Q}:focus .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${Q}.last-focused .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
			`);const V=(0,v.$8P)(S.listSelectionOutline,S.listInactiveFocusOutline??"");V&&$.push(`.monaco-list${Q} .monaco-list-row.focused.selected { outline: 1px dotted ${V}; outline-offset: -1px; }`),S.listSelectionOutline&&$.push(`.monaco-list${Q} .monaco-list-row.selected { outline: 1px dotted ${S.listSelectionOutline}; outline-offset: -1px; }`),S.listInactiveFocusOutline&&$.push(`.monaco-list${Q} .monaco-list-row.focused { outline: 1px dotted ${S.listInactiveFocusOutline}; outline-offset: -1px; }`),S.listHoverOutline&&$.push(`.monaco-list${Q} .monaco-list-row:hover { outline: 1px dashed ${S.listHoverOutline}; outline-offset: -1px; }`),S.listDropBackground&&$.push(`
				.monaco-list${Q}.drop-target,
				.monaco-list${Q} .monaco-list-rows.drop-target,
				.monaco-list${Q} .monaco-list-row.drop-target { background-color: ${S.listDropBackground} !important; color: inherit !important; }
			`),S.tableColumnsBorder&&$.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${S.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),S.tableOddRowsBackgroundColor&&$.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${S.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=$.join(`
`)}}t.$cR=re,t.$dR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:m.$Ys.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:m.$Ys.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:m.$Ys.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const be={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Se(X,S){const Q=X.indexOf(S);if(Q===-1)return[];const $=[];let W=Q-1;for(;W>=0&&X[W]===S-(Q-W);)$.push(X[W--]);for($.reverse(),W=Q;W<X.length&&X[W]===S+(W-Q);)$.push(X[W++]);return $}function Oe(X,S){const Q=[];let $=0,W=0;for(;$<X.length||W<S.length;)if($>=X.length)Q.push(S[W++]);else if(W>=S.length)Q.push(X[$++]);else if(X[$]===S[W]){Q.push(X[$]),$++,W++;continue}else X[$]<S[W]?Q.push(X[$++]):Q.push(S[W++]);return Q}function Te(X,S){const Q=[];let $=0,W=0;for(;$<X.length||W<S.length;)if($>=X.length)Q.push(S[W++]);else if(W>=S.length)Q.push(X[$++]);else if(X[$]===S[W]){$++,W++;continue}else X[$]<S[W]?Q.push(X[$++]):W++;return Q}const de=(X,S)=>X-S;class ie{constructor(S,Q){this.c=S,this.d=Q}get templateId(){return this.c}renderTemplate(S){return this.d.map(Q=>Q.renderTemplate(S))}renderElement(S,Q,$,W){let V=0;for(const p of this.d)p.renderElement(S,Q,$[V++],W)}disposeElement(S,Q,$,W){let V=0;for(const p of this.d)p.disposeElement?.(S,Q,$[V],W),V+=1}disposeTemplate(S){let Q=0;for(const $ of this.d)$.disposeTemplate(S[Q++])}}class fe{constructor(S){this.c=S,this.templateId="a18n"}renderTemplate(S){return S}renderElement(S,Q,$){const W=this.c.getAriaLabel(S);W?$.setAttribute("aria-label",W):$.removeAttribute("aria-label");const V=this.c.getAriaLevel&&this.c.getAriaLevel(S);typeof V=="number"?$.setAttribute("aria-level",`${V}`):$.removeAttribute("aria-level")}disposeTemplate(S){}}class Y{constructor(S,Q){this.c=S,this.d=Q}getDragElements(S){const Q=this.c.getSelectedElements();return Q.indexOf(S)>-1?Q:[S]}getDragURI(S){return this.d.getDragURI(S)}getDragLabel(S,Q){if(this.d.getDragLabel)return this.d.getDragLabel(S,Q)}onDragStart(S,Q){this.d.onDragStart?.(S,Q)}onDragOver(S,Q,$,W){return this.d.onDragOver(S,Q,$,W)}onDragLeave(S,Q,$,W){this.d.onDragLeave?.(S,Q,$,W)}onDragEnd(S){this.d.onDragEnd?.(S)}drop(S,Q,$,W){this.d.drop(S,Q,$,W)}dispose(){this.d.dispose()}}class q{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),S=>this.G(S),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),S=>this.G(S),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let S=!1;const Q=s.Event.chain(this.y.add(new T.$QQ(this.k.domNode,"keydown")).event,V=>V.map(p=>new i.$QO(p)).filter(p=>S=p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$KP.stop(p,!0)).filter(()=>!1)),$=s.Event.chain(this.y.add(new T.$QQ(this.k.domNode,"keyup")).event,V=>V.forEach(()=>S=!1).map(p=>new i.$QO(p)).filter(p=>p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$KP.stop(p,!0)).map(({browserEvent:p})=>{const y=this.getFocus(),E=y.length?y[0]:void 0,M=typeof E<"u"?this.k.element(E):void 0,k=typeof E<"u"?this.k.domElement(E):this.k.domNode;return{index:E,element:M,anchor:k,browserEvent:p}})),W=s.Event.chain(this.k.onContextMenu,V=>V.filter(p=>!S).map(({element:p,index:y,browserEvent:E})=>({element:p,index:y,anchor:new b.$LO(E),browserEvent:E})));return s.Event.any(Q,$,W)}get onKeyDown(){return this.y.add(new T.$QQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new T.$QQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new T.$QQ(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new T.$QQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new T.$QQ(this.k.domNode,"blur",!0)).event)}constructor(S,Q,$,W,V=be){this.A=S,this.B=V,this.c=new o("focused"),this.f=new o("anchor"),this.g=new s.$Vd,this.x="",this.y=new e.$Qc,this.z=new s.$Nd,this.onDidDispose=this.z.event;const p=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(p!=="listbox");const y=[this.c.renderer,this.d.renderer];this.u=V.accessibilityProvider,this.u&&(y.push(new fe(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),W=W.map(M=>new ie(M.templateId,[...y,M]));const E={...V,dnd:V.dnd&&new Y(this,V.dnd)};if(this.k=this.C(Q,$,W,E),this.k.domNode.setAttribute("role",p),V.styleController)this.q=V.styleController(this.k.domId);else{const M=(0,v.$xP)(this.k.domNode);this.q=new re(M,this.k.domId)}if(this.o=new A.$UQ([new j(this.c,this.k,V.identityProvider),new j(this.d,this.k,V.identityProvider),new j(this.f,this.k,V.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new N(this,this.k)),(typeof V.keyboardSupport!="boolean"||V.keyboardSupport)&&(this.v=new B(this,this.k,V),this.y.add(this.v)),V.keyboardNavigationLabelProvider){const M=V.keyboardNavigationDelegate||t.$$Q;this.t=new I(this,this.k,V.keyboardNavigationLabelProvider,V.keyboardNavigationEventFilter??(()=>!0),M),this.y.add(this.t)}this.w=this.D(V),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(S,Q,$,W){return new r.$7Q(S,Q,$,W)}D(S){return new se(this)}updateOptions(S={}){this.B={...this.B,...S},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(S),this.v?.updateOptions(S),this.k.updateOptions(S)}get options(){return this.B}splice(S,Q,$=[]){if(S<0||S>this.k.length)throw new n.$WQ(this.A,`Invalid start index: ${S}`);if(Q<0)throw new n.$WQ(this.A,`Invalid delete count: ${Q}`);Q===0&&$.length===0||this.g.bufferEvents(()=>this.o.splice(S,Q,$))}updateWidth(S){this.k.updateWidth(S)}updateElementHeight(S,Q){this.k.updateElementHeight(S,Q,null)}rerender(){this.k.rerender()}element(S){return this.k.element(S)}indexOf(S){return this.k.indexOf(S)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(S){this.k.setScrollTop(S)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(S){this.k.setScrollLeft(S)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(S){this.x=S,this.k.domNode.setAttribute("aria-label",S)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(S,Q){this.k.layout(S,Q)}triggerTypeNavigation(){this.t?.trigger()}setSelection(S,Q){for(const $ of S)if($<0||$>=this.length)throw new n.$WQ(this.A,`Invalid index ${$}`);this.d.set(S,Q)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(S=>this.k.element(S))}setAnchor(S){if(typeof S>"u"){this.f.set([]);return}if(S<0||S>=this.length)throw new n.$WQ(this.A,`Invalid index ${S}`);this.f.set([S])}getAnchor(){return(0,u.$Nb)(this.f.get(),void 0)}getAnchorElement(){const S=this.getAnchor();return typeof S>"u"?void 0:this.element(S)}setFocus(S,Q){for(const $ of S)if($<0||$>=this.length)throw new n.$WQ(this.A,`Invalid index ${$}`);this.c.set(S,Q)}focusNext(S=1,Q=!1,$,W){if(this.length===0)return;const V=this.c.get(),p=this.E(V.length>0?V[0]+S:0,Q,W);p>-1&&this.setFocus([p],$)}focusPrevious(S=1,Q=!1,$,W){if(this.length===0)return;const V=this.c.get(),p=this.F(V.length>0?V[0]-S:0,Q,W);p>-1&&this.setFocus([p],$)}async focusNextPage(S,Q){let $=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);$=$===0?0:$-1;const W=this.getFocus()[0];if(W!==$&&(W===void 0||$>W)){const V=this.F($,!1,Q);V>-1&&W!==V?this.setFocus([V],S):this.setFocus([$],S)}else{const V=this.k.getScrollTop();let p=V+this.k.renderHeight;$>W&&(p-=this.k.elementHeight($)),this.k.setScrollTop(p),this.k.getScrollTop()!==V&&(this.setFocus([]),await(0,c.$Ug)(0),await this.focusNextPage(S,Q))}}async focusPreviousPage(S,Q){let $;const W=this.k.getScrollTop();W===0?$=this.k.indexAt(W):$=this.k.indexAfter(W-1);const V=this.getFocus()[0];if(V!==$&&(V===void 0||V>=$)){const p=this.E($,!1,Q);p>-1&&V!==p?this.setFocus([p],S):this.setFocus([$],S)}else{const p=W;this.k.setScrollTop(W-this.k.renderHeight),this.k.getScrollTop()!==p&&(this.setFocus([]),await(0,c.$Ug)(0),await this.focusPreviousPage(S,Q))}}focusLast(S,Q){if(this.length===0)return;const $=this.F(this.length-1,!1,Q);$>-1&&this.setFocus([$],S)}focusFirst(S,Q){this.focusNth(0,S,Q)}focusNth(S,Q,$){if(this.length===0)return;const W=this.E(S,!1,$);W>-1&&this.setFocus([W],Q)}E(S,Q=!1,$){for(let W=0;W<this.length;W++){if(S>=this.length&&!Q)return-1;if(S=S%this.length,!$||$(this.element(S)))return S;S++}return-1}F(S,Q=!1,$){for(let W=0;W<this.length;W++){if(S<0&&!Q)return-1;if(S=(this.length+S%this.length)%this.length,!$||$(this.element(S)))return S;S--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(S=>this.k.element(S))}reveal(S,Q){if(S<0||S>=this.length)throw new n.$WQ(this.A,`Invalid index ${S}`);const $=this.k.getScrollTop(),W=this.k.elementTop(S),V=this.k.elementHeight(S);if((0,g.$Cf)(Q)){const p=V-this.k.renderHeight;this.k.setScrollTop(p*(0,a.$Pl)(Q,0,1)+W)}else{const p=W+V,y=$+this.k.renderHeight;W<$&&p>=y||(W<$||p>=y&&V>=this.k.renderHeight?this.k.setScrollTop(W):p>=y&&this.k.setScrollTop(p-this.k.renderHeight))}}getRelativeTop(S){if(S<0||S>=this.length)throw new n.$WQ(this.A,`Invalid index ${S}`);const Q=this.k.getScrollTop(),$=this.k.elementTop(S),W=this.k.elementHeight(S);if($<Q||$+W>Q+this.k.renderHeight)return null;const V=W-this.k.renderHeight;return Math.abs((Q-$)/V)}isDOMFocused(){return(0,v.$qP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getElementID(S){return this.k.getElementDomId(S)}style(S){this.q.style(S)}G({indexes:S,browserEvent:Q}){return{indexes:S,elements:S.map($=>this.k.element($)),browserEvent:Q}}H(){const S=this.c.get();this.k.domNode.classList.toggle("element-focused",S.length>0),this.I()}I(){const S=this.c.get();if(S.length>0){let Q;this.u?.getActiveDescendantId&&(Q=this.u.getActiveDescendantId(this.k.element(S[0]))),this.k.domNode.setAttribute("aria-activedescendant",Q||this.k.getElementDomId(S[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const S=this.d.get();this.k.domNode.classList.toggle("selection-none",S.length===0),this.k.domNode.classList.toggle("selection-single",S.length===1),this.k.domNode.classList.toggle("selection-multiple",S.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$eR=q,Ye([O.$ih],q.prototype,"onDidChangeFocus",null),Ye([O.$ih],q.prototype,"onDidChangeSelection",null),Ye([O.$ih],q.prototype,"onContextMenu",null),Ye([O.$ih],q.prototype,"onKeyDown",null),Ye([O.$ih],q.prototype,"onKeyUp",null),Ye([O.$ih],q.prototype,"onKeyPress",null),Ye([O.$ih],q.prototype,"onDidFocus",null),Ye([O.$ih],q.prototype,"onDidBlur",null)}),define($e[61],pe([1,0,6,34,36,12,15]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$j=t.$0j=t.$9j=t.$8j=t.$7j=t.$6j=t.$5j=t.$4j=t.MarkdownStringTextNewlineStyle=void 0;var A;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class u{constructor(g="",n=!1){if(this.value=g,typeof this.value!="string")throw(0,v.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(g,n=0){return this.value+=s(this.supportThemeIcons?(0,T.$Xj)(g):g).replace(/([ \t]+)/g,(r,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,n){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(g,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(g),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(g,n){const r=new RegExp((0,U.$Fe)(n),"g");return g.replace(r,(b,f)=>g.charAt(f-1)!=="\\"?`\\${b}`:b)}}t.$4j=u;function c(h){return m(h)?!h.value:Array.isArray(h)?h.every(c):!0}t.$5j=c;function m(h){return h instanceof u?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}t.$6j=m;function O(h,g){return h===g?!0:!h||!g?!1:h.value===g.value&&h.isTrusted===g.isTrusted&&h.supportThemeIcons===g.supportThemeIcons&&h.supportHtml===g.supportHtml&&(h.baseUri===g.baseUri||!!h.baseUri&&!!g.baseUri&&(0,i.$og)(w.URI.from(h.baseUri),w.URI.from(g.baseUri)))}t.$7j=O;function s(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$8j=s;function l(h){return h.replace(/"/g,"&quot;")}t.$9j=l;function e(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$0j=e;function a(h){const g=[],n=h.split("|").map(b=>b.trim());h=n[0];const r=n[1];if(r){const b=/height=(\d+)/.exec(r),f=/width=(\d+)/.exec(r),o=b?b[1]:"",F=f?f[1]:"",j=isFinite(parseInt(F)),L=isFinite(parseInt(o));j&&g.push(`width="${F}"`),L&&g.push(`height="${o}"`)}return{href:h,dimensions:g}}t.$$j=a}),define($e[123],pe([1,0,3,115,21,54,14,19,116,6,4,61,34,76,27,2,78,52,29,50,36,12,15]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s,l,e,a,h,g,n,r,b,f,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=t.$kR=t.$jR=t.$iR=t.$hR=void 0;const F=Object.freeze({image:(Y,q,X)=>{let S=[],Q=[];return Y&&({href:Y,dimensions:S}=(0,O.$$j)(Y),Q.push(`src="${(0,O.$9j)(Y)}"`)),X&&Q.push(`alt="${(0,O.$9j)(X)}"`),q&&Q.push(`title="${(0,O.$9j)(q)}"`),S.length&&(Q=Q.concat(S)),"<img "+Q.join(" ")+">"},paragraph:Y=>`<p>${Y}</p>`,link:(Y,q,X)=>typeof Y!="string"?"":(Y===X&&(X=(0,O.$0j)(X)),q=typeof q=="string"?(0,O.$9j)((0,O.$0j)(q)):"",Y=(0,O.$0j)(Y),Y=Y.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Y}" title="${q||Y}">${X}</a>`)});function j(Y,q={},X={}){const S=new a.$Qc;let Q=!1;const $=(0,U.$PQ)(q),W=function(P){let H;try{H=(0,g.$mh)(decodeURIComponent(P))}catch{}return H?(H=(0,r.$0m)(H,x=>{if(Y.uris&&Y.uris[x])return o.URI.revive(Y.uris[x])}),encodeURIComponent(JSON.stringify(H))):P},V=function(P,H){const x=Y.uris&&Y.uris[P];let te=o.URI.revive(x);return H?P.startsWith(n.Schemas.data+":")?P:(te||(te=o.URI.parse(P)),n.$cg.uriToBrowserUri(te).toString(!0)):!te||o.URI.parse(P).toString()===te.toString()?P:(te.query&&(te=te.with({query:W(te.query)})),te.toString())},p=new h.marked.Renderer;p.image=F.image,p.link=F.link,p.paragraph=F.paragraph;const y=[],E=[];if(q.codeBlockRendererSync?p.code=(P,H)=>{const x=l.$AM.nextId(),te=q.codeBlockRendererSync(L(H),P);return E.push([x,te]),`<div class="code" data-code="${x}">${(0,f.$Ee)(P)}</div>`}:q.codeBlockRenderer&&(p.code=(P,H)=>{const x=l.$AM.nextId(),te=q.codeBlockRenderer(L(H),P);return y.push(te.then(ne=>[x,ne])),`<div class="code" data-code="${x}">${(0,f.$Ee)(P)}</div>`}),q.actionHandler){const P=function(te){let ne=te.target;if(!(ne.tagName!=="A"&&(ne=ne.parentElement,!ne||ne.tagName!=="A")))try{let ge=ne.dataset.href;ge&&(Y.baseUri&&(ge=d(o.URI.from(Y.baseUri),ge)),q.actionHandler.callback(ge,te))}catch(ge){(0,c.$Z)(ge)}finally{te.preventDefault()}},H=q.actionHandler.disposables.add(new i.$QQ($,"click")),x=q.actionHandler.disposables.add(new i.$QQ($,"auxclick"));q.actionHandler.disposables.add(m.Event.any(H.event,x.event)(te=>{const ne=new A.$LO(te);!ne.leftButton&&!ne.middleButton||P(ne)})),q.actionHandler.disposables.add(v.$TO($,"keydown",te=>{const ne=new w.$QO(te);!ne.equals(10)&&!ne.equals(3)||P(ne)}))}Y.supportHtml||(X.sanitizer=P=>(Y.isTrusted?P.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?P:"",X.sanitize=!0,X.silent=!0),X.renderer=p;let M=Y.value??"";M.length>1e5&&(M=`${M.substr(0,1e5)}\u2026`),Y.supportThemeIcons&&(M=(0,s.$Yj)(M));let k;if(q.fillInIncompleteTokens){const P={...h.marked.defaults,...X},H=h.marked.lexer(M,P),x=ue(H);k=h.marked.parser(x,P)}else k=h.marked.parse(M,X);Y.supportThemeIcons&&(k=(0,u.$fR)(k).map(H=>typeof H=="string"?H:H.outerHTML).join(""));const C=new DOMParser().parseFromString(D(Y,k),"text/html");if(C.body.querySelectorAll("img").forEach(P=>{const H=P.getAttribute("src");if(H){let x=H;try{Y.baseUri&&(x=d(o.URI.from(Y.baseUri),x))}catch{}P.src=V(x,!0)}}),C.body.querySelectorAll("a").forEach(P=>{const H=P.getAttribute("href");if(P.setAttribute("href",""),!H||/^data:|javascript:/i.test(H)||/^command:/i.test(H)&&!Y.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(H))P.replaceWith(...P.childNodes);else{let x=V(H,!1);Y.baseUri&&(x=d(o.URI.from(Y.baseUri),H)),P.dataset.href=x}}),$.innerHTML=D(Y,C.body.innerHTML),y.length>0)Promise.all(y).then(P=>{if(Q)return;const H=new Map(P),x=$.querySelectorAll("div[data-code]");for(const te of x){const ne=H.get(te.dataset.code??"");ne&&v.$RP(te,ne)}q.asyncRenderCallback?.()});else if(E.length>0){const P=new Map(E),H=$.querySelectorAll("div[data-code]");for(const x of H){const te=P.get(x.dataset.code??"");te&&v.$RP(x,te)}}if(q.asyncRenderCallback)for(const P of $.getElementsByTagName("img")){const H=S.add(v.$TO(P,"load",()=>{H.dispose(),q.asyncRenderCallback()}))}return{element:$,dispose:()=>{Q=!0,S.dispose()}}}t.$hR=j;function L(Y){if(!Y)return"";const q=Y.split(/[\s+|:|,|\{|\?]/,1);return q.length?q[0]:Y}function d(Y,q){return/^\w[\w\d+.-]*:/.test(q)?q:Y.path.endsWith("/")?(0,b.$yg)(Y,q).toString():(0,b.$yg)((0,b.$ug)(Y),q).toString()}function D(Y,q){const{config:X,allowedSchemes:S}=B(Y);T.addHook("uponSanitizeAttribute",($,W)=>{if(W.attrName==="style"||W.attrName==="class"){if($.tagName==="SPAN"){if(W.attrName==="style"){W.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(W.attrValue);return}else if(W.attrName==="class"){W.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(W.attrValue);return}}W.keepAttr=!1;return}});const Q=v.$_P(S);try{return T.sanitize(q,{...X,RETURN_TRUSTED_TYPE:!0})}finally{T.removeHook("uponSanitizeAttribute"),Q.dispose()}}t.$iR=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function B(Y){const q=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return Y.isTrusted&&q.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...v.$aQ],ALLOWED_ATTR:t.$iR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:q}}function z(Y){return typeof Y=="string"?Y:_(Y)}t.$jR=z;function _(Y){let q=Y.value??"";q.length>1e5&&(q=`${q.substr(0,1e5)}\u2026`);const X=h.marked.parse(q,{renderer:N.value}).replace(/&(#\d+|[a-zA-Z]+);/g,S=>I.get(S)??S);return D({isTrusted:!1},X).toString()}t.$kR=_;const I=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),N=new e.$U(()=>{const Y=new h.marked.Renderer;return Y.code=q=>q,Y.blockquote=q=>q,Y.html=q=>"",Y.heading=(q,X,S)=>q+`
`,Y.hr=()=>"",Y.list=(q,X)=>q,Y.listitem=q=>q+`
`,Y.paragraph=q=>q+`
`,Y.table=(q,X)=>q+X+`
`,Y.tablerow=q=>q,Y.tablecell=(q,X)=>q+" ",Y.strong=q=>q,Y.em=q=>q,Y.codespan=q=>q,Y.br=()=>`
`,Y.del=q=>q,Y.image=(q,X,S)=>"",Y.text=q=>q,Y.link=(q,X,S)=>S,Y});function Z(Y){let q="";return Y.forEach(X=>{q+=X.raw}),q}function ee(Y){for(const q of Y.tokens)if(q.type==="text"){const X=q.raw.split(`
`),S=X[X.length-1];if(S.includes("`"))return se(Y);if(S.includes("**"))return Te(Y);if(S.match(/\*\w/))return re(Y);if(S.match(/(^|\s)__\w/))return de(Y);if(S.match(/(^|\s)_\w/))return be(Y);if(S.match(/(^|\s)\[.*\]\(\w*/))return Se(Y);if(S.match(/(^|\s)\[\w/))return Oe(Y)}}function ue(Y){let q,X;for(q=0;q<Y.length;q++){const S=Y[q];if(S.type==="paragraph"&&S.raw.match(/(\n|^)```/)){X=ae(Y.slice(q));break}if(S.type==="paragraph"&&S.raw.match(/(\n|^)\|/)){X=fe(Y.slice(q));break}if(q===Y.length-1&&S.type==="paragraph"){const Q=ee(S);if(Q){X=[Q];break}}}if(X){const S=[...Y.slice(0,q),...X];return S.links=Y.links,S}return Y}t.$lR=ue;function ae(Y){const q=Z(Y);return h.marked.lexer(q+"\n```")}function se(Y){return ie(Y,"`")}function re(Y){return ie(Y,"*")}function be(Y){return ie(Y,"_")}function Se(Y){return ie(Y,")")}function Oe(Y){return ie(Y,"](about:blank)")}function Te(Y){return ie(Y,"**")}function de(Y){return ie(Y,"__")}function ie(Y,q){const X=Z(Array.isArray(Y)?Y:[Y]);return h.marked.lexer(X+q)[0]}function fe(Y){const q=Z(Y),X=q.split(`
`);let S,Q=!1;for(let $=0;$<X.length;$++){const W=X[$].trim();if(typeof S>"u"&&W.match(/^\s*\|/)){const V=W.match(/(\|[^\|]+)(?=\||$)/g);V&&(S=V.length)}else if(typeof S=="number")if(W.match(/^\s*\|/)){if($!==X.length-1)return;Q=!0}else return}if(typeof S=="number"&&S>0){const $=Q?X.slice(0,-1).join(`
`):q,W=!!$.match(/\|\s*$/),V=$+(W?"":"|")+`
|${" --- |".repeat(S)}`;return h.marked.lexer(V)}}}),define($e[124],pe([1,0,3,9,28,61,34,2,7,105]),function(oe,t,v,T,i,U,w,A,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HQ=t.$GQ=void 0;function m(l,e){(0,u.$yf)(e)?l.title=(0,w.$Zj)(e):e?.markdownNotSupportedFallback?l.title=e.markdownNotSupportedFallback:l.removeAttribute("title")}t.$GQ=m;class O{constructor(e,a,h){this.c=e,this.d=a,this.f=h}async update(e,a,h){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let g;if(e===void 0||(0,u.$yf)(e)||e instanceof HTMLElement)g=e;else if(!(0,u.$Mf)(e.markdown))g=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,c.localize)(0,null),a),this.b=new i.$Xd;const n=this.b.token;if(g=await e.markdown(n),g===void 0&&(g=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(g,a,h)}g(e,a,h){const g=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!g,...h};this.a=this.c.showHover(n,a)}g?.dispose()}h(e){return e?(0,U.$6j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(l,e,a,h){let g,n;const r=(j,L)=>{const d=n!==void 0;j&&(n?.dispose(),n=void 0),L&&(g?.dispose(),g=void 0),d&&l.onDidHideHover?.()},b=(j,L,d)=>new T.$5g(async()=>{(!n||n.isDisposed)&&(n=new O(l,d||e,j>0),await n.update(a,L,h))},j),f=()=>{if(g)return;const j=new A.$Qc,L=B=>r(!1,B.fromElement===e);j.add(v.$TO(e,v.$IP.MOUSE_LEAVE,L,!0));const d=()=>r(!0,!0);j.add(v.$TO(e,v.$IP.MOUSE_DOWN,d,!0));const D={targetElements:[e],dispose:()=>{}};if(l.placement===void 0||l.placement==="mouse"){const B=z=>{D.x=z.x+10,z.target instanceof HTMLElement&&z.target.classList.contains("action-label")&&r(!0,!0)};j.add(v.$TO(e,v.$IP.MOUSE_MOVE,B,!0))}j.add(b(l.delay,!1,D)),g=j},o=v.$TO(e,v.$IP.MOUSE_OVER,f,!0);return{show:j=>{r(!1,!0),b(0,j)},hide:()=>{r(!0,!0)},update:async(j,L)=>{a=j,await n?.update(a,void 0,L)},dispose:()=>{o.dispose(),r(!0,!0)}}}t.$HQ=s}),define($e[125],pe([1,0,3,21,14,123,38,11,4,43,2,5,107,98]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=void 0;const l=v.$,e="selectOption.entry.template";class a{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=v.$PP(n,l(".option-text")),r.detail=v.$PP(n,l(".option-detail")),r.decoratorRight=v.$PP(n,l(".option-decorator-right")),r}renderElement(n,r,b){const f=b,o=n.text,F=n.detail,j=n.decoratorRight,L=n.isDisabled;f.text.textContent=o,f.detail.textContent=F||"",f.decoratorRight.innerText=j||"",L?f.root.classList.add("option-disabled"):f.root.classList.remove("option-disabled")}disposeTemplate(n){}}class h extends m.$Rc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,b,f,o){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=f,this.g=o||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=h.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new u.$Nd,this.B(this.r),this.O(),this.N(b),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=v.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=v.$PP(this.w,l(".select-box-details-pane"));const r=v.$PP(this.w,l(".select-box-dropdown-container-width-control")),b=v.$PP(r,l(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",v.$PP(b,this.D),this.G=0,this.y=v.$xP(this.w),this.w.setAttribute("draggable","true"),this.B(v.$TO(this.w,v.$IP.DRAG_START,f=>{v.$KP.stop(f,!0)}))}O(){this.B(v.$UO(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(v.$TO(this.h,v.$IP.CLICK,r=>{v.$KP.stop(r),this.f?this.X(!0):this.W()})),this.B(v.$TO(this.h,v.$IP.MOUSE_DOWN,r=>{v.$KP.stop(r)}));let n;this.B(v.$TO(this.h,"touchstart",r=>{n=this.f})),this.B(v.$TO(this.h,"touchend",r=>{v.$KP.stop(r),n?this.X(!0):this.W()})),this.B(v.$TO(this.h,v.$IP.KEY_DOWN,r=>{const b=new i.$QO(r);let f=!1;O.$k?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&(f=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&(f=!0),f&&(this.W(),v.$KP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){A.$tb(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,f)=>{this.h.add(this.U(b.text,f,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=b}S(){const n=this.s.selectBackground??"",r=v.$8P(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,b){const f=document.createElement("option");return f.value=n,f.text=n,f.disabled=!!b,f}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,b)=>{this.hb(b),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=v.$vP(this.h),b=v.$_O(this.h),f=getComputedStyle(this.h),o=parseFloat(f.getPropertyValue("--dropdown-padding-top"))+parseFloat(f.getPropertyValue("--dropdown-padding-bottom")),F=r.innerHeight-b.top-b.height-(this.g.minBottomMargin||0),j=b.top-h.b,L=this.h.offsetWidth,d=this.bb(this.D),D=Math.max(d,Math.round(L)).toString()+"px";this.w.style.width=D,this.z.getHTMLElement().style.height="",this.z.layout();let B=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const z=this.H?this.L:0,_=B+o+z,I=Math.floor((F-o-z)/this.getHeight()),N=Math.floor((j-o-z)/this.getHeight());if(n)return b.top+b.height>r.innerHeight-22||b.top<h.b||I<1&&N<1?!1:(I<h.c&&N>I&&this.m.length>I?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(b.top+b.height>r.innerHeight-22||b.top<h.b||this.G===0&&I<1||this.G===1&&N<1)return this.X(!0),!1;if(this.G===0){if(this.f&&I+N<1)return this.X(!0),!1;_>F&&(B=I*this.getHeight())}else _>j&&(B=N*this.getHeight());return this.z.layout(B),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=B+o+"px",this.w.style.height=""):this.w.style.height=B+o+"px",this.hb(this.n),this.w.style.width=D,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let b=0,f=0;this.m.forEach((o,F)=>{const j=o.detail?o.detail.length:0,L=o.decoratorRight?o.decoratorRight.length:0,d=o.text.length+j+L;d>f&&(b=F,f=d)}),n.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),r=v.$bP(n)}return r}cb(n){if(this.z)return;this.C=v.$PP(n,l(".select-box-dropdown-list-container")),this.t=new a,this.z=new w.$eR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:f=>{let o=f.text;return f.detail&&(o+=`. ${f.detail}`),f.decoratorRight&&(o+=`. ${f.decoratorRight}`),f.description&&(o+=`. ${f.description}`),o},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>O.$k?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new T.$QQ(this.C,"keydown")),b=u.Event.chain(r.event,f=>f.filter(()=>this.z.length>0).map(o=>new i.$QO(o)));this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode===3))(this.jb,this)),this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode===2))(this.jb,this)),this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode===9))(this.ib,this)),this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode===16))(this.lb,this)),this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode===18))(this.kb,this)),this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode===12))(this.nb,this)),this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode===11))(this.mb,this)),this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode===14))(this.ob,this)),this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode===13))(this.pb,this)),this.B(u.Event.chain(b,f=>f.filter(o=>o.keyCode>=21&&o.keyCode<=56||o.keyCode>=85&&o.keyCode<=113))(this.qb,this)),this.B(v.$TO(this.z.getHTMLElement(),v.$IP.POINTER_UP,f=>this.db(f))),this.B(this.z.onMouseOver(f=>typeof f.index<"u"&&this.z.setFocus([f.index]))),this.B(this.z.onDidChangeFocus(f=>this.gb(f))),this.B(v.$TO(this.w,v.$IP.FOCUS_OUT,f=>{!this.f||v.$hP(f.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;v.$KP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const b=r.closest(".monaco-list-row");if(!b)return;const f=Number(b.getAttribute("data-index")),o=b.classList.contains("option-disabled");f>=0&&f<this.m.length&&!o&&(this.n=f,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const b=o=>{for(let F=0;F<o.childNodes.length;F++){const j=o.childNodes.item(F);(j.tagName&&j.tagName.toLowerCase())==="img"?o.removeChild(j):b(j)}},f=(0,U.$hR)({value:n,supportThemeIcons:!0},{actionHandler:r});return f.element.classList.add("select-box-description-markdown"),b(f.element),f.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],b=r?.description??"",f=r?.descriptionIsMarkdown??!1;if(b){if(f){const o=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(b,o))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){v.$KP.stop(n),this.select(this.F),this.X(!0)}jb(n){v.$KP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){v.$KP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(v.$KP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){v.$KP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){v.$KP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){v.$KP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){v.$KP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=c.KeyCodeUtils.toString(n.keyCode);let b=-1;for(let f=0;f<this.m.length-1;f++)if(b=(f+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===r&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),v.$KP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$mR=h}),define($e[126],pe([1,0,38,125,119,20,5,97]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pR=t.$oR=void 0,t.$oR={...v.$dR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends U.$qQ{constructor(c,m,O,s,l){super(),w.$k&&!l?.useCustomDrawn?this.a=new i.$nR(c,m,s,l):this.a=new T.$mR(c,m,O,s,l),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(c,m){this.a.setOptions(c,m)}select(c){this.a.select(c)}setAriaLabel(c){this.a.setAriaLabel(c)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(c){this.a.setFocusable(c)}render(c){this.a.render(c)}}t.$pR=A}),define($e[62],pe([1,0,16,53,3,23,124,126,35,2,5,7,102,51]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wR=t.$vR=t.$uR=void 0;class l extends c.$Rc{get action(){return this._action}constructor(g,n,r={}){super(),this.m=r,this._context=g||this,this._action=n,n instanceof u.$vi&&this.B(n.onDidChange(b=>{this.element&&this.t(b)}))}t(g){g.enabled!==void 0&&this.u(),g.checked!==void 0&&this.G(),g.class!==void 0&&this.F(),g.label!==void 0&&(this.w(),this.C()),g.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new u.$wi)),this.j}set actionRunner(g){this.j=g}isEnabled(){return this._action.enabled}setActionContext(g){this._context=g}render(g){const n=this.element=g;this.B(U.$mQ.addTarget(g));const r=this.m&&this.m.draggable;r&&(g.draggable=!0,v.$zO&&this.B((0,i.$TO)(g,i.$IP.DRAG_START,b=>b.dataTransfer?.setData(T.$kQ.TEXT,this._action.label)))),this.B((0,i.$TO)(n,U.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$TO)(n,i.$IP.MOUSE_DOWN,b=>{r||i.$KP.stop(b,!0),this._action.enabled&&b.button===0&&n.classList.add("active")})),m.$k&&this.B((0,i.$TO)(n,i.$IP.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$TO)(n,i.$IP.CLICK,b=>{i.$KP.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$TO)(n,i.$IP.DBLCLICK,b=>{i.$KP.stop(b,!0)})),[i.$IP.MOUSE_UP,i.$IP.MOUSE_OUT].forEach(b=>{this.B((0,i.$TO)(n,b,f=>{i.$KP.stop(f),n.classList.remove("active")}))})}onClick(g,n=!1){i.$KP.stop(g,!0);const r=O.$Hf(this._context)?this.m?.useEventAsContext?g:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(g){this.element&&(this.element.tabIndex=g?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const g=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(g):(this.f=(0,w.$HQ)(this.m.hoverDelegate,this.element,g),this.q.add(this.f))):this.element.title=g}D(){if(this.element){const g=this.z()??"";this.element.setAttribute("aria-label",g)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$uR=l;class e extends l{constructor(g,n,r){super(g,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(g){super.render(g),O.$If(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===u.$xi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(g){this.H&&(this.H.tabIndex=g?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let g=null;return this.action.tooltip?g=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(g=this.action.label,this.m.keybinding&&(g=s.localize(0,null,g,this.m.keybinding))),g??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const g=this.z()??"";this.H.setAttribute("aria-label",g)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$vR=e;class a extends l{constructor(g,n,r,b,f,o,F){super(g,n),this.b=new A.$pR(r,b,f,o,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(g,n){this.b.setOptions(g,n)}select(g){this.b.select(g)}g(){this.B(this.b.onDidSelect(g=>this.n(g.selected,g.index)))}n(g,n){this.actionRunner.run(this._action,this.r(g,n))}r(g,n){return g}setFocusable(g){this.b.setFocusable(g)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(g){this.b.render(g)}}t.$wR=a}),define($e[63],pe([1,0,3,14,62,35,4,2,7,51]),function(oe,t,v,T,i,U,w,A,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JQ=t.$IQ=t.ActionsOrientation=void 0;var c;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(c||(t.ActionsOrientation=c={}));class m extends A.$Rc{constructor(l,e={}){super(),this.g=this.B(new A.$Qc),this.r=this.B(new A.$Zc),this.w=!1,this.y=!0,this.C=this.B(new w.$Nd),this.onDidBlur=this.C.event,this.D=this.B(new w.$Nd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new w.$Nd),this.onDidRun=this.G.event,this.H=this.B(new w.$Nd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$wi,this.g.add(this.f)),this.g.add(this.f.onDidRun(g=>this.G.fire(g))),this.g.add(this.f.onWillRun(g=>this.H.fire(g))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let a,h;switch(this.m){case 0:a=[15],h=[17];break;case 1:a=[16],h=[18],this.domNode.className+=" vertical";break}this.B(v.$TO(this.domNode,v.$IP.KEY_DOWN,g=>{const n=new T.$QO(g);let r=!0;const b=typeof this.t=="number"?this.viewItems[this.t]:void 0;a&&(n.equals(a[0])||n.equals(a[1]))?r=this.P():h&&(n.equals(h[0])||n.equals(h[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&b instanceof i.$uR&&b.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(v.$TO(this.domNode,v.$IP.KEY_UP,g=>{const n=new T.$QO(g);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(v.$NP(this.domNode)),this.B(this.u.onDidBlur(()=>{(v.$pP()===this.domNode||!v.$hP(v.$pP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),l.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(l){l?this.z.setAttribute("aria-label",l):this.z.removeAttribute("aria-label")}setFocusable(l){if(this.y=l,this.y){const e=this.viewItems.find(a=>a instanceof i.$uR&&a.isEnabled());e instanceof i.$uR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$uR&&e.setFocusable(!1)})}J(l){let e=!1;return this.n.keys.forEach(a=>{e=e||l.equals(a)}),e}L(){for(let l=0;l<this.z.children.length;l++){const e=this.z.children[l];if(v.$hP(v.$pP(),e)){this.t=l,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(l){this.j=l,this.viewItems.forEach(e=>e.setActionContext(l))}get actionRunner(){return this.f}set actionRunner(l){this.f=l,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=l)}getContainer(){return this.domNode}hasAction(l){return this.viewItems.findIndex(e=>e.action.id===l.id)!==-1}getAction(l){if(typeof l=="number")return this.viewItems[l]?.action;if(l instanceof HTMLElement){for(;l.parentElement!==this.z;){if(!l.parentElement)return;l=l.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===l)return this.viewItems[e].action}}push(l,e={}){const a=Array.isArray(l)?l:[l];let h=u.$Cf(e.index)?e.index:null;a.forEach(g=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(g,b)),r||(r=new i.$vR(this.context,g,b)),this.b.allowContextMenu||this.r.set(r,v.$TO(n,v.$IP.CONTEXT_MENU,f=>{v.$KP.stop(f,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$uR&&this.viewItems.length===0&&r.setFocusable(!0),h===null||h<0||h>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[h]),this.viewItems.splice(h,0,r),h++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(l){if(l>=0&&l<this.z.children.length){const e=this.z.children.item(l);if(e)return e.clientWidth}return 0}getHeight(l){if(l>=0&&l<this.z.children.length){const e=this.z.children.item(l);if(e)return e.clientHeight}return 0}pull(l){l>=0&&l<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[l]),this.r.deleteAndDispose(this.viewItems[l]),(0,A.$Mc)(this.viewItems.splice(l,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,A.$Mc)(this.viewItems),this.r.clearAndDisposeAll(),v.$SO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(l){let e=!1,a;if(l===void 0?e=!0:typeof l=="number"?a=l:typeof l=="boolean"&&(e=l),e&&typeof this.t>"u"){const h=this.viewItems.findIndex(g=>g.isEnabled());this.t=h===-1?void 0:h,this.Q(void 0,void 0,!0)}else a!==void 0&&(this.t=a),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(l){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let a;do{if(!l&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,a=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===U.$xi.ID));return this.Q(),!0}P(l){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let a;do{if(this.t=this.t-1,this.t<0){if(!l&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}a=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===U.$xi.ID));return this.Q(!0),!0}Q(l,e,a=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const h=this.t!==void 0?this.viewItems[this.t]:void 0;if(h){let g=!0;u.$Mf(h.focus)||(g=!1),this.b.focusOnlyEnabledItems&&u.$Mf(h.isEnabled)&&!h.isEnabled()&&(g=!1),h.action.id===U.$xi.ID&&(g=!1),g&&h.showHover?.(),g?(a||this.s!==this.t)&&(h.focus(l),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(l){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$uR){const a=e._context===null||e._context===void 0?l:e._context;this.run(e._action,a)}}async run(l,e){await this.f.run(l,e)}dispose(){this.j=void 0,this.viewItems=(0,A.$Mc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$IQ=m;function O(s){if(!s.length)return s;let l=-1;for(let a=0;a<s.length;a++)if(s[a].id!==U.$xi.ID){l=a;break}if(l===-1)return[];s=s.slice(l);for(let a=s.length-1;a>=0&&s[a].id===U.$xi.ID;a--)s.splice(a,1);let e=!1;for(let a=s.length-1;a>=0;a--){const h=s[a].id===U.$xi.ID;h&&!e?s.splice(a,1):h?h&&(e=!1):e=!0}return s}t.$JQ=O}),define($e[64],pe([1,0,3,21,54,63,56,59,20,4,80,50,106,94]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bS=t.$aS=t.$_R=t.MessageType=void 0;const l=v.$;var e;(function(g){g[g.INFO=1]="INFO",g[g.WARNING=2]="WARNING",g[g.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$_R={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class a extends u.$qQ{constructor(n,r,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new c.$Nd),this.onDidChange=this.O.event,this.P=this.B(new c.$Nd),this.onDidHeightChange=this.P.event,this.a=r,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=v.$PP(n,l(".monaco-inputbox.idle"));const f=this.g.flexibleHeight?"textarea":"input",o=v.$PP(this.element,l(".ibwrapper"));if(this.b=v.$PP(o,l(f+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=v.$PP(o,l("div.mirror")),this.y.innerText="\xA0",this.N=new A.$AQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),v.$PP(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(L=>this.b.scrollTop=L.scrollTop));const F=this.B(new T.$QQ(n.ownerDocument,"selectionchange")),j=c.Event.filter(F.event,()=>n.ownerDocument.getSelection()?.anchorNode===o);this.B(j(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$IQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:v.$fP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return v.$qP(this.b)}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return v.$bP(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,f=parseFloat(this.y.style.paddingRight||"")||0;r=b+f}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:b})}showMessage(n,r){if(this.w==="open"&&(0,O.$_m)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${v.$8P(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=v.$bP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:f=>{if(!this.h)return null;n=v.$PP(f,l(".monaco-inputbox-container")),r();const o={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,i.$OQ)(this.h.content,o):(0,i.$NQ)(this.h.content,o);F.classList.add(this.U(this.h.type));const j=this.stylesForType(this.h.type);return F.style.backgroundColor=j.background??"",F.style.color=j.foreground??"",F.style.border=j.border?`1px solid ${j.border}`:"",v.$PP(n,F),null},onHide:()=>{this.w="closed"},layout:r});let b;this.h.type===3?b=s.localize(0,null,this.h.content):this.h.type===2?b=s.localize(1,null,this.h.content):b=s.localize(2,null,this.h.content),w.$SQ(b),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,b=n.charCodeAt(n.length-1)===10?" ":"";(n+b).replace(/\u000c/g,"")?this.y.textContent=n+b:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",b=n.inputForeground??"",f=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${v.$8P(f,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=v.$fP(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,b=r.selectionStart,f=r.selectionEnd,o=r.value;b!==null&&f!==null&&(this.value=o.substr(0,b)+n+o.substr(f),r.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$aS=a;class h extends a{constructor(n,r,b){const f=s.localize(3,null,"\u21C5"),o=s.localize(4,null,"\u21C5");super(n,r,b),this.db=this.B(new c.$Nd),this.onDidFocus=this.db.event,this.eb=this.B(new c.$Nd),this.onDidBlur=this.eb.event,this.bb=new m.$0R(b.history,100);const F=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(f)&&!this.n.endsWith(o)&&this.bb.getHistory().length){const j=this.n.endsWith(")")?f:o,L=this.n+j;b.showPlaceholderOnFocus&&!v.$qP(this.b)?this.n=L:this.setPlaceHolder(L)}};this.cb=new MutationObserver((j,L)=>{j.forEach(d=>{d.target.textContent||F()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>F()),this.F(this.b,()=>{const j=L=>{if(this.n.endsWith(L)){const d=this.n.slice(0,this.n.length-L.length);return b.showPlaceholderOnFocus?this.n=d:this.setPlaceHolder(d),!0}else return!1};j(o)||j(f)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach(b=>{this.bb.add(b)}),r.forEach(b=>{this.bb.add(b)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",w.$TQ(this.value?this.value:s.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,w.$TQ(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(n){super.setPlaceHolder(n),this.setTooltip(n)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$bS=h}),define($e[65],pe([1,0,62,20,17,18,4,3,99]),function(oe,t,v,T,i,U,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tR=t.$sR=t.$rR=t.$qR=void 0,t.$qR={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class u extends v.$uR{constructor(s,l,e){super(s,l,e),this.a=this.B(new c({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:e.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:e.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:e.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$rR=u;class c extends T.$qQ{constructor(s){super(),this.a=this.B(new w.$Nd),this.onChange=this.a.event,this.b=this.B(new w.$Nd),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const l=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,l.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&l.push(...this.c.actionClassName.split(" ")),this.s&&l.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...l),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,e=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),e.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this.s,this.a.fire(!0),e.preventDefault(),e.stopPropagation();return}this.b.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(s){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.domNode.title=s,this.domNode.setAttribute("aria-label",s)}}t.$sR=c;class m extends T.$qQ{constructor(s,l,e){super(),this.c=s,this.g=l,this.a=new c({title:this.c,isChecked:this.g,icon:i.$Vj.check,actionClassName:"monaco-checkbox",...t.$qR}),this.domNode=this.a.domNode,this.b=e,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(s){this.a.checked=s,this.h()}focus(){this.domNode.focus()}hasFocus(){return(0,A.$qP)(this.domNode)}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$tR=m}),define($e[127],pe([1,0,65,17,104]),function(oe,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oS=t.$nS=t.$mS=void 0;const U=i.localize(0,null),w=i.localize(1,null),A=i.localize(2,null);class u extends v.$sR{constructor(s){super({icon:T.$Vj.caseSensitive,title:U+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$mS=u;class c extends v.$sR{constructor(s){super({icon:T.$Vj.wholeWord,title:w+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$nS=c;class m extends v.$sR{constructor(s){super({icon:T.$Vj.regex,title:A+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$oS=m}),define($e[128],pe([1,0,3,127,64,20,4,103,2,93]),function(oe,t,v,T,i,U,w,A,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pS=void 0;const c=A.localize(0,null);class m extends U.$qQ{static{this.OPTION_CHANGE="optionChange"}constructor(s,l,e){super(),this.n=!0,this.s=!1,this.w=this.B(new u.$Sc),this.N=[],this.O=this.B(new w.$Nd),this.onDidOptionChange=this.O.event,this.P=this.B(new w.$Nd),this.onKeyDown=this.P.event,this.Q=this.B(new w.$Nd),this.onMouseDown=this.Q.event,this.R=this.B(new w.$Nd),this.onInput=this.R.event,this.S=this.B(new w.$Nd),this.onKeyUp=this.S.event,this.U=this.B(new w.$Nd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new w.$Nd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||c,this.h=!!e.showCommonFindToggles;const a=e.appendCaseSensitiveLabel||"",h=e.appendWholeWordsLabel||"",g=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,b=!!e.flexibleWidth,f=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$bS(this.domNode,l,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:b,flexibleMaxHeight:f,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new T.$oS({appendTitle:g,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new T.$nS({appendTitle:h,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new T.$mS({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const o=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const j=o.indexOf(this.domNode.ownerDocument.activeElement);if(j>=0){let L=-1;F.equals(17)?L=(j+1)%o.length:F.equals(15)&&(j===0?L=o.length-1:L=j-1),F.equals(9)?(o[j].blur(),this.inputBox.focus()):L>=0&&o[L].focus(),v.$KP.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(v.$TO(this.inputBox.inputElement,"compositionstart",o=>{this.s=!0})),this.B(v.$TO(this.inputBox.inputElement,"compositionend",o=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,o=>this.P.fire(o)),this.C(this.inputBox.inputElement,o=>this.S.fire(o)),this.D(this.inputBox.inputElement,o=>this.R.fire()),this.j(this.inputBox.inputElement,o=>this.Q.fire(o))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const l of this.N)l.domNode.remove();this.N=[],this.w.value=new u.$Qc;for(const l of s??[])this.w.value.add(l),this.y.appendChild(l.domNode),this.w.value.add(l.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(l);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((l,e)=>l+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$pS=m}),define($e[129],pe([1,0,3,21,14,63,128,64,60,38,65,57,24,35,11,9,17,18,31,4,33,2,45,7,108,100]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s,l,e,a,h,g,n,r,b,f,o,F,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZS=t.TreeFindMatchType=t.TreeFindMode=t.$YS=t.$XS=t.RenderIndentGuides=t.$WS=t.$VS=void 0;class L extends u.$4Q{set context($){this.c.context=$}get context(){return this.c.context}constructor($){super($.elements.map(W=>W.element)),this.c=$}}function d(Q){return Q instanceof u.$4Q?new L(Q):Q}class D{constructor($,W){this.d=$,this.f=W,this.b=f.$Rc.None,this.c=new f.$Qc}getDragURI($){return this.f.getDragURI($.element)}getDragLabel($,W){if(this.f.getDragLabel)return this.f.getDragLabel($.map(V=>V.element),W)}onDragStart($,W){this.f.onDragStart?.(d($),W)}onDragOver($,W,V,p,y=!0){const E=this.f.onDragOver(d($),W&&W.element,V,p),M=this.a!==W;if(M&&(this.b.dispose(),this.a=W),typeof W>"u")return E;if(M&&typeof E!="boolean"&&E.autoExpand&&(this.b=(0,a.$Vg)(()=>{const H=this.d(),x=H.getNodeLocation(W);H.isCollapsed(x)&&H.setCollapsed(x,!1),this.a=void 0},500,this.c)),typeof E=="boolean"||!E.accept||typeof E.bubble>"u"||E.feedback){if(!y){const H=typeof E=="boolean"?E:E.accept,x=typeof E=="boolean"?void 0:E.effect;return{accept:H,effect:x,feedback:[V]}}return E}if(E.bubble===1){const H=this.d(),x=H.getNodeLocation(W),te=H.getParentNodeLocation(x),ne=H.getNode(te),ge=te&&H.getListIndex(te);return this.onDragOver($,ne,ge,p,!1)}const k=this.d(),R=k.getNodeLocation(W),C=k.getListIndex(R),P=k.getListRenderCount(R);return{...E,feedback:(0,e.$Rb)(C,C+P)}}drop($,W,V,p){this.b.dispose(),this.a=void 0,this.f.drop(d($),W&&W.element,V,p)}onDragEnd($){this.f.onDragEnd?.($)}dispose(){this.c.dispose(),this.f.dispose()}}function B(Q,$){return $&&{...$,identityProvider:$.identityProvider&&{getId(W){return $.identityProvider.getId(W.element)}},dnd:$.dnd&&new D(Q,$.dnd),multipleSelectionController:$.multipleSelectionController&&{isSelectionSingleChangeEvent(W){return $.multipleSelectionController.isSelectionSingleChangeEvent({...W,element:W.element})},isSelectionRangeChangeEvent(W){return $.multipleSelectionController.isSelectionRangeChangeEvent({...W,element:W.element})}},accessibilityProvider:$.accessibilityProvider&&{...$.accessibilityProvider,getSetSize(W){const V=Q(),p=V.getNodeLocation(W),y=V.getParentNodeLocation(p);return V.getNode(y).visibleChildrenCount},getPosInSet(W){return W.visibleChildIndex+1},isChecked:$.accessibilityProvider&&$.accessibilityProvider.isChecked?W=>$.accessibilityProvider.isChecked(W.element):void 0,getRole:$.accessibilityProvider&&$.accessibilityProvider.getRole?W=>$.accessibilityProvider.getRole(W.element):()=>"treeitem",getAriaLabel(W){return $.accessibilityProvider.getAriaLabel(W.element)},getWidgetAriaLabel(){return $.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:$.accessibilityProvider&&$.accessibilityProvider.getWidgetRole?()=>$.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:$.accessibilityProvider&&$.accessibilityProvider.getAriaLevel?W=>$.accessibilityProvider.getAriaLevel(W.element):W=>W.depth,getActiveDescendantId:$.accessibilityProvider.getActiveDescendantId&&(W=>$.accessibilityProvider.getActiveDescendantId(W.element))},keyboardNavigationLabelProvider:$.keyboardNavigationLabelProvider&&{...$.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(W){return $.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(W.element)}}}}class z{constructor($){this.a=$}getHeight($){return this.a.getHeight($.element)}getTemplateId($){return this.a.getTemplateId($.element)}hasDynamicHeight($){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight($.element)}setDynamicHeight($,W){this.a.setDynamicHeight?.($.element,W)}}t.$VS=z;class _{static lift($){return $ instanceof _?$:new _($)}static empty($=0){return new _({focus:[],selection:[],expanded:Object.create(null),scrollTop:$})}constructor($){if(this.focus=new Set($.focus),this.selection=new Set($.selection),$.expanded instanceof Array){this.expanded=Object.create(null);for(const W of $.expanded)this.expanded[W]=1}else this.expanded=$.expanded;this.expanded=$.expanded,this.scrollTop=$.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$WS=_;var I;(function(Q){Q.None="none",Q.OnHover="onHover",Q.Always="always"})(I||(t.RenderIndentGuides=I={}));class N{get elements(){return this.b}constructor($,W=[]){this.b=W,this.a=new f.$Qc,this.onDidChange=r.Event.forEach($,V=>this.b=V,this.a)}dispose(){this.a.dispose()}}class Z{static{this.a=8}constructor($,W,V,p,y,E={}){this.o=$,this.p=W,this.q=p,this.s=y,this.b=new Map,this.c=new Map,this.d=Z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=f.$Rc.None,this.m=new f.$Qc,this.templateId=$.templateId,this.updateOptions(E),r.Event.map(V,M=>M.node)(this.u,this,this.m),$.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions($={}){if(typeof $.indent<"u"){const W=(0,o.$Pl)($.indent,0,40);if(W!==this.d){this.d=W;for(const[V,p]of this.c)this.v(V,p)}}if(typeof $.renderIndentGuides<"u"){const W=$.renderIndentGuides!==I.None;if(W!==this.g){this.g=W;for(const[V,p]of this.c)this.w(V,p);if(this.k.dispose(),W){const V=new f.$Qc;this.q.onDidChange(this.x,this,V),this.k=V,this.x(this.q.elements)}}}typeof $.hideTwistiesOfChildlessElements<"u"&&(this.f=$.hideTwistiesOfChildlessElements)}renderTemplate($){const W=(0,v.$PP)($,(0,v.$)(".monaco-tl-row")),V=(0,v.$PP)(W,(0,v.$)(".monaco-tl-indent")),p=(0,v.$PP)(W,(0,v.$)(".monaco-tl-twistie")),y=(0,v.$PP)(W,(0,v.$)(".monaco-tl-contents")),E=this.o.renderTemplate(y);return{container:$,indent:V,twistie:p,indentGuidesDisposable:f.$Rc.None,templateData:E}}renderElement($,W,V,p){this.c.set($,V),this.b.set($.element,$),this.v($,V),this.o.renderElement($,W,V.templateData,p)}disposeElement($,W,V,p){V.indentGuidesDisposable.dispose(),this.o.disposeElement?.($,W,V.templateData,p),typeof p=="number"&&(this.c.delete($),this.b.delete($.element))}disposeTemplate($){this.o.disposeTemplate($.templateData)}t($){const W=this.b.get($);W&&this.u(W)}u($){const W=this.c.get($);W&&(this.x(this.q.elements),this.v($,W))}v($,W){const V=Z.a+($.depth-1)*this.d;W.twistie.style.paddingLeft=`${V}px`,W.indent.style.width=`${V+this.d-16}px`,$.collapsible?W.container.setAttribute("aria-expanded",String(!$.collapsed)):W.container.removeAttribute("aria-expanded"),W.twistie.classList.remove(...g.ThemeIcon.asClassNameArray(h.$Vj.treeItemExpanded));let p=!1;this.o.renderTwistie&&(p=this.o.renderTwistie($.element,W.twistie)),$.collapsible&&(!this.f||$.visibleChildrenCount>0)?(p||W.twistie.classList.add(...g.ThemeIcon.asClassNameArray(h.$Vj.treeItemExpanded)),W.twistie.classList.add("collapsible"),W.twistie.classList.toggle("collapsed",$.collapsed)):W.twistie.classList.remove("collapsible","collapsed"),this.w($,W)}w($,W){if((0,v.$SO)(W.indent),W.indentGuidesDisposable.dispose(),!this.g)return;const V=new f.$Qc,p=this.p();for(;;){const y=p.getNodeLocation($),E=p.getParentNodeLocation(y);if(!E)break;const M=p.getNode(E),k=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(M)&&k.classList.add("active"),W.indent.childElementCount===0?W.indent.appendChild(k):W.indent.insertBefore(k,W.indent.firstElementChild),this.s.add(M,k),V.add((0,f.$Pc)(()=>this.s.delete(M,k))),$=M}W.indentGuidesDisposable=V}x($){if(!this.g)return;const W=new Set,V=this.p();$.forEach(p=>{const y=V.getNodeLocation(p);try{const E=V.getParentNodeLocation(y);p.collapsible&&p.children.length>0&&!p.collapsed?W.add(p):E&&W.add(V.getNode(E))}catch{}}),this.j.forEach(p=>{W.has(p)||this.s.forEach(p,y=>y.classList.remove("active"))}),W.forEach(p=>{this.j.has(p)||this.s.forEach(p,y=>y.classList.add("active"))}),this.j=W}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,f.$Mc)(this.m)}}class ee{get totalCount(){return this.a}get matchCount(){return this.b}set pattern($){this.c=$,this.d=$.toLowerCase()}constructor($,W,V){this.g=$,this.j=W,this.k=V,this.a=0,this.b=0,this.c="",this.d="",this.f=new f.$Qc,$.onWillRefilter(this.m,this,this.f)}filter($,W){let V=1;if(this.k){const E=this.k.filter($,W);if(typeof E=="boolean"?V=E?1:0:(0,O.$SS)(E)?V=(0,O.$TS)(E.visibility):V=E,V===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:V};const p=this.j.getKeyboardNavigationLabel($),y=Array.isArray(p)?p:[p];for(const E of y){const M=E&&E.toString();if(typeof M>"u")return{data:b.FuzzyScore.Default,visibility:V};let k;if(this.g.findMatchType===be.Contiguous){const R=M.toLowerCase().indexOf(this.d);if(R>-1){k=[Number.MAX_SAFE_INTEGER,0];for(let C=this.d.length;C>0;C--)k.push(R+C-1)}}else k=(0,b.$Qj)(this.c,this.d,0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(k)return this.b++,y.length===1?{data:k,visibility:V}:{data:{label:M,score:k},visibility:V}}return this.g.findMode===re.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility($):2:{data:b.FuzzyScore.Default,visibility:V}}m(){this.a=0,this.b=0}dispose(){(0,f.$Mc)(this.f)}}class ue extends m.$sR{constructor($){super({icon:h.$Vj.listFilter,title:(0,j.localize)(0,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$XS=ue;class ae extends m.$sR{constructor($){super({icon:h.$Vj.searchFuzzy,title:(0,j.localize)(1,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$YS=ae;const se={inputBoxStyles:A.$_R,toggleStyles:m.$qR,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var re;(function(Q){Q[Q.Highlight=0]="Highlight",Q[Q.Filter=1]="Filter"})(re||(t.TreeFindMode=re={}));var be;(function(Q){Q[Q.Fuzzy=0]="Fuzzy",Q[Q.Contiguous=1]="Contiguous"})(be||(t.TreeFindMatchType=be={}));class Se extends f.$Rc{set mode($){this.b.checked=$===re.Filter,this.f.inputBox.setPlaceHolder($===re.Filter?(0,j.localize)(2,null):(0,j.localize)(3,null))}set matchType($){this.c.checked=$===be.Fuzzy}get value(){return this.f.inputBox.value}set value($){this.f.inputBox.value=$}constructor($,W,V,p,y,E){super(),this.t=W,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Nd,this.onDidDisable=this._onDidDisable.event,$.appendChild(this.a.root),this.B((0,f.$Pc)(()=>$.removeChild(this.a.root)));const M=E?.styles??se;M.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=M.listFilterWidgetBackground),M.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${M.listFilterWidgetShadow}`),this.b=this.B(new ue({...M.toggleStyles,isChecked:p===re.Filter})),this.c=this.B(new ae({...M.toggleStyles,isChecked:y===be.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?re.Filter:re.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?be.Fuzzy:be.Contiguous,this.q),this.f=this.B(new w.$pS(this.a.findInput,V,{label:(0,j.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:M.inputBoxStyles,toggleStyles:M.toggleStyles,history:E?.history})),this.g=this.B(new U.$IQ(this.a.actionbar)),this.mode=p;const k=this.B(new T.$QQ(this.f.inputBox.inputElement,"keydown")),R=r.Event.chain(k.event,x=>x.map(te=>new i.$QO(te)));this.B(R(x=>{if(x.equals(3)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(x.equals(18)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(x.equals(16)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const C=this.B(new l.$vi("close",(0,j.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(C,{icon:!0,label:!1});const P=this.B(new T.$QQ(this.a.grab,"mousedown"));this.B(P.event(x=>{const te=new f.$Qc,ne=te.add(new T.$QQ((0,v.$vP)(x),"mousemove")),ge=te.add(new T.$QQ((0,v.$vP)(x),"mouseup")),ve=this.m,Ce=x.pageX,Ae=this.s,De=x.pageY;this.a.grab.classList.add("grabbing");const Re=this.a.root.style.transition;this.a.root.style.transition="unset";const Fe=Qe=>{const ze=Qe.pageX-Ce;this.m=ve-ze;const Me=Qe.pageY-De;this.s=Ae+Me,this.layout()};te.add(ne.event(Fe)),te.add(ge.event(Qe=>{Fe(Qe),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Re,te.dispose()}))}));const H=r.Event.chain(this.B(new T.$QQ(this.a.grab,"keydown")).event,x=>x.map(te=>new i.$QO(te)));this.B(H(x=>{let te,ne;if(x.keyCode===15?te=Number.POSITIVE_INFINITY:x.keyCode===17?te=0:x.keyCode===10&&(te=this.m===0?Number.POSITIVE_INFINITY:0),x.keyCode===16?ne=0:x.keyCode===18&&(ne=Number.POSITIVE_INFINITY),te!==void 0&&(x.preventDefault(),x.stopPropagation(),this.m=te,this.layout()),ne!==void 0){x.preventDefault(),x.stopPropagation(),this.s=ne;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout($=this.j){this.j=$,this.m=(0,o.$Pl)(this.m,0,Math.max(0,$-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$Pl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage($){this.f.showMessage($)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,a.$Ug)(300),super.dispose()}}class Oe{get pattern(){return this.b}get mode(){return this.d}set mode($){$!==this.d&&(this.d=$,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire($))}get matchType(){return this.f}set matchType($){$!==this.f&&(this.f=$,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire($))}constructor($,W,V,p,y,E={}){this.t=$,this.u=V,this.v=p,this.w=y,this.x=E,this.b="",this.c="",this.j=0,this.k=new r.$Nd,this.onDidChangeMode=this.k.event,this.m=new r.$Nd,this.onDidChangeMatchType=this.m.event,this.o=new r.$Nd,this.onDidChangePattern=this.o.event,this.p=new r.$Nd,this.onDidChangeOpenState=this.p.event,this.q=new f.$Qc,this.s=new f.$Qc,this.d=$.options.defaultFindMode??re.Highlight,this.f=$.options.defaultFindMatchType??be.Fuzzy,W.onDidSplice(this.z,this,this.s)}updateOptions($={}){$.defaultFindMode!==void 0&&(this.mode=$.defaultFindMode),$.defaultFindMatchType!==void 0&&(this.matchType=$.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Se(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode($=>this.mode=$,void 0,this.q),this.g.onDidChangeMatchType($=>this.matchType=$,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y($){this.b=$,this.o.fire($),this.v.pattern=$,this.t.refilter(),$&&this.t.focusNext(0,!0,void 0,V=>!b.FuzzyScore.isDefault(V.filterData));const W=this.t.getFocus();if(W.length>0){const V=W[0];this.t.getRelativeTop(V)===null&&this.t.reveal(V,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const $=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&$?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,j.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus($){return!this.g||!this.pattern||this.d===re.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault($.filterData)}layout($){this.j=$,this.g?.layout($)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Te(Q){let $=s.TreeMouseEventTarget.Unknown;return(0,v.$lP)(Q.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?$=s.TreeMouseEventTarget.Twistie:(0,v.$lP)(Q.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?$=s.TreeMouseEventTarget.Element:(0,v.$lP)(Q.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&($=s.TreeMouseEventTarget.Filter),{browserEvent:Q.browserEvent,element:Q.element?Q.element.element:null,target:$}}function de(Q){return{element:Q.element?Q.element.element:null,browserEvent:Q.browserEvent,anchor:Q.anchor}}function ie(Q,$){$(Q),Q.children.forEach(W=>ie(W,$))}class fe{get f(){return this.d||(this.d=this.m()),this.d}constructor($,W){this.g=$,this.j=W,this.a=[],this.c=new r.$Nd,this.onDidChange=this.c.event}set($,W){!W?.__forceEvent&&(0,e.$tb)(this.a,$)||this.k($,!1,W)}k($,W,V){if(this.a=[...$],this.b=void 0,this.d=void 0,!W){const p=this;this.c.fire({get elements(){return p.get()},browserEvent:V})}}get(){return this.b||(this.b=this.a.map($=>$.element)),[...this.b]}getNodes(){return this.a}has($){return this.f.has($)}onDidModelSplice({insertedNodes:$,deletedNodes:W}){if(!this.j){const k=this.m(),R=C=>k.delete(C);W.forEach(C=>ie(C,R)),this.set([...k.values()]);return}const V=new Set,p=k=>V.add(this.j.getId(k.element).toString());W.forEach(k=>ie(k,p));const y=new Map,E=k=>y.set(this.j.getId(k.element).toString(),k);$.forEach(k=>ie(k,E));const M=[];for(const k of this.a){const R=this.j.getId(k.element).toString();if(!V.has(R))M.push(k);else{const P=y.get(R);P&&P.visible&&M.push(P)}}if(this.a.length>0&&M.length===0){const k=this.g();k&&M.push(k)}this.k(M,!0)}m(){const $=new Set;for(const W of this.a)$.add(W);return $}}class Y extends c.$bR{constructor($,W){super($),this.x=W}u($){if((0,c.$0Q)($.browserEvent.target)||(0,c.$8Q)($.browserEvent.target)||(0,c.$9Q)($.browserEvent.target)||$.browserEvent.isHandledByList)return;const W=$.element;if(!W)return super.u($);if(this.p($)||this.o($))return super.u($);const V=$.browserEvent.target,p=V.classList.contains("monaco-tl-twistie")||V.classList.contains("monaco-icon-label")&&V.classList.contains("folder-icon")&&$.browserEvent.offsetX<16;let y=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?y=this.x.expandOnlyOnTwistieClick(W.element):y=!!this.x.expandOnlyOnTwistieClick,y&&!p&&$.browserEvent.detail!==2)return super.u($);if(!this.x.expandOnDoubleClick&&$.browserEvent.detail===2)return super.u($);if(W.collapsible){const E=this.x.getNodeLocation(W),M=$.browserEvent.altKey;if(this.x.setFocus([E]),this.x.toggleCollapsed(E,M),y&&p){$.browserEvent.isHandledByList=!0;return}}super.u($)}v($){$.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||$.browserEvent.isHandledByList||super.v($)}}class q extends c.$eR{constructor($,W,V,p,y,E,M,k){super($,W,V,p,k),this.p=y,this.s=E,this.K=M}D($){return new Y(this,$.tree)}splice($,W,V=[]){if(super.splice($,W,V),V.length===0)return;const p=[],y=[];let E;V.forEach((M,k)=>{this.p.has(M)&&p.push($+k),this.s.has(M)&&y.push($+k),this.K.has(M)&&(E=$+k)}),p.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...p])),y.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...y])),typeof E=="number"&&super.setAnchor(E)}setFocus($,W,V=!1){super.setFocus($,W),V||this.p.set($.map(p=>this.element(p)),W)}setSelection($,W,V=!1){super.setSelection($,W),V||this.s.set($.map(p=>this.element(p)),W)}setAnchor($,W=!1){super.setAnchor($),W||(typeof $>"u"?this.K.set([]):this.K.set([this.element($)]))}}class X{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Te)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Te),$=>$.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Te)}get onPointer(){return r.Event.map(this.j.onPointer,Te)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??re.Highlight}set findMode($){this.x&&(this.x.mode=$)}get findMatchType(){return this.x?.matchType??be.Fuzzy}set findMatchType($){this.x&&(this.x.matchType=$)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor($,W,V,p,y={}){this.D=$,this.E=y,this.w=new r.$Vd,this.onDidChangeFindOpenState=r.Event.None,this.A=new f.$Qc,this.B=new r.$Nd,this.onWillRefilter=this.B.event,this.C=new r.$Nd,this.onDidUpdateOptions=this.C.event;const E=new z(V),M=new r.$Wd,k=new r.$Wd,R=this.A.add(new N(k.event)),C=new n.$Fc;this.k=p.map(ne=>new Z(ne,()=>this.o,M.event,R,C,y));for(const ne of this.k)this.A.add(ne);let P;y.keyboardNavigationLabelProvider&&(P=new ee(this,y.keyboardNavigationLabelProvider,y.filter),y={...y,filter:P},this.A.add(P)),this.p=new fe(()=>this.j.getFocusedElements()[0],y.identityProvider),this.q=new fe(()=>this.j.getSelectedElements()[0],y.identityProvider),this.u=new fe(()=>this.j.getAnchorElement(),y.identityProvider),this.j=new q($,W,E,this.k,this.p,this.q,this.u,{...B(()=>this.o,y),tree:this}),this.o=this.I($,this.j,y),M.input=this.o.onDidChangeCollapseState;const H=r.Event.forEach(this.o.onDidSplice,ne=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(ne),this.q.onDidModelSplice(ne)})},this.A);H(()=>null,null,this.A);const x=this.A.add(new r.$Nd),te=this.A.add(new a.$Qg(0));if(this.A.add(r.Event.any(H,this.p.onDidChange,this.q.onDidChange)(()=>{te.trigger(()=>{const ne=new Set;for(const ge of this.p.getNodes())ne.add(ge);for(const ge of this.q.getNodes())ne.add(ge);x.fire([...ne.values()])})})),k.input=x.event,y.keyboardSupport!==!1){const ne=r.Event.chain(this.j.onKeyDown,ge=>ge.filter(ve=>!(0,c.$8Q)(ve.target)).map(ve=>new i.$QO(ve)));r.Event.chain(ne,ge=>ge.filter(ve=>ve.keyCode===15))(this.F,this,this.A),r.Event.chain(ne,ge=>ge.filter(ve=>ve.keyCode===17))(this.G,this,this.A),r.Event.chain(ne,ge=>ge.filter(ve=>ve.keyCode===10))(this.H,this,this.A)}if((y.findWidgetEnabled??!0)&&y.keyboardNavigationLabelProvider&&y.contextViewProvider){const ne=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Oe(this,this.o,this.j,P,y.contextViewProvider,ne),this.y=ge=>this.x.shouldAllowFocus(ge),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,v.$xP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===I.Always)}updateOptions($={}){this.E={...this.E,...$};for(const W of this.k)W.updateOptions($);this.j.updateOptions(this.E),this.x?.updateOptions($),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===I.Always)}get options(){return this.E}updateWidth($){const W=this.o.getListIndex($);W!==-1&&this.j.updateWidth(W)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop($){this.j.scrollTop=$}get scrollLeft(){return this.j.scrollLeft}set scrollLeft($){this.j.scrollLeft=$}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const $=this.j.firstVisibleIndex;return $<0||$>=this.j.length?void 0:this.j.element($).element}get lastVisibleElement(){const $=this.j.lastVisibleIndex;return this.j.element($).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel($){this.j.ariaLabel=$}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,v.$qP)(this.getHTMLElement())}layout($,W){this.j.layout($,W),(0,F.$Cf)(W)&&this.x?.layout(W)}style($){const W=`.${this.j.domId}`,V=[];$.treeIndentGuidesStroke&&(V.push(`.monaco-list${W}:hover .monaco-tl-indent > .indent-guide, .monaco-list${W}.always .monaco-tl-indent > .indent-guide  { border-color: ${$.treeInactiveIndentGuidesStroke}; }`),V.push(`.monaco-list${W} .monaco-tl-indent > .indent-guide.active { border-color: ${$.treeIndentGuidesStroke}; }`)),this.z.textContent=V.join(`
`),this.j.style($)}getParentElement($){const W=this.o.getParentNodeLocation($);return this.o.getNode(W).element}getFirstElementChild($){return this.o.getFirstElementChild($)}getNode($){return this.o.getNode($)}getNodeLocation($){return this.o.getNodeLocation($)}collapse($,W=!1){return this.o.setCollapsed($,!0,W)}expand($,W=!1){return this.o.setCollapsed($,!1,W)}toggleCollapsed($,W=!1){return this.o.setCollapsed($,void 0,W)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible($){return this.o.isCollapsible($)}setCollapsible($,W){return this.o.setCollapsible($,W)}isCollapsed($){return this.o.isCollapsed($)}expandTo($){this.o.expandTo($)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor($){if(typeof $>"u")return this.j.setAnchor(void 0);const W=this.o.getNode($);this.u.set([W]);const V=this.o.getListIndex($);V>-1&&this.j.setAnchor(V,!0)}getAnchor(){return(0,e.$Nb)(this.u.get(),void 0)}setSelection($,W){const V=$.map(y=>this.o.getNode(y));this.q.set(V,W);const p=$.map(y=>this.o.getListIndex(y)).filter(y=>y>-1);this.j.setSelection(p,W,!0)}getSelection(){return this.q.get()}setFocus($,W){const V=$.map(y=>this.o.getNode(y));this.p.set(V,W);const p=$.map(y=>this.o.getListIndex(y)).filter(y=>y>-1);this.j.setFocus(p,W,!0)}focusNext($=1,W=!1,V,p=this.y){this.j.focusNext($,W,V,p)}focusPrevious($=1,W=!1,V,p=this.y){this.j.focusPrevious($,W,V,p)}focusNextPage($,W=this.y){return this.j.focusNextPage($,W)}focusPreviousPage($,W=this.y){return this.j.focusPreviousPage($,W)}focusLast($,W=this.y){this.j.focusLast($,W)}focusFirst($,W=this.y){this.j.focusFirst($,W)}getFocus(){return this.p.get()}reveal($,W){this.o.expandTo($);const V=this.o.getListIndex($);V!==-1&&this.j.reveal(V,W)}getRelativeTop($){const W=this.o.getListIndex($);return W===-1?null:this.j.getRelativeTop(W)}getViewState($=this.options.identityProvider){if(!$)throw new s.$QS(this.D,"Can't get tree view state without an identity provider");const W=E=>$.getId(E).toString(),V=_.empty(this.scrollTop);for(const E of this.getFocus())V.focus.add(W(E));for(const E of this.getSelection())V.selection.add(W(E));const p=this.o.getNode(),y=[p];for(;y.length>0;){const E=y.shift();E!==p&&E.collapsible&&(V.expanded[W(E.element)]=E.collapsed?0:1),y.push(...E.children)}return V}F($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const V=W[0],p=this.o.getNodeLocation(V);if(!this.o.setCollapsed(p,!0)){const E=this.o.getParentNodeLocation(p);if(!E)return;const M=this.o.getListIndex(E);this.j.reveal(M),this.j.setFocus([M])}}G($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const V=W[0],p=this.o.getNodeLocation(V);if(!this.o.setCollapsed(p,!1)){if(!V.children.some(k=>k.visible))return;const[E]=this.j.getFocus(),M=E+1;this.j.reveal(M),this.j.setFocus([M])}}H($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const V=W[0],p=this.o.getNodeLocation(V),y=$.browserEvent.altKey;this.o.setCollapsed(p,void 0,y)}navigate($){return new S(this.j,this.o,$)}dispose(){(0,f.$Mc)(this.A),this.j.dispose()}}t.$ZS=X;class S{constructor($,W,V){this.b=$,this.c=W,V?this.a=this.c.getListIndex(V):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define($e[130],pe([1,0,129,120,24,26]),function(oe,t,v,T,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$S=void 0;class w extends v.$ZS{constructor(u,c,m,O,s,l={}){super(u,c,m,O,l),this.f=u,this.g=s,this.d=new Map,this.c=l.identityProvider}getInput(){return this.b}setInput(u,c){if(c&&!this.c)throw new i.$QS(this.f,"Can't restore tree view state without an identity provider");if(this.b=u,!u){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!c){this.m(u);return}const m=[],O=[],s=e=>{const a=this.c.getId(e).toString();return!c.expanded[a]},l=e=>{const a=this.c.getId(e.element).toString();c.focus.has(a)&&m.push(e.element),c.selection.has(a)&&O.push(e.element)};this.m(u,s,l),this.setFocus(m),this.setSelection(O),c&&typeof c.scrollTop=="number"&&(this.scrollTop=c.scrollTop)}updateChildren(u=this.b){if(typeof this.b>"u")throw new i.$QS(this.f,"Tree input not set");let c;this.c&&(c=m=>{const O=this.c.getId(m).toString(),s=this.d.get(O);if(s)return s.collapsed}),this.m(u,c)}resort(u=this.b,c=!0){this.o.resort(u===this.b?null:u,c)}refresh(u){if(u===void 0){this.j.rerender();return}this.o.rerender(u)}m(u,c,m){let O;if(this.c){const s=new Set,l=m;m=e=>{const a=this.c.getId(e.element).toString();s.add(a),this.d.set(a,e),l?.(e)},O=e=>{const a=this.c.getId(e.element).toString();s.has(a)||this.d.delete(a)}}this.o.setChildren(u===this.b?null:u,this.s(u,c).elements,{onDidCreateNode:m,onDidDeleteNode:O})}s(u,c){const m=[...this.g.getChildren(u)];return{elements:U.Iterable.map(m,s=>{const{elements:l,size:e}=this.s(s,c),a=this.g.hasChildren?this.g.hasChildren(s):void 0,h=e===0?void 0:c&&c(s);return{element:s,children:l,collapsible:a,collapsed:h}}),size:m.length}}I(u,c,m){return new T.$1S(u,c,m)}}t.$$S=w}),define($e[66],pe([1,0,11,9,32,28,25,6,4,2,52,12,7]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zh=t.ProxyChannel=t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.RequestInitiator=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=void 0;var l;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(l||(l={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(a||(a={}));function h(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(g||(g={}));function n(de){let ie=0;for(let fe=0;;fe+=7){const Y=de.read(1);if(ie|=(Y.buffer[0]&127)<<fe,!(Y.buffer[0]&128))return ie}}const r=j(0);function b(de,ie){if(ie===0){de.write(r);return}let fe=0;for(let q=ie;q!==0;q=q>>>7)fe++;const Y=i.$be.alloc(fe);for(let q=0;ie!==0;q++)Y.buffer[q]=ie&127,ie=ie>>>7,ie>0&&(Y.buffer[q]|=128);de.write(Y)}class f{constructor(ie){this.b=ie,this.a=0}read(ie){const fe=this.b.slice(this.a,this.a+ie);return this.a+=fe.byteLength,fe}}t.$oh=f;class o{constructor(){this.a=[]}get buffer(){return i.$be.concat(this.a)}write(ie){this.a.push(ie)}}t.$ph=o;var F;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(F||(F={}));function j(de){const ie=i.$be.alloc(1);return ie.writeUInt8(de,0),ie}const L={Undefined:j(F.Undefined),String:j(F.String),Buffer:j(F.Buffer),VSBuffer:j(F.VSBuffer),Array:j(F.Array),Object:j(F.Object),Uint:j(F.Int)},d=typeof Buffer<"u";function D(de,ie){if(typeof ie>"u")de.write(L.Undefined);else if(typeof ie=="string"){const fe=i.$be.fromString(ie);de.write(L.String),b(de,fe.byteLength),de.write(fe)}else if(d&&Buffer.isBuffer(ie)){const fe=i.$be.wrap(ie);de.write(L.Buffer),b(de,fe.byteLength),de.write(fe)}else if(ie instanceof i.$be)de.write(L.VSBuffer),b(de,ie.byteLength),de.write(ie);else if(Array.isArray(ie)){de.write(L.Array),b(de,ie.length);for(const fe of ie)D(de,fe)}else if(typeof ie=="number"&&(ie|0)===ie)de.write(L.Uint),b(de,ie);else{const fe=i.$be.fromString(JSON.stringify(ie));de.write(L.Object),b(de,fe.byteLength),de.write(fe)}}t.$qh=D;function B(de){switch(de.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return de.read(n(de)).toString();case F.Buffer:return de.read(n(de)).buffer;case F.VSBuffer:return de.read(n(de));case F.Array:{const fe=n(de),Y=[];for(let q=0;q<fe;q++)Y.push(B(de));return Y}case F.Object:return JSON.parse(de.read(n(de)).toString());case F.Int:return n(de)}}t.$rh=B;class z{constructor(ie,fe,Y=null,q=1e3){this.h=ie,this.j=fe,this.k=Y,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(ie,fe){this.b.set(ie,fe),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const fe=this.o([ie.type]);this.k?.logOutgoing(fe,0,1,h(ie.type));return}case 201:case 202:case 204:case 203:{const fe=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(fe,ie.id,1,h(ie.type),ie.data);return}}}o(ie,fe=void 0){const Y=new o;return D(Y,ie),D(Y,fe),this.p(Y.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const fe=new f(ie),Y=B(fe),q=B(fe),X=Y[0];switch(X){case 100:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(X)}: ${Y[2]}.${Y[3]}`,q),this.s({type:X,id:Y[1],channelName:Y[2],name:Y[3],arg:q});case 102:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(X)}: ${Y[2]}.${Y[3]}`,q),this.t({type:X,id:Y[1],channelName:Y[2],name:Y[3],arg:q});case 101:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(X)}`),this.u({type:X,id:Y[1]});case 103:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(X)}`),this.u({type:X,id:Y[1]})}}s(ie){const fe=this.b.get(ie.channelName);if(!fe){this.v(ie);return}const Y=new U.$Xd;let q;try{q=fe.call(this.j,ie.name,ie.arg,Y.token)}catch(Q){q=Promise.reject(Q)}const X=ie.id;q.then(Q=>{this.m({id:X,data:Q,type:201})},Q=>{Q instanceof Error?this.m({id:X,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.m({id:X,data:Q,type:203})}).finally(()=>{S.dispose(),this.d.delete(ie.id)});const S=(0,c.$Pc)(()=>Y.cancel());this.d.set(ie.id,S)}t(ie){const fe=this.b.get(ie.channelName);if(!fe){this.v(ie);return}const Y=ie.id,X=fe.listen(this.j,ie.name,ie.arg)(S=>this.m({id:Y,data:S,type:204}));this.d.set(ie.id,X)}u(ie){const fe=this.d.get(ie.id);fe&&(fe.dispose(),this.d.delete(ie.id))}v(ie){let fe=this.g.get(ie.channelName);fe||(fe=[],this.g.set(ie.channelName,fe));const Y=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);fe.push({request:ie,timeoutTimer:Y})}w(ie){const fe=this.g.get(ie);if(fe){for(const Y of fe)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}t.$sh=z;var _;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(_||(t.RequestInitiator=_={}));class I{constructor(ie,fe=null){this.l=ie,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=fe}getChannel(ie){const fe=this;return{call(Y,q,X){return fe.a?Promise.reject(new A.$4):fe.m(ie,Y,q,X)},listen(Y,q){return fe.a?u.Event.None:fe.o(ie,Y,q)}}}m(ie,fe,Y,q=U.CancellationToken.None){const X=this.g++,Q={id:X,type:100,channelName:ie,name:fe,arg:Y};if(q.isCancellationRequested)return Promise.reject(new A.$4);let $;return new Promise((V,p)=>{if(q.isCancellationRequested)return p(new A.$4);const y=()=>{const R=C=>{switch(C.type){case 201:this.f.delete(X),V(C.data);break;case 202:{this.f.delete(X);const P=new Error(C.data.message);P.stack=Array.isArray(C.data.stack)?C.data.stack.join(`
`):C.data.stack,P.name=C.data.name,p(P);break}case 203:this.f.delete(X),p(C.data);break}};this.f.set(X,R),this.p(Q)};let E=null;this.b===g.Idle?y():(E=(0,T.$Hg)(R=>this.u()),E.then(()=>{E=null,y()}));const M=()=>{E?(E.cancel(),E=null):this.p({id:X,type:101}),p(new A.$4)},k=q.onCancellationRequested(M);$=(0,c.$Oc)((0,c.$Pc)(M),k),this.d.add($)}).finally(()=>{$.dispose(),this.d.delete($)})}o(ie,fe,Y){const q=this.g++,S={id:q,type:102,channelName:ie,name:fe,arg:Y};let Q=null;const $=new u.$Nd({onWillAddFirstListener:()=>{Q=(0,T.$Hg)(V=>this.u()),Q.then(()=>{Q=null,this.d.add($),this.p(S)})},onDidRemoveLastListener:()=>{Q?(Q.cancel(),Q=null):(this.d.delete($),this.p({id:q,type:103}))}}),W=V=>$.fire(V.data);return this.f.set(q,W),$.event}p(ie){switch(ie.type){case 100:case 102:{const fe=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(fe,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const fe=this.q([ie.type,ie.id]);this.j?.logOutgoing(fe,ie.id,0,e(ie.type));return}}}q(ie,fe=void 0){const Y=new o;return D(Y,ie),D(Y,fe),this.r(Y.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const fe=new f(ie),Y=B(fe),q=B(fe),X=Y[0];switch(X){case 200:return this.j?.logIncoming(ie.byteLength,0,0,h(X)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,Y[1],0,h(X),q),this.t({type:Y[0],id:Y[1],data:q})}}t(ie){if(ie.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}t.$th=I,Ye([w.$ih],I.prototype,"onDidInitializePromise",null);class N{get connections(){const ie=[];return this.f.forEach(fe=>ie.push(fe)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new u.$Nd,this.onDidAddConnection=this.g.event,this.h=new u.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(ie(({protocol:fe,onDidClientDisconnect:Y})=>{const q=u.Event.once(fe.onMessage);this.j.add(q(X=>{const S=new f(X),Q=B(S),$=new z(fe,Q),W=new I(fe);this.a.forEach((p,y)=>$.registerChannel(y,p));const V={channelServer:$,channelClient:W,ctx:Q};this.f.add(V),this.g.fire(V),this.j.add(Y(()=>{$.dispose(),W.dispose(),this.f.delete(V),this.h.fire(V)}))}))}))}getChannel(ie,fe){const Y=this;return{call(q,X,S){let Q;if((0,s.$Mf)(fe)){const W=(0,v.$3b)(Y.connections.filter(fe));Q=W?Promise.resolve(W):u.Event.toPromise(u.Event.filter(Y.onDidAddConnection,fe))}else Q=fe.routeCall(Y,q,X);const $=Q.then(W=>W.channelClient.getChannel(ie));return ee($).call(q,X,S)},listen(q,X){if((0,s.$Mf)(fe))return Y.k(ie,fe,q,X);const S=fe.routeEvent(Y,q,X).then(Q=>Q.channelClient.getChannel(ie));return ee(S).listen(q,X)}}}k(ie,fe,Y,q){const X=this;let S;const Q=new u.$Nd({onWillAddFirstListener:()=>{S=new c.$Qc;const $=new u.$Td,W=new Map,V=y=>{const M=y.channelClient.getChannel(ie).listen(Y,q),k=$.add(M);W.set(y,k)},p=y=>{const E=W.get(y);E&&(E.dispose(),W.delete(y))};X.connections.filter(fe).forEach(V),u.Event.filter(X.onDidAddConnection,fe)(V,void 0,S),X.onDidRemoveConnection(p,void 0,S),$.event(Q.fire,Q,S),S.add($)},onDidRemoveLastListener:()=>{S?.dispose(),S=void 0}});return Q.event}registerChannel(ie,fe){this.a.set(ie,fe);for(const Y of this.f)Y.channelServer.registerChannel(ie,fe)}dispose(){this.j.dispose();for(const ie of this.f)ie.channelClient.dispose(),ie.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$uh=N;class Z{constructor(ie,fe,Y=null){const q=new o;D(q,fe),ie.send(q.buffer),this.a=new I(ie,Y),this.d=new z(ie,fe,Y)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,fe){this.d.registerChannel(ie,fe)}dispose(){this.a.dispose(),this.d.dispose()}}t.$vh=Z;function ee(de){return{call(ie,fe,Y){return de.then(q=>q.call(ie,fe,Y))},listen(ie,fe){const Y=new u.$Wd;return de.then(q=>Y.input=q.listen(ie,fe)),Y.event}}}t.$wh=ee;function ue(de){let ie=!1;return{call(fe,Y,q){return ie?de.call(fe,Y,q):(0,T.$Ug)(0).then(()=>ie=!0).then(()=>de.call(fe,Y,q))},listen(fe,Y){if(ie)return de.listen(fe,Y);const q=new u.$Wd;return(0,T.$Ug)(0).then(()=>ie=!0).then(()=>q.input=de.listen(fe,Y)),q.event}}}t.$xh=ue;class ae{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const fe of ie.connections)if(await Promise.resolve(this.a(fe.ctx)))return Promise.resolve(fe);return await u.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}t.$yh=ae;var se;(function(de){function ie(X,S,Q){const $=X,W=Q&&Q.disableMarshalling,V=new Map;for(const p in $)Y(p)&&V.set(p,u.Event.buffer($[p],!0,void 0,S));return new class{listen(p,y,E){const M=V.get(y);if(M)return M;if(q(y)){const k=$[y];if(typeof k=="function")return k.call($,E)}throw new A.$ab(`Event not found: ${y}`)}call(p,y,E){const M=$[y];if(typeof M=="function"){if(!W&&Array.isArray(E))for(let R=0;R<E.length;R++)E[R]=(0,m.$nh)(E[R]);let k=M.apply($,E);return k instanceof Promise||(k=Promise.resolve(k)),k}throw new A.$ab(`Method not found: ${y}`)}}}de.fromService=ie;function fe(X,S){const Q=S&&S.disableMarshalling;return new Proxy({},{get($,W){if(typeof W=="string")return S?.properties?.has(W)?S.properties.get(W):q(W)?function(V){return X.listen(W,V)}:Y(W)?X.listen(W):async function(...V){let p;S&&!(0,s.$Hf)(S.context)?p=[S.context,...V]:p=V;const y=await X.call(W,p);return Q?y:(0,m.$nh)(y)};throw new A.$ab(`Property not found: ${String(W)}`)}})}de.toService=fe;function Y(X){return X[0]==="o"&&X[1]==="n"&&O.$1e(X.charCodeAt(2))}function q(X){return/^onDynamic/.test(X)&&O.$1e(X.charCodeAt(9))}})(se||(t.ProxyChannel=se={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function be(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ie=de.toString();if(ie!=="[object Object]")return ie}return de}function Se(de){return Array.isArray(de)?de.map(be):be(de)}function Oe(de,ie,fe,Y,q,X,S){S=Se(S);const Q=re[q],$=Q[Y%Q.length];let W=[`%c[${de}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(fe).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(X)?(W=W.concat(S),W.push(")")):W.push(S),console.log.apply(console,W)}class Te{constructor(ie,fe){this.d=ie,this.f=fe,this.a=0,this.b=0}logOutgoing(ie,fe,Y,q,X){this.b+=ie,Oe(this.d,this.b,ie,fe,Y,q,X)}logIncoming(ie,fe,Y,q,X){this.a+=ie,Oe(this.f,this.a,ie,fe,Y,q,X)}}t.$zh=Te}),define($e[30],pe([1,0,5]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R=t.$Q=t.$P=t.$O=t.$N=void 0,t.$N=v.$h.vscode.ipcRenderer,t.$O=v.$h.vscode.ipcMessagePort,t.$P=v.$h.vscode.webFrame,t.$Q=v.$h.vscode.process,t.$R=v.$h.vscode.context}),define($e[131],pe([1,0,87,30]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JT=void 0;let i=0;function U(A,u,c){const m=[],O=i++,s=`vscode:onContextMenu${O}`,l=(e,a,h)=>{m[a].click?.(h)};T.$N.once(s,l),T.$N.once(v.$GT,(e,a)=>{a===O&&(T.$N.removeListener(s,l),c?.())}),T.$N.send(v.$FT,O,A.map(e=>w(e,m)),s,u)}t.$JT=U;function w(A,u){const c={id:u.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return u.push(A),Array.isArray(A.submenu)&&(c.submenu=A.submenu.map(m=>w(m,u))),c}}),define($e[132],pe([1,0,32,4,66,88,30]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RT=void 0;class A extends i.$vh{static f(){const c=T.Event.fromNodeEventEmitter(w.$N,"vscode:message",(m,O)=>v.$be.wrap(O));return w.$N.send("vscode:hello"),new U.$NT(w.$N,c)}constructor(c){const m=A.f();super(m,c),this.b=m}dispose(){this.b.disconnect()}}t.$RT=A}),define($e[133],pe([13,10]),function(oe,t){return oe.create("vs/platform/files/common/files",t)}),define($e[134],pe([13,10]),function(oe,t){return oe.create("vs/platform/theme/common/iconRegistry",t)}),define($e[39],pe([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rh=t.$Qh=t.$Ph=t._util=void 0;var v;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function A(u){return u[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=A})(v||(t._util=v={})),t.$Ph=i("instantiationService");function T(w,A,u){A[v.DI_TARGET]===A?A[v.DI_DEPENDENCIES].push({id:w,index:u}):(A[v.DI_DEPENDENCIES]=[{id:w,index:u}],A[v.DI_TARGET]=A)}function i(w){if(v.serviceIds.has(w))return v.serviceIds.get(w);const A=function(u,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(A,u,m)};return A.toString=()=>w,v.serviceIds.set(w,A),A}t.$Qh=i;function U(w){return w}t.$Rh=U}),define($e[135],pe([1,0,39]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tm=t.$sm=t.$rm=t.ID=void 0,t.ID="diagnosticsService",t.$rm=(0,v.$Qh)(t.ID);function T(U){return!!U.hostName&&!!U.errorMessage}t.$sm=T;class i{async getPerformanceInfo(w,A){return{}}async getSystemInfo(w,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,A){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.$tm=i}),define($e[136],pe([1,0,86,22,12,7,15,133,39,5,29,27]),function(oe,t,v,T,i,U,w,A,u,c,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ik=t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.FileKind=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.FileOperationResult=t.$wk=t.$vk=t.$uk=t.$tk=t.$sk=t.FileChangeType=t.$rk=t.FileOperation=t.$qk=t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.FileSystemProviderErrorCode=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.FileSystemProviderCapabilities=t.$bk=t.FilePermission=t.FileType=t.$ak=t.$_j=void 0,t.$_j=(0,u.$Qh)("fileService");function s(q){return q.create===!0}t.$ak=s;var l;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(l||(t.FileType=l={}));var e;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function a(q){const X=q;return!!X&&typeof X.onDidChange=="function"}t.$bk=a;var h;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function g(q){return!!(q.capabilities&2)}t.$ck=g;function n(q){return!!(q.capabilities&8)}t.$dk=n;function r(q){return!!(q.capabilities&131072)}t.$ek=r;function b(q){return!!(q.capabilities&4)}t.$fk=b;function f(q){return!!(q.capabilities&16)}t.$gk=f;function o(q){return g(q)?!!(q.capabilities&16384):!1}t.$hk=o;function F(q){return g(q)?!!(q.capabilities&32768):!1}t.$ik=F;function j(q){return!!(q.capabilities&65536)}t.$jk=j;function L(q){return!!(q.capabilities&2048)}t.$kk=L;var d;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(d||(t.FileSystemProviderErrorCode=d={}));class D extends Error{static create(X,S){const Q=new D(X.toString(),S);return _(Q,S),Q}constructor(X,S){super(X),this.code=S}}t.$lk=D;function B(q,X){return D.create(q,X)}t.$mk=B;function z(q){return q||B((0,A.localize)(0,null),d.Unknown)}t.$nk=z;function _(q,X){return q.name=X?`${X} (FileSystemError)`:"FileSystemError",q}t.$ok=_;function I(q){if(!q)return d.Unknown;if(q instanceof D)return q.code;const X=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!X)return d.Unknown;switch(X[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}t.$pk=I;function N(q){if(q instanceof re)return q.fileOperationResult;switch(I(q)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 9;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileTooLarge:return 7;default:return 10}}t.$qk=N;var Z;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(Z||(t.FileOperation=Z={}));class ee{constructor(X,S,Q){this.resource=X,this.operation=S,this.target=Q}isOperation(X){return this.operation===X}}t.$rk=ee;var ue;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(ue||(t.FileChangeType=ue={}));class ae{static{this.a=null}constructor(X,S){this.c=S,this.b=void 0,this.d=new O.$U(()=>{const Q=v.$Wh.forUris(()=>this.c);return Q.fill(this.rawAdded.map($=>[$,!0])),Q}),this.f=new O.$U(()=>{const Q=v.$Wh.forUris(()=>this.c);return Q.fill(this.rawUpdated.map($=>[$,!0])),Q}),this.g=new O.$U(()=>{const Q=v.$Wh.forUris(()=>this.c);return Q.fill(this.rawDeleted.map($=>[$,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of X){switch(Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}this.b!==ae.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=ae.a):this.b!==void 0&&(this.b=ae.a))}}contains(X,...S){return this.h(X,{includeChildren:!1},...S)}affects(X,...S){return this.h(X,{includeChildren:!0},...S)}h(X,S,...Q){if(!X)return!1;const $=Q.length>0;return!!((!$||Q.includes(1))&&(this.d.value.get(X)||S.includeChildren&&this.d.value.findSuperstr(X))||(!$||Q.includes(0))&&(this.f.value.get(X)||S.includeChildren&&this.f.value.findSuperstr(X))||(!$||Q.includes(2))&&(this.g.value.findSubstr(X)||S.includeChildren&&this.g.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.b===X}hasCorrelation(){return typeof this.b=="number"}}t.$sk=ae;function se(q,X,S){return!q||!X||q===X||X.length>q.length?!1:(X.charAt(X.length-1)!==T.sep&&(X+=T.sep),S?(0,i.$3e)(q,X):q.indexOf(X)===0)}t.$tk=se;class re extends Error{constructor(X,S,Q){super(X),this.fileOperationResult=S,this.options=Q}}t.$uk=re;class be extends re{constructor(X,S,Q,$){super(X,S,$),this.fileOperationResult=S,this.size=Q}}t.$vk=be;class Se extends re{constructor(X,S,Q){super(X,2,Q),this.stat=S}}t.$wk=Se;var Oe;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Oe||(t.FileOperationResult=Oe={})),t.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$zk="files.associations",t.$Ak="files.exclude",t.$Bk="files.readonlyInclude",t.$Ck="files.readonlyExclude",t.$Dk="files.readonlyFromPermissions";var Te;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Te||(t.FileKind=Te={})),t.$Ek="";function de(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}t.$Fk=de;async function ie(q,X){if(!X.hasProvider(w.URI.from({scheme:q.scheme})))return new Promise(S=>{const Q=X.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===q.scheme&&$.added&&(Q.dispose(),S())})})}t.$Gk=ie;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(X){return(0,U.$Cf)(X)||(X=0),X<fe.KB?(0,A.localize)(1,null,X.toFixed(0)):X<fe.MB?(0,A.localize)(2,null,(X/fe.KB).toFixed(2)):X<fe.GB?(0,A.localize)(3,null,(X/fe.MB).toFixed(2)):X<fe.TB?(0,A.localize)(4,null,(X/fe.GB).toFixed(2)):(0,A.localize)(5,null,(X/fe.TB).toFixed(2))}}t.$Hk=fe;function Y(q){const X=typeof q=="string"||q?.scheme===m.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===m.Schemas.file?1024*fe.MB:X?10*fe.MB:c.$p?50*fe.MB:1024*fe.MB}t.$Ik=Y}),define($e[137],pe([1,0,39]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$78b=t.$68b=void 0,t.$68b=(0,v.$Qh)("mainProcessService");class T{constructor(U,w){this.a=U,this.b=w}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,w){this.a.registerChannel(U,w)}}t.$78b=T}),define($e[138],pe([1,0,2,132]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$88b=void 0;class i extends v.$Rc{constructor(w){super(),this.a=this.B(new T.$RT(`window:${w}`))}getChannel(w){return this.a.getChannel(w)}registerChannel(w,A){this.a.registerChannel(w,A)}}t.$88b=i});var Di=this&&this.__param||function(oe,t){return function(v,T){t(v,T,oe)}};define($e[139],pe([1,0,66,137]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_8b=void 0;let i=class{constructor(w,A){return this.windowId=w,v.ProxyChannel.toService(A.getChannel("nativeHost"),{context:w,properties:(()=>{const u=new Map;return u.set("windowId",w),u})()})}};t.$_8b=i,t.$_8b=i=Ye([Di(1,T.$68b)],i)}),define($e[67],pe([1,0,75,7]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hn=void 0;class i{constructor(){this.a=new Map}add(w,A){v.ok(T.$yf(w)),v.ok(T.$Af(A)),v.ok(!this.a.has(w),"There is already an extension with this id"),this.a.set(w,A)}knows(w){return this.a.has(w)}as(w){return this.a.get(w)||null}}t.$hn=new i}),define($e[140],pe([1,0,4,67]),function(oe,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$in=void 0,t.$in={JSONContribution:"base.contributions.json"};function i(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class U{constructor(){this.b=new v.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[i(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const w=new U;T.$hn.add(t.$in.JSONContribution,w)}),define($e[141],pe([1,0,9,17,18,4,7,15,134,140,67]),function(oe,t,v,T,i,U,w,A,u,c,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bw=t.$aw=t.$_v=t.$$v=t.$0v=t.$9v=t.$8v=t.$7v=t.IconFontDefinition=t.IconContribution=t.$6v=void 0,t.$6v={IconContribution:"base.contributions.icons"};var O;(function(b){function f(o,F){let j=o.defaults;for(;i.ThemeIcon.isThemeIcon(j);){const L=e.getIcon(j.id);if(!L)return;j=L.defaults}return j}b.getDefinition=f})(O||(t.IconContribution=O={}));var s;(function(b){function f(F){return{weight:F.weight,style:F.style,src:F.src.map(j=>({format:j.format,location:j.location.toString()}))}}b.toJSONObject=f;function o(F){const j=L=>(0,w.$yf)(L)?L:void 0;if(F&&Array.isArray(F.src)&&F.src.every(L=>(0,w.$yf)(L.format)&&(0,w.$yf)(L.location)))return{weight:j(F.weight),style:j(F.style),src:F.src.map(L=>({format:L.format,location:A.URI.parse(L.location)}))}}b.fromJSONObject=o})(s||(t.IconFontDefinition=s={}));class l{constructor(){this.a=new U.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,u.localize)(0,null)},fontCharacter:{type:"string",description:(0,u.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(f,o,F,j){const L=this.b[f];if(L){if(F&&!L.description){L.description=F,this.d.properties[f].markdownDescription=`${F} $(${f})`;const B=this.e.enum.indexOf(f);B!==-1&&(this.e.enumDescriptions[B]=F),this.a.fire()}return L}const d={id:f,description:F,defaults:o,deprecationMessage:j};this.b[f]=d;const D={$ref:"#/definitions/icons"};return j&&(D.deprecationMessage=j),F&&(D.markdownDescription=`${F}: $(${f})`),this.d.properties[f]=D,this.e.enum.push(f),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:f}}deregisterIcon(f){delete this.b[f],delete this.d.properties[f];const o=this.e.enum.indexOf(f);o!==-1&&(this.e.enum.splice(o,1),this.e.enumDescriptions.splice(o,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(f=>this.b[f])}getIcon(f){return this.b[f]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(f,o){const F=this.f[f];return F||(this.f[f]=o,this.a.fire(),o)}deregisterIconFont(f){delete this.f[f]}getIconFont(f){return this.f[f]}toString(){const f=(L,d)=>L.id.localeCompare(d.id),o=L=>{for(;i.ThemeIcon.isThemeIcon(L.defaults);)L=this.b[L.defaults.id];return`codicon codicon-${L?L.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const j=Object.keys(this.b).map(L=>this.b[L]);for(const L of j.filter(d=>!!d.description).sort(f))F.push(`|<i class="${o(L)}"></i>|${L.id}|${i.ThemeIcon.isThemeIcon(L.defaults)?L.defaults.id:L.id}|${L.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const L of j.filter(d=>!i.ThemeIcon.isThemeIcon(d.defaults)).sort(f))F.push(`|<i class="${o(L)}"></i>|${L.id}|`);return F.join(`
`)}}const e=new l;m.$hn.add(t.$6v.IconContribution,e);function a(b,f,o,F){return e.registerIcon(b,f,o,F)}t.$7v=a;function h(){return e}t.$8v=h;function g(){const b=(0,T.$Tj)();for(const f in b){const o="\\"+b[f].toString(16);e.registerIcon(f,{fontCharacter:o})}}g(),t.$9v="vscode://schemas/icons";const n=m.$hn.as(c.$in.JSONContribution);n.registerSchema(t.$9v,e.getIconSchema());const r=new v.$7g(()=>n.notifySchemaChanged(t.$9v),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$0v=a("widget-close",T.$Vj.close,(0,u.localize)(2,null)),t.$$v=a("goto-previous-location",T.$Vj.arrowUp,(0,u.localize)(3,null)),t.$_v=a("goto-next-location",T.$Vj.arrowDown,(0,u.localize)(4,null)),t.$aw=i.ThemeIcon.modify(T.$Vj.sync,"spin"),t.$bw=i.ThemeIcon.modify(T.$Vj.loading,"spin")}),define($e[142],pe([1,0,3,4,2,18,141]),function(oe,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0Cb=t.$9Cb=void 0;function A(c){const m=new i.$Qc,O=m.add(new T.$Nd),s=(0,w.$8v)();return m.add(s.onDidChange(()=>O.fire())),c&&m.add(c.onDidProductIconThemeChange(()=>O.fire())),{dispose:()=>m.dispose(),onDidChange:O.event,getCSS(){const l=c?c.getProductIconTheme():new u,e={},a=g=>{const n=l.getIcon(g);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${g.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,v.$7P)(r.id)}; }`):`.codicon-${g.id}:before { content: '${n.fontCharacter}'; }`},h=[];for(const g of s.getIcons()){const n=a(g);n&&h.push(n)}for(const g in e){const n=e[g],r=n.weight?`font-weight: ${n.weight};`:"",b=n.style?`font-style: ${n.style};`:"",f=n.src.map(o=>`${(0,v.$6P)(o.location)} format('${o.format}')`).join(", ");h.push(`@font-face { src: ${f}; font-family: ${(0,v.$7P)(g)};${r}${b} font-display: block; }`)}return h.join(`
`)}}}t.$9Cb=A;class u{getIcon(m){const O=(0,w.$8v)();let s=m.defaults;for(;U.ThemeIcon.isThemeIcon(s);){const l=O.getIcon(s.id);if(!l)return;s=l.defaults}return s}}t.$0Cb=u}),define($e[143],pe([1,0,5]),function(oe,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oC=t.$nC=t.$mC=t.$lC=t.$kC=t.$jC=t.$iC=t.$hC=t.$gC=void 0,t.$gC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function T(O){return typeof O.parentId=="number"}t.$hC=T;function i(O){return!!O.workspaceUri}t.$iC=i;function U(O){return!!O.folderUri}t.$jC=U;function w(O){return!!O.fileUri}t.$kC=w;function A(O){const s=u(O),l=O.getValue("window.menuBarVisibility");return l==="default"||s==="native"&&l==="compact"||v.$k&&v.$n?"classic":l}t.$lC=A;function u(O){if(v.$p)return"custom";const s=O.getValue("window");if(s){if(v.$k&&s.nativeTabs===!0||v.$k&&s.nativeFullScreen===!1)return"native";const a=s.titleBarStyle;if(a==="native"||a==="custom")return a}return v.$l?"native":"custom"}t.$mC=u;function c(O){return!(!v.$j||v.$p||u(O)==="native")}t.$nC=c;function m(O=0){return Math.pow(1.2,O)}t.$oC=m}),define($e[144],pe([1,0,16,3,30,143]),function(oe,t,v,T,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$d9b=t.$c9b=t.$b9b=void 0;function w(m){for(const{window:O}of(0,T.getWindows)())A(O)?.webFrame?.setZoomLevel(m);(0,v.$vO)((0,U.$oC)(m)),(0,v.$sO)(m)}t.$b9b=w;function A(m){if(m===window)return{ipcRenderer:i.$N,webFrame:i.$P};{const O=m;if(O?.vscode?.ipcRenderer&&O?.vscode?.webFrame)return O.vscode}}function u(){w((0,v.$tO)()+1)}t.$c9b=u;function c(){w((0,v.$tO)()-1)}t.$d9b=c}),define($e[145],pe([1,0,10,3,130,9,131,30,135,136,138,139,142,144,14,101,92]),function(oe,t,v,T,i,U,w,A,u,c,m,O,s,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,h=/\s--inspect-port=(?<port>\d+)/;class g{getHeight(_){return 22}getTemplateId(_){return L(_)?"process":F(_)?"machine":(0,u.$sm)(_)?"error":j(_)?"header":""}}class n{hasChildren(_){return(0,u.$sm)(_)?!1:L(_)?!!_.children?.length:!0}getChildren(_){return L(_)?_.children?_.children:[]:(0,u.$sm)(_)?[]:j(_)?_.processRoots.length>1?_.processRoots:[_.processRoots[0].rootProcess]:F(_)?[_.rootProcess]:[_.processes]}}class r{constructor(){this.templateId="header"}renderTemplate(_){const I=(0,T.$PP)(_,(0,T.$)(".row")),N=(0,T.$PP)(I,(0,T.$)(".nameLabel")),Z=(0,T.$PP)(I,(0,T.$)(".cpu")),ee=(0,T.$PP)(I,(0,T.$)(".memory")),ue=(0,T.$PP)(I,(0,T.$)(".pid"));return{name:N,CPU:Z,memory:ee,PID:ue}}renderElement(_,I,N,Z){N.name.textContent=(0,v.localize)(0,null),N.CPU.textContent=(0,v.localize)(1,null),N.PID.textContent=(0,v.localize)(2,null),N.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(_){}}class b{constructor(){this.templateId="machine"}renderTemplate(_){const I=Object.create(null),N=(0,T.$PP)(_,(0,T.$)(".row"));return I.name=(0,T.$PP)(N,(0,T.$)(".nameLabel")),I}renderElement(_,I,N,Z){N.name.textContent=_.element.name}disposeTemplate(_){}}class f{constructor(){this.templateId="error"}renderTemplate(_){const I=Object.create(null),N=(0,T.$PP)(_,(0,T.$)(".row"));return I.name=(0,T.$PP)(N,(0,T.$)(".nameLabel")),I}renderElement(_,I,N,Z){N.name.textContent=_.element.errorMessage}disposeTemplate(_){}}class o{constructor(_,I,N){this.a=_,this.b=I,this.c=N,this.templateId="process"}renderTemplate(_){const I=(0,T.$PP)(_,(0,T.$)(".row")),N=(0,T.$PP)(I,(0,T.$)(".nameLabel")),Z=(0,T.$PP)(I,(0,T.$)(".cpu")),ee=(0,T.$PP)(I,(0,T.$)(".memory")),ue=(0,T.$PP)(I,(0,T.$)(".pid"));return{name:N,CPU:Z,PID:ue,memory:ee}}renderElement(_,I,N,Z){const{element:ee}=_,ue=ee.pid.toFixed(0);let ae=ee.name;this.c.has(ee.pid)&&(ae=this.c.get(ee.pid)),N.name.textContent=ae,N.name.title=ee.cmd,N.CPU.textContent=ee.load.toFixed(0),N.PID.textContent=ue,N.PID.parentElement.id=`pid-${ue}`;const se=this.a==="win32"?ee.mem:this.b*(ee.mem/100);N.memory.textContent=(se/c.$Hk.MB).toFixed(0)}disposeTemplate(_){}}function F(z){return!!z.name&&!!z.rootProcess}function j(z){return!!z.processRoots}function L(z){return!!z.pid}class d{constructor(_,I){this.f=I,this.b=new Map;const N=new m.$88b(_);this.c=new O.$_8b(_,N),this.k(I.styles),this.g(I),A.$N.on("vscode:pidToNameResponse",(Z,ee)=>{this.b=new Map;for(const[ue,ae]of ee)this.b.set(ue,ae)}),A.$N.on("vscode:listProcessesResponse",async(Z,ee)=>{ee.forEach((ue,ae)=>{L(ue.rootProcess)&&(ue.rootProcess.name=ae===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ee}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ee),this.m(0)}),this.a=Date.now(),A.$N.send("vscode:pidToNameRequest"),A.$N.send("vscode:listProcesses")}g(_){document.onkeydown=I=>{const N=_.platform==="darwin"?I.metaKey:I.ctrlKey;N&&I.keyCode===87&&(I.stopPropagation(),I.preventDefault(),A.$N.send("vscode:closeProcessExplorer")),N&&I.keyCode===187&&(0,l.$c9b)(),N&&I.keyCode===189&&(0,l.$d9b)()}}async h(_){const I=document.getElementById("process-list");if(!I)return;const{totalmem:N}=await this.c.getOSStatistics(),Z=[new o(this.f.platform,N,this.b),new r,new b,new f];this.d=new i.$$S("processExplorer",I,new g,Z,new n,{identityProvider:{getId:ee=>L(ee)?ee.pid.toString():(0,u.$sm)(ee)?ee.hostName:j(ee)?"processes":F(ee)?ee.name:"header"}}),this.d.setInput({processes:{processRoots:_}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ee=>{const ue=new e.$QO(ee);if(ue.keyCode===35&&ue.altKey){const ae=this.n();Promise.all(ae.map(se=>this.c.killProcess(se,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ee=>{L(ee.element)&&this.l(ee.element,!0)}),I.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{I.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(_){const I=a.exec(_);return I&&I.groups.port!=="0"||_.indexOf("node ")>=0||_.indexOf("node.exe")>=0}j(_){const I={type:"node",request:"attach",name:`process ${_.pid}`};let N=a.exec(_.cmd);N?I.port=Number(N.groups.port):I.processId=String(_.pid),N=h.exec(_.cmd),N&&(I.port=Number(N.groups.port)),A.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[I]})}k(_){const I=(0,T.$xP)(),N=[];_.listFocusBackground&&(N.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${_.listFocusBackground}; }`),N.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${_.listFocusBackground}; }`)),_.listFocusForeground&&N.push(`.monaco-list:focus .monaco-list-row.focused { color: ${_.listFocusForeground}; }`),_.listActiveSelectionBackground&&(N.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${_.listActiveSelectionBackground}; }`),N.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${_.listActiveSelectionBackground}; }`)),_.listActiveSelectionForeground&&N.push(`.monaco-list:focus .monaco-list-row.selected { color: ${_.listActiveSelectionForeground}; }`),_.listHoverBackground&&N.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${_.listHoverBackground}; }`),_.listHoverForeground&&N.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${_.listHoverForeground}; }`),_.listFocusOutline&&N.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${_.listFocusOutline}; outline-offset: -1px; }`),_.listHoverOutline&&N.push(`.monaco-list-row:hover { outline: 1px dashed ${_.listHoverOutline}; outline-offset: -1px; }`),_.scrollbarShadowColor&&N.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${_.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${_.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${_.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),_.scrollbarSliderBackgroundColor&&N.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${_.scrollbarSliderBackgroundColor};
				}
			`),_.scrollbarSliderHoverBackgroundColor&&N.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${_.scrollbarSliderHoverBackgroundColor};
				}
			`),_.scrollbarSliderActiveBackgroundColor&&N.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${_.scrollbarSliderActiveBackgroundColor};
				}
			`),I.textContent=N.join(`
`),_.color&&(document.body.style.color=_.color)}l(_,I){const N=[],Z=Number(_.pid);I&&(N.push({accelerator:"Alt+E",label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(Z,"SIGTERM")}}),N.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(Z,"SIGKILL")}}),N.push({type:"separator"})),N.push({label:(0,v.localize)(6,null),click:()=>{const ee=this.n();ee?.includes(Z)||(ee.length=0,ee.push(Z));const ue=ee?.map(ae=>document.getElementById(`pid-${ae}`)).filter(ae=>!!ae);if(ue){const ae=ue.map(se=>se.innerText).filter(se=>!!se);this.c.writeClipboardText(ae.join(`
`))}}}),N.push({label:(0,v.localize)(7,null),click:()=>{const ee=document.getElementById("process-list");ee&&this.c.writeClipboardText(ee.innerText)}}),_&&I&&this.i(_.cmd)&&(N.push({type:"separator"}),N.push({label:(0,v.localize)(8,null),click:()=>{this.j(_)}})),(0,w.$JT)(N)}m(_){setTimeout(()=>{const I=Date.now(),N=_+I-this.a;this.a=I,N>1e3?(A.$N.send("vscode:pidToNameRequest"),A.$N.send("vscode:listProcesses")):this.m(N)},200)}n(){return this.d?.getSelection()?.map(_=>{if(!(!_||!("pid"in _)))return _.pid}).filter(_=>!!_)}}function D(){const z=(0,T.$xP)();z.id="codiconStyles";const _=(0,s.$9Cb)(void 0);function I(){z.textContent=_.getCSS()}const N=new U.$7g(I,0);_.onDidChange(()=>N.schedule()),N.schedule()}function B(z){const _=z.data.platform==="win32"?"windows":z.data.platform==="linux"?"linux":"mac";document.body.classList.add(_),D(),(0,l.$b9b)(z.data.zoomLevel),new d(z.windowId,z.data)}t.startup=B})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec3f042f9d6b042b9b2e83082ca53f18fee92070/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
