/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=te[J[L]];return e};define(te[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class L{static get(){const R=new Map,j=new Map,A=new Map,v=new Map;function h(f,E){f.has(E.detail)||f.set(E.detail,-E.timestamp)}function c(f,E){const y=f.get(E.detail);y&&(y>=0||f.set(E.detail,y+E.timestamp))}let P=[];typeof J=="function"&&typeof J.getStats=="function"&&(P=J.getStats().slice(0).sort((f,E)=>f.timestamp-E.timestamp));for(const f of P)switch(f.type){case 10:h(R,f);break;case 11:case 12:c(R,f);break;case 21:h(j,f);break;case 22:c(j,f);break;case 33:h(A,f);break;case 34:c(A,f);break;case 31:h(v,f);break;case 32:c(v,f);break}let I=0;A.forEach(f=>I+=f);function d(f){const E=[];return f.forEach((y,m)=>E.push([m,y])),E}return{amdLoad:d(R),amdInvoke:d(j),nodeRequire:d(A),nodeEval:d(v),nodeRequireTotal:I}}static toMarkdownTable(R,j){let A="";const v=[];return R.forEach((h,c)=>{v[c]=h.length}),j.forEach(h=>{h.forEach((c,P)=>{typeof c>"u"&&(c=h[P]="-");const I=c.toString().length;v[P]=Math.max(I,v[P])})}),R.forEach((h,c)=>{A+=`| ${h+" ".repeat(v[c]-h.toString().length)} `}),A+=`|
`,R.forEach((h,c)=>{A+=`| ${"-".repeat(v[c])} `}),A+=`|
`,j.forEach(h=>{h.forEach((c,P)=>{typeof c<"u"&&(A+=`| ${c+" ".repeat(v[P]-c.toString().length)} `)}),A+=`|
`}),A}}e.$T=L}),define(te[52],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function L(A){return(v,h,c)=>{let P=null,I=null;if(typeof c.value=="function"?(P="value",I=c.value):typeof c.get=="function"&&(P="get",I=c.get),!I)throw new Error("not supported");c[P]=A(I,h)}}function D(A,v,h){let c=null,P=null;if(typeof h.value=="function"?(c="value",P=h.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",P=h.get),!P)throw new Error("not supported");const I=`$memoize$${v}`;h[c]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,d)}),this[I]}}e.$ih=D;function R(A,v,h){return L((c,P)=>{const I=`$debounce$${P}`,d=`$debounce$result$${P}`;return function(...f){this[d]||(this[d]=h?h():void 0),clearTimeout(this[I]),v&&(this[d]=v(this[d],...f),f=[this[d]]),this[I]=setTimeout(()=>{c.apply(this,f),this[d]=h?h():void 0},A)}})}e.$jh=R;function j(A,v,h){return L((c,P)=>{const I=`$throttle$timer$${P}`,d=`$throttle$result$${P}`,f=`$throttle$lastRun$${P}`,E=`$throttle$pending$${P}`;return function(...y){if(this[d]||(this[d]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),v&&(this[d]=v(this[d],...y)),this[E])return;const m=this[f]+A;m<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0):(this[E]=!0,this[I]=setTimeout(()=>{this[E]=!1,this[f]=Date.now(),c.apply(this,[this[d]]),this[d]=h?h():void 0},m-Date.now()))}})}e.$kh=j}),define(te[71],ne([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function D(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function R(h,c="Unreachable"){throw new Error(c)}e.$3c=R;function j(h){if(!h)throw new L.$bb("Assertion Failed")}e.$4c=j;function A(h){if(!h()){debugger;h(),(0,L.$Z)(new L.$bb("Assertion Failed"))}}e.$5c=A;function v(h,c){let P=0;for(;P<h.length-1;){const I=h[P],d=h[P+1];if(!c(I,d))return!1;P++}return!0}e.$6c=v}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var j;(function(s){s.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function A(s,o=!1){let t=0;const i=s.length;let n="",r=0,l=16,k=0;function b(se){let ue=0,ce=0;for(;ue<se;){const re=s.charCodeAt(t);if(re>=48&&re<=57)ce=ce*16+re-48;else if(re>=65&&re<=70)ce=ce*16+re-65+10;else if(re>=97&&re<=102)ce=ce*16+re-97+10;else break;t++,ue++}return ue<se&&(ce=-1),ce}function w(se){t=se,n="",r=0,l=16,k=0}function O(){const se=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return k=3,s.substring(se,t);let ue=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ue=t}else k=3;return s.substring(se,ue)}function B(){let se="",ue=t;for(;;){if(t>=i){se+=s.substring(ue,t),k=2;break}const ce=s.charCodeAt(t);if(ce===34){se+=s.substring(ue,t),t++;break}if(ce===92){if(se+=s.substring(ue,t),t++,t>=i){k=2;break}switch(s.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const q=b(4);q>=0?se+=String.fromCharCode(q):k=4;break}default:k=5}ue=t;continue}if(ce>=0&&ce<=31)if(h(ce)){se+=s.substring(ue,t),k=2;break}else k=6;t++}return se}function _(){if(n="",k=0,r=t,t>=i)return r=i,l=17;let se=s.charCodeAt(t);if(v(se)){do t++,n+=String.fromCharCode(se),se=s.charCodeAt(t);while(v(se));return l=15}if(h(se))return t++,n+=String.fromCharCode(se),se===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(se){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=B(),l=10;case 47:{const ue=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!h(s.charCodeAt(t));)t++;return n=s.substring(ue,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let re=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,re=!0;break}t++}return re||(t++,k=1),n=s.substring(ue,t),l=13}return n+=String.fromCharCode(se),t++,l=16}case 45:if(n+=String.fromCharCode(se),t++,t===i||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=O(),l=11;default:for(;t<i&&ee(se);)t++,se=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(se),t++,l=16}}function ee(se){if(v(se)||h(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let se;do se=_();while(se>=12&&se<=15);return se}return{setPosition:w,getPosition:()=>t,scan:o?oe:_,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>k}}e.$Vm=A;function v(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function I(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(b,w,O,B){r.value=b,r.offset=w,r.length=O,r.type=B,r.colonOffset=void 0,n=r}try{N(s,{onObjectBegin:(b,w)=>{if(o<=b)throw i;n=void 0,l=o>b,t.push("")},onObjectProperty:(b,w,O)=>{if(o<w||(k(b,w,O,"property"),t[t.length-1]=b,o<=w+O))throw i},onObjectEnd:(b,w)=>{if(o<=b)throw i;n=void 0,t.pop()},onArrayBegin:(b,w)=>{if(o<=b)throw i;n=void 0,t.push(0)},onArrayEnd:(b,w)=>{if(o<=b)throw i;n=void 0,t.pop()},onLiteralValue:(b,w,O)=>{if(o<w||(k(b,w,O,S(b)),o<=w+O))throw i},onSeparator:(b,w,O)=>{if(o<=w)throw i;if(b===":"&&n&&n.type==="property")n.colonOffset=w,l=!1,n=void 0;else if(b===","){const B=t[t.length-1];typeof B=="number"?t[t.length-1]=B+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(b){if(b!==i)throw b}return{path:t,previousNode:n,isAtPropertyKey:l,matches:b=>{let w=0;for(let O=0;w<b.length&&O<t.length;O++)if(b[w]===t[O]||b[w]==="*")w++;else if(b[w]!=="**")return!1;return w===b.length}}}e.$Wm=I;function d(s,o=[],t=j.DEFAULT){let i=null,n=[];const r=[];function l(b){Array.isArray(n)?n.push(b):i!==null&&(n[i]=b)}return N(s,{onObjectBegin:()=>{const b={};l(b),r.push(n),n=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const b=[];l(b),r.push(n),n=b,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(b,w,O)=>{o.push({error:b,offset:w,length:O})}},t),n[0]}e.$Xm=d;function f(s,o=[],t=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(b){i.type==="property"&&(i.length=b-i.offset,i=i.parent)}function r(b){return i.children.push(b),b}N(s,{onObjectBegin:b=>{i=r({type:"object",offset:b,length:-1,parent:i,children:[]})},onObjectProperty:(b,w,O)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:b,offset:w,length:O,parent:i})},onObjectEnd:(b,w)=>{i.length=b+w-i.offset,i=i.parent,n(b+w)},onArrayBegin:(b,w)=>{i=r({type:"array",offset:b,length:-1,parent:i,children:[]})},onArrayEnd:(b,w)=>{i.length=b+w-i.offset,i=i.parent,n(b+w)},onLiteralValue:(b,w,O)=>{r({type:S(b),offset:w,length:O,parent:i,value:b}),n(w+O)},onSeparator:(b,w,O)=>{i.type==="property"&&(b===":"?i.colonOffset=w:b===","&&n(w))},onError:(b,w,O)=>{o.push({error:b,offset:w,length:O})}},t);const k=i.children[0];return k&&delete k.parent,k}e.$Ym=f;function E(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$Zm=E;function y(s){if(!s.parent||!s.parent.children)return[];const o=y(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$1m=y;function m(s){switch(s.type){case"array":return s.children.map(m);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=m(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$2m=m;function u(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$3m=u;function $(s,o,t=!1){if(u(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=$(i[n],o,t);if(r)return r}return s}}e.$4m=$;function N(s,o,t=j.DEFAULT){const i=A(s,!1);function n(Z){return Z?()=>Z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Z){return Z?K=>Z(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),k=r(o.onObjectProperty),b=n(o.onObjectEnd),w=n(o.onArrayBegin),O=n(o.onArrayEnd),B=r(o.onLiteralValue),_=r(o.onSeparator),ee=n(o.onComment),oe=r(o.onError),se=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function ce(){for(;;){const Z=i.scan();switch(i.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:se||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(Z){case 12:case 13:se?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return Z}}}function re(Z,K=[],C=[]){if(oe(Z),K.length+C.length>0){let F=i.getToken();for(;F!==17;){if(K.indexOf(F)!==-1){ce();break}else if(C.indexOf(F)!==-1)break;F=ce()}}}function q(Z){const K=i.getTokenValue();return Z?B(K):k(K),ce(),!0}function X(){switch(i.getToken()){case 11:{let Z=0;try{Z=JSON.parse(i.getTokenValue()),typeof Z!="number"&&(re(2),Z=0)}catch{re(2)}B(Z);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return ce(),!0}function T(){return i.getToken()!==10?(re(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(_(":"),ce(),G()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function U(){l(),ce();let Z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Z||re(4,[],[]),_(","),ce(),i.getToken()===2&&ue)break}else Z&&re(6,[],[]);T()||re(4,[],[2,5]),Z=!0}return b(),i.getToken()!==2?re(7,[2],[]):ce(),!0}function H(){w(),ce();let Z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Z||re(4,[],[]),_(","),ce(),i.getToken()===4&&ue)break}else Z&&re(6,[],[]);G()||re(4,[],[4,5]),Z=!0}return O(),i.getToken()!==4?re(8,[4],[]):ce(),!0}function G(){switch(i.getToken()){case 3:return H();case 1:return U();case 10:return q(!0);default:return X()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(re(4,[],[]),!1):G()?(i.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.$5m=N;function p(s,o){const t=A(s),i=[];let n,r=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==l&&i.push(s.substring(r,l)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$6m=p;function S(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$7m=S}),define(te[72],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=e.rot=e.$Pl=void 0;function L(v,h,c){return Math.min(Math.max(v,h),c)}e.$Pl=L;function D(v,h){return(h+v%h)%h}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Rl=R;class j{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Sl=j;class A{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Tl=A}),function(){function J(R){const j=[];typeof R=="number"&&j.push("code/timeOrigin",R);function A(h){j.push(h,Date.now())}function v(){const h=[];for(let c=0;c<j.length;c+=2)h.push({name:j[c],startTime:j[c+1]});return h}return{mark:A,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))j.push({name:A.name,startTime:Math.round(R+A.startTime)});return j}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(D,R,j){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:j})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var j=Object.create(null);if(L.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var A in D)L.d(j,A,function(v){return D[v]}.bind(null,A));return j},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var R;e=J.exports=C,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],h=e.src=[],c=0,P=c++;h[P]="0|[1-9]\\d*";var I=c++;h[I]="[0-9]+";var d=c++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[P]+")\\.("+h[P]+")\\.("+h[P]+")";var E=c++;h[E]="("+h[I]+")\\.("+h[I]+")\\.("+h[I]+")";var y=c++;h[y]="(?:"+h[P]+"|"+h[d]+")";var m=c++;h[m]="(?:"+h[I]+"|"+h[d]+")";var u=c++;h[u]="(?:-("+h[y]+"(?:\\."+h[y]+")*))";var $=c++;h[$]="(?:-?("+h[m]+"(?:\\."+h[m]+")*))";var N=c++;h[N]="[0-9A-Za-z-]+";var p=c++;h[p]="(?:\\+("+h[N]+"(?:\\."+h[N]+")*))";var S=c++,s="v?"+h[f]+h[u]+"?"+h[p]+"?";h[S]="^"+s+"$";var o="[v=\\s]*"+h[E]+h[$]+"?"+h[p]+"?",t=c++;h[t]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var n=c++;h[n]=h[I]+"|x|X|\\*";var r=c++;h[r]=h[P]+"|x|X|\\*";var l=c++;h[l]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[u]+")?"+h[p]+"?)?)?";var k=c++;h[k]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[$]+")?"+h[p]+"?)?)?";var b=c++;h[b]="^"+h[i]+"\\s*"+h[l]+"$";var w=c++;h[w]="^"+h[i]+"\\s*"+h[k]+"$";var O=c++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=c++;h[B]="(?:~>?)";var _=c++;h[_]="(\\s*)"+h[B]+"\\s+",v[_]=new RegExp(h[_],"g");var ee=c++;h[ee]="^"+h[B]+h[l]+"$";var oe=c++;h[oe]="^"+h[B]+h[k]+"$";var se=c++;h[se]="(?:\\^)";var ue=c++;h[ue]="(\\s*)"+h[se]+"\\s+",v[ue]=new RegExp(h[ue],"g");var ce=c++;h[ce]="^"+h[se]+h[l]+"$";var re=c++;h[re]="^"+h[se]+h[k]+"$";var q=c++;h[q]="^"+h[i]+"\\s*("+o+")$|^$";var X=c++;h[X]="^"+h[i]+"\\s*("+s+")$|^$";var T=c++;h[T]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[l]+")",v[T]=new RegExp(h[T],"g");var U=c++;h[U]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var H=c++;h[H]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var G=c++;h[G]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)R(Z,h[Z]),v[Z]||(v[Z]=new RegExp(h[Z]));function K(V,Y){if(V instanceof C)return V;if(typeof V!="string"||V.length>j||!(Y?v[t]:v[S]).test(V))return null;try{return new C(V,Y)}catch{return null}}function C(V,Y){if(V instanceof C){if(V.loose===Y)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof C))return new C(V,Y);R("SemVer",V,Y),this.loose=Y;var x=V.trim().match(Y?v[t]:v[S]);if(!x)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<A)return ye}return $e}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=K,e.valid=function(V,Y){var x=K(V,Y);return x?x.version:null},e.clean=function(V,Y){var x=K(V.trim().replace(/^[=v]+/,""),Y);return x?x.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof C||(V=new C(V,this.loose)),this.compareMain(V)||this.comparePre(V)},C.prototype.compareMain=function(V){return V instanceof C||(V=new C(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},C.prototype.comparePre=function(V){if(V instanceof C||(V=new C(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Y=0;do{var x=this.prerelease[Y],$e=V.prerelease[Y];if(R("prerelease compare",Y,x,$e),x===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(x===void 0)return-1;if(x!==$e)return a(x,$e)}while(++Y)},C.prototype.inc=function(V,Y){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Y,x,$e){typeof x=="string"&&($e=x,x=void 0);try{return new C(V,x).inc(Y,$e).version}catch{return null}},e.diff=function(V,Y){if(Q(V,Y))return null;var x=K(V),$e=K(Y);if(x.prerelease.length||$e.prerelease.length){for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var F=/^[0-9]+$/;function a(V,Y){var x=F.test(V),$e=F.test(Y);return x&&$e&&(V=+V,Y=+Y),x&&!$e?-1:$e&&!x?1:V<Y?-1:V>Y?1:0}function g(V,Y,x){return new C(V,x).compare(new C(Y,x))}function z(V,Y,x){return g(V,Y,x)>0}function M(V,Y,x){return g(V,Y,x)<0}function Q(V,Y,x){return g(V,Y,x)===0}function W(V,Y,x){return g(V,Y,x)!==0}function le(V,Y,x){return g(V,Y,x)>=0}function ae(V,Y,x){return g(V,Y,x)<=0}function me(V,Y,x,$e){var ye;switch(Y){case"===":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V===x;break;case"!==":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ye=V!==x;break;case"":case"=":case"==":ye=Q(V,x,$e);break;case"!=":ye=W(V,x,$e);break;case">":ye=z(V,x,$e);break;case">=":ye=le(V,x,$e);break;case"<":ye=M(V,x,$e);break;case"<=":ye=ae(V,x,$e);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function de(V,Y){if(V instanceof de){if(V.loose===Y)return V;V=V.value}if(!(this instanceof de))return new de(V,Y);R("comparator",V,Y),this.loose=Y,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Y){return a(Y,V)},e.major=function(V,Y){return new C(V,Y).major},e.minor=function(V,Y){return new C(V,Y).minor},e.patch=function(V,Y){return new C(V,Y).patch},e.compare=g,e.compareLoose=function(V,Y){return g(V,Y,!0)},e.rcompare=function(V,Y,x){return g(Y,V,x)},e.sort=function(V,Y){return V.sort(function(x,$e){return e.compare(x,$e,Y)})},e.rsort=function(V,Y){return V.sort(function(x,$e){return e.rcompare(x,$e,Y)})},e.gt=z,e.lt=M,e.eq=Q,e.neq=W,e.gte=le,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function fe(V,Y){if(V instanceof fe)return V.loose===Y?V:new fe(V.raw,Y);if(V instanceof de)return new fe(V.value,Y);if(!(this instanceof fe))return new fe(V,Y);if(this.loose=Y,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Y,x,$e,ye,Re,Pe,Le,Ie,Ae,Ue,Ne,De){return((Y=he(x)?"":he($e)?">="+x+".0.0":he(ye)?">="+x+"."+$e+".0":">="+Y)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+Ae+1)+".0":Ne?"<="+Ie+"."+Ae+"."+Ue+"-"+Ne:"<="+Le)).trim()}function be(V,Y){for(var x=0;x<V.length;x++)if(!V[x].test(Y))return!1;if(Y.prerelease.length){for(x=0;x<V.length;x++)if(R(V[x].semver),V[x].semver!==ge&&V[x].semver.prerelease.length>0){var $e=V[x].semver;if($e.major===Y.major&&$e.minor===Y.minor&&$e.patch===Y.patch)return!0}return!1}return!0}function Se(V,Y,x){try{Y=new fe(Y,x)}catch{return!1}return Y.test(V)}function Ce(V,Y,x,$e){var ye,Re,Pe,Le,Ie;switch(V=new C(V,$e),Y=new fe(Y,$e),x){case">":ye=z,Re=ae,Pe=M,Le=">",Ie=">=";break;case"<":ye=M,Re=le,Pe=z,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(V,Y,$e))return!1;for(var Ae=0;Ae<Y.set.length;++Ae){var Ue=Y.set[Ae],Ne=null,De=null;if(Ue.forEach(function(ze){ze.semver===ge&&(ze=new de(">=0.0.0")),Ne=Ne||ze,De=De||ze,ye(ze.semver,Ne.semver,$e)?Ne=ze:Pe(ze.semver,De.semver,$e)&&(De=ze)}),Ne.operator===Le||Ne.operator===Ie||(!De.operator||De.operator===Le)&&Re(V,De.semver)||De.operator===Ie&&Pe(V,De.semver))return!1}return!0}de.prototype.parse=function(V){var Y=this.loose?v[q]:v[X],x=V.match(Y);if(!x)throw new TypeError("Invalid comparator: "+V);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new C(x[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new C(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Y){if(!(V instanceof de))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new fe(V.value,Y),Se(this.value,x,Y);if(V.operator==="")return x=new fe(this.value,Y),Se(V.semver,x,Y);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Re=this.semver.version===V.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,Y)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||Re&&Pe||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Y=this.loose;V=V.trim(),R("range",V,Y);var x=Y?v[H]:v[U];V=V.replace(x,we),R("hyphen replace",V),V=V.replace(v[T],"$1$2$3"),R("comparator trim",V,v[T]),V=(V=(V=V.replace(v[_],"$1~")).replace(v[ue],"$1^")).split(/\s+/).join(" ");var $e=Y?v[q]:v[X],ye=V.split(" ").map(function(Re){return function(Pe,Le){return R("comp",Pe),Pe=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Ne,De){R("caret",Ne,De);var ze=De?v[re]:v[ce];return Ne.replace(ze,function(je,ve,Ee,ke,Oe){var Fe;return R("caret",Ne,je,ve,Ee,ke,Oe),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?Fe=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Oe?(R("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+Oe+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+Oe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+Oe+" <"+(+ve+1)+".0.0"):(R("no pr"),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+ke+" <"+ve+"."+Ee+"."+(+ke+1):">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+ke+" <"+(+ve+1)+".0.0"),R("caret return",Fe),Fe})}(Ue,Ae)}).join(" ")}(Pe,Le),R("caret",Pe),Pe=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Ne,De){var ze=De?v[oe]:v[ee];return Ne.replace(ze,function(je,ve,Ee,ke,Oe){var Fe;return R("tilde",Ne,je,ve,Ee,ke,Oe),he(ve)?Fe="":he(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(ke)?Fe=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Oe?(R("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Fe=">="+ve+"."+Ee+"."+ke+Oe+" <"+ve+"."+(+Ee+1)+".0"):Fe=">="+ve+"."+Ee+"."+ke+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",Fe),Fe})}(Ue,Ae)}).join(" ")}(Pe,Le),R("tildes",Pe),Pe=function(Ie,Ae){return R("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Ue){return function(Ne,De){Ne=Ne.trim();var ze=De?v[w]:v[b];return Ne.replace(ze,function(je,ve,Ee,ke,Oe,Fe){R("xRange",Ne,je,ve,Ee,ke,Oe,Fe);var qe=he(Ee),Me=qe||he(ke),Te=Me||he(Oe);return ve==="="&&Te&&(ve=""),qe?je=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Me&&(ke=0),Te&&(Oe=0),ve===">"?(ve=">=",Me?(Ee=+Ee+1,ke=0,Oe=0):Te&&(ke=+ke+1,Oe=0)):ve==="<="&&(ve="<",Me?Ee=+Ee+1:ke=+ke+1),je=ve+Ee+"."+ke+"."+Oe):Me?je=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(je=">="+Ee+"."+ke+".0 <"+Ee+"."+(+ke+1)+".0"),R("xRange return",je),je})}(Ue,Ae)}).join(" ")}(Pe,Le),R("xrange",Pe),Pe=function(Ie,Ae){return R("replaceStars",Ie,Ae),Ie.trim().replace(v[G],"")}(Pe,Le),R("stars",Pe),Pe}(Re,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Re){return!!Re.match($e)})),ye=ye.map(function(Re){return new de(Re,Y)})},fe.prototype.intersects=function(V,Y){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function($e){return V.set.some(function(ye){return ye.every(function(Re){return $e.intersects(Re,Y)})})})})},e.toComparators=function(V,Y){return new fe(V,Y).set.map(function(x){return x.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new C(V,this.loose));for(var Y=0;Y<this.set.length;Y++)if(be(this.set[Y],V))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(V,Y,x){var $e=null,ye=null;try{var Re=new fe(Y,x)}catch{return null}return V.forEach(function(Pe){Re.test(Pe)&&($e&&ye.compare(Pe)!==-1||(ye=new C($e=Pe,x)))}),$e},e.minSatisfying=function(V,Y,x){var $e=null,ye=null;try{var Re=new fe(Y,x)}catch{return null}return V.forEach(function(Pe){Re.test(Pe)&&($e&&ye.compare(Pe)!==1||(ye=new C($e=Pe,x)))}),$e},e.validRange=function(V,Y){try{return new fe(V,Y).range||"*"}catch{return null}},e.ltr=function(V,Y,x){return Ce(V,Y,"<",x)},e.gtr=function(V,Y,x){return Ce(V,Y,">",x)},e.outside=Ce,e.prerelease=function(V,Y){var x=K(V,Y);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(V,Y,x){return V=new fe(V,x),Y=new fe(Y,x),V.intersects(Y)},e.coerce=function(V){if(V instanceof C)return V;if(typeof V!="string")return null;var Y=V.match(v[O]);return Y==null?null:K((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,R=J.exports={};function j(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function v(m){if(L===setTimeout)return setTimeout(m,0);if((L===j||!L)&&setTimeout)return L=setTimeout,setTimeout(m,0);try{return L(m,0)}catch{try{return L.call(null,m,0)}catch{return L.call(this,m,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:j}catch{L=j}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var h,c=[],P=!1,I=-1;function d(){P&&h&&(P=!1,h.length?c=h.concat(c):I=-1,c.length&&f())}function f(){if(!P){var m=v(d);P=!0;for(var u=c.length;u;){for(h=c,c=[];++I<u;)h&&h[I].run();I=-1,u=c.length}h=null,P=!1,function($){if(D===clearTimeout)return clearTimeout($);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout($);try{D($)}catch{try{return D.call(null,$)}catch{return D.call(this,$)}}}(m)}}function E(m,u){this.fun=m,this.array=u}function y(){}R.nextTick=function(m){var u=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)u[$-1]=arguments[$];c.push(new E(m,u)),c.length!==1||P||v(f)},E.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=y,R.addListener=y,R.once=y,R.off=y,R.removeListener=y,R.removeAllListeners=y,R.emit=y,R.prependListener=y,R.prependOnceListener=y,R.listeners=function(m){return[]},R.binding=function(m){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(m){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class D{constructor(v,h,c){this.level=v,this.key=h,this.value=c,this.forward=[]}}const R=void 0;class j{constructor(v,h=2**16){this.comparator=v,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(v){return!!j.g(this,v,this.comparator)}get(v){return j.g(this,v,this.comparator)?.value}set(v,h){return j.h(this,v,h,this.comparator)&&(this.f+=1),this}delete(v){const h=j.k(this,v,this.comparator);return h&&(this.f-=1),h}forEach(v,h){let c=this.e.forward[0];for(;c;)v.call(h,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let v=this.e.forward[0];for(;v;)yield[v.key,v.value],v=v.forward[0]}*keys(){let v=this.e.forward[0];for(;v;)yield v.key,v=v.forward[0]}*values(){let v=this.e.forward[0];for(;v;)yield v.value,v=v.forward[0]}toString(){let v="[SkipList]:",h=this.e.forward[0];for(;h;)v+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return v}static g(v,h,c){let P=v.e;for(let I=v.d-1;I>=0;I--)for(;P.forward[I]&&c(P.forward[I].key,h)<0;)P=P.forward[I];if(P=P.forward[0],P&&c(P.key,h)===0)return P}static h(v,h,c,P){const I=[];let d=v.e;for(let f=v.d-1;f>=0;f--){for(;d.forward[f]&&P(d.forward[f].key,h)<0;)d=d.forward[f];I[f]=d}if(d=d.forward[0],d&&P(d.key,h)===0)return d.value=c,!1;{const f=j.j(v);if(f>v.d){for(let E=v.d;E<f;E++)I[E]=v.e;v.d=f}d=new D(f,h,c);for(let E=0;E<f;E++)d.forward[E]=I[E].forward[E],I[E].forward[E]=d;return!0}}static j(v,h=.5){let c=1;for(;Math.random()<h&&c<v.c;)c+=1;return c}static k(v,h,c){const P=[];let I=v.e;for(let d=v.d-1;d>=0;d--){for(;I.forward[d]&&c(I.forward[d].key,h)<0;)I=I.forward[d];P[d]=I}if(I=I.forward[0],!I||c(I.key,h)!==0)return!1;for(let d=0;d<v.d&&P[d].forward[d]===I;d++)P[d].forward[d]=I.forward[d];for(;v.d>0&&v.e.forward[v.d-1]===R;)v.d-=1;return!0}}e.$zr=j}),define(te[45],ne([0,1,9,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function R(p){const S=p;return S?typeof S.read=="function":!1}e.$Yd=R;function j(p){const S=p;return S?[S.on,S.pause,S.resume,S.destroy].every(s=>typeof s=="function"):!1}e.$Zd=j;function A(p){const S=p;return S?j(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$1d=A;function v(p,S){return new h(p,S)}e.$2d=v;class h{constructor(S,s){this.e=S,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(s=>s(S))}h(S){this.c.error.length===0?(0,L.$Z)(S):this.c.error.slice(0).forEach(s=>s(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,s){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(S,s){if(this.a.destroyed)return;let o;switch(S){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,S){const s=[];let o;for(;(o=p.read())!==null;)s.push(o);return S(s)}e.$3d=c;function P(p,S,s){const o=[];let t;for(;(t=p.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?S(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}e.$4d=P;function I(p,S){return new Promise((s,o)=>{const t=[];d(p,{onData:i=>{S&&t.push(i)},onError:i=>{S?o(i):s(void 0)},onEnd:()=>{s(S?S(t):void 0)}})})}e.$5d=I;function d(p,S,s){p.on("error",o=>{s?.isCancellationRequested||S.onError(o)}),p.on("end",()=>{s?.isCancellationRequested||S.onEnd()}),p.on("data",o=>{s?.isCancellationRequested||S.onData(o)})}e.$6d=d;function f(p,S){return new Promise((s,o)=>{const t=new D.$Qc,i=[],n=k=>{if(i.push(k),i.length>S)return t.dispose(),p.pause(),s({stream:p,buffer:i,ended:!1})},r=k=>(t.dispose(),o(k)),l=()=>(t.dispose(),s({stream:p,buffer:i,ended:!0}));t.add((0,D.$Pc)(()=>p.removeListener("error",r))),p.on("error",r),t.add((0,D.$Pc)(()=>p.removeListener("end",l))),p.on("end",l),t.add((0,D.$Pc)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$7d=f;function E(p,S){const s=v(S);return s.end(p),s}e.$8d=E;function y(){const p=v(()=>{throw new Error("not supported")});return p.end(),p}e.$9d=y;function m(p){let S=!1;return{read:()=>S?null:(S=!0,p)}}e.$0d=m;function u(p,S,s){const o=v(s);return d(p,{onData:t=>o.write(S.data(t)),onError:t=>o.error(S.error?S.error(t):t),onEnd:()=>o.end()}),o}e.$$d=u;function $(p,S,s){let o=!1;return{read:()=>{const t=S.read();return o?t:(o=!0,t!==null?s([p,t]):p)}}}e.$_d=$;function N(p,S,s){let o=!1;const t=v(s);return d(S,{onData:i=>o?t.write(i):(o=!0,t.write(s([p,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(p)),t.end()}}),t}e.$ae=N}),define(te[14],ne([0,1,164,45]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const R=typeof Buffer<"u",j=new L.$U(()=>new Uint8Array(256));let A,v;class h{static alloc(O){return R?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return R&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,B){return!(B?.dontUseNodeBuffer||!1)&&R?new h(Buffer.from(O)):(A||(A=new TextEncoder),new h(A.encode(O)))}static fromByteArray(O){const B=h.alloc(O.length);for(let _=0,ee=O.length;_<ee;_++)B.buffer[_]=O[_];return B}static concat(O,B){if(typeof B>"u"){B=0;for(let oe=0,se=O.length;oe<se;oe++)B+=O[oe].byteLength}const _=h.alloc(B);let ee=0;for(let oe=0,se=O.length;oe<se;oe++){const ue=O[oe];_.set(ue,ee),ee+=ue.byteLength}return _}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return R?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(O,B){return new h(this.buffer.subarray(O,B))}set(O,B){if(O instanceof h)this.buffer.set(O.buffer,B);else if(O instanceof Uint8Array)this.buffer.set(O,B);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),B);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return d(this.buffer,O)}writeUInt32BE(O,B){f(this.buffer,O,B)}readUInt32LE(O){return E(this.buffer,O)}writeUInt32LE(O,B){y(this.buffer,O,B)}readUInt8(O){return m(this.buffer,O)}writeUInt8(O,B){u(this.buffer,O,B)}indexOf(O,B=0){return c(this.buffer,O instanceof h?O.buffer:O,B)}}e.$be=h;function c(w,O,B=0){const _=O.byteLength,ee=w.byteLength;if(_===0)return 0;if(_===1)return w.indexOf(O[0]);if(_>ee-B)return-1;const oe=j.value;oe.fill(O.length);for(let re=0;re<O.length;re++)oe[O[re]]=O.length-re-1;let se=B+O.length-1,ue=se,ce=-1;for(;se<ee;)if(w[se]===O[ue]){if(ue===0){ce=se;break}se--,ue--}else se+=Math.max(O.length-ue,oe[w[se]]),ue=O.length-1;return ce}e.$ce=c;function P(w,O){return w[O+0]<<0>>>0|w[O+1]<<8>>>0}e.$de=P;function I(w,O,B){w[B+0]=O&255,O=O>>>8,w[B+1]=O&255}e.$ee=I;function d(w,O){return w[O]*2**24+w[O+1]*2**16+w[O+2]*2**8+w[O+3]}e.$fe=d;function f(w,O,B){w[B+3]=O,O=O>>>8,w[B+2]=O,O=O>>>8,w[B+1]=O,O=O>>>8,w[B]=O}e.$ge=f;function E(w,O){return w[O+0]<<0>>>0|w[O+1]<<8>>>0|w[O+2]<<16>>>0|w[O+3]<<24>>>0}e.$he=E;function y(w,O,B){w[B+0]=O&255,O=O>>>8,w[B+1]=O&255,O=O>>>8,w[B+2]=O&255,O=O>>>8,w[B+3]=O&255}e.$ie=y;function m(w,O){return w[O]}e.$je=m;function u(w,O,B){w[B]=O}e.$ke=u;function $(w){return D.$3d(w,O=>h.concat(O))}e.$le=$;function N(w){return D.$0d(w)}e.$me=N;function p(w){return D.$5d(w,O=>h.concat(O))}e.$ne=p;async function S(w){return w.ended?h.concat(w.buffer):h.concat([...w.buffer,await p(w.stream)])}e.$oe=S;function s(w){return D.$8d(w,O=>h.concat(O))}e.$pe=s;function o(w){return D.$$d(w,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}e.$qe=o;function t(w){return D.$2d(O=>h.concat(O),w)}e.$re=t;function i(w,O){return D.$_d(w,O,B=>h.concat(B))}e.$se=i;function n(w,O){return D.$ae(w,O,B=>h.concat(B))}e.$te=n;function r(w){let O=0,B=0,_=0;const ee=new Uint8Array(Math.floor(w.length/4*3)),oe=ue=>{switch(B){case 3:ee[_++]=O|ue,B=0;break;case 2:ee[_++]=O|ue>>>2,O=ue<<6,B=3;break;case 1:ee[_++]=O|ue>>>4,O=ue<<4,B=2;break;default:O=ue<<2,B=1}};for(let ue=0;ue<w.length;ue++){const ce=w.charCodeAt(ue);if(ce>=65&&ce<=90)oe(ce-65);else if(ce>=97&&ce<=122)oe(ce-97+26);else if(ce>=48&&ce<=57)oe(ce-48+52);else if(ce===43||ce===45)oe(62);else if(ce===47||ce===95)oe(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ue]}`)}}const se=_;for(;B>0;)oe(0);return h.wrap(ee).slice(0,se)}e.$ue=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:w},O=!0,B=!1){const _=B?k:l;let ee="";const oe=w.byteLength%3;let se=0;for(;se<w.byteLength-oe;se+=3){const ue=w[se+0],ce=w[se+1],re=w[se+2];ee+=_[ue>>>2],ee+=_[(ue<<4|ce>>>4)&63],ee+=_[(ce<<2|re>>>6)&63],ee+=_[re&63]}if(oe===1){const ue=w[se+0];ee+=_[ue>>>2],ee+=_[ue<<4&63],O&&(ee+="==")}else if(oe===2){const ue=w[se+0],ce=w[se+1];ee+=_[ue>>>2],ee+=_[(ue<<4|ce>>>4)&63],ee+=_[ce<<2&63],O&&(ee+="=")}return ee}e.$ve=b}),define(te[41],ne([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;function D(u){return R(u,0)}e.$Ei=D;function R(u,$){switch(typeof u){case"object":return u===null?j(349,$):Array.isArray(u)?h(u,$):c(u,$);case"string":return v(u,$);case"boolean":return A(u,$);case"number":return j(u,$);case"undefined":return j(937,$);default:return j(617,$)}}e.$Fi=R;function j(u,$){return($<<5)-$+u|0}e.$Gi=j;function A(u,$){return j(u?433:863,$)}function v(u,$){$=j(149417,$);for(let N=0,p=u.length;N<p;N++)$=j(u.charCodeAt(N),$);return $}e.$Hi=v;function h(u,$){return $=j(104579,$),u.reduce((N,p)=>R(p,N),$)}function c(u,$){return $=j(181387,$),Object.keys(u).sort().reduce((N,p)=>(N=v(p,N),R(u[p],N)),$)}class P{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=R($,this.g),this.g}}e.$Ii=P;var I;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(u,$,N=32){const p=N-$,S=~((1<<p)-1);return(u<<$|(S&u)>>>p)>>>0}function f(u,$=0,N=u.byteLength,p=0){for(let S=0;S<N;S++)u[$+S]=p}function E(u,$,N="0"){for(;u.length<$;)u=N+u;return u}function y(u,$=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(N=>N.toString(16).padStart(2,"0")).join(""):E((u>>>0).toString(16),$/4)}e.$Ji=y;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const N=$.length;if(N===0)return;const p=this.p;let S=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=$.charCodeAt(0),t=0);;){let i=o;if(L.$6e(o))if(t+1<N){const n=$.charCodeAt(t+1);L.$7e(n)?(t++,i=L.$8e(o,n)):i=65533}else{s=o;break}else L.$7e(o)&&(i=65533);if(S=this.w(p,S,i),t++,t<N)o=$.charCodeAt(t);else break}this.r=S,this.u=s}w($,N,p){return p<128?$[N++]=p:p<2048?($[N++]=192|(p&1984)>>>6,$[N++]=128|(p&63)>>>0):p<65536?($[N++]=224|(p&61440)>>>12,$[N++]=128|(p&4032)>>>6,$[N++]=128|(p&63)>>>0):($[N++]=240|(p&1835008)>>>18,$[N++]=128|(p&258048)>>>12,$[N++]=128|(p&4032)>>>6,$[N++]=128|(p&63)>>>0),N>=64&&(this.y(),N-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),N}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=m.g,N=this.q;for(let l=0;l<64;l+=4)$.setUint32(l,N.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)$.setUint32(l,d($.getUint32(l-12,!1)^$.getUint32(l-32,!1)^$.getUint32(l-56,!1)^$.getUint32(l-64,!1),1),!1);let p=this.h,S=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let l=0;l<80;l++)l<20?(i=S&s|~S&o,n=1518500249):l<40?(i=S^s^o,n=1859775393):l<60?(i=S&s|S&o|s&o,n=2400959708):(i=S^s^o,n=3395469782),r=d(p,5)+i+t+n+$.getUint32(l*4,!1)&4294967295,t=o,o=s,s=d(S,30),S=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+S&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Ki=m}),define(te[54],ne([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const j="error",A="warning",v="warn",h="info",c="ignore";function P(d){return d?L.$2e(j,d)?R.Error:L.$2e(A,d)||L.$2e(v,d)?R.Warning:L.$2e(h,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=P;function I(d){switch(d){case R.Error:return j;case R.Warning:return A;case R.Info:return h;default:return c}}R.toString=I}(D||(D={})),e.default=D}),define(te[30],ne([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=void 0;function D(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const $=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([N,p])=>{$[N]=p&&typeof p=="object"?D(p):p}),$}e.$8m=D;function R(u){if(!u||typeof u!="object")return u;const $=[u];for(;$.length>0;){const N=$.shift();Object.freeze(N);for(const p in N)if(j.call(N,p)){const S=N[p];typeof S=="object"&&!Object.isFrozen(S)&&!(0,L.$Bf)(S)&&$.push(S)}}return u}e.$9m=R;const j=Object.prototype.hasOwnProperty;function A(u,$){return v(u,$,new Set)}e.$0m=A;function v(u,$,N){if((0,L.$Hf)(u))return u;const p=$(u);if(typeof p<"u")return p;if(Array.isArray(u)){const S=[];for(const s of u)S.push(v(s,$,N));return S}if((0,L.$Af)(u)){if(N.has(u))throw new Error("Cannot clone recursive data-structure");N.add(u);const S={};for(const s in u)j.call(u,s)&&(S[s]=v(u[s],$,N));return N.delete(u),S}return u}function h(u,$,N=!0){return(0,L.$Af)(u)?((0,L.$Af)($)&&Object.keys($).forEach(p=>{p in u?N&&((0,L.$Af)(u[p])&&(0,L.$Af)($[p])?h(u[p],$[p],N):u[p]=$[p]):u[p]=$[p]}),u):$}e.$$m=h;function c(u,$){if(u===$)return!0;if(u==null||$===null||$===void 0||typeof u!=typeof $||typeof u!="object"||Array.isArray(u)!==Array.isArray($))return!1;let N,p;if(Array.isArray(u)){if(u.length!==$.length)return!1;for(N=0;N<u.length;N++)if(!c(u[N],$[N]))return!1}else{const S=[];for(p in u)S.push(p);S.sort();const s=[];for(p in $)s.push(p);if(s.sort(),!c(S,s))return!1;for(N=0;N<S.length;N++)if(!c(u[S[N]],$[S[N]]))return!1}return!0}e.$_m=c;function P(u){const $=new Set;return JSON.stringify(u,(N,p)=>{if((0,L.$Af)(p)||Array.isArray(p)){if($.has(p))return"[Circular]";$.add(p)}return p})}e.$an=P;function I(u,$){const N=Object.create(null);return!u||!$||Object.keys($).forEach(S=>{const s=u[S],o=$[S];c(s,o)||(N[S]=o)}),N}e.$bn=I;function d(u,$){const N=$.toLowerCase(),p=Object.keys(u).find(S=>S.toLowerCase()===N);return p?u[p]:u[$]}e.$cn=d;function f(u,$){const N=Object.create(null);for(const[p,S]of Object.entries(u))$(p,S)&&(N[p]=S);return N}e.$dn=f;function E(u){let $=[];for(;Object.prototype!==u;)$=$.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return $}e.$en=E;function y(u){const $=[];for(const N of E(u))typeof u[N]=="function"&&$.push(N);return $}e.$fn=y;function m(u,$){const N=S=>function(){const s=Array.prototype.slice.call(arguments,0);return $(S,s)},p={};for(const S of u)p[S]=N(S);return p}e.$gn=m}),define(te[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$dg=D,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(v){for(let h=0;h<v.length;h++)v[h]=Math.floor(Math.random()*256);return v};const j=new Uint8Array(16),A=[];for(let v=0;v<256;v++)A.push(v.toString(16).padStart(2,"0"));return function(){R(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let h=0,c="";return c+=A[j[h++]],c+=A[j[h++]],c+=A[j[h++]],c+=A[j[h++]],c+="-",c+=A[j[h++]],c+=A[j[h++]],c+="-",c+=A[j[h++]],c+=A[j[h++]],c+="-",c+=A[j[h++]],c+=A[j[h++]],c+="-",c+=A[j[h++]],c+=A[j[h++]],c+=A[j[h++]],c+=A[j[h++]],c+=A[j[h++]],c+=A[j[h++]],c}}()}),define(te[74],ne([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(A){const v=A.replace(/\-/g,":").toLowerCase();return!D.has(v)}function j(){const A=(0,L.networkInterfaces)();for(const v in A){const h=A[v];if(h){for(const{mac:c}of h)if(R(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Rm=j}),define(te[75],ne([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=void 0;const D=60,R=D*60,j=R*24,A=j*7,v=j*30,h=j*365;function c(I,d,f,E){typeof I!="number"&&(I=I.getTime());const y=Math.round((new Date().getTime()-I)/1e3);if(y<-30)return(0,L.localize)(0,null,c(new Date().getTime()+y*1e3,!1));if(!E&&y<30)return(0,L.localize)(1,null);let m;return y<D?(m=y,d?m===1?f?(0,L.localize)(2,null,m):(0,L.localize)(3,null,m):f?(0,L.localize)(4,null,m):(0,L.localize)(5,null,m):m===1?f?(0,L.localize)(6,null,m):(0,L.localize)(7,null,m):f?(0,L.localize)(8,null,m):(0,L.localize)(9,null,m)):y<R?(m=Math.floor(y/D),d?m===1?f?(0,L.localize)(10,null,m):(0,L.localize)(11,null,m):f?(0,L.localize)(12,null,m):(0,L.localize)(13,null,m):m===1?f?(0,L.localize)(14,null,m):(0,L.localize)(15,null,m):f?(0,L.localize)(16,null,m):(0,L.localize)(17,null,m)):y<j?(m=Math.floor(y/R),d?m===1?f?(0,L.localize)(18,null,m):(0,L.localize)(19,null,m):f?(0,L.localize)(20,null,m):(0,L.localize)(21,null,m):m===1?f?(0,L.localize)(22,null,m):(0,L.localize)(23,null,m):f?(0,L.localize)(24,null,m):(0,L.localize)(25,null,m)):y<A?(m=Math.floor(y/j),d?m===1?(0,L.localize)(26,null,m):(0,L.localize)(27,null,m):m===1?(0,L.localize)(28,null,m):(0,L.localize)(29,null,m)):y<v?(m=Math.floor(y/A),d?m===1?f?(0,L.localize)(30,null,m):(0,L.localize)(31,null,m):f?(0,L.localize)(32,null,m):(0,L.localize)(33,null,m):m===1?f?(0,L.localize)(34,null,m):(0,L.localize)(35,null,m):f?(0,L.localize)(36,null,m):(0,L.localize)(37,null,m)):y<h?(m=Math.floor(y/v),d?m===1?f?(0,L.localize)(38,null,m):(0,L.localize)(39,null,m):f?(0,L.localize)(40,null,m):(0,L.localize)(41,null,m):m===1?f?(0,L.localize)(42,null,m):(0,L.localize)(43,null,m):f?(0,L.localize)(44,null,m):(0,L.localize)(45,null,m)):(m=Math.floor(y/h),d?m===1?f?(0,L.localize)(46,null,m):(0,L.localize)(47,null,m):f?(0,L.localize)(48,null,m):(0,L.localize)(49,null,m):m===1?f?(0,L.localize)(50,null,m):(0,L.localize)(51,null,m):f?(0,L.localize)(52,null,m):(0,L.localize)(53,null,m))}e.$em=c;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$fm=P}),define(te[77],ne([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function j(I,d){return d&&(I.stack||I.stacktrace)?R.localize(0,null,v(I),A(I.stack)||A(I.stacktrace)):v(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function v(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?R.localize(1,null,I.message):I.message||R.localize(2,null)}function h(I=null,d=!1){if(!I)return R.localize(3,null);if(Array.isArray(I)){const f=L.$Gb(I),E=h(f[0],d);return f.length>1?R.localize(4,null,E,f.length):E}if(D.$yf(I))return I;if(I.detail){const f=I.detail;if(f.error)return j(f.error,d);if(f.exception)return j(f.exception,d)}return I.stack?j(I,d):I.message?I.message:R.localize(5,null)}e.$Bi=h;function c(I){const d=I;return d instanceof Error&&Array.isArray(d.actions)}e.$Ci=c;function P(I,d){let f;return typeof I=="string"?f=new Error(I):f=I,f.actions=d,f}e.$Di=P}),define(te[78],ne([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$xp=D}),define(te[55],ne([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.TerminateResponseCode=e.Source=void 0;var D;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function j(v,...h){const c=h.reduce((d,f)=>(d[f]=!0,d),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(d=>!c[d]).forEach(d=>{for(let f=0;f<P.length;f++)if(d.search(P[f])!==-1){delete v[d];break}})}e.$Al=j;function A(v){v&&(delete v.DEBUG,L.$k&&delete v.DYLD_LIBRARY_PATH,L.$l&&delete v.LD_PRELOAD)}e.$Bl=A}),define(te[80],ne([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$1p=e.$Zp=e.$Yp=void 0;function D(c){const P=c;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Yp=D;function R(c){const P=[];let I;try{const d=JSON.parse(c.arguments),f=d[d.length-1];f&&f.__$stack&&(d.pop(),I=f.__$stack),P.push(...d)}catch{P.push("Unable to log remote console arguments",c.arguments)}return{args:P,stack:I}}e.$Zp=R;function j(c){if(typeof c!="string")return j(R(c).stack);const P=c;if(P){const I=A(P),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$1p=j;function A(c){if(!c)return c;const P=c.indexOf(`
`);return P===-1?c:c.substring(0,P)}function v(c,P){const{args:I,stack:d}=R(c),f=typeof I[0]=="string"&&I.length===1;let E=A(d);E&&(E=`(${E.trim()})`);let y=[];if(typeof I[0]=="string"?E&&f?y=[`%c[${P}] %c${I[0]} %c${E}`,h("blue"),h(""),h("grey")]:y=[`%c[${P}] %c${I[0]}`,h("blue"),h(""),...I.slice(1)]:y=[`%c[${P}]%`,h("blue"),...I],E&&!f&&y.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}e.log=v;function h(c){return`color: ${c}`}}),define(te[46],ne([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function R(h){return JSON.stringify(h,A)}e.$lh=R;function j(h){let c=JSON.parse(h);return c=v(c),c}e.$mh=j;function A(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function v(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof L.$be||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let P=0;P<h.length;++P)h[P]=v(h[P],c+1);else for(const P in h)Object.hasOwnProperty.call(h,P)&&(h[P]=v(h[P],c+1))}return h}e.$nh=v}),define(te[81],ne([0,1,70,15,13,11]),function(J,e,L,D,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=void 0;class A{constructor(d,f,E){this.id=d,this.dependencies=f,this.callback=E}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,f,E)=>{typeof d!="string"&&(E=f,f=d,d=null),(typeof f!="object"||!Array.isArray(f))&&(E=f,f=null),this.c.push(new A(d,f,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const f=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!f)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(d){return new Promise((f,E)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const m=()=>{y.removeEventListener("load",u),y.removeEventListener("error",$)},u=N=>{m(),f(this.c.pop())},$=N=>{m(),E(N)};y.addEventListener("load",u),y.addEventListener("error",$),this.f&&(d=this.f.createScriptURL(d)),y.setAttribute("src",d),document.getElementsByTagName("head")[0].appendChild(y)})}i(d){return new Promise((f,E)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),f(this.c.pop())}catch(y){E(y)}})}async j(d){try{const f=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,m=j.URI.parse(d).fsPath,u=f.readFileSync(m).toString(),$=y.wrap(u.replace(/^#!.*/,""));return new E.Script($).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const h=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function P(I,d,f){if(L.$S){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[I]&&(I=c[I]);const E=`${I}/${d}`;if(h.has(E))return h.get(E);let y;if(/^\w[\w\d+.-]*:\/\//.test(E))y=E;else{const N=`${f&&!R.$p?D.$_f:D.$$f}/${E}`;y=D.$cg.asBrowserUri(N).toString(!0)}const m=v.INSTANCE.load(y);return h.set(E,m),m}else return await new Promise((E,y)=>{J([I],E,y)})}e.$IC=P}),define(te[82],ne([0,1,33,47,28,74,13]),function(J,e,L,D,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=void 0,e.$Sm=new class{c(d){return this.a||(this.a=D.$Wh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,f=0;const E=(0,L.networkInterfaces)();for(const y in E){const m=E[y];if(m)for(const{mac:u,internal:$}of m)$||(f+=1,this.c(u.toUpperCase())&&(d+=1))}this.b=f>0?d/f:0}return this.b}};let v;async function h(d){return v||(v=(async()=>await c(d)||R.$eg())()),v}e.$Tm=h;async function c(d){try{const f=await new Promise((y,m)=>{J(["crypto"],y,m)}),E=(0,j.$Rm)();return f.createHash("sha256").update(E,"utf8").digest("hex")}catch(f){d(f);return}}const P="Software\\Microsoft\\SQMClient";async function I(d){if(A.$j){const f=await new Promise((E,y)=>{J(["@vscode/windows-registry"],E,y)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(E){return d(E),""}}return""}e.$Um=I}),define(te[83],ne([0,1,33,16,24]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0;const j=/^\d+$/,A=/^Microsoft.PowerShell_.*/,v=/^Microsoft.PowerShellPreview_.*/;var h;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class I{constructor(S,s,o){this.exePath=S,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:p=!1,findPreview:S=!1}={}){const s=d({useAlternateBitness:p});if(!s)return null;const o=D.$ic(s,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const l of await R.Promises.readdir(o)){let k=-1;if(S){const w=l.indexOf("-");if(w<0)continue;const O=l.substring(0,w);if(!j.test(O)||l.substring(w+1)!=="preview")continue;k=parseInt(O,10)}else{if(!j.test(l))continue;k=parseInt(l,10)}if(k<=t)continue;const b=D.$ic(o,l,"pwsh.exe");await R.SymlinkSupport.existsFile(b)&&(i=b,t=k)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=S?" Preview":"";return new I(i,`PowerShell${r}${n}`,!0)}async function E({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const S=D.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(S))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=p?{pwshMsixDirRegex:v,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(S))if(s.test(t)){const i=D.$ic(S,t,"pwsh.exe");return new I(i,o)}return null}function y(){const p=D.$ic(L.homedir(),".dotnet","tools","pwsh.exe");return new I(p,".NET Core PowerShell Global Tool")}function m(){const p=D.$ic(process.env.windir,c===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(p,"Windows PowerShell",!0)}async function*u(){let p=await f();p&&(yield p),p=await f({useAlternateBitness:!0}),p&&(yield p),p=await E(),p&&(yield p),p=y(),p&&(yield p),p=await f({findPreview:!0}),p&&(yield p),p=await E({findPreview:!0}),p&&(yield p),p=await f({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=m(),p&&(yield p)}async function*$(){for await(const p of u())await p.exists()&&(yield p)}e.$yl=$;async function N(){for await(const p of $())return p;return null}e.$zl=N}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(J,e,L,D,R,j,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Dl=e.$Cl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function h(I=R.env){return I.comspec||"cmd.exe"}e.$Cl=h;function c(I){let d=[],f=!1;const E=function(y){if(f){d.push(y);return}(!I.send(y,u=>{if(u&&console.error(u),f=!1,d.length>0){const $=d.slice(0);d=[],$.forEach(N=>E(N))}})||D.$j)&&(f=!0)};return{send:E}}e.$Dl=c;var P;(function(I){async function d(f,E,y){if(L.$hc(f))return f;if(E===void 0&&(E=R.cwd()),L.$lc(f)!=="."||(y===void 0&&A.$yf(R.env.PATH)&&(y=R.env.PATH.split(L.$sc)),y===void 0||y.length===0))return L.$ic(E,f);async function u($){if(await v.Promises.exists($)){let N;try{N=await v.Promises.stat($)}catch(p){p.message.startsWith("EACCES")&&(N=await v.Promises.lstat($))}return N?!N.isDirectory():!1}return!1}for(const $ of y){let N;if(L.$hc($)?N=L.$ic($,f):N=L.$ic(E,$,f),await u(N))return N;let p=N+".com";if(await u(p)||(p=N+".exe",await u(p)))return p}return L.$ic(E,f)}I.findExecutable=d})(P||(e.win32=P={}))}),define(te[84],ne([0,1,33,13,83,56]),function(J,e,L,D,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0;async function A(I,d){return I===1?D.$j?P():j.$Cl(d):h(I,d)}e.$El=A;let v=null;function h(I,d){if(D.$l&&I===2||D.$k&&I===3)return"/bin/bash";if(!v){let f;if(D.$j)f="/bin/bash";else{if(f=d.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}v=f}return v}let c=null;async function P(){return c||(c=(await(0,R.$zl)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,L,D){var R=arguments.length,j=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(J,e,L,D);else for(var v=J.length-1;v>=0;v--)(A=J[v])&&(j=(R<3?A(j):R>3?A(e,L,j):A(e,L))||j);return R>3&&j&&Object.defineProperty(e,L,j),j};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(J,e,L,D,R,j,A,v,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.ProxyChannel=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.RequestInitiator=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;var f;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(f||(f={}));function E(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(y||(y={}));function m(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(u||(u={}));function $(T){let U=0;for(let H=0;;H+=7){const G=T.read(1);if(U|=(G.buffer[0]&127)<<H,!(G.buffer[0]&128))return U}}const N=t(0);function p(T,U){if(U===0){T.write(N);return}let H=0;for(let Z=U;Z!==0;Z=Z>>>7)H++;const G=R.$be.alloc(H);for(let Z=0;U!==0;Z++)G.buffer[Z]=U&127,U=U>>>7,U>0&&(G.buffer[Z]|=128);T.write(G)}class S{constructor(U){this.b=U,this.a=0}read(U){const H=this.b.slice(this.a,this.a+U);return this.a+=H.byteLength,H}}e.$oh=S;class s{constructor(){this.a=[]}get buffer(){return R.$be.concat(this.a)}write(U){this.a.push(U)}}e.$ph=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const U=R.$be.alloc(1);return U.writeUInt8(T,0),U}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(T,U){if(typeof U>"u")T.write(i.Undefined);else if(typeof U=="string"){const H=R.$be.fromString(U);T.write(i.String),p(T,H.byteLength),T.write(H)}else if(n&&Buffer.isBuffer(U)){const H=R.$be.wrap(U);T.write(i.Buffer),p(T,H.byteLength),T.write(H)}else if(U instanceof R.$be)T.write(i.VSBuffer),p(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(i.Array),p(T,U.length);for(const H of U)r(T,H)}else if(typeof U=="number"&&(U|0)===U)T.write(i.Uint),p(T,U);else{const H=R.$be.fromString(JSON.stringify(U));T.write(i.Object),p(T,H.byteLength),T.write(H)}}e.$qh=r;function l(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read($(T)).toString();case o.Buffer:return T.read($(T)).buffer;case o.VSBuffer:return T.read($(T));case o.Array:{const H=$(T),G=[];for(let Z=0;Z<H;Z++)G.push(l(T));return G}case o.Object:return JSON.parse(T.read($(T)).toString());case o.Int:return $(T)}}e.$rh=l;class k{constructor(U,H,G=null,Z=1e3){this.h=U,this.j=H,this.k=G,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(U,H){this.b.set(U,H),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const H=this.o([U.type]);this.k?.logOutgoing(H,0,1,m(U.type));return}case 201:case 202:case 204:case 203:{const H=this.o([U.type,U.id],U.data);this.k?.logOutgoing(H,U.id,1,m(U.type),U.data);return}}}o(U,H=void 0){const G=new s;return r(G,U),r(G,H),this.p(G.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const H=new S(U),G=l(H),Z=l(H),K=G[0];switch(K){case 100:return this.k?.logIncoming(U.byteLength,G[1],1,`${E(K)}: ${G[2]}.${G[3]}`,Z),this.s({type:K,id:G[1],channelName:G[2],name:G[3],arg:Z});case 102:return this.k?.logIncoming(U.byteLength,G[1],1,`${E(K)}: ${G[2]}.${G[3]}`,Z),this.t({type:K,id:G[1],channelName:G[2],name:G[3],arg:Z});case 101:return this.k?.logIncoming(U.byteLength,G[1],1,`${E(K)}`),this.u({type:K,id:G[1]});case 103:return this.k?.logIncoming(U.byteLength,G[1],1,`${E(K)}`),this.u({type:K,id:G[1]})}}s(U){const H=this.b.get(U.channelName);if(!H){this.v(U);return}const G=new j.$Xd;let Z;try{Z=H.call(this.j,U.name,U.arg,G.token)}catch(F){Z=Promise.reject(F)}const K=U.id;Z.then(F=>{this.m({id:K,data:F,type:201})},F=>{F instanceof Error?this.m({id:K,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:K,data:F,type:203})}).finally(()=>{C.dispose(),this.d.delete(U.id)});const C=(0,c.$Pc)(()=>G.cancel());this.d.set(U.id,C)}t(U){const H=this.b.get(U.channelName);if(!H){this.v(U);return}const G=U.id,K=H.listen(this.j,U.name,U.arg)(C=>this.m({id:G,data:C,type:204}));this.d.set(U.id,K)}u(U){const H=this.d.get(U.id);H&&(H.dispose(),this.d.delete(U.id))}v(U){let H=this.g.get(U.channelName);H||(H=[],this.g.set(U.channelName,H));const G=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:U,timeoutTimer:G})}w(U){const H=this.g.get(U);if(H){for(const G of H)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$sh=k;var b;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class w{constructor(U,H=null){this.l=U,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=H}getChannel(U){const H=this;return{call(G,Z,K){return H.a?Promise.reject(new v.$4):H.m(U,G,Z,K)},listen(G,Z){return H.a?h.Event.None:H.o(U,G,Z)}}}m(U,H,G,Z=j.CancellationToken.None){const K=this.g++,F={id:K,type:100,channelName:U,name:H,arg:G};if(Z.isCancellationRequested)return Promise.reject(new v.$4);let a;return new Promise((z,M)=>{if(Z.isCancellationRequested)return M(new v.$4);const Q=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(K),z(de.data);break;case 202:{this.f.delete(K);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,M(ge);break}case 203:this.f.delete(K),M(de.data);break}};this.f.set(K,me),this.p(F)};let W=null;this.b===u.Idle?Q():(W=(0,D.$Hg)(me=>this.u()),W.then(()=>{W=null,Q()}));const le=()=>{W?(W.cancel(),W=null):this.p({id:K,type:101}),M(new v.$4)},ae=Z.onCancellationRequested(le);a=(0,c.$Oc)((0,c.$Pc)(le),ae),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(U,H,G){const Z=this.g++,C={id:Z,type:102,channelName:U,name:H,arg:G};let F=null;const a=new h.$Nd({onWillAddFirstListener:()=>{F=(0,D.$Hg)(z=>this.u()),F.then(()=>{F=null,this.d.add(a),this.p(C)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(a),this.p({id:Z,type:103}))}}),g=z=>a.fire(z.data);return this.f.set(Z,g),a.event}p(U){switch(U.type){case 100:case 102:{const H=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(H,U.id,0,`${E(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const H=this.q([U.type,U.id]);this.j?.logOutgoing(H,U.id,0,E(U.type));return}}}q(U,H=void 0){const G=new s;return r(G,U),r(G,H),this.r(G.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const H=new S(U),G=l(H),Z=l(H),K=G[0];switch(K){case 200:return this.j?.logIncoming(U.byteLength,0,0,m(K)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,G[1],0,m(K),Z),this.t({type:G[0],id:G[1],data:Z})}}t(U){if(U.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Mc)(this.d.values()),this.d.clear()}}e.$th=w,pe([A.$ih],w.prototype,"onDidInitializePromise",null);class O{get connections(){const U=[];return this.f.forEach(H=>U.push(H)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new h.$Nd,this.onDidAddConnection=this.g.event,this.h=new h.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Qc,this.j.add(U(({protocol:H,onDidClientDisconnect:G})=>{const Z=h.Event.once(H.onMessage);this.j.add(Z(K=>{const C=new S(K),F=l(C),a=new k(H,F),g=new w(H);this.a.forEach((M,Q)=>a.registerChannel(Q,M));const z={channelServer:a,channelClient:g,ctx:F};this.f.add(z),this.g.fire(z),this.j.add(G(()=>{a.dispose(),g.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(U,H){const G=this;return{call(Z,K,C){let F;if((0,d.$Mf)(H)){const g=(0,L.$3b)(G.connections.filter(H));F=g?Promise.resolve(g):h.Event.toPromise(h.Event.filter(G.onDidAddConnection,H))}else F=H.routeCall(G,Z,K);const a=F.then(g=>g.channelClient.getChannel(U));return _(a).call(Z,K,C)},listen(Z,K){if((0,d.$Mf)(H))return G.k(U,H,Z,K);const C=H.routeEvent(G,Z,K).then(F=>F.channelClient.getChannel(U));return _(C).listen(Z,K)}}}k(U,H,G,Z){const K=this;let C;const F=new h.$Nd({onWillAddFirstListener:()=>{C=new c.$Qc;const a=new h.$Td,g=new Map,z=Q=>{const le=Q.channelClient.getChannel(U).listen(G,Z),ae=a.add(le);g.set(Q,ae)},M=Q=>{const W=g.get(Q);W&&(W.dispose(),g.delete(Q))};K.connections.filter(H).forEach(z),h.Event.filter(K.onDidAddConnection,H)(z,void 0,C),K.onDidRemoveConnection(M,void 0,C),a.event(F.fire,F,C),C.add(a)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return F.event}registerChannel(U,H){this.a.set(U,H);for(const G of this.f)G.channelServer.registerChannel(U,H)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$uh=O;class B{constructor(U,H,G=null){const Z=new s;r(Z,H),U.send(Z.buffer),this.a=new w(U,G),this.d=new k(U,H,G)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,H){this.d.registerChannel(U,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$vh=B;function _(T){return{call(U,H,G){return T.then(Z=>Z.call(U,H,G))},listen(U,H){const G=new h.$Wd;return T.then(Z=>G.input=Z.listen(U,H)),G.event}}}e.$wh=_;function ee(T){let U=!1;return{call(H,G,Z){return U?T.call(H,G,Z):(0,D.$Ug)(0).then(()=>U=!0).then(()=>T.call(H,G,Z))},listen(H,G){if(U)return T.listen(H,G);const Z=new h.$Wd;return(0,D.$Ug)(0).then(()=>U=!0).then(()=>Z.input=T.listen(H,G)),Z.event}}}e.$xh=ee;class oe{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const H of U.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await h.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$yh=oe;var se;(function(T){function U(K,C,F){const a=K,g=F&&F.disableMarshalling,z=new Map;for(const M in a)G(M)&&z.set(M,h.Event.buffer(a[M],!0,void 0,C));return new class{listen(M,Q,W){const le=z.get(Q);if(le)return le;if(Z(Q)){const ae=a[Q];if(typeof ae=="function")return ae.call(a,W)}throw new v.$ab(`Event not found: ${Q}`)}call(M,Q,W){const le=a[Q];if(typeof le=="function"){if(!g&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,P.$nh)(W[me]);let ae=le.apply(a,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new v.$ab(`Method not found: ${Q}`)}}}T.fromService=U;function H(K,C){const F=C&&C.disableMarshalling;return new Proxy({},{get(a,g){if(typeof g=="string")return C?.properties?.has(g)?C.properties.get(g):Z(g)?function(z){return K.listen(g,z)}:G(g)?K.listen(g):async function(...z){let M;C&&!(0,d.$Hf)(C.context)?M=[C.context,...z]:M=z;const Q=await K.call(g,M);return F?Q:(0,P.$nh)(Q)};throw new v.$ab(`Property not found: ${String(g)}`)}})}T.toService=H;function G(K){return K[0]==="o"&&K[1]==="n"&&I.$1e(K.charCodeAt(2))}function Z(K){return/^onDynamic/.test(K)&&I.$1e(K.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function re(T){return Array.isArray(T)?T.map(ce):ce(T)}function q(T,U,H,G,Z,K,C){C=re(C);const F=ue[Z],a=F[G%F.length];let g=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(K)?(g=g.concat(C),g.push(")")):g.push(C),console.log.apply(console,g)}class X{constructor(U,H){this.d=U,this.f=H,this.a=0,this.b=0}logOutgoing(U,H,G,Z,K){this.b+=U,q(this.d,this.b,U,H,G,Z,K)}logIncoming(U,H,G,Z,K){this.a+=U,q(this.f,this.a,U,H,G,Z,K)}}e.$zh=X}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;class E extends f.$sh{constructor(u){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",$=>R.$be.wrap(Buffer.from($,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$3p=E;class y{constructor(u,$){this.i=u,this.j=$,this.c=new Set,this.g=new Map,this.h=new h.$Nd,this.onDidProcessExit=this.h.event;const N=$&&$.timeout?$.timeout:6e4;this.b=new D.$Qg(N),this.d=null,this.f=null}getChannel(u){const $=this;return{call(N,p,S){return $.k(u,N,p,S)},listen(N,p){return $.l(u,N,p)}}}k(u,$,N,p=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(v.$5());this.b.cancel();const S=this.n(u),s=(0,D.$Hg)(i=>S.call($,N,i)),o=p.onCancellationRequested(()=>s.cancel()),t=(0,c.$Pc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(u,$,N){if(!this.b)return h.Event.None;this.b.cancel();let p;const S=new h.$Nd({onWillAddFirstListener:()=>{p=this.n(u).listen($,N)(S.fire,S),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return S.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,P.$8m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,d.$Bl)($.env),this.d=(0,L.fork)(this.i,u,$);const N=new h.$Nd;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$Yp)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}N.fire(R.$be.wrap(Buffer.from(n,"base64")))});const S=this.j.useQueue?(0,I.$Dl)(this.d):this.d,s=n=>this.d&&this.d.connected&&S.send(n.buffer.toString("base64")),o=N.event,t={send:s,onMessage:o};this.f=new f.$th(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.$Mc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(u){let $=this.g.get(u);return $||($=this.m.getChannel(u),this.g.set(u,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$4p=y}),define(te[86],ne([0,1,8,4,2,46,3]),function(J,e,L,D,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.StorageState=e.$2o=e.StorageHint=void 0;var v;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function h(d){const f=d;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$2o=h;var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class P extends R.$Rc{static{this.a=100}constructor(f,E=Object.create(null)){super(),this.r=f,this.s=E,this.b=this.B(new D.$Qd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Rg(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((E,y)=>this.w(y,E)),f.deleted?.forEach(E=>this.w(E,void 0))}finally{this.b.resume()}}w(f,E){if(this.c===c.Closed)return;let y=!1;(0,A.$Hf)(E)?y=this.f.delete(f):this.f.get(f)!==E&&(this.f.set(f,E),y=!0),y&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,E){const y=this.f.get(f);return(0,A.$Hf)(y)?E:y}getBoolean(f,E){const y=this.get(f);return(0,A.$Hf)(y)?E:y==="true"}getNumber(f,E){const y=this.get(f);return(0,A.$Hf)(y)?E:parseInt(y,10)}getObject(f,E){const y=this.get(f);return(0,A.$Hf)(y)?E:(0,j.$mh)(y)}async set(f,E,y=!1){if(this.c===c.Closed)return;if((0,A.$Hf)(E))return this.delete(f,y);const m=(0,A.$Af)(E)||Array.isArray(E)?(0,j.$lh)(E):String(E);if(this.f.get(f)!==m)return this.f.set(f,m),this.j.set(f,m),this.h.delete(f),this.b.fire({key:f,external:y}),this.D()}async delete(f,E=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:E}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$3o=P;class I{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((E,y)=>this.a.set(y,E)),f.delete?.forEach(E=>this.a.delete(E))}async optimize(){}async close(){}}e.$4o=I}),define(te[87],ne([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[88],ne([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[89],ne([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(te[90],ne([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(te[91],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[92],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[93],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[94],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[95],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[96],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[97],ne([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[98],ne([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[99],ne([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[100],ne([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[101],ne([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[102],ne([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[103],ne([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[104],ne([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(te[105],ne([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[106],ne([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[107],ne([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(te[108],ne([0,1,9,90]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var R;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(R||(e.TokenType=R={}));function j(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const A=(0,D.localize)(3,null),v=(0,D.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.$7)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const I=this.d,d=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:d};this.g.push({offset:I,lexeme:d,additionalInfo:P}),this.f.push(f)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const I=this.c.substring(this.d,this.e),d=h.b.get(I);d?this.k(d):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,I=!1,d=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(v);return}const E=this.c.charCodeAt(P);if(I)I=!1;else if(E===47&&!d){P++;break}else E===91?d=!0:E===92?I=!0:E===93&&(d=!1);P++}for(;P<this.c.length&&h.a.has(this.c.charCodeAt(P));)P++;this.e=P;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=h}),define(te[109],ne([0,1,76,52,15,16,35,17,11]),function(J,e,L,D,R,j,A,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.$gm=void 0,e.$gm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,j.$lc)(R.$cg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,j.$ic)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,v.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,v.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$fm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$ic)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,v.$vg)(h.URI.file((0,j.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,v.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,v.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,v.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?h.URI.file((0,j.$ic)(f,"argv.json")):(0,v.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,j.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,j.$jc)(f):(0,j.$gc)((0,j.$ic)(R.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,j.$jc)(f)):h.URI.file((0,j.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,j.$jc)(f);const E=A.env.VSCODE_EXTENSIONS;if(E)return E;const y=A.env.VSCODE_PORTABLE;return y?(0,j.$ic)(y,"extensions"):(0,v.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(E=>/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,j.$gc)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,j.$gc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$gm.test(f))}get extensionLogLevel(){const f=[];for(const E of this.args.log||[]){const y=e.$gm.exec(E);y&&y[1]&&y[2]&&f.push([y[1],y[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,v.$vg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?h.URI.file((0,j.$ic)(f,"policy.json")):(0,v.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,E,y){this.a=f,this.b=E,this.c=y,this.editSessionId=this.args.editSessionId}}e.$hm=c,pe([D.$ih],c.prototype,"appRoot",null),pe([D.$ih],c.prototype,"userHome",null),pe([D.$ih],c.prototype,"userDataPath",null),pe([D.$ih],c.prototype,"appSettingsHome",null),pe([D.$ih],c.prototype,"tmpDir",null),pe([D.$ih],c.prototype,"cacheHome",null),pe([D.$ih],c.prototype,"stateResource",null),pe([D.$ih],c.prototype,"userRoamingDataHome",null),pe([D.$ih],c.prototype,"userDataSyncHome",null),pe([D.$ih],c.prototype,"sync",null),pe([D.$ih],c.prototype,"machineSettingsResource",null),pe([D.$ih],c.prototype,"workspaceStorageHome",null),pe([D.$ih],c.prototype,"localHistoryHome",null),pe([D.$ih],c.prototype,"keyboardLayoutResource",null),pe([D.$ih],c.prototype,"argvResource",null),pe([D.$ih],c.prototype,"isExtensionDevelopment",null),pe([D.$ih],c.prototype,"untitledWorkspacesHome",null),pe([D.$ih],c.prototype,"builtinExtensionsPath",null),pe([D.$ih],c.prototype,"extensionsPath",null),pe([D.$ih],c.prototype,"extensionDevelopmentLocationURI",null),pe([D.$ih],c.prototype,"extensionDevelopmentKind",null),pe([D.$ih],c.prototype,"extensionTestsLocationURI",null),pe([D.$ih],c.prototype,"debugExtensionHost",null),pe([D.$ih],c.prototype,"logLevel",null),pe([D.$ih],c.prototype,"extensionLogLevel",null),pe([D.$ih],c.prototype,"serviceMachineIdResource",null),pe([D.$ih],c.prototype,"disableTelemetry",null),pe([D.$ih],c.prototype,"disableWorkspaceTrust",null),pe([D.$ih],c.prototype,"useInMemorySecretStorage",null),pe([D.$ih],c.prototype,"policyFile",null);function P(d,f){return I(d["inspect-extensions"],d["inspect-brk-extensions"],5870,f,d.debugId,d.extensionEnvironment)}e.$im=P;function I(d,f,E,y,m,u){const N=Number(f||d)||(y?null:E),p=N?!!f:!1;let S;if(u)try{S=JSON.parse(u)}catch{}return{port:N,break:p,debugId:m,env:S}}e.$jm=I}),function(){"use strict";function J(e,L,D){function R(A,v){const h=j(A,v),c=[h];return e.isAbsolute(h)||c.unshift(D),e.resolve(...c)}function j(A,v){process.env.VSCODE_DEV&&(v="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,v);const P=A["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(I,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,v)}return{getUserDataPath:R}}if(typeof define=="function")define(te[110],ne([165,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[111],ne([0,1,33,109,110]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=e.$lm=e.$km=void 0;class j extends D.$hm{constructor(c,P){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(c,P.nameShort)},P)}}e.$km=j;function A(h,c){return(0,D.$jm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$lm=A;function v(h,c){return(0,D.$jm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$mm=v}),define(te[112],ne([0,1,3,94]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;function R(A,v,h,c){try{j(A,v,h,c)}catch(P){A.error(P?.message??P)}return v}e.$yp=R;function j(A,v,h,c){const P=(I,d,f)=>{const E=I[d];if((0,L.$yf)(E)){const y=E,m=y.length;if(m>1&&y[0]==="%"&&y[m-1]==="%"){const u=y.substr(1,m-2);let $=h[u];$===void 0&&c&&($=c[u]);const N=typeof $=="string"?$:$?.message,p=c?.[u],S=typeof p=="string"?p:p?.message;if(!N){S||A.warn(`[${v.name}]: ${(0,D.localize)(0,null,u)}`);return}if(f&&(d==="title"||d==="category")&&S&&S!==N){const s={value:N,original:S};I[d]=s}else I[d]=N}}else if((0,L.$Af)(E))for(const y in E)E.hasOwnProperty(y)&&(y==="commands"?P(E,y,!0):P(E,y,f));else if(Array.isArray(E))for(let y=0;y<E.length;y++)P(E,y,f)};for(const I in v)v.hasOwnProperty(I)&&P(v,I)}}),define(te[48],ne([0,1,17,54,98,42]),function(J,e,L,D,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function h(u){return u=u.trim(),u==="*"||A.test(u)}e.$Mo=h;function c(u){if(!h(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=u.match(A);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}e.$No=c;function P(u){if(!u)return null;const $=u.majorBase,N=u.majorMustEqual,p=u.minorBase;let S=u.minorMustEqual;const s=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&($===0||(S=!1),o=!1);let t=0;if(u.preRelease){const i=v.exec(u.preRelease);if(i){const[,n,r,l]=i;t=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:$,majorMustEqual:N,minorBase:p,minorMustEqual:S,patchBase:s,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.$Oo=P;function I(u,$,N){let p;typeof u=="string"?p=P(c(u)):p=u;let S;$ instanceof Date?S=$.getTime():typeof $=="string"&&(S=new Date($).getTime());let s;if(typeof N=="string"?s=P(c(N)):s=N,!p||!s)return!1;const o=p.majorBase,t=p.minorBase,i=p.patchBase;let n=s.majorBase,r=s.minorBase,l=s.patchBase;const k=s.notBefore;let b=s.majorMustEqual,w=s.minorMustEqual,O=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||S&&S<k?!1:i>=l:(o===1&&n===0&&(!b||!w||!O)&&(n=1,r=0,l=0,b=!0,w=!1,O=!1),o<n?!1:o>n?!b:t<r?!1:t>r?!w:i<l?!1:i>l?!O:!(S&&S<k))}e.$Po=I;function d(u,$,N,p,S){const s=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return s.push([D.default.Error,R.localize(0,null)]),s;if(typeof p.name!="string")return s.push([D.default.Error,R.localize(1,null,"name")]),s;if(typeof p.version!="string")return s.push([D.default.Error,R.localize(2,null,"version")]),s;if(!p.engines)return s.push([D.default.Error,R.localize(3,null,"engines")]),s;if(typeof p.engines.vscode!="string")return s.push([D.default.Error,R.localize(4,null,"engines.vscode")]),s;if(typeof p.extensionDependencies<"u"&&!m(p.extensionDependencies))return s.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),s;if(typeof p.activationEvents<"u"){if(!m(p.activationEvents))return s.push([D.default.Error,R.localize(6,null,"activationEvents")]),s;if(typeof p.main>"u"&&typeof p.browser>"u")return s.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),s}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&s.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return s.push([D.default.Error,R.localize(9,null,"main")]),s;{const i=(0,L.$vg)(N,p.main);(0,L.$pg)(i,N)||s.push([D.default.Warning,R.localize(10,null,i.path,N.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return s.push([D.default.Error,R.localize(11,null,"browser")]),s;{const i=(0,L.$vg)(N,p.browser);(0,L.$pg)(i,N)||s.push([D.default.Warning,R.localize(12,null,i.path,N.path)])}}if(!j.valid(p.version))return s.push([D.default.Error,R.localize(13,null)]),s;const o=[];if(!f(u,$,p,S,o))for(const i of o)s.push([D.default.Error,i]);return s}e.$Qo=d;function f(u,$,N,p,S){return p||typeof N.main>"u"&&typeof N.browser>"u"?!0:y(u,$,N.engines.vscode,S)}e.$Ro=f;function E(u,$,N){return u==="*"||y($,N,u)}e.$So=E;function y(u,$,N,p=[]){const S=P(c(N));if(!S)return p.push(R.localize(14,null,N)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return p.push(R.localize(15,null,N)),!1}else if(!S.majorMustEqual)return p.push(R.localize(16,null,N)),!1;return I(u,$,S)?!0:(p.push(R.localize(17,null,u,N)),!1)}function m(u){if(!Array.isArray(u))return!1;for(let $=0,N=u.length;$<N;$++)if(typeof u[$]!="string")return!1;return!0}}),define(te[113],ne([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;async function R(j,A,v){let h=v&&v.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const P=(await A.readFile(j.serviceMachineIdResource)).value.toString();h=(0,D.$dg)(P)?P:null}catch{h=null}if(!h){h=(0,D.$eg)();try{await A.writeFile(j.serviceMachineIdResource,L.$be.fromString(h))}catch{}}return v?.store("storage.serviceMachineId",h,-1,1),h}e.$ap=R}),define(te[49],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class L{constructor(R,j=[],A=!1){this.ctor=R,this.staticArguments=j,this.supportsDelayedInstantiation=A}}e.$Nh=L}),define(te[114],ne([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.InstantiationType=void 0;const D=[];var R;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function j(v,h,c){h instanceof L.$Nh||(h=new L.$Nh(h,[],!!c)),D.push([v,h])}e.$xr=j;function A(){return D}e.$yr=A}),define(te[115],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class L{constructor(j,A){this.key=j,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$cq=L;class D{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const A of this.a.values())A.outgoing.size===0&&j.push(A);return j}insertEdge(j,A){const v=this.lookupOrInsertNode(j),h=this.lookupOrInsertNode(A);v.outgoing.set(h.key,h),h.incoming.set(v.key,v)}removeNode(j){const A=this.b(j);this.a.delete(A);for(const v of this.a.values())v.outgoing.delete(A),v.incoming.delete(A)}lookupOrInsertNode(j){const A=this.b(j);let v=this.a.get(A);return v||(v=new L(A,j),this.a.set(A,v)),v}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[A,v]of this.a)j.push(`${A}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,A]of this.a){const v=new Set([j]),h=this.c(A,v);if(h)return h}}c(j,A){for(const[v,h]of j.outgoing){if(A.has(v))return[...A,v].join(" -> ");A.add(v);const c=this.c(h,A);if(c)return c;A.delete(v)}}}e.$dq=D}),define(te[25],ne([0,1,3,11,10]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,R.$Qh)("configurationService");function j(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof D.URI)}e.$li=j;function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof D.URI)}e.$mi=A;var v;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=h;function c(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$oi=c;function P(u,$){const N=Object.create(null);for(const p in u)I(N,p,u[p],$);return N}e.$pi=P;function I(u,$,N,p){const S=$.split("."),s=S.pop();let o=u;for(let t=0;t<S.length;t++){const i=S[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${$} as ${S.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=N}catch{p(`Ignoring ${$} as ${S.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${$} as ${S.join(".")} is ${JSON.stringify(o)}`)}e.$qi=I;function d(u,$){const N=$.split(".");f(u,N)}e.$ri=d;function f(u,$){const N=$.shift();if($.length===0){delete u[N];return}if(Object.keys(u).indexOf(N)!==-1){const p=u[N];typeof p=="object"&&!Array.isArray(p)&&(f(p,$),Object.keys(p).length===0&&delete u[N])}}function E(u,$,N){function p(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const S=$.split("."),s=p(u,S);return typeof s>"u"?N:s}e.$si=E;function y(u,$,N){Object.keys($).forEach(p=>{p!=="__proto__"&&(p in u?L.$Af(u[p])&&L.$Af($[p])?y(u[p],$[p],N):N&&(u[p]=$[p]):u[p]=$[p])})}e.$ti=y;function m(u){return u.replace(/[\[\]]/g,"")}e.$ui=m}),define(te[116],ne([0,1,13,29,108,10,89,9]),function(J,e,L,D,R,j,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",L.$k),h.set("isLinux",L.$l),h.set("isWindows",L.$j),h.set("isWeb",L.$p),h.set("isMacNative",L.$k&&!L.$p),h.set("isEdge",L.$H),h.set("isFirefox",L.$F),h.set("isChrome",L.$E),h.set("isSafari",L.$G);function c(F,a){if(h.get(F)!==void 0)throw(0,v.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(F,a)}e.$Mi=c;const P=Object.prototype.hasOwnProperty;var I;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const d={regexParsingWithErrorRecovery:!0},f=(0,A.localize)(0,null),E=(0,A.localize)(1,null),y=(0,A.localize)(2,null),m=(0,A.localize)(3,null),u=(0,A.localize)(4,null),$=(0,A.localize)(5,null),N=(0,A.localize)(6,null),p=(0,A.localize)(7,null);class S{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=d){this.k=a,this.d=new R.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const g=this.l();if(!this.E()){const z=this.D(),M=z.type===17?$:void 0;throw this.h.push({message:u,offset:z.offset,lexeme:R.$Li.getLexeme(z),additionalInfo:M}),S.c}return g}catch(g){if(g!==S.c)throw g;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const g=this.o();a.push(g)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const g=this.s();a.push(g)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const g=this.l();return this.A(1,m),g?.negate()}case 17:return this.z(),B.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const g=this.l();return this.A(1,m),g}case 17:{const g=a.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const Q=M.lexeme,W=Q.lastIndexOf("/"),le=W===Q.length-1?void 0:this.w(Q.substring(W+1));let ae;try{ae=new RegExp(Q.substring(1,W),le)}catch{throw this.B("REGEX",M)}return ce.create(g,ae)}switch(M.type){case 10:case 19:{const Q=[M.lexeme];this.z();let W=this.D(),le=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?le++:M.lexeme.charCodeAt(fe)===41&&le--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?le++:M.lexeme.charCodeAt(fe)===41&&le--}if(le<0)break;Q.push(R.$Li.getLexeme(W)),this.z(),W=this.D()}const ae=Q.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this.w(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this.B("REGEX",M)}return s.regex(g,ge)}case 18:{const Q=M.lexeme;this.z();let W=null;if(!(0,D.$Be)(Q)){const le=Q.indexOf("/"),ae=Q.lastIndexOf("/");if(le!==ae&&le>=0){const me=Q.slice(le+1,ae),de=Q[ae+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",M)}}}if(W===null)throw this.B("REGEX",M);return ce.create(g,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const M=this.u();return s.notIn(g,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return s.equals(g,M);switch(M){case"true":return s.has(g);case"false":return s.not(g);default:return s.equals(g,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return s.notEquals(g,M);switch(M){case"true":return s.not(g);case"false":return s.has(g);default:return s.notEquals(g,M)}}case 5:return this.z(),se.create(g,this.u());case 6:return this.z(),ue.create(g,this.u());case 7:return this.z(),ee.create(g,this.u());case 8:return this.z(),oe.create(g,this.u());case 13:return this.z(),s.in(g,this.u());default:return s.has(g)}}case 20:throw this.h.push({message:N,offset:a.offset,lexeme:"",additionalInfo:p}),S.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,g){if(this.C(a))return this.z();throw this.B(g,this.D())}B(a,g,z){const M=(0,A.localize)(8,null,a,R.$Li.getLexeme(g)),Q=g.offset,W=R.$Li.getLexeme(g);return this.h.push({message:M,offset:Q,lexeme:W,additionalInfo:z}),S.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=S;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return l.create(a)}static equals(a,g){return k.create(a,g)}static notEquals(a,g){return O.create(a,g)}static regex(a,g){return ce.create(a,g)}static in(a,g){return b.create(a,g)}static notIn(a,g){return w.create(a,g)}static not(a){return B.create(a)}static and(...a){return X.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,g){return ee.create(a,g)}static greaterEquals(a,g){return oe.create(a,g)}static smaller(a,g){return se.create(a,g)}static smallerEquals(a,g){return ue.create(a,g)}static{this.c=new S({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Oi=s;function o(F){const a=new S({regexParsingWithErrorRecovery:!1});return F.map(g=>(a.parse(g),a.lexingErrors.length>0?a.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$Pi=o;function t(F,a){const g=F?F.substituteConstants():void 0,z=a?a.substituteConstants():void 0;return!g&&!z?!0:!g||!z?!1:g.equals(z)}e.$Qi=t;function i(F,a){return F.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$Ri=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$Si=r;class l{static create(a,g=null){const z=h.get(a);return typeof z=="boolean"?z?r.INSTANCE:n.INSTANCE:new l(a,g)}constructor(a,g){this.key=a,this.c=g,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:H(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=h.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=B.create(this.key,this)),this.c}}e.$Ti=l;class k{static create(a,g,z=null){if(typeof g=="boolean")return g?l.create(a,z):B.create(a,z);const M=h.get(a);return typeof M=="boolean"?g===(M?"true":"false")?r.INSTANCE:n.INSTANCE:new k(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ui=k;class b{static create(a,g){return new b(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:G(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.f),z=a.getValue(this.d);return Array.isArray(g)?g.includes(z):typeof z=="string"&&typeof g=="object"&&g!==null?P.call(g,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Vi=b;class w{static create(a,g){return new w(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=11,this.c=b.create(a,g)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=w;class O{static create(a,g,z=null){if(typeof g=="boolean")return g?B.create(a,z):l.create(a,z);const M=h.get(a);return typeof M=="boolean"?g===(M?"true":"false")?n.INSTANCE:r.INSTANCE:new O(a,g,z)}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Xi=O;class B{static create(a,g=null){const z=h.get(a);return typeof z=="boolean"?z?n.INSTANCE:r.INSTANCE:new B(a,g)}constructor(a,g){this.c=a,this.d=g,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:H(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=h.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Yi=B;function _(F,a){if(typeof F=="string"){const g=parseFloat(F);isNaN(g)||(F=g)}return typeof F=="string"||typeof F=="number"?a(F):n.INSTANCE}class ee{static create(a,g,z=null){return _(g,M=>new ee(a,M,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Zi=ee;class oe{static create(a,g,z=null){return _(g,M=>new oe(a,M,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$1i=oe;class se{static create(a,g,z=null){return _(g,M=>new se(a,M,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$2i=se;class ue{static create(a,g,z=null){return _(g,M=>new ue(a,M,z))}constructor(a,g,z){this.c=a,this.d=g,this.f=z,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:G(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$3i=ue;class ce{static create(a,g){return new ce(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return g<z?-1:g>z?1:0}equals(a){if(a.type===this.type){const g=this.f?this.f.source:"",z=a.f?a.f.source:"";return this.d===a.d&&g===z}return!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.d);return this.f?this.f.test(g):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$4i=ce;class re{static create(a){return new re(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new re(this.c.map(a))}negate(){return this.c}}e.$5i=re;function q(F){let a=null;for(let g=0,z=F.length;g<z;g++){const M=F[g].substituteConstants();if(F[g]!==M&&a===null){a=[];for(let Q=0;Q<g;Q++)a[Q]=F[Q]}a!==null&&(a[g]=M)}return a===null?F:a}class X{static create(a,g,z){return X.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const M=i(this.expr[g],a.expr[g]);if(M!==0)return M}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:X.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].evaluate(a))return!1;return!0}static d(a,g,z){const M=[];let Q=!1;for(const W of a)if(W){if(W.type===1){Q=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&Q)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const le=M.pop(),ae=M.length===0,me=T.create(W.expr.map(de=>X.create([de,le],null,z)),null,ae);me&&(M.push(me),M.sort(i))}if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let le=W+1;le<M.length;le++)if(M[W].negate().equals(M[le]))return n.INSTANCE;if(M.length===1)return M[0]}return new X(M,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new X(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());this.c=T.create(a,this,!0)}return this.c}}e.$6i=X;class T{static create(a,g,z){return T.d(a,g,z)}constructor(a,g){this.expr=a,this.c=g,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,z=this.expr.length;g<z;g++){const M=i(this.expr[g],a.expr[g]);if(M!==0)return M}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,z=this.expr.length;g<z;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let g=0,z=this.expr.length;g<z;g++)if(this.expr[g].evaluate(a))return!0;return!1}static d(a,g,z){let M=[],Q=!1;if(a){for(let W=0,le=a.length;W<le;W++){const ae=a[W];if(ae){if(ae.type===0){Q=!0;continue}if(ae.type===1)return r.INSTANCE;if(ae.type===9){M=M.concat(ae.expr);continue}M.push(ae)}}if(M.length===0&&Q)return n.INSTANCE;M.sort(i)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let le=W+1;le<M.length;le++)if(M[W].negate().equals(M[le]))return r.INSTANCE;if(M.length===1)return M[0]}return new T(M,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new T(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());for(;a.length>1;){const g=a.shift(),z=a.shift(),M=[];for(const Q of C(g))for(const W of C(z))M.push(X.create([Q,W],null,!1));a.unshift(T.create(M,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$7i=T;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(a,g,z){super(a,null),this.f=g,typeof z=="object"?U.d.push({...z,key:a}):z!==!0&&U.d.push({key:a,description:z,type:g!=null?typeof g:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return k.create(this.key,a)}notEqualsTo(a){return O.create(this.key,a)}}e.$8i=U,e.$9i=(0,j.$Qh)("contextKeyService");function H(F,a){return F<a?-1:F>a?1:0}function G(F,a,g,z){return F<g?-1:F>g?1:a<z?-1:a>z?1:0}function Z(F,a){if(F.type===0||a.type===1)return!0;if(F.type===9)return a.type===9?K(F.expr,a.expr):!1;if(a.type===9){for(const g of a.expr)if(Z(F,g))return!0;return!1}if(F.type===6){if(a.type===6)return K(a.expr,F.expr);for(const g of F.expr)if(Z(g,a))return!0;return!1}return F.equals(a)}e.$0i=Z;function K(F,a){let g=0,z=0;for(;g<F.length&&z<a.length;){const M=F[g].cmp(a[z]);if(M<0)return!1;M===0&&g++,z++}return g===F.length}function C(F){return F.type===9?F.expr:[F]}}),define(te[59],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Pn=(0,L.$Qh)("downloadService")}),define(te[18],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,L.$Qh)("environmentService"),e.$Yh=(0,L.$Rh)(e.$Xh)}),define(te[21],ne([0,1,92,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$$n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=void 0,e.$Yn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Zn=new RegExp(e.$Yn),e.$1n="__web_extension",e.$2n="skipWalkthrough",e.$3n="extensionsSync",e.$4n="dependecyOrPackExtensionInstall";function R(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$5n=R;function j(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$6n=j;function A(u,$){switch(u){case 3:return $==="x64"?"win32-x64":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$7n=A;function v(u,$){return $==="web"&&!u.includes("web")}e.$8n=v;function h(u,$,N){return v($,N)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===N}e.$9n=h;function c(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$0n=c;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var I;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$$n=(0,D.$Qh)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var y;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class m extends Error{constructor($,N){super($),this.code=N,this.name=N}}e.$_n=m,e.$ao=(0,D.$Qh)("extensionManagementService"),e.$bo="extensionsIdentifiers/disabled",e.$co="extensionsIdentifiers/enabled",e.$do=(0,D.$Qh)("IGlobalExtensionEnablementService"),e.$eo=(0,D.$Qh)("IExtensionTipsService"),e.$fo=(0,L.localize)(0,null),e.$go={value:e.$fo,original:"Extensions"},e.$ho={value:(0,L.localize)(1,null),original:"Preferences"}}),define(te[60],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=void 0,e.$fp=(0,L.$Qh)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((j,A)=>J(["node-vsce-sign"],async v=>j(v),A))),this.a}async verify(j,A,v){let h;try{h=await this.b()}catch{return!1}return h.verify(j,A,v)}}e.$gp=D}),define(te[61],ne([0,1,14,9,100,12]),function(J,e,L,D,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;async function A(P,I,d,f,E,y){let m;try{await v(P,I,d,f,E,y)}catch(u){m=u}finally{m&&E.errorTransformer&&(m=E.errorTransformer(m)),typeof m<"u"&&d.error(m),d.end()}}e.$Np=A;async function v(P,I,d,f,E,y){h(y);const m=await P.open(I,{create:!1});try{h(y);let u=0,$=0,N=E&&typeof E.length=="number"?E.length:void 0,p=L.$be.alloc(Math.min(E.bufferSize,typeof N=="number"?N:E.bufferSize)),S=E&&typeof E.position=="number"?E.position:0,s=0;do $=await P.read(m,S,p.buffer,s,p.byteLength-s),S+=$,s+=$,u+=$,typeof N=="number"&&(N-=$),s===p.byteLength&&(await d.write(f(p)),p=L.$be.alloc(Math.min(E.bufferSize,typeof N=="number"?N:E.bufferSize)),s=0);while($>0&&(typeof N!="number"||N>0)&&h(y)&&c(u,E));if(s>0){let o=s;typeof N=="number"&&(o=Math.min(s,N)),d.write(f(p.slice(0,o)))}}catch(u){throw(0,j.$nk)(u)}finally{await P.close(m)}}function h(P){if(P.isCancellationRequested)throw(0,D.$5)();return!0}function c(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,j.$mk)((0,R.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[117],ne([0,1,4,166,2,13,167]),function(J,e,L,D,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class v extends R.$Rc{constructor(){super(...arguments),this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const P=this.j(c),I=P.filter(f=>{const E=this.c.get(f.path);return E?!(0,D.$Bj)(E.request.excludes,f.excludes)||!(0,D.$Bj)(E.request.includes,f.includes):!0}),d=Array.from(this.c.values()).filter(({request:f})=>!P.find(E=>E.path===f.path&&(0,D.$Bj)(E.excludes,f.excludes)&&(0,D.$Bj)(E.includes,f.includes))).map(({request:f})=>f.path);I.length&&this.m(`Request to start watching: ${I.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const f of d)this.h(f);for(const f of I)this.g(f)}g(c){const P=new A.$0p(c,d=>this.a.fire(d),d=>this.b.fire(d),this.f),I={request:c,instance:P};this.c.set(c.path,I)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const P=this.c.get(c);P&&(this.c.delete(c),P.instance.dispose())}j(c){const P=new Map;for(const I of c){const d=j.$l?I.path:I.path.toLowerCase();let f=P.get(I.correlationId);f||(f=new Map,P.set(I.correlationId,f)),f.set(d,I)}return Array.from(P.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,P]of this.c)P.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,P){return P?`[File Watcher (node.js)] ${c} (path: ${P.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$_p=v}),define(te[118],ne([0,1,62,117]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class R extends L.$Rp{constructor(A,v,h){super(A,v,h),this.s()}r(A){return A.add(new D.$_p)}}e.$aq=R}),define(te[119],ne([0,1,15,57,85,62]),function(J,e,L,D,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;class A extends j.$Sp{constructor(h,c,P){super(h,c,P),this.s()}r(h){const c=h.add(new R.$4p(L.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:P,signal:I})=>this.t(`terminated by itself with code ${P}, signal: ${I}`))),D.ProxyChannel.toService((0,D.$xh)(c.getChannel("watcher")))}}e.$5p=A}),define(te[63],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class L{constructor(...R){this.a=new Map;for(const[j,A]of R)this.set(j,A)}set(R,j){const A=this.a.get(R);return this.a.set(R,j),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$Oh=L}),define(te[120],ne([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,D,R,j,A,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;const P=!1;class I extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class d{constructor(m=new h.$Oh,u=!1,$,N=P){this.f=m,this.g=u,this.h=$,this.i=N,this.o=new Set,this.f.set(v.$Ph,this),this._globalGraph=N?$?._globalGraph??new A.$dq(p=>p):void 0}createChild(m){return new d(m,this.g,this,this.i)}invokeFunction(m,...u){const $=E.traceInvocation(this.i,m);let N=!1;try{return m({get:S=>{if(N)throw(0,D.$7)("service accessor is only valid during the invocation of its target method");const s=this.m(S,$);if(!s)throw new Error(`[invokeFunction] unknown service '${S}'`);return s}},...u)}finally{N=!0,$.stop()}}createInstance(m,...u){let $,N;return m instanceof j.$Nh?($=E.traceCreation(this.i,m.ctor),N=this.j(m.ctor,m.staticArguments.concat(u),$)):($=E.traceCreation(this.i,m),N=this.j(m,u,$)),$.stop(),N}j(m,u=[],$){const N=v._util.getServiceDependencies(m).sort((s,o)=>s.index-o.index),p=[];for(const s of N){const o=this.m(s.id,$);o||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${s.id}.`,!1),p.push(o)}const S=N.length>0?N[0].index:u.length;if(u.length!==S){console.trace(`[createInstance] First service dependency of ${m.name} at position ${S+1} conflicts with ${u.length} static arguments`);const s=S-u.length;s>0?u=u.concat(new Array(s)):u=u.slice(0,S)}return Reflect.construct(m,u.concat(p))}k(m,u){if(this.f.get(m)instanceof j.$Nh)this.f.set(m,u);else if(this.h)this.h.k(m,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const u=this.f.get(m);return!u&&this.h?this.h.l(m):u}m(m,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const $=this.l(m);return $ instanceof j.$Nh?this.q(m,$,u.branch(m,!0)):(u.branch(m,!1),$)}q(m,u,$){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,u,$)}finally{this.o.delete(m)}}r(m,u,$){const N=new A.$dq(s=>s.id.toString());let p=0;const S=[{id:m,desc:u,_trace:$}];for(;S.length;){const s=S.pop();if(N.lookupOrInsertNode(s),p++>1e3)throw new I(N);for(const o of v._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${m} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof j.$Nh){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};N.insertEdge(s,i),S.push(i)}}}for(;;){const s=N.roots();if(s.length===0){if(!N.isEmpty())throw new I(N);break}for(const{data:o}of s){if(this.l(o.id)instanceof j.$Nh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}N.removeNode(o)}}return this.l(m)}s(m,u,$=[],N,p){if(this.f.get(m)instanceof j.$Nh)return this.t(m,u,$,N,p);if(this.h)return this.h.s(m,u,$,N,p);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(m,u,$=[],N,p){if(N){const S=new d(void 0,this.g,this,this.i);S.c=String(m);const s=new Map,o=new L.$_g(()=>{const t=S.j(u,$,p);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const l of n)r.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new c.$1c,s.set(i,l)),(b,w,O)=>{const B=l.push([b,w,O]);return(0,R.$Pc)(B)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,$,p)}u(m,u){if(u&&console.warn(m),this.g)throw new Error(m)}}e.$eq=d;var f;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(f||(f={}));class E{static{this.all=new Set}static{this.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,u){return m?new E(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(m,u){return m?new E(1,u.name):E.c}static{this.f=0}constructor(m,u){this.type=m,this.name=u,this.g=Date.now(),this.h=[]}branch(m,u){const $=new E(3,m.toString());return this.h.push([m,u,$]),$}stop(){const m=Date.now()-this.g;E.f+=m;let u=!1;function $(p,S){const s=[],o=new Array(p+1).join("	");for(const[t,i,n]of S.h)if(i&&n){u=!0,s.push(`${o}CREATES -> ${t}`);const r=$(p+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const N=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(m>2||u)&&E.all.add(N.join(`
`))}}e.$fq=E});var ie=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(te[64],ne([0,1,20,2,13,102,21,10]),function(J,e,L,D,R,j,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=void 0;function h(P){return P.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.$Sq=h,e.$Tq=(0,v.$Qh)("languagePackService");let c=class extends D.$Rc{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new L.$Xd;setTimeout(()=>I.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const E=d.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(m=>m.startsWith("lp-"))).map(y=>{const m=y.properties.localizedLanguages?.[0],u=h(y);return{...this.f(u,m,y),extensionId:y.identifier.id,galleryExtension:y}});return E.push(this.f("en","English")),E}f(I,d,f){const E=d??I;let y;if(E!==I&&(y=`(${I})`),I.toLowerCase()===R.$w.toLowerCase()&&(y??="",y+=(0,j.localize)(0,null)),f?.installCount){y??="";const m=f.installCount;let u;m>1e6?u=`${Math.floor(m/1e5)/10}M`:m>1e3?u=`${Math.floor(m/1e3)}K`:u=String(m),y+=` $(cloud-download) ${u}`}return{id:I,label:E,description:y}}};e.$Uq=c,e.$Uq=c=pe([ie(0,A.$$n)],c)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,L,D,R,j,A,v,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,d.$Qh)("logService"),e.$_i=(0,d.$Qh)("loggerService");function f(){return new Date().toISOString()}function E(b){return(0,c.$Cf)(b)}e.$aj=E;var y;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$bj=y.Info;function m(b,w,O){switch(w){case y.Trace:b.trace(O);break;case y.Debug:b.debug(O);break;case y.Info:b.info(O);break;case y.Warning:b.warn(O);break;case y.Error:b.error(O);break;case y.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=m;function u(b,w=!1){let O="";for(let B=0;B<b.length;B++){let _=b[B];if(_ instanceof Error&&(_=(0,L.$Bi)(_,w)),typeof _=="object")try{_=JSON.stringify(_)}catch{}O+=(B>0?" ":"")+_}return O}class $ extends j.$Rc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new D.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==y.Off&&this.b<=w}}e.$dj=$;class N extends ${constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...O){this.f(y.Trace)&&this.g(y.Trace,u([w,...O],!0))}debug(w,...O){this.f(y.Debug)&&this.g(y.Debug,u([w,...O]))}info(w,...O){this.f(y.Info)&&this.g(y.Info,u([w,...O]))}warn(w,...O){this.f(y.Warning)&&this.g(y.Warning,u([w,...O]))}error(w,...O){if(this.f(y.Error))if(w instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=w.stack,this.g(y.Error,u(B))}else this.g(y.Error,u([w,...O]))}flush(){}}e.$ej=N;class p extends ${constructor(w=e.$bj){super(),this.setLevel(w),this.g=!v.$j}trace(w,...O){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...O):console.log(`[main ${f()}]`,w,...O))}debug(w,...O){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...O):console.log(`[main ${f()}]`,w,...O))}info(w,...O){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...O):console.log(`[main ${f()}]`,w,...O))}warn(w,...O){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...O):console.warn(`[main ${f()}]`,w,...O))}error(w,...O){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...O):console.error(`[main ${f()}]`,w,...O))}dispose(){}flush(){}}e.$fj=p;class S extends ${constructor(w=e.$bj,O=!0){super(),this.g=O,this.setLevel(w)}trace(w,...O){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...O):console.log(w,...O))}debug(w,...O){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...O):console.log(w,...O))}info(w,...O){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...O):console.log(w,...O))}warn(w,...O){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...O):console.log(w,...O))}error(w,...O){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...O):console.error(w,...O))}dispose(){}flush(){}}e.$gj=S;class s extends ${constructor(w,O=e.$bj){super(),this.g=w,this.setLevel(O)}trace(w,...O){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(w),...O])}debug(w,...O){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(w),...O])}info(w,...O){this.f(y.Info)&&this.g.log(y.Info,[this.h(w),...O])}warn(w,...O){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(w),...O])}error(w,...O){this.f(y.Error)&&this.g.log(y.Error,[this.h(w),...O])}h(w){return typeof w=="string"?w:(0,L.$Bi)(w,this.f(y.Trace))}dispose(){}flush(){}}e.$hj=s;class o extends ${constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const O of this.g)O.setLevel(w);super.setLevel(w)}trace(w,...O){for(const B of this.g)B.trace(w,...O)}debug(w,...O){for(const B of this.g)B.debug(w,...O)}info(w,...O){for(const B of this.g)B.info(w,...O)}warn(w,...O){for(const B of this.g)B.warn(w,...O)}error(w,...O){for(const B of this.g)B.error(w,...O)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$ij=o;class t extends j.$Rc{constructor(w,O,B){if(super(),this.h=w,this.j=O,this.b=new A.$zc,this.c=this.B(new D.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeVisibility=this.g.event,B)for(const _ of B)this.b.set(_.resource,{logger:void 0,info:_})}m(w){return(0,c.$yf)(w)?[...this.b.values()].find(O=>O.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,O){const B=this.n(w),_=(0,c.$yf)(w)?w:O?.id??(0,R.$Ei)(B.toString()).toString(16);let ee=this.b.get(B)?.logger;const oe=O?.logLevel==="always"?y.Trace:O?.logLevel;ee||(ee=this.s(B,oe??this.getLogLevel(B)??this.h,{...O,id:_}));const se={logger:ee,info:{resource:B,id:_,logLevel:oe,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(se.info),this.b.set(B,se),ee}n(w){return(0,c.$yf)(w)?(0,h.$vg)(this.j,`${w}.log`):w}setLogLevel(w,O){if(P.URI.isUri(w)){const B=w,_=O,ee=this.b.get(B);ee&&_!==ee.info.logLevel&&(ee.info.logLevel=_===this.h?void 0:_,ee.logger?.setLevel(_),this.b.set(ee.info.resource,ee),this.f.fire([B,_]))}else{this.h=w;for(const[B,_]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,O){const B=this.m(w);B&&O!==!B.info.hidden&&(B.info.hidden=!O,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,O]))}getLogLevel(w){let O;return w&&(O=this.b.get(w)?.info.logLevel),O??this.h}registerLogger(w){const O=this.b.get(w.resource);O?O.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const O=this.b.get(w);O&&(O.logger&&O.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=t;class i{constructor(){this.onDidChangeLogLevel=new D.$Nd().event}setLevel(w){}getLevel(){return y.Info}trace(w,...O){}debug(w,...O){}info(w,...O){}warn(w,...O){}error(w,...O){}critical(w,...O){}dispose(){}flush(){}}e.$kj=i;class n extends i{}e.$lj=n;function r(b){if(b.verbose)return y.Trace;if(typeof b.logLevel=="string"){const w=k(b.logLevel.toLowerCase());if(w!==void 0)return w}return e.$bj}e.$mj=r;function l(b){switch(b){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$nj=l;function k(b){switch(b){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$oj=k,e.$pj=new I.$8i("logLevel",l(y.Info))}),define(te[121],ne([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,D,R,j,A,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class P extends A.$Rc{constructor(d,f){super(),this.a=d,this.b=f,this.c=this.B(new j.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$Rg(0)),this.w=[],this.y=this.B(new D.$Rg(0))}watch(d,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(d,f):this.z(d,f)}n(d,f){const E={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},y=(0,L.$Tb)(this.j,E);return this.r(),(0,A.$Pc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,R.$Z)(d))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$Tp)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const f of this.j)(0,h.$Pp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const f of this.j)(0,h.$Pp)(f)&&d.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,f){const E={path:this.H(d),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},y=(0,L.$Tb)(this.w,E);return this.C(),(0,A.$Pc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,R.$Z)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$Tp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,v.$gc)(d.fsPath)}}e.$Xp=P}),define(te[122],ne([0,1,19,8,14,20,4,41,65,2,47,15,123,17,45,99,12,61,6,9]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u,$,N){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;let S=class extends c.$Rc{static{p=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Nd),this.Y=this.B(new A.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$4g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const i=new c.$Qc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new m.$sk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Mc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await D.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$zg)(o))throw new m.$uk((0,y.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new N.$ab;throw i.message=(0,y.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,m.$fk)(t)||(0,m.$ck)(t)||(0,m.$gk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,m.$fk)(t)||(0,m.$ck)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,m.$pk)(i)===m.FileSystemProviderErrorCode.FileNotFound?new m.$uk((0,y.localize)(2,null,this.sb(o)),1):(0,m.$nk)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,k=t?.resolveMetadata,b=await i.stat(o);let w;return this.t(i,o,b,void 0,!!k,(O,B)=>(w||(w=P.$Wh.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(O.resource)||w.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&l?B===1:!1))}async t(o,t,i,n,r,l){const{providerExtUri:k}=this.R(o),b={resource:t,name:k.basename(t),isFile:(i.type&m.FileType.File)!==0,isDirectory:(i.type&m.FileType.Directory)!==0,isSymbolicLink:(i.type&m.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&m.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Fk)({mtime:i.mtime,size:i.size}),children:void 0};if(b.isDirectory&&l(b,n)){try{const w=await o.readdir(t),O=await D.Promises.settled(w.map(async([B,_])=>{try{const ee=k.joinPath(t,B),oe=r?await o.stat(ee):{type:_};return await this.t(o,ee,oe,w.length,r,l)}catch(ee){return this.b.trace(ee),null}}));b.children=(0,L.$Gb)(O)}catch(w){this.b.trace(w),b.children=[]}return b}return b}async resolveAll(o){return D.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new m.$uk((0,y.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=R.$be.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new m.$rk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let l=i;if((0,m.$ik)(n)&&!l?.atomic){const k=n.enforceAtomicWriteFile?.(o);k&&(l={...i,atomic:k})}try{await this.w(n,o,l)||await this.U(n,r.dirname(o));let b;if((0,m.$ck)(n)&&!(t instanceof R.$be))if((0,E.$Zd)(t)){const w=await(0,E.$7d)(t,3);w.ended?b=R.$be.concat(w.buffer):b=w}else b=(0,E.$4d)(t,w=>R.$be.concat(w),3);else b=t;!(0,m.$fk)(n)||(0,m.$ck)(n)&&b instanceof R.$be||(0,m.$ck)(n)&&(0,m.$ik)(n)&&l?.atomic?await this.hb(n,o,l,b):await this.db(n,o,l,b instanceof R.$be?(0,R.$me)(b):b),this.r.fire(new m.$rk(o,4))}catch(k){throw new m.$uk((0,y.localize)(4,null,this.sb(o),(0,m.$nk)(k).toString()),(0,m.$qk)(k),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(t)));if(n)throw new Error((0,y.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&m.FileType.Directory)throw new m.$uk((0,y.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==m.$Ek&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,m.$Fk)({mtime:i.mtime,size:l.size}))throw new m.$uk((0,y.localize)(10,null),3,i);return l}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,l)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const k=await this.C(o,t,i,n);r(k)}catch(k){l(k)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,R.$ne)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new j.$Xd(n);let l=i;(0,m.$hk)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const k=this.J(t,l).then(w=>w,w=>{throw r.dispose(!0),w});let b;try{return typeof l?.etag=="string"&&l.etag!==m.$Ek&&await k,l?.atomic&&(0,m.$hk)(o)||!((0,m.$fk)(o)||(0,m.$gk)(o))||(0,m.$ck)(o)&&l?.preferUnbuffered?b=this.I(o,t,l):(0,m.$gk)(o)?b=this.G(o,t,r.token,l):b=this.H(o,t,r.token,l),b.on("end",()=>r.dispose()),b.on("error",()=>r.dispose()),{...await k,value:b}}catch(w){throw b&&await(0,E.$5d)(b),this.F(w,t,l)}}F(o,t,i){const n=(0,y.localize)(11,null,this.sb(t),(0,m.$nk)(o).toString());return o instanceof m.$wk?new m.$wk(n,o.stat,i):o instanceof m.$vk?new m.$vk(n,o.fileOperationResult,o.size,o.options):new m.$uk(n,(0,m.$qk)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,E.$$d)(r,{data:l=>l instanceof R.$be?l:R.$be.wrap(l),error:l=>this.F(l,t,n)},l=>R.$be.concat(l))}H(o,t,i,n=Object.create(null)){const r=(0,R.$re)();return(0,u.$Np)(o,t,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),r}I(o,t,i){const n=(0,E.$2d)(r=>R.$be.concat(r));return(async()=>{try{let r;i?.atomic&&(0,m.$hk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(R.$be.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new m.$uk((0,y.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==m.$Ek&&t.etag===i.etag)throw new m.$wk((0,y.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new m.$vk((0,y.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"move",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$rk(o,l==="move"?2:3,k)),k}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"copy",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$rk(o,l==="copy"?3:2,k)),k}async N(o,t,i,n,r,l){if(t.toString()===n.toString())return r;const{exists:k,isSameResourceWithDifferentPathCase:b}=await this.Q(o,t,i,n,r,l);if(k&&!b&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,m.$dk)(o))await o.copy(t,n,{overwrite:l});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:l}),r):(await this.N(o,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,m.$fk)(o)&&(0,m.$fk)(i))return this.jb(o,t,i,n);if((0,m.$fk)(o)&&(0,m.$ck)(i))return this.pb(o,t,i,n);if((0,m.$ck)(o)&&(0,m.$fk)(i))return this.nb(o,t,i,n);if((0,m.$ck)(o)&&(0,m.$ck)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async r=>{const l=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,l):this.O(o,r.resource,i,l)}))}async Q(o,t,i,n,r,l){let k=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:O}=this.R(o);if(O||(k=w.isEqual(t,n)),k&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(t),this.sb(n)));if(!k&&w.isEqualOrParent(n,t))throw new Error((0,y.localize)(16,null,this.sb(t),this.sb(n)))}const b=await this.exists(n);if(b&&!k){if(!l)throw new m.$uk((0,y.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,y.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:b,isSameResourceWithDifferentPathCase:k}}R(o){const t=this.S(o);return{providerExtUri:t?f.$lg:f.$ng,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$rk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&m.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(t)));break}catch(r){if((0,m.$pk)(r)!==m.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(l){if((0,m.$pk)(l)!==m.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,y.localize)(22,null,this.sb(o)));let l;try{l=await i.stat(o)}catch{}if(l)this.rb(o,l);else throw new m.$uk((0,y.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const b=await this.resolve(o);if(b.isDirectory&&Array.isArray(b.children)&&b.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,m.$jk)(i)&&!n?.atomic){const b=i.enforceAtomicDelete?.(o);b&&(n={...t,atomic:b})}const r=!!n?.useTrash,l=!!n?.recursive,k=n?.atomic??!1;await i.delete(o,{recursive:l,useTrash:r,atomic:k}),this.r.fire(new m.$rk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,m.$ek)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,m.$dk)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:p.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Qc;let n=!1,r=()=>{n=!0};i.add((0,c.$Pc)(()=>r())),(async()=>{try{const k=await this.bb(o,t);n?(0,c.$Mc)(k):r=()=>(0,c.$Mc)(k)}catch(k){this.b.error(k)}})();const l=t.correlationId;if(typeof l=="number"){const k=i.add(new A.$Nd);return i.add(this.X.event(w=>{w.correlates(l)&&k.fire(w)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,v.$Ei)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Pc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Mc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Mc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,E.$Zd)(n)||(0,E.$1d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(l){throw(0,m.$nk)(l)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,E.$1d)(i)){if(i.buffer.length>0){const l=R.$be.concat(i.buffer);await this.gb(o,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,k)=>{(0,E.$6d)(r,{onData:async b=>{r.pause();try{await this.gb(o,t,b,b.byteLength,n,0)}catch(w){return k(w)}n+=b.byteLength,setTimeout(()=>r.resume())},onError:b=>k(b),onEnd:()=>l()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,l){let k=0;for(;k<n;){const b=await o.write(t,r+k,i.buffer,l+k,n-k);k+=b}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof R.$be?r=n:(0,E.$Zd)(n)?r=await(0,R.$ne)(n):(0,E.$1d)(n)?r=await(0,R.$oe)(n):r=(0,R.$le)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,l;try{r=await o.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const k=R.$be.alloc(this.a);let b=0,w=0,O=0;do O=await o.read(r,b,k.buffer,w,k.byteLength-w),await this.gb(i,l,k,O,b,w),b+=O,w+=O,w===k.byteLength&&(w=0);while(O>0)}catch(k){throw(0,m.$nk)(k)}finally{await D.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(i,r,R.$be.wrap(l),l.byteLength,0,0)}catch(l){throw(0,m.$nk)(l)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,R.$ne)(this.H(o,t,j.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new m.$uk((0,y.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&m.FilePermission.Readonly)throw new m.$uk((0,y.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===I.Schemas.file?o.fsPath:o.toString(!0)}};e.$Op=S,e.$Op=S=p=pe([ie(0,$.$$i)],S)}),define(te[124],ne([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u,$,N,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,N.$Bi)(o)}`)}})();class s extends $.$Xp{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=v.Event.None,this.N=new j.$zc(n=>d.$mg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await E.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:m.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await E.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,d.$vg)(t,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=m.FileType.Unknown:t.isFile()?n=m.FileType.File:t.isDirectory()?n=m.FileType.Directory:n=m.FileType.Unknown,i&&(n|=m.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new R.$Sg;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await E.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,f.$2d)(l=>A.$be.concat(l.map(k=>A.$be.wrap(k))).buffer);return(0,u.$Np)(this,t,r,l=>l.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$vg)((0,d.$ug)(t),`${(0,d.$sg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await E.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const l=new c.$Qc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{l.dispose()}}async S(t,i,n,r){let l;try{const k=this.H(t);if(!n.create||!n.overwrite){if(await E.Promises.exists(k)){if(!n.overwrite)throw(0,m.$mk)((0,y.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,m.$mk)((0,y.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(l,0,i,0,i.byteLength)}catch(k){throw await this.gb(t,k)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let l;(0,m.$ak)(i)&&!n&&(l=await this.O(t));let k;try{if((0,m.$ak)(i)&&i.unlock)try{const{stat:w}=await E.SymlinkSupport.stat(r);w.mode&128||await E.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let b;if((0,m.$ak)(i)){if(I.$j)try{await E.Promises.truncate(r,0),b="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}b||(b="w")}else b="r";k=await E.Promises.open(r,b)}catch(b){throw l?.dispose(),(0,m.$ak)(i)?await this.gb(t,b):this.fb(b)}if(this.U.set(k,0),(0,m.$ak)(i)&&this.X.set(k,t),l){const b=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.W.set(k,l),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),b.dispose())}return k}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await E.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await E.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,l){const k=this.Z(t,i);let b=null;try{b=(await E.Promises.read(t,n,r,l,k)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,k,b)}return b}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,l){return(0,R.$ah)(()=>this.ab(t,i,n,r,l),100,3)}async ab(t,i,n,r,l){const k=this.Z(t,i);let b=null;try{b=(await E.Promises.write(t,n,r,l,k)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,k,b)}return b}async mkdir(t){try{await E.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.$ic)((0,P.$lc)(n),`${(0,P.$mc)(n)}${i.atomic.postfix}`)),await E.Promises.rm(n,E.RimRafMode.MOVE,r)}else try{await E.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:k,symbolicLink:b}=await E.SymlinkSupport.stat(n);l=k.isDirectory()&&!b}catch{}if(l)await E.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"move",n.overwrite),await E.Promises.rename(r,l)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(2,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(l)),k.toString()))),this.fb(k)}}async copy(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"copy",n.overwrite),await E.Promises.copy(r,l,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,y.localize)(3,null,(0,P.$mc)(r),(0,P.$mc)((0,P.$lc)(l)),k.toString()))),this.fb(k)}}async bb(t,i,n,r){const l=this.H(t),k=this.H(i);let b=!1;if(!!(this.capabilities&1024)||(b=(0,h.$Wf)(l,k,!0)),b){if(n==="copy")throw(0,m.$mk)((0,y.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const O=await this.L(t);if(!O)throw(0,m.$mk)((0,y.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const B=await this.L(i);if(B){if(!r)throw(0,m.$mk)((0,y.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);O.type&m.FileType.File&&B.type&m.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),l=this.H(i),k=!!(this.capabilities&1024);if((0,h.$Wf)(r,l,!k))return;const b=new c.$Qc;try{b.add(await this.O(t)),b.add(await this.O(i)),n&&await E.Promises.mkdir((0,P.$lc)(l),{recursive:!0}),await E.Promises.copyFile(r,l)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{b.dispose()}}t(t,i,n){return new p.$5p(r=>t(r),r=>i(r),n)}F(t,i,n){return new S.$aq(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof m.$lk)return t;let i=t,n;switch(t.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=m.FileSystemProviderErrorCode.Unknown;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.$mk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await E.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,m.$mk)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$bq=s}),define(te[126],ne([0,1,2,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=void 0;class R extends L.$Rc{constructor(A,v=[]){super(),this.a=new D.$ij([A,...v]),this.B(A.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...v){this.a.trace(A,...v)}debug(A,...v){this.a.debug(A,...v)}info(A,...v){this.a.info(A,...v)}warn(A,...v){this.a.warn(A,...v)}error(A,...v){this.a.error(A,...v)}flush(){this.a.flush()}}e.$RN=R}),define(te[127],ne([0,1,12,6]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function j(c,P,I,d,f){try{const E=await new Promise((m,u)=>{J(["@vscode/spdlog"],m,u)});E.setFlushOn(R.Trace);const y=await E.createAsyncRotatingLogger(c,P,I,d);return f?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(E){console.error(E)}return null}function A(c,P,I){switch(P){case D.LogLevel.Trace:c.trace(I);break;case D.LogLevel.Debug:c.debug(I);break;case D.LogLevel.Info:c.info(I);break;case D.LogLevel.Warning:c.warn(I);break;case D.LogLevel.Error:c.error(I);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function v(c,P){switch(P){case D.LogLevel.Trace:c.setLevel(R.Trace);break;case D.LogLevel.Debug:c.setLevel(R.Debug);break;case D.LogLevel.Info:c.setLevel(R.Info);break;case D.LogLevel.Warning:c.setLevel(R.Warning);break;case D.LogLevel.Error:c.setLevel(R.Error);break;case D.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class h extends D.$ej{constructor(P,I,d,f,E){super(),this.m=[],this.setLevel(E),this.n=this.s(P,I,d,f),this.B(this.onDidChangeLogLevel(y=>{this.r&&v(this.r,y)}))}async s(P,I,d,f){const E=d?6:1,y=30/E*L.$Hk.MB,m=await j(P,I,y,E,f);if(m){this.r=m,v(this.r,this.getLevel());for(const{level:u,message:$}of this.m)A(this.r,u,$);this.m=[]}}g(P,I){this.r?A(this.r,P,I):this.getLevel()<=P&&this.m.push({level:P,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$GN=h}),define(te[128],ne([0,1,28,6,127]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=void 0;class j extends D.$jj{s(v,h,c){return new R.$GN((0,L.$eg)(),v.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$HN=j}),define(te[38],ne([0,1,4,65,2,10]),function(J,e,L,D,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0,e.$jn=(0,j.$Qh)("policy");class A extends R.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const P=Object.keys(this.f).length;return this.f={...c,...this.f},P!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(I,[d,f])=>({...I,[d]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[P,I])=>({...c,[P]:{definition:I,value:this.g.get(P)}}),{})}}e.$kn=A;class v{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$ln=v}),define(te[129],ne([0,1,8,4,65,3,12,6,38]),function(J,e,L,D,R,j,A,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$48b=void 0;function c(I,d){const f=[];for(const E of new Set(R.Iterable.concat(I.keys(),d.keys())))I.get(E)!==d.get(E)&&f.push(E);return f}let P=class extends h.$kn{constructor(d,f,E){super(),this.m=d,this.n=f,this.s=E,this.c=this.B(new L.$Rg(500));const y=D.Event.filter(f.onDidFilesChange,m=>m.affects(d));this.B(f.watch(d)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const f=await this.n.readFile(this.m),E=JSON.parse(f.value.toString());if(!(0,j.$Af)(E))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(E))this.f[y]&&d.set(y,E[y])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return d}async w(){const d=await this.u(),f=c(this.g,d);this.g=d,f.length>0&&this.h.fire(f)}};e.$48b=P,e.$48b=P=pe([ie(1,A.$_j),ie(2,v.$$i)],P)}),define(te[130],ne([0,1,38,8,171,2,6]),function(J,e,L,D,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=void 0;let v=class extends L.$kn{constructor(c,P){super(),this.m=c,this.n=P,this.a=new D.$Ng,this.b=this.B(new j.$Sc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((P,I)=>{try{this.b.value=(0,R.createWatcher)(this.n,c,d=>{this.t(d),P()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),I(d)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const P in c){const I=c[P];I===void 0?this.g.delete(P):this.g.set(P,I)}this.h.fire(Object.keys(c))}};e.$38b=v,e.$38b=v=pe([ie(0,A.$$i)],v)}),define(te[32],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,L.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0;class R{constructor(){this.a=new Map}add(A,v){L.ok(D.$yf(A)),L.ok(D.$Af(v)),L.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,v)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$hn=new R}),define(te[131],ne([0,1,4,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=void 0,e.$in={JSONContribution:"base.contributions.json"};function R(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class j{constructor(){this.b=new L.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[R(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const A=new j;D.$hn.add(e.$in.JSONContribution,A)}),define(te[43],ne([0,1,19,4,3,88,25,131,36]),function(J,e,L,D,R,j,A,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.ConfigurationScope=e.$mn=e.EditPresentationTypes=void 0;var c;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$mn={Configuration:"base.contributions.configuration"};var P;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn="vscode://schemas/settings/resourceLanguage",e.$un="vscode://schemas/settings/configurationDefaults";const I=h.$hn.as(v.$in.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$Nd,this.onDidSchemaChange=this.i.event,this.j=new D.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$tn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),I.registerSchema(e.$tn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),I.registerSchema(e.$tn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),I.registerSchema(e.$tn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$wn.test(r)){const l=this.a.get(r),k=l?.valuesSources??new Map;if(n)for(const B of Object.keys(i[r]))k.set(B,n);const b={...l?.value||{},...i[r]};this.a.set(r,{source:n,value:b,valuesSources:k});const w=(0,A.$ui)(r),O={type:"object",default:b,description:j.localize(1,null,w),$ref:e.$tn,defaultDefaultValue:b,source:R.$yf(n)?void 0:n,defaultValueSource:n};t.push(...y(r)),this.d[r]=O,this.b.properties[r]=O}else{this.a.set(r,{value:i[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),l=R.$yf(i)?i:i?.id,k=R.$yf(r?.source)?r?.source:r?.source?.id;if(l===k)if(o.add(n),this.a.delete(n),e.$wn.test(n))delete this.d[n],delete this.b.properties[n];else{const b=this.d[n];b&&(this.w(n,b),this.r(n,b))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=R.$Hf(s.scope)?n:s.scope;const l=s.properties;if(l)for(const b in l){const w=l[b];if(o&&N(b,w)){delete l[b];continue}if(w.source=t,w.defaultDefaultValue=l[b].default,this.w(b,w),e.$wn.test(b)?w.scope=void 0:(w.scope=R.$Hf(w.scope)?n:w.scope,w.restricted=R.$Hf(w.restricted)?!!i?.includes(b):w.restricted),l[b].hasOwnProperty("included")&&!l[b].included){this.f[b]=l[b],delete l[b];continue}else this.d[b]=l[b],l[b].policy?.name&&this.e.set(l[b].policy.name,b);!l[b].deprecationMessage&&l[b].markdownDeprecationMessage&&(l[b].deprecationMessage=l[b].markdownDeprecationMessage),r.add(b)}const k=s.allOf;if(k)for(const b of k)this.p(b,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$nn.properties[s]=o,o.scope){case 1:e.$on.properties[s]=o;break;case 2:e.$pn.properties[s]=o;break;case 6:e.$qn.properties[s]=o;break;case 3:e.$rn.properties[s]=o;break;case 4:e.$sn.properties[s]=o;break;case 5:e.$sn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$nn.properties[s],o.scope){case 1:delete e.$on.properties[s];break;case 2:delete e.$pn.properties[s];break;case 6:delete e.$qn.properties[s];break;case 3:delete e.$rn.properties[s];break;case 4:case 5:delete e.$sn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$tn};this.w(o,t),e.$nn.properties[o]=t,e.$on.properties[o]=t,e.$pn.properties[o]=t,e.$qn.properties[o]=t,e.$rn.properties[o]=t,e.$sn.properties[o]=t}}v(){const s={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$tn};e.$nn.patternProperties[e.$vn]=s,e.$on.patternProperties[e.$vn]=s,e.$pn.patternProperties[e.$vn]=s,e.$qn.patternProperties[e.$vn]=s,e.$rn.patternProperties[e.$vn]=s,e.$sn.patternProperties[e.$vn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;R.$Ff(i)&&(i=o.defaultDefaultValue,n=void 0),R.$Ff(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",E=new RegExp(f,"g");e.$vn=`^(${f})+$`,e.$wn=new RegExp(e.$vn);function y(S){const s=[];if(e.$wn.test(S)){let o=E.exec(S);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=E.exec(S)}}return(0,L.$Lb)(s)}e.$xn=y;function m(S){return S.reduce((s,o)=>`${s}[${o}]`,"")}e.$yn=m;function u(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$zn=u;const $=new d;h.$hn.add(e.$mn.Configuration,$);function N(S,s){return S.trim()?e.$wn.test(S)?j.localize(7,null,S):$.getConfigurationProperties()[S]!==void 0?j.localize(8,null,S):s.policy?.name&&$.getPolicyConfigurations().get(s.policy?.name)!==void 0?j.localize(9,null,S,s.policy?.name,$.getPolicyConfigurations().get(s.policy?.name)):null:j.localize(6,null)}e.$An=N;function p(){const S=[],s=$.getConfigurationProperties();for(const o of Object.keys(s))S.push([o,s[o].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.$Bn=p}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,L,D,R,j,A,v,h,c,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=void 0;function f(o){return Object.isFrozen(o)?o:v.$9m(o)}class E{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof E)return i;const n=new y("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,P.$si)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,P.$si)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Lb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Lb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=v.$8m(this.contents),n=v.$8m(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const k of t)if(l.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(i,k.contents);for(const b of k.overrides){const[w]=n.filter(O=>L.$tb(O.identifiers,b.identifiers));w?(this.h(w.contents,b.contents),w.keys.push(...b.keys),w.keys=L.$Lb(w.keys)):n.push(v.$8m(b))}for(const b of k.keys)r.indexOf(b)===-1&&r.push(b)}return new E(i,r,n,l.every(k=>k instanceof E)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Lb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const k=i[r];k&&(typeof l=="object"&&typeof k=="object"?(l=v.$8m(l),this.h(l,k)):l=k),n[r]=l}return new E(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&h.$Af(t[n])&&h.$Af(i[n])){this.h(t[n],i[n]);continue}t[n]=v.$8m(i[n])}}i(t){let i=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=v.$8m(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.$ri)(this.contents,t),I.$wn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$tb(n.identifiers,(0,I.$xn)(t))),1))}j(t,i,n){(0,P.$qi)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),I.$wn.test(t)&&this.overrides.push({identifiers:(0,I.$xn)(t),keys:Object.keys(this.contents[t]),contents:(0,P.$pi)(this.contents[t],r=>console.error(r))})}}e.$Cn=E;class y{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!h.$Hf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:l,restricted:k,hasExcludedProperties:b}=this.h(t,i);this.b=new E(n,r,l,b?[t]:void 0),this.c=k||[]}g(t){let i={},n=null,r=[];const l=[],k=[];function b(O){Array.isArray(r)?r.push(O):n!==null&&(r[n]=O)}const w={onObjectBegin:()=>{const O={};b(O),l.push(r),r=O,n=null},onObjectProperty:O=>{n=O},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const O=[];b(O),l.push(r),r=O,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:b,onError:(O,B,_)=>{k.push({error:O,offset:B,length:_})}};if(t)try{R.$5m(t,w),i=r[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(t,i){const n=d.$hn.as(I.$mn.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const l=(0,P.$pi)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(t),b=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:l,keys:k,overrides:b,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const k={},b=[];for(const w in t)if(I.$wn.test(w)&&n){const O=this.i(t[w],i,!1,r);k[w]=O.raw,l=l||O.hasExcludedProperties,b.push(...O.restricted)}else{const O=i[w],B=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&b.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(B===void 0||r.scopes===void 0||r.scopes.includes(B))&&!(r.skipRestricted&&O?.restricted))?k[w]=t[w]:l=!0}return{raw:k,restricted:b,hasExcludedProperties:l}}j(t,i){const n=[];for(const r of Object.keys(t))if(I.$wn.test(r)){const l={};for(const k in t[r])l[k]=t[r][k];n.push({identifiers:(0,I.$xn)(r),keys:Object.keys(l),contents:(0,P.$pi)(l,i)})}return n}}e.$Dn=y;class m extends j.$Rc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new D.$Nd),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new E}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$En=m;class u{constructor(t,i,n,r,l,k,b,w,O,B,_,ee,oe){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=k,this.g=b,this.h=w,this.i=O,this.j=B,this.k=_,this.l=ee,this.m=oe}get value(){return f(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class ${constructor(t,i,n,r,l=new E,k=new E,b=new A.$zc,w=new E,O=new A.$zc){this.c=t,this.d=i,this.f=n,this.g=r,this.h=l,this.i=k,this.j=b,this.l=w,this.m=O,this.a=null,this.b=new A.$zc,this.n=null}getValue(t,i,n){return this.q(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new E,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.q(t,i,n),l=this.u(i.resource,n),k=i.resource?this.m.get(i.resource)||this.l:this.l,b=new Set;for(const w of r.overrides)for(const O of w.identifiers)r.getOverrideValue(t,O)!==void 0&&b.add(O);return new u(t,i,r.getValue(t),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,k)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:l,removed:k}=S(this.c,t);i=[...r,...l,...k]}for(const r of i)for(const l of(0,I.$xn)(r)){const k=this.c.getKeysForOverrideIdentifier(l),b=t.getKeysForOverrideIdentifier(l),w=[...b.filter(O=>k.indexOf(O)===-1),...k.filter(O=>b.indexOf(O)===-1),...k.filter(O=>!v.$_m(this.c.override(l).getValue(O),t.override(l).getValue(O)))];n.push([l,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=S(this.d,t),l=[...i,...n,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.applicationConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateApplicationConfiguration(t),{keys:k,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.localUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateLocalUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.remoteUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateRemoteUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.workspaceConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateWorkspaceConfiguration(t),{keys:k,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.p.get(t),{added:r,updated:l,removed:k,overrides:b}=S(n,i),w=[...r,...l,...k];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:b}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:k}=S(i,void 0);return{keys:[...n,...r,...l],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,n){let r=this.r(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}r({resource:t},i){let n=this.s();if(i&&t){const r=i.getFolder(t);r&&(n=this.t(r.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const n=this.s(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}u(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.x(t.defaults),n=this.x(t.policy),r=this.x(t.application),l=this.x(t.user),k=this.x(t.workspace),b=t.folders.reduce((w,O)=>(w.set(c.URI.revive(O[0]),this.x(O[1])),w),new A.$zc);return new $(i,n,r,l,new E,k,b,new E,new A.$zc)}static x(t){return new E(t.contents,t.keys,t.overrides)}}e.$Fn=$;function N(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,k])=>{const b=(0,A.$wc)(i,l,new Set);k.forEach(w=>b.add(w))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Gn=N;class p{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const k of l)this.affectedKeys.add(k);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=$.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const k=this.d.charCodeAt(l);if(k!==this.b&&k!==this.c)return!1;if(i){const b=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!v.$_m(b,w)}return!0}}e.$Hn=p;function S(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],k=o?.getAllOverrideIdentifiers()||[],b=t?.getAllOverrideIdentifiers()||[];if(t){const w=b.filter(O=>!k.includes(O));for(const O of w)l.push([O,t.getKeysForOverrideIdentifier(O)])}if(o){const w=k.filter(O=>!b.includes(O));for(const O of w)l.push([O,o.getKeysForOverrideIdentifier(O)])}if(t&&o){for(const w of k)if(b.includes(w)){const O=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});l.push([w,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:n,updated:r,overrides:l}}function s(o,t){const i=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],n=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const k=(0,P.$si)(t.contents,l),b=(0,P.$si)(o.contents,l);v.$_m(k,b)||r.push(l)}}return{added:i,removed:n,updated:r}}}),define(te[132],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,L,D,R,j,A,v,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=void 0;class d extends R.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new v.$Cn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.$hn.as(h.$mn.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:u})=>this.c(Array.from(m),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,u){this.h(m,I.$hn.as(h.$mn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new v.$Cn;const m=I.$hn.as(h.$mn.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,u){const $=this.f();for(const N of m){const p=$[N],S=u[N];p!==void 0?this.b.addValue(N,p):S?this.b.addValue(N,S.default):this.b.removeValue(N)}}}e.$In=d;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new v.$Cn}async initialize(){return this.configurationModel}}e.$Jn=f;let E=class extends R.$Rc{get configurationModel(){return this.b}constructor(m,u,$){super(),this.c=m,this.f=u,this.g=$,this.a=this.B(new D.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new v.$Cn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const u={},$=[],N=I.$hn.as(h.$mn.Configuration).getConfigurationProperties();for(const p of m){const S=N[p];if(!S){$.push(p);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.g.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}$.push(p),u[S.policy.name]={type:S.type}}}return(0,A.$Lf)(u)||await this.f.updatePolicyDefinitions(u),$}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const u=I.$hn.as(h.$mn.Configuration).getPolicyConfigurations(),$=(0,L.$Gb)(m.map(N=>u.get(N)));this.m($,!0)}m(m,u){this.g.trace("PolicyConfiguration#update",m);const $=I.$hn.as(h.$mn.Configuration).getConfigurationProperties(),N=[],p=this.b.isEmpty();for(const S of m){const s=$[S]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(p?o!==void 0:!(0,j.$_m)(this.b.getValue(S),o))&&N.push([S,o])}else this.b.getValue(S)!==void 0&&N.push([S,void 0])}if(N.length){this.g.trace("PolicyConfiguration#changed",N);const S=this.b;this.b=new v.$Cn;for(const s of S.keys)this.b.setValue(s,S.getValue(s));for(const[s,o]of N)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);u&&this.a.fire(this.b)}}};e.$Kn=E,e.$Kn=E=pe([ie(1,P.$jn),ie(2,c.$$i)],E)}),define(te[133],ne([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,D,R,j,A,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0;class P extends R.$Rc{constructor(d,f,E,y){super(),this.j=d,this.h=this.B(new D.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$In),this.c=E instanceof c.$ln?new h.$Jn:this.B(new h.$Kn(this.b,E,y)),this.f=this.B(new v.$En(this.j,{},j.$mg,f)),this.a=new v.$Fn(this.b.configurationModel,this.c.configurationModel,new v.$Cn,new v.$Cn),this.g=this.B(new L.$7g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:m,properties:u})=>this.n(m,u))),this.B(this.c.onDidChangeConfiguration(m=>this.r(m))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,f,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new v.$Fn(d,f,new v.$Cn,E)}getConfigurationData(){return this.a.toData()}getValue(d,f){const E=typeof d=="string"?d:void 0,y=(0,A.$li)(d)?d:(0,A.$li)(f)?f:{};return this.a.getValue(E,y,void 0)}updateValue(d,f,E,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const f=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(d);this.s(E,f,2)}n(d,f){const E=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(d,f);this.s(y,E,7)}r(d){const f=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(d);this.s(E,f,7)}s(d,f,E){const y=new v.$Hn(d,{data:f},this.a);y.source=E,y.sourceConfig=this.t(E),this.h.fire(y)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Ln=P}),define(te[67],ne([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function D(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Vk=D;function R(c){if(!c)return;const P=c.indexOf("+");return P<0?c:c.substr(0,P)}e.$Wk=R;function j(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Xk=j;function A(c){const{host:P,port:I}=h(c);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:I}}e.$Yk=A;function v(c,P){let{host:I,port:d}=h(c);return typeof d>"u"&&(d=P),{host:I,port:d}}e.$Zk=v;function h(c){const P=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=c.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const d=c.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:c,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.TargetPlatform=e.ExtensionType=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l="extensions.user.cache",e.$2l="extensions.builtin.cache",e.$3l="undefined_publisher",e.$4l=["ui","workspace","web"];function j(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$5l=j,e.$6l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(A||(e.ExtensionType=A={}));var v;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class h{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,u){if(typeof m>"u"||m===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof m=="string"||typeof u=="string"){const $=typeof m=="string"?m:m.value,N=typeof u=="string"?u:u.value;return L.$2e($,N)}return m._lower===u._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$7l=h;class c{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const u of m)this.add(u)}add(m){this.c.add(h.toKey(m))}delete(m){return this.c.delete(h.toKey(m))}has(m){return this.c.has(h.toKey(m))}}e.$8l=c;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(h.toKey(m))}get(m){return this.c.get(h.toKey(m))}has(m){return this.c.has(h.toKey(m))}set(m,u){this.c.set(h.toKey(m),u)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$9l=P;function I(y){return d(y)}e.$0l=I;function d(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$$l=d;function f(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$_l=f;function E(y,m){if(m){const u=`onResolveRemoteAuthority:${(0,R.$Wk)(m)}`;return!!y.activationEvents?.includes(u)}return!1}e.$am=E,e.$bm=(0,D.$Qh)("IBuiltinExtensionsScannerService")}),define(te[134],ne([0,1,2,37,12]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;class j extends L.$Rc{constructor(v,h,c,P,I){super(),this.a=v,this.b=h,this.c=c,this.f=I,this.B(P.onDidInstallExtensions(d=>this.g(d))),this.B(P.onDidUninstallExtension(d=>this.h(d)))}g(v){for(const h of v)h.local&&this.invalidate(h.profileLocation)}h(v){v.error||this.invalidate(v.profileLocation)}async invalidate(v){if(v)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,v)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(v){try{await this.b.del(this.c.extUri.joinPath(v.cacheHome,D.$1l))}catch(h){(0,R.$qk)(h)!==1&&this.f.error(h)}}}e.$Hp=j}),define(te[44],ne([0,1,14,9,2,103,43,10,6,36]),function(J,e,L,D,R,j,A,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$To=(0,v.$Qh)("requestService");class P{constructor(S){this.b=S}toJSON(){if(!this.a){const S=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?S[s]="*****":S[s]=this.b[s];this.a=S}return this.a}}class I extends R.$Rc{constructor(S){super(),this.b=0,this.a=S.createLogger("network",{name:(0,j.localize)(0,null),when:h.$pj.isEqualTo((0,h.$nj)(h.LogLevel.Trace)).serialize()})}async c(S,s,o){const t=`${S} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new P(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,D.$9)(i)),i}}}e.$Uo=I;function d(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$Vo=d;function f(p){return p.res.statusCode===204}e.$Wo=f;async function E(p){return f(p)?null:(await(0,L.$ne)(p.stream)).toString()}e.$Xo=E;async function y(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);return E(p)}e.$Yo=y;async function m(p){if(!d(p))throw new Error("Server returned "+p.res.statusCode);if(f(p))return null;const s=(await(0,L.$ne)(p.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$Zo=m;function u(p){N(p)}e.$1o=u;let $;function N(p){const S=c.$hn.as(A.$mn.Configuration),s=$;$={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[$],remove:s?[s]:[]})}N(1)}),define(te[135],ne([0,1,20,15,12,44]),function(J,e,L,D,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=void 0;let A=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,P=L.CancellationToken.None){if(h.scheme===D.Schemas.file||h.scheme===D.Schemas.vscodeRemote){await this.b.copy(h,c);return}const I={type:"GET",url:h.toString(!0)},d=await this.a.request(I,P);if(d.res.statusCode===200)await this.b.writeFile(c,d.stream);else{const f=await(0,j.$Yo)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${f}`)}}};e.$7N=A,e.$7N=A=pe([ie(0,j.$To),ie(1,R.$_j)],A)}),define(te[136],ne([0,1,137,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;function R(A,v){return A.protocol==="http:"?v.HTTP_PROXY||v.http_proxy||null:A.protocol==="https:"&&(v.HTTPS_PROXY||v.https_proxy||v.HTTP_PROXY||v.http_proxy)||null}async function j(A,v,h={}){const c=(0,L.parse)(A),P=h.proxyUrl||R(c,v);if(!P)return null;const I=(0,L.parse)(P);if(!/^https?:$/.test(I.protocol||""))return null;const d={host:I.hostname||"",port:(I.port?+I.port:0)||(I.protocol==="https"?443:80),auth:I.auth,rejectUnauthorized:(0,D.$Ef)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,E)=>{J(["http-proxy-agent"],f,E)})).HttpProxyAgent(P,d):new(await new Promise((f,E)=>{J(["https-proxy-agent"],f,E)})).HttpsProxyAgent(P,d)}e.$Yq=j}),define(te[138],ne([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=void 0;let E;async function y(u,$,N,p){return N["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.$Ol)(p)&&!N["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.$Ol)(p)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=d.Promises.withAsyncBody(async(S,s)=>{const o=new j.$Xd;let t=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$Pl)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,R.localize)(0,null)))},t);try{S(await m($,o.token))}catch(r){!(0,v.$3)(r)&&!o.token.isCancellationRequested?s(new Error((0,R.localize)(1,null,(0,A.$Bi)(r)))):S({})}finally{clearTimeout(n),o.dispose()}})),E)}e.$Ul=y;async function m(u,$){const N=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",N);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",p);const S=(0,c.$eg)().replace(/-/g,"").substr(0,12),s=new RegExp(S+"({.*})"+S),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,P.$El)(h.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if($.isCancellationRequested)return n(new v.$4);const r=(0,D.$mc)(t);let l,k;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${b} -p '''${S}'' + JSON.stringify(process.env) + ''${S}'''`,k=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${b} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,k=["-i","-l","-c"]):(l=`'${process.execPath}' ${b} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),l);const w=(0,L.spawn)(t,[...k,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});$.onCancellationRequested(()=>(w.kill(),n(new v.$4))),w.on("error",_=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,A.$Bi)(_)),n(_)});const O=[];w.stdout.on("data",_=>O.push(_));const B=[];w.stderr.on("data",_=>B.push(_)),w.on("close",(_,ee)=>{const oe=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",oe);const se=Buffer.concat(B).toString("utf8");if(se.trim()&&u.trace("getUnixShellEnvironment#stderr",se),_||ee)return n(new Error((0,R.localize)(2,null,_,ee)));const ue=s.exec(oe),ce=ue?ue[1]:"{}";try{const re=JSON.parse(ce);N?re.ELECTRON_RUN_AS_NODE=N:delete re.ELECTRON_RUN_AS_NODE,p?re.ELECTRON_NO_ATTACH_CONSOLE=p:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",re),i(re)}catch(re){u.error("getUnixShellEnvironment#errorCaught",(0,A.$Bi)(re)),n(re)}})})}}),define(te[139],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=e.$IN=void 0,e.$IN=(0,L.$Qh)("stateReadService"),e.$JN=(0,L.$Qh)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(J,e,L,D,R,j,A,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=e.$LN=e.$KN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class P extends R.$Rc{constructor(E,y,m,u){super(),this.h=E,this.j=m,this.m=u,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=y===0?void 0:this.B(new L.$Rg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(E){E.fileOperationResult!==1&&this.j.error(E)}}getItem(E,y){const m=this.a[E];return(0,j.$Hf)(m)?y:m}setItem(E,y){this.setItems([{key:E,data:y}])}setItems(E){let y=!1;for(const{key:m,data:u}of E)this.a[m]!==u&&((0,j.$Hf)(u)?(0,j.$Ff)(this.a[m])||(this.a[m]=void 0,y=!0):(this.a[m]=u,y=!0));y&&this.r()}removeItem(E){(0,j.$Ff)(this.a[E])||(this.a[E]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const E=JSON.stringify(this.a,null,4);if(E!==this.b)try{await this.m.writeFile(this.h,D.$be.fromString(E),{atomic:{postfix:".vsctmp"}}),this.b=E}catch(y){this.j.error(y)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$KN=P;let I=class extends R.$Rc{constructor(E,y,m,u){super(),this.a=this.B(new P(y.stateResource,E,m,u))}async init(){await this.a.init()}getItem(E,y){return this.a.getItem(E,y)}};e.$LN=I,e.$LN=I=pe([ie(1,A.$Xh),ie(2,h.$$i),ie(3,v.$_j)],I);class d extends I{setItem(E,y){this.a.setItem(E,y)}setItems(E){this.a.setItems(E)}removeItem(E){this.a.removeItem(E)}close(){return this.a.close()}}e.$MN=d}),define(te[69],ne([0,1,13,35,28]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=void 0;function j(h){if(L.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function A(h,c,P,I,d,f,E,y,m){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=E,u.sessionID=(0,R.$eg)()+Date.now(),u.commitHash=I,u.version=d,u["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,L.$i)(L.$u),u["common.nodePlatform"]=D.$cc,u["common.nodeArch"]=P,u["common.product"]=m||"desktop",y&&(u["common.msftInternal"]=y);let $=0;const N=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-N,enumerable:!0},"common.sequence":{get:()=>$++,enumerable:!0}}),L.$m&&(u["common.snap"]="true");const p=j(c);return p&&(u["common.platformDetail"]=p),u}e.$io=A;function v(h){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const P=c.toLowerCase();return h.some(I=>P===I)}e.$jo=v}),define(te[26],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,L.$Qh)("telemetryService"),e.$el=(0,L.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var D;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(J,e,L,D,R,j,A,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$ko=c;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$lo=P,e.$mo=new P;class I{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$no=I,e.$oo="telemetry",e.$po="extensionTelemetryLog",e.$qo={log:()=>null,flush:()=>Promise.resolve(null)};function d(i,n){return R.Event.debounce(n.onDidChangeConfiguration,(l,k)=>{const b=l?new Set([...l.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:b}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,j.$ni)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$ro=d;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$so=f;function E(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$to=E;function y(i){const n=i.getValue(h.$ll),r=i.getValue(h.$ml);if(i.getValue(h.$nl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$uo=y;function m(i){const n={},r={},l={};N(i,l);for(let k in l){k=k.length>150?k.substr(k.length-149):k;const b=l[k];typeof b=="number"?r[k]=b:typeof b=="boolean"?r[k]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${b.length}`),n[k]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(n[k]=b)}return{properties:n,measurements:r}}e.$vo=m;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function $(i){if(!i)return"none";const n=(0,A.$Wk)(i);return u.has(n)?n:"other"}e.$wo=$;function N(i,n,r=0,l){if(i)for(const k of Object.getOwnPropertyNames(i)){const b=i[k],w=l?l+k:k;Array.isArray(b)?n[w]=(0,L.$an)(b):b instanceof Date?n[w]=b.toISOString():(0,D.$Af)(b)?r<2?N(b,n,r+1,w+"."):n[w]=(0,L.$an)(b):n[w]=b}}function p(i,n){const r=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,v.$jo)(r)||l}e.$xo=p;function S(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$yo=S;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const l=[];for(const O of n)for(;;){const B=O.exec(i);if(!B)break;l.push([B.index,O.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const O=b.exec(i);if(!O)break;const B=l.some(([_,ee])=>O.index<ee&&_<b.lastIndex);!k.test(O[0])&&!B&&(r+=i.substring(w,O.index)+"<REDACTED: user-file-path>",w=b.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$0m)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,n);for(const k of n)l=l.replace(k,"");return l=o(l),l}})}e.$zo=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,D,R,j,A,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$We)(t.id,i.id)===0}e.$Ao=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new d(i.identifier,n,r)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new d({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof d?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Bo=d;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(t){const i=f.exec(t);return i&&i[1]?[m(i[1]),i[2]]:[m(t),void 0]}e.$Co=E;function y(t,i){return`${t}.${i}`}e.$Do=y;function m(t){return t.toLowerCase()}e.$Eo=m;function u(t,i){return m(y(t??R.$3l,i))}e.$Fo=u;function $(t,i){const n=[],r=l=>{for(const k of n)if(k.some(b=>P(i(b),i(l))))return k;return null};for(const l of t){const k=r(l);k?k.push(l):n.push([l])}return n}e.$Go=$;function N(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Ho=N;function p(t){return{id:new c.$ko(t.identifier.id),name:new c.$ko(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Io=p,e.$Jo=new R.$7l("pprice.better-merge");function S(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(k=>!P(k.identifier,{id:l}))){const k=t.filter(b=>P(b.identifier,{id:l}));k.length===1&&(n.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Ko=S;async function s(t,i){if(!j.$l)return!1;let n;try{n=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,v.$9)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,D.$7n)(n?"alpine":j.$u,h.$dc);return i.debug("ComputeTargetPlatform:",r),r}e.$Lo=o}),define(te[140],ne([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,L,D,R,j,A,v,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=void 0;const d=m=>(0,h.localize)(0,null,m),f=(0,h.localize)(1,null,"ms-dotnettools.csharp");function E(m,u){return u?`${m.publisher}.${m.name}@${m.version}`:`${m.publisher}.${m.name}`}let y=class{constructor(u,$,N){this.a=u,this.b=$,this.d=N}get f(){}async listExtensions(u,$,N){let p=await this.b.getInstalled(1,N);const S=I.$6l.map(o=>o.toLowerCase());if($&&$!==""){if(S.indexOf($.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf($.toLowerCase())>-1:!1)}else if($===""){this.a.info("Possible Categories: "),S.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),p=p.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of p)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(E(o.manifest,u)))}async installExtensions(u,$,N,p){const S=[];try{const s=[];u.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const o=[];let t=[];const i=(r,l,k)=>{t.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...N,isBuiltin:k,installPreReleaseVersion:l==="prerelease"||N.installPreReleaseVersion}})};for(const r of u)if(r instanceof v.URI)o.push({vsix:r,installOptions:N});else{const[l,k]=(0,P.$Co)(r);i(l,k,!1)}for(const r of $)if(r instanceof v.URI)o.push({vsix:r,installOptions:{...N,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,k]=(0,P.$Co)(r);i(l,k,!0)}const n=await this.b.getInstalled(1,N.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:l})=>{try{const k=await this.g(r,l,p,n);k&&s.push(k)}catch(k){this.a.error(k),S.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:l})=>{const k=n.find(b=>(0,P.$Ao)(b.identifier,{id:r}));if(k){if(!p&&(!l||l==="prerelease"&&k.preRelease))return this.a.info((0,h.localize)(5,null,r,k.manifest.version,r)),!1;if(l&&k.manifest.version===l)return this.a.info((0,h.localize)(6,null,`${r}@${l}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async l=>{const k=r.get(l.id.toLowerCase());if(k)try{const b=await this.j(l,k,n);b&&s.push(b)}catch(b){this.a.error(b.message||b.stack||b),S.push(l.id)}else this.a.error(`${d(l.version?`${l.id}@${l.version}`:l.id)}
${f}`),S.push(l.id)}))}}catch(s){throw this.a.error((0,h.localize)(7,null,(0,D.$9)(s))),s}if(S.length)throw new Error((0,h.localize)(8,null,S.join(", ")))}async g(u,$,N,p){const S=await this.b.getManifest(u);if(!S)throw new Error("Invalid vsix");if(await this.l(S,N,$.profileLocation,p))try{return await this.b.install(u,$),this.a.info((0,h.localize)(9,null,(0,j.$sg)(u))),S}catch(o){if((0,D.$3)(o))return this.a.info((0,h.localize)(10,null,(0,j.$sg)(u))),null;throw o}return null}async h(u){const $=new Map,N=u.some(s=>s.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),S=[];for(const s of u)c.$Zn.test(s.id)&&S.push({...s,preRelease:N});if(S.length){const s=await this.d.getExtensions(S,{targetPlatform:p},L.CancellationToken.None);for(const o of s)$.set(o.identifier.id.toLowerCase(),o)}return $}async j({id:u,version:$,installOptions:N},p,S){const s=await this.d.getManifest(p,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=S.find(t=>(0,P.$Ao)(t.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.a.info((0,h.localize)(11,null,$?`${u}@${$}`:u)),null;this.a.info((0,h.localize)(12,null,u,p.version))}try{N.isBuiltin?this.a.info($?(0,h.localize)(13,null,u,$):(0,h.localize)(14,null,u)):this.a.info($?(0,h.localize)(15,null,u,$):(0,h.localize)(16,null,u));const t=await this.b.installFromGallery(p,{...N,installGivenVersion:!!$});return this.a.info((0,h.localize)(17,null,u,t.manifest.version)),s}catch(t){if((0,D.$3)(t))return this.a.info((0,h.localize)(18,null,u)),null;throw t}}k(u){return!0}async l(u,$,N,p){if(!$){const S={id:(0,P.$Fo)(u.publisher,u.name)},s=p.find(o=>(0,P.$Ao)(S,o.identifier)&&(0,A.gt)(o.manifest.version,u.version));if(s)return this.a.info((0,h.localize)(19,null,s.identifier.id,s.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,$,N){const p=async s=>{if(s instanceof v.URI){const o=await this.b.getManifest(s);return E(o)}return s},S=[];for(const s of u){const o=await p(s),i=(await this.b.getInstalled(void 0,N)).filter(n=>(0,P.$Ao)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${f}`);if(i.some(n=>n.type===0)){this.a.info((0,h.localize)(20,null,o));return}if(!$&&i.some(n=>n.isBuiltin)){this.a.info((0,h.localize)(21,null,o));return}this.a.info((0,h.localize)(22,null,o));for(const n of i)await this.b.uninstall(n,{profileLocation:N}),S.push(n);this.f?this.a.info((0,h.localize)(23,null,o,this.f)):this.a.info((0,h.localize)(24,null,o))}}async locateExtension(u){const $=await this.b.getInstalled();u.forEach(N=>{$.forEach(p=>{if(p.identifier.id===N&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(u){return this.f?(0,h.localize)(25,null,u,this.f):(0,h.localize)(26,null,u)}};e.$hp=y,e.$hp=y=pe([ie(1,c.$ao),ie(2,c.$$n)],y)}),define(te[141],ne([0,1,4,2,31,27,37]),function(J,e,L,D,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;class v extends D.$Rc{constructor(c,P,I,d,f,E,y){super(),this.f=c,this.g=P,this.h=I,this.j=d,this.m=f,this.n=E,this.r=y,this.a=this.B(new L.$Nd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$Zc),this.s().then(null,m=>y.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(P=>(this.c.set(P.id,(0,D.$Oc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(c){for(const P of c.extensions)this.I(this.L(P.identifier,P.version),c.profileLocation)}async y(c){for(const P of c.extensions){const I=this.L(P.identifier,P.version);c.error?this.J(I,c.profileLocation):this.I(I,c.profileLocation)}}async z(c){for(const P of c.extensions)this.J(this.L(P.identifier,P.version),c.profileLocation)}async C(c){const P=[],I=[];for(const d of c.extensions){const f=this.L(d.identifier,d.version);c.error?this.I(f,c.profileLocation):(this.J(f,c.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),I.push(this.f.scanInstalledExtensionAtLocation(d.location).then(E=>{E?P.push(E):this.r.info("Extension not found at the location",d.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(I),P.length&&await this.H(P)}catch(d){this.r.error(d)}}D(c){for(const P of this.h.profiles)c.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(c){const P=[],I=[],d=await this.j.scanProfileExtensions(c),f=new Set,E=new Set;for(const[y,m]of this.b)m.has(c)&&E.add(y);for(const y of d){const m=this.L(y.identifier,y.version);f.add(m),E.has(m)||(P.push(y.identifier),this.I(m,c))}for(const y of E)if(!f.has(y)){const m=this.M(y);m&&(I.push(m.identifier),this.J(y,c))}(P.length||I.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:c}:void 0,removed:I.length?{extensions:I,profileLocation:c}:void 0})}async G(c){const P=await this.j.scanProfileExtensions(c);for(const I of P)this.I(this.L(I.identifier,I.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.L(I.identifier,I.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,P){let I=this.b.get(c);I||this.b.set(c,I=new R.$Ac(d=>this.m.extUri.getComparisonKey(d))),I.add(P)}J(c,P){const I=this.b.get(c);I&&I.delete(P),I?.size||this.b.delete(c)}L(c,P){return`${A.$7l.toKey(c.id)}@${P}`}M(c){const[P,I]=(0,j.$Co)(c);return I?{identifier:{id:P},version:I}:void 0}}e.$Ip=v}),define(te[142],ne([0,1,113,39]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=void 0;async function R(j,A,v,h,c,P,I){const d={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${A.nameShort})`};if((0,D.$so)(A,v)&&(0,D.$uo)(h)===3){const f=await(0,L.$ap)(v,c,P);d["X-Market-User-Id"]=f,d["VSCode-SessionId"]=I.machineId||f}return d}e.$bp=R}),define(te[143],ne([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;let y=class extends f.$Uq{constructor(N,p,S,s){super(S),this.h=N,this.j=s,this.g=this.B(new m(p,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(N,p){const s=(await this.g.getLanguagePacks())[p];if(!s){this.j.warn(`No language pack found for ${p}`);return}const o=s.translations[N];return o?E.URI.file(o):void 0}async getInstalledLanguages(){const N=await this.g.getLanguagePacks(),p=Object.keys(N).map(S=>{const s=N[S];return{...this.f(S,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((S,s)=>S.label.localeCompare(s.label)),p}async m(N){N&&N.manifest&&N.manifest.contributes&&N.manifest.contributes.localizations&&N.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",N.identifier.id),await this.update())}async n(N){const p=await this.g.getLanguagePacks();Object.keys(p).some(S=>p[S]&&p[S].extensions.some(s=>(0,I.$Ao)(s.extensionIdentifier,N.identifier)))&&(this.j.info("Removing language packs from the extension",N.identifier.id),await this.update())}async update(){const[N,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),S=await this.g.update(p);return!(0,D.$tb)(Object.keys(N),Object.keys(S))}};e.$Vq=y,e.$Vq=y=pe([ie(0,P.$ao),ie(1,c.$Yh),ie(2,P.$$n),ie(3,d.$$i)],y);let m=class extends j.$Rc{constructor(N,p){super(),this.j=p,this.c={},this.f=(0,v.$ic)(N.userDataPath,"languagepacks.json"),this.g=new R.$2g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(N){return this.s(p=>{Object.keys(p).forEach(S=>delete p[S]),this.m(p,...N)}).then(()=>this.c)}m(N,...p){for(const S of p)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.n(N,S);Object.keys(N).forEach(S=>this.r(N[S]))}n(N,p){const S=p.identifier,s=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of s)if(p.location.scheme===A.Schemas.file&&u(o)){let t=N[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},N[o.languageId]=t);const i=t.extensions.filter(n=>(0,I.$Ao)(n.extensionIdentifier,S))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:S,version:p.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,v.$ic)(p.location.fsPath,n.path)}}r(N){if(N){const p=(0,L.createHash)("md5");for(const S of N.extensions)p.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);N.hash=p.digest("hex")}}s(N=()=>null){return this.g.queue(()=>{let p=null;return h.Promises.readFile(this.f,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(p=N(S),S)).then(S=>{for(const o of Object.keys(S))S[o]||delete S[o];this.c=S,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),h.Promises.writeFile(this.f,s)}).then(()=>p,S=>this.j.error(S))})}};m=pe([ie(0,c.$Yh),ie(1,d.$$i)],m);function u($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const N of $.translations)if(typeof N.id!="string"||typeof N.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(te[144],ne([0,1,81,9,30,39]),function(J,e,L,D,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",v="https://mobile.events.data.microsoft.com/ping";async function h(P,I,d){const f=await(0,L.$IC)("@microsoft/1ds-core-js","dist/ms.core.js"),E=await(0,L.$IC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new f.AppInsightsCore,m=new E.PostChannel,u={instrumentationKey:P,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(d){u.extensionConfig={};const $={alwaysUseXhrOverride:!0,httpXHROverride:d};u.extensionConfig[m.identifier]=$}return y.initialize(u,[]),y.addTelemetryInitializer($=>{I&&($.ext=$.ext??{},$.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),y}class c{constructor(I,d,f,E,y){this.e=I,this.f=d,this.g=f,this.h=y,this.c=A,this.d=v,this.g||(this.g={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}i(I){if(this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{I(d)},d=>{(0,D.$Z)(d),console.error(d)})}}log(I,d){if(!this.a)return;d=(0,R.$$m)(d,this.g),d=(0,j.$vo)(d);const f=this.f+"/"+I;try{this.i(E=>{E.pluginVersionString=d?.properties.version??"Unknown",E.track({name:f,baseData:{name:f,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.$EN=c}),define(te[145],ne([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let E=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,$,N){this.k=$,this.l=N,this.d={},this.i=new L.$Qc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,j.$Fe)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Fe)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(d.$ll)||p.affectsConfiguration(d.$nl)||p.affectsConfiguration(d.$ml))&&this.m()}))}setExperimentProperty(u,$){this.d[u]=$}m(){let u=(0,f.$uo)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const N=$.usage?3:$.error?2:0;u=Math.min(u,N)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,$,N){this.g<$||(N=(0,D.$$m)(N,this.d),N=(0,f.$zo)(N,this.j),N=(0,D.$$m)(N,this.c),this.b.forEach(p=>p.log(u,N)))}publicLog(u,$){this.n(u,3,$)}publicLog2(u,$){this.publicLog(u,$)}publicLogError(u,$){this.h&&this.n(u,2,$)}publicLogError2(u,$){this.publicLogError(u,$)}};e.$2q=E,e.$2q=E=pe([ie(1,v.$ki),ie(2,P.$qj)],E);function y(){const m=(0,A.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=R.$p?"":(0,A.localize)(3,null),N=(0,A.localize)(4,null),p=(0,A.localize)(5,null),S=(0,A.localize)(6,null),s=(0,A.localize)(7,null),o=`
|       | ${N} | ${p} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${m} ${u} ${$}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}I.$hn.as(h.$mn.Configuration).registerConfiguration({id:d.$kl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[d.$ll]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.$hn.as(h.$mn.Configuration).registerConfiguration({id:d.$kl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[d.$nl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,A.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,A.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${d.$ll}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[147],ne([0,1,14,20,174,144]),function(J,e,L,D,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=void 0;async function A(P,I){const d=await I.request(P,D.CancellationToken.None),f=(await(0,L.$ne)(d.stream)).toString(),E=d.res.statusCode??200;return{headers:d.res.headers,statusCode:E,responseData:f}}async function v(P){const I={method:P.type,headers:P.headers};return new Promise((f,E)=>{const y=R.request(P.url??"",I,m=>{m.on("data",function(u){f({headers:m.headers,statusCode:m.statusCode??200,responseData:u.toString()})}),m.on("error",function(u){E(u)})});y.write(P.data,m=>{m&&E(m)}),y.end()})}async function h(P,I,d){const f=typeof I.data=="string"?I.data:new TextDecoder().decode(I.data),E={type:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data).toString()},url:I.urlString,data:f};try{const y=P?await A(E,P):await v(E);d(y.statusCode,y.headers,y.responseData)}catch{d(0,{})}}class c extends j.$EN{constructor(I,d,f,E,y){const m={sendPOST:(u,$)=>{h(I,u,$)}};super(d,f,E,y,m)}}e.$FN=c}),define(te[148],ne([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9b=void 0;async function R(j,A){const v=Object.create(null),h=(P,I)=>{const d=JSON.parse(P);v[I]=d};if(A){const P=[],I=await D.Promises.readdir(A);for(const f of I)try{(await D.Promises.stat((0,L.$ic)(A,f))).isDirectory()&&P.push(f)}catch{}const d=[];for(const f of P)(await D.Promises.readdir((0,L.$ic)(A,f))).filter(y=>y==="telemetry.json").length===1&&d.push(f);for(const f of d){const E=(await D.Promises.readFile((0,L.$ic)(A,f,"telemetry.json"))).toString();h(E,f)}}let c=(await D.Promises.readFile((0,L.$ic)(j,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await D.Promises.readFile((0,L.$ic)(j,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(v,null,4)}e.$o9b=R}),define(te[149],ne([0,1,13,82,26]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=e.$G8b=void 0;async function j(v,h){let c=v.getItem(R.$il);return(typeof c!="string"||L.$k&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,D.$Tm)(h.error.bind(h))),c}e.$G8b=j;async function A(v,h){let c=v.getItem(R.$jl);return typeof c!="string"&&(c=await(0,D.$Um)(h.error.bind(h))),c}e.$H8b=A}),define(te[22],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=void 0,e.$Jk=(0,L.$Qh)("IUriIdentityService")}),define(te[150],ne([0,1,22,114,12,17,73,4,2]),function(J,e,L,D,R,j,A,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;class c{static{this._clock=0}constructor(d){this.uri=d,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let P=class{constructor(d){this.g=d,this.c=new h.$Qc,this.f=2**16;const f=new Map,E=y=>{let m=f.get(y.scheme);return m===void 0&&(m=d.hasProvider(y)&&!this.g.hasCapability(y,1024),f.set(y.scheme,m)),m};this.c.add(v.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{f.delete(y.scheme)})),this.extUri=new j.$kg(E),this.d=new A.$zr((y,m)=>this.extUri.compare(y,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,j.$wg)(d));const f=this.d.get(d);return f?f.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new c(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((E,y)=>E[1].time<y[1].time?1:E[1].time>y[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let E=0;E<f;E++)this.d.set(d[E][0],d[E][1].touch())}};e.$Ar=P,e.$Ar=P=pe([ie(0,R.$_j)],P),(0,D.$xr)(L.$Jk,P,1)}),define(te[151],ne([0,1,4,2,12,47,31]),function(J,e,L,D,R,j,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$58b=void 0;class v extends D.$Rc{constructor(c,P,I,d,f,E){super(),this.f=c,this.g=P,this.h=I,this.j=d,this.m=f,this.n=E,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=j.$Wh.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Ac(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,P){return this.g.open(this.t(c),P)}close(c){return this.g.close(c)}read(c,P,I,d,f){return this.g.read(c,P,I,d,f)}write(c,P,I,d,f){return this.g.write(c,P,I,d,f)}watch(c,P){this.b.set(c,c);const I=this.g.watch(this.t(c),P);return(0,D.$Pc)(()=>{this.b.delete(c),I.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,P,I){return this.g.rename(this.t(c),this.t(P),I)}readFile(c,P){return this.g.readFile(this.t(c),P)}readFileStream(c,P,I){return this.g.readFileStream(this.t(c),P,I)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,P,I){return this.g.writeFile(this.t(c),P,I)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,P){return this.g.delete(this.t(c),P)}copy(c,P,I){if((0,R.$dk)(this.g))return this.g.copy(this.t(c),this.t(P),I);throw new Error("copy not supported")}cloneFile(c,P){if((0,R.$ek)(this.g))return this.g.cloneFile(this.t(c),this.t(P));throw new Error("clone not supported")}s(c){const P=[];for(const I of c){if(I.resource.scheme!==this.f)continue;const d=this.u(I.resource);this.b.findSubstr(d)&&P.push({resource:d,type:I.type,cId:I.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$58b=v}),define(te[152],ne([0,1,107,16,47,17,11,10,15]),function(J,e,L,D,R,j,A,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,v.$Qh)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$1h=c;function P(i){return typeof i?.id=="string"&&!c(i)&&!d(i)}e.$2h=P,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function I(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$mc)(i)}:n?e.$3h:e.$4h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$5h=I;function d(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$6h=d;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:A.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$7h=f;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$8h=y;function m(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$9h=m;class u{constructor(n,r,l,k,b){this.h=n,this.j=l,this.k=k,this.l=b,this.c=R.$Wh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$Wh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=u;class ${constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,j.$vg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=$;function N(i){return new $({uri:i,index:0,name:(0,j.$rg)(i)},{uri:i.toString()})}e.$_h=N,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,L.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function p(i,n){return j.$mg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$ei=p;function S(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$fi=S,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$gi}e.$hi=s;function o(i,n){return!p(i,n)&&!S(i)}e.$ii=o;function t(i){return(typeof i=="string"?(0,D.$nc)(i):(0,j.$tg)(i))===e.$bi}e.$ji=t}),define(te[23],ne([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.ProfileResourceType=void 0;var N;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(N||(e.ProfileResourceType=N={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Kk=p,e.$Lk=(0,P.$Qh)("IUserDataProfilesService");function S(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Mk=S;function s(i,n,r,l,k,b){return{id:i,name:n,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:b&&k?.useDefaultFlags?.globalState?b.globalStorageHome:(0,j.$vg)(r,"globalStorage"),settingsResource:b&&k?.useDefaultFlags?.settings?b.settingsResource:(0,j.$vg)(r,"settings.json"),keybindingsResource:b&&k?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,j.$vg)(r,"keybindings.json"),tasksResource:b&&k?.useDefaultFlags?.tasks?b.tasksResource:(0,j.$vg)(r,"tasks.json"),snippetsHome:b&&k?.useDefaultFlags?.snippets?b.snippetsHome:(0,j.$vg)(r,"snippets"),extensionsResource:b&&k?.useDefaultFlags?.extensions?b.extensionsResource:(0,j.$vg)(r,"extensions.json"),cacheHome:(0,j.$vg)(l,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Nk=s;let o=class extends R.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,k){super(),this.t=n,this.u=r,this.w=l,this.y=k,this.f=!0,this.h=this.B(new D.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zc,emptyWindows:new Map},this.profilesHome=(0,j.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,$.$yf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(s((0,j.$sg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},n))}}catch(b){this.y.error(b)}const l=new f.$zc,k=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[w,O]of Object.entries(b.workspaces)){const B=A.URI.parse(w),_=r.find(ee=>ee.id===O);_&&l.set(B,_)}if(b.emptyWindows)for(const[w,O]of Object.entries(b.emptyWindows)){const B=r.find(_=>_.id===O);B&&k.set(w,B)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:l,emptyWindows:k}}return this.z}D(){const n=s("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,u.$Fe)(r)}\\s(\\d+)`);let k=0;for(const w of this.profiles){const O=l.exec(w.name),B=O?parseInt(O[1]):0;k=B>k?B:k}const b=`${r} ${k+1}`;return this.createProfile((0,L.$Ei)((0,m.$eg)()).toString(16),b,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$Ei)((0,m.$eg)()).toString(16),n,r,l)}async createProfile(n,r,l,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(n,r,l);return k&&await this.setProfileForWorkspace(k,b),b}async F(n,r,l){if(!(0,$.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const b=this.profiles.find(B=>B.name===r||B.id===n);if(b)return b;const w=s(n,r,(0,j.$vg)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(w.location);const O=[];return this.j.fire({profile:w,join(B){O.push(B)}}),await y.Promises.settled(O),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(k=>k.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(k){l.push(k)}});try{await Promise.allSettled(l)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,c.$qk)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(k=>k.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return A.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,d.$1h)(n)?n.uri:(0,d.$6h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const k=[...this.profiles,...n],b=[];this.s.profiles=[];for(let w of k)w.isDefault||r.some(O=>w.id===O.id)||(w=l.find(O=>w.id===O.id)??w,w.isTransient?this.s.profiles.push(w):b.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(b),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const k=this.G(n),b=l?this.s:this.C;A.URI.isUri(k)?(b.workspaces.delete(k),r&&b.workspaces.set(k,r)):(b.emptyWindows.delete(k),r&&b.emptyWindows.set(k,r)),l||this.M()}M(){const n={};for(const[l,k]of this.C.workspaces.entries())n[l.toString()]=k.id;const r={};for(const[l,k]of this.C.emptyWindows.entries())r[l.toString()]=k.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[b,w]of Object.entries(n.workspaces)){const O=A.URI.parse(w);r[b]=this.w.extUri.isEqual(O,l.location)?l.id:this.w.extUri.basename(O)}const k={};if(n.emptyWindows)for(const[b,w]of Object.entries(n.emptyWindows)){const O=A.URI.parse(w);k[b]=this.w.extUri.isEqual(O,l.location)?l.id:this.w.extUri.basename(O)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ok=o,e.$Ok=o=pe([ie(0,h.$Xh),ie(1,c.$_j),ie(2,E.$Jk),ie(3,I.$$i)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Pk=t}),define(te[153],ne([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u,$,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=void 0;let p=class extends v.$Rc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,k,b,w){super(),this.z=n,this.C=r,this.D=l,this.F=k,this.G=b,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$Nd),this.s=this.B(new A.$Nd),this.t=this.B(new A.$Nd),this.u=this.B(new A.$Nd),this.w=this.B(new A.$Nd),this.y=[],this.B((0,v.$Pc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,d.$9n)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const k=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:b})=>(0,f.$Ao)(b,n.identifier));if(k?.local)return k?.local;throw k?.error?k.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new d.$_n(I.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:k,options:b})=>{try{const w=await this.O(k,!!b?.installGivenVersion,!!b?.installPreReleaseVersion);l.push({...w,options:b})}catch(w){r.push({identifier:k.identifier,operation:2,source:k,error:w})}})),l.length&&r.push(...await this.I(l));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!P.URI.isUri(k.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$Io)(k.source),error:k.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,E.$0l)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const b=(await this.getInstalled(1,k.extensionsResource)).find(w=>(0,f.$Ao)(w.identifier,n.identifier));b?this.w.fire(b):this.u.fire({identifier:n.identifier,profileLocation:k.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const k=await this.J(l,(b,w)=>n.some(O=>(0,f.$Eo)(w.identifier.id)===(0,f.$Fo)(O.manifest.publisher,O.manifest.name))?!1:this.L(b,w));r.push(...k)}catch(k){r.push({identifier:{id:(0,f.$Fo)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:k})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l},k){const b=l.isApplicationScoped||l.isBuiltin||(0,E.$0l)(n),w={...l,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:b,profileLocation:b?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},O=ue=>`${f.$Bo.create(ue).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const ue=this.j.get(O(r));if(ue)return this.F.info("Extensions is already requested to install",r.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const B=[],_=[],ee=[],oe=this.Z(n,r,w);P.URI.isUri(r)||this.j.set(O(r),{task:oe,waitingTasks:[]}),this.n.fire({identifier:oe.identifier,source:r,profileLocation:w.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),B.push({task:oe,manifest:n});let se=!1;try{if(w.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const ce=await this.N(oe.identifier,n,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),re=await this.getInstalled(void 0,w.profileLocation),q={...w,donotIncludePackAndDependencies:!0,context:{...w.context,[d.$4n]:!0}};for(const{gallery:X,manifest:T}of(0,L.$Lb)(ce,({gallery:U})=>U.identifier.id)){se=se||!!T.extensionDependencies?.some(G=>(0,f.$Ao)({id:G},oe.identifier));const U=O(X),H=this.j.get(U);if(H){if(k(oe,H.task)){const G=H.task.identifier;this.F.info("Waiting for already requested installing extension",G.id,oe.identifier.id),H.waitingTasks.push(oe),_.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,Z=>Z.some(K=>(0,f.$Ao)(K.identifier,G)))).then(Z=>{if(this.F.info("Finished waiting for already requested installing extension",G.id,oe.identifier.id),!Z.find(C=>(0,f.$Ao)(C.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!re.some(({identifier:G})=>(0,f.$Ao)(G,X.identifier))){const G=this.Z(T,X,q);this.j.set(U,{task:G,waitingTasks:[oe]}),this.n.fire({identifier:G.identifier,source:X,profileLocation:w.profileLocation}),this.F.info("Installing extension:",G.identifier.id,oe.identifier.id),B.push({task:G,manifest:T})}}}catch(ce){if(P.URI.isUri(oe.source))(0,L.$Kb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",oe.identifier.id,ce.message),(0,L.$Kb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",oe.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),ce}const ue=B.reduce((ce,{task:re,manifest:q})=>(ce.set(re.identifier.id.toLowerCase(),{task:re,manifest:q}),ce),new Map);for(;ue.size;){let ce;const re=[...ue.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(X=>ue.has(X.toLowerCase())));re.length?ce=ue.size===1?re:re.filter(({task:q})=>!(q===oe&&!se)):(this.F.info("Found extensions with circular dependencies",re.map(({task:q})=>q.identifier.id)),ce=[...ue.values()]),await this.M(ce.map(async({task:q})=>{const X=new Date().getTime();try{const T=await q.run();if(await this.M(this.y.map(U=>U.postInstall(T,q.source,w,R.CancellationToken.None))),!P.URI.isUri(q.source)){const U=q.operation===3,H=U?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(o(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Io)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,durationSinceUpdate:H}),h.$p&&q.operation!==3)try{await this.z.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}}ee.push({local:T,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:T.isApplicationScoped})}catch(T){throw P.URI.isUri(q.source)||o(this.C,q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Io)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-X,error:T}),this.F.error("Error while installing the extension:",q.identifier.id),T}finally{ue.delete(q.identifier.id.toLowerCase())}}))}return _.length&&await this.M(_),ee.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),ee}catch(ue){if(B.forEach(({task:ce})=>ce.cancel()),ee.length)try{const ce=await Promise.allSettled(ee.map(({local:re})=>this.$(re,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let re=0;re<ce.length;re++){const q=ce[re],{identifier:X}=ee[re];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",X.id):this.F.warn("Rollback: Error while uninstalling extension",X.id,(0,j.$9)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,j.$9)(ce),ee.map(({identifier:re})=>re.id))}return B.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:w.context,profileLocation:w.profileLocation,error:ue}))}finally{for(const{task:ue}of B)ue.source&&!P.URI.isUri(ue.source)&&this.j.delete(O(ue.source))}}L(n,r){for(const[,{task:l,waitingTasks:k}]of this.j.entries())if(l===n&&(k.includes(r)||k.some(b=>this.L(b,r)))||l===r&&k[0]&&!this.L(n,k[0]))return!1;return!0}async M(n){const r=[],l=[],k=await Promise.allSettled(n);for(const b of k)b.status==="fulfilled"?r.push(b.value):l.push(b.reason);if(l.length)throw S(l);return r}async N(n,r,l,k,b){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,b),O=[],B=[],_=async(ee,oe)=>{O.push(ee);const se=oe.extensionDependencies||[],ue=[...se];if(oe.extensionPack){const ce=l?w.find(re=>(0,f.$Ao)(re.identifier,ee)):void 0;for(const re of oe.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$Ao)({id:q},{id:re}))||ue.every(q=>!(0,f.$Ao)({id:q},{id:re}))&&ue.push(re)}if(ue.length){const ce=ue.filter(re=>O.every(q=>!(0,f.$Ao)(q,{id:re})));if(ce.length){const re=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:k})),R.CancellationToken.None);for(const q of re){if(O.find(U=>(0,f.$Ao)(U,q.identifier)))continue;const X=se.some(U=>(0,f.$Ao)({id:U},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(U){if(X)throw U;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,j.$9)(U));continue}B.push({gallery:T.extension,manifest:T.manifest}),await _(T.extension.identifier,T.manifest)}}}};return await _(n,r),B}async O(n,r,l){let k;const b=await this.getExtensionsControlManifest();if(b.malicious.some(B=>(0,f.$Ao)(n.identifier,B)))throw new d.$_n(I.localize(1,null,n.identifier.id),d.ExtensionManagementErrorCode.Malicious);const w=b.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!k)throw new d.$_n(I.localize(2,null,n.identifier.id,w.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const B=await this.getTargetPlatform();throw new d.$_n(I.localize(3,null,n.identifier.id,this.G.nameLong,(0,d.$5n)(B)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(n,r,l),!k)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],R.CancellationToken.None))[0]?new d.$_n(I.localize(4,null,n.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$_n(I.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const O=await this.z.getManifest(k,R.CancellationToken.None);if(O===null)throw new d.$_n(`Missing manifest for extension ${k.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(O.version!==k.version)throw new d.$_n(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:O}}async P(n,r,l){const k=await this.getTargetPlatform();let b=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(b=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null),!b&&await this.z.isExtensionCompatible(n,l,k)&&(b=n),b||(r?b=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null:b=await this.z.getCompatibleExtension(n,l,k)),b}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=ee=>`${ee.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,b=this.m.get(k(n.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),b.waitUntilTaskIsFinished();const w=ee=>{const oe=this.$(ee,l);return this.m.set(k(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.t.fire({identifier:ee.identifier,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped}),oe},O=(ee,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Ho)(ee),error:oe}),this.u.fire({identifier:ee.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:ee.isApplicationScoped})},B=[],_=[];try{B.push(w(n));const ee=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const oe=this.U(n,ee);for(const se of oe)this.m.has(k(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):B.push(w(se))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(B.map(oe=>oe.extension),ee,n),await this.M(B.map(async oe=>{try{if(await oe.run(),await this.M(this.y.map(se=>se.postUninstall(oe.extension,l,R.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}O(oe.extension)}catch(se){const ue=se instanceof d.$_n?se:new d.$_n((0,j.$9)(se),d.ExtensionManagementErrorCode.Internal);throw O(oe.extension,ue),ue}finally{_.push(oe)}}))}catch(ee){const oe=ee instanceof d.$_n?ee:new d.$_n((0,j.$9)(ee),d.ExtensionManagementErrorCode.Internal);for(const se of B){try{se.cancel()}catch{}_.includes(se)||O(se.extension,oe)}throw oe}finally{for(const ee of B)this.m.delete(k(ee.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}R(n,r,l){for(const k of n){const b=this.W(k,r);if(b.length){const w=b.filter(O=>!n.some(B=>(0,f.$Ao)(B.identifier,O.identifier)));if(w.length)throw new Error(this.S(k,w,l))}}}S(n,r,l){return l===n?r.length===1?I.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const k=n.manifest.extensionPack?n.manifest.extensionPack:[];if(k.length){const b=r.filter(O=>!O.isBuiltin&&k.some(B=>(0,f.$Ao)({id:B},O.identifier))),w=[];for(const O of b)w.push(...this.U(O,r,l));return[...b,...w]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(k=>(0,f.$Ao)({id:k},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$qp=p,e.$qp=p=pe([ie(0,d.$$n),ie(1,u.$dl),ie(2,$.$Jk),ie(3,y.$$i),ie(4,m.$qj),ie(5,N.$Lk)],p);function S(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$rp=S;function s(i){if(i instanceof d.$_n)return i;const n=new d.$_n(i.message,d.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$sp=s;function o(i,n,{extensionData:r,verificationStatus:l,duration:k,error:b,durationSinceUpdate:w}){let O,B;(0,c.$Gf)(l)&&(l===!0?l="Verified":(l===!1||(O=d.ExtensionManagementErrorCode.Signature,B=l),l="Unverified")),b&&(b instanceof d.$_n?(O=b.code,b.code===d.ExtensionManagementErrorCode.Signature&&(B=b.message)):O=d.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!b,duration:k,errorcode:O,errorcodeDetail:B,durationSinceUpdate:w})}class t{constructor(){this.d=new D.$Sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Hg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Hg)(n=>new Promise((r,l)=>{const k=n.onCancellationRequested(()=>{k.dispose(),l(new j.$4)})})),this.d.open()),this.g.cancel()}}e.$tp=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class N extends Error{constructor(t,i){super(t),this.code=i}}e.$up=N,e.$vp=(0,I.$Qh)("IExtensionsProfileScannerService");let p=class extends R.$Rc{constructor(t,i,n,r,l,k){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=l,this.t=k,this.b=this.B(new j.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new A.$zc}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,l=>{const k=[];for(const b of l)t.some(([w])=>(0,c.$Ao)(w.identifier,b.identifier)&&w.manifest.version!==b.version)?n.push(b):k.push(b);for(const[b,w]of t){const O=k.findIndex(_=>(0,c.$Ao)(_.identifier,b.identifier)&&_.version===b.manifest.version),B={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:w};O===-1?(r.push(B),k.push(B)):k.splice(O,1,B)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const l=[];for(const k of r){const b=t.find(([w])=>(0,c.$Ao)(w.identifier,k.identifier)&&w.manifest.version===k.version);b&&(k.metadata={...k.metadata,...b[1]},n.push(k)),l.push(k)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const l=[];for(const k of r)(0,c.$Ao)(k.identifier,t.identifier)?n.push(k):l.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],l;try{const k=await this.m.readFile(t);l=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,P.$qk)(k)!==1)throw k;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new N((0,m.$9)(k),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let k=!1;for(const b of l){S(b)||this.w(t);let w;if((0,y.$yf)(b.relativeLocation)&&b.relativeLocation)w=this.z(b.relativeLocation);else if((0,y.$yf)(b.location))w=this.z(b.location),k=!0,b.relativeLocation=b.location,b.location=w.toJSON();else{w=v.URI.revive(b.location);const O=this.y(w);O&&(k=!0,b.relativeLocation=O)}r.push({identifier:b.identifier,location:w,version:b.version,metadata:b.metadata})}k&&await this.m.writeFile(t,D.$be.fromString(JSON.stringify(l)))}if(i){r=i(r);const k=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(t,D.$be.fromString(JSON.stringify(k)))}return r})}w(t){const i=new N(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,P.$qk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(k=>S(k))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,P.$qk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,P.$qk)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,P.$qk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$2g,this.h.set(t,i)),i}};e.$wp=p,e.$wp=p=pe([ie(1,P.$_j),ie(2,f.$Lk),ie(3,E.$Jk),ie(4,u.$dl),ie(5,d.$$i)],p);function S(o){return(0,y.$Af)(o)&&(0,h.$0n)(o.identifier)&&(s(o.location)||(0,y.$yf)(o.location)&&o.location)&&((0,y.$Ff)(o.relativeLocation)||(0,y.$yf)(o.relativeLocation))&&o.version&&(0,y.$yf)(o.version)}function s(o){return o?(0,y.$yf)(o.path)&&(0,y.$yf)(o.scheme):!1}}),define(te[50],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,46,40,23,22,112]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u,$,N,p,S,s,o,t,i,n,r,l,k,b,w,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.$zp=e.Translations=void 0;var B;(function(re){function q(X,T){if(X===T)return!0;const U=Object.keys(X),H=new Set;for(const G of Object.keys(T))H.add(G);if(U.length!==H.size)return!1;for(const G of U){if(X[G]!==T[G])return!1;H.delete(G)}return H.size===0}re.equals=q})(B||(e.Translations=B={})),e.$zp=(0,t.$Qh)("IExtensionsScannerService");let _=class extends c.$Rc{constructor(q,X,T,U,H,G,Z,K,C,F,a,g){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=X,this.r=T,this.s=U,this.t=H,this.u=G,this.w=Z,this.y=K,this.z=C,this.C=F,this.D=a,this.F=g,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,f.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Lo)(this.w,this.y)),this.G}async scanAllExtensions(q,X,T){const[U,H]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(X)]),G=T?await this.scanExtensionsUnderDevelopment(q,[...U,...H]):[];return this.L(U,H,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const X=[];X.push(this.M(!!q.useCache,q.language)),X.push(this.N(q.language,!!q.checkControlFile));const[T,U]=await Promise.all(X);return this.J([...T,...U],0,q,!1)}async scanUserExtensions(q){const X=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(X,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),H=q.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let G;try{G=await H.scanExtensions(U)}catch(Z){if(Z instanceof k.$up&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await H.scanExtensions(U);else throw Z}return G=await this.J(G,1,q,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(q,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===P.Schemas.file).map(async U=>{const H=await this.P(U,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(H)).map(Z=>(Z.type=X.find(K=>(0,p.$Ao)(K.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,H)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,X,T){const U=await this.P(q,!1,X,!0,T.language,!0,void 0),H=await this.n.scanExtension(U);return!H||!T.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(q,X,T){const U=await this.P(q,!1,X,!0,T.language,!0,void 0),H=await this.n.scanOneOrMultipleExtensions(U);return this.J(H,X,T,!0)}async scanMetadata(q){const X=(0,f.$vg)(q,"package.json"),T=(await this.w.readFile(X)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,X){const T=(0,f.$vg)(q,"package.json"),U=(await this.w.readFile(T)).value.toString(),H=JSON.parse(U);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,H.__metadata={...H.__metadata,...X},await this.w.writeFile((0,f.$vg)(q,"package.json"),j.$be.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$up&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$be.fromString(JSON.stringify([])))}catch(X){(0,o.$qk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$9)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,X,T,U){return T.includeAllVersions||(q=this.L(X===0?q:void 0,X===1?q:void 0,X==="development"?q:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(q=q.filter(H=>H.isValid)),q.sort((H,G)=>{const Z=I.$mc(H.location.fsPath),K=I.$mc(G.location.fsPath);return Z<K?-1:Z>K?1:0})}L(q,X,T,U,H){const G=(K,C,F)=>{if(K.isValid&&!C.isValid)return!1;if(K.isValid===C.isValid){if(H&&E.gt(K.manifest.version,C.manifest.version))return this.y.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(E.eq(K.manifest.version,C.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${C.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===U)return this.y.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${K.location.path} with ${C.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${C.location.path}.`),!0},Z=new S.$9l;return q?.forEach(K=>{const C=Z.get(K.identifier.id);(!C||G(C,K,!1))&&Z.set(K.identifier.id,K)}),X?.forEach(K=>{const C=Z.get(K.identifier.id);if(!C&&q&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!C||G(C,K,!1))&&Z.set(K.identifier.id,K)}),T?.forEach(K=>{const C=Z.get(K.identifier.id);(!C||G(C,K,!0))&&Z.set(K.identifier.id,K),Z.set(K.identifier.id,K)}),[...Z.values()]}async M(q,X){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),H=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",H.length),H}async N(q,X){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const U=X?await this.O():{},H=[],G=u.URI.file(I.$gc(I.$ic(P.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const C=U[K.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":H.push((0,f.$vg)(G,K.name));break;default:H.push(u.URI.file(C));break}}const Z=await Promise.all(H.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,L.$Gb)(Z)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,X,T,U,H,G,Z){const K=await this.f(H??d.$w),C=await this.Q(q),F=X&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=F?await this.Q(F):void 0;return new ee(q,C,F,a,X,Z,T,U,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,H,K)}async Q(q){try{const X=await this.w.stat(q);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Ap=_,e.$Ap=_=pe([ie(4,b.$Lk),ie(5,k.$vp),ie(6,o.$_j),ie(7,i.$$i),ie(8,N.$Xh),ie(9,n.$qj),ie(10,w.$Jk),ie(11,t.$Ph)],_);class ee{constructor(q,X,T,U,H,G,Z,K,C,F,a,g,z,M,Q){this.location=q,this.mtime=X,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=H,this.profileScanOptions=G,this.type=Z,this.excludeObsolete=K,this.validate=C,this.productVersion=F,this.productDate=a,this.productCommit=g,this.devMode=z,this.language=M,this.translations=Q}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,X){return(0,f.$og)(q.location,X.location)&&q.mtime===X.mtime&&(0,f.$og)(q.applicationExtensionslocation,X.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&q.profile===X.profile&&R.$_m(q.profileScanOptions,X.profileScanOptions)&&q.type===X.type&&q.excludeObsolete===X.excludeObsolete&&q.validate===X.validate&&q.productVersion===X.productVersion&&q.productDate===X.productDate&&q.productCommit===X.productCommit&&q.devMode===X.devMode&&q.language===X.language&&B.equals(q.translations,X.translations)}}e.$Bp=ee;let oe=class extends c.$Rc{constructor(q,X,T,U,H){super(),this.f=q,this.g=X,this.h=T,this.j=U,this.m=H}async scanExtensions(q){const X=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,m.$Lf)(T)?X:X.filter(U=>!T[p.$Bo.create(U).toString()])}async n(q){const X=await this.j.resolve(q.location);if(!X.children?.length)return[];const T=await Promise.all(X.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,f.$sg)(U.resource).indexOf(".")===0)return null;const H=new ee(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(H)}));return(0,L.$Gb)(T).sort((U,H)=>U.location.path<H.location.path?-1:1)}async r(q){let X=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){X=X.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);X.push(...T)}return X}async s(q,X,T){const U=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!U.length)return[];const H=await Promise.all(U.map(async G=>{if(X(G)){const Z=new ee(G.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Z,G.metadata)}return null}));return(0,L.$Gb)(H)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$vg)(q.location,"package.json"))){const X=await this.scanExtension(q);return X?[X]:[]}else return await this.scanExtensions(q)}catch(X){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,A.$9)(X)),[]}}async scanExtension(q,X){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=S.$3l),X=X??T.__metadata,delete T.__metadata;const U=(0,p.$Fo)(T.publisher,T.name),H=X?.id?{id:U,uuid:X.id}:{id:U},G=X?.isSystem?0:q.type,Z=G===0||!!X?.isBuiltin;T=await this.t(q.location,T,ee.createNlsConfiguration(q));const K={type:G,identifier:H,manifest:T,location:q.location,isBuiltin:Z,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return q.validate?this.validate(K,q):K}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,X){let T=!0;const U=(0,s.$Qo)(X.productVersion,X.productDate,X.location,q.manifest,q.isBuiltin);for(const[H,G]of U)H===y.default.Error&&(T=!1,this.m.error(this.z(X.location,G)));return q.isValid=T,q.validations=U,q}async scanExtensionManifest(q){const X=(0,f.$vg)(q,"package.json");let T;try{T=(await this.j.readFile(X)).value.toString()}catch(H){return(0,o.$qk)(H)!==1&&this.m.error(this.z(q,(0,$.localize)(0,null,X.path,H.message))),null}let U;try{U=JSON.parse(T)}catch{const G=[];(0,v.$Xm)(T,G);for(const Z of G)this.m.error(this.z(q,(0,$.localize)(1,null,X.path,Z.offset,Z.length,(0,h.$xp)(Z.error))));return null}return(0,v.$7m)(U)!=="object"?(this.m.error(this.z(q,(0,$.localize)(2,null,X.path))),null):U}async t(q,X,T){const U=await this.u(q,X,T);if(U)try{const H=[],G=await this.w(U.default,H);if(H.length>0)return H.forEach(K=>{this.m.error(this.z(q,(0,$.localize)(3,null,U.default?.path,(0,h.$xp)(K.error))))}),X;if((0,v.$7m)(U)!=="object")return this.m.error(this.z(q,(0,$.localize)(4,null,U.default?.path))),X;const Z=U.values||Object.create(null);return(0,O.$yp)(this.m,X,Z,G)}catch{}return X}async u(q,X,T){const U=(0,f.$vg)(q,"package.nls.json"),H=(C,F)=>{F.forEach(a=>{this.m.error(this.z(q,(0,$.localize)(5,null,C?.path,(0,h.$xp)(a.error))))})},G=C=>{this.m.error(this.z(q,(0,$.localize)(6,null,C?.path)))},Z=`${X.publisher}.${X.name}`,K=T.translations[Z];if(K)try{const C=u.URI.file(K),F=(await this.j.readFile(C)).value.toString(),a=[],g=(0,v.$Xm)(F,a);return a.length>0?(H(C,a),{values:void 0,default:U}):(0,v.$7m)(g)!=="object"?(G(C),{values:void 0,default:U}):{values:g.contents?g.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let F;try{F=await this.y(q,T)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const a=(await this.j.readFile(F.localized)).value.toString(),g=[],z=(0,v.$Xm)(a,g);return g.length>0?(H(F.localized,g),{values:void 0,default:F.original}):(0,v.$7m)(z)!=="object"?(G(F.localized),{values:void 0,default:F.original}):{values:z,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(q,X){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,v.$Xm)(T,X)}catch{}}y(q,X){return new Promise((T,U)=>{const H=G=>{const Z=(0,f.$vg)(q,`package.nls.${G}.json`);this.j.exists(Z).then(K=>{K&&T({localized:Z,original:(0,f.$vg)(q,"package.nls.json")});const C=G.lastIndexOf("-");C===-1?T({localized:(0,f.$vg)(q,"package.nls.json"),original:null}):(G=G.substring(0,C),H(G))})};if(X.devMode||X.pseudo||!X.language)return T({localized:(0,f.$vg)(q,"package.nls.json"),original:null});H(X.language)})}z(q,X){return`[${q.path}]: ${X}`}};oe=pe([ie(1,k.$vp),ie(2,w.$Jk),ie(3,o.$_j),ie(4,i.$$i)],oe);let se=class extends oe{constructor(q,X,T,U,H,G,Z){super(X,U,H,G,Z),this.G=q,this.H=T,this.D=this.B(new D.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const X=this.M(q),T=await this.I(X);if(this.C=q,T&&T.input&&ee.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(H=>(H.location=u.URI.revive(H.location),H));const U=await super.scanExtensions(q);return await this.J(X,{input:q,result:U}),U}async I(q){try{const X=await this.j.readFile(q),T=JSON.parse(X.value.toString());return{result:T.result,input:(0,l.$nh)(T.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",q.path,(0,A.$9)(X))}return null}async J(q,X){try{await this.j.writeFile(q,j.$be.fromString(JSON.stringify(X)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,A.$9)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),X=await this.I(q);if(!X)return;const T=X.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$_m(U,T))try{this.m.info("Invalidating Cache",T,U),await this.j.del(q),this.F.fire()}catch(H){this.m.error(H)}}M(q){const X=this.N(q);return this.h.extUri.joinPath(X.cacheHome,q.type===0?S.$2l:S.$1l)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(q.location,X.extensionsResource))??this.G:this.H.defaultProfile}};se=pe([ie(2,b.$Lk),ie(3,k.$vp),ie(4,w.$Jk),ie(5,o.$_j),ie(6,i.$$i)],se);function ue(re,q){const X=(0,p.$Do)(re.manifest.publisher,re.manifest.name);return{id:X,identifier:new S.$7l(X),isBuiltin:re.type===0,isUserBuiltin:re.type===1&&re.isBuiltin,isUnderDevelopment:q,extensionLocation:re.location,uuid:re.identifier.uuid,targetPlatform:re.targetPlatform,...re.manifest}}e.$Cp=ue;class ce extends _{constructor(q,X,T,U,H,G,Z,K,C,F,a,g){super(q,X,(0,f.$vg)(T,".vscode-oss-dev","extensions","control.json"),U,H,G,Z,K,C,F,a,g),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(u.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Dp=ce}),define(te[154],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,D,R,j,A,v,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;let d=class extends A.$Rc{constructor(E,y){super(),this.b=E,this.f=y,this.a=new D.$1g(5)}async postUninstall(E){const y=this.g(E,"uninstall");y&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error(m)}}));try{await c.Promises.rm(this.m(E))}catch(m){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error(m)}}g(E,y){const m=`vscode:${y}`;if(E.location.scheme===v.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[m]=="string"){const u=E.manifest.scripts[m].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${m} should be a node script`),null):{script:(0,h.$ic)(E.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(E,y,m,u,$){return new Promise((N,p)=>{const S=this.j(E,y,m,$);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?p(t):N(void 0)};S.on("error",t=>{o((0,R.$Bi)(t)||"Unknown")}),S.on("exit",(t,i)=>{o(t?`post-${y} process exited with code ${t}`:void 0)}),u&&(s=setTimeout(()=>{s=null,S.kill(),p("timed out")},5e3))})}j(E,y,m,u){const $={silent:!0,execArgv:void 0},N=(0,L.fork)(E,[`--type=extension-post-${y}`,...m],$);N.stdout.setEncoding("utf8"),N.stderr.setEncoding("utf8");const p=j.Event.fromNodeEventEmitter(N.stdout,"data"),S=j.Event.fromNodeEventEmitter(N.stderr,"data");p(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${y}`,t)),S(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${y}`,t));const s=j.Event.any(j.Event.map(p,t=>({data:`%c${t}`,format:[""]})),j.Event.map(S,t=>({data:`%c${t}`,format:["color: red"]})));return j.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),N}m(E){return(0,h.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};e.$Fp=d,e.$Fp=d=pe([ie(0,I.$Lk),ie(1,P.$$i)],d)}),define(te[155],ne([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,D,R,j,A,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=void 0;let P=class extends A.$wp{constructor(d,f,E,y,m,u){super(c.URI.file(d.extensionsPath),f,E,y,m,u)}};e.$QN=P,e.$QN=P=pe([ie(0,h.$Yh),ie(1,v.$_j),ie(2,D.$Lk),ie(3,R.$Jk),ie(4,j.$dl),ie(5,L.$$i)],P)}),define(te[156],ne([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,D,R,j,A,v,h,c,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D8b=void 0;let d=class extends j.$Dp{constructor(E,y,m,u,$,N,p,S){super(L.URI.file($.builtinExtensionsPath),L.URI.file($.extensionsPath),$.userHome,E.defaultProfile,E,y,m,u,$,N,p,S)}};e.$D8b=d,e.$D8b=d=pe([ie(0,I.$Lk),ie(1,R.$vp),ie(2,A.$_j),ie(3,h.$$i),ie(4,D.$Yh),ie(5,c.$qj),ie(6,P.$Jk),ie(7,v.$Ph)],d)}),define(te[157],ne([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,D,R,j,A,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7o=e.$6o=e.$5o=void 0,e.$5o="__$__isNewStorageMarker",e.$6o="__$__targetStorageMarker",e.$7o=(0,h.$Qh)("storageService");var P;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var I;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var d;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function f($){const N=$.get(e.$6o);if(N)try{return JSON.parse(N)}catch{}return Object.create(null)}e.$8o=f;class E extends R.$Rc{static{this.a=60*1e3}constructor(N={flushInterval:E.a}){super(),this.m=N,this.b=this.B(new D.$Qd),this.c=this.B(new D.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(N,p,S){return D.Event.filter(this.b.event,s=>s.scope===N&&(p===void 0||s.key===p),S)}n(){this.j.value=(0,L.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(N,p){const{key:S,external:s}=p;if(S===e.$6o){switch(N){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:N})}else this.b.fire({scope:N,key:S,target:this.J(N)[S],external:s})}w(N){this.f.fire({reason:N})}get(N,p,S){return this.P(p)?.get(N,S)}getBoolean(N,p,S){return this.P(p)?.getBoolean(N,S)}getNumber(N,p,S){return this.P(p)?.getNumber(N,S)}getObject(N,p,S){return this.P(p)?.getObject(N,S)}storeAll(N,p){this.y(()=>{for(const S of N)this.store(S.key,S.value,S.scope,S.target,p)})}store(N,p,S,s,o=!1){if((0,A.$Hf)(p)){this.remove(N,S,o);return}this.y(()=>{this.z(N,S,s),this.P(S)?.set(N,p,o)})}remove(N,p,S=!1){this.y(()=>{this.z(N,p,void 0),this.P(p)?.delete(N,S)})}y(N){this.b.pause(),this.c.pause();try{N()}finally{this.b.resume(),this.c.resume()}}keys(N,p){const S=[],s=this.J(N);for(const o of Object.keys(s))s[o]===p&&S.push(o);return S}z(N,p,S,s=!1){const o=this.J(p);typeof S=="number"?o[N]!==S&&(o[N]=S,this.P(p)?.set(e.$6o,JSON.stringify(o),s)):typeof o[N]=="number"&&(delete o[N],this.P(p)?.set(e.$6o,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(N){switch(N){case-1:return this.I;case 0:return this.G;default:return this.D}}L(N){const p=this.P(N);return p?f(p):Object.create(null)}isNew(N){return this.getBoolean(e.$5o,N)===!0}async flush(N=P.NONE){this.f.fire({reason:N});const p=this.P(-1),S=this.P(0),s=this.P(1);switch(N){case P.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const N=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,S=this.P(1)?.items??new Map;return u(N,p,S,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(N){return await this.flush(),this.P(N)?.optimize()}async switch(N,p){return this.w(P.NONE),(0,c.$Kk)(N)?this.R(N,p):this.S(N,p)}M(N,p){return!(N.id===p.id||y(p)&&y(N))}N(N,p,S){this.y(()=>{const s=new Set;for(const[o,t]of N)s.add(o),p.get(o)!==t&&this.u(S,{key:o,external:!0});for(const[o]of p.items)s.has(o)||this.u(S,{key:o,external:!0})})}}e.$9o=E;function y($){return $.isDefault||!!$.useDefaultFlags?.globalState}e.$0o=y;class m extends E{constructor(){super(),this.U=this.B(new v.$3o(new v.$4o,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$3o(new v.$4o,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$3o(new v.$4o,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(N=>this.u(1,N))),this.B(this.W.onDidChangeStorage(N=>this.u(0,N))),this.B(this.U.onDidChangeStorage(N=>this.u(-1,N)))}P(N){switch(N){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(N){switch(N){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(N){return!1}}e.$$o=m;async function u($,N,p,S,s,o){const t=B=>{try{return JSON.parse(B)}catch{return B}},i=new Map,n=new Map;$.forEach((B,_)=>{i.set(_,B),n.set(_,t(B))});const r=new Map,l=new Map;N.forEach((B,_)=>{r.set(_,B),l.set(_,t(B))});const k=new Map,b=new Map;p.forEach((B,_)=>{k.set(_,B),b.set(_,t(B))}),console.group(S!==s?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const w=[];if(i.forEach((B,_)=>{w.push({key:_,value:B})}),console.table(w),console.groupEnd(),console.log(n),S!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const B=[];r.forEach((_,ee)=>{B.push({key:ee,value:_})}),console.table(B),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const O=[];k.forEach((B,_)=>{O.push({key:_,value:B})}),console.table(O),console.groupEnd(),console.log(b)}e.$_o=u}),define(te[158],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u,$,N,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=void 0;const s=j.$p?"web":(0,I.$7n)(j.$u,A.$dc),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((g,z)=>g|z,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(g=b){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,z=this.d.pageSize){return new w({...this.d,pageNumber:g,pageSize:z})}withFilter(g,...z){const M=[...this.d.criteria,...z.length?z.map(Q=>({filterType:g,value:Q})):[{filterType:g}]];return new w({...this.d,criteria:M})}withSortBy(g){return new w({...this.d,sortBy:g})}withSortOrder(g){return new w({...this.d,sortOrder:g})}withFlags(...g){return new w({...this.d,flags:g.reduce((z,M)=>z|M,0)})}withAssetTypes(...g){return new w({...this.d,assetTypes:g})}withSource(g){return new w({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:z,pageSize:M,sortBy:Q,sortOrder:W,flags:le,assetTypes:ae}=this.d;return{filters:[{criteria:g,pageNumber:z,pageSize:M,sortBy:Q,sortOrder:W}],assetTypes:ae,flags:le}}get searchText(){const g=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(a,g){const z=(a||[]).filter(M=>M.statisticName===g)[0];return z?z.value:0}function B(a){const g="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(M=>M.assetType.indexOf(g)===0).reduce((M,Q)=>{const W=oe(a,Q.assetType);return W&&M.push([Q.assetType.substring(g.length),W]),M},[])}function _(a){if(a.properties){const g=a.properties.filter(Q=>Q.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=g.filter(Q=>z.test(Q.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return oe(a,r.Repository)}function ee(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function oe(a,g){return a.files.filter(M=>M.assetType===g)[0]?{uri:`${a.assetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function se(a,g){const z=a.properties?a.properties.filter(Q=>Q.key===g):[],M=z.length>0&&z[0].value;return M?M.split(",").map(Q=>(0,d.$Eo)(Q)):[]}function ue(a){const g=a.properties?a.properties.filter(z=>z.key===l.Engine):[];return g.length>0&&g[0].value||""}function ce(a){const g=a.properties?a.properties.filter(z=>z.key===l.PreRelease):[];return g.length>0&&g[0].value==="true"}function re(a){const g=a.properties?a.properties.filter(M=>M.key===l.LocalizedLanguages):[],z=g.length>0&&g[0].value||"";return z?z.split(","):[]}function q(a){return a.properties?.find(g=>g.key===l.SponsorLink)?.value}function X(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,I.$6n)(a.targetPlatform):"undefined"}function U(a){const g=(0,L.$Lb)(a.versions.map(T)),z=!!a.tags?.includes(I.$1n),M=g.indexOf("web");return z?M===-1&&g.push("web"):M!==-1&&g.splice(M,1),g}function H(a,g){for(let z=0;z<a.length;z++){const M=a[z];if(M.version===a[z-1]?.version){let Q=z;if(T(M)===g)for(;Q>0&&a[Q-1].version===M.version;)Q--;Q!==z&&(a.splice(z,1),a.splice(Q,0,M))}}return a}e.$cp=H;function G(a,g,z){a.telemetryData={index:g,querySource:z,queryActivityId:a.queryContext?.[o]}}function Z(a,g,z,M){const Q=a.versions[0],W={manifest:oe(g,r.Manifest),readme:oe(g,r.Details),changelog:oe(g,r.Changelog),license:oe(g,r.License),repository:_(g),download:ee(g),icon:oe(g,r.Icon),signature:oe(g,r.Signature),coreTranslations:B(g)};return{identifier:{id:(0,d.$Fo)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:g.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(Q),description:a.shortDescription||"",installCount:O(a.statistics,"install"),rating:O(a.statistics,"averagerating"),ratingCount:O(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:z,assets:W,properties:{dependencies:se(g,l.Dependency),extensionPack:se(g,l.ExtensionPack),engine:ue(g),localizedLanguages:re(g),targetPlatform:T(g),isPreReleaseVersion:ce(g)},hasPreReleaseVersion:ce(Q),hasReleaseVersion:!0,preview:X(a.flags),isSigned:!!W.signature,queryContext:M}}let K=class{constructor(g,z,M,Q,W,le,ae,me){this.k=z,this.l=M,this.n=Q,this.o=W,this.q=le,this.u=ae,this.w=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,$.$bp)(ae.version,ae,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,z,M){const Q=D.CancellationToken.isCancellationToken(z)?{}:z,W=D.CancellationToken.isCancellationToken(z)?z:M,le=[],ae=[],me=[],de=[];let ge=!0;for(const we of g){we.uuid?ae.push(we.uuid):le.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!ae.length&&!le.length)return[];let fe=new w().withPage(1,g.length);ae.length&&(fe=fe.withFilter(n.ExtensionId,...ae)),le.length&&(fe=fe.withFilter(n.ExtensionName,...le)),(Q.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),Q.source&&(fe=fe.withSource(Q.source));const{extensions:he}=await this.z(fe,{targetPlatform:Q.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!Q.compatible},W);return Q.source&&he.forEach((we,be)=>G(we,be,Q.source)),he}async getCompatibleExtension(g,z,M){if((0,I.$8n)(g.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(g,z,M))return g;const Q=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,g.identifier.uuid),{extensions:W}=await this.z(Q,{targetPlatform:M,compatible:!0,includePreRelease:z},D.CancellationToken.None);return W[0]||null}async isExtensionCompatible(g,z,M){if(!(0,I.$9n)(g.properties.targetPlatform,g.allTargetPlatforms,M)||!z&&g.properties.isPreReleaseVersion)return!1;let Q=g.properties.engine;if(!Q){const W=await this.getManifest(g,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Q=W.engines.vscode}return(0,f.$So)(Q,this.u.version,this.u.date)}async y(g,z,M,Q,W){if(!(0,I.$9n)(T(g),Q,W)||z!=="any"&&ce(g)!==(z==="prerelease"))return!1;if(M)try{const le=await this.E(g);if(!(0,f.$So)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,R.$9)(le)),!1}return!0}async query(g,z){let M=g.text||"";const Q=g.pageSize??50;let W=new w().withPage(1,Q);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),W=W.withFilter(n.SearchText,M)),W=W.withSortBy(0)):g.ids?W=W.withFilter(n.ExtensionId,...g.ids):g.names?W=W.withFilter(n.ExtensionName,...g.names):W=W.withSortBy(4),typeof g.sortBy=="number"&&(W=W.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(W=W.withSortOrder(g.sortOrder)),g.source&&(W=W.withSource(g.source));const le=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!g.includePreRelease},fe);return he.forEach((be,Se)=>G(be,(ge.pageNumber-1)*ge.pageSize+Se,g.source)),{extensions:he,total:we}},{extensions:ae,total:me}=await le(W,z),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$4;const{extensions:he}=await le(W.withPage(ge+1),fe);return he};return{firstPage:ae,total:me,pageSize:W.pageSize,getPage:de}}async z(g,z,M){const Q=g.flags;g.flags&t.IncludeLatestVersionOnly&&g.flags&t.IncludeVersions&&(g=g.withFlags(g.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(g.flags&t.IncludeLatestVersionOnly)&&!(g.flags&t.IncludeVersions)&&(g=g.withFlags(g.flags,t.IncludeLatestVersionOnly)),z.versions?.length&&(g=g.withFlags(g.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),g=g.withFlags(g.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:le,context:ae}=await this.B(g,M);if(!(g.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,z,ae);we&&fe.push(we)}return{extensions:fe,total:le}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,d.$Fo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,v.$Ef)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Ce=>(0,d.$Ao)(Ce,we))?.includePreRelease;if(z.compatible&&(0,I.$8n)(U(he),z.targetPlatform))continue;const Se=await this.A(he,z,ae);!Se||Se.properties.isPreReleaseVersion&&(!be||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==z.targetPlatform&&Se.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,Se])}if(ge.size){const fe=new S.$Jd,he=new w().withFlags(Q&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,z,M);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const Se=ge.get(be.identifier.uuid);de.push([Se,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:le}}async A(g,z,M){const Q={id:(0,d.$Fo)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},W=z.versions?.find(de=>(0,d.$Ao)(de,Q))?.version,le=(0,v.$Ef)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,d.$Ao)(de,Q))?.includePreRelease,ae=U(g),me=H(g.versions,z.targetPlatform);if(z.compatible&&(0,I.$8n)(ae,z.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,le?"any":"release",z.compatible,ae,z.targetPlatform))return Z(g,ge,ae,M);if(W&&ge.version===W)return null}}return W||z.compatible?null:Z(g,g.versions[0],ae)}async B(g,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const M=await this.j,Q=JSON.stringify(g.raw),W={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},le=new S.$Jd;let ae,me,de=0;try{if(ae=await this.k.request({type:"POST",url:this.g&&g.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Q,headers:W},z),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,u.$Zo)(ae);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(Q.length),duration:le.elapsed(),success:!!ae&&(0,u.$Vo)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,R.$3)(me)?"canceled":(0,R.$9)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(g,z,M,Q){if(!this.isEnabled())return;const W=j.$p?this.x(`/itemName/${g}.${z}/version/${M}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${z}/${M}/stats?statType=${Q}`),le=j.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:W,headers:me},D.CancellationToken.None)}catch{}}async download(g,z,M){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const Q=(0,d.$Io)(g),W=new Date().getTime(),le=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Q,duration:fe}),ae=M===2?"install":M===3?"update":"",me=ae?{uri:`${g.assets.download.uri}${h.URI.parse(g.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${g.assets.download.fallbackUri}${h.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:g.assets.download,de=g.queryContext?.[o]?{[o]:g.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(z,ge.stream),le(new Date().getTime()-W)}async downloadSignatureArchive(g,z){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const M=await this.D(g.assets.signature);await this.q.writeFile(z,M.stream)}async getReadme(g,z){if(g.assets.readme){const M=await this.D(g.assets.readme,{},z);return await(0,u.$Yo)(M)||""}return""}async getManifest(g,z){if(g.assets.manifest){const M=await this.D(g.assets.manifest,{},z),Q=await(0,u.$Yo)(M);return Q?JSON.parse(Q):null}return null}async C(g,z){const M=oe(g,r.Manifest);if(!M)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},W=await this.D(M,{headers:Q});return await(0,u.$Zo)(W)}async getCoreTranslation(g,z){const M=g.assets.coreTranslations.filter(Q=>Q[0]===z.toUpperCase())[0];if(M){const Q=await this.D(M[1]),W=await(0,u.$Yo)(Q);return W?JSON.parse(W):null}return null}async getChangelog(g,z){if(g.assets.changelog){const M=await this.D(g.assets.changelog,{},z);return await(0,u.$Yo)(M)||""}return""}async getAllCompatibleVersions(g,z,M){let Q=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?Q=Q.withFilter(n.ExtensionId,g.identifier.uuid):Q=Q.withFilter(n.ExtensionName,g.identifier.id);const{galleryExtensions:W}=await this.B(Q,D.CancellationToken.None);if(!W.length)return[];const le=U(W[0]);if((0,I.$8n)(le,M))return[];const ae=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,z?"any":"release",!0,le,M)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of H(ae,M))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async D(g,z={},M=D.CancellationToken.None){const Q=await this.j,W={type:"GET"},le={...Q,...z.headers||{}};z={...z,...W,headers:le};const ae=g.uri,me=g.fallbackUri,de={...z,url:ae};try{const ge=await this.k.request(de,M);if(ge.res.statusCode===200)return ge;const fe=await(0,u.$Yo)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$3)(ge))throw ge;const fe=(0,R.$9)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:ae,message:fe});const he={...z,url:me};return this.k.request(he,M)}}async E(g){let z=ue(g);if(!z){const M=await this.C(g,D.CancellationToken.None);if(!M)throw new Error("Manifest was not found");z=M.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const g=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,u.$Zo)(g),M=[],Q={},W=[];if(z){for(const le of z.malicious)M.push({id:le});if(z.migrateToPreRelease)for(const[le,ae]of Object.entries(z.migrateToPreRelease))(!ae.engine||(0,f.$So)(ae.engine,this.u.version,this.u.date))&&(Q[le.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[le,ae]of Object.entries(z.deprecated))ae&&(Q[le.toLowerCase()]=(0,v.$Ef)(ae)?{}:ae);if(z.search)for(const le of z.search)W.push(le)}return{malicious:M,deprecated:Q,search:W}}};K=pe([ie(1,u.$To),ie(2,y.$$i),ie(3,P.$Xh),ie(4,p.$dl),ie(5,E.$_j),ie(6,m.$qj),ie(7,c.$ki)],K);let C=class extends K{constructor(g,z,M,Q,W,le,ae,me){super(g,z,M,Q,W,le,ae,me)}};e.$dp=C,e.$dp=C=pe([ie(0,N.$7o),ie(1,u.$To),ie(2,y.$$i),ie(3,P.$Xh),ie(4,p.$dl),ie(5,E.$_j),ie(6,m.$qj),ie(7,c.$ki)],C);let F=class extends K{constructor(g,z,M,Q,W,le,ae){super(void 0,g,z,M,Q,W,le,ae)}};e.$ep=F,e.$ep=F=pe([ie(0,u.$To),ie(1,y.$$i),ie(2,P.$Xh),ie(3,p.$dl),ie(4,E.$_j),ie(5,m.$qj),ie(6,c.$ki)],F)}),define(te[159],ne([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,D,R,j,A,v,h,c,P){"use strict";var I,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=e.$NN=void 0;let f=class extends h.$Ok{static{I=this}static{this.a="profileAssociationsMigration"}constructor(u,$,N,p,S){super(N,p,$,S),this.U=u,this.W=N}O(){return this.U.getItem(I.b,[]).map($=>({...$,location:(0,c.$yf)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):L.URI.revive($.location)}))}Q(){const u=this.U.getItem(I.c,{});return this.U.getItem(I.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$NN=f,e.$NN=f=I=pe([ie(0,A.$IN),ie(1,v.$Jk),ie(2,D.$Yh),ie(3,R.$_j),ie(4,j.$$i)],f);let E=d=class extends f{constructor(u,$,N,p,S){super(u,$,N,p,S),this.$=u}P(u){u.length?this.$.setItem(d.b,u.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(d.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(d.c,u):this.$.removeItem(d.c)}Q(){const u="workspaceAndProfileInfo",$=this.$.getItem(u,void 0);if($){this.$.removeItem(u);const p=$.reduce((S,{workspace:s,profile:o})=>(S[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),S),{});this.$.setItem(d.c,{workspaces:p})}const N=super.Q();return this.$.getItem(d.a,!1)||(this.R(N),this.$.setItem(d.a,!0)),N}};e.$ON=E,e.$ON=E=d=pe([ie(0,A.$JN),ie(1,v.$Jk),ie(2,D.$Yh),ie(3,R.$_j),ie(4,j.$$i)],E);let y=class extends E{constructor(u,$,N,p){super(new P.$MN(0,$,p,N),u,$,N,p)}async init(){return await this.$.init(),super.init()}};e.$PN=y,e.$PN=y=pe([ie(0,v.$Jk),ie(1,D.$Yh),ie(2,R.$_j),ie(3,j.$$i)],y)}),define(te[51],ne([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,D,R,j,A,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.zip=e.$mp=e.$lp=void 0,e.$lp="end of central directory record signature not found";const P=new RegExp(e.$lp);class I extends Error{constructor(o,t){let i=t.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=t}}e.$mp=I;function d(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(t=>o&t).reduce((t,i)=>t+i,o&61440)}function f(s){if(s instanceof I)return s;let o;return P.test(s.message)&&(o="CorruptZip"),new I(o,s)}function E(s,o,t,i,n,r){const l=R.$lc(o),k=R.$ic(i,l);if(!k.startsWith(i))return Promise.reject(new Error(v.localize(0,null,o)));const b=R.$ic(i,o);let w;return r.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(A.Promises.mkdir(k,{recursive:!0})).then(()=>new Promise((O,B)=>{if(!r.isCancellationRequested)try{w=(0,L.createWriteStream)(b,{mode:t}),w.once("close",()=>O()),w.once("error",B),s.once("error",B),s.pipe(w)}catch(_){B(_)}}))}function y(s,o,t,i){let n=(0,D.$Hg)(()=>Promise.resolve()),r=0;const l=i.onCancellationRequested(()=>{n.cancel(),s.close()});return new Promise((k,b)=>{const w=new D.$Og,O=B=>{B.isCancellationRequested||(r++,s.readEntry())};s.once("error",b),s.once("close",()=>n.then(()=>{i.isCancellationRequested||s.entryCount===r?k():b(new I("Incomplete",new Error(v.localize(1,null,r,s.entryCount))))},b)),s.readEntry(),s.on("entry",B=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(B.fileName)){O(i);return}const _=B.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(_)){const se=R.$ic(o,_);n=(0,D.$Hg)(ue=>A.Promises.mkdir(se,{recursive:!0}).then(()=>O(ue)).then(void 0,b));return}const ee=u(s,B),oe=d(B);n=(0,D.$Hg)(se=>w.queue(()=>ee.then(ue=>E(ue,_,oe,o,t,se).then(()=>O(se)))).then(null,b))})}).finally(()=>l.dispose())}function m(s,o=!1){return new Promise((t,i)=>{(0,h.open)(s,o?{lazyEntries:!0}:void 0,(n,r)=>{n?i(f(n)):t((0,j.$Jf)(r))})})}function u(s,o){return new Promise((t,i)=>{s.openReadStream(o,(n,r)=>{n?i(f(n)):t((0,j.$Jf)(r))})})}function $(s,o){return new Promise((t,i)=>{const n=new c.ZipFile;o.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const r=(0,L.createWriteStream)(s);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>t(s))})}e.zip=$;function N(s,o,t={},i){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=m(s,!0);return t.overwrite&&(r=r.then(l=>A.Promises.rm(o).then(()=>l))),r.then(l=>y(l,o,{sourcePathRegex:n},i))}e.$op=N;function p(s,o){return m(s).then(t=>new Promise((i,n)=>{t.on("entry",r=>{r.fileName===o&&u(t,r).then(l=>i(l),l=>n(l))}),t.once("close",()=>n(new Error(v.localize(2,null,o))))}))}function S(s,o){return p(s,o).then(t=>new Promise((i,n)=>{const r=[];t.once("error",n),t.on("data",l=>r.push(l)),t.on("end",()=>i(Buffer.concat(r)))}))}e.$pp=S}),define(te[160],ne([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u,$){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;let p=class extends R.$Rc{static{N=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,A.$vg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new E.$_n(r.message,E.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===$.LogLevel.Trace)}catch(l){const k=l;if(n=k.code,k.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${k.output}`),n===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.$_n(I.$lp,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,h.$Ef)(o)?o:!0}async u(s){await this.g;const o=(0,A.$vg)(this.extensionsDownloadDir,`${this.z(s)}${N.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await t(o);return}const i=(0,A.$vg)(this.extensionsDownloadDir,`.${(0,c.$eg)()}`);await this.h.exists(i)||await t(i);try{await P.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,D.$9)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(N.c))i.push(l.resource);else{const k=y.$Bo.parse(l.name);k&&t.push([k,l])}const n=(0,y.$Go)(t,([l])=>l),r=[];for(const l of n)l.sort((k,b)=>v.rcompare(k[0].version,b[0].version)),o.push(...l.slice(1).map(k=>k[1].resource)),r.push(l[0][1]);r.sort((l,k)=>l.mtime-k.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...i),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?y.$Bo.create(s).toString().toLowerCase():(0,c.$eg)()}};e.$Ep=p,e.$Ep=p=N=pe([ie(0,f.$Yh),ie(1,u.$_j),ie(2,E.$$n),ie(3,d.$ki),ie(4,m.$fp),ie(5,$.$$i)],p)}),define(te[161],ne([0,1,51,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;function R(j){return(0,L.$pp)(j,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$Gp=R}),define(te[162],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u,$,N,p,S,s,o,t,i,n,r,l,k,b,w,O,B,_,ee,oe,se,ue,ce,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Jp=(0,ee.$Rh)(t.$ao);const q=".vsctmp";let X=class extends o.$qp{constructor(C,F,a,g,z,M,Q,W,le,ae,me,de){super(C,F,me,a,ae,de),this.fb=z,this.gb=M,this.hb=Q,this.ib=le,this.eb=new Map,this.rb=new P.$Ac;const ge=this.B(W.createInstance(k.$Fp));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Hp(de,le,me,this,this.F)),this.db=this.B(W.createInstance(l.$Ep));const fe=this.B(new O.$Ip(this,this.fb,de,M,me,le,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Lo)(this.ib,this.F)),this.jb}async zip(C){this.F.trace("ExtensionManagementService#zip",C.identifier.id);const F=await this.pb(C),a=await(0,N.zip)((0,f.$vg)(this.db.extensionsDownloadDir,(0,u.$eg)()).fsPath,F);return m.URI.file(a)}async unzip(C){return this.F.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:F,cleanup:a}=await this.lb(C),g=d.$jc(F.fsPath);try{return await(0,b.$Gp)(g)}finally{await a()}}getInstalled(C,F=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(C??null,F)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.bb.scanUserExtensionAtLocation(C)}async install(C,F={}){this.F.trace("ExtensionManagementService#install",C.toString());const{location:a,cleanup:g}=await this.lb(C);try{const z=await(0,b.$Gp)(d.$jc(a.fsPath)),M=(0,i.$Fo)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,B.$So)(z.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,M,this.G.version));const W=(await this.I([{manifest:z,extension:a,options:F}])).find(({identifier:le})=>(0,i.$Ao)(le,{id:M}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$sp)(new Error(`Unknown error while installing extension ${M}`))}finally{await g()}}async installFromLocation(C,F){this.F.trace("ExtensionManagementService#installFromLocation",C.toString());const a=await this.bb.scanUserExtensionAtLocation(C);if(!a)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.ub([[a,void 0]],F),this.F.info("Successfully installed extension",a.identifier.id,F.toString()),a}async installExtensionsFromProfile(C,F,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",C,F.toString(),a.toString());const g=(await this.bb.scanExtensions(1,F)).filter(z=>C.some(M=>(0,i.$Ao)(M,z.identifier)));if(g.length){const z=await Promise.all(g.map(M=>this.bb.scanMetadata(M,F)));await this.ub(g.map((M,Q)=>[M,z[Q]]),a),this.F.info("Successfully installed extensions",g.map(M=>M.identifier.id),a.toString())}return g}async updateMetadata(C,F,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",C.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),C=await this.bb.updateMetadata(C,F,a),this.cb.invalidate(a),this.w.fire(C),C}async reinstallFromGallery(C){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const F=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:F,compatible:!0},R.CancellationToken.None);if(!a)throw new Error(p.localize(2,null));await this.bb.setUninstalled(C);try{await this.bb.removeUninstalledExtension(C)}catch(g){throw new Error(p.localize(3,null,(0,j.$Bi)(g)))}return this.installFromGallery(a)}ab(C,F,a,g){return this.bb.copyExtension(C,F,a,g)}copyExtensions(C,F){return this.bb.copyExtensions(C,F)}markAsUninstalled(...C){return this.bb.setUninstalled(...C)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(C){this.F.error(C)}}async download(C,F,a){const{location:g}=await this.db.download(C,F,!a);return g}async lb(C){if(C.scheme===I.Schemas.file)return{location:C,async cleanup(){}};this.F.trace("Downloading extension from",C.toString());const F=(0,f.$vg)(this.db.extensionsDownloadDir,(0,u.$eg)());return await this.hb.download(C,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.ib.del(F)}catch(g){this.F.error(g)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(C,F,a){if(m.URI.isUri(F))return new G(C,F,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const g=i.$Bo.create(F).toString();let z=this.eb.get(g);return z||(this.eb.set(g,z=new H(C,F,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(g))),z}$(C,F){return new Z(C,F.profileLocation,this.gb)}async pb(C){const F=async g=>{let z=await $.Promises.readdir(g);z=z.map(W=>d.$ic(g,W));const M=await Promise.all(z.map(W=>$.Promises.stat(W)));let Q=Promise.resolve([]);return M.forEach((W,le)=>{const ae=z[le];W.isFile()&&(Q=Q.then(me=>[...me,ae])),W.isDirectory()&&(Q=Q.then(me=>F(ae).then(de=>[...me,...de])))}),Q};return(await F(C.location.fsPath)).map(g=>({path:`extension/${d.$kc(C.location.fsPath,g)}`,localPath:g}))}async qb({added:C,removed:F}){if(F){const a=C&&this.D.extUri.isEqual(F.profileLocation,C.profileLocation)?F.extensions.filter(g=>C.extensions.every(z=>!(0,i.$Ao)(z,g))):F.extensions;for(const g of a)this.F.info("Extensions removed from another source",g.id,F.profileLocation.toString()),this.u.fire({identifier:g,profileLocation:F.profileLocation})}if(C){const g=(await this.bb.scanExtensions(1,C.profileLocation)).filter(z=>C.extensions.some(M=>(0,i.$Ao)(M,z.identifier)));this.s.fire(g.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,C.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:C.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(F=>this.rb.add(F)));const C=await this.ib.resolve(this.fb.userExtensionsLocation);for(const F of C.children??[])F.isDirectory&&this.rb.add(F.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(F=>this.tb(F)))}async tb(C){if(!C.affects(this.fb.userExtensionsLocation,1))return;const F=[];for(const a of C.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const g=await this.bb.scanUserExtensionAtLocation(a);g&&g.installedTimestamp===void 0&&(this.rb.add(a),F.push(g))}F.length&&(await this.ub(F.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(a=>a.identifier.id)))}async ub(C,F){const a=C.map(g=>g[0]);await this.vb(a),await this.gb.addExtensionsToProfile(C,F),this.s.fire(a.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:F})))}async vb(C){const F=await this.bb.getUninstalledExtensions();for(const a of C){const g=i.$Bo.create(a);F[g.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",g.id),await this.bb.setInstalled(g),this.F.info("Removed the extension from uninstalled list:",g.id))}}};e.$Kp=X,e.$Kp=X=pe([ie(0,t.$$n),ie(1,ue.$dl),ie(2,oe.$$i),ie(3,s.$Yh),ie(4,r.$zp),ie(5,n.$vp),ie(6,S.$Pn),ie(7,ee.$Ph),ie(8,_.$_j),ie(9,se.$qj),ie(10,ce.$Jk),ie(11,re.$Lk)],X);let T=class extends c.$Rc{constructor(C,F,a,g,z,M){super(),this.j=C,this.m=F,this.n=a,this.s=g,this.t=z,this.u=M,this.h=this.B(new v.$Nd),this.onExtract=this.h.event,this.c=(0,f.$vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$2g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(C,F){const a={includeInvalid:!0,profileLocation:F};let g=[];return C===null||C===0?g.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):C===1&&g.push(...await this.n.scanUserExtensions(a)),g=C!==null?g.filter(z=>z.type===C):g,Promise.all(g.map(z=>this.F(z)))}async scanAllUserExtensions(C){const F=await this.n.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(F.map(a=>this.F(a)))}async scanUserExtensionAtLocation(C){try{const F=await this.n.scanExistingExtension(C,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(C,F,a,g,z){const M=C.toString(),Q=m.URI.file(d.$ic(this.n.userExtensionsLocation.fsPath,`.${(0,u.$eg)()}`)),W=m.URI.file(d.$ic(this.n.userExtensionsLocation.fsPath,M));let le=await this.m.exists(W);if(le&&g){try{await this.y(C.id,W,"removeExisting")}catch{throw new t.$_n(p.localize(4,null,W.fsPath,C.id),t.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.u.trace(`Started extracting the extension from ${F} to ${W.fsPath}`),await(0,N.$op)(F,Q.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,C.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof N.$mp&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$_n(ae.message,me)}await this.n.updateMetadata(Q,a);try{this.u.trace(`Started renaming the extension from ${Q.fsPath} to ${W.fsPath}`),await this.C(Q.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.u.info(`Rename failed because of ${(0,A.$9)(ae)}. Deleted from extracted location`,Q),ae}this.h.fire(W)}catch(ae){try{await this.m.del(Q,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(C,F){return F?(await this.w(C,F))?.metadata:this.n.scanMetadata(C.location)}async w(C,F){return(await this.s.scanProfileExtensions(F)).find(g=>(0,i.$Ao)(g.identifier,C.identifier))}async updateMetadata(C,F,a){return a?await this.s.updateMetadata([[C,F]],a):await this.n.updateMetadata(C.location,F),this.D(C.location,C.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...C){const F=C.map(a=>i.$Bo.create(a));await this.z(a=>F.forEach(g=>{a[g.toString()]=!0,this.u.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(C){await this.z(F=>delete F[C.toString()])}async removeExtension(C,F){if(this.t.extUri.isEqualOrParent(C.location,this.n.userExtensionsLocation))return this.y(C.identifier.id,C.location,F)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.z(F=>delete F[i.$Bo.create(C).toString()])}async copyExtension(C,F,a,g){const z=await this.w(C,F),M=await this.w(C,a);return g={...z?.metadata,...g},M?await this.s.updateMetadata([[C,{...M.metadata,...g}]],a):await this.s.addExtensionsToProfile([[C,g]],a),this.D(C.location,C.type,a)}async copyExtensions(C,F){const a=await this.scanExtensions(1,C),g=await Promise.all(a.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,C)]));await this.s.addExtensionsToProfile(g,F)}async y(C,F,a){this.u.trace(`Deleting ${a} extension from disk`,C,F.fsPath);const g=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,h.$Ei)((0,u.$eg)()).toString(16)}${q}`);await this.C(F.fsPath,g.fsPath),await this.m.del(g,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,C,F.fsPath)}async z(C){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,_.$qk)(g)!==1)throw g}let a={};if(F)try{a=JSON.parse(F)}catch{}return C&&(C(a),Object.keys(a).length?await this.m.writeFile(this.c,D.$be.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(C,F){try{await $.Promises.rename(C,F,2*60*1e3)}catch(a){throw new t.$_n(a.message||p.localize(5,null,C,F),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(C,F,a){if(a){const z=(await this.n.scanUserExtensions({profileLocation:a})).find(M=>this.t.extUri.isEqual(M.location,C));if(z)return this.F(z)}else{const g=await this.n.scanExistingExtension(C,F,{includeInvalid:!0});if(g)return this.F(g)}throw new Error(p.localize(6,null,C.path))}async F(C){const F=await this.m.resolve(C.location);let a,g;return F.children&&(a=F.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,g=F.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:a,changelogUrl:g,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async G(){const C=await this.getUninstalledExtensions();if(Object.keys(C).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(C));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const z of F)C[i.$Bo.create(z).toString()]||a.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Go)(F,M=>M.identifier);await L.Promises.settled(z.map(async M=>{const Q=M.sort((W,le)=>E.rcompare(W.manifest.version,le.manifest.version))[0];a.has(Q.identifier.id.toLowerCase())||await this.j(await this.F(Q))}))}catch(z){this.u.error(z)}const g=F.filter(z=>z.metadata&&C[i.$Bo.create(z).toString()]);await Promise.allSettled(g.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let C;try{C=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,_.$qk)(F)!==1&&this.u.error(F);return}if(C?.children)try{await Promise.allSettled(C.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(a){(0,_.$qk)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Lp=T,e.$Lp=T=pe([ie(1,_.$_j),ie(2,r.$zp),ie(3,n.$vp),ie(4,ce.$Jk),ie(5,oe.$$i)],T);class U extends o.$tp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Ff)(this.options.operation)?this.l:this.options.operation}constructor(C,F,a,g,z,M,Q,W,le){super(),this.identifier=C,this.source=F,this.options=a,this.m=g,this.n=z,this.o=M,this.p=Q,this.q=W,this.s=le,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(C){const[F,a]=await this.x(C);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,a]],this.j),F}async u({zipPath:C,key:F,metadata:a},g,z){let M=await this.v(F);return M||(this.s.trace("Extracting extension...",F.id),M=await this.m.extractUserExtension(F,C,a,g,z),this.s.info("Extracting extension completed.",F.id)),M}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(g=>i.$Bo.create(g).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class H extends U{constructor(C,F,a,g,z,M,Q,W,le,ae){super(F.identifier,F,a,z,M,Q,W,le,ae),this.y=F,this.z=g}async x(C){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Q=>(0,i.$Ao)(Q.identifier,this.y.identifier));a&&(this.l=3);const g={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Ef)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,g),g];const{location:z,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:i.$Bo.create(this.y),metadata:g},!1,C),g]}catch(Q){try{await this.z.delete(z)}catch(W){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$9)(W))}throw Q}}async B(C){try{await(0,b.$Gp)(C)}catch(F){throw new t.$_n((0,o.$rp)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Mp=H;class G extends U{constructor(C,F,a,g,z,M,Q,W,le,ae){super({id:(0,i.$Fo)(C.publisher,C.name)},F,a,z,M,Q,W,le,ae),this.y=C,this.z=F,this.A=g}async h(C){const F=await super.h(C);return this.D(F,C),F}async x(C){const F=new i.$Bo(this.identifier,this.y.version),g=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Q=>(0,i.$Ao)(this.identifier,Q.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this.l=3,F.equals(new i.$Bo(g.identifier,g.manifest.version)))try{await this.m.removeExtension(g,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&E.gt(g.manifest.version,this.y.version)&&await this.m.setUninstalled(g);else{const Q=await this.v(F);if(Q)try{await this.m.removeExtension(Q,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$jc(this.z.fsPath),key:F,metadata:z},!0,C),z]}async D(C,F){try{let[a]=await this.A.getExtensions([{id:C.identifier.id,version:C.manifest.version}],F);if(a||([a]=await this.A.getExtensions([{id:C.identifier.id}],F)),a){const g={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(C,g,this.options.profileLocation)}}catch{}}}class Z extends o.$tp{constructor(C,F,a){super(),this.extension=C,this.j=F,this.k=a}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(te[163],ne([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;let E=class extends I.$Uo{constructor($,N,p,S){super(S),this.m=$,this.n=N,this.r=p,this.s(),this.B($.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,N){const{f:p,g:S}=this;let s;try{s=await(0,c.$Ul)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,j.$9)(i)))}const o={...process.env,...s},t=$.agent?$.agent:await(0,d.$Yq)($.url||"",o,{proxyUrl:p,strictSSL:S});return $.agent=t,$.strictSSL=S,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>m($,N))}async resolveProxy($){}};e.$Zq=E,e.$Zq=E=pe([ie(0,v.$ki),ie(1,h.$Yh),ie(2,P.$$i),ie(3,P.$_i)],E);async function y(u){return((0,L.parse)(u.url).protocol==="https:"?await new Promise((p,S)=>{J(["https"],p,S)}):await new Promise((p,S)=>{J(["http"],p,S)})).request}async function m(u,$){return D.Promises.withAsyncBody(async(N,p)=>{const S=(0,L.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await y(u),o={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,A.$Ef)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(o.auth=u.user+":"+u.password);const t=s(o,i=>{const n=(0,A.$Cf)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)m({...u,url:i.headers.location,followRedirects:n-1},$).then(N,p);else{let r=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),N({res:i,stream:(0,R.$qe)(r)})}});t.on("error",p),u.timeout&&t.setTimeout(u.timeout),u.isChromiumNetwork&&t.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&t.write(u.data),t.end(),$.onCancellationRequested(()=>{t.abort(),p(new j.$4)})})}e.$1q=m}),define(te[179],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,D,R,j,A,v,h,c,P,I,d,f,E,y,m,u,$,N,p,S,s,o,t,i,n,r,l,k,b,w,O,B,_,ee,oe,se,ue,ce,re,q,X,T,U,H,G,Z,K,C,F,a,g,z,M,Q,W,le,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends A.$Rc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(ee.$$i),Ce=be.get(r.$_j),V=be.get(u.$Yh),Y=be.get(g.$Lk);Se.info("CLI main",this.b),this.g(Se),await this.h(V,Ce,Y,he),await Promise.all(we.map(x=>{(0,D.$Lg)(x.flush(),1e3)}))})}async f(){const he=new O.$Oh,we={_serviceBrand:void 0,...ce.default};he.set(re.$qj,we);const be=new $.$km(this.b,we);he.set(u.$Yh,be),await Promise.all([be.appSettingsHome.with({scheme:v.Schemas.file}).fsPath,be.extensionsPath].map(je=>je?d.Promises.mkdir(je,{recursive:!0}):void 0));const Se=new le.$HN((0,ee.$mj)(be),be.logsHome);he.set(ee.$_i,Se);const Ce=this.B(Se.createLogger("cli",{name:(0,ae.localize)(0,null)})),V=[];Se.getLogLevel()===ee.LogLevel.Trace&&V.push(new ee.$gj(Se.getLogLevel()));const Y=this.B(new W.$RN(Ce,V));he.set(ee.$$i,Y);const x=this.B(new l.$Op(Y));he.set(r.$_j,x);const $e=this.B(new k.$bq(Y));x.registerProvider(v.Schemas.file,$e);const ye=new a.$Ar(x);he.set(F.$Jk,ye);const Re=new T.$LN(1,be,Y,x),Pe=new z.$NN(Re,ye,be,x,Y);he.set(g.$Lk,Pe),x.registerProvider(v.Schemas.vscodeUserData,new me.$58b(v.Schemas.file,$e,v.Schemas.vscodeUserData,Pe,ye,Y));const Le=c.$j&&we.win32RegValueName?this.B(new ue.$38b(Y,we.win32RegValueName)):be.policyFile?this.B(new oe.$48b(be.policyFile,x,Y)):new se.$ln;he.set(se.$jn,Le);const Ie=this.B(new E.$Ln(Pe.defaultProfile.settingsResource,x,Le,Y));he.set(f.$ki,Ie),await Promise.all([Re.init(),Ie.initialize()]);let Ae;try{Ae=await(0,M.$G8b)(Re,Y)}catch(je){je.code!=="ENOENT"&&Y.error(je)}const Ue=await(0,M.$H8b)(Re,Y);Pe.init(),he.set(F.$Jk,new a.$Ar(x));const Ne=new X.$Zq(Ie,be,Y,Se);he.set(q.$To,Ne),he.set(y.$Pn,new b.$Nh(m.$7N,void 0,!0)),he.set(o.$vp,new b.$Nh(Q.$QN,void 0,!0)),he.set(t.$zp,new b.$Nh(n.$D8b,void 0,!0)),he.set(S.$fp,new b.$Nh(S.$gp,void 0,!0)),he.set(i.$Jp,new b.$Nh(i.$Kp,void 0,!0)),he.set(p.$$n,new b.$Nh(N.$ep,void 0,!0)),he.set(B.$Tq,new b.$Nh(_.$Vq,void 0,!1));const De=[],ze=(0,Z.$xo)(we,Ie);if((0,Z.$so)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&De.push(new K.$FN(Ne,ze,"monacoworkbench",null,we.aiConfig.ariaKey));const je={appenders:De,sendErrorTelemetry:!1,commonProperties:(0,U.$io)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,Ue,ze),piiPaths:(0,Z.$yo)(be)};he.set(H.$dl,new b.$Nh(G.$2q,[je],!1))}else he.set(H.$dl,Z.$mo);return[new w.$eq(he),De]}g(he){(0,j.setUnexpectedErrorHandler)(we=>{const be=(0,R.$Bi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,j.$Y)(we)||(0,j.$Z)(we)}),process.on("unhandledRejection",we=>(0,j.$Z)(we))}async h(he,we,be,Se){let Ce;if(he.args.profile&&(Ce=be.profiles.find(Y=>Y.name===he.args.profile),!Ce))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Ce??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(s.$hp,new ee.$gj(ee.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Y={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return Se.createInstance(s.$hp,new ee.$gj(ee.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Y,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(s.$hp,new ee.$gj(ee.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return Se.createInstance(s.$hp,new ee.$gj(ee.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.$o9b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?I.URI.file((0,h.$hc)(we)?we:(0,h.$ic)((0,P.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec3f042f9d6b042b9b2e83082ca53f18fee92070/core/vs/code/node/cliProcessMain.js.map
