/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/stopwatch","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Re=function(pe){for(var e=[],E=0,L=pe.length;E<L;E++)e[E]=Ae[pe[E]];return e};define(Ae[67],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function E(R){return($,D,g)=>{let A=null,S=null;if(typeof g.value=="function"?(A="value",S=g.value):typeof g.get=="function"&&(A="get",S=g.get),!S)throw new Error("not supported");g[A]=R(S,D)}}function L(R,$,D){let g=null,A=null;if(typeof D.value=="function"?(g="value",A=D.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",A=D.get),!A)throw new Error("not supported");const S=`$memoize$${$}`;D[g]=function(...o){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,o)}),this[S]}}e.$ih=L;function P(R,$,D){return E((g,A)=>{const S=`$debounce$${A}`,o=`$debounce$result$${A}`;return function(...v){this[o]||(this[o]=D?D():void 0),clearTimeout(this[S]),$&&(this[o]=$(this[o],...v),v=[this[o]]),this[S]=setTimeout(()=>{g.apply(this,v),this[o]=D?D():void 0},R)}})}e.$jh=P;function M(R,$,D){return E((g,A)=>{const S=`$throttle$timer$${A}`,o=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...f){if(this[o]||(this[o]=D?D():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),$&&(this[o]=$(this[o],...f)),this[p])return;const t=this[v]+R;t<=Date.now()?(this[v]=Date.now(),g.apply(this,[this[o]]),this[o]=D?D():void 0):(this[p]=!0,this[S]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),g.apply(this,[this[o]]),this[o]=D?D():void 0},t-Date.now()))}})}e.$kh=M}),define(Ae[89],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=void 0;class E{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$zM=E,e.$AM=new E("id#")}),define(Ae[119],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var P;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(r,s=!1){let c=0;const h=r.length;let b="",m=0,I=16,k=0;function d(z){let F=0,O=0;for(;F<z;){const x=r.charCodeAt(c);if(x>=48&&x<=57)O=O*16+x-48;else if(x>=65&&x<=70)O=O*16+x-65+10;else if(x>=97&&x<=102)O=O*16+x-97+10;else break;c++,F++}return F<z&&(O=-1),O}function w(z){c=z,b="",m=0,I=16,k=0}function y(){const z=c;if(r.charCodeAt(c)===48)c++;else for(c++;c<r.length&&g(r.charCodeAt(c));)c++;if(c<r.length&&r.charCodeAt(c)===46)if(c++,c<r.length&&g(r.charCodeAt(c)))for(c++;c<r.length&&g(r.charCodeAt(c));)c++;else return k=3,r.substring(z,c);let F=c;if(c<r.length&&(r.charCodeAt(c)===69||r.charCodeAt(c)===101))if(c++,(c<r.length&&r.charCodeAt(c)===43||r.charCodeAt(c)===45)&&c++,c<r.length&&g(r.charCodeAt(c))){for(c++;c<r.length&&g(r.charCodeAt(c));)c++;F=c}else k=3;return r.substring(z,F)}function C(){let z="",F=c;for(;;){if(c>=h){z+=r.substring(F,c),k=2;break}const O=r.charCodeAt(c);if(O===34){z+=r.substring(F,c),c++;break}if(O===92){if(z+=r.substring(F,c),c++,c>=h){k=2;break}switch(r.charCodeAt(c++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Z=d(4);Z>=0?z+=String.fromCharCode(Z):k=4;break}default:k=5}F=c;continue}if(O>=0&&O<=31)if(D(O)){z+=r.substring(F,c),k=2;break}else k=6;c++}return z}function B(){if(b="",k=0,m=c,c>=h)return m=h,I=17;let z=r.charCodeAt(c);if($(z)){do c++,b+=String.fromCharCode(z),z=r.charCodeAt(c);while($(z));return I=15}if(D(z))return c++,b+=String.fromCharCode(z),z===13&&r.charCodeAt(c)===10&&(c++,b+=`
`),I=14;switch(z){case 123:return c++,I=1;case 125:return c++,I=2;case 91:return c++,I=3;case 93:return c++,I=4;case 58:return c++,I=6;case 44:return c++,I=5;case 34:return c++,b=C(),I=10;case 47:{const F=c-1;if(r.charCodeAt(c+1)===47){for(c+=2;c<h&&!D(r.charCodeAt(c));)c++;return b=r.substring(F,c),I=12}if(r.charCodeAt(c+1)===42){c+=2;const O=h-1;let x=!1;for(;c<O;){if(r.charCodeAt(c)===42&&r.charCodeAt(c+1)===47){c+=2,x=!0;break}c++}return x||(c++,k=1),b=r.substring(F,c),I=13}return b+=String.fromCharCode(z),c++,I=16}case 45:if(b+=String.fromCharCode(z),c++,c===h||!g(r.charCodeAt(c)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=y(),I=11;default:for(;c<h&&j(z);)c++,z=r.charCodeAt(c);if(m!==c){switch(b=r.substring(m,c),b){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return b+=String.fromCharCode(z),c++,I=16}}function j(z){if($(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let z;do z=B();while(z>=12&&z<=15);return z}return{setPosition:w,getPosition:()=>c,scan:s?V:B,getToken:()=>I,getTokenValue:()=>b,getTokenOffset:()=>m,getTokenLength:()=>c-m,getTokenError:()=>k}}e.$Vm=R;function $(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function g(r){return r>=48&&r<=57}var A;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(A||(A={}));function S(r,s){const c=[],h=new Object;let b;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function k(d,w,y,C){m.value=d,m.offset=w,m.length=y,m.type=C,m.colonOffset=void 0,b=m}try{u(r,{onObjectBegin:(d,w)=>{if(s<=d)throw h;b=void 0,I=s>d,c.push("")},onObjectProperty:(d,w,y)=>{if(s<w||(k(d,w,y,"property"),c[c.length-1]=d,s<=w+y))throw h},onObjectEnd:(d,w)=>{if(s<=d)throw h;b=void 0,c.pop()},onArrayBegin:(d,w)=>{if(s<=d)throw h;b=void 0,c.push(0)},onArrayEnd:(d,w)=>{if(s<=d)throw h;b=void 0,c.pop()},onLiteralValue:(d,w,y)=>{if(s<w||(k(d,w,y,l(d)),s<=w+y))throw h},onSeparator:(d,w,y)=>{if(s<=w)throw h;if(d===":"&&b&&b.type==="property")b.colonOffset=w,I=!1,b=void 0;else if(d===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(I=!0,c[c.length-1]=""),b=void 0}}})}catch(d){if(d!==h)throw d}return{path:c,previousNode:b,isAtPropertyKey:I,matches:d=>{let w=0;for(let y=0;w<d.length&&y<c.length;y++)if(d[w]===c[y]||d[w]==="*")w++;else if(d[w]!=="**")return!1;return w===d.length}}}e.$Wm=S;function o(r,s=[],c=M.DEFAULT){let h=null,b=[];const m=[];function I(d){Array.isArray(b)?b.push(d):h!==null&&(b[h]=d)}return u(r,{onObjectBegin:()=>{const d={};I(d),m.push(b),b=d,h=null},onObjectProperty:d=>{h=d},onObjectEnd:()=>{b=m.pop()},onArrayBegin:()=>{const d=[];I(d),m.push(b),b=d,h=null},onArrayEnd:()=>{b=m.pop()},onLiteralValue:I,onError:(d,w,y)=>{s.push({error:d,offset:w,length:y})}},c),b[0]}e.$Xm=o;function v(r,s=[],c=M.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(d){h.type==="property"&&(h.length=d-h.offset,h=h.parent)}function m(d){return h.children.push(d),d}u(r,{onObjectBegin:d=>{h=m({type:"object",offset:d,length:-1,parent:h,children:[]})},onObjectProperty:(d,w,y)=>{h=m({type:"property",offset:w,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:d,offset:w,length:y,parent:h})},onObjectEnd:(d,w)=>{h.length=d+w-h.offset,h=h.parent,b(d+w)},onArrayBegin:(d,w)=>{h=m({type:"array",offset:d,length:-1,parent:h,children:[]})},onArrayEnd:(d,w)=>{h.length=d+w-h.offset,h=h.parent,b(d+w)},onLiteralValue:(d,w,y)=>{m({type:l(d),offset:w,length:y,parent:h,value:d}),b(w+y)},onSeparator:(d,w,y)=>{h.type==="property"&&(d===":"?h.colonOffset=w:d===","&&b(w))},onError:(d,w,y)=>{s.push({error:d,offset:w,length:y})}},c);const k=h.children[0];return k&&delete k.parent,k}e.$Ym=v;function p(r,s){if(!r)return;let c=r;for(const h of s)if(typeof h=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let b=!1;for(const m of c.children)if(Array.isArray(m.children)&&m.children[0].value===h){c=m.children[1],b=!0;break}if(!b)return}else{const b=h;if(c.type!=="array"||b<0||!Array.isArray(c.children)||b>=c.children.length)return;c=c.children[b]}return c}e.$Zm=p;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const c=r.parent.children[0].value;s.push(c)}else if(r.parent.type==="array"){const c=r.parent.children.indexOf(r);c!==-1&&s.push(c)}return s}e.$1m=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const c of r.children){const h=c.children[1];h&&(s[c.children[0].value]=t(h))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$2m=t;function i(r,s,c=!1){return s>=r.offset&&s<r.offset+r.length||c&&s===r.offset+r.length}e.$3m=i;function n(r,s,c=!1){if(i(r,s,c)){const h=r.children;if(Array.isArray(h))for(let b=0;b<h.length&&h[b].offset<=s;b++){const m=n(h[b],s,c);if(m)return m}return r}}e.$4m=n;function u(r,s,c=M.DEFAULT){const h=R(r,!1);function b(oe){return oe?()=>oe(h.getTokenOffset(),h.getTokenLength()):()=>!0}function m(oe){return oe?ce=>oe(ce,h.getTokenOffset(),h.getTokenLength()):()=>!0}const I=b(s.onObjectBegin),k=m(s.onObjectProperty),d=b(s.onObjectEnd),w=b(s.onArrayBegin),y=b(s.onArrayEnd),C=m(s.onLiteralValue),B=m(s.onSeparator),j=b(s.onComment),V=m(s.onError),z=c&&c.disallowComments,F=c&&c.allowTrailingComma;function O(){for(;;){const oe=h.scan();switch(h.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(oe){case 12:case 13:z?x(10):j();break;case 16:x(1);break;case 15:case 14:break;default:return oe}}}function x(oe,ce=[],ve=[]){if(V(oe),ce.length+ve.length>0){let _=h.getToken();for(;_!==17;){if(ce.indexOf(_)!==-1){O();break}else if(ve.indexOf(_)!==-1)break;_=O()}}}function Z(oe){const ce=h.getTokenValue();return oe?C(ce):k(ce),O(),!0}function De(){switch(h.getToken()){case 11:{let oe=0;try{oe=JSON.parse(h.getTokenValue()),typeof oe!="number"&&(x(2),oe=0)}catch{x(2)}C(oe);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return O(),!0}function ke(){return h.getToken()!==10?(x(3,[],[2,5]),!1):(Z(!1),h.getToken()===6?(B(":"),O(),be()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function Ie(){I(),O();let oe=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(oe||x(4,[],[]),B(","),O(),h.getToken()===2&&F)break}else oe&&x(6,[],[]);ke()||x(4,[],[2,5]),oe=!0}return d(),h.getToken()!==2?x(7,[2],[]):O(),!0}function de(){w(),O();let oe=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(oe||x(4,[],[]),B(","),O(),h.getToken()===4&&F)break}else oe&&x(6,[],[]);be()||x(4,[],[4,5]),oe=!0}return y(),h.getToken()!==4?x(8,[4],[]):O(),!0}function be(){switch(h.getToken()){case 3:return de();case 1:return Ie();case 10:return Z(!0);default:return De()}}return O(),h.getToken()===17?c.allowEmptyContent?!0:(x(4,[],[]),!1):be()?(h.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$5m=u;function a(r,s){const c=R(r),h=[];let b,m=0,I;do switch(I=c.getPosition(),b=c.scan(),b){case 12:case 13:case 17:m!==I&&h.push(r.substring(m,I)),s!==void 0&&h.push(c.getTokenValue().replace(/[^\r\n]/g,s)),m=c.getPosition();break}while(b!==17);return h.join("")}e.$6m=a;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$7m=l}),function(pe,e){typeof define=="function"&&define.amd?define(Ae[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(he,le){for(var ye=0;ye<le.length;ye++){var ee=le[ye];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(he,ee.key,ee)}}function E(he,le,ye){return le&&e(he.prototype,le),ye&&e(he,ye),Object.defineProperty(he,"prototype",{writable:!1}),he}function L(he,le){if(he){if(typeof he=="string")return P(he,le);var ye=Object.prototype.toString.call(he).slice(8,-1);if(ye==="Object"&&he.constructor&&(ye=he.constructor.name),ye==="Map"||ye==="Set")return Array.from(he);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return P(he,le)}}function P(he,le){(le==null||le>he.length)&&(le=he.length);for(var ye=0,ee=new Array(le);ye<le;ye++)ee[ye]=he[ye];return ee}function M(he,le){var ye=typeof Symbol<"u"&&he[Symbol.iterator]||he["@@iterator"];if(ye)return(ye=ye.call(he)).next.bind(ye);if(Array.isArray(he)||(ye=L(he))||le&&he&&typeof he.length=="number"){ye&&(he=ye);var ee=0;return function(){return ee>=he.length?{done:!0}:{done:!1,value:he[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=R();function $(he){pe.defaults=he}var D=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(le){return o[le]};function p(he,le){if(le){if(D.test(he))return he.replace(g,v)}else if(A.test(he))return he.replace(S,v);return he}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(he){return he.replace(f,function(le,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var i=/(^|[^\[])\^/g;function n(he,le){he=typeof he=="string"?he:he.source,le=le||"";var ye={replace:function(fe,ie){return ie=ie.source||ie,ie=ie.replace(i,"$1"),he=he.replace(fe,ie),ye},getRegex:function(){return new RegExp(he,le)}};return ye}var u=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(he,le,ye){if(he){var ee;try{ee=decodeURIComponent(t(ye)).replace(u,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}le&&!a.test(ye)&&(ye=b(le,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var r={},s=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(he,le){r[" "+he]||(s.test(he)?r[" "+he]=he+"/":r[" "+he]=d(he,"/",!0)),he=r[" "+he];var ye=he.indexOf(":")===-1;return le.substring(0,2)==="//"?ye?le:he.replace(c,"$1")+le:le.charAt(0)==="/"?ye?le:he.replace(h,"$1")+le:he+le}var m={exec:function(){}};function I(he){for(var le=1,ye,ee;le<arguments.length;le++){ye=arguments[le];for(ee in ye)Object.prototype.hasOwnProperty.call(ye,ee)&&(he[ee]=ye[ee])}return he}function k(he,le){var ye=he.replace(/\|/g,function(ie,se,me){for(var Pe=!1,T=se;--T>=0&&me[T]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ee=ye.split(/ \|/),fe=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>le)ee.splice(le);else for(;ee.length<le;)ee.push("");for(;fe<ee.length;fe++)ee[fe]=ee[fe].trim().replace(/\\\|/g,"|");return ee}function d(he,le,ye){var ee=he.length;if(ee===0)return"";for(var fe=0;fe<ee;){var ie=he.charAt(ee-fe-1);if(ie===le&&!ye)fe++;else if(ie!==le&&ye)fe++;else break}return he.slice(0,ee-fe)}function w(he,le){if(he.indexOf(le[1])===-1)return-1;for(var ye=he.length,ee=0,fe=0;fe<ye;fe++)if(he[fe]==="\\")fe++;else if(he[fe]===le[0])ee++;else if(he[fe]===le[1]&&(ee--,ee<0))return fe;return-1}function y(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(he,le){if(le<1)return"";for(var ye="";le>1;)le&1&&(ye+=he),le>>=1,he+=he;return ye+he}function B(he,le,ye,ee){var fe=le.href,ie=le.title?p(le.title):null,se=he[1].replace(/\\([\[\]])/g,"$1");if(he[0].charAt(0)!=="!"){ee.state.inLink=!0;var me={type:"link",raw:ye,href:fe,title:ie,text:se,tokens:ee.inlineTokens(se)};return ee.state.inLink=!1,me}return{type:"image",raw:ye,href:fe,title:ie,text:p(se)}}function j(he,le){var ye=he.match(/^(\s+)(?:```)/);if(ye===null)return le;var ee=ye[1];return le.split(`
`).map(function(fe){var ie=fe.match(/^\s+/);if(ie===null)return fe;var se=ie[0];return se.length>=ee.length?fe.slice(ee.length):fe}).join(`
`)}var V=function(){function he(ye){this.options=ye||pe.defaults}var le=he.prototype;return le.space=function(ee){var fe=this.rules.block.newline.exec(ee);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},le.code=function(ee){var fe=this.rules.block.code.exec(ee);if(fe){var ie=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:d(ie,`
`)}}},le.fences=function(ee){var fe=this.rules.block.fences.exec(ee);if(fe){var ie=fe[0],se=j(ie,fe[3]||"");return{type:"code",raw:ie,lang:fe[2]?fe[2].trim():fe[2],text:se}}},le.heading=function(ee){var fe=this.rules.block.heading.exec(ee);if(fe){var ie=fe[2].trim();if(/#$/.test(ie)){var se=d(ie,"#");(this.options.pedantic||!se||/ $/.test(se))&&(ie=se.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:ie,tokens:this.lexer.inline(ie)}}},le.hr=function(ee){var fe=this.rules.block.hr.exec(ee);if(fe)return{type:"hr",raw:fe[0]}},le.blockquote=function(ee){var fe=this.rules.block.blockquote.exec(ee);if(fe){var ie=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},le.list=function(ee){var fe=this.rules.block.list.exec(ee);if(fe){var ie,se,me,Pe,T,q,G,Q,K,Y,ue,Ne,Be=fe[1].trim(),Je=Be.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Je?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Je?Be:"[*+-]");for(var _e=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(Ne=!1,!(!(fe=_e.exec(ee))||this.rules.block.hr.test(ee)));){if(ie=fe[0],ee=ee.substring(ie.length),Q=fe[2].split(`
`,1)[0],K=ee.split(`
`,1)[0],this.options.pedantic?(Pe=2,ue=Q.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ue=Q.slice(Pe),Pe+=fe[1].length),q=!1,!Q&&/^ *$/.test(K)&&(ie+=K+`
`,ee=ee.substring(K.length+1),Ne=!0),!Ne)for(var Ye=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ee&&(Y=ee.split(`
`,1)[0],Q=Y,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Ye.test(Q)||xe.test(ee)));){if(Q.search(/[^ ]/)>=Pe||!Q.trim())ue+=`
`+Q.slice(Pe);else if(!q)ue+=`
`+Q;else break;!q&&!Q.trim()&&(q=!0),ie+=Y+`
`,ee=ee.substring(Y.length+1)}Ge.loose||(G?Ge.loose=!0:/\n *\n *$/.test(ie)&&(G=!0)),this.options.gfm&&(se=/^\[[ xX]\] /.exec(ue),se&&(me=se[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ie,task:!!se,checked:me,loose:!1,text:ue}),Ge.raw+=ie}Ge.items[Ge.items.length-1].raw=ie.trimRight(),Ge.items[Ge.items.length-1].text=ue.trimRight(),Ge.raw=Ge.raw.trimRight();var Ue=Ge.items.length;for(T=0;T<Ue;T++){this.lexer.state.top=!1,Ge.items[T].tokens=this.lexer.blockTokens(Ge.items[T].text,[]);var ut=Ge.items[T].tokens.filter(function(J){return J.type==="space"}),X=ut.every(function(J){for(var Ee=J.raw.split(""),je=0,Oe=M(Ee),Ze;!(Ze=Oe()).done;){var nt=Ze.value;if(nt===`
`&&(je+=1),je>1)return!0}return!1});!Ge.loose&&ut.length&&X&&(Ge.loose=!0,Ge.items[T].loose=!0)}return Ge}},le.html=function(ee){var fe=this.rules.block.html.exec(ee);if(fe){var ie={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var se=this.options.sanitizer?this.options.sanitizer(fe[0]):p(fe[0]);ie.type="paragraph",ie.text=se,ie.tokens=this.lexer.inline(se)}return ie}},le.def=function(ee){var fe=this.rules.block.def.exec(ee);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var ie=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:fe[0],href:fe[2],title:fe[3]}}},le.table=function(ee){var fe=this.rules.block.table.exec(ee);if(fe){var ie={type:"table",header:k(fe[1]).map(function(G){return{text:G}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=fe[0];var se=ie.align.length,me,Pe,T,q;for(me=0;me<se;me++)/^ *-+: *$/.test(ie.align[me])?ie.align[me]="right":/^ *:-+: *$/.test(ie.align[me])?ie.align[me]="center":/^ *:-+ *$/.test(ie.align[me])?ie.align[me]="left":ie.align[me]=null;for(se=ie.rows.length,me=0;me<se;me++)ie.rows[me]=k(ie.rows[me],ie.header.length).map(function(G){return{text:G}});for(se=ie.header.length,Pe=0;Pe<se;Pe++)ie.header[Pe].tokens=this.lexer.inline(ie.header[Pe].text);for(se=ie.rows.length,Pe=0;Pe<se;Pe++)for(q=ie.rows[Pe],T=0;T<q.length;T++)q[T].tokens=this.lexer.inline(q[T].text);return ie}}},le.lheading=function(ee){var fe=this.rules.block.lheading.exec(ee);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},le.paragraph=function(ee){var fe=this.rules.block.paragraph.exec(ee);if(fe){var ie=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:ie,tokens:this.lexer.inline(ie)}}},le.text=function(ee){var fe=this.rules.block.text.exec(ee);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},le.escape=function(ee){var fe=this.rules.inline.escape.exec(ee);if(fe)return{type:"escape",raw:fe[0],text:p(fe[1])}},le.tag=function(ee){var fe=this.rules.inline.tag.exec(ee);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):p(fe[0]):fe[0]}},le.link=function(ee){var fe=this.rules.inline.link.exec(ee);if(fe){var ie=fe[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var se=d(ie.slice(0,-1),"\\");if((ie.length-se.length)%2===0)return}else{var me=w(fe[2],"()");if(me>-1){var Pe=fe[0].indexOf("!")===0?5:4,T=Pe+fe[1].length+me;fe[2]=fe[2].substring(0,me),fe[0]=fe[0].substring(0,T).trim(),fe[3]=""}}var q=fe[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);Q&&(q=Q[1],G=Q[3])}else G=fe[3]?fe[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(ie)?q=q.slice(1):q=q.slice(1,-1)),B(fe,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},le.reflink=function(ee,fe){var ie;if((ie=this.rules.inline.reflink.exec(ee))||(ie=this.rules.inline.nolink.exec(ee))){var se=(ie[2]||ie[1]).replace(/\s+/g," ");if(se=fe[se.toLowerCase()],!se||!se.href){var me=ie[0].charAt(0);return{type:"text",raw:me,text:me}}return B(ie,se,ie[0],this.lexer)}},le.emStrong=function(ee,fe,ie){ie===void 0&&(ie="");var se=this.rules.inline.emStrong.lDelim.exec(ee);if(se&&!(se[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=se[1]||se[2]||"";if(!me||me&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Pe=se[0].length-1,T,q,G=Pe,Q=0,K=se[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(K.lastIndex=0,fe=fe.slice(-1*ee.length+Pe);(se=K.exec(fe))!=null;)if(T=se[1]||se[2]||se[3]||se[4]||se[5]||se[6],!!T){if(q=T.length,se[3]||se[4]){G+=q;continue}else if((se[5]||se[6])&&Pe%3&&!((Pe+q)%3)){Q+=q;continue}if(G-=q,!(G>0)){if(q=Math.min(q,q+G+Q),Math.min(Pe,q)%2){var Y=ee.slice(1,Pe+se.index+q);return{type:"em",raw:ee.slice(0,Pe+se.index+q+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var ue=ee.slice(2,Pe+se.index+q-1);return{type:"strong",raw:ee.slice(0,Pe+se.index+q+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},le.codespan=function(ee){var fe=this.rules.inline.code.exec(ee);if(fe){var ie=fe[2].replace(/\n/g," "),se=/[^ ]/.test(ie),me=/^ /.test(ie)&&/ $/.test(ie);return se&&me&&(ie=ie.substring(1,ie.length-1)),ie=p(ie,!0),{type:"codespan",raw:fe[0],text:ie}}},le.br=function(ee){var fe=this.rules.inline.br.exec(ee);if(fe)return{type:"br",raw:fe[0]}},le.del=function(ee){var fe=this.rules.inline.del.exec(ee);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},le.autolink=function(ee,fe){var ie=this.rules.inline.autolink.exec(ee);if(ie){var se,me;return ie[2]==="@"?(se=p(this.options.mangle?fe(ie[1]):ie[1]),me="mailto:"+se):(se=p(ie[1]),me=se),{type:"link",raw:ie[0],text:se,href:me,tokens:[{type:"text",raw:se,text:se}]}}},le.url=function(ee,fe){var ie;if(ie=this.rules.inline.url.exec(ee)){var se,me;if(ie[2]==="@")se=p(this.options.mangle?fe(ie[0]):ie[0]),me="mailto:"+se;else{var Pe;do Pe=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Pe!==ie[0]);se=p(ie[0]),ie[1]==="www."?me="http://"+se:me=se}return{type:"link",raw:ie[0],text:se,href:me,tokens:[{type:"text",raw:se,text:se}]}}},le.inlineText=function(ee,fe){var ie=this.rules.inline.text.exec(ee);if(ie){var se;return this.lexer.state.inRawBlock?se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):p(ie[0]):ie[0]:se=p(this.options.smartypants?fe(ie[0]):ie[0]),{type:"text",raw:ie[0],text:se}}},he}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=I({},z),z.gfm=I({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=I({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=n(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=n(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=n(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=n(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=n(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=n(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=n(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=n(F.reflink).replace("label",F._label).replace("ref",z._label).getRegex(),F.nolink=n(F.nolink).replace("ref",z._label).getRegex(),F.reflinkSearch=n(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=I({},F),F.pedantic=I({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=I({},F.normal,{escape:n(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=n(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=I({},F.gfm,{br:n(F.br).replace("{2,}","*").getRegex(),text:n(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(he){var le="",ye,ee,fe=he.length;for(ye=0;ye<fe;ye++)ee=he.charCodeAt(ye),Math.random()>.5&&(ee="x"+ee.toString(16)),le+="&#"+ee+";";return le}var Z=function(){function he(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||pe.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:z.normal,inline:F.normal};this.options.pedantic?(ee.block=z.pedantic,ee.inline=F.pedantic):this.options.gfm&&(ee.block=z.gfm,this.options.breaks?ee.inline=F.breaks:ee.inline=F.gfm),this.tokenizer.rules=ee}he.lex=function(ee,fe){var ie=new he(fe);return ie.lex(ee)},he.lexInline=function(ee,fe){var ie=new he(fe);return ie.inlineTokens(ee)};var le=he.prototype;return le.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},le.blockTokens=function(ee,fe){var ie=this;fe===void 0&&(fe=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(G,Q,K){return Q+"    ".repeat(K.length)});for(var se,me,Pe,T;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(se=G.call({lexer:ie},ee,fe))?(ee=ee.substring(se.raw.length),fe.push(se),!0):!1}))){if(se=this.tokenizer.space(ee)){ee=ee.substring(se.raw.length),se.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(se);continue}if(se=this.tokenizer.code(ee)){ee=ee.substring(se.raw.length),me=fe[fe.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+se.raw,me.text+=`
`+se.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):fe.push(se);continue}if(se=this.tokenizer.fences(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.heading(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.hr(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.blockquote(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.list(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.html(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.def(ee)){ee=ee.substring(se.raw.length),me=fe[fe.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+se.raw,me.text+=`
`+se.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[se.tag]||(this.tokens.links[se.tag]={href:se.href,title:se.title});continue}if(se=this.tokenizer.table(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.lheading(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(Pe=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=ee.slice(1),K=void 0;ie.options.extensions.startBlock.forEach(function(Y){K=Y.call({lexer:this},Q),typeof K=="number"&&K>=0&&(G=Math.min(G,K))}),G<1/0&&G>=0&&(Pe=ee.substring(0,G+1))}(),this.state.top&&(se=this.tokenizer.paragraph(Pe))){me=fe[fe.length-1],T&&me.type==="paragraph"?(me.raw+=`
`+se.raw,me.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):fe.push(se),T=Pe.length!==ee.length,ee=ee.substring(se.raw.length);continue}if(se=this.tokenizer.text(ee)){ee=ee.substring(se.raw.length),me=fe[fe.length-1],me&&me.type==="text"?(me.raw+=`
`+se.raw,me.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):fe.push(se);continue}if(ee){var q="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,fe},le.inline=function(ee,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ee,tokens:fe}),fe},le.inlineTokens=function(ee,fe){var ie=this;fe===void 0&&(fe=[]);var se,me,Pe,T=ee,q,G,Q;if(this.tokens.links){var K=Object.keys(this.tokens.links);if(K.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)K.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,q.index)+"["+C("a",q[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,q.index)+"["+C("a",q[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,q.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(se=ue.call({lexer:ie},ee,fe))?(ee=ee.substring(se.raw.length),fe.push(se),!0):!1}))){if(se=this.tokenizer.escape(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.tag(ee)){ee=ee.substring(se.raw.length),me=fe[fe.length-1],me&&se.type==="text"&&me.type==="text"?(me.raw+=se.raw,me.text+=se.text):fe.push(se);continue}if(se=this.tokenizer.link(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(se.raw.length),me=fe[fe.length-1],me&&se.type==="text"&&me.type==="text"?(me.raw+=se.raw,me.text+=se.text):fe.push(se);continue}if(se=this.tokenizer.emStrong(ee,T,Q)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.codespan(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.br(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.del(ee)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(se=this.tokenizer.autolink(ee,x)){ee=ee.substring(se.raw.length),fe.push(se);continue}if(!this.state.inLink&&(se=this.tokenizer.url(ee,x))){ee=ee.substring(se.raw.length),fe.push(se);continue}if(Pe=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Ne=ee.slice(1),Be=void 0;ie.options.extensions.startInline.forEach(function(Je){Be=Je.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ue=Math.min(ue,Be))}),ue<1/0&&ue>=0&&(Pe=ee.substring(0,ue+1))}(),se=this.tokenizer.inlineText(Pe,O)){ee=ee.substring(se.raw.length),se.raw.slice(-1)!=="_"&&(Q=se.raw.slice(-1)),G=!0,me=fe[fe.length-1],me&&me.type==="text"?(me.raw+=se.raw,me.text+=se.text):fe.push(se);continue}if(ee){var Y="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return fe},E(he,null,[{key:"rules",get:function(){return{block:z,inline:F}}}]),he}(),De=function(){function he(ye){this.options=ye||pe.defaults}var le=he.prototype;return le.code=function(ee,fe,ie){var se=(fe||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(ee,se);me!=null&&me!==ee&&(ie=!0,ee=me)}return ee=ee.replace(/\n$/,"")+`
`,se?'<pre><code class="'+this.options.langPrefix+p(se,!0)+'">'+(ie?ee:p(ee,!0))+`</code></pre>
`:"<pre><code>"+(ie?ee:p(ee,!0))+`</code></pre>
`},le.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},le.html=function(ee){return ee},le.heading=function(ee,fe,ie,se){if(this.options.headerIds){var me=this.options.headerPrefix+se.slug(ie);return"<h"+fe+' id="'+me+'">'+ee+"</h"+fe+`>
`}return"<h"+fe+">"+ee+"</h"+fe+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(ee,fe,ie){var se=fe?"ol":"ul",me=fe&&ie!==1?' start="'+ie+'"':"";return"<"+se+me+`>
`+ee+"</"+se+`>
`},le.listitem=function(ee){return"<li>"+ee+`</li>
`},le.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(ee){return"<p>"+ee+`</p>
`},le.table=function(ee,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+fe+`</table>
`},le.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},le.tablecell=function(ee,fe){var ie=fe.header?"th":"td",se=fe.align?"<"+ie+' align="'+fe.align+'">':"<"+ie+">";return se+ee+("</"+ie+`>
`)},le.strong=function(ee){return"<strong>"+ee+"</strong>"},le.em=function(ee){return"<em>"+ee+"</em>"},le.codespan=function(ee){return"<code>"+ee+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(ee){return"<del>"+ee+"</del>"},le.link=function(ee,fe,ie){if(ee=l(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var se='<a href="'+p(ee)+'"';return fe&&(se+=' title="'+fe+'"'),se+=">"+ie+"</a>",se},le.image=function(ee,fe,ie){if(ee=l(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var se='<img src="'+ee+'" alt="'+ie+'"';return fe&&(se+=' title="'+fe+'"'),se+=this.options.xhtml?"/>":">",se},le.text=function(ee){return ee},he}(),ke=function(){function he(){}var le=he.prototype;return le.strong=function(ee){return ee},le.em=function(ee){return ee},le.codespan=function(ee){return ee},le.del=function(ee){return ee},le.html=function(ee){return ee},le.text=function(ee){return ee},le.link=function(ee,fe,ie){return""+ie},le.image=function(ee,fe,ie){return""+ie},le.br=function(){return""},he}(),Ie=function(){function he(){this.seen={}}var le=he.prototype;return le.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(ee,fe){var ie=ee,se=0;if(this.seen.hasOwnProperty(ie)){se=this.seen[ee];do se++,ie=ee+"-"+se;while(this.seen.hasOwnProperty(ie))}return fe||(this.seen[ee]=se,this.seen[ie]=0),ie},le.slug=function(ee,fe){fe===void 0&&(fe={});var ie=this.serialize(ee);return this.getNextSafeSlug(ie,fe.dryrun)},he}(),de=function(){function he(ye){this.options=ye||pe.defaults,this.options.renderer=this.options.renderer||new De,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Ie}he.parse=function(ee,fe){var ie=new he(fe);return ie.parse(ee)},he.parseInline=function(ee,fe){var ie=new he(fe);return ie.parseInline(ee)};var le=he.prototype;return le.parse=function(ee,fe){fe===void 0&&(fe=!0);var ie="",se,me,Pe,T,q,G,Q,K,Y,ue,Ne,Be,Je,Ge,_e,Ye,xe,it,tt,Ue=ee.length;for(se=0;se<Ue;se++){if(ue=ee[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(tt=this.options.extensions.renderers[ue.type].call({parser:this},ue),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){ie+=tt||"";continue}switch(ue.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,t(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(K="",Q="",T=ue.header.length,me=0;me<T;me++)Q+=this.renderer.tablecell(this.parseInline(ue.header[me].tokens),{header:!0,align:ue.align[me]});for(K+=this.renderer.tablerow(Q),Y="",T=ue.rows.length,me=0;me<T;me++){for(G=ue.rows[me],Q="",q=G.length,Pe=0;Pe<q;Pe++)Q+=this.renderer.tablecell(this.parseInline(G[Pe].tokens),{header:!1,align:ue.align[Pe]});Y+=this.renderer.tablerow(Q)}ie+=this.renderer.table(K,Y);continue}case"blockquote":{Y=this.parse(ue.tokens),ie+=this.renderer.blockquote(Y);continue}case"list":{for(Ne=ue.ordered,Be=ue.start,Je=ue.loose,T=ue.items.length,Y="",me=0;me<T;me++)_e=ue.items[me],Ye=_e.checked,xe=_e.task,Ge="",_e.task&&(it=this.renderer.checkbox(Ye),Je?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(_e.tokens,Je),Y+=this.renderer.listitem(Ge,xe,Ye);ie+=this.renderer.list(Y,Ne,Be);continue}case"html":{ie+=this.renderer.html(ue.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(Y=ue.tokens?this.parseInline(ue.tokens):ue.text;se+1<Ue&&ee[se+1].type==="text";)ue=ee[++se],Y+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);ie+=fe?this.renderer.paragraph(Y):Y;continue}default:{var ut='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}}return ie},le.parseInline=function(ee,fe){fe=fe||this.renderer;var ie="",se,me,Pe,T=ee.length;for(se=0;se<T;se++){if(me=ee[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Pe=this.options.extensions.renderers[me.type].call({parser:this},me),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){ie+=Pe||"";continue}switch(me.type){case"escape":{ie+=fe.text(me.text);break}case"html":{ie+=fe.html(me.text);break}case"link":{ie+=fe.link(me.href,me.title,this.parseInline(me.tokens,fe));break}case"image":{ie+=fe.image(me.href,me.title,me.text);break}case"strong":{ie+=fe.strong(this.parseInline(me.tokens,fe));break}case"em":{ie+=fe.em(this.parseInline(me.tokens,fe));break}case"codespan":{ie+=fe.codespan(me.text);break}case"br":{ie+=fe.br();break}case"del":{ie+=fe.del(this.parseInline(me.tokens,fe));break}case"text":{ie+=fe.text(me.text);break}default:{var q='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return ie},he}();function be(he,le,ye){if(typeof he>"u"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof le=="function"&&(ye=le,le=null),le=I({},be.defaults,le||{}),y(le),ye){var ee=le.highlight,fe;try{fe=Z.lex(he,le)}catch(T){return ye(T)}var ie=function(q){var G;if(!q)try{le.walkTokens&&be.walkTokens(fe,le.walkTokens),G=de.parse(fe,le)}catch(Q){q=Q}return le.highlight=ee,q?ye(q):ye(null,G)};if(!ee||ee.length<3||(delete le.highlight,!fe.length))return ie();var se=0;be.walkTokens(fe,function(T){T.type==="code"&&(se++,setTimeout(function(){ee(T.text,T.lang,function(q,G){if(q)return ie(q);G!=null&&G!==T.text&&(T.text=G,T.escaped=!0),se--,se===0&&ie()})},0))}),se===0&&ie();return}function me(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(T.message+"",!0)+"</pre>";throw T}try{var Pe=Z.lex(he,le);if(le.walkTokens){if(le.async)return Promise.all(be.walkTokens(Pe,le.walkTokens)).then(function(){return de.parse(Pe,le)}).catch(me);be.walkTokens(Pe,le.walkTokens)}return de.parse(Pe,le)}catch(T){me(T)}}be.options=be.setOptions=function(he){return I(be.defaults,he),$(be.defaults),be},be.getDefaults=R,be.defaults=pe.defaults,be.use=function(){for(var he=arguments.length,le=new Array(he),ye=0;ye<he;ye++)le[ye]=arguments[ye];var ee=I.apply(void 0,[{}].concat(le)),fe=be.defaults.extensions||{renderers:{},childTokens:{}},ie;le.forEach(function(se){if(se.extensions&&(ie=!0,se.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var T=fe.renderers?fe.renderers[Pe.name]:null;T?fe.renderers[Pe.name]=function(){for(var q=arguments.length,G=new Array(q),Q=0;Q<q;Q++)G[Q]=arguments[Q];var K=Pe.renderer.apply(this,G);return K===!1&&(K=T.apply(this,G)),K}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),se.renderer&&function(){var Pe=be.defaults.renderer||new De,T=function(Q){var K=Pe[Q];Pe[Q]=function(){for(var Y=arguments.length,ue=new Array(Y),Ne=0;Ne<Y;Ne++)ue[Ne]=arguments[Ne];var Be=se.renderer[Q].apply(Pe,ue);return Be===!1&&(Be=K.apply(Pe,ue)),Be}};for(var q in se.renderer)T(q);ee.renderer=Pe}(),se.tokenizer&&function(){var Pe=be.defaults.tokenizer||new V,T=function(Q){var K=Pe[Q];Pe[Q]=function(){for(var Y=arguments.length,ue=new Array(Y),Ne=0;Ne<Y;Ne++)ue[Ne]=arguments[Ne];var Be=se.tokenizer[Q].apply(Pe,ue);return Be===!1&&(Be=K.apply(Pe,ue)),Be}};for(var q in se.tokenizer)T(q);ee.tokenizer=Pe}(),se.walkTokens){var me=be.defaults.walkTokens;ee.walkTokens=function(Pe){var T=[];return T.push(se.walkTokens.call(this,Pe)),me&&(T=T.concat(me.call(this,Pe))),T}}ie&&(ee.extensions=fe),be.setOptions(ee)})},be.walkTokens=function(he,le){for(var ye=[],ee=function(){var me=ie.value;switch(ye=ye.concat(le.call(be,me)),me.type){case"table":{for(var Pe=M(me.header),T;!(T=Pe()).done;){var q=T.value;ye=ye.concat(be.walkTokens(q.tokens,le))}for(var G=M(me.rows),Q;!(Q=G()).done;)for(var K=Q.value,Y=M(K),ue;!(ue=Y()).done;){var Ne=ue.value;ye=ye.concat(be.walkTokens(Ne.tokens,le))}break}case"list":{ye=ye.concat(be.walkTokens(me.items,le));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[me.type]?be.defaults.extensions.childTokens[me.type].forEach(function(Be){ye=ye.concat(be.walkTokens(me[Be],le))}):me.tokens&&(ye=ye.concat(be.walkTokens(me.tokens,le)))}},fe=M(he),ie;!(ie=fe()).done;)ee();return ye},be.parseInline=function(he,le){if(typeof he>"u"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");le=I({},be.defaults,le||{}),y(le);try{var ye=Z.lexInline(he,le);return le.walkTokens&&be.walkTokens(ye,le.walkTokens),de.parseInline(ye,le)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(ee.message+"",!0)+"</pre>";throw ee}},be.Parser=de,be.parser=de.parse,be.Renderer=De,be.TextRenderer=ke,be.Lexer=Z,be.lexer=Z.lex,be.Tokenizer=V,be.Slugger=Ie,be.parse=be;var oe=be.options,ce=be.setOptions,ve=be.use,_=be.walkTokens,W=be.parseInline,ae=be,we=de.parse,ne=Z.lex;pe.Lexer=Z,pe.Parser=de,pe.Renderer=De,pe.Slugger=Ie,pe.TextRenderer=ke,pe.Tokenizer=V,pe.getDefaults=R,pe.lexer=ne,pe.marked=be,pe.options=oe,pe.parse=ae,pe.parseInline=W,pe.parser=we,pe.setOptions=ce,pe.use=ve,pe.walkTokens=_,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Ae[121],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=e.rot=e.$Pl=void 0;function E($,D,g){return Math.min(Math.max($,D),g)}e.$Pl=E;function L($,D){return(D+$%D)%D}e.rot=L;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Rl=P;class M{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Sl=M;class R{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Tl=R}),function(){function pe(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function R(D){M.push(D,Date.now())}function $(){const D=[];for(let g=0;g<M.length;g+=2)D.push({name:M[g],startTime:M[g+1]});return D}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(P+R.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=E(L))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var L in E)(typeof exports=="object"?exports:pe)[L]=E[L]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function E(L){if(e[L])return e[L].exports;var P=e[L]={i:L,l:!1,exports:{}};return pe[L].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=pe,E.c=e,E.d=function(L,P,M){E.o(L,P)||Object.defineProperty(L,P,{enumerable:!0,get:M})},E.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},E.t=function(L,P){if(1&P&&(L=E(L)),8&P||4&P&&typeof L=="object"&&L&&L.__esModule)return L;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:L}),2&P&&typeof L!="string")for(var R in L)E.d(M,R,function($){return L[$]}.bind(null,R));return M},E.n=function(L){var P=L&&L.__esModule?function(){return L.default}:function(){return L};return E.d(P,"a",P),P},E.o=function(L,P){return Object.prototype.hasOwnProperty.call(L,P)},E.p="",E(E.s=0)}([function(pe,e,E){(function(L){var P;e=pe.exports=ve,P=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var K=Array.prototype.slice.call(arguments,0);K.unshift("SEMVER"),console.log.apply(console,K)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],D=e.src=[],g=0,A=g++;D[A]="0|[1-9]\\d*";var S=g++;D[S]="[0-9]+";var o=g++;D[o]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=g++;D[v]="("+D[A]+")\\.("+D[A]+")\\.("+D[A]+")";var p=g++;D[p]="("+D[S]+")\\.("+D[S]+")\\.("+D[S]+")";var f=g++;D[f]="(?:"+D[A]+"|"+D[o]+")";var t=g++;D[t]="(?:"+D[S]+"|"+D[o]+")";var i=g++;D[i]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var n=g++;D[n]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var u=g++;D[u]="[0-9A-Za-z-]+";var a=g++;D[a]="(?:\\+("+D[u]+"(?:\\."+D[u]+")*))";var l=g++,r="v?"+D[v]+D[i]+"?"+D[a]+"?";D[l]="^"+r+"$";var s="[v=\\s]*"+D[p]+D[n]+"?"+D[a]+"?",c=g++;D[c]="^"+s+"$";var h=g++;D[h]="((?:<|>)?=?)";var b=g++;D[b]=D[S]+"|x|X|\\*";var m=g++;D[m]=D[A]+"|x|X|\\*";var I=g++;D[I]="[v=\\s]*("+D[m]+")(?:\\.("+D[m]+")(?:\\.("+D[m]+")(?:"+D[i]+")?"+D[a]+"?)?)?";var k=g++;D[k]="[v=\\s]*("+D[b]+")(?:\\.("+D[b]+")(?:\\.("+D[b]+")(?:"+D[n]+")?"+D[a]+"?)?)?";var d=g++;D[d]="^"+D[h]+"\\s*"+D[I]+"$";var w=g++;D[w]="^"+D[h]+"\\s*"+D[k]+"$";var y=g++;D[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=g++;D[C]="(?:~>?)";var B=g++;D[B]="(\\s*)"+D[C]+"\\s+",$[B]=new RegExp(D[B],"g");var j=g++;D[j]="^"+D[C]+D[I]+"$";var V=g++;D[V]="^"+D[C]+D[k]+"$";var z=g++;D[z]="(?:\\^)";var F=g++;D[F]="(\\s*)"+D[z]+"\\s+",$[F]=new RegExp(D[F],"g");var O=g++;D[O]="^"+D[z]+D[I]+"$";var x=g++;D[x]="^"+D[z]+D[k]+"$";var Z=g++;D[Z]="^"+D[h]+"\\s*("+s+")$|^$";var De=g++;D[De]="^"+D[h]+"\\s*("+r+")$|^$";var ke=g++;D[ke]="(\\s*)"+D[h]+"\\s*("+s+"|"+D[I]+")",$[ke]=new RegExp(D[ke],"g");var Ie=g++;D[Ie]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var de=g++;D[de]="^\\s*("+D[k]+")\\s+-\\s+("+D[k]+")\\s*$";var be=g++;D[be]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)P(oe,D[oe]),$[oe]||($[oe]=new RegExp(D[oe]));function ce(K,Y){if(K instanceof ve)return K;if(typeof K!="string"||K.length>M||!(Y?$[c]:$[l]).test(K))return null;try{return new ve(K,Y)}catch{return null}}function ve(K,Y){if(K instanceof ve){if(K.loose===Y)return K;K=K.version}else if(typeof K!="string")throw new TypeError("Invalid Version: "+K);if(K.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ve))return new ve(K,Y);P("SemVer",K,Y),this.loose=Y;var ue=K.trim().match(Y?$[c]:$[l]);if(!ue)throw new TypeError("Invalid Version: "+K);if(this.raw=K,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<R)return Be}return Ne}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=ce,e.valid=function(K,Y){var ue=ce(K,Y);return ue?ue.version:null},e.clean=function(K,Y){var ue=ce(K.trim().replace(/^[=v]+/,""),Y);return ue?ue.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(K){return P("SemVer.compare",this.version,this.loose,K),K instanceof ve||(K=new ve(K,this.loose)),this.compareMain(K)||this.comparePre(K)},ve.prototype.compareMain=function(K){return K instanceof ve||(K=new ve(K,this.loose)),W(this.major,K.major)||W(this.minor,K.minor)||W(this.patch,K.patch)},ve.prototype.comparePre=function(K){if(K instanceof ve||(K=new ve(K,this.loose)),this.prerelease.length&&!K.prerelease.length)return-1;if(!this.prerelease.length&&K.prerelease.length)return 1;if(!this.prerelease.length&&!K.prerelease.length)return 0;var Y=0;do{var ue=this.prerelease[Y],Ne=K.prerelease[Y];if(P("prerelease compare",Y,ue,Ne),ue===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ue===void 0)return-1;if(ue!==Ne)return W(ue,Ne)}while(++Y)},ve.prototype.inc=function(K,Y){switch(K){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+K)}return this.format(),this.raw=this.version,this},e.inc=function(K,Y,ue,Ne){typeof ue=="string"&&(Ne=ue,ue=void 0);try{return new ve(K,ue).inc(Y,Ne).version}catch{return null}},e.diff=function(K,Y){if(he(K,Y))return null;var ue=ce(K),Ne=ce(Y);if(ue.prerelease.length||Ne.prerelease.length){for(var Be in ue)if((Be==="major"||Be==="minor"||Be==="patch")&&ue[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ue)if((Be==="major"||Be==="minor"||Be==="patch")&&ue[Be]!==Ne[Be])return Be},e.compareIdentifiers=W;var _=/^[0-9]+$/;function W(K,Y){var ue=_.test(K),Ne=_.test(Y);return ue&&Ne&&(K=+K,Y=+Y),ue&&!Ne?-1:Ne&&!ue?1:K<Y?-1:K>Y?1:0}function ae(K,Y,ue){return new ve(K,ue).compare(new ve(Y,ue))}function we(K,Y,ue){return ae(K,Y,ue)>0}function ne(K,Y,ue){return ae(K,Y,ue)<0}function he(K,Y,ue){return ae(K,Y,ue)===0}function le(K,Y,ue){return ae(K,Y,ue)!==0}function ye(K,Y,ue){return ae(K,Y,ue)>=0}function ee(K,Y,ue){return ae(K,Y,ue)<=0}function fe(K,Y,ue,Ne){var Be;switch(Y){case"===":typeof K=="object"&&(K=K.version),typeof ue=="object"&&(ue=ue.version),Be=K===ue;break;case"!==":typeof K=="object"&&(K=K.version),typeof ue=="object"&&(ue=ue.version),Be=K!==ue;break;case"":case"=":case"==":Be=he(K,ue,Ne);break;case"!=":Be=le(K,ue,Ne);break;case">":Be=we(K,ue,Ne);break;case">=":Be=ye(K,ue,Ne);break;case"<":Be=ne(K,ue,Ne);break;case"<=":Be=ee(K,ue,Ne);break;default:throw new TypeError("Invalid operator: "+Y)}return Be}function ie(K,Y){if(K instanceof ie){if(K.loose===Y)return K;K=K.value}if(!(this instanceof ie))return new ie(K,Y);P("comparator",K,Y),this.loose=Y,this.parse(K),this.semver===se?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(K,Y){return W(Y,K)},e.major=function(K,Y){return new ve(K,Y).major},e.minor=function(K,Y){return new ve(K,Y).minor},e.patch=function(K,Y){return new ve(K,Y).patch},e.compare=ae,e.compareLoose=function(K,Y){return ae(K,Y,!0)},e.rcompare=function(K,Y,ue){return ae(Y,K,ue)},e.sort=function(K,Y){return K.sort(function(ue,Ne){return e.compare(ue,Ne,Y)})},e.rsort=function(K,Y){return K.sort(function(ue,Ne){return e.rcompare(ue,Ne,Y)})},e.gt=we,e.lt=ne,e.eq=he,e.neq=le,e.gte=ye,e.lte=ee,e.cmp=fe,e.Comparator=ie;var se={};function me(K,Y){if(K instanceof me)return K.loose===Y?K:new me(K.raw,Y);if(K instanceof ie)return new me(K.value,Y);if(!(this instanceof me))return new me(K,Y);if(this.loose=Y,this.raw=K,this.set=K.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+K);this.format()}function Pe(K){return!K||K.toLowerCase()==="x"||K==="*"}function T(K,Y,ue,Ne,Be,Je,Ge,_e,Ye,xe,it,tt,Ue){return((Y=Pe(ue)?"":Pe(Ne)?">="+ue+".0.0":Pe(Be)?">="+ue+"."+Ne+".0":">="+Y)+" "+(_e=Pe(Ye)?"":Pe(xe)?"<"+(+Ye+1)+".0.0":Pe(it)?"<"+Ye+"."+(+xe+1)+".0":tt?"<="+Ye+"."+xe+"."+it+"-"+tt:"<="+_e)).trim()}function q(K,Y){for(var ue=0;ue<K.length;ue++)if(!K[ue].test(Y))return!1;if(Y.prerelease.length){for(ue=0;ue<K.length;ue++)if(P(K[ue].semver),K[ue].semver!==se&&K[ue].semver.prerelease.length>0){var Ne=K[ue].semver;if(Ne.major===Y.major&&Ne.minor===Y.minor&&Ne.patch===Y.patch)return!0}return!1}return!0}function G(K,Y,ue){try{Y=new me(Y,ue)}catch{return!1}return Y.test(K)}function Q(K,Y,ue,Ne){var Be,Je,Ge,_e,Ye;switch(K=new ve(K,Ne),Y=new me(Y,Ne),ue){case">":Be=we,Je=ee,Ge=ne,_e=">",Ye=">=";break;case"<":Be=ne,Je=ye,Ge=we,_e="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(K,Y,Ne))return!1;for(var xe=0;xe<Y.set.length;++xe){var it=Y.set[xe],tt=null,Ue=null;if(it.forEach(function(ut){ut.semver===se&&(ut=new ie(">=0.0.0")),tt=tt||ut,Ue=Ue||ut,Be(ut.semver,tt.semver,Ne)?tt=ut:Ge(ut.semver,Ue.semver,Ne)&&(Ue=ut)}),tt.operator===_e||tt.operator===Ye||(!Ue.operator||Ue.operator===_e)&&Je(K,Ue.semver)||Ue.operator===Ye&&Ge(K,Ue.semver))return!1}return!0}ie.prototype.parse=function(K){var Y=this.loose?$[Z]:$[De],ue=K.match(Y);if(!ue)throw new TypeError("Invalid comparator: "+K);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new ve(ue[2],this.loose):this.semver=se},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(K){return P("Comparator.test",K,this.loose),this.semver===se||(typeof K=="string"&&(K=new ve(K,this.loose)),fe(K,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(K,Y){if(!(K instanceof ie))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new me(K.value,Y),G(this.value,ue,Y);if(K.operator==="")return ue=new me(this.value,Y),G(K.semver,ue,Y);var Ne=!(this.operator!==">="&&this.operator!==">"||K.operator!==">="&&K.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||K.operator!=="<="&&K.operator!=="<"),Je=this.semver.version===K.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||K.operator!==">="&&K.operator!=="<="),_e=fe(this.semver,"<",K.semver,Y)&&(this.operator===">="||this.operator===">")&&(K.operator==="<="||K.operator==="<"),Ye=fe(this.semver,">",K.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(K.operator===">="||K.operator===">");return Ne||Be||Je&&Ge||_e||Ye},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(K){return K.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(K){var Y=this.loose;K=K.trim(),P("range",K,Y);var ue=Y?$[de]:$[Ie];K=K.replace(ue,T),P("hyphen replace",K),K=K.replace($[ke],"$1$2$3"),P("comparator trim",K,$[ke]),K=(K=(K=K.replace($[B],"$1~")).replace($[F],"$1^")).split(/\s+/).join(" ");var Ne=Y?$[Z]:$[De],Be=K.split(" ").map(function(Je){return function(Ge,_e){return P("comp",Ge),Ge=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ue){P("caret",tt,Ue);var ut=Ue?$[x]:$[O];return tt.replace(ut,function(X,J,Ee,je,Oe){var Ze;return P("caret",tt,X,J,Ee,je,Oe),Pe(J)?Ze="":Pe(Ee)?Ze=">="+J+".0.0 <"+(+J+1)+".0.0":Pe(je)?Ze=J==="0"?">="+J+"."+Ee+".0 <"+J+"."+(+Ee+1)+".0":">="+J+"."+Ee+".0 <"+(+J+1)+".0.0":Oe?(P("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ze=J==="0"?Ee==="0"?">="+J+"."+Ee+"."+je+Oe+" <"+J+"."+Ee+"."+(+je+1):">="+J+"."+Ee+"."+je+Oe+" <"+J+"."+(+Ee+1)+".0":">="+J+"."+Ee+"."+je+Oe+" <"+(+J+1)+".0.0"):(P("no pr"),Ze=J==="0"?Ee==="0"?">="+J+"."+Ee+"."+je+" <"+J+"."+Ee+"."+(+je+1):">="+J+"."+Ee+"."+je+" <"+J+"."+(+Ee+1)+".0":">="+J+"."+Ee+"."+je+" <"+(+J+1)+".0.0"),P("caret return",Ze),Ze})}(it,xe)}).join(" ")}(Ge,_e),P("caret",Ge),Ge=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,Ue){var ut=Ue?$[V]:$[j];return tt.replace(ut,function(X,J,Ee,je,Oe){var Ze;return P("tilde",tt,X,J,Ee,je,Oe),Pe(J)?Ze="":Pe(Ee)?Ze=">="+J+".0.0 <"+(+J+1)+".0.0":Pe(je)?Ze=">="+J+"."+Ee+".0 <"+J+"."+(+Ee+1)+".0":Oe?(P("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ze=">="+J+"."+Ee+"."+je+Oe+" <"+J+"."+(+Ee+1)+".0"):Ze=">="+J+"."+Ee+"."+je+" <"+J+"."+(+Ee+1)+".0",P("tilde return",Ze),Ze})}(it,xe)}).join(" ")}(Ge,_e),P("tildes",Ge),Ge=function(Ye,xe){return P("replaceXRanges",Ye,xe),Ye.split(/\s+/).map(function(it){return function(tt,Ue){tt=tt.trim();var ut=Ue?$[w]:$[d];return tt.replace(ut,function(X,J,Ee,je,Oe,Ze){P("xRange",tt,X,J,Ee,je,Oe,Ze);var nt=Pe(Ee),$t=nt||Pe(je),bt=$t||Pe(Oe);return J==="="&&bt&&(J=""),nt?X=J===">"||J==="<"?"<0.0.0":"*":J&&bt?($t&&(je=0),bt&&(Oe=0),J===">"?(J=">=",$t?(Ee=+Ee+1,je=0,Oe=0):bt&&(je=+je+1,Oe=0)):J==="<="&&(J="<",$t?Ee=+Ee+1:je=+je+1),X=J+Ee+"."+je+"."+Oe):$t?X=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":bt&&(X=">="+Ee+"."+je+".0 <"+Ee+"."+(+je+1)+".0"),P("xRange return",X),X})}(it,xe)}).join(" ")}(Ge,_e),P("xrange",Ge),Ge=function(Ye,xe){return P("replaceStars",Ye,xe),Ye.trim().replace($[be],"")}(Ge,_e),P("stars",Ge),Ge}(Je,Y)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Je){return!!Je.match(Ne)})),Be=Be.map(function(Je){return new ie(Je,Y)})},me.prototype.intersects=function(K,Y){if(!(K instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Ne){return K.set.some(function(Be){return Be.every(function(Je){return Ne.intersects(Je,Y)})})})})},e.toComparators=function(K,Y){return new me(K,Y).set.map(function(ue){return ue.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},me.prototype.test=function(K){if(!K)return!1;typeof K=="string"&&(K=new ve(K,this.loose));for(var Y=0;Y<this.set.length;Y++)if(q(this.set[Y],K))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(K,Y,ue){var Ne=null,Be=null;try{var Je=new me(Y,ue)}catch{return null}return K.forEach(function(Ge){Je.test(Ge)&&(Ne&&Be.compare(Ge)!==-1||(Be=new ve(Ne=Ge,ue)))}),Ne},e.minSatisfying=function(K,Y,ue){var Ne=null,Be=null;try{var Je=new me(Y,ue)}catch{return null}return K.forEach(function(Ge){Je.test(Ge)&&(Ne&&Be.compare(Ge)!==1||(Be=new ve(Ne=Ge,ue)))}),Ne},e.validRange=function(K,Y){try{return new me(K,Y).range||"*"}catch{return null}},e.ltr=function(K,Y,ue){return Q(K,Y,"<",ue)},e.gtr=function(K,Y,ue){return Q(K,Y,">",ue)},e.outside=Q,e.prerelease=function(K,Y){var ue=ce(K,Y);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(K,Y,ue){return K=new me(K,ue),Y=new me(Y,ue),K.intersects(Y)},e.coerce=function(K){if(K instanceof ve)return K;if(typeof K!="string")return null;var Y=K.match($[y]);return Y==null?null:ce((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,E(1))},function(pe,e){var E,L,P=pe.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(t){if(E===setTimeout)return setTimeout(t,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(t,0);try{return E(t,0)}catch{try{return E.call(null,t,0)}catch{return E.call(this,t,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var D,g=[],A=!1,S=-1;function o(){A&&D&&(A=!1,D.length?g=D.concat(g):S=-1,g.length&&v())}function v(){if(!A){var t=$(o);A=!0;for(var i=g.length;i;){for(D=g,g=[];++S<i;)D&&D[S].run();S=-1,i=g.length}D=null,A=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function f(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)i[n-1]=arguments[n];g.push(new p(t,i)),g.length!==1||A||$(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=f,P.addListener=f,P.once=f,P.off=f,P.removeListener=f,P.removeAllListeners=f,P.emit=f,P.prependListener=f,P.prependOnceListener=f,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ae[122],Re([1,0,11,6]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function P(a){const l=a;return l?typeof l.read=="function":!1}e.$Yd=P;function M(a){const l=a;return l?[l.on,l.pause,l.resume,l.destroy].every(r=>typeof r=="function"):!1}e.$Zd=M;function R(a){const l=a;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$1d=R;function $(a,l){return new D(a,l)}e.$2d=$;class D{constructor(l,r){this.e=l,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(r=>r(l))}h(l){this.c.error.length===0?(0,E.$Z)(l):this.c.error.slice(0).forEach(r=>r(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,r){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(l,r){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const c=s.indexOf(r);c>=0&&s.splice(c,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(a,l){const r=[];let s;for(;(s=a.read())!==null;)r.push(s);return l(r)}e.$3d=g;function A(a,l,r){const s=[];let c;for(;(c=a.read())!==null&&s.length<r;)s.push(c);return c===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof c<"u"){const h=c;return c=void 0,h}return a.read()}}}e.$4d=A;function S(a,l){return new Promise((r,s)=>{const c=[];o(a,{onData:h=>{l&&c.push(h)},onError:h=>{l?s(h):r(void 0)},onEnd:()=>{r(l?l(c):void 0)}})})}e.$5d=S;function o(a,l,r){a.on("error",s=>{r?.isCancellationRequested||l.onError(s)}),a.on("end",()=>{r?.isCancellationRequested||l.onEnd()}),a.on("data",s=>{r?.isCancellationRequested||l.onData(s)})}e.$6d=o;function v(a,l){return new Promise((r,s)=>{const c=new L.$Qc,h=[],b=k=>{if(h.push(k),h.length>l)return c.dispose(),a.pause(),r({stream:a,buffer:h,ended:!1})},m=k=>(c.dispose(),s(k)),I=()=>(c.dispose(),r({stream:a,buffer:h,ended:!0}));c.add((0,L.$Pc)(()=>a.removeListener("error",m))),a.on("error",m),c.add((0,L.$Pc)(()=>a.removeListener("end",I))),a.on("end",I),c.add((0,L.$Pc)(()=>a.removeListener("data",b))),a.on("data",b)})}e.$7d=v;function p(a,l){const r=$(l);return r.end(a),r}e.$8d=p;function f(){const a=$(()=>{throw new Error("not supported")});return a.end(),a}e.$9d=f;function t(a){let l=!1;return{read:()=>l?null:(l=!0,a)}}e.$0d=t;function i(a,l,r){const s=$(r);return o(a,{onData:c=>s.write(l.data(c)),onError:c=>s.error(l.error?l.error(c):c),onEnd:()=>s.end()}),s}e.$$d=i;function n(a,l,r){let s=!1;return{read:()=>{const c=l.read();return s?c:(s=!0,c!==null?r([a,c]):a)}}}e.$_d=n;function u(a,l,r){let s=!1;const c=$(r);return o(l,{onData:h=>s?c.write(h):(s=!0,c.write(r([a,h]))),onError:h=>c.error(h),onEnd:()=>{s||(s=!0,c.write(a)),c.end()}}),c}e.$ae=u}),define(Ae[23],Re([1,0,44,122]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const P=typeof Buffer<"u",M=new E.$U(()=>new Uint8Array(256));let R,$;class D{static alloc(y){return P?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return P&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(y)):(R||(R=new TextEncoder),new D(R.encode(y)))}static fromByteArray(y){const C=D.alloc(y.length);for(let B=0,j=y.length;B<j;B++)C.buffer[B]=y[B];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let V=0,z=y.length;V<z;V++)C+=y[V].byteLength}const B=D.alloc(C);let j=0;for(let V=0,z=y.length;V<z;V++){const F=y[V];B.set(F,j),j+=F.byteLength}return B}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return P?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(y,C){return new D(this.buffer.subarray(y,C))}set(y,C){if(y instanceof D)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return o(this.buffer,y)}writeUInt32BE(y,C){v(this.buffer,y,C)}readUInt32LE(y){return p(this.buffer,y)}writeUInt32LE(y,C){f(this.buffer,y,C)}readUInt8(y){return t(this.buffer,y)}writeUInt8(y,C){i(this.buffer,y,C)}indexOf(y,C=0){return g(this.buffer,y instanceof D?y.buffer:y,C)}}e.$be=D;function g(w,y,C=0){const B=y.byteLength,j=w.byteLength;if(B===0)return 0;if(B===1)return w.indexOf(y[0]);if(B>j-C)return-1;const V=M.value;V.fill(y.length);for(let x=0;x<y.length;x++)V[y[x]]=y.length-x-1;let z=C+y.length-1,F=z,O=-1;for(;z<j;)if(w[z]===y[F]){if(F===0){O=z;break}z--,F--}else z+=Math.max(y.length-F,V[w[z]]),F=y.length-1;return O}e.$ce=g;function A(w,y){return w[y+0]<<0>>>0|w[y+1]<<8>>>0}e.$de=A;function S(w,y,C){w[C+0]=y&255,y=y>>>8,w[C+1]=y&255}e.$ee=S;function o(w,y){return w[y]*2**24+w[y+1]*2**16+w[y+2]*2**8+w[y+3]}e.$fe=o;function v(w,y,C){w[C+3]=y,y=y>>>8,w[C+2]=y,y=y>>>8,w[C+1]=y,y=y>>>8,w[C]=y}e.$ge=v;function p(w,y){return w[y+0]<<0>>>0|w[y+1]<<8>>>0|w[y+2]<<16>>>0|w[y+3]<<24>>>0}e.$he=p;function f(w,y,C){w[C+0]=y&255,y=y>>>8,w[C+1]=y&255,y=y>>>8,w[C+2]=y&255,y=y>>>8,w[C+3]=y&255}e.$ie=f;function t(w,y){return w[y]}e.$je=t;function i(w,y,C){w[C]=y}e.$ke=i;function n(w){return L.$3d(w,y=>D.concat(y))}e.$le=n;function u(w){return L.$0d(w)}e.$me=u;function a(w){return L.$5d(w,y=>D.concat(y))}e.$ne=a;async function l(w){return w.ended?D.concat(w.buffer):D.concat([...w.buffer,await a(w.stream)])}e.$oe=l;function r(w){return L.$8d(w,y=>D.concat(y))}e.$pe=r;function s(w){return L.$$d(w,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}e.$qe=s;function c(w){return L.$2d(y=>D.concat(y),w)}e.$re=c;function h(w,y){return L.$_d(w,y,C=>D.concat(C))}e.$se=h;function b(w,y){return L.$ae(w,y,C=>D.concat(C))}e.$te=b;function m(w){let y=0,C=0,B=0;const j=new Uint8Array(Math.floor(w.length/4*3)),V=F=>{switch(C){case 3:j[B++]=y|F,C=0;break;case 2:j[B++]=y|F>>>2,y=F<<6,C=3;break;case 1:j[B++]=y|F>>>4,y=F<<4,C=2;break;default:y=F<<2,C=1}};for(let F=0;F<w.length;F++){const O=w.charCodeAt(F);if(O>=65&&O<=90)V(O-65);else if(O>=97&&O<=122)V(O-97+26);else if(O>=48&&O<=57)V(O-48+52);else if(O===43||O===45)V(62);else if(O===47||O===95)V(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${w[F]}`)}}const z=B;for(;C>0;)V(0);return D.wrap(j).slice(0,z)}e.$ue=m;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:w},y=!0,C=!1){const B=C?k:I;let j="";const V=w.byteLength%3;let z=0;for(;z<w.byteLength-V;z+=3){const F=w[z+0],O=w[z+1],x=w[z+2];j+=B[F>>>2],j+=B[(F<<4|O>>>4)&63],j+=B[(O<<2|x>>>6)&63],j+=B[x&63]}if(V===1){const F=w[z+0];j+=B[F>>>2],j+=B[F<<4&63],y&&(j+="==")}else if(V===2){const F=w[z+0],O=w[z+1];j+=B[F>>>2],j+=B[(F<<4|O>>>4)&63],j+=B[O<<2&63],y&&(j+="=")}return j}e.$ve=d}),define(Ae[123],Re([1,0,28,13]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.FuzzyScore=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.or=void 0;function P(...ie){return function(se,me){for(let Pe=0,T=ie.length;Pe<T;Pe++){const q=ie[Pe](se,me);if(q)return q}return null}}e.or=P,e.$Dj=M.bind(void 0,!1),e.$Ej=M.bind(void 0,!0);function M(ie,se,me){if(!me||me.length<se.length)return null;let Pe;return ie?Pe=L.$3e(me,se):Pe=me.indexOf(se)===0,Pe?se.length>0?[{start:0,end:se.length}]:[]:null}function R(ie,se){const me=se.toLowerCase().indexOf(ie.toLowerCase());return me===-1?null:[{start:me,end:me+ie.length}]}e.$Fj=R;function $(ie,se){return D(ie.toLowerCase(),se.toLowerCase(),0,0)}e.$Gj=$;function D(ie,se,me,Pe){if(me===ie.length)return[];if(Pe===se.length)return null;if(ie[me]===se[Pe]){let T=null;return(T=D(ie,se,me+1,Pe+1))?i({start:Pe,end:Pe+1},T):null}return D(ie,se,me,Pe+1)}function g(ie){return 97<=ie&&ie<=122}function A(ie){return 65<=ie&&ie<=90}e.$Hj=A;function S(ie){return 48<=ie&&ie<=57}function o(ie){return ie===32||ie===9||ie===10||ie===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>v.add(ie.charCodeAt(0)));function p(ie){return o(ie)||v.has(ie)}function f(ie,se){return ie===se||p(ie)&&p(se)}function t(ie){return g(ie)||A(ie)||S(ie)}function i(ie,se){return se.length===0?se=[ie]:ie.end===se[0].start?se[0].start=ie.start:se.unshift(ie),se}function n(ie,se){for(let me=se;me<ie.length;me++){const Pe=ie.charCodeAt(me);if(A(Pe)||S(Pe)||me>0&&!t(ie.charCodeAt(me-1)))return me}return ie.length}function u(ie,se,me,Pe){if(me===ie.length)return[];if(Pe===se.length)return null;if(ie[me]!==se[Pe].toLowerCase())return null;{let T=null,q=Pe+1;for(T=u(ie,se,me+1,Pe+1);!T&&(q=n(se,q))<se.length;)T=u(ie,se,me+1,q),q++;return T===null?null:i({start:Pe,end:Pe+1},T)}}function a(ie){let se=0,me=0,Pe=0,T=0,q=0;for(let ue=0;ue<ie.length;ue++)q=ie.charCodeAt(ue),A(q)&&se++,g(q)&&me++,t(q)&&Pe++,S(q)&&T++;const G=se/ie.length,Q=me/ie.length,K=Pe/ie.length,Y=T/ie.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:K,numericPercent:Y}}function l(ie){const{upperPercent:se,lowerPercent:me}=ie;return me===0&&se>.6}function r(ie){const{upperPercent:se,lowerPercent:me,alphaPercent:Pe,numericPercent:T}=ie;return me>.2&&se<.8&&Pe>.6&&T<.2}function s(ie){let se=0,me=0,Pe=0,T=0;for(let q=0;q<ie.length;q++)Pe=ie.charCodeAt(q),A(Pe)&&se++,g(Pe)&&me++,o(Pe)&&T++;return(se===0||me===0)&&T===0?ie.length<=30:se<=5}function c(ie,se){if(!se||(se=se.trim(),se.length===0)||!s(ie)||se.length>60)return null;const me=a(se);if(!r(me)){if(!l(me))return null;se=se.toLowerCase()}let Pe=null,T=0;for(ie=ie.toLowerCase();T<se.length&&(Pe=u(ie,se,0,T))===null;)T=n(se,T+1);return Pe}e.$Ij=c;function h(ie,se,me=!1){if(!se||se.length===0)return null;let Pe=null,T=0;for(ie=ie.toLowerCase(),se=se.toLowerCase();T<se.length&&(Pe=b(ie,se,0,T,me))===null;)T=m(se,T+1);return Pe}e.$Jj=h;function b(ie,se,me,Pe,T){if(me===ie.length)return[];if(Pe===se.length)return null;if(f(ie.charCodeAt(me),se.charCodeAt(Pe))){let q=null,G=Pe+1;if(q=b(ie,se,me+1,Pe+1,T),!T)for(;!q&&(G=m(se,G))<se.length;)q=b(ie,se,me+1,G,T),G++;return q?ie.charCodeAt(me)!==se.charCodeAt(Pe)?q:i({start:Pe,end:Pe+1},q):null}else return null}function m(ie,se){for(let me=se;me<ie.length;me++)if(p(ie.charCodeAt(me))||me>0&&p(ie.charCodeAt(me-1)))return me;return ie.length}const I=P(e.$Ej,c,R),k=P(e.$Ej,c,$),d=new E.$Cc(1e4);function w(ie,se,me=!1){if(typeof ie!="string"||typeof se!="string")return null;let Pe=d.get(ie);Pe||(Pe=new RegExp(L.$Le(ie),"i"),d.set(ie,Pe));const T=Pe.exec(se);return T?[{start:T.index,end:T.index+T[0].length}]:me?k(ie,se):I(ie,se)}e.$Kj=w;function y(ie,se){const me=we(ie,ie.toLowerCase(),0,se,se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?B(me):null}e.$Lj=y;function C(ie,se,me,Pe,T,q){const G=Math.min(13,ie.length);for(;me<G;me++){const Q=we(ie,se,me,Pe,T,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,q]}e.$Mj=C;function B(ie){if(typeof ie>"u")return[];const se=[],me=ie[1];for(let Pe=ie.length-1;Pe>1;Pe--){const T=ie[Pe]+me,q=se[se.length-1];q&&q.end===T?q.end=T+1:se.push({start:T,end:T+1})}return se}e.$Nj=B;const j=128;function V(){const ie=[],se=[];for(let me=0;me<=j;me++)se[me]=0;for(let me=0;me<=j;me++)ie.push(se.slice(0));return ie}function z(ie){const se=[];for(let me=0;me<=ie;me++)se[me]=0;return se}const F=z(2*j),O=z(2*j),x=V(),Z=V(),De=V(),ke=!1;function Ie(ie,se,me,Pe,T){function q(Q,K,Y=" "){for(;Q.length<K;)Q=Y+Q;return Q}let G=` |   |${Pe.split("").map(Q=>q(Q,3)).join("|")}
`;for(let Q=0;Q<=me;Q++)Q===0?G+=" |":G+=`${se[Q-1]}|`,G+=ie[Q].slice(0,T+1).map(K=>q(K.toString(),3)).join("|")+`
`;return G}function de(ie,se,me,Pe){ie=ie.substr(se),me=me.substr(Pe),console.log(Ie(Z,ie,ie.length,me,me.length)),console.log(Ie(De,ie,ie.length,me,me.length)),console.log(Ie(x,ie,ie.length,me,me.length))}function be(ie,se){if(se<0||se>=ie.length)return!1;const me=ie.codePointAt(se);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$if(me)}}function oe(ie,se){if(se<0||se>=ie.length)return!1;switch(ie.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ce(ie,se,me){return se[ie]!==me[ie]}function ve(ie,se,me,Pe,T,q,G=!1){for(;se<me&&T<q;)ie[se]===Pe[T]&&(G&&(F[se]=T),se+=1),T+=1;return se===me}e.$Oj=ve;var _;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(_||(_={}));var W;(function(ie){ie.Default=[-100,0];function se(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}ie.isDefault=se})(W||(e.FuzzyScore=W={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(se,me){this.firstMatchCanBeWeak=se,this.boostFullMatch=me}}e.$Pj=ae;function we(ie,se,me,Pe,T,q,G=ae.default){const Q=ie.length>j?j:ie.length,K=Pe.length>j?j:Pe.length;if(me>=Q||q>=K||Q-me>K-q||!ve(se,me,Q,T,q,K,!0))return;ne(Q,K,me,q,se,T);let Y=1,ue=1,Ne=me,Be=q;const Je=[!1];for(Y=1,Ne=me;Ne<Q;Y++,Ne++){const it=F[Ne],tt=O[Ne],Ue=Ne+1<Q?O[Ne+1]:K;for(ue=it-q+1,Be=it;Be<Ue;ue++,Be++){let ut=Number.MIN_SAFE_INTEGER,X=!1;Be<=tt&&(ut=he(ie,se,Ne,me,Pe,T,Be,K,q,x[Y-1][ue-1]===0,Je));let J=0;ut!==Number.MAX_SAFE_INTEGER&&(X=!0,J=ut+Z[Y-1][ue-1]);const Ee=Be>it,je=Ee?Z[Y][ue-1]+(x[Y][ue-1]>0?-5:0):0,Oe=Be>it+1&&x[Y][ue-1]>0,Ze=Oe?Z[Y][ue-2]+(x[Y][ue-2]>0?-5:0):0;if(Oe&&(!Ee||Ze>=je)&&(!X||Ze>=J))Z[Y][ue]=Ze,De[Y][ue]=3,x[Y][ue]=0;else if(Ee&&(!X||je>=J))Z[Y][ue]=je,De[Y][ue]=2,x[Y][ue]=0;else if(X)Z[Y][ue]=J,De[Y][ue]=1,x[Y][ue]=x[Y-1][ue-1]+1;else throw new Error("not possible")}}if(ke&&de(ie,me,Pe,q),!Je[0]&&!G.firstMatchCanBeWeak)return;Y--,ue--;const Ge=[Z[Y][ue],q];let _e=0,Ye=0;for(;Y>=1;){let it=ue;do{const tt=De[Y][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&se[me+Y-1]===T[q+ue-1]&&!ce(it+q-1,Pe,T)&&_e+1>x[Y][it]&&(it=ue),it===ue?_e++:_e=1,Ye||(Ye=it),Y--,ue=it-1,Ge.push(ue)}K===Q&&G.boostFullMatch&&(Ge[0]+=2);const xe=Ye-Q;return Ge[0]-=xe,Ge}e.$Qj=we;function ne(ie,se,me,Pe,T,q){let G=ie-1,Q=se-1;for(;G>=me&&Q>=Pe;)T[G]===q[Q]&&(O[G]=Q,G--),Q--}function he(ie,se,me,Pe,T,q,G,Q,K,Y,ue){if(se[me]!==q[G])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return G===me-Pe?Ne=ie[me]===T[G]?7:5:ce(G,T,q)&&(G===0||!ce(G-1,T,q))?(Ne=ie[me]===T[G]?7:5,Be=!0):be(q,G)&&(G===0||!be(q,G-1))?Ne=5:(be(q,G-1)||oe(q,G-1))&&(Ne=5,Be=!0),Ne>1&&me===Pe&&(ue[0]=!0),Be||(Be=ce(G,T,q)||be(q,G-1)||oe(q,G-1)),me===Pe?G>K&&(Ne-=Be?3:5):Y?Ne+=Be?2:0:Ne+=Be?0:1,G+1===Q&&(Ne-=Be?3:5),Ne}function le(ie,se,me,Pe,T,q,G){return ee(ie,se,me,Pe,T,q,!0,G)}e.$Rj=le;function ye(ie,se,me,Pe,T,q,G){return ee(ie,se,me,Pe,T,q,!1,G)}e.$Sj=ye;function ee(ie,se,me,Pe,T,q,G,Q){let K=we(ie,se,me,Pe,T,q,Q);if(K&&!G)return K;if(ie.length>=3){const Y=Math.min(7,ie.length-1);for(let ue=me+1;ue<Y;ue++){const Ne=fe(ie,ue);if(Ne){const Be=we(Ne,Ne.toLowerCase(),me,Pe,T,q,Q);Be&&(Be[0]-=3,(!K||Be[0]>K[0])&&(K=Be))}}}return K}function fe(ie,se){if(se+1>=ie.length)return;const me=ie[se],Pe=ie[se+1];if(me!==Pe)return ie.slice(0,se)+Pe+me+ie.slice(se+2)}}),define(Ae[31],Re([1,0,13]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(L||(L={})),function(P){const M="error",R="warning",$="warn",D="info",g="ignore";function A(o){return o?E.$2e(M,o)?P.Error:E.$2e(R,o)||E.$2e($,o)?P.Warning:E.$2e(D,o)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function S(o){switch(o){case P.Error:return M;case P.Warning:return R;case P.Info:return D;default:return g}}P.toString=S}(L||(L={})),e.default=L}),define(Ae[124],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(Ae[51],Re([1,0,18,13]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class P{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const p=v.charCodeAt(0),f=this.b.charCodeAt(this.c);return p-f}value(){return this.b[this.c]}}e.$Sh=P;class M{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,L.$Ve)(v,this.b,0,v.length,this.c,this.d):(0,L.$Xe)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=M;class R{constructor(v=!0,p=!0){this.f=v,this.g=p}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let p=v.length-1;p>=0;p--,this.c--){const f=this.b.charCodeAt(p);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,L.$Ve)(v,this.b,0,v.length,this.d,this.e):(0,L.$Xe)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=R;var $;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})($||($={}));class D{constructor(v,p){this.f=v,this.g=p,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,L.$We)(v,this.c.scheme);if(this.d[this.e]===2)return(0,L.$We)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,L.$Ue)(v,this.c.query);if(this.d[this.e]===5)return(0,L.$Ue)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(A||(A={}));class S{static forUris(v=()=>!1,p=()=>!1){return new S(new D(v,p))}static forPaths(v=!1){return new S(new R(void 0,!v))}static forStrings(){return new S(new P)}static forConfigKeys(){return new S(new M)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,p){if(p){const f=p.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t,v)}else{const f=v.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t[0],t[1])}}set(v,p){const f=this.b.reset(v);let t;this.c||(this.c=new g,this.c.segment=f.value());const i=[];for(t=this.c;;){const u=f.cmp(t.segment);if(u>0)t.left||(t.left=new g,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if(u<0)t.right||(t.right=new g,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const n=t.value;t.value=p,t.key=v;for(let u=i.length-1;u>=0;u--){const a=i[u][1];a.updateHeight();const l=a.balanceFactor();if(l<-1||l>1){const r=i[u][0],s=i[u+1][0];if(r===1&&s===1)i[u][1]=a.rotateLeft();else if(r===-1&&s===-1)i[u][1]=a.rotateRight();else if(r===1&&s===-1)a.right=i[u+1][1]=i[u+1][1].rotateRight(),i[u][1]=a.rotateLeft();else if(r===-1&&s===1)a.left=i[u+1][1]=i[u+1][1].rotateLeft(),i[u][1]=a.rotateRight();else throw new Error;if(u>0)switch(i[u-1][0]){case-1:i[u-1][1].left=i[u][1];break;case 1:i[u-1][1].right=i[u][1];break;case 0:i[u-1][1].mid=i[u][1];break}else this.c=i[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const p=this.b.reset(v);let f=this.c;for(;f;){const t=p.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else break}return f}has(v){const p=this.d(v);return!(p?.value===void 0&&p?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,p){const f=this.b.reset(v),t=[];let i=this.c;for(;i;){const n=f.cmp(i.segment);if(n>0)t.push([-1,i]),i=i.left;else if(n<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const n=this.f(i.right);if(n.key){const{key:u,value:a,segment:l}=n;this.e(n.key,!1),i.key=u,i.value=a,i.segment=l}}else{const n=i.left??i.right;if(t.length>0){const[u,a]=t[t.length-1];switch(u){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this.c=n}for(let n=t.length-1;n>=0;n--){const u=t[n][1];u.updateHeight();const a=u.balanceFactor();if(a>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),t[n][1]=u.rotateLeft()):a<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),t[n][1]=u.rotateRight()),n>0)switch(t[n-1][0]){case-1:t[n-1][1].left=t[n][1];break;case 1:t[n-1][1].right=t[n][1];break;case 0:t[n-1][1].mid=t[n][1];break}else this.c=t[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const p=this.b.reset(v);let f=this.c,t;for(;f;){const i=p.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if(p.hasNext())p.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(v){return this.g(v,!1)}g(v,p){const f=this.b.reset(v);let t=this.c;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[p,f]of this)v(f,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const p=[];return this.j(v,p),p[Symbol.iterator]()}j(v,p){v&&(v.left&&this.j(v.left,p),v.value&&p.push([v.key,v.value]),v.mid&&this.j(v.mid,p),v.right&&this.j(v.right,p))}_isBalanced(){const v=p=>{if(!p)return!0;const f=p.balanceFactor();return f<-1||f>1?!1:v(p.left)&&v(p.right)};return v(this.c)}}e.$Wh=S}),define(Ae[45],Re([1,0,90]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Wj=e.ThemeColor=void 0;var L;(function(R){function $(D){return D&&typeof D=="object"&&typeof D.id=="string"}R.isThemeColor=$})(L||(e.ThemeColor=L={}));function P(R){return{id:R}}e.$Wj=P;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function D(n){const u=$.exec(n.id);if(!u)return D(E.$Vj.error);const[,a,l]=u,r=["codicon","codicon-"+a];return l&&r.push("codicon-modifier-"+l.substring(1)),r}R.asClassNameArray=D;function g(n){return D(n).join(" ")}R.asClassName=g;function A(n){return"."+D(n).join(".")}R.asCSSSelector=A;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}R.isThemeIcon=S;const o=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(n){const u=o.exec(n);if(!u)return;const[,a]=u;return{id:a}}R.fromString=v;function p(n){return{id:n}}R.fromId=p;function f(n,u){let a=n.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),u&&(a=`${a}~${u}`),{id:a}}R.modify=f;function t(n){const u=n.id.lastIndexOf("~");if(u!==-1)return n.id.substring(u+1)}R.getModifier=t;function i(n,u){return n.id===u.id&&n.color?.id===u.color?.id}R.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Ae[125],Re([1,0,123,13,45]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=void 0;const M="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function D(i){return i.replace($,(n,u)=>u?n:`\\${n}`)}e.$Xj=D;const g=new RegExp(`\\\\${R.source}`,"g");function A(i){return i.replace(g,n=>`\\${n}`)}e.$Yj=A;const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function o(i){return i.indexOf(M)===-1?i:i.replace(S,(n,u,a,l)=>a?n:u||l||"")}e.$Zj=o;function v(i){return i?i.replace(/\$\((.*?)\)/g,(n,u)=>` ${u} `).trim():""}e.$1j=v;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){p.lastIndex=0;let n="";const u=[];let a=0;for(;;){const l=p.lastIndex,r=p.exec(i),s=i.substring(l,r?.index);if(s.length>0){n+=s;for(let c=0;c<s.length;c++)u.push(a)}if(!r)break;a+=r[0].length}return{text:n,iconOffsets:u}}e.$2j=f;function t(i,n,u=!1){const{text:a,iconOffsets:l}=n;if(!l||l.length===0)return(0,E.$Kj)(i,a,u);const r=(0,L.$Je)(a," "),s=a.length-r.length,c=(0,E.$Kj)(i,r,u);if(c)for(const h of c){const b=l[h.start+s]+s;h.start+=b,h.end+=b}return c}e.$3j=t}),define(Ae[38],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(P){return E.test(P)}e.$dg=L,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function($){for(let D=0;D<$.length;D++)$[D]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let D=0,g="";return g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g}}()}),define(Ae[126],Re([1,0,18,68,38]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=e.$2s=e.$1s=e.$Zs=void 0;function M(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$Zs=M;function R(S,o,v){const p={id:(0,P.$eg)(),name:S,uri:o,data:v};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$1s=R;class ${constructor(){this.a=new Map}get size(){let o=0;for(const v of this.a)o++;return o}has(o){return this.a.has(this.b(o))}matches(o){const v=[...this.a.keys()];return L.Iterable.some(this,([p,f])=>f.asFile())&&v.push("files"),A(D(o),v)}get(o){return this.a.get(this.b(o))?.[0]}append(o,v){const p=this.a.get(o);p?p.push(v):this.a.set(this.b(o),[v])}replace(o,v){this.a.set(this.b(o),[v])}delete(o){this.a.delete(this.b(o))}*[Symbol.iterator](){for(const[o,v]of this.a)for(const p of v)yield[o,p]}b(o){return D(o)}}e.$2s=$;function D(S){return S.toLowerCase()}function g(S,o){return A(D(S),o.map(D))}e.$3s=g;function A(S,o){if(S==="*/*")return o.length>0;if(o.includes(S))return!0;const v=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[p,f,t]=v;return t==="*"?o.some(i=>i.startsWith(f+"/")):!1}e.$4s=Object.freeze({create:S=>(0,E.$Lb)(S.map(o=>o.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$4s.split(S).filter(o=>!o.startsWith("#"))})}),define(Ae[127],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.StringEOL=void 0;var E;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function L(P){let M=0,R=0,$=0,D=0;for(let g=0,A=P.length;g<A;g++){const S=P.charCodeAt(g);S===13?(M===0&&(R=g),M++,g+1<A&&P.charCodeAt(g+1)===10?(D|=2,g++):D|=3,$=g+1):S===10&&(D|=1,M===0&&(R=g),M++,$=g+1)}return M===0&&(R=P.length),[M,R,P.length-$,D]}e.$7s=L}),define(Ae[128],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0,e.$4r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[129],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class L{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let D=0,g=$.notIn.length;D<g;D++)switch($.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,D){if($.getTokenCount()===0)return!0;const g=$.findTokenIndexAtOffset(D-2),A=$.getStandardTokenType(g);return this.isOK(A)}g($,D){for(let g=$;g<=D;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$qt=L;class P{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of $)M(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),M(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),M(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),M(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&M(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$rt=P;function M(R,$,D){R.has($)?R.get($).push(D):R.set($,[D])}}),define(Ae[130],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uB=e.$tB=e.$sB=e.$rB=e.$qB=e.$pB=e.$oB=e.$nB=e.$mB=e.NodeColor=e.$lB=void 0;class E{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$mB)return P(this.right);let t=this;for(;t.parent!==e.$mB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$mB?e.$mB:t.parent}prev(){if(this.left!==e.$mB)return M(this.left);let t=this;for(;t.parent!==e.$mB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$mB?e.$mB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$lB=E;var L;(function(f){f[f.Black=0]="Black",f[f.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$mB=new E(null,0),e.$mB.parent=e.$mB,e.$mB.left=e.$mB,e.$mB.right=e.$mB,e.$mB.color=0;function P(f){for(;f.left!==e.$mB;)f=f.left;return f}e.$nB=P;function M(f){for(;f.right!==e.$mB;)f=f.right;return f}e.$oB=M;function R(f){return f===e.$mB?0:f.size_left+f.piece.length+R(f.right)}function $(f){return f===e.$mB?0:f.lf_left+f.piece.lineFeedCnt+$(f.right)}function D(){e.$mB.parent=e.$mB}function g(f,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$mB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$mB?f.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$pB=g;function A(f,t){const i=t.left;t.left=i.right,i.right!==e.$mB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$mB?f.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$qB=A;function S(f,t){let i,n;if(t.left===e.$mB?(n=t,i=n.right):t.right===e.$mB?(n=t,i=n.left):(n=P(t.right),i=n.right),n===f.root){f.root=i,i.color=0,t.detach(),D(),f.root.parent=e.$mB;return}const u=n.color===1;if(n===n.parent.left?n.parent.left=i:n.parent.right=i,n===t?(i.parent=n.parent,p(f,i)):(n.parent===t?i.parent=n:i.parent=n.parent,p(f,i),n.left=t.left,n.right=t.right,n.parent=t.parent,n.color=t.color,t===f.root?f.root=n:t===t.parent.left?t.parent.left=n:t.parent.right=n,n.left!==e.$mB&&(n.left.parent=n),n.right!==e.$mB&&(n.right.parent=n),n.size_left=t.size_left,n.lf_left=t.lf_left,p(f,n)),t.detach(),i.parent.left===i){const l=R(i),r=$(i);if(l!==i.parent.size_left||r!==i.parent.lf_left){const s=l-i.parent.size_left,c=r-i.parent.lf_left;i.parent.size_left=l,i.parent.lf_left=r,v(f,i.parent,s,c)}}if(p(f,i.parent),u){D();return}let a;for(;i!==f.root&&i.color===0;)i===i.parent.left?(a=i.parent.right,a.color===1&&(a.color=0,i.parent.color=1,g(f,i.parent),a=i.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.right.color===0&&(a.left.color=0,a.color=1,A(f,a),a=i.parent.right),a.color=i.parent.color,i.parent.color=0,a.right.color=0,g(f,i.parent),i=f.root)):(a=i.parent.left,a.color===1&&(a.color=0,i.parent.color=1,A(f,i.parent),a=i.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,i=i.parent):(a.left.color===0&&(a.right.color=0,a.color=1,g(f,a),a=i.parent.left),a.color=i.parent.color,i.parent.color=0,a.left.color=0,A(f,i.parent),i=f.root));i.color=0,D()}e.$rB=S;function o(f,t){for(p(f,t);t!==f.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,g(f,t)),t.parent.color=0,t.parent.parent.color=1,A(f,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,A(f,t)),t.parent.color=0,t.parent.parent.color=1,g(f,t.parent.parent))}f.root.color=0}e.$sB=o;function v(f,t,i,n){for(;t!==f.root&&t!==e.$mB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=n),t=t.parent}e.$tB=v;function p(f,t){let i=0,n=0;if(t!==f.root){for(;t!==f.root&&t===t.parent.right;)t=t.parent;if(t!==f.root)for(t=t.parent,i=R(t.left)-t.size_left,n=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=n;t!==f.root&&(i!==0||n!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=n),t=t.parent}}e.$uB=p}),define(Ae[91],Re([1,0,131,29,92,130,93]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=void 0;const $=65535;function D(i){let n;return i[i.length-1]<65536?n=new Uint16Array(i.length):n=new Uint32Array(i.length),n.set(i,0),n}class g{constructor(n,u,a,l,r){this.lineStarts=n,this.cr=u,this.lf=a,this.crlf=l,this.isBasicASCII=r}}function A(i,n=!0){const u=[0];let a=1;for(let l=0,r=i.length;l<r;l++){const s=i.charCodeAt(l);s===13?l+1<r&&i.charCodeAt(l+1)===10?(u[a++]=l+2,l++):u[a++]=l+1:s===10&&(u[a++]=l+1)}return n?D(u):u}e.$BB=A;function S(i,n){i.length=0,i[0]=0;let u=1,a=0,l=0,r=0,s=!0;for(let h=0,b=n.length;h<b;h++){const m=n.charCodeAt(h);m===13?h+1<b&&n.charCodeAt(h+1)===10?(r++,i[u++]=h+2,h++):(a++,i[u++]=h+1):m===10?(l++,i[u++]=h+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const c=new g(D(i),a,l,r,s);return i.length=0,c}e.$CB=S;class o{constructor(n,u,a,l,r){this.bufferIndex=n,this.start=u,this.end=a,this.lineFeedCnt=l,this.length=r}}e.$DB=o;class v{constructor(n,u){this.buffer=n,this.lineStarts=u}}e.$EB=v;class p{constructor(n,u){this.a=[],this.c=n,this.d=u,this.b=0,n.root!==M.$mB&&n.iterate(n.root,a=>(a!==M.$mB&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class f{constructor(n){this.a=n,this.b=[]}get(n){for(let u=this.b.length-1;u>=0;u--){const a=this.b[u];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let u=this.b.length-1;u>=0;u--){const a=this.b[u];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let u=!1;const a=this.b;for(let l=0;l<a.length;l++){const r=a[l];if(r.node.parent===null||r.nodeStartOffset>=n){a[l]=null,u=!0;continue}}if(u){const l=[];for(const r of a)r!==null&&l.push(r);this.b=l}}}class t{constructor(n,u,a){this.create(n,u,a)}create(n,u,a){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=M.$mB,this.b=1,this.c=0,this.d=u,this.e=u.length,this.f=a;let l=null;for(let r=0,s=n.length;r<s;r++)if(n[r].buffer.length>0){n[r].lineStarts||(n[r].lineStarts=A(n[r].buffer));const c=new o(r+1,{line:0,column:0},{line:n[r].lineStarts.length-1,column:n[r].buffer.length-n[r].lineStarts[n[r].lineStarts.length-1]},n[r].lineStarts.length-1,n[r].buffer.length);this.a.push(n[r]),l=this.S(l,c)}this.h=new f(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const u=$,a=u-Math.floor(u/3),l=a*2;let r="",s=0;const c=[];if(this.iterate(this.root,h=>{const b=this.R(h),m=b.length;if(s<=a||s+m<l)return r+=b,s+=m,!0;const I=r.replace(/\r\n|\r|\n/g,n);return c.push(new v(I,A(I))),r=b,s=m,!0}),s>0){const h=r.replace(/\r\n|\r|\n/g,n);c.push(new v(h,A(h)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new p(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let u=0;return this.iterate(this.root,l=>{if(l===M.$mB)return!0;const r=this.R(l),s=r.length,c=n.G(u),h=n.G(u+s),b=n.getValueInRange2(c,h);return u+=s,r===b})}getOffsetAt(n,u){let a=0,l=this.root;for(;l!==M.$mB;)if(l.left!==M.$mB&&l.lf_left+1>=n)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=n){a+=l.size_left;const r=this.B(l,n-l.lf_left-2);return a+=r+u-1}else n-=l.lf_left+l.piece.lineFeedCnt,a+=l.size_left+l.piece.length,l=l.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let u=this.root,a=0;const l=n;for(;u!==M.$mB;)if(u.size_left!==0&&u.size_left>=n)u=u.left;else if(u.size_left+u.piece.length>=n){const r=this.A(u,n-u.size_left);if(a+=u.lf_left+r.index,r.index===0){const s=this.getOffsetAt(a+1,1),c=l-s;return new E.$ts(a+1,c+1)}return new E.$ts(a+1,r.remainder+1)}else if(n-=u.size_left+u.piece.length,a+=u.lf_left+u.piece.lineFeedCnt,u.right===M.$mB){const r=this.getOffsetAt(a+1,1),s=l-n-r;return new E.$ts(a+1,s+1)}else u=u.right;return new E.$ts(1,1)}getValueInRange(n,u){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.H(n.startLineNumber,n.startColumn),l=this.H(n.endLineNumber,n.endColumn),r=this.getValueInRange2(a,l);return u?u!==this.d||!this.f?r.replace(/\r\n|\r|\n/g,u):u===this.getEOL()&&this.f?r:r.replace(/\r\n|\r|\n/g,u):r}getValueInRange2(n,u){if(n.node===u.node){const c=n.node,h=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);return h.substring(b+n.remainder,b+u.remainder)}let a=n.node;const l=this.a[a.piece.bufferIndex].buffer,r=this.u(a.piece.bufferIndex,a.piece.start);let s=l.substring(r+n.remainder,r+a.piece.length);for(a=a.next();a!==M.$mB;){const c=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);if(a===u.node){s+=c.substring(h,h+u.remainder);break}else s+=c.substr(h,a.piece.length);a=a.next()}return s}getLinesContent(){const n=[];let u=0,a="",l=!1;return this.iterate(this.root,r=>{if(r===M.$mB)return!0;const s=r.piece;let c=s.length;if(c===0)return!0;const h=this.a[s.bufferIndex].buffer,b=this.a[s.bufferIndex].lineStarts,m=s.start.line,I=s.end.line;let k=b[m]+s.start.column;if(l&&(h.charCodeAt(k)===10&&(k++,c--),n[u++]=a,a="",l=!1,c===0))return!0;if(m===I)return!this.f&&h.charCodeAt(k+c-1)===13?(l=!0,a+=h.substr(k,c-1)):a+=h.substr(k,c),!0;a+=this.f?h.substring(k,Math.max(k,b[m+1]-this.e)):h.substring(k,b[m+1]).replace(/(\r\n|\r|\n)$/,""),n[u++]=a;for(let d=m+1;d<I;d++)a=this.f?h.substring(b[d],b[d+1]-this.e):h.substring(b[d],b[d+1]).replace(/(\r\n|\r|\n)$/,""),n[u++]=a;return!this.f&&h.charCodeAt(b[I]+s.end.column-1)===13?(l=!0,s.end.column===0?u--:a=h.substr(b[I],s.end.column-1)):a=h.substr(b[I],s.end.column),!0}),l&&(n[u++]=a,a=""),n[u++]=a,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const u=n.node.next();if(!u)return 0;const a=this.a[u.piece.bufferIndex],l=this.u(u.piece.bufferIndex,u.piece.start);return a.buffer.charCodeAt(l)}else{const u=this.a[n.node.piece.bufferIndex],l=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return u.buffer.charCodeAt(l)}}getLineCharCode(n,u){const a=this.H(n,u+1);return this.l(a)}getLineLength(n){if(n===this.getLineCount()){const u=this.getOffsetAt(n,1);return this.getLength()-u}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const u=this.G(n);return this.l(u)}findMatchesInNode(n,u,a,l,r,s,c,h,b,m,I){const k=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start),w=this.u(n.piece.bufferIndex,r),y=this.u(n.piece.bufferIndex,s);let C;const B={line:0,column:0};let j,V;u._wordSeparators?(j=k.buffer.substring(w,y),V=z=>z+w,u.reset(0)):(j=k.buffer,V=z=>z,u.reset(w));do if(C=u.next(j),C){if(V(C.index)>=y)return m;this.s(n,V(C.index)-d,B);const z=this.t(n.piece.bufferIndex,r,B),F=B.line===r.line?B.column-r.column+l:B.column+1,O=F+C[0].length;if(I[m++]=(0,R.$xB)(new L.$us(a+z,F,a+z,O),C,h),V(C.index)+C[0].length>=y||m>=b)return m}while(C);return m}findMatchesLineByLine(n,u,a,l){const r=[];let s=0;const c=new R.$AB(u.wordSeparators,u.regex);let h=this.H(n.startLineNumber,n.startColumn);if(h===null)return[];const b=this.H(n.endLineNumber,n.endColumn);if(b===null)return[];let m=this.s(h.node,h.remainder);const I=this.s(b.node,b.remainder);if(h.node===b.node)return this.findMatchesInNode(h.node,c,n.startLineNumber,n.startColumn,m,I,u,a,l,s,r),r;let k=n.startLineNumber,d=h.node;for(;d!==b.node;){const y=this.t(d.piece.bufferIndex,m,d.piece.end);if(y>=1){const B=this.a[d.piece.bufferIndex].lineStarts,j=this.u(d.piece.bufferIndex,d.piece.start),V=B[m.line+y],z=k===n.startLineNumber?n.startColumn:1;if(s=this.findMatchesInNode(d,c,k,z,m,this.s(d,V-j),u,a,l,s,r),s>=l)return r;k+=y}const C=k===n.startLineNumber?n.startColumn-1:0;if(k===n.endLineNumber){const B=this.getLineContent(k).substring(C,n.endColumn-1);return s=this.n(u,c,B,n.endLineNumber,C,s,r,a,l),r}if(s=this.n(u,c,this.getLineContent(k).substr(C),k,C,s,r,a,l),s>=l)return r;k++,h=this.H(k,1),d=h.node,m=this.s(h.node,h.remainder)}if(k===n.endLineNumber){const y=k===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(k).substring(y,n.endColumn-1);return s=this.n(u,c,C,n.endLineNumber,y,s,r,a,l),r}const w=k===n.startLineNumber?n.startColumn:1;return s=this.findMatchesInNode(b.node,c,k,w,m,I,u,a,l,s,r),r}n(n,u,a,l,r,s,c,h,b){const m=n.wordSeparators;if(!h&&n.simpleSearch){const k=n.simpleSearch,d=k.length,w=a.length;let y=-d;for(;(y=a.indexOf(k,y+d))!==-1;)if((!m||(0,R.$zB)(m,a,w,y,d))&&(c[s++]=new P.$Lu(new L.$us(l,y+1+r,l,y+1+d+r),null),s>=b))return s;return s}let I;u.reset(0);do if(I=u.next(a),I&&(c[s++]=(0,R.$xB)(new L.$us(l,I.index+1+r,l,I.index+1+I[0].length+r),I,h),s>=b))return s;while(I);return s}insert(n,u,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==M.$mB){const{node:l,remainder:r,nodeStartOffset:s}=this.G(n),c=l.piece,h=c.bufferIndex,b=this.s(l,r);if(l.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&s+c.length===n&&u.length<$){this.F(l,u),this.y();return}if(s===n)this.o(u,l),this.h.validate(n);else if(s+l.piece.length>n){const m=[];let I=new o(c.bufferIndex,b,c.end,this.t(c.bufferIndex,b,c.end),this.u(h,c.end)-this.u(h,b));if(this.K()&&this.M(u)&&this.I(l,r)===10){const y={line:I.start.line+1,column:0};I=new o(I.bufferIndex,y,I.end,this.t(I.bufferIndex,y,I.end),I.length-1),u+=`
`}if(this.K()&&this.L(u))if(this.I(l,r-1)===13){const y=this.s(l,r-1);this.C(l,y),u="\r"+u,l.piece.length===0&&m.push(l)}else this.C(l,b);else this.C(l,b);const k=this.w(u);I.length>0&&this.S(l,I);let d=l;for(let w=0;w<k.length;w++)d=this.S(d,k[w]);this.v(m)}else this.q(u,l)}else{const l=this.w(u);let r=this.T(null,l[0]);for(let s=1;s<l.length;s++)r=this.S(r,l[s])}this.y()}delete(n,u){if(this.j.lineNumber=0,this.j.value="",u<=0||this.root===M.$mB)return;const a=this.G(n),l=this.G(n+u),r=a.node,s=l.node;if(r===s){const k=this.s(r,a.remainder),d=this.s(r,l.remainder);if(a.nodeStartOffset===n){if(u===r.piece.length){const w=r.next();(0,M.$rB)(this,r),this.N(w),this.y();return}this.D(r,d),this.h.validate(n),this.N(r),this.y();return}if(a.nodeStartOffset+r.piece.length===n+u){this.C(r,k),this.O(r),this.y();return}this.E(r,k,d),this.y();return}const c=[],h=this.s(r,a.remainder);this.C(r,h),this.h.validate(n),r.piece.length===0&&c.push(r);const b=this.s(s,l.remainder);this.D(s,b),s.piece.length===0&&c.push(s);const m=r.next();for(let k=m;k!==M.$mB&&k!==s;k=k.next())c.push(k);const I=r.piece.length===0?r.prev():r;this.v(c),this.O(I),this.y()}o(n,u){const a=[];if(this.K()&&this.M(n)&&this.L(u)){const s=u.piece,c={line:s.start.line+1,column:0},h=new o(s.bufferIndex,c,s.end,this.t(s.bufferIndex,c,s.end),s.length-1);u.piece=h,n+=`
`,(0,M.$tB)(this,u,-1,-1),u.piece.length===0&&a.push(u)}const l=this.w(n);let r=this.T(u,l[l.length-1]);for(let s=l.length-2;s>=0;s--)r=this.T(r,l[s]);this.N(r),this.v(a)}q(n,u){this.Q(n,u)&&(n+=`
`);const a=this.w(n),l=this.S(u,a[0]);let r=l;for(let s=1;s<a.length;s++)r=this.S(r,a[s]);this.N(l)}s(n,u,a){const l=n.piece,r=n.piece.bufferIndex,s=this.a[r].lineStarts,h=s[l.start.line]+l.start.column+u;let b=l.start.line,m=l.end.line,I=0,k=0,d=0;for(;b<=m&&(I=b+(m-b)/2|0,d=s[I],I!==m);)if(k=s[I+1],h<d)m=I-1;else if(h>=k)b=I+1;else break;return a?(a.line=I,a.column=h-d,null):{line:I,column:h-d}}t(n,u,a){if(a.column===0)return a.line-u.line;const l=this.a[n].lineStarts;if(a.line===l.length-1)return a.line-u.line;const r=l[a.line+1],s=l[a.line]+a.column;if(r>s+1)return a.line-u.line;const c=s-1;return this.a[n].buffer.charCodeAt(c)===13?a.line-u.line+1:a.line-u.line}u(n,u){return this.a[n].lineStarts[u.line]+u.column}v(n){for(let u=0;u<n.length;u++)(0,M.$rB)(this,n[u])}w(n){if(n.length>$){const m=[];for(;n.length>$;){const k=n.charCodeAt($-1);let d;k===13||k>=55296&&k<=56319?(d=n.substring(0,$-1),n=n.substring($-1)):(d=n.substring(0,$),n=n.substring($));const w=A(d);m.push(new o(this.a.length,{line:0,column:0},{line:w.length-1,column:d.length-w[w.length-1]},w.length-1,d.length)),this.a.push(new v(d,w))}const I=A(n);return m.push(new o(this.a.length,{line:0,column:0},{line:I.length-1,column:n.length-I[I.length-1]},I.length-1,n.length)),this.a.push(new v(n,I)),m}let u=this.a[0].buffer.length;const a=A(n,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===u&&u!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let m=0;m<a.length;m++)a[m]+=u+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+n,u+=1}else{if(u!==0)for(let m=0;m<a.length;m++)a[m]+=u;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=n}const r=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,c=r-this.a[0].lineStarts[s],h={line:s,column:c},b=new o(0,l,h,this.t(0,l,h),r-u);return this.g=h,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,u=0){let a=this.root,l="";const r=this.h.get2(n);if(r){a=r.node;const s=this.B(a,n-r.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);if(r.nodeStartLineNumber+a.piece.lineFeedCnt===n)l=c.substring(h+s,h+a.piece.length);else{const b=this.B(a,n-r.nodeStartLineNumber);return c.substring(h+s,h+b-u)}}else{let s=0;const c=n;for(;a!==M.$mB;)if(a.left!==M.$mB&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const h=this.B(a,n-a.lf_left-2),b=this.B(a,n-a.lf_left-1),m=this.a[a.piece.bufferIndex].buffer,I=this.u(a.piece.bufferIndex,a.piece.start);return s+=a.size_left,this.h.set({node:a,nodeStartOffset:s,nodeStartLineNumber:c-(n-1-a.lf_left)}),m.substring(I+h,I+b-u)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const h=this.B(a,n-a.lf_left-2),b=this.a[a.piece.bufferIndex].buffer,m=this.u(a.piece.bufferIndex,a.piece.start);l=b.substring(m+h,m+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,s+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==M.$mB;){const s=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),h=this.u(a.piece.bufferIndex,a.piece.start);return l+=s.substring(h,h+c-u),l}else{const c=this.u(a.piece.bufferIndex,a.piece.start);l+=s.substr(c,a.piece.length)}a=a.next()}return l}y(){let n=this.root,u=1,a=0;for(;n!==M.$mB;)u+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this.b=u,this.c=a,this.h.validate(this.c)}A(n,u){const a=n.piece,l=this.s(n,u),r=l.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===u){const s=this.t(n.piece.bufferIndex,a.start,l);if(s!==r)return{index:s,remainder:0}}return{index:r,remainder:l.column}}B(n,u){if(u<0)return 0;const a=n.piece,l=this.a[a.bufferIndex].lineStarts,r=a.start.line+u+1;return r>a.end.line?l[a.end.line]+a.end.column-l[a.start.line]-a.start.column:l[r]-l[a.start.line]-a.start.column}C(n,u){const a=n.piece,l=a.lineFeedCnt,r=this.u(a.bufferIndex,a.end),s=u,c=this.u(a.bufferIndex,s),h=this.t(a.bufferIndex,a.start,s),b=h-l,m=c-r,I=a.length+m;n.piece=new o(a.bufferIndex,a.start,s,h,I),(0,M.$tB)(this,n,m,b)}D(n,u){const a=n.piece,l=a.lineFeedCnt,r=this.u(a.bufferIndex,a.start),s=u,c=this.t(a.bufferIndex,s,a.end),h=this.u(a.bufferIndex,s),b=c-l,m=r-h,I=a.length+m;n.piece=new o(a.bufferIndex,s,a.end,c,I),(0,M.$tB)(this,n,m,b)}E(n,u,a){const l=n.piece,r=l.start,s=l.end,c=l.length,h=l.lineFeedCnt,b=u,m=this.t(l.bufferIndex,l.start,b),I=this.u(l.bufferIndex,u)-this.u(l.bufferIndex,r);n.piece=new o(l.bufferIndex,l.start,b,m,I),(0,M.$tB)(this,n,I-c,m-h);const k=new o(l.bufferIndex,a,s,this.t(l.bufferIndex,a,s),this.u(l.bufferIndex,s)-this.u(l.bufferIndex,a)),d=this.S(n,k);this.N(d)}F(n,u){this.Q(u,n)&&(u+=`
`);const a=this.K()&&this.L(u)&&this.M(n),l=this.a[0].buffer.length;this.a[0].buffer+=u;const r=A(u,!1);for(let d=0;d<r.length;d++)r[d]+=l;if(a){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1));const s=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[s],h={line:s,column:c},b=n.piece.length+u.length,m=n.piece.lineFeedCnt,I=this.t(0,n.piece.start,h),k=I-m;n.piece=new o(n.piece.bufferIndex,n.piece.start,h,I,b),this.g=h,(0,M.$tB)(this,n,u.length,k)}G(n){let u=this.root;const a=this.h.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let l=0;for(;u!==M.$mB;)if(u.size_left>n)u=u.left;else if(u.size_left+u.piece.length>=n){l+=u.size_left;const r={node:u,remainder:n-u.size_left,nodeStartOffset:l};return this.h.set(r),r}else n-=u.size_left+u.piece.length,l+=u.size_left+u.piece.length,u=u.right;return null}H(n,u){let a=this.root,l=0;for(;a!==M.$mB;)if(a.left!==M.$mB&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const r=this.B(a,n-a.lf_left-2),s=this.B(a,n-a.lf_left-1);return l+=a.size_left,{node:a,remainder:Math.min(r+u-1,s),nodeStartOffset:l}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const r=this.B(a,n-a.lf_left-2);if(r+u-1<=a.piece.length)return{node:a,remainder:r+u-1,nodeStartOffset:l};u-=a.piece.length-r;break}else n-=a.lf_left+a.piece.lineFeedCnt,l+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==M.$mB;){if(a.piece.lineFeedCnt>0){const r=this.B(a,0),s=this.J(a);return{node:a,remainder:Math.min(u-1,r),nodeStartOffset:s}}else if(a.piece.length>=u-1){const r=this.J(a);return{node:a,remainder:u-1,nodeStartOffset:r}}else u-=a.piece.length;a=a.next()}return null}I(n,u){if(n.piece.lineFeedCnt<1)return-1;const a=this.a[n.piece.bufferIndex],l=this.u(n.piece.bufferIndex,n.piece.start)+u;return a.buffer.charCodeAt(l)}J(n){if(!n)return 0;let u=n.size_left;for(;n!==this.root;)n.parent.right===n&&(u+=n.parent.size_left+n.parent.piece.length),n=n.parent;return u}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$mB||n.piece.lineFeedCnt===0)return!1;const u=n.piece,a=this.a[u.bufferIndex].lineStarts,l=u.start.line,r=a[l]+u.start.column;return l===a.length-1||a[l+1]>r+1?!1:this.a[u.bufferIndex].buffer.charCodeAt(r)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$mB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const u=n.prev();this.M(u)&&this.P(u,n)}}O(n){if(this.K()&&this.M(n)){const u=n.next();this.L(u)&&this.P(n,u)}}P(n,u){const a=[],l=this.a[n.piece.bufferIndex].lineStarts;let r;n.piece.end.column===0?r={line:n.piece.end.line-1,column:l[n.piece.end.line]-l[n.piece.end.line-1]-1}:r={line:n.piece.end.line,column:n.piece.end.column-1};const s=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new o(n.piece.bufferIndex,n.piece.start,r,c,s),(0,M.$tB)(this,n,-1,-1),n.piece.length===0&&a.push(n);const h={line:u.piece.start.line+1,column:0},b=u.piece.length-1,m=this.t(u.piece.bufferIndex,h,u.piece.end);u.piece=new o(u.piece.bufferIndex,h,u.piece.end,m,b),(0,M.$tB)(this,u,-1,-1),u.piece.length===0&&a.push(u);const I=this.w(`\r
`);this.S(n,I[0]);for(let k=0;k<a.length;k++)(0,M.$rB)(this,a[k])}Q(n,u){if(this.K()&&this.M(n)){const a=u.next();if(this.L(a)){if(n+=`
`,a.piece.length===1)(0,M.$rB)(this,a);else{const l=a.piece,r={line:l.start.line+1,column:0},s=l.length-1,c=this.t(l.bufferIndex,r,l.end);a.piece=new o(l.bufferIndex,r,l.end,c,s),(0,M.$tB)(this,a,-1,-1)}return!0}}return!1}iterate(n,u){if(n===M.$mB)return u(M.$mB);const a=this.iterate(n.left,u);return a&&u(n)&&this.iterate(n.right,u)}R(n){if(n===M.$mB)return"";const u=this.a[n.piece.bufferIndex],a=n.piece,l=this.u(a.bufferIndex,a.start),r=this.u(a.bufferIndex,a.end);return u.buffer.substring(l,r)}getPieceContent(n){const u=this.a[n.bufferIndex],a=this.u(n.bufferIndex,n.start),l=this.u(n.bufferIndex,n.end);return u.buffer.substring(a,l)}S(n,u){const a=new M.$lB(u,1);if(a.left=M.$mB,a.right=M.$mB,a.parent=M.$mB,a.size_left=0,a.lf_left=0,this.root===M.$mB)this.root=a,a.color=0;else if(n.right===M.$mB)n.right=a,a.parent=n;else{const r=(0,M.$nB)(n.right);r.left=a,a.parent=r}return(0,M.$sB)(this,a),a}T(n,u){const a=new M.$lB(u,1);if(a.left=M.$mB,a.right=M.$mB,a.parent=M.$mB,a.size_left=0,a.lf_left=0,this.root===M.$mB)this.root=a,a.color=0;else if(n.left===M.$mB)n.left=a,a.parent=n;else{const l=(0,M.$oB)(n.left);l.right=a,a.parent=l}return(0,M.$sB)(this,a),a}U(n){let u="";return this.iterate(n,a=>(u+=this.R(a),!0)),u}}e.$FB=t}),define(Ae[132],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8=e.$f8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$f8=E;class L{constructor(M){this.identifier=M}}e.$g8=L}),define(Ae[133],Re([9,10]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Ae[134],Re([1,0,5,6,133]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;class M extends L.$Rc{constructor(o,v="",p="",f=!0,t){super(),this.h=this.B(new E.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=v,this.u=p,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,v){this.C&&await this.C(o)}}e.$vi=M;class R extends L.$Rc{constructor(){super(...arguments),this.f=this.B(new E.$Nd),this.onWillRun=this.f.event,this.m=this.B(new E.$Nd),this.onDidRun=this.m.event}async run(o,v){if(!o.enabled)return;this.f.fire({action:o});let p;try{await this.u(o,v)}catch(f){p=f}this.m.fire({action:o,error:p})}async u(o,v){await o.run(v)}}e.$wi=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let v=[];for(const p of o)p.length&&(v.length?v=[...v,new $,...p]:v=p);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$xi=$;class D{get actions(){return this.a}constructor(o,v,p,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=v,this.class=f,this.a=p}async run(){}}e.$yi=D;class g extends M{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,P.localize(0,null),void 0,!1)}}e.$zi=g;function A(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...o)=>S.run(...o),tooltip:S.label}}e.$Ai=A}),define(Ae[135],Re([9,10]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Ae[136],Re([1,0,135]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=void 0;const L=60,P=L*60,M=P*24,R=M*7,$=M*30,D=M*365;function g(S,o,v,p){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,E.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!p&&f<30)return(0,E.localize)(1,null);let t;return f<L?(t=f,o?t===1?v?(0,E.localize)(2,null,t):(0,E.localize)(3,null,t):v?(0,E.localize)(4,null,t):(0,E.localize)(5,null,t):t===1?v?(0,E.localize)(6,null,t):(0,E.localize)(7,null,t):v?(0,E.localize)(8,null,t):(0,E.localize)(9,null,t)):f<P?(t=Math.floor(f/L),o?t===1?v?(0,E.localize)(10,null,t):(0,E.localize)(11,null,t):v?(0,E.localize)(12,null,t):(0,E.localize)(13,null,t):t===1?v?(0,E.localize)(14,null,t):(0,E.localize)(15,null,t):v?(0,E.localize)(16,null,t):(0,E.localize)(17,null,t)):f<M?(t=Math.floor(f/P),o?t===1?v?(0,E.localize)(18,null,t):(0,E.localize)(19,null,t):v?(0,E.localize)(20,null,t):(0,E.localize)(21,null,t):t===1?v?(0,E.localize)(22,null,t):(0,E.localize)(23,null,t):v?(0,E.localize)(24,null,t):(0,E.localize)(25,null,t)):f<R?(t=Math.floor(f/M),o?t===1?(0,E.localize)(26,null,t):(0,E.localize)(27,null,t):t===1?(0,E.localize)(28,null,t):(0,E.localize)(29,null,t)):f<$?(t=Math.floor(f/R),o?t===1?v?(0,E.localize)(30,null,t):(0,E.localize)(31,null,t):v?(0,E.localize)(32,null,t):(0,E.localize)(33,null,t):t===1?v?(0,E.localize)(34,null,t):(0,E.localize)(35,null,t):v?(0,E.localize)(36,null,t):(0,E.localize)(37,null,t)):f<D?(t=Math.floor(f/$),o?t===1?v?(0,E.localize)(38,null,t):(0,E.localize)(39,null,t):v?(0,E.localize)(40,null,t):(0,E.localize)(41,null,t):t===1?v?(0,E.localize)(42,null,t):(0,E.localize)(43,null,t):v?(0,E.localize)(44,null,t):(0,E.localize)(45,null,t)):(t=Math.floor(f/D),o?t===1?v?(0,E.localize)(46,null,t):(0,E.localize)(47,null,t):v?(0,E.localize)(48,null,t):(0,E.localize)(49,null,t):t===1?v?(0,E.localize)(50,null,t):(0,E.localize)(51,null,t):v?(0,E.localize)(52,null,t):(0,E.localize)(53,null,t))}e.$em=g;function A(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$fm=A}),define(Ae[137],Re([9,10]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Ae[39],Re([1,0,18,16,137]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function M(S,o){return o&&(S.stack||S.stacktrace)?P.localize(0,null,$(S),R(S.stack)||R(S.stacktrace)):$(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function $(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?P.localize(1,null,S.message):S.message||P.localize(2,null)}function D(S=null,o=!1){if(!S)return P.localize(3,null);if(Array.isArray(S)){const v=E.$Gb(S),p=D(v[0],o);return v.length>1?P.localize(4,null,p,v.length):p}if(L.$yf(S))return S;if(S.detail){const v=S.detail;if(v.error)return M(v.error,o);if(v.exception)return M(v.exception,o)}return S.stack?M(S,o):S.message?S.message:P.localize(5,null)}e.$Bi=D;function g(S){const o=S;return o instanceof Error&&Array.isArray(o.actions)}e.$Ci=g;function A(S,o){let v;return typeof S=="string"?v=new Error(S):v=S,v.actions=o,v}e.$Di=A}),define(Ae[138],Re([1,0,44,19]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=void 0;const P=new E.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(k,d,w=!1){const y=k||"",C=d||"",B=P.value.collator.compare(y,C);return P.value.collatorIsNumeric&&B===0&&y!==C?y<C?-1:1:B}e.$iq=$;function D(k,d){const w=M.value.collator;return k=k||"",d=d||"",a(w,k,d)}e.$jq=D;function g(k,d){const w=M.value.collator;return k=k||"",d=d||"",c(k,d)||a(w,k,d)}e.$kq=g;function A(k,d){const w=M.value.collator;return k=k||"",d=d||"",s(k,d)||a(w,k,d)}e.$lq=A;function S(k,d){return k=k||"",d=d||"",k===d?0:k<d?-1:1}e.$mq=S;function o(k,d){const[w,y]=n(k),[C,B]=n(d);let j=P.value.collator.compare(y,B);if(j===0){if(P.value.collatorIsNumeric&&y!==B)return y<B?-1:1;if(j=P.value.collator.compare(w,C),P.value.collatorIsNumeric&&j===0&&w!==C)return w<C?-1:1}return j}e.$nq=o;function v(k,d){k=k||"",d=d||"";const w=u(k),y=u(d),C=M.value.collator,B=R.value.collator;return a(B,w,y)||a(C,k,d)}e.$oq=v;function p(k,d){k=k||"",d=d||"";const w=u(k),y=u(d),C=M.value.collator,B=R.value.collator;return a(B,w,y)||c(k,d)||a(C,k,d)}e.$pq=p;function f(k,d){k=k||"",d=d||"";const w=u(k),y=u(d),C=M.value.collator,B=R.value.collator;return a(B,w,y)||s(k,d)||a(C,k,d)}e.$qq=f;function t(k,d){k=k||"",d=d||"";const w=u(k).toLowerCase(),y=u(d).toLowerCase();return w!==y?w<y?-1:1:k!==d?k<d?-1:1:0}e.$rq=t;const i=/^(.*?)(\.([^.]*))?$/;function n(k,d=!1){const w=k?i.exec(k):[];let y=[w&&w[1]||"",w&&w[3]||""];return d&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function u(k){const d=k?i.exec(k):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function a(k,d,w){const y=k.compare(d,w);return y!==0?y:d.length!==w.length?d.length<w.length?-1:1:0}function l(k){const d=k.charAt(0);return d.toLocaleUpperCase()!==d}function r(k){const d=k.charAt(0);return d.toLocaleLowerCase()!==d}function s(k,d){return l(k)&&r(d)?-1:r(k)&&l(d)?1:0}function c(k,d){return r(k)&&l(d)?-1:l(k)&&r(d)?1:0}function h(k,d,w=!1){return w||(k=k&&k.toLowerCase(),d=d&&d.toLowerCase()),k===d?0:k<d?-1:1}function b(k,d,w=!1){const y=k.split(L.sep),C=d.split(L.sep),B=y.length-1,j=C.length-1;let V,z;for(let F=0;;F++){if(V=B===F,z=j===F,V&&z)return $(y[F],C[F],w);if(V)return-1;if(z)return 1;const O=h(y[F],C[F],w);if(O!==0)return O}}e.$sq=b;function m(k,d,w){const y=k.toLowerCase(),C=d.toLowerCase(),B=I(k,d,w);if(B)return B;const j=y.endsWith(w),V=C.endsWith(w);if(j!==V)return j?-1:1;const z=$(y,C);return z!==0?z:y.localeCompare(C)}e.$tq=m;function I(k,d,w){const y=k.toLowerCase(),C=d.toLowerCase(),B=y.startsWith(w),j=C.startsWith(w);if(B!==j)return B?-1:1;if(B&&j){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}e.$uq=I}),define(Ae[46],Re([1,0,19,21,13,16]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function R(m){return m===47||m===92}e.$Qf=R;function $(m){return m.replace(/[\\/]/g,E.$fc.sep)}e.$Rf=$;function D(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Sf=D;function g(m,I=E.$fc.sep){if(!m)return"";const k=m.length,d=m.charCodeAt(0);if(R(d)){if(R(m.charCodeAt(1))&&!R(m.charCodeAt(2))){let y=3;const C=y;for(;y<k&&!R(m.charCodeAt(y));y++);if(C!==y&&!R(m.charCodeAt(y+1))){for(y+=1;y<k;y++)if(R(m.charCodeAt(y)))return m.slice(0,y+1).replace(/[\\/]/g,I)}}return I}else if(i(d)&&m.charCodeAt(1)===58)return R(m.charCodeAt(2))?m.slice(0,2)+I:m.slice(0,2);let w=m.indexOf("://");if(w!==-1){for(w+=3;w<k;w++)if(R(m.charCodeAt(w)))return m.slice(0,w+1)}return""}e.$Tf=g;function A(m){if(!L.$j||!m||m.length<5)return!1;let I=m.charCodeAt(0);if(I!==92||(I=m.charCodeAt(1),I!==92))return!1;let k=2;const d=k;for(;k<m.length&&(I=m.charCodeAt(k),I!==92);k++);return!(d===k||(I=m.charCodeAt(k+1),isNaN(I)||I===92))}e.$Uf=A;const S=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(m,I=L.$j){const k=I?S:o;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||I&&v.test(m)||m==="."||m===".."||I&&m[m.length-1]==="."||I&&m.length!==m.trim().length||m.length>255)}e.$Vf=p;function f(m,I,k){const d=m===I;return!k||d?d:!m||!I?!1:(0,P.$2e)(m,I)}e.$Wf=f;function t(m,I,k,d=E.sep){if(m===I)return!0;if(!m||!I||I.length>m.length)return!1;if(k){if(!(0,P.$3e)(m,I))return!1;if(I.length===m.length)return!0;let y=I.length;return I.charAt(I.length-1)===d&&y--,m.charAt(y)===d}return I.charAt(I.length-1)!==d&&(I+=d),m.indexOf(I)===0}e.$Xf=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$Yf=i;function n(m,I){return L.$j&&m.endsWith(":")&&(m+=E.sep),(0,E.$hc)(m)||(m=(0,E.$ic)(I,m)),m=(0,E.$gc)(m),L.$j?(m=(0,P.$Ke)(m,E.sep),m.endsWith(":")&&(m+=E.sep)):(m=(0,P.$Ke)(m,E.sep),m||(m=E.sep)),m}e.$Zf=n;function u(m){const I=(0,E.$gc)(m);return L.$j?m.length>3?!1:a(I)&&(m.length===2||I.charCodeAt(2)===92):I===E.$fc.sep}e.$1f=u;function a(m,I=L.$j){return I?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$2f=a;function l(m,I=L.$j){return a(m,I)?m[0]:void 0}e.$3f=l;function r(m,I,k){return I.length>m.length?-1:m===I?0:(k&&(m=m.toLowerCase(),I=I.toLowerCase()),m.indexOf(I))}e.$4f=r;function s(m){const I=m.split(":");let k,d,w;for(const y of I){const C=Number(y);(0,M.$Cf)(C)?d===void 0?d=C:w===void 0&&(w=C):k=k?[k,y].join(":"):y}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:d!==void 0?d:void 0,column:w!==void 0?w:d!==void 0?1:void 0}}e.$5f=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(m,I,k=8){let d="";for(let y=0;y<k;y++){let C;y===0&&L.$j&&!I&&(k===3||k===4)?C=h:C=c,d+=C.charAt(Math.floor(Math.random()*C.length))}let w;return I?w=`${I}-${d}`:w=d,m?(0,E.$ic)(m,w):w}e.$6f=b}),define(Ae[69],Re([1,0,19]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=e.$Rr=e.$Qr=void 0,e.$Qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const S=(0,E.$nc)(A),o=L[S.toLowerCase()];return o!==void 0?o:R(A)}e.$Rr=M;function R(A){const S=(0,E.$nc)(A);return P[S.toLowerCase()]}e.$Sr=R;function $(A){for(const S in P)if(P[S]===A)return S}e.$Tr=$;const D=/^(.+)\/(.+?)(;.+)?$/;function g(A,S){const o=D.exec(A);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:S?void 0:A}e.$Ur=g}),define(Ae[52],Re([1,0,23,2]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function P(D){return JSON.stringify(D,R)}e.$lh=P;function M(D){let g=JSON.parse(D);return g=$(g),g}e.$mh=M;function R(D,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function $(D,g=0){if(!D||g>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return L.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof E.$be||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let A=0;A<D.length;++A)D[A]=$(D[A],g+1);else for(const A in D)Object.hasOwnProperty.call(D,A)&&(D[A]=$(D[A],g+1))}return D}e.$nh=$}),define(Ae[14],Re([1,0,11,21,2]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var M;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$7f="vscode-tkn",e.$8f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${M.vscodeRemoteResource}`}set(A,S,o){this.a[A]=S,this.b[A]=o}setConnectionToken(A,S){this.c[A]=S}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(t){return E.$Z(t),A}const S=A.authority;let o=this.a[S];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const v=this.b[S],p=this.c[S];let f=`path=${encodeURIComponent(A.path)}`;return typeof p=="string"&&(f+=`&${e.$8f}=${encodeURIComponent(p)}`),P.URI.from({scheme:L.$p?this.d:M.vscodeRemoteResource,authority:`${o}:${v}`,path:this.f,query:f})}}e.$9f=new R,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class ${static{this.a=e.$bg}asBrowserUri(A){const S=this.b(A,pe);return this.uriToBrowserUri(S)}uriToBrowserUri(A){return A.scheme===M.vscodeRemote?e.$9f.rewrite(A):A.scheme===M.file&&(L.$n||L.$q&&L.$h.origin===`${M.vscodeFileResource}://${$.a}`)?A.with({scheme:M.vscodeFileResource,authority:A.authority||$.a,query:null,fragment:null}):A}asFileUri(A){const S=this.b(A,pe);return this.uriToFileUri(S)}uriToFileUri(A){return A.scheme===M.vscodeFileResource?A.with({scheme:M.file,authority:A.authority!==$.a?A.authority:null,query:null,fragment:null}):A}b(A,S){return P.URI.isUri(A)?A:P.URI.parse(S.toUrl(A))}}e.$cg=new $;var D;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const S="vscode-coi";function o(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:P.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const t=f?.get(S);if(t)return A.get(t)}g.getHeadersFromQuery=o;function v(p,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(S,i):p[S]=i}g.addSearchParam=v})(D||(e.COI=D={}))}),define(Ae[24],Re([1,0,46,14,19,21,13,2]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function D(v){return(0,$.$vc)(v,!0)}e.$jg=D;class g{constructor(p){this.a=p}compare(p,f,t=!1){return p===f?0:(0,R.$Ue)(this.getComparisonKey(p,t),this.getComparisonKey(f,t))}isEqual(p,f,t=!1){return p===f?!0:!p||!f?!1:this.getComparisonKey(p,t)===this.getComparisonKey(f,t)}getComparisonKey(p,f=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,f,t=!1){if(p.scheme===f.scheme){if(p.scheme===L.Schemas.file)return E.$Xf(D(p),D(f),this.a(p))&&p.query===f.query&&(t||p.fragment===f.fragment);if((0,e.$Ag)(p.authority,f.authority))return E.$Xf(p.path,f.path,this.a(p),"/")&&p.query===f.query&&(t||p.fragment===f.fragment)}return!1}joinPath(p,...f){return $.URI.joinPath(p,...f)}basenameOrAuthority(p){return(0,e.$sg)(p)||p.authority}basename(p){return P.$fc.basename(p.path)}extname(p){return P.$fc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let f;return p.scheme===L.Schemas.file?f=$.URI.file(P.$lc(D(p))).path:(f=P.$fc.dirname(p.path),p.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),f="/")),p.with({path:f})}normalizePath(p){if(!p.path.length)return p;let f;return p.scheme===L.Schemas.file?f=$.URI.file(P.$gc(D(p))).path:f=P.$fc.normalize(p.path),p.with({path:f})}relativePath(p,f){if(p.scheme!==f.scheme||!(0,e.$Ag)(p.authority,f.authority))return;if(p.scheme===L.Schemas.file){const n=P.$kc(D(p),D(f));return M.$j?E.$Rf(n):n}let t=p.path||"/";const i=f.path||"/";if(this.a(p)){let n=0;for(const u=Math.min(t.length,i.length);n<u&&!(t.charCodeAt(n)!==i.charCodeAt(n)&&t.charAt(n).toLowerCase()!==i.charAt(n).toLowerCase());n++);t=i.substr(0,n)+t.substr(n)}return P.$fc.relative(t,i)}resolvePath(p,f){if(p.scheme===L.Schemas.file){const t=$.URI.file(P.$jc(D(p),f));return p.with({authority:t.authority,path:t.path})}return f=E.$Sf(f),p.with({path:P.$fc.resolve(p.path,f)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,f){return p===f||p!==void 0&&f!==void 0&&(0,R.$2e)(p,f)}hasTrailingPathSeparator(p,f=P.sep){if(p.scheme===L.Schemas.file){const t=D(p);return t.length>E.$Tf(t).length&&t[t.length-1]===f}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,f=P.sep){return(0,e.$Bg)(p,f)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,f=P.sep){let t=!1;if(p.scheme===L.Schemas.file){const i=D(p);t=i!==void 0&&i.length===E.$Tf(i).length&&i[i.length-1]===f}else{f="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Bg)(p,f)?p.with({path:p.path+"/"}):p}}e.$kg=g,e.$lg=new g(()=>!1),e.$mg=new g(v=>v.scheme===L.Schemas.file?!M.$l:!0),e.$ng=new g(v=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function A(v,p){const f=[];for(let t=0;t<v.length;t++){const i=p(v[t]);v.some((n,u)=>u===t?!1:(0,e.$pg)(i,p(n)))||f.push(v[t])}return f}e.$Eg=A;var S;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function p(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(u=>{const[a,l]=u.split(":");a&&l&&t.set(a,l)});const n=f.path.substring(0,f.path.indexOf(";"));return n&&t.set(v.META_DATA_MIME,n),t}v.parseMetaData=p})(S||(e.DataUri=S={}));function o(v,p,f){if(p){let t=v.path;return t&&t[0]!==P.$fc.sep&&(t=P.$fc.sep+t),v.with({scheme:f,authority:p,path:t})}return v.with({scheme:f})}e.$Fg=o}),define(Ae[12],Re([1,0,20,11,5,6,24,21,124]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function g(we){return!!we&&typeof we.then=="function"}e.$Gg=g;function A(we){const ne=new E.$Xd,he=we(ne.token),le=new Promise((ye,ee)=>{const fe=ne.token.onCancellationRequested(()=>{fe.dispose(),ne.dispose(),ee(new L.$4)});Promise.resolve(he).then(ie=>{fe.dispose(),ne.dispose(),ye(ie)},ie=>{fe.dispose(),ne.dispose(),ee(ie)})});return new class{cancel(){ne.cancel()}then(ye,ee){return le.then(ye,ee)}catch(ye){return this.then(void 0,ye)}finally(ye){return le.finally(ye)}}}e.$Hg=A;function S(we,ne,he){return new Promise((le,ye)=>{const ee=ne.onCancellationRequested(()=>{ee.dispose(),le(he)});we.then(le,ye).finally(()=>ee.dispose())})}e.$Ig=S;function o(we,ne){return new Promise((he,le)=>{const ye=ne.onCancellationRequested(()=>{ye.dispose(),le(new L.$4)});we.then(he,le).finally(()=>ye.dispose())})}e.$Jg=o;async function v(we){let ne=-1;const he=we.map((le,ye)=>le.then(ee=>(ne=ye,ee)));try{return await Promise.race(he)}finally{we.forEach((le,ye)=>{ye!==ne&&le.cancel()})}}e.$Kg=v;function p(we,ne,he){let le;const ye=setTimeout(()=>{le?.(void 0),he?.()},ne);return Promise.race([we.finally(()=>clearTimeout(ye)),new Promise(ee=>le=ee)])}e.$Lg=p;function f(we){return new Promise((ne,he)=>{const le=we();g(le)?le.then(ne,he):ne(le)})}e.$Mg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ne){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ne,!this.b){const he=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(he,he).then(le)})}return new Promise((he,le)=>{this.b.then(he,le)})}return this.a=ne(),new Promise((he,le)=>{this.a.then(ye=>{this.a=null,he(ye)},ye=>{this.a=null,le(ye)})})}dispose(){this.f=!0}}e.$Ng=t;class i{constructor(){this.a=Promise.resolve(null)}queue(ne){return this.a=this.a.then(()=>ne(),()=>ne())}}e.$Og=i;class n{constructor(){this.a=new Map}queue(ne,he){const ye=(this.a.get(ne)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(ne)===ye&&this.a.delete(ne)});return this.a.set(ne,ye),ye}}e.$Pg=n;const u=(we,ne)=>{let he=!0;const le=setTimeout(()=>{he=!1,ne()},we);return{isTriggered:()=>he,dispose:()=>{clearTimeout(le),he=!1}}},a=we=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,we())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};class l{constructor(ne){this.defaultDelay=ne,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ne,he=this.defaultDelay){this.g=ne,this.h(),this.b||(this.b=new Promise((ye,ee)=>{this.d=ye,this.f=ee}).then(()=>{if(this.b=null,this.d=null,this.g){const ye=this.g;return this.g=null,ye()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=he===D.$Kd?a(le):u(he,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=l;class r{constructor(ne){this.a=new l(ne),this.b=new t}trigger(ne,he){return this.a.trigger(()=>this.b.queue(ne),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=r;class s{constructor(){this.a=!1,this.b=new Promise((ne,he)=>{this.d=ne})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=s;class c extends s{constructor(ne){super(),this.f=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this.f),super.open()}}e.$Tg=c;function h(we,ne){return ne?new Promise((he,le)=>{const ye=setTimeout(()=>{ee.dispose(),he()},we),ee=ne.onCancellationRequested(()=>{clearTimeout(ye),ee.dispose(),le(new L.$4)})}):A(he=>h(we,he))}e.$Ug=h;function b(we,ne=0,he){const le=setTimeout(()=>{we(),he&&ye.dispose()},ne),ye=(0,M.$Pc)(()=>{clearTimeout(le),he?.deleteAndLeak(ye)});return he?.add(ye),ye}e.$Vg=b;function m(we,ne,he){let le=0;const ye=setInterval(()=>{le++,(le>=he||we())&&ee.dispose()},ne),ee=(0,M.$Pc)(()=>{clearInterval(ye)});return ee}e.$Wg=m;function I(we){const ne=[];let he=0;const le=we.length;function ye(){return he<le?we[he++]():null}function ee(fe){fe!=null&&ne.push(fe);const ie=ye();return ie?ie.then(ee):Promise.resolve(ne)}return Promise.resolve(null).then(ee)}e.$Xg=I;function k(we,ne=le=>!!le,he=null){let le=0;const ye=we.length,ee=()=>{if(le>=ye)return Promise.resolve(he);const fe=we[le++];return Promise.resolve(fe()).then(se=>ne(se)?Promise.resolve(se):ee())};return ee()}e.$Yg=k;function d(we,ne=le=>!!le,he=null){if(we.length===0)return Promise.resolve(he);let le=we.length;const ye=()=>{le=-1;for(const ee of we)ee.cancel?.()};return new Promise((ee,fe)=>{for(const ie of we)ie.then(se=>{--le>=0&&ne(se)?(ye(),ee(se)):le===0&&ee(he)}).catch(se=>{--le>=0&&(ye(),fe(se))})})}e.$Zg=d;class w{constructor(ne){this.a=0,this.d=ne,this.f=[],this.b=0,this.g=new P.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(ne){return this.a++,new Promise((he,le)=>{this.f.push({factory:ne,c:he,e:le}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ne=this.f.shift();this.b++;const he=ne.factory();he.then(ne.c,ne.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=w;class y extends w{constructor(){super(1)}}e.$2g=y;class C{constructor(){this.a=new ke,this.b=0}queue(ne){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ne())):this.a.run(this.b++,ne())}}e.$3g=C;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ne=new be;return this.b.add(ne),ne.p}g(){for(const[,ne]of this.a)if(ne.size>0)return!1;return!0}queueFor(ne,he=R.$lg){const le=he.getComparisonKey(ne);let ye=this.a.get(le);if(!ye){ye=new y;const ee=this.f++,fe=P.Event.once(ye.onDrained)(()=>{ye?.dispose(),this.a.delete(le),this.h(),this.d?.deleteAndDispose(ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(ee,fe),this.a.set(le,ye)}return ye}h(){this.g()&&this.j()}j(){for(const ne of this.b)ne.complete();this.b.clear()}dispose(){for(const[,ne]of this.a)ne.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=B;class j{constructor(ne,he){this.a=-1,typeof ne=="function"&&typeof he=="number"&&this.setIfNotSet(ne,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ne,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ne()},he)}setIfNotSet(ne,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ne()},he))}}e.$5g=j;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ne,he){this.cancel(),this.a=setInterval(()=>{ne()},he)}}e.$6g=V;class z{constructor(ne,he){this.b=-1,this.a=ne,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ne=this.d){this.cancel(),this.b=setTimeout(this.f,ne)}get delay(){return this.d}set delay(ne){this.d=ne}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=z;class F{constructor(ne,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=ne,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ne=this.b){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ne/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=F;class O extends z{constructor(ne,he){super(ne,he),this.j=[]}work(ne){this.j.push(ne),this.isScheduled()||this.schedule()}h(){const ne=this.j;this.j=[],this.a?.(ne)}dispose(){this.j=[],super.dispose()}}e.$9g=O;class x extends M.$Rc{constructor(ne,he){super(),this.g=ne,this.h=he,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(ne){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ne.length>this.g.maxBufferedWork)return!1}else if(this.pending+ne.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of ne)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=x,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=we=>{(0,$.$B)(()=>{if(ne)return;const he=Date.now()+15;we(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$$g=(we,ne)=>{const he=requestIdleCallback(we,typeof ne=="number"?{timeout:ne}:void 0);let le=!1;return{dispose(){le||(le=!0,cancelIdleCallback(he))}}}}();class Z{constructor(ne){this.d=!1,this.a=()=>{try{this.f=ne()}catch(he){this.g=he}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=Z;async function De(we,ne,he){let le;for(let ye=0;ye<he;ye++)try{return await we()}catch(ee){le=ee,await h(ne)}throw le}e.$ah=De;class ke{isRunning(ne){return typeof ne=="number"?this.a?.taskId===ne:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ne,he,le){return this.a={taskId:ne,cancel:()=>le?.(),promise:he},he.then(()=>this.d(ne),()=>this.d(ne)),he}d(ne){this.a&&ne===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ne=this.b;this.b=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}queue(ne){if(this.b)this.b.run=ne;else{let he,le;const ye=new Promise((ee,fe)=>{he=ee,le=fe});this.b={run:ne,promise:ye,promiseResolve:he,promiseReject:le}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=ke;class Ie{constructor(ne,he=()=>Date.now()){this.d=ne,this.f=he,this.a=0,this.b=0}increment(){const ne=this.f();return ne-this.a>this.d&&(this.a=ne,this.b=0),this.b++,this.b}}e.$ch=Ie;var de;(function(we){we[we.Resolved=0]="Resolved",we[we.Rejected=1]="Rejected"})(de||(de={}));class be{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ne,he)=>{this.a=ne,this.b=he})}complete(ne){return new Promise(he=>{this.a(ne),this.d={outcome:0,value:ne},he()})}error(ne){return new Promise(he=>{this.b(ne),this.d={outcome:1,value:ne},he()})}cancel(){return this.error(new L.$4)}}e.$dh=be;var oe;(function(we){async function ne(le){let ye;const ee=await Promise.all(le.map(fe=>fe.then(ie=>ie,ie=>{ye||(ye=ie)})));if(typeof ye<"u")throw ye;return ee}we.settled=ne;function he(le){return new Promise(async(ye,ee)=>{try{await le(ye,ee)}catch(fe){ee(fe)}})}we.withAsyncBody=he})(oe||(e.Promises=oe={}));var ce;(function(we){we[we.Initial=0]="Initial",we[we.DoneOK=1]="DoneOK",we[we.DoneError=2]="DoneError"})(ce||(ce={}));class ve{static fromArray(ne){return new ve(he=>{he.emitMany(ne)})}static fromPromise(ne){return new ve(async he=>{he.emitMany(await ne)})}static fromPromises(ne){return new ve(async he=>{await Promise.all(ne.map(async le=>he.emitOne(await le)))})}static merge(ne){return new ve(async he=>{await Promise.all(ne.map(async le=>{for await(const ye of le)he.emitOne(ye)}))})}static{this.EMPTY=ve.fromArray([])}constructor(ne){this.a=0,this.b=[],this.d=null,this.f=new P.$Nd,queueMicrotask(async()=>{const he={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(ne(he)),this.j()}catch(le){this.k(le)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ne<this.b.length)return{done:!1,value:this.b[ne++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(ne,he){return new ve(async le=>{for await(const ye of ne)le.emitOne(he(ye))})}map(ne){return ve.map(this,ne)}static filter(ne,he){return new ve(async le=>{for await(const ye of ne)he(ye)&&le.emitOne(ye)})}filter(ne){return ve.filter(this,ne)}static coalesce(ne){return ve.filter(ne,he=>!!he)}coalesce(){return ve.coalesce(this)}static async toPromise(ne){const he=[];for await(const le of ne)he.push(le);return he}toPromise(){return ve.toPromise(this)}g(ne){this.a===0&&(this.b.push(ne),this.f.fire())}h(ne){this.a===0&&(this.b=this.b.concat(ne),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ne){this.a===0&&(this.a=2,this.d=ne,this.f.fire())}}e.$eh=ve;class _ extends ve{constructor(ne,he){super(he),this.l=ne}cancel(){this.l.cancel()}}e.$fh=_;function W(we){const ne=new E.$Xd,he=we(ne.token);return new _(ne,async le=>{const ye=ne.token.onCancellationRequested(()=>{ye.dispose(),ne.dispose(),le.reject(new L.$4)});try{for await(const ee of he){if(ne.token.isCancellationRequested)return;le.emitOne(ee)}ye.dispose(),ne.dispose()}catch(ee){ye.dispose(),ne.dispose(),le.reject(ee)}})}e.$gh=W;class ae{constructor(){this.a=new be,this.b=new ve(le=>{if(ne){le.reject(ne);return}return he&&le.emitMany(he),this.d=ye=>le.reject(ye),this.f=ye=>le.emitOne(ye),this.a.p});let ne,he;this.f=le=>{he||(he=[]),he.push(le)},this.d=le=>{ne||(ne=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ne){this.d(ne),this.a.complete()}emitOne(ne){this.f(ne)}}e.$hh=ae}),define(Ae[33],Re([1,0,18,12,46,28,19,21,13]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function g(){return Object.create(null)}e.$sj=g,e.$tj="**",e.$uj="/";const A="[/\\\\]",S="[^/\\\\]",o=/\//g;function v(De,ke){switch(De){case 0:return"";case 1:return`${S}*?`;default:return`(?:${A}|${S}+${A}${ke?`|${A}${S}+`:""})*?`}}function p(De,ke){if(!De)return[];const Ie=[];let de=!1,be=!1,oe="";for(const ce of De){switch(ce){case ke:if(!de&&!be){Ie.push(oe),oe="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":be=!0;break;case"]":be=!1;break}oe+=ce}return oe&&Ie.push(oe),Ie}e.$vj=p;function f(De){if(!De)return"";let ke="";const Ie=p(De,e.$uj);if(Ie.every(de=>de===e.$tj))ke=".*";else{let de=!1;Ie.forEach((be,oe)=>{if(be===e.$tj){if(de)return;ke+=v(2,oe===Ie.length-1)}else{let ce=!1,ve="",_=!1,W="";for(const ae of be){if(ae!=="}"&&ce){ve+=ae;continue}if(_&&(ae!=="]"||!W)){let we;ae==="-"?we=ae:(ae==="^"||ae==="!")&&!W?we="^":ae===e.$uj?we="":we=(0,D.$Fe)(ae),W+=we;continue}switch(ae){case"{":ce=!0;continue;case"[":_=!0;continue;case"}":{const ne=`(?:${p(ve,",").map(he=>f(he)).join("|")})`;ke+=ne,ce=!1,ve="";break}case"]":{ke+="["+W+"]",_=!1,W="";break}case"?":ke+=S;continue;case"*":ke+=v(1);continue;default:ke+=(0,D.$Fe)(ae)}}oe<Ie.length-1&&(Ie[oe+1]!==e.$tj||oe+2<Ie.length)&&(ke+=A)}de=be===e.$tj})}return ke}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.$Cc(1e4),s=function(){return!1},c=function(){return null};function h(De,ke){if(!De)return c;let Ie;typeof De!="string"?Ie=De.pattern:Ie=De,Ie=Ie.trim();const de=`${Ie}_${!!ke.trimForExclusions}`;let be=r.get(de);if(be)return b(be,De);let oe;return t.test(Ie)?be=I(Ie.substr(4),Ie):(oe=i.exec(m(Ie,ke)))?be=k(oe[1],Ie):(ke.trimForExclusions?u:n).test(Ie)?be=d(Ie,ke):(oe=a.exec(m(Ie,ke)))?be=w(oe[1].substr(1),Ie,!0):(oe=l.exec(m(Ie,ke)))?be=w(oe[1],Ie,!1):be=y(Ie),r.set(de,be),b(be,De)}function b(De,ke){if(typeof ke=="string")return De;const Ie=function(de,be){return(0,P.$Xf)(de,ke.base,!$.$l)?De((0,D.$Je)(de.substr(ke.base.length),R.sep),be):null};return Ie.allBasenames=De.allBasenames,Ie.allPaths=De.allPaths,Ie.basenames=De.basenames,Ie.patterns=De.patterns,Ie}function m(De,ke){return ke.trimForExclusions&&De.endsWith("/**")?De.substr(0,De.length-2):De}function I(De,ke){return function(Ie,de){return typeof Ie=="string"&&Ie.endsWith(De)?ke:null}}function k(De,ke){const Ie=`/${De}`,de=`\\${De}`,be=function(ce,ve){return typeof ce!="string"?null:ve?ve===De?ke:null:ce===De||ce.endsWith(Ie)||ce.endsWith(de)?ke:null},oe=[De];return be.basenames=oe,be.patterns=[ke],be.allBasenames=oe,be}function d(De,ke){const Ie=x(De.slice(1,-1).split(",").map(ve=>h(ve,ke)).filter(ve=>ve!==c),De),de=Ie.length;if(!de)return c;if(de===1)return Ie[0];const be=function(ve,_){for(let W=0,ae=Ie.length;W<ae;W++)if(Ie[W](ve,_))return De;return null},oe=Ie.find(ve=>!!ve.allBasenames);oe&&(be.allBasenames=oe.allBasenames);const ce=Ie.reduce((ve,_)=>_.allPaths?ve.concat(_.allPaths):ve,[]);return ce.length&&(be.allPaths=ce),be}function w(De,ke,Ie){const de=R.sep===R.$fc.sep,be=de?De:De.replace(o,R.sep),oe=R.sep+be,ce=R.$fc.sep+De;let ve;return Ie?ve=function(_,W){return typeof _=="string"&&(_===be||_.endsWith(oe)||!de&&(_===De||_.endsWith(ce)))?ke:null}:ve=function(_,W){return typeof _=="string"&&(_===be||!de&&_===De)?ke:null},ve.allPaths=[(Ie?"*/":"./")+De],ve}function y(De){try{const ke=new RegExp(`^${f(De)}$`);return function(Ie){return ke.lastIndex=0,typeof Ie=="string"&&ke.test(Ie)?De:null}}catch{return c}}function C(De,ke,Ie){return!De||typeof ke!="string"?!1:B(De)(ke,void 0,Ie)}e.$wj=C;function B(De,ke={}){if(!De)return s;if(typeof De=="string"||j(De)){const Ie=h(De,ke);if(Ie===c)return s;const de=function(be,oe){return!!Ie(be,oe)};return Ie.allBasenames&&(de.allBasenames=Ie.allBasenames),Ie.allPaths&&(de.allPaths=Ie.allPaths),de}return F(De,ke)}e.$xj=B;function j(De){const ke=De;return ke?typeof ke.base=="string"&&typeof ke.pattern=="string":!1}e.$yj=j;function V(De){return De.allBasenames||[]}e.$zj=V;function z(De){return De.allPaths||[]}e.$Aj=z;function F(De,ke){const Ie=x(Object.getOwnPropertyNames(De).map(ve=>O(ve,De[ve],ke)).filter(ve=>ve!==c)),de=Ie.length;if(!de)return c;if(!Ie.some(ve=>!!ve.requiresSiblings)){if(de===1)return Ie[0];const ve=function(ae,we){let ne;for(let he=0,le=Ie.length;he<le;he++){const ye=Ie[he](ae,we);if(typeof ye=="string")return ye;(0,L.$Gg)(ye)&&(ne||(ne=[]),ne.push(ye))}return ne?(async()=>{for(const he of ne){const le=await he;if(typeof le=="string")return le}return null})():null},_=Ie.find(ae=>!!ae.allBasenames);_&&(ve.allBasenames=_.allBasenames);const W=Ie.reduce((ae,we)=>we.allPaths?ae.concat(we.allPaths):ae,[]);return W.length&&(ve.allPaths=W),ve}const be=function(ve,_,W){let ae,we;for(let ne=0,he=Ie.length;ne<he;ne++){const le=Ie[ne];le.requiresSiblings&&W&&(_||(_=(0,R.$mc)(ve)),ae||(ae=_.substr(0,_.length-(0,R.$nc)(ve).length)));const ye=le(ve,_,ae,W);if(typeof ye=="string")return ye;(0,L.$Gg)(ye)&&(we||(we=[]),we.push(ye))}return we?(async()=>{for(const ne of we){const he=await ne;if(typeof he=="string")return he}return null})():null},oe=Ie.find(ve=>!!ve.allBasenames);oe&&(be.allBasenames=oe.allBasenames);const ce=Ie.reduce((ve,_)=>_.allPaths?ve.concat(_.allPaths):ve,[]);return ce.length&&(be.allPaths=ce),be}function O(De,ke,Ie){if(ke===!1)return c;const de=h(De,Ie);if(de===c)return c;if(typeof ke=="boolean")return de;if(ke){const be=ke.when;if(typeof be=="string"){const oe=(ce,ve,_,W)=>{if(!W||!de(ce,ve))return null;const ae=be.replace("$(basename)",()=>_),we=W(ae);return(0,L.$Gg)(we)?we.then(ne=>ne?De:null):we?De:null};return oe.requiresSiblings=!0,oe}}return de}function x(De,ke){const Ie=De.filter(ve=>!!ve.basenames);if(Ie.length<2)return De;const de=Ie.reduce((ve,_)=>{const W=_.basenames;return W?ve.concat(W):ve},[]);let be;if(ke){be=[];for(let ve=0,_=de.length;ve<_;ve++)be.push(ke)}else be=Ie.reduce((ve,_)=>{const W=_.patterns;return W?ve.concat(W):ve},[]);const oe=function(ve,_){if(typeof ve!="string")return null;if(!_){let ae;for(ae=ve.length;ae>0;ae--){const we=ve.charCodeAt(ae-1);if(we===47||we===92)break}_=ve.substr(ae)}const W=de.indexOf(_);return W!==-1?be[W]:null};oe.basenames=de,oe.patterns=be,oe.allBasenames=de;const ce=De.filter(ve=>!ve.basenames);return ce.push(oe),ce}function Z(De,ke){return(0,E.$tb)(De,ke,(Ie,de)=>typeof Ie=="string"&&typeof de=="string"?Ie===de:typeof Ie!="string"&&typeof de!="string"?Ie.base===de.base&&Ie.pattern===de.pattern:!1)}e.$Bj=Z}),define(Ae[53],Re([1,0,11,125,24,13,2]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class D{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,E.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=o(this.supportThemeIcons?(0,L.$Xj)(i):i).replace(/([ \t]+)/g,(u,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(i,n,u){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(i,n){const u=new RegExp((0,M.$Fe)(n),"g");return i.replace(u,(a,l)=>i.charAt(l-1)!=="\\"?`\\${a}`:a)}}e.$4j=D;function g(t){return A(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$5j=g;function A(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$6j=A;function S(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.$og)(R.URI.from(t.baseUri),R.URI.from(i.baseUri)))}e.$7j=S;function o(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$8j=o;function v(t){return t.replace(/"/g,"&quot;")}e.$9j=v;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$0j=p;function f(t){const i=[],n=t.split("|").map(a=>a.trim());t=n[0];const u=n[1];if(u){const a=/height=(\d+)/.exec(u),l=/width=(\d+)/.exec(u),r=a?a[1]:"",s=l?l[1]:"",c=isFinite(parseInt(s)),h=isFinite(parseInt(r));c&&i.push(`width="${s}"`),h&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$$j=f}),define(Ae[94],Re([1,0,18,46,19,21,24,13]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=void 0;function D(h,b){const{os:m,tildify:I,relative:k}=b;if(k){const y=g(h,k,m);if(typeof y=="string")return y}let d=h.fsPath;if(m===1&&!M.$j?d=d.replace(/\//g,"\\"):m!==1&&M.$j&&(d=d.replace(/\\/g,"/")),m!==1&&I?.userHome){const y=I.userHome.fsPath;let C;h.scheme!==I.userHome.scheme&&h.path[0]===P.$fc.sep&&h.path[1]!==P.$fc.sep?C=I.userHome.with({path:h.path}).fsPath:C=d,d=o(C,y,m)}return(m===1?P.$ec:P.$fc).normalize(A(d,m===1))}e.$sv=D;function g(h,b,m){const I=m===1?P.$ec:P.$fc,k=m===3?R.$lg:R.$ng,d=b.getWorkspace(),w=(0,E.$Nb)(d.folders);if(!w)return;h.scheme!==w.uri.scheme&&h.path[0]===P.$fc.sep&&h.path[1]!==P.$fc.sep&&(h=w.uri.with({path:h.path}));const y=b.getWorkspaceFolder(h);if(!y)return;let C;if(k.isEqual(y.uri,h)?C="":C=k.relativePath(y.uri,h)??"",C&&(C=I.normalize(C)),d.folders.length>1&&!b.noPrefix){const B=y.name?y.name:k.basenameOrAuthority(y.uri);C=C?`${B} \u2022 ${C}`:B}return C}function A(h,b=M.$j){return(0,L.$2f)(h,b)?h.charAt(0).toUpperCase()+h.slice(1):h}e.$tv=A;let S=Object.create(null);function o(h,b,m=M.OS){if(m===1||!h||!b)return h;let I=S.original===b?S.normalized:void 0;I||(I=b,M.$j&&(I=(0,L.$Rf)(I)),I=`${(0,$.$Ke)(I,P.$fc.sep)}${P.$fc.sep}`,S={original:b,normalized:I});let k=h;return M.$j&&(k=(0,L.$Rf)(k)),(m===3?k.startsWith(I):(0,$.$3e)(k,I))?`~/${k.substr(I.length)}`:h}e.$uv=o;function v(h,b){return h.replace(/^~($|\/|\\)/,`${b}$1`)}e.$vv=v;const p="\u2026",f="\\\\",t="~";function i(h,b=P.sep){const m=new Array(h.length);let I=!1;for(let k=0;k<h.length;k++){const d=h[k];if(d===""){m[k]=`.${b}`;continue}if(!d){m[k]=d;continue}I=!0;let w="",y=d;y.indexOf(f)===0?(w=y.substr(0,y.indexOf(f)+f.length),y=y.substr(y.indexOf(f)+f.length)):y.indexOf(b)===0?(w=y.substr(0,y.indexOf(b)+b.length),y=y.substr(y.indexOf(b)+b.length)):y.indexOf(t)===0&&(w=y.substr(0,y.indexOf(t)+t.length),y=y.substr(y.indexOf(t)+t.length));const C=y.split(b);for(let B=1;I&&B<=C.length;B++)for(let j=C.length-B;I&&j>=0;j--){I=!1;let V=C.slice(j,j+B).join(b);for(let z=0;!I&&z<h.length;z++)if(z!==k&&h[z]&&h[z].indexOf(V)>-1){const F=j+B===C.length,O=j>0&&h[z].indexOf(b)>-1?b+V:V,x=h[z].endsWith(O);I=!F||x}if(!I){let z="";(C[0].endsWith(":")||w!=="")&&(j===1&&(j=0,B++,V=C[0]+b+V),j>0&&(z=C[0]+b),z=w+z),j>0&&(z=z+p+b),z=z+V,j+B<C.length&&(z=z+b+p),m[k]=z}}I&&(m[k]=d)}return m}e.$wv=i;var n;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function u(h,b=Object.create(null)){const m=[];let I=!1,k="";for(const d of h)if(d==="$"||I&&d==="{")k&&m.push({value:k,type:n.TEXT}),k="",I=!0;else if(d==="}"&&I){const w=b[k];if(typeof w=="string")w.length&&m.push({value:w,type:n.VARIABLE});else if(w){const y=m[m.length-1];(!y||y.type!==n.SEPARATOR)&&m.push({value:w.label,type:n.SEPARATOR})}k="",I=!1}else k+=d;return k&&!I&&m.push({value:k,type:n.TEXT}),m.filter((d,w)=>{if(d.type===n.SEPARATOR){const y=m[w-1],C=m[w+1];return[y,C].every(B=>B&&(B.type===n.VARIABLE||B.type===n.TEXT)&&B.value.length>0)}return!0}).map(d=>d.value).join("")}e.$xv=u;function a(h,b){return M.$k||b?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$k?"&":"&&"):h.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$yv=a;function l(h,b){return M.$k||b?h.replace(/\(&&\w\)|&&/g,""):M.$j?h.replace(/&&|&/g,m=>m==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.$zv=l;function r(h){return h.replace(/&/g,"&&")}e.$Av=r;function s(h){if(h.endsWith("]")){const b=h.lastIndexOf(" [",h.length-2);if(b!==-1){const m=c(h.substring(0,b));return{name:m.name,parentPath:m.parentPath+h.substring(b)}}}return c(h)}e.$Bv=s;function c(h){const b=h.indexOf("/")!==-1?P.$fc:P.$ec,m=b.basename(h),I=b.dirname(h);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[139],Re([1,0,23,2]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=void 0;function P(S){return S.toJSON()}class M{constructor(o){this.a=o}transformIncoming(o){const v=this.a.transformIncoming(o);return v===o?o:P(L.URI.from(v))}transformOutgoing(o){const v=this.a.transformOutgoing(o);return v===o?o:P(L.URI.from(v))}transformOutgoingURI(o){const v=this.a.transformOutgoing(o);return v===o?o:L.URI.from(v)}transformOutgoingScheme(o){return this.a.transformOutgoingScheme(o)}}e.$Mm=M,e.$Nm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,o,v){if(!S||v>200)return null;if(typeof S=="object"){if(S instanceof L.URI)return o.transformOutgoing(S);for(const p in S)if(Object.hasOwnProperty.call(S,p)){const f=R(S[p],o,v+1);f!==null&&(S[p]=f)}}return null}function $(S,o){const v=R(S,o,0);return v===null?S:v}e.$Om=$;function D(S,o,v,p){if(!S||p>200)return null;if(typeof S=="object"){if(S.$mid===1)return v?L.URI.revive(o.transformIncoming(S)):o.transformIncoming(S);if(S instanceof E.$be)return null;for(const f in S)if(Object.hasOwnProperty.call(S,f)){const t=D(S[f],o,v,p+1);t!==null&&(S[f]=t)}}return null}function g(S,o){const v=D(S,o,!1,0);return v===null?S:v}e.$Pm=g;function A(S,o){const v=D(S,o,!0,0);return v===null?S:v}e.$Qm=A}),define(Ae[140],Re([1,0,13,21,23]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=e.$Ms=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function D(){return $||($=new TextDecoder("UTF-16BE")),$}let g;function A(){return g||(g=L.$D()?R():D()),g}e.$Ms=A;function S(p,f,t){const i=new Uint16Array(p.buffer,f,t);return t>0&&(i[0]===65279||i[0]===65534)?o(p,f,t):R().decode(i)}e.$Ns=S;function o(p,f,t){const i=[];let n=0;for(let u=0;u<t;u++){const a=P.$de(p,f);f+=2,i[n++]=String.fromCharCode(a)}return i.join("")}class v{constructor(f){this.a=f|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const f=new Uint16Array(this.b.buffer,0,this.d);return A().decode(f)}f(){const f=this.e();this.d=0,this.c===null?this.c=[f]:this.c[this.c.length]=f}appendCharCode(f){const t=this.a-this.d;t<=1&&(t===0||E.$6e(f))&&this.f(),this.b[this.d++]=f}appendASCIICharCode(f){this.d===this.a&&this.f(),this.b[this.d++]=f}appendString(f){const t=f.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=f;return}for(let i=0;i<t;i++)this.b[this.d++]=f.charCodeAt(i)}}e.$Os=v}),define(Ae[141],Re([1,0,23,140]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=void 0;function P(D){return D.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,S,o){this.oldPosition=g,this.oldText=A,this.newPosition=S,this.newText=o}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,S){const o=A.length;E.$ge(g,o,S),S+=4;for(let v=0;v<o;v++)E.$ee(g,A.charCodeAt(v),S),S+=2;return S}static d(g,A){const S=E.$fe(g,A);return A+=4,(0,L.$Ns)(g,A,S)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(g,A){return E.$ge(g,this.oldPosition,A),A+=4,E.$ge(g,this.newPosition,A),A+=4,A=M.c(g,this.oldText,A),A=M.c(g,this.newText,A),A}static read(g,A,S){const o=E.$fe(g,A);A+=4;const v=E.$fe(g,A);A+=4;const p=M.d(g,A);A+=M.a(p);const f=M.d(g,A);return A+=M.a(f),S.push(new M(o,p,v,f)),A}}e.$Ps=M;function R(D,g){return D===null||D.length===0?g:new $(D,g).compress()}e.$Qs=R;class ${constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,S=this.n(g),o=this.l(A);for(;g<this.f||A<this.h;){if(S===null){this.k(o),o=this.l(++A);continue}if(o===null){this.m(S),S=this.n(++g);continue}if(o.oldEnd<=S.newPosition){this.k(o),o=this.l(++A);continue}if(S.newEnd<=o.oldPosition){this.m(S),S=this.n(++g);continue}if(o.oldPosition<S.newPosition){const[i,n]=$.r(o,S.newPosition-o.oldPosition);this.k(i),o=n;continue}if(S.newPosition<o.oldPosition){const[i,n]=$.q(S,o.oldPosition-S.newPosition);this.m(i),S=n;continue}let f,t;if(o.oldEnd===S.newEnd)f=S,t=o,S=this.n(++g),o=this.l(++A);else if(o.oldEnd<S.newEnd){const[i,n]=$.q(S,o.oldLength);f=i,t=o,S=n,o=this.l(++A)}else{const[i,n]=$.r(o,S.newLength);f=S,t=i,S=this.n(++g),o=n}this.d[this.e++]=new M(f.oldPosition,f.oldText,t.newPosition,t.newText),this.g+=f.newLength-f.oldLength,this.j+=t.newLength-t.oldLength}const v=$.s(this.d);return $.t(v)}k(g){this.d[this.e++]=$.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=$.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new M(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new M(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const S=g.newText.substr(0,A),o=g.newText.substr(A);return[new M(g.oldPosition,g.oldText,g.newPosition,S),new M(g.oldEnd,"",g.newPosition+A,o)]}static r(g,A){const S=g.oldText.substr(0,A),o=g.oldText.substr(A);return[new M(g.oldPosition,S,g.newPosition,g.newText),new M(g.oldPosition+A,o,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let S=0,o=g[0];for(let v=1;v<g.length;v++){const p=g[v];o.oldEnd===p.oldPosition?o=new M(o.oldPosition,o.oldText+p.oldText,o.newPosition,o.newText+p.newText):(A[S++]=o,o=p)}return A[S++]=o,A}static t(g){if(g.length===0)return g;const A=[];let S=0;for(let o=0;o<g.length;o++){const v=g[o];v.oldText!==v.newText&&(A[S++]=v)}return A}}}),define(Ae[142],Re([1,0,33,19]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EE=void 0;function P(M,R,$,D,g,A){if(Array.isArray(M)){let S=0;for(const o of M){const v=P(o,R,$,D,g,A);if(v===10)return v;v>S&&(S=v)}return S}else{if(typeof M=="string")return D?M==="*"?5:M===$?10:0:0;if(M){const{language:S,pattern:o,scheme:v,hasAccessToAllModels:p,notebookType:f}=M;if(!D&&!p)return 0;f&&g&&(R=g);let t=0;if(v)if(v===R.scheme)t=10;else if(v==="*")t=5;else return 0;if(S)if(S===$)t=10;else if(S==="*")t=Math.max(t,5);else return 0;if(f)if(f===A)t=10;else if(f==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(o){let i;if(typeof o=="string"?i=o:i={...o,base:(0,L.$gc)(o.base)},i===R.fsPath||(0,E.$wj)(i,R.fsPath))t=10;else return 0}return t}else return 0}}e.$EE=P}),define(Ae[143],Re([1,0,5,13,29,92,91,127,141,6]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GB=void 0;class A extends g.$Rc{constructor(o,v,p,f,t,i,n){super(),this.m=this.B(new E.$Nd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!i,this.g=f,this.h=t,this.c=new R.$FB(o,p,n)}equals(o){return!(o instanceof A)||this.f!==o.f||this.getEOL()!==o.getEOL()?!1:this.c.equal(o.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(o){return this.c.createSnapshot(o?this.f:"")}getOffsetAt(o,v){return this.c.getOffsetAt(o,v)}getPositionAt(o){return this.c.getPositionAt(o)}getRangeAt(o,v){const p=o+v,f=this.getPositionAt(o),t=this.getPositionAt(p);return new P.$us(f.lineNumber,f.column,t.lineNumber,t.column)}getValueInRange(o,v=0){if(o.isEmpty())return"";const p=this.n(v);return this.c.getValueInRange(o,p)}getValueLengthInRange(o,v=0){if(o.isEmpty())return 0;if(o.startLineNumber===o.endLineNumber)return o.endColumn-o.startColumn;const p=this.getOffsetAt(o.startLineNumber,o.startColumn),f=this.getOffsetAt(o.endLineNumber,o.endColumn);let t=0;const i=this.n(v),n=this.getEOL();if(i.length!==n.length){const u=i.length-n.length,a=o.endLineNumber-o.startLineNumber;t=u*a}return f-p+t}getCharacterCountInRange(o,v=0){if(this.j){let p=0;const f=o.startLineNumber,t=o.endLineNumber;for(let i=f;i<=t;i++){const n=this.getLineContent(i),u=i===f?o.startColumn-1:0,a=i===t?o.endColumn-1:n.length;for(let l=u;l<a;l++)L.$6e(n.charCodeAt(l))?(p=p+1,l=l+1):p=p+1}return p+=this.n(v).length*(t-f),p}return this.getValueLengthInRange(o,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(o){return this.c.getLineContent(o)}getLineCharCode(o,v){return this.c.getLineCharCode(o,v)}getCharCode(o){return this.c.getCharCode(o)}getLineLength(o){return this.c.getLineLength(o)}getLineMinColumn(o){return 1}getLineMaxColumn(o){return this.getLineLength(o)+1}getLineFirstNonWhitespaceColumn(o){const v=L.$Qe(this.getLineContent(o));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(o){const v=L.$Se(this.getLineContent(o));return v===-1?0:v+2}n(o){switch(o){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(o){this.c.setEOL(o)}applyEdits(o,v,p){let f=this.g,t=this.h,i=this.j,n=!0,u=[];for(let b=0;b<o.length;b++){const m=o[b];n&&m._isTracked&&(n=!1);const I=m.range;if(m.text){let C=!0;i||(C=!L.$ef(m.text),i=C),!f&&C&&(f=L.$df(m.text)),!t&&C&&(t=L.$gf(m.text))}let k="",d=0,w=0,y=0;if(m.text){let C;[d,w,y,C]=(0,$.$7s)(m.text);const B=this.getEOL();C===0||C===(B===`\r
`?2:1)?k=m.text:k=m.text.replace(/\r\n|\r|\n/g,B)}u[b]={sortIndex:b,identifier:m.identifier||null,range:I,rangeOffset:this.getOffsetAt(I.startLineNumber,I.startColumn),rangeLength:this.getValueLengthInRange(I),text:k,eolCount:d,firstLineLength:w,lastLineLength:y,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}u.sort(A.u);let a=!1;for(let b=0,m=u.length-1;b<m;b++){const I=u[b].range.getEndPosition(),k=u[b+1].range.getStartPosition();if(k.isBeforeOrEqual(I)){if(k.isBefore(I))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(u=this.s(u));const l=p||v?A._getInverseEditRanges(u):[],r=[];if(v)for(let b=0;b<u.length;b++){const m=u[b],I=l[b];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let k=I.startLineNumber;k<=I.endLineNumber;k++){let d="";k===I.startLineNumber&&(d=this.getLineContent(m.range.startLineNumber),L.$Qe(d)!==-1)||r.push({lineNumber:k,oldContent:d})}}let s=null;if(p){let b=0;s=[];for(let m=0;m<u.length;m++){const I=u[m],k=l[m],d=this.getValueInRange(I.range),w=I.rangeOffset+b;b+=I.text.length-d.length,s[m]={sortIndex:I.sortIndex,identifier:I.identifier,range:k,text:d,textChange:new D.$Ps(I.rangeOffset,d,w,I.text)}}a||s.sort((m,I)=>m.sortIndex-I.sortIndex)}this.g=f,this.h=t,this.j=i;const c=this.t(u);let h=null;if(v&&r.length>0){r.sort((b,m)=>m.lineNumber-b.lineNumber),h=[];for(let b=0,m=r.length;b<m;b++){const I=r[b].lineNumber;if(b>0&&r[b-1].lineNumber===I)continue;const k=r[b].oldContent,d=this.getLineContent(I);d.length===0||d===k||L.$Qe(d)!==-1||h.push(I)}}return this.m.fire(),new M.$Pu(s,c,h)}s(o){return o.length<1e3?o:[this._toSingleEditOperation(o)]}_toSingleEditOperation(o){let v=!1;const p=o[0].range,f=o[o.length-1].range,t=new P.$us(p.startLineNumber,p.startColumn,f.endLineNumber,f.endColumn);let i=p.startLineNumber,n=p.startColumn;const u=[];for(let c=0,h=o.length;c<h;c++){const b=o[c],m=b.range;v=v||b.forceMoveMarkers,u.push(this.getValueInRange(new P.$us(i,n,m.startLineNumber,m.startColumn))),b.text.length>0&&u.push(b.text),i=m.endLineNumber,n=m.endColumn}const a=u.join(""),[l,r,s]=(0,$.$7s)(a);return{sortIndex:0,identifier:o[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:a,eolCount:l,firstLineLength:r,lastLineLength:s,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(o){o.sort(A.w);const v=[];for(let p=0;p<o.length;p++){const f=o[p],t=f.range.startLineNumber,i=f.range.startColumn,n=f.range.endLineNumber,u=f.range.endColumn;if(t===n&&i===u&&f.text.length===0)continue;f.text?(this.c.delete(f.rangeOffset,f.rangeLength),this.c.insert(f.rangeOffset,f.text,!0)):this.c.delete(f.rangeOffset,f.rangeLength);const a=new P.$us(t,i,n,u);v.push({range:a,rangeLength:f.rangeLength,text:f.text,rangeOffset:f.rangeOffset,forceMoveMarkers:f.forceMoveMarkers})}return v}findMatchesLineByLine(o,v,p,f){return this.c.findMatchesLineByLine(o,v,p,f)}getPieceTree(){return this.c}static _getInverseEditRange(o,v){const p=o.startLineNumber,f=o.startColumn,[t,i,n]=(0,$.$7s)(v);let u;if(v.length>0){const a=t+1;a===1?u=new P.$us(p,f,p,f+i):u=new P.$us(p,f,p+a-1,n+1)}else u=new P.$us(p,f,p,f);return u}static _getInverseEditRanges(o){const v=[];let p=0,f=0,t=null;for(let i=0,n=o.length;i<n;i++){const u=o[i];let a,l;t?t.range.endLineNumber===u.range.startLineNumber?(a=p,l=f+(u.range.startColumn-t.range.endColumn)):(a=p+(u.range.startLineNumber-t.range.endLineNumber),l=u.range.startColumn):(a=u.range.startLineNumber,l=u.range.startColumn);let r;if(u.text.length>0){const s=u.eolCount+1;s===1?r=new P.$us(a,l,a,l+u.firstLineLength):r=new P.$us(a,l,a+s-1,u.lastLineLength+1)}else r=new P.$us(a,l,a,l);p=r.endLineNumber,f=r.endColumn,v.push(r),t=u}return v}static u(o,v){const p=P.$us.compareRangesUsingEnds(o.range,v.range);return p===0?o.sortIndex-v.sortIndex:p}static w(o,v){const p=P.$us.compareRangesUsingEnds(o.range,v.range);return p===0?v.sortIndex-o.sortIndex:-p}}e.$GB=A}),define(Ae[144],Re([1,0,13,91,143]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HB=void 0;class M{constructor(D,g,A,S,o,v,p,f,t){this.a=D,this.b=g,this.c=A,this.d=S,this.e=o,this.f=v,this.g=p,this.h=f,this.j=t}k(D){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?D===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(D){const g=this.k(D),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let o=0,v=A.length;o<v;o++){const p=A[o].buffer.replace(/\r\n|\r|\n/g,g),f=(0,L.$BB)(p);A[o]=new L.$EB(p,f)}const S=new P.$GB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(D){return this.a[0].buffer.substr(0,D).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(D){if(D.length===0)return;this.a.length===0&&E.$mf(D)&&(this.b=E.$lf,D=D.substr(1));const g=D.charCodeAt(D.length-1);g===13||g>=55296&&g<=56319?(this.m(D.substr(0,D.length-1),!1),this.c=!0,this.d=g):(this.m(D,!1),this.c=!1,this.d=g)}m(D,g){!g&&D.length===0||(this.c?this.n(String.fromCharCode(this.d)+D):this.n(D))}n(D){const g=(0,L.$CB)(this.e,D);this.a.push(new L.$EB(D,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=E.$df(D)),this.k||(this.k=E.$gf(D)))}finish(D=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,D)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const D=this.a[this.a.length-1];D.buffer+=String.fromCharCode(this.d);const g=(0,L.$BB)(D.buffer);D.lineStarts=g,this.d===13&&this.f++}}}e.$HB=R}),define(Ae[95],Re([1,0,23,21]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$=e.$o$=void 0;var P;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(P||(P={}));function M(S){for(let o=0,v=S.length;o<v;o+=4){const p=S[o+0],f=S[o+1],t=S[o+2],i=S[o+3];S[o+0]=i,S[o+1]=t,S[o+2]=f,S[o+3]=p}}function R(S){const o=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return L.$D()||M(o),E.$be.wrap(o)}function $(S){const o=S.buffer;if(L.$D()||M(o),o.byteOffset%4===0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const v=new Uint8Array(o.byteLength);return v.set(o),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function D(S){const o=new Uint32Array(g(S));let v=0;if(o[v++]=S.id,S.type==="full")o[v++]=1,o[v++]=S.data.length,o.set(S.data,v),v+=S.data.length;else{o[v++]=2,o[v++]=S.deltas.length;for(const p of S.deltas)o[v++]=p.start,o[v++]=p.deleteCount,p.data?(o[v++]=p.data.length,o.set(p.data,v),v+=p.data.length):o[v++]=0}return R(o)}e.$o$=D;function g(S){let o=0;if(o+=1+1,S.type==="full")o+=1+S.data.length;else{o+=1,o+=(1+1+1)*S.deltas.length;for(const v of S.deltas)v.data&&(o+=v.data.length)}return o}function A(S){const o=$(S);let v=0;const p=o[v++];if(o[v++]===1){const n=o[v++],u=o.subarray(v,v+n);return v+=n,{id:p,type:"full",data:u}}const t=o[v++],i=[];for(let n=0;n<t;n++){const u=o[v++],a=o[v++],l=o[v++];let r;l>0&&(r=o.subarray(v,v+l),v+=l),i[n]={start:u,deleteCount:a,data:r}}return{id:p,type:"delta",deltas:i}}e.$p$=A}),define(Ae[145],Re([9,10]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Ae[146],Re([1,0,18,26,21,128,147,145]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(J){this.c=J}hasChanged(J){return this.c[J]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class S{constructor(J,Ee,je,Oe){this.id=J,this.name=Ee,this.defaultValue=je,this.schema=Oe}applyUpdate(J,Ee){return v(J,Ee)}compute(J,Ee,je){return je}}class o{constructor(J,Ee){this.newValue=J,this.didChange=Ee}}e.ApplyUpdateResult=o;function v(X,J){if(typeof X!="object"||typeof J!="object"||!X||!J)return new o(J,X!==J);if(Array.isArray(X)||Array.isArray(J)){const je=Array.isArray(X)&&Array.isArray(J)&&E.$tb(X,J);return new o(J,!je)}let Ee=!1;for(const je in J)if(J.hasOwnProperty(je)){const Oe=v(X[je],J[je]);Oe.didChange&&(X[je]=Oe.newValue,Ee=!0)}return new o(X,Ee)}class p{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,Ee){return v(J,Ee)}validate(J){return this.defaultValue}}class f{constructor(J,Ee,je,Oe){this.id=J,this.name=Ee,this.defaultValue=je,this.schema=Oe}applyUpdate(J,Ee){return v(J,Ee)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,Ee,je){return je}}function t(X,J){return typeof X>"u"?J:X==="false"?!1:!!X}e.boolean=t;class i extends f{constructor(J,Ee,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=je),super(J,Ee,je,Oe)}validate(J){return t(J,this.defaultValue)}}function n(X,J,Ee,je){if(typeof X>"u")return J;let Oe=parseInt(X,10);return isNaN(Oe)?J:(Oe=Math.max(Ee,Oe),Oe=Math.min(je,Oe),Oe|0)}e.clampedInt=n;class u extends f{static clampedInt(J,Ee,je,Oe){return n(J,Ee,je,Oe)}constructor(J,Ee,je,Oe,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=je,nt.minimum=Oe,nt.maximum=Ze),super(J,Ee,je,nt),this.minimum=Oe,this.maximum=Ze}validate(J){return u.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}function a(X,J,Ee,je){if(typeof X>"u")return J;const Oe=l.float(X,J);return l.clamp(Oe,Ee,je)}e.clampedFloat=a;class l extends f{static clamp(J,Ee,je){return J<Ee?Ee:J>je?je:J}static float(J,Ee){if(typeof J=="number")return J;if(typeof J>"u")return Ee;const je=parseFloat(J);return isNaN(je)?Ee:je}constructor(J,Ee,je,Oe,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=je),super(J,Ee,je,Ze),this.validationFn=Oe}validate(J){return this.validationFn(l.float(J,this.defaultValue))}}class r extends f{static string(J,Ee){return typeof J!="string"?Ee:J}constructor(J,Ee,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=je),super(J,Ee,je,Oe)}validate(J){return r.string(J,this.defaultValue)}}function s(X,J,Ee,je){return typeof X!="string"?J:je&&X in je?je[X]:Ee.indexOf(X)===-1?J:X}e.stringSet=s;class c extends f{constructor(J,Ee,je,Oe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Oe,Ze.default=je),super(J,Ee,je,Ze),this.c=Oe}validate(J){return s(J,this.defaultValue,this.c)}}class h extends S{constructor(J,Ee,je,Oe,Ze,nt,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=Ze,$t.default=Oe),super(J,Ee,je,$t),this.c=Ze,this.d=nt}validate(J){return typeof J!="string"?this.defaultValue:this.c.indexOf(J)===-1?this.defaultValue:this.d(J)}}function b(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,Ee,je){return je===0?J.accessibilitySupport:je}}class I extends S{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:$.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function d(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function y(X){switch(X){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function C(X){switch(X){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class B extends p{constructor(){super(141)}compute(J,Ee,je){const Oe=["monaco-editor"];return Ee.get(39)&&Oe.push(Ee.get(39)),J.extraEditorClassName&&Oe.push(J.extraEditorClassName),Ee.get(73)==="default"?Oe.push("mouse-default"):Ee.get(73)==="copy"&&Oe.push("mouse-copy"),Ee.get(111)&&Oe.push("showUnused"),Ee.get(139)&&Oe.push("showDeprecated"),Oe.join(" ")}}class j extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(J,Ee,je){return je&&J.emptySelectionClipboard}}class V extends S{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:$.localize(16,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:$.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":s(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":s(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class z extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?z.OFF:J==="true"?z.ON:J:J?z.ON:z.OFF}}e.EditorFontLigatures=z;class F extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?F.OFF:J==="true"?F.TRANSLATE:J:J?F.TRANSLATE:F.OFF}compute(J,Ee,je){return J.fontInfo.fontVariationSettings}}e.EditorFontVariations=F;class O extends p{constructor(){super(50)}compute(J,Ee,je){return J.fontInfo}}class x extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(J){const Ee=l.float(J,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Ee,6,100)}compute(J,Ee,je){return J.fontInfo.fontSize}}class Z extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(J){return J==="normal"||J==="bold"?J:String(u.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}class De extends S{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:je,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:je,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:je,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:je,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:je,description:$.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{multiple:s(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??s(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??s(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??s(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??s(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??s(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ke extends S{constructor(){const J={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:J.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:J.above,description:$.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:u.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:u.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var Ie;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class de extends p{constructor(){super(144)}compute(J,Ee,je){return de.computeLayout(Ee,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio,glyphMarginDecorationLaneCount:J.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(J){const Ee=J.height/J.lineHeight,je=Math.floor(J.paddingTop/J.lineHeight);let Oe=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(Oe=Math.max(Oe,Ee-1));const Ze=(je+J.viewLineCount+Oe)/(J.pixelRatio*J.height),nt=Math.floor(J.viewLineCount/Ze);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Oe,desiredRatio:Ze,minimapLineCount:nt}}static c(J,Ee){const je=J.outerWidth,Oe=J.outerHeight,Ze=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=Ee.stableMinimapLayoutInput,$t=nt&&J.outerHeight===nt.outerHeight&&J.lineHeight===nt.lineHeight&&J.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&J.pixelRatio===nt.pixelRatio&&J.scrollBeyondLastLine===nt.scrollBeyondLastLine&&J.paddingTop===nt.paddingTop&&J.paddingBottom===nt.paddingBottom&&J.minimap.enabled===nt.minimap.enabled&&J.minimap.side===nt.minimap.side&&J.minimap.size===nt.minimap.size&&J.minimap.showSlider===nt.minimap.showSlider&&J.minimap.renderCharacters===nt.minimap.renderCharacters&&J.minimap.maxColumn===nt.minimap.maxColumn&&J.minimap.scale===nt.minimap.scale&&J.verticalScrollbarWidth===nt.verticalScrollbarWidth&&J.isViewportWrapping===nt.isViewportWrapping,bt=J.lineHeight,Pt=J.typicalHalfwidthCharacterWidth,Kt=J.scrollBeyondLastLine,Ht=J.minimap.renderCharacters;let vt=Ze>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const zt=J.minimap.maxColumn,Nt=J.minimap.size,Gt=J.minimap.side,Bt=J.verticalScrollbarWidth,kt=J.viewLineCount,Ft=J.remainingWidth,jt=J.isViewportWrapping,Qt=Ht?2:3;let Wt=Math.floor(Ze*Oe);const Vt=Wt/Ze;let Ot=!1,at=!1,dt=Qt*vt,At=vt/Ze,qt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Ce,extraLinesBeyondLastLine:Le,desiredRatio:$e,minimapLineCount:H}=de.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Kt,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:Oe,lineHeight:bt,pixelRatio:Ze});if(kt/H>1)Ot=!0,at=!0,vt=1,dt=1,At=vt/Ze;else{let ze=!1,Qe=vt+1;if(Nt==="fit"){const qe=Math.ceil((Ce+kt+Le)*dt);jt&&$t&&Ft<=Ee.stableFitRemainingWidth?(ze=!0,Qe=Ee.stableFitMaxMinimapScale):ze=qe>Wt}if(Nt==="fill"||ze){Ot=!0;const qe=vt;dt=Math.min(bt*Ze,Math.max(1,Math.floor(1/$e))),jt&&$t&&Ft<=Ee.stableFitRemainingWidth&&(Qe=Ee.stableFitMaxMinimapScale),vt=Math.min(Qe,Math.max(1,Math.floor(dt/Qt))),vt>qe&&(qt=Math.min(2,vt/qe)),At=vt/Ze/qt,Wt=Math.ceil(Math.max(Jt,Ce+kt+Le)*dt),jt?(Ee.stableMinimapLayoutInput=J,Ee.stableFitRemainingWidth=Ft,Ee.stableFitMaxMinimapScale=vt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const Rt=Math.floor(zt*At),ot=Math.min(Rt,Math.max(0,Math.floor((Ft-Bt-2)*At/(Pt+At)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Ze*ot);const Tt=wt/Ze;wt=Math.floor(wt*qt);const Ct=Ht?1:2,We=Gt==="left"?0:je-ot-Bt;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:ot,minimapHeightIsEditorHeight:Ot,minimapIsSampling:at,minimapScale:vt,minimapLineHeight:dt,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:Vt}}static computeLayout(J,Ee){const je=Ee.outerWidth|0,Oe=Ee.outerHeight|0,Ze=Ee.lineHeight|0,nt=Ee.lineNumbersDigitCount|0,$t=Ee.typicalHalfwidthCharacterWidth,bt=Ee.maxDigitWidth,Pt=Ee.pixelRatio,Kt=Ee.viewLineCount,Ht=J.get(136),vt=Ht==="inherit"?J.get(135):Ht,zt=vt==="inherit"?J.get(131):vt,Nt=J.get(134),Gt=Ee.isDominatedByLongLines,Bt=J.get(57),kt=J.get(67).renderType!==0,Ft=J.get(68),jt=J.get(105),Qt=J.get(84),Wt=J.get(72),Vt=J.get(103),Ot=Vt.verticalScrollbarSize,at=Vt.verticalHasArrows,dt=Vt.arrowSize,At=Vt.horizontalScrollbarSize,qt=J.get(43),Rt=J.get(110)!=="never";let ot=J.get(65);qt&&Rt&&(ot+=16);let wt=0;if(kt){const Et=Math.max(nt,Ft);wt=Math.round(Et*bt)}let Tt=0;Bt&&(Tt=Ze*Ee.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Tt,Jt=We+wt,Ce=Jt+ot;const Le=je-Tt-wt-ot;let $e=!1,H=!1,Me=-1;vt==="inherit"&&Gt?($e=!0,H=!0):zt==="on"||zt==="bounded"?H=!0:zt==="wordWrapColumn"&&(Me=Nt);const ze=de.c({outerWidth:je,outerHeight:Oe,lineHeight:Ze,typicalHalfwidthCharacterWidth:$t,pixelRatio:Pt,scrollBeyondLastLine:jt,paddingTop:Qt.top,paddingBottom:Qt.bottom,minimap:Wt,verticalScrollbarWidth:Ot,viewLineCount:Kt,remainingWidth:Le,isViewportWrapping:H},Ee.memory||new A);ze.renderMinimap!==0&&ze.minimapLeft===0&&(Ct+=ze.minimapWidth,We+=ze.minimapWidth,Jt+=ze.minimapWidth,Ce+=ze.minimapWidth);const Qe=Le-ze.minimapWidth,qe=Math.max(1,Math.floor((Qe-Ot-2)/$t)),et=at?dt:0;return H&&(Me=Math.max(1,qe),zt==="bounded"&&(Me=Math.min(Me,Nt))),{width:je,height:Oe,glyphMarginLeft:Ct,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:wt,decorationsLeft:Jt,decorationsWidth:ot,contentLeft:Ce,contentWidth:Qe,minimap:ze,viewportColumn:qe,isWordWrapMinified:$e,isViewportWrapping:H,wrappingColumn:Me,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:At,overviewRuler:{top:et,width:Ot,height:Oe-2*et,right:0}}}}e.EditorLayoutInfoComputer=de;class be extends S{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(J){return s(J,"simple",["simple","advanced"])}compute(J,Ee,je){return Ee.get(2)===2?"advanced":je}}class oe extends S{constructor(){const J={enabled:!0};super(64,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:$.localize(50,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:t(J.enabled,this.defaultValue.enabled)}}}class ce extends S{constructor(){const J={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:J.scrollWithEditor,description:$.localize(54,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:u.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ve extends S{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:$.localize(62,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:s(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:u.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class _ extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):u.clampedInt(J,this.defaultValue,0,1e3)}compute(J,Ee,je){return je<0?u.clampedInt(-je*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class W extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>l.clamp(J,0,150),{markdownDescription:$.localize(63,null)})}compute(J,Ee,je){return J.fontInfo.lineHeight}}class ae extends S{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:J.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:$.localize(74,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:s(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ee.side,this.defaultValue.side,["right","left"]),showSlider:s(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(Ee.scale,1,1,3),maxColumn:u.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function we(X){return X==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class ne extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{top:u.clampedInt(Ee.top,0,0,1e3),bottom:u.clampedInt(Ee.bottom,0,0,1e3)}}}class he extends S{constructor(){const J={enabled:!0,cycle:!0};super(86,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:$.localize(78,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class le extends p{constructor(){super(142)}compute(J,Ee,je){return J.pixelRatio}}class ye extends S{constructor(){const J={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(89,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:J.strings,description:$.localize(82,null)},comments:{anyOf:Ee,default:J.comments,description:$.localize(83,null)},other:{anyOf:Ee,default:J.other,description:$.localize(84,null)}},default:J,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const Pt=J?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!J||typeof J!="object")return this.defaultValue;const{other:Ee,comments:je,strings:Oe}=J,Ze=["on","inline","off"];let nt,$t,bt;return typeof Ee=="boolean"?nt=Ee?"on":"off":nt=s(Ee,this.defaultValue.other,Ze),typeof je=="boolean"?$t=je?"on":"off":$t=s(je,this.defaultValue.comments,Ze),typeof Oe=="boolean"?bt=Oe?"on":"off":bt=s(Oe,this.defaultValue.strings,Ze),{other:nt,comments:$t,strings:bt}}}var ee;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class fe extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(J){let Ee=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?(Ee=4,je=J):J==="interval"?Ee=3:J==="relative"?Ee=2:J==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:je}}}function ie(X){const J=X.get(98);return J==="editable"?X.get(91):J!=="on"}e.filterValidationDecorations=ie;class se extends S{constructor(){const J=[],Ee={type:"number",description:$.localize(91,null)};super(102,"rulers",J,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:J,description:$.localize(93,null)})}validate(J){if(Array.isArray(J)){const Ee=[];for(const je of J)if(typeof je=="number")Ee.push({column:u.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Oe=je;Ee.push({column:u.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return Ee.sort((je,Oe)=>je.column-Oe.column),Ee}return this.defaultValue}}class me extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(J){return!J||typeof J!="object"?this.defaultValue:J}}function Pe(X,J){if(typeof X!="string")return J;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends S{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:J.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J,je=u.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=u.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ee.vertical,this.defaultValue.vertical),horizontal:Pe(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:u.clampedInt(Ee.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:u.clampedInt(Ee.verticalSliderSize,Oe,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends S{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:$.localize(112,null)}})}applyUpdate(J,Ee){let je=!1;Ee.allowedCharacters&&J&&(L.$_m(J.allowedCharacters,Ee.allowedCharacters)||(J={...J,allowedCharacters:Ee.allowedCharacters},je=!0)),Ee.allowedLocales&&J&&(L.$_m(J.allowedLocales,Ee.allowedLocales)||(J={...J,allowedLocales:Ee.allowedLocales},je=!0));const Oe=super.applyUpdate(J,Ee);return je?new o(Oe.newValue,!0):Oe}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{nonBasicASCII:Y(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Y(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Y(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(J.allowedLocales,this.defaultValue.allowedLocales)}}c(J,Ee){if(typeof J!="object"||!J)return Ee;const je={};for(const[Oe,Ze]of Object.entries(J))Ze===!0&&(je[Oe]=!0);return je}}class G extends S{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(114,null),$.localize(115,null)],description:$.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:$.localize(117,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:s(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends S{constructor(){const J={enabled:M.$4r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$4r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:$.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:$.localize(119,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends S{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],default:J.bracketPairs,description:$.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:J.bracketPairsHorizontal,description:$.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:$.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:$.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(130,null),$.localize(131,null),$.localize(132,null)],default:J.highlightActiveIndentation,description:$.localize(133,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{bracketPairs:Y(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Y(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:Y(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Y(X,J,Ee){const je=Ee.indexOf(X);return je===-1?J:Ee[je]}class ue extends S{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(134,null),$.localize(135,null)],default:J.insertMode,description:$.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:$.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:$.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:$.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(140,null),$.localize(141,null),$.localize(142,null),$.localize(143,null)],default:J.selectionMode,markdownDescription:$.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:$.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:$.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:$.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:$.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:$.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{insertMode:s(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:s(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class Ne extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(183,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(J.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Je extends S{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(184,null),$.localize(185,null),$.localize(186,null),$.localize(187,null)],description:$.localize(188,null),default:"same"}})}validate(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(J,Ee,je){return Ee.get(2)===2?0:je}}class Ge extends p{constructor(){super(145)}compute(J,Ee,je){const Oe=Ee.get(144);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class _e extends S{constructor(){const J={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:$.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(191,null),$.localize(192,null)],default:"afterDrop"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:s(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends S{constructor(){const J={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",J,{"editor.pasteAs.enabled":{type:"boolean",default:J.enabled,markdownDescription:$.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterPaste"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:s(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?it:P.$l?tt:xe,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(X){return e.editorOptionsRegistry[X.id]=X,X}var ut;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSeparators=130]="wordSeparators",X[X.wordWrap=131]="wordWrap",X[X.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=134]="wordWrapColumn",X[X.wordWrapOverride1=135]="wordWrapOverride1",X[X.wordWrapOverride2=136]="wordWrapOverride2",X[X.wrappingIndent=137]="wrappingIndent",X[X.wrappingStrategy=138]="wrappingStrategy",X[X.showDeprecated=139]="showDeprecated",X[X.inlayHints=140]="inlayHints",X[X.editorClassName=141]="editorClassName",X[X.pixelRatio=142]="pixelRatio",X[X.tabFocusMode=143]="tabFocusMode",X[X.layoutInfo=144]="layoutInfo",X[X.wrappingInfo=145]="wrappingInfo",X[X.defaultColorDecorators=146]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(ut||(e.EditorOption=ut={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(197,null)})),acceptSuggestionOnEnter:Ue(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(198,null),""],markdownDescription:$.localize(199,null)})),accessibilitySupport:Ue(new m),accessibilityPageSize:Ue(new u(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(200,null),tags:["accessibility"]})),ariaLabel:Ue(new r(4,"ariaLabel",$.localize(201,null))),ariaRequired:Ue(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(203,null),$.localize(204,null),""],description:$.localize(205,null)})),autoClosingComments:Ue(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(206,null),$.localize(207,null),""],description:$.localize(208,null)})),autoClosingDelete:Ue(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(209,null),""],description:$.localize(210,null)})),autoClosingOvertype:Ue(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(211,null),""],description:$.localize(212,null)})),autoClosingQuotes:Ue(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(213,null),$.localize(214,null),""],description:$.localize(215,null)})),autoIndent:Ue(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null)],description:$.localize(221,null)})),automaticLayout:Ue(new i(13,"automaticLayout",!1)),autoSurround:Ue(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(222,null),$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),bracketPairColorization:Ue(new Q),bracketPairGuides:Ue(new K),stickyTabStops:Ue(new i(116,"stickyTabStops",!1,{description:$.localize(226,null)})),codeLens:Ue(new i(17,"codeLens",!0,{description:$.localize(227,null)})),codeLensFontFamily:Ue(new r(18,"codeLensFontFamily","",{description:$.localize(228,null)})),codeLensFontSize:Ue(new u(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(229,null)})),colorDecorators:Ue(new i(20,"colorDecorators",!0,{description:$.localize(230,null)})),colorDecoratorActivatedOn:Ue(new c(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(231,null),$.localize(232,null),$.localize(233,null)],description:$.localize(234,null)})),colorDecoratorsLimit:Ue(new u(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(235,null)})),columnSelection:Ue(new i(22,"columnSelection",!1,{description:$.localize(236,null)})),comments:Ue(new I),contextmenu:Ue(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(237,null)})),cursorBlinking:Ue(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:$.localize(238,null)})),cursorSmoothCaretAnimation:Ue(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null)],description:$.localize(242,null)})),cursorStyle:Ue(new h(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:$.localize(243,null)})),cursorSurroundingLines:Ue(new u(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(244,null)})),cursorSurroundingLinesStyle:Ue(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(245,null),$.localize(246,null)],markdownDescription:$.localize(247,null)})),cursorWidth:Ue(new u(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(248,null)})),disableLayerHinting:Ue(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new i(34,"domReadOnly",!1)),dragAndDrop:Ue(new i(35,"dragAndDrop",!0,{description:$.localize(249,null)})),emptySelectionClipboard:Ue(new j),dropIntoEditor:Ue(new _e),stickyScroll:Ue(new ce),experimentalWhitespaceRendering:Ue(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(250,null),$.localize(251,null),$.localize(252,null)],description:$.localize(253,null)})),extraEditorClassName:Ue(new r(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new l(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:$.localize(254,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new i(42,"fixedOverflowWidgets",!1)),folding:Ue(new i(43,"folding",!0,{description:$.localize(255,null)})),foldingStrategy:Ue(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(256,null),$.localize(257,null)],description:$.localize(258,null)})),foldingHighlight:Ue(new i(45,"foldingHighlight",!0,{description:$.localize(259,null)})),foldingImportsByDefault:Ue(new i(46,"foldingImportsByDefault",!1,{description:$.localize(260,null)})),foldingMaximumRegions:Ue(new u(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(261,null)})),unfoldOnClickAfterEndOfLine:Ue(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(262,null)})),fontFamily:Ue(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(263,null)})),fontInfo:Ue(new O),fontLigatures2:Ue(new z),fontSize:Ue(new x),fontWeight:Ue(new Z),fontVariations:Ue(new F),formatOnPaste:Ue(new i(55,"formatOnPaste",!1,{description:$.localize(264,null)})),formatOnType:Ue(new i(56,"formatOnType",!1,{description:$.localize(265,null)})),glyphMargin:Ue(new i(57,"glyphMargin",!0,{description:$.localize(266,null)})),gotoLocation:Ue(new De),hideCursorInOverviewRuler:Ue(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(267,null)})),hover:Ue(new ke),inDiffEditor:Ue(new i(61,"inDiffEditor",!1)),letterSpacing:Ue(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>l.clamp(X,-5,20),{description:$.localize(268,null)})),lightbulb:Ue(new oe),lineDecorationsWidth:Ue(new _),lineHeight:Ue(new W),lineNumbers:Ue(new fe),lineNumbersMinChars:Ue(new u(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new i(69,"linkedEditing",!1,{description:$.localize(269,null)})),links:Ue(new i(70,"links",!0,{description:$.localize(270,null)})),matchBrackets:Ue(new c(71,"matchBrackets","always",["always","near","never"],{description:$.localize(271,null)})),minimap:Ue(new ae),mouseStyle:Ue(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new l(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:$.localize(272,null)})),mouseWheelZoom:Ue(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(273,null)})),multiCursorMergeOverlapping:Ue(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(274,null)})),multiCursorModifier:Ue(new h(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],we,{markdownEnumDescriptions:[$.localize(275,null),$.localize(276,null)],markdownDescription:$.localize(277,null)})),multiCursorPaste:Ue(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(278,null),$.localize(279,null)],markdownDescription:$.localize(280,null)})),multiCursorLimit:Ue(new u(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(281,null)})),occurrencesHighlight:Ue(new i(81,"occurrencesHighlight",!0,{description:$.localize(282,null)})),multiDocumentOccurrencesHighlight:Ue(new i(80,"multiDocumentOccurrencesHighlight",!1,{description:$.localize(283,null)})),overviewRulerBorder:Ue(new i(82,"overviewRulerBorder",!0,{description:$.localize(284,null)})),overviewRulerLanes:Ue(new u(83,"overviewRulerLanes",3,0,3)),padding:Ue(new ne),pasteAs:Ue(new Ye),parameterHints:Ue(new he),peekWidgetDefaultFocus:Ue(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(285,null),$.localize(286,null)],description:$.localize(287,null)})),definitionLinkOpensInPeek:Ue(new i(88,"definitionLinkOpensInPeek",!1,{description:$.localize(288,null)})),quickSuggestions:Ue(new ye),quickSuggestionsDelay:Ue(new u(90,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(289,null)})),readOnly:Ue(new i(91,"readOnly",!1)),readOnlyMessage:Ue(new me),renameOnType:Ue(new i(93,"renameOnType",!1,{description:$.localize(290,null),markdownDeprecationMessage:$.localize(291,null)})),renderControlCharacters:Ue(new i(94,"renderControlCharacters",!0,{description:$.localize(292,null),restricted:!0})),renderFinalNewline:Ue(new c(95,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:$.localize(293,null)})),renderLineHighlight:Ue(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(294,null)],description:$.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Ue(new i(97,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(296,null)})),renderValidationDecorations:Ue(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(297,null),$.localize(298,null),$.localize(299,null),""],description:$.localize(300,null)})),revealHorizontalRightPadding:Ue(new u(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new i(101,"roundedSelection",!0,{description:$.localize(301,null)})),rulers:Ue(new se),scrollbar:Ue(new T),scrollBeyondLastColumn:Ue(new u(104,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(302,null)})),scrollBeyondLastLine:Ue(new i(105,"scrollBeyondLastLine",!0,{description:$.localize(303,null)})),scrollPredominantAxis:Ue(new i(106,"scrollPredominantAxis",!0,{description:$.localize(304,null)})),selectionClipboard:Ue(new i(107,"selectionClipboard",!0,{description:$.localize(305,null),included:P.$l})),selectionHighlight:Ue(new i(108,"selectionHighlight",!0,{description:$.localize(306,null)})),selectOnLineNumbers:Ue(new i(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(307,null),$.localize(308,null),$.localize(309,null)],description:$.localize(310,null)})),showUnused:Ue(new i(111,"showUnused",!0,{description:$.localize(311,null)})),showDeprecated:Ue(new i(139,"showDeprecated",!0,{description:$.localize(312,null)})),inlayHints:Ue(new ve),snippetSuggestions:Ue(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(313,null),$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),smartSelect:Ue(new Ne),smoothScrolling:Ue(new i(114,"smoothScrolling",!1,{description:$.localize(318,null)})),stopRenderingLineAfter:Ue(new u(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ue),inlineSuggest:Ue(new G),inlineCompletionsAccessibilityVerbose:Ue(new i(148,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(319,null)})),suggestFontSize:Ue(new u(119,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new u(120,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new i(121,"suggestOnTriggerCharacters",!0,{description:$.localize(322,null)})),suggestSelection:Ue(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(323,null),$.localize(324,null),$.localize(325,null)],description:$.localize(326,null)})),tabCompletion:Ue(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(327,null),$.localize(328,null),$.localize(329,null)],description:$.localize(330,null)})),tabIndex:Ue(new u(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new q),unusualLineTerminators:Ue(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(331,null),$.localize(332,null),$.localize(333,null)],description:$.localize(334,null)})),useShadowDOM:Ue(new i(127,"useShadowDOM",!0)),useTabStops:Ue(new i(128,"useTabStops",!0,{description:$.localize(335,null)})),wordBreak:Ue(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(336,null),$.localize(337,null)],description:$.localize(338,null)})),wordSeparators:Ue(new r(130,"wordSeparators",R.$5r,{description:$.localize(339,null)})),wordWrap:Ue(new c(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(340,null),$.localize(341,null),$.localize(342,null),$.localize(343,null)],description:$.localize(344,null)})),wordWrapBreakAfterCharacters:Ue(new r(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new r(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new u(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(345,null)})),wordWrapOverride1:Ue(new c(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new c(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new B),defaultColorDecorators:Ue(new i(146,"defaultColorDecorators",!1,{markdownDescription:$.localize(346,null)})),pixelRatio:Ue(new le),tabFocusMode:Ue(new i(143,"tabFocusMode",!1,{markdownDescription:$.localize(347,null)})),layoutInfo:Ue(new de),wrappingInfo:Ue(new Ge),wrappingIndent:Ue(new Je),wrappingStrategy:Ue(new be)}}),define(Ae[148],Re([9,10]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[149],Re([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[150],Re([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[151],Re([9,10]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[152],Re([9,10]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[153],Re([9,10]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Ae[154],Re([9,10]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Ae[155],Re([9,10]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[156],Re([9,10]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Ae[157],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[158],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[159],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[160],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[161],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[162],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[163],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[164],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[165],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[166],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[167],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[168],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[169],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[170],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[171],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/configuration",e)}),define(Ae[172],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Ae[173],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Ae[174],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[175],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[176],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[177],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[178],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[179],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ae[180],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[181],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[182],Re([1,0,11,150]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var P;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,L.localize)(3,null),$=(0,L.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const S=this.d,o=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:o};this.g.push({offset:S,lexeme:o,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const S=this.c.substring(this.d,this.e),o=D.b.get(S);o?this.k(o):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,S=!1,o=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const p=this.c.charCodeAt(A);if(S)S=!1;else if(p===47&&!o){A++;break}else p===91?o=!0:p===92?S=!0:p===93&&(o=!1);A++}for(;A<this.c.length&&D.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=D}),define(Ae[183],Re([1,0,24,31,152,296]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||R.test(i)}e.$Mo=D;function g(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=i.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$No=g;function A(i){if(!i)return null;const n=i.majorBase,u=i.majorMustEqual,a=i.minorBase;let l=i.minorMustEqual;const r=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(n===0||(l=!1),s=!1);let c=0;if(i.preRelease){const h=$.exec(i.preRelease);if(h){const[,b,m,I]=h;c=Date.UTC(Number(b),Number(m)-1,Number(I))}}return{majorBase:n,majorMustEqual:u,minorBase:a,minorMustEqual:l,patchBase:r,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:c}}e.$Oo=A;function S(i,n,u){let a;typeof i=="string"?a=A(g(i)):a=i;let l;n instanceof Date?l=n.getTime():typeof n=="string"&&(l=new Date(n).getTime());let r;if(typeof u=="string"?r=A(g(u)):r=u,!a||!r)return!1;const s=a.majorBase,c=a.minorBase,h=a.patchBase;let b=r.majorBase,m=r.minorBase,I=r.patchBase;const k=r.notBefore;let d=r.majorMustEqual,w=r.minorMustEqual,y=r.patchMustEqual;return r.isMinimum?s>b?!0:s<b?!1:c>m?!0:c<m||l&&l<k?!1:h>=I:(s===1&&b===0&&(!d||!w||!y)&&(b=1,m=0,I=0,d=!0,w=!1,y=!1),s<b?!1:s>b?!d:c<m?!1:c>m?!w:h<I?!1:h>I?!y:!(l&&l<k))}e.$Po=S;function o(i,n,u,a,l){const r=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return r.push([L.default.Error,P.localize(0,null)]),r;if(typeof a.name!="string")return r.push([L.default.Error,P.localize(1,null,"name")]),r;if(typeof a.version!="string")return r.push([L.default.Error,P.localize(2,null,"version")]),r;if(!a.engines)return r.push([L.default.Error,P.localize(3,null,"engines")]),r;if(typeof a.engines.vscode!="string")return r.push([L.default.Error,P.localize(4,null,"engines.vscode")]),r;if(typeof a.extensionDependencies<"u"&&!t(a.extensionDependencies))return r.push([L.default.Error,P.localize(5,null,"extensionDependencies")]),r;if(typeof a.activationEvents<"u"){if(!t(a.activationEvents))return r.push([L.default.Error,P.localize(6,null,"activationEvents")]),r;if(typeof a.main>"u"&&typeof a.browser>"u")return r.push([L.default.Error,P.localize(7,null,"activationEvents","main","browser")]),r}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&r.push([L.default.Warning,P.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return r.push([L.default.Error,P.localize(9,null,"main")]),r;{const h=(0,E.$vg)(u,a.main);(0,E.$pg)(h,u)||r.push([L.default.Warning,P.localize(10,null,h.path,u.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return r.push([L.default.Error,P.localize(11,null,"browser")]),r;{const h=(0,E.$vg)(u,a.browser);(0,E.$pg)(h,u)||r.push([L.default.Warning,P.localize(12,null,h.path,u.path)])}}if(!M.valid(a.version))return r.push([L.default.Error,P.localize(13,null)]),r;const s=[];if(!v(i,n,a,l,s))for(const h of s)r.push([L.default.Error,h]);return r}e.$Qo=o;function v(i,n,u,a,l){return a||typeof u.main>"u"&&typeof u.browser>"u"?!0:f(i,n,u.engines.vscode,l)}e.$Ro=v;function p(i,n,u){return i==="*"||f(n,u,i)}e.$So=p;function f(i,n,u,a=[]){const l=A(g(u));if(!l)return a.push(P.localize(14,null,u)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return a.push(P.localize(15,null,u)),!1}else if(!l.majorMustEqual)return a.push(P.localize(16,null,u)),!1;return S(i,n,l)?!0:(a.push(P.localize(17,null,i,u)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let n=0,u=i.length;n<u;n++)if(typeof i[n]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class E{constructor(P,M=[],R=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$Nh=E}),define(Ae[71],Re([1,0,70]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.InstantiationType=void 0;const L=[];var P;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M($,D,g){D instanceof E.$Nh||(D=new E.$Nh(D,[],!!g)),L.push([$,D])}e.$xr=M;function R(){return L}e.$yr=R}),define(Ae[184],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$cq=E;class L{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),D=this.lookupOrInsertNode(R);$.outgoing.set(D.key,D),D.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new E(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),D=this.c(R,$);if(D)return D}}c(M,R){for(const[$,D]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const g=this.c(D,R);if(g)return g;R.delete($)}}}e.$dq=L}),define(Ae[4],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(D){return D[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$Ph=P("instantiationService");function L(R,$,D){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:D}):($[E.DI_DEPENDENCIES]=[{id:R,index:D}],$[E.DI_TARGET]=$)}function P(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(D,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L($,D,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$Qh=P;function M(R){return R}e.$Rh=M}),define(Ae[40],Re([1,0,16,2,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,P.$Qh)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.$li=M;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof L.URI)}e.$mi=R;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=D;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$oi=g;function A(i,n){const u=Object.create(null);for(const a in i)S(u,a,i[a],n);return u}e.$pi=A;function S(i,n,u,a){const l=n.split("."),r=l.pop();let s=i;for(let c=0;c<l.length;c++){const h=l[c];let b=s[h];switch(typeof b){case"undefined":b=s[h]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${l.slice(0,c+1).join(".")} is ${JSON.stringify(b)}`);return}s=b}if(typeof s=="object"&&s!==null)try{s[r]=u}catch{a(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(s)}`)}else a(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.$qi=S;function o(i,n){const u=n.split(".");v(i,u)}e.$ri=o;function v(i,n){const u=n.shift();if(n.length===0){delete i[u];return}if(Object.keys(i).indexOf(u)!==-1){const a=i[u];typeof a=="object"&&!Array.isArray(a)&&(v(a,n),Object.keys(a).length===0&&delete i[u])}}function p(i,n,u){function a(s,c){let h=s;for(const b of c){if(typeof h!="object"||h===null)return;h=h[b]}return h}const l=n.split("."),r=a(i,l);return typeof r>"u"?u:r}e.$si=p;function f(i,n,u){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?E.$Af(i[a])&&E.$Af(n[a])?f(i[a],n[a],u):u&&(i[a]=n[a]):i[a]=n[a])})}e.$ti=f;function t(i){return i.replace(/[\[\]]/g,"")}e.$ui=t}),define(Ae[34],Re([1,0,21,13,182,4,149,11]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",E.$k),D.set("isLinux",E.$l),D.set("isWindows",E.$j),D.set("isWeb",E.$p),D.set("isMacNative",E.$k&&!E.$p),D.set("isEdge",E.$H),D.set("isFirefox",E.$F),D.set("isChrome",E.$E),D.set("isSafari",E.$G);function g(_,W){if(D.get(_)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(_,W)}e.$Mi=g;const A=Object.prototype.hasOwnProperty;var S;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const o={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),p=(0,R.localize)(1,null),f=(0,R.localize)(2,null),t=(0,R.localize)(3,null),i=(0,R.localize)(4,null),n=(0,R.localize)(5,null),u=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=o){this.k=W,this.d=new P.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ae=this.l();if(!this.E()){const we=this.D(),ne=we.type===17?n:void 0;throw this.h.push({message:i,offset:we.offset,lexeme:P.$Li.getLexeme(we),additionalInfo:ne}),l.c}return ae}catch(ae){if(ae!==l.c)throw ae;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const ae=this.o();W.push(ae)}return W.length===1?W[0]:r.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const ae=this.s();W.push(ae)}return W.length===1?W[0]:r.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const ae=this.l();return this.A(1,t),ae?.negate()}case 17:return this.z(),C.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const ae=this.l();return this.A(1,t),ae}case 17:{const ae=W.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const he=ne.lexeme,le=he.lastIndexOf("/"),ye=le===he.length-1?void 0:this.w(he.substring(le+1));let ee;try{ee=new RegExp(he.substring(1,le),ye)}catch{throw this.B("REGEX",ne)}return O.create(ae,ee)}switch(ne.type){case 10:case 19:{const he=[ne.lexeme];this.z();let le=this.D(),ye=0;for(let me=0;me<ne.lexeme.length;me++)ne.lexeme.charCodeAt(me)===40?ye++:ne.lexeme.charCodeAt(me)===41&&ye--;for(;!this.E()&&le.type!==15&&le.type!==16;){switch(le.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let me=0;me<le.lexeme.length;me++)le.lexeme.charCodeAt(me)===40?ye++:ne.lexeme.charCodeAt(me)===41&&ye--}if(ye<0)break;he.push(P.$Li.getLexeme(le)),this.z(),le=this.D()}const ee=he.join(""),fe=ee.lastIndexOf("/"),ie=fe===ee.length-1?void 0:this.w(ee.substring(fe+1));let se;try{se=new RegExp(ee.substring(1,fe),ie)}catch{throw this.B("REGEX",ne)}return r.regex(ae,se)}case 18:{const he=ne.lexeme;this.z();let le=null;if(!(0,L.$Be)(he)){const ye=he.indexOf("/"),ee=he.lastIndexOf("/");if(ye!==ee&&ye>=0){const fe=he.slice(ye+1,ee),ie=he[ee+1]==="i"?"i":"";try{le=new RegExp(fe,ie)}catch{throw this.B("REGEX",ne)}}}if(le===null)throw this.B("REGEX",ne);return O.create(ae,le)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const ne=this.u();return r.notIn(ae,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return r.equals(ae,ne);switch(ne){case"true":return r.has(ae);case"false":return r.not(ae);default:return r.equals(ae,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return r.notEquals(ae,ne);switch(ne){case"true":return r.not(ae);case"false":return r.has(ae);default:return r.notEquals(ae,ne)}}case 5:return this.z(),z.create(ae,this.u());case 6:return this.z(),F.create(ae,this.u());case 7:return this.z(),j.create(ae,this.u());case 8:return this.z(),V.create(ae,this.u());case 13:return this.z(),r.in(ae,this.u());default:return r.has(ae)}}case 20:throw this.h.push({message:u,offset:W.offset,lexeme:"",additionalInfo:a}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ae){if(this.C(W))return this.z();throw this.B(ae,this.D())}B(W,ae,we){const ne=(0,R.localize)(8,null,W,P.$Li.getLexeme(ae)),he=ae.offset,le=P.$Li.getLexeme(ae);return this.h.push({message:ne,offset:he,lexeme:le,additionalInfo:we}),l.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=l;class r{static false(){return b.INSTANCE}static true(){return m.INSTANCE}static has(W){return I.create(W)}static equals(W,ae){return k.create(W,ae)}static notEquals(W,ae){return y.create(W,ae)}static regex(W,ae){return O.create(W,ae)}static in(W,ae){return d.create(W,ae)}static notIn(W,ae){return w.create(W,ae)}static not(W){return C.create(W)}static and(...W){return De.create(W,null,!0)}static or(...W){return ke.create(W,null,!0)}static greater(W,ae){return j.create(W,ae)}static greaterEquals(W,ae){return V.create(W,ae)}static smaller(W,ae){return z.create(W,ae)}static smallerEquals(W,ae){return F.create(W,ae)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Oi=r;function s(_){const W=new l({regexParsingWithErrorRecovery:!1});return _.map(ae=>(W.parse(ae),W.lexingErrors.length>0?W.lexingErrors.map(we=>({errorMessage:we.additionalInfo?(0,R.localize)(9,null,we.additionalInfo):(0,R.localize)(10,null),offset:we.offset,length:we.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(we=>({errorMessage:we.additionalInfo?`${we.message}. ${we.additionalInfo}`:we.message,offset:we.offset,length:we.lexeme.length})):[]))}e.$Pi=s;function c(_,W){const ae=_?_.substituteConstants():void 0,we=W?W.substituteConstants():void 0;return!ae&&!we?!0:!ae||!we?!1:ae.equals(we)}e.$Qi=c;function h(_,W){return _.cmp(W)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return m.INSTANCE}}e.$Ri=b;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return b.INSTANCE}}e.$Si=m;class I{static create(W,ae=null){const we=D.get(W);return typeof we=="boolean"?we?m.INSTANCE:b.INSTANCE:new I(W,ae)}constructor(W,ae){this.key=W,this.c=ae,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:de(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=D.get(this.key);return typeof W=="boolean"?W?m.INSTANCE:b.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Ti=I;class k{static create(W,ae,we=null){if(typeof ae=="boolean")return ae?I.create(W,we):C.create(W,we);const ne=D.get(W);return typeof ne=="boolean"?ae===(ne?"true":"false")?m.INSTANCE:b.INSTANCE:new k(W,ae,we)}constructor(W,ae,we){this.c=W,this.d=ae,this.f=we,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:be(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const ae=W?"true":"false";return this.d===ae?m.INSTANCE:b.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Ui=k;class d{static create(W,ae){return new d(W,ae)}constructor(W,ae){this.d=W,this.f=ae,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:be(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ae=W.getValue(this.f),we=W.getValue(this.d);return Array.isArray(ae)?ae.includes(we):typeof we=="string"&&typeof ae=="object"&&ae!==null?A.call(ae,we):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Vi=d;class w{static create(W,ae){return new w(W,ae)}constructor(W,ae){this.d=W,this.f=ae,this.type=11,this.c=d.create(W,ae)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=w;class y{static create(W,ae,we=null){if(typeof ae=="boolean")return ae?C.create(W,we):I.create(W,we);const ne=D.get(W);return typeof ne=="boolean"?ae===(ne?"true":"false")?b.INSTANCE:m.INSTANCE:new y(W,ae,we)}constructor(W,ae,we){this.c=W,this.d=ae,this.f=we,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:be(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const ae=W?"true":"false";return this.d===ae?b.INSTANCE:m.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Xi=y;class C{static create(W,ae=null){const we=D.get(W);return typeof we=="boolean"?we?b.INSTANCE:m.INSTANCE:new C(W,ae)}constructor(W,ae){this.c=W,this.d=ae,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:de(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=D.get(this.c);return typeof W=="boolean"?W?b.INSTANCE:m.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Yi=C;function B(_,W){if(typeof _=="string"){const ae=parseFloat(_);isNaN(ae)||(_=ae)}return typeof _=="string"||typeof _=="number"?W(_):b.INSTANCE}class j{static create(W,ae,we=null){return B(ae,ne=>new j(W,ne,we))}constructor(W,ae,we){this.c=W,this.d=ae,this.f=we,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:be(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Zi=j;class V{static create(W,ae,we=null){return B(ae,ne=>new V(W,ne,we))}constructor(W,ae,we){this.c=W,this.d=ae,this.f=we,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:be(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$1i=V;class z{static create(W,ae,we=null){return B(ae,ne=>new z(W,ne,we))}constructor(W,ae,we){this.c=W,this.d=ae,this.f=we,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:be(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$2i=z;class F{static create(W,ae,we=null){return B(ae,ne=>new F(W,ne,we))}constructor(W,ae,we){this.c=W,this.d=ae,this.f=we,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:be(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$3i=F;class O{static create(W,ae){return new O(W,ae)}constructor(W,ae){this.d=W,this.f=ae,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ae=this.f?this.f.source:"",we=W.f?W.f.source:"";return ae<we?-1:ae>we?1:0}equals(W){if(W.type===this.type){const ae=this.f?this.f.source:"",we=W.f?W.f.source:"";return this.d===W.d&&ae===we}return!1}substituteConstants(){return this}evaluate(W){const ae=W.getValue(this.d);return this.f?this.f.test(ae):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$4i=O;class x{static create(W){return new x(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new x(this.c.map(W))}negate(){return this.c}}e.$5i=x;function Z(_){let W=null;for(let ae=0,we=_.length;ae<we;ae++){const ne=_[ae].substituteConstants();if(_[ae]!==ne&&W===null){W=[];for(let he=0;he<ae;he++)W[he]=_[he]}W!==null&&(W[ae]=ne)}return W===null?_:W}class De{static create(W,ae,we){return De.d(W,ae,we)}constructor(W,ae){this.expr=W,this.c=ae,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ae=0,we=this.expr.length;ae<we;ae++){const ne=h(this.expr[ae],W.expr[ae]);if(ne!==0)return ne}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ae=0,we=this.expr.length;ae<we;ae++)if(!this.expr[ae].equals(W.expr[ae]))return!1;return!0}return!1}substituteConstants(){const W=Z(this.expr);return W===this.expr?this:De.create(W,this.c,!1)}evaluate(W){for(let ae=0,we=this.expr.length;ae<we;ae++)if(!this.expr[ae].evaluate(W))return!1;return!0}static d(W,ae,we){const ne=[];let he=!1;for(const le of W)if(le){if(le.type===1){he=!0;continue}if(le.type===0)return b.INSTANCE;if(le.type===6){ne.push(...le.expr);continue}ne.push(le)}if(ne.length===0&&he)return m.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(h);for(let le=1;le<ne.length;le++)ne[le-1].equals(ne[le])&&(ne.splice(le,1),le--);if(ne.length===1)return ne[0];for(;ne.length>1;){const le=ne[ne.length-1];if(le.type!==9)break;ne.pop();const ye=ne.pop(),ee=ne.length===0,fe=ke.create(le.expr.map(ie=>De.create([ie,ye],null,we)),null,ee);fe&&(ne.push(fe),ne.sort(h))}if(ne.length===1)return ne[0];if(we){for(let le=0;le<ne.length;le++)for(let ye=le+1;ye<ne.length;ye++)if(ne[le].negate().equals(ne[ye]))return b.INSTANCE;if(ne.length===1)return ne[0]}return new De(ne,ae)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ae of this.expr)W.push(...ae.keys());return W}map(W){return new De(this.expr.map(ae=>ae.map(W)),null)}negate(){if(!this.c){const W=[];for(const ae of this.expr)W.push(ae.negate());this.c=ke.create(W,this,!0)}return this.c}}e.$6i=De;class ke{static create(W,ae,we){return ke.d(W,ae,we)}constructor(W,ae){this.expr=W,this.c=ae,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ae=0,we=this.expr.length;ae<we;ae++){const ne=h(this.expr[ae],W.expr[ae]);if(ne!==0)return ne}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ae=0,we=this.expr.length;ae<we;ae++)if(!this.expr[ae].equals(W.expr[ae]))return!1;return!0}return!1}substituteConstants(){const W=Z(this.expr);return W===this.expr?this:ke.create(W,this.c,!1)}evaluate(W){for(let ae=0,we=this.expr.length;ae<we;ae++)if(this.expr[ae].evaluate(W))return!0;return!1}static d(W,ae,we){let ne=[],he=!1;if(W){for(let le=0,ye=W.length;le<ye;le++){const ee=W[le];if(ee){if(ee.type===0){he=!0;continue}if(ee.type===1)return m.INSTANCE;if(ee.type===9){ne=ne.concat(ee.expr);continue}ne.push(ee)}}if(ne.length===0&&he)return b.INSTANCE;ne.sort(h)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let le=1;le<ne.length;le++)ne[le-1].equals(ne[le])&&(ne.splice(le,1),le--);if(ne.length===1)return ne[0];if(we){for(let le=0;le<ne.length;le++)for(let ye=le+1;ye<ne.length;ye++)if(ne[le].negate().equals(ne[ye]))return m.INSTANCE;if(ne.length===1)return ne[0]}return new ke(ne,ae)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ae of this.expr)W.push(...ae.keys());return W}map(W){return new ke(this.expr.map(ae=>ae.map(W)),null)}negate(){if(!this.c){const W=[];for(const ae of this.expr)W.push(ae.negate());for(;W.length>1;){const ae=W.shift(),we=W.shift(),ne=[];for(const he of ve(ae))for(const le of ve(we))ne.push(De.create([he,le],null,!1));W.unshift(ke.create(ne,null,!1))}this.c=ke.create(W,this,!0)}return this.c}}e.$7i=ke;class Ie extends I{static{this.d=[]}static all(){return Ie.d.values()}constructor(W,ae,we){super(W,null),this.f=ae,typeof we=="object"?Ie.d.push({...we,key:W}):we!==!0&&Ie.d.push({key:W,description:we,type:ae!=null?typeof ae:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return k.create(this.key,W)}notEqualsTo(W){return y.create(this.key,W)}}e.$8i=Ie,e.$9i=(0,M.$Qh)("contextKeyService");function de(_,W){return _<W?-1:_>W?1:0}function be(_,W,ae,we){return _<ae?-1:_>ae?1:W<we?-1:W>we?1:0}function oe(_,W){if(_.type===0||W.type===1)return!0;if(_.type===9)return W.type===9?ce(_.expr,W.expr):!1;if(W.type===9){for(const ae of W.expr)if(oe(_,ae))return!0;return!1}if(_.type===6){if(W.type===6)return ce(W.expr,_.expr);for(const ae of _.expr)if(oe(ae,W))return!0;return!1}return _.equals(W)}e.$0i=oe;function ce(_,W){let ae=0,we=0;for(;ae<_.length&&we<W.length;){const ne=_[ae].cmp(W[we]);if(ne<0)return!1;ne===0&&ae++,we++}return ae===_.length}function ve(_){return _.type===9?_.expr:[_]}}),define(Ae[185],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,E.$Qh)("environmentService"),e.$Yh=(0,E.$Rh)(e.$Xh)}),define(Ae[96],Re([1,0,151,4]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$$n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=void 0,e.$Yn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Zn=new RegExp(e.$Yn),e.$1n="__web_extension",e.$2n="skipWalkthrough",e.$3n="extensionsSync",e.$4n="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$5n=P;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$6n=M;function R(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$7n=R;function $(i,n){return n==="web"&&!i.includes("web")}e.$8n=$;function D(i,n,u){return $(n,u)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===u}e.$9n=D;function g(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$0n=g;var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var S;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var o;(function(i){i.Install="install",i.Uninstall="uninstall"})(o||(e.StatisticType=o={}));var v;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$$n=(0,L.$Qh)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var f;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class t extends Error{constructor(n,u){super(n),this.code=u,this.name=u}}e.$_n=t,e.$ao=(0,L.$Qh)("extensionManagementService"),e.$bo="extensionsIdentifiers/disabled",e.$co="extensionsIdentifiers/enabled",e.$do=(0,L.$Qh)("IGlobalExtensionEnablementService"),e.$eo=(0,L.$Qh)("IExtensionTipsService"),e.$fo=(0,E.localize)(0,null),e.$go={value:e.$fo,original:"Extensions"},e.$ho={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Ae[41],Re([1,0,51,19,13,16,2,153,4,21,14,44]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,D.$Qh)("fileService");function o(oe){return oe.create===!0}e.$ak=o;var v;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var p;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function f(oe){const ce=oe;return!!ce&&typeof ce.onDidChange=="function"}e.$bk=f;var t;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(oe){return!!(oe.capabilities&2)}e.$ck=i;function n(oe){return!!(oe.capabilities&8)}e.$dk=n;function u(oe){return!!(oe.capabilities&131072)}e.$ek=u;function a(oe){return!!(oe.capabilities&4)}e.$fk=a;function l(oe){return!!(oe.capabilities&16)}e.$gk=l;function r(oe){return i(oe)?!!(oe.capabilities&16384):!1}e.$hk=r;function s(oe){return i(oe)?!!(oe.capabilities&32768):!1}e.$ik=s;function c(oe){return!!(oe.capabilities&65536)}e.$jk=c;function h(oe){return!!(oe.capabilities&2048)}e.$kk=h;var b;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class m extends Error{static create(ce,ve){const _=new m(ce.toString(),ve);return d(_,ve),_}constructor(ce,ve){super(ce),this.code=ve}}e.$lk=m;function I(oe,ce){return m.create(oe,ce)}e.$mk=I;function k(oe){return oe||I((0,$.localize)(0,null),b.Unknown)}e.$nk=k;function d(oe,ce){return oe.name=ce?`${ce} (FileSystemError)`:"FileSystemError",oe}e.$ok=d;function w(oe){if(!oe)return b.Unknown;if(oe instanceof m)return oe.code;const ce=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!ce)return b.Unknown;switch(ce[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.$pk=w;function y(oe){if(oe instanceof F)return oe.fileOperationResult;switch(w(oe)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.$qk=y;var C;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class B{constructor(ce,ve,_){this.resource=ce,this.operation=ve,this.target=_}isOperation(ce){return this.operation===ce}}e.$rk=B;var j;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class V{static{this.a=null}constructor(ce,ve){this.c=ve,this.b=void 0,this.d=new S.$U(()=>{const _=E.$Wh.forUris(()=>this.c);return _.fill(this.rawAdded.map(W=>[W,!0])),_}),this.f=new S.$U(()=>{const _=E.$Wh.forUris(()=>this.c);return _.fill(this.rawUpdated.map(W=>[W,!0])),_}),this.g=new S.$U(()=>{const _=E.$Wh.forUris(()=>this.c);return _.fill(this.rawDeleted.map(W=>[W,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of ce){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==V.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(ce,...ve){return this.h(ce,{includeChildren:!1},...ve)}affects(ce,...ve){return this.h(ce,{includeChildren:!0},...ve)}h(ce,ve,..._){if(!ce)return!1;const W=_.length>0;return!!((!W||_.includes(1))&&(this.d.value.get(ce)||ve.includeChildren&&this.d.value.findSuperstr(ce))||(!W||_.includes(0))&&(this.f.value.get(ce)||ve.includeChildren&&this.f.value.findSuperstr(ce))||(!W||_.includes(2))&&(this.g.value.findSubstr(ce)||ve.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$sk=V;function z(oe,ce,ve){return!oe||!ce||oe===ce||ce.length>oe.length?!1:(ce.charAt(ce.length-1)!==L.sep&&(ce+=L.sep),ve?(0,P.$3e)(oe,ce):oe.indexOf(ce)===0)}e.$tk=z;class F extends Error{constructor(ce,ve,_){super(ce),this.fileOperationResult=ve,this.options=_}}e.$uk=F;class O extends F{constructor(ce,ve,_,W){super(ce,ve,W),this.fileOperationResult=ve,this.size=_}}e.$vk=O;class x extends F{constructor(ce,ve,_){super(ce,2,_),this.stat=ve}}e.$wk=x;var Z;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var De;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(De||(e.FileKind=De={})),e.$Ek="";function ke(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}e.$Fk=ke;async function Ie(oe,ce){if(!ce.hasProvider(R.URI.from({scheme:oe.scheme})))return new Promise(ve=>{const _=ce.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===oe.scheme&&W.added&&(_.dispose(),ve())})})}e.$Gk=Ie;class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(ce){return(0,M.$Cf)(ce)||(ce=0),ce<de.KB?(0,$.localize)(1,null,ce.toFixed(0)):ce<de.MB?(0,$.localize)(2,null,(ce/de.KB).toFixed(2)):ce<de.GB?(0,$.localize)(3,null,(ce/de.MB).toFixed(2)):ce<de.TB?(0,$.localize)(4,null,(ce/de.GB).toFixed(2)):(0,$.localize)(5,null,(ce/de.TB).toFixed(2))}}e.$Hk=de;function be(oe){const ce=typeof oe=="string"||oe?.scheme===A.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===A.Schemas.file?1024*de.MB:ce?10*de.MB:g.$p?50*de.MB:1024*de.MB}e.$Ik=be}),define(Ae[72],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class E{constructor(...P){this.a=new Map;for(const[M,R]of P)this.set(M,R)}set(P,M){const R=this.a.get(P);return this.a.set(P,M),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Oh=E}),define(Ae[186],Re([1,0,12,11,6,70,184,4,72,187]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=void 0;const A=!1;class S extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class o{constructor(t=new D.$Oh,i=!1,n,u=A){this.f=t,this.g=i,this.h=n,this.i=u,this.o=new Set,this.f.set($.$Ph,this),this._globalGraph=u?n?._globalGraph??new R.$dq(a=>a):void 0}createChild(t){return new o(t,this.g,this,this.i)}invokeFunction(t,...i){const n=p.traceInvocation(this.i,t);let u=!1;try{return t({get:l=>{if(u)throw(0,L.$7)("service accessor is only valid during the invocation of its target method");const r=this.m(l,n);if(!r)throw new Error(`[invokeFunction] unknown service '${l}'`);return r}},...i)}finally{u=!0,n.stop()}}createInstance(t,...i){let n,u;return t instanceof M.$Nh?(n=p.traceCreation(this.i,t.ctor),u=this.j(t.ctor,t.staticArguments.concat(i),n)):(n=p.traceCreation(this.i,t),u=this.j(t,i,n)),n.stop(),u}j(t,i=[],n){const u=$._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),a=[];for(const r of u){const s=this.m(r.id,n);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),a.push(s)}const l=u.length>0?u[0].index:i.length;if(i.length!==l){console.trace(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${i.length} static arguments`);const r=l-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,l)}return Reflect.construct(t,i.concat(a))}k(t,i){if(this.f.get(t)instanceof M.$Nh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const n=this.l(t);return n instanceof M.$Nh?this.q(t,n,i.branch(t,!0)):(i.branch(t,!1),n)}q(t,i,n){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,n)}finally{this.o.delete(t)}}r(t,i,n){const u=new R.$dq(r=>r.id.toString());let a=0;const l=[{id:t,desc:i,_trace:n}];for(;l.length;){const r=l.pop();if(u.lookupOrInsertNode(r),a++>1e3)throw new S(u);for(const s of $._util.getServiceDependencies(r.desc.ctor)){const c=this.l(s.id);if(c||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),c instanceof M.$Nh){const h={id:s.id,desc:c,_trace:r._trace.branch(s.id,!0)};u.insertEdge(r,h),l.push(h)}}}for(;;){const r=u.roots();if(r.length===0){if(!u.isEmpty())throw new S(u);break}for(const{data:s}of r){if(this.l(s.id)instanceof M.$Nh){const h=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,h)}u.removeNode(s)}}return this.l(t)}s(t,i,n=[],u,a){if(this.f.get(t)instanceof M.$Nh)return this.t(t,i,n,u,a);if(this.h)return this.h.s(t,i,n,u,a);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,n=[],u,a){if(u){const l=new o(void 0,this.g,this,this.i);l.c=String(t);const r=new Map,s=new E.$_g(()=>{const c=l.j(i,n,a);for(const[h,b]of r){const m=c[h];if(typeof m=="function")for(const I of b)m.apply(c,I)}return r.clear(),c});return new Proxy(Object.create(null),{get(c,h){if(!s.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let I=r.get(h);return I||(I=new g.$1c,r.set(h,I)),(d,w,y)=>{const C=I.push([d,w,y]);return(0,P.$Pc)(C)}}if(h in c)return c[h];const b=s.value;let m=b[h];return typeof m!="function"||(m=m.bind(b),c[h]=m),m},set(c,h,b){return s.value[h]=b,!0},getPrototypeOf(c){return i.prototype}})}else return this.j(i,n,a)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$eq=o;var v;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(v||(v={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const n=new p(3,t.toString());return this.h.push([t,i,n]),n}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function n(a,l){const r=[],s=new Array(a+1).join("	");for(const[c,h,b]of l.h)if(h&&b){i=!0,r.push(`${s}CREATES -> ${c}`);const m=n(a+1,b);m&&r.push(m)}else r.push(`${s}uses -> ${c}`);return r.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add(u.join(`
`))}}e.$fq=p}),define(Ae[15],Re([1,0,39,5,97,6,28,21,24,16,2,34,4]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,o.$Qh)("logService"),e.$_i=(0,o.$Qh)("loggerService");function v(){return new Date().toISOString()}function p(d){return(0,g.$Cf)(d)}e.$aj=p;var f;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$bj=f.Info;function t(d,w,y){switch(w){case f.Trace:d.trace(y);break;case f.Debug:d.debug(y);break;case f.Info:d.info(y);break;case f.Warning:d.warn(y);break;case f.Error:d.error(y);break;case f.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=t;function i(d,w=!1){let y="";for(let C=0;C<d.length;C++){let B=d[C];if(B instanceof Error&&(B=(0,E.$Bi)(B,w)),typeof B=="object")try{B=JSON.stringify(B)}catch{}y+=(C>0?" ":"")+B}return y}class n extends M.$Rc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new L.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==f.Off&&this.b<=w}}e.$dj=n;class u extends n{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...y){this.f(f.Trace)&&this.g(f.Trace,i([w,...y],!0))}debug(w,...y){this.f(f.Debug)&&this.g(f.Debug,i([w,...y]))}info(w,...y){this.f(f.Info)&&this.g(f.Info,i([w,...y]))}warn(w,...y){this.f(f.Warning)&&this.g(f.Warning,i([w,...y]))}error(w,...y){if(this.f(f.Error))if(w instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=w.stack,this.g(f.Error,i(C))}else this.g(f.Error,i([w,...y]))}flush(){}}e.$ej=u;class a extends n{constructor(w=e.$bj){super(),this.setLevel(w),this.g=!$.$j}trace(w,...y){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...y):console.log(`[main ${v()}]`,w,...y))}debug(w,...y){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...y):console.log(`[main ${v()}]`,w,...y))}info(w,...y){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...y):console.log(`[main ${v()}]`,w,...y))}warn(w,...y){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,w,...y):console.warn(`[main ${v()}]`,w,...y))}error(w,...y){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,w,...y):console.error(`[main ${v()}]`,w,...y))}dispose(){}flush(){}}e.$fj=a;class l extends n{constructor(w=e.$bj,y=!0){super(),this.g=y,this.setLevel(w)}trace(w,...y){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...y):console.log(w,...y))}debug(w,...y){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...y):console.log(w,...y))}info(w,...y){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...y):console.log(w,...y))}warn(w,...y){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...y):console.log(w,...y))}error(w,...y){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...y):console.error(w,...y))}dispose(){}flush(){}}e.$gj=l;class r extends n{constructor(w,y=e.$bj){super(),this.g=w,this.setLevel(y)}trace(w,...y){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(w),...y])}debug(w,...y){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(w),...y])}info(w,...y){this.f(f.Info)&&this.g.log(f.Info,[this.h(w),...y])}warn(w,...y){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(w),...y])}error(w,...y){this.f(f.Error)&&this.g.log(f.Error,[this.h(w),...y])}h(w){return typeof w=="string"?w:(0,E.$Bi)(w,this.f(f.Trace))}dispose(){}flush(){}}e.$hj=r;class s extends n{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const y of this.g)y.setLevel(w);super.setLevel(w)}trace(w,...y){for(const C of this.g)C.trace(w,...y)}debug(w,...y){for(const C of this.g)C.debug(w,...y)}info(w,...y){for(const C of this.g)C.info(w,...y)}warn(w,...y){for(const C of this.g)C.warn(w,...y)}error(w,...y){for(const C of this.g)C.error(w,...y)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$ij=s;class c extends M.$Rc{constructor(w,y,C){if(super(),this.h=w,this.j=y,this.b=new R.$zc,this.c=this.B(new L.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Nd),this.onDidChangeVisibility=this.g.event,C)for(const B of C)this.b.set(B.resource,{logger:void 0,info:B})}m(w){return(0,g.$yf)(w)?[...this.b.values()].find(y=>y.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,y){const C=this.n(w),B=(0,g.$yf)(w)?w:y?.id??(0,P.$Ei)(C.toString()).toString(16);let j=this.b.get(C)?.logger;const V=y?.logLevel==="always"?f.Trace:y?.logLevel;j||(j=this.s(C,V??this.getLogLevel(C)??this.h,{...y,id:B}));const z={logger:j,info:{resource:C,id:B,logLevel:V,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(z.info),this.b.set(C,z),j}n(w){return(0,g.$yf)(w)?(0,D.$vg)(this.j,`${w}.log`):w}setLogLevel(w,y){if(A.URI.isUri(w)){const C=w,B=y,j=this.b.get(C);j&&B!==j.info.logLevel&&(j.info.logLevel=B===this.h?void 0:B,j.logger?.setLevel(B),this.b.set(j.info.resource,j),this.f.fire([C,B]))}else{this.h=w;for(const[C,B]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,y){const C=this.m(w);C&&y!==!C.info.hidden&&(C.info.hidden=!y,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,y]))}getLogLevel(w){let y;return w&&(y=this.b.get(w)?.info.logLevel),y??this.h}registerLogger(w){const y=this.b.get(w.resource);y?y.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const y=this.b.get(w);y&&(y.logger&&y.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=c;class h{constructor(){this.onDidChangeLogLevel=new L.$Nd().event}setLevel(w){}getLevel(){return f.Info}trace(w,...y){}debug(w,...y){}info(w,...y){}warn(w,...y){}error(w,...y){}critical(w,...y){}dispose(){}flush(){}}e.$kj=h;class b extends h{}e.$lj=b;function m(d){if(d.verbose)return f.Trace;if(typeof d.logLevel=="string"){const w=k(d.logLevel.toLowerCase());if(w!==void 0)return w}return e.$bj}e.$mj=m;function I(d){switch(d){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$nj=I;function k(d){switch(d){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$oj=k,e.$pj=new S.$8i("logLevel",I(f.Info))}),define(Ae[188],Re([1,0,6,15]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=void 0;class P extends E.$Rc{constructor(R,$=[]){super(),this.a=new L.$ij([R,...$]),this.B(R.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$RN=P}),define(Ae[98],Re([1,0,31,154,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(D){function g(p,f){return f-p}D.compare=g;const A=Object.create(null);A[D.Error]=(0,L.localize)(0,null),A[D.Warning]=(0,L.localize)(1,null),A[D.Info]=(0,L.localize)(2,null);function S(p){return A[p]||""}D.toString=S;function o(p){switch(p){case E.default.Error:return D.Error;case E.default.Warning:return D.Warning;case E.default.Info:return D.Info;case E.default.Ignore:return D.Hint}}D.fromSeverity=o;function v(p){switch(p){case D.Error:return E.default.Error;case D.Warning:return E.default.Warning;case D.Info:return E.default.Info;case D.Hint:return E.default.Ignore}}D.toSeverity=v}(R||(e.MarkerSeverity=R={}));var $;(function(D){const g="";function A(o){return S(o,!0)}D.makeKey=A;function S(o,v){const p=[g];return o.source?p.push(o.source.replace("\xA6","\\\xA6")):p.push(g),o.code?typeof o.code=="string"?p.push(o.code.replace("\xA6","\\\xA6")):p.push(o.code.value.replace("\xA6","\\\xA6")):p.push(g),o.severity!==void 0&&o.severity!==null?p.push(R.toString(o.severity)):p.push(g),o.message&&v?p.push(o.message.replace("\xA6","\\\xA6")):p.push(g),o.startLineNumber!==void 0&&o.startLineNumber!==null?p.push(o.startLineNumber.toString()):p.push(g),o.startColumn!==void 0&&o.startColumn!==null?p.push(o.startColumn.toString()):p.push(g),o.endLineNumber!==void 0&&o.endLineNumber!==null?p.push(o.endLineNumber.toString()):p.push(g),o.endColumn!==void 0&&o.endColumn!==null?p.push(o.endColumn.toString()):p.push(g),p.push(g),p.join("\xA6")}D.makeKeyOptionalMessage=S})($||(e.IMarkerData=$={})),e.$at=(0,P.$Qh)("markerService")}),define(Ae[189],Re([1,0,5,31,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3u=e.$2u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$1u=e.Severity=void 0,e.Severity=L.default,e.$1u=(0,P.$Qh)("notificationService");var M;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class D{constructor(){this.progress=new g,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$2u=D;class g{infinite(){}done(){}total(S){}worked(S){}}e.$3u=g}),define(Ae[99],Re([1,0,13,2,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EU=e.$DU=e.$CU=e.$BU=e.$AU=void 0,e.$AU=(0,P.$Qh)("openerService");function M(g,A){return L.URI.isUri(g)?(0,E.$2e)(g.scheme,A):(0,E.$3e)(g,A+":")}e.$BU=M;function R(g,...A){return A.some(S=>M(g,S))}e.$CU=R;function $(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$DU=$;function D(g){let A;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return S&&(A={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$EU=D}),define(Ae[190],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,E.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(pe,e,E,L){var P=arguments.length,M=P<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,E):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(pe,e,E,L);else for(var $=pe.length-1;$>=0;$--)(R=pe[$])&&(M=(P<3?R(M):P>3?R(e,E,M):R(e,E))||M);return P>3&&M&&Object.defineProperty(e,E,M),M},Ve=this&&this.__param||function(pe,e){return function(E,L){e(E,L,pe)}};define(Ae[54],Re([1,0,12,20,6,4]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.ProgressLocation=e.$4u=void 0,e.$4u=(0,M.$Qh)("progressService");var R;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$5u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(o){this.b=o}report(o){this.a=o,this.b(this.a)}}e.$6u=$;class D{get value(){return this.a}constructor(o){this.e=o}report(o){this.b?this.b.push(o):this.b=[o],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const o=this.b.shift();this.a=o,await this.e(this.a)}}finally{this.c=!1;const o=this.d;this.d=void 0,o?.()}}drain(){return this.c?new Promise(o=>{const v=this.d;this.d=()=>{v?.(),o()}}):Promise.resolve()}}e.$7u=D;let g=class extends P.$Rc{constructor(o,v){super(),this.a=new E.$dh,v.withProgress(o,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Pc)(()=>this.a.complete()))}report(o){this.b?this.b.report(o):this.c=o}};e.$8u=g,e.$8u=g=Ke([Ve(1,e.$4u)],g);class A extends P.$Rc{constructor(o){super(),this.g=o,this.a=0,this.b=this.B(new P.$Qc)}start(o){this.stop();const v=++this.a,p=new L.$Xd;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},o),this.b.add((0,P.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Pc)(()=>p.cancel())),this.b.add((0,P.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:p.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(o){this.a===o&&this.b.clear()}}e.$9u=A,e.$0u=(0,M.$Qh)("editorProgressService")}),define(Ae[30],Re([1,0,55,16]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0;class P{constructor(){this.a=new Map}add(R,$){E.ok(L.$yf(R)),E.ok(L.$Af($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$hn=new P}),define(Ae[73],Re([1,0,5,30]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=void 0,e.$in={JSONContribution:"base.contributions.json"};function P($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[P(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;L.$hn.add(e.$in.JSONContribution,R)}),define(Ae[56],Re([1,0,18,5,16,148,40,73,30]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.ConfigurationScope=e.$mn=e.EditPresentationTypes=void 0;var g;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$mn={Configuration:"base.contributions.configuration"};var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn="vscode://schemas/settings/resourceLanguage",e.$un="vscode://schemas/settings/configurationDefaults";const S=D.$hn.as($.$in.JSONContribution);class o{constructor(){this.h=new Set,this.i=new L.$Nd,this.onDidSchemaChange=this.i.event,this.j=new L.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$tn,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const c=new Set;this.n(r,s,c),S.registerSchema(e.$tn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(r){const s=new Set;this.o(r,s),S.registerSchema(e.$tn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const c=new Set;this.o(s,c),this.n(r,!1,c),S.registerSchema(e.$tn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const c=[];for(const{overrides:h,source:b}of r)for(const m in h)if(s.add(m),e.$wn.test(m)){const I=this.a.get(m),k=I?.valuesSources??new Map;if(b)for(const C of Object.keys(h[m]))k.set(C,b);const d={...I?.value||{},...h[m]};this.a.set(m,{source:b,value:d,valuesSources:k});const w=(0,R.$ui)(m),y={type:"object",default:d,description:M.localize(1,null,w),$ref:e.$tn,defaultDefaultValue:d,source:P.$yf(b)?void 0:b,defaultValueSource:b};c.push(...f(m)),this.d[m]=y,this.b.properties[m]=y}else{this.a.set(m,{value:h[m],source:b});const I=this.d[m];I&&(this.w(m,I),this.r(m,I))}this.m(c)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:c,source:h}of r)for(const b in c){const m=this.a.get(b),I=P.$yf(h)?h:h?.id,k=P.$yf(m?.source)?m?.source:m?.source?.id;if(I===k)if(s.add(b),this.a.delete(b),e.$wn.test(b))delete this.d[b],delete this.b.properties[b];else{const d=this.d[b];d&&(this.w(b,d),this.r(b,d))}}this.u()}deltaConfiguration(r){let s=!1;const c=new Set;r.removedDefaults&&(this.l(r.removedDefaults,c),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,c),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,c),r.addedConfigurations&&this.n(r.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,c){r.forEach(h=>{this.p(h,s,h.extensionInfo,h.restrictedProperties,void 0,c),this.c.push(h),this.q(h)})}o(r,s){const c=h=>{if(h.properties)for(const b in h.properties){s.add(b);const m=this.d[b];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[b],this.s(b,h.properties[b])}h.allOf?.forEach(b=>c(b))};for(const h of r){c(h);const b=this.c.indexOf(h);b!==-1&&this.c.splice(b,1)}}p(r,s=!0,c,h,b=3,m){b=P.$Hf(r.scope)?b:r.scope;const I=r.properties;if(I)for(const d in I){const w=I[d];if(s&&u(d,w)){delete I[d];continue}if(w.source=c,w.defaultDefaultValue=I[d].default,this.w(d,w),e.$wn.test(d)?w.scope=void 0:(w.scope=P.$Hf(w.scope)?b:w.scope,w.restricted=P.$Hf(w.restricted)?!!h?.includes(d):w.restricted),I[d].hasOwnProperty("included")&&!I[d].included){this.f[d]=I[d],delete I[d];continue}else this.d[d]=I[d],I[d].policy?.name&&this.e.set(I[d].policy.name,d);!I[d].deprecationMessage&&I[d].markdownDeprecationMessage&&(I[d].deprecationMessage=I[d].markdownDeprecationMessage),m.add(d)}const k=r.allOf;if(k)for(const d of k)this.p(d,s,c,h,b,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=c=>{const h=c.properties;if(h)for(const m in h)this.r(m,h[m]);c.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$nn.properties[r]=s,s.scope){case 1:e.$on.properties[r]=s;break;case 2:e.$pn.properties[r]=s;break;case 6:e.$qn.properties[r]=s;break;case 3:e.$rn.properties[r]=s;break;case 4:e.$sn.properties[r]=s;break;case 5:e.$sn.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$nn.properties[r],s.scope){case 1:delete e.$on.properties[r];break;case 2:delete e.$pn.properties[r];break;case 6:delete e.$qn.properties[r];break;case 3:delete e.$rn.properties[r];break;case 4:case 5:delete e.$sn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,c={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$tn};this.w(s,c),e.$nn.properties[s]=c,e.$on.properties[s]=c,e.$pn.properties[s]=c,e.$qn.properties[s]=c,e.$rn.properties[s]=c,e.$sn.properties[s]=c}}v(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$tn};e.$nn.patternProperties[e.$vn]=r,e.$on.patternProperties[e.$vn]=r,e.$pn.patternProperties[e.$vn]=r,e.$qn.patternProperties[e.$vn]=r,e.$rn.patternProperties[e.$vn]=r,e.$sn.patternProperties[e.$vn]=r,this.i.fire()}w(r,s){const c=this.a.get(r);let h=c?.value,b=c?.source;P.$Ff(h)&&(h=s.defaultDefaultValue,b=void 0),P.$Ff(h)&&(h=i(s.type)),s.default=h,s.defaultValueSource=b}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.$vn=`^(${v})+$`,e.$wn=new RegExp(e.$vn);function f(l){const r=[];if(e.$wn.test(l)){let s=p.exec(l);for(;s?.length;){const c=s[1].trim();c&&r.push(c),s=p.exec(l)}}return(0,E.$Lb)(r)}e.$xn=f;function t(l){return l.reduce((r,s)=>`${r}[${s}]`,"")}e.$yn=t;function i(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$zn=i;const n=new o;D.$hn.add(e.$mn.Configuration,n);function u(l,r){return l.trim()?e.$wn.test(l)?M.localize(7,null,l):n.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):r.policy?.name&&n.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,l,r.policy?.name,n.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.$An=u;function a(){const l=[],r=n.getConfigurationProperties();for(const s of Object.keys(r))l.push([s,r[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$Bn=a}),define(Ae[191],Re([1,0,18,5,119,6,28,26,16,2,40,56,30]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=void 0;function v(s){return Object.isFrozen(s)?s:$.$9m(s)}class p{constructor(c={},h=[],b=[],m){this.b=c,this.c=h,this.d=b,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(h=>{if(h instanceof p)return h;const b=new f("");return b.parseRaw(h),b.configurationModel});this.f=c.reduce((h,b)=>b===h?b:h.merge(b),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,A.$si)(this.contents,c):this.contents}inspect(c,h){const b=this.rawConfiguration.getValue(c),m=h?this.rawConfiguration.getOverrideValue(c,h):void 0,I=h?this.rawConfiguration.override(h).getValue(c):b;return{value:b,override:m,merged:I}}getOverrideValue(c,h){const b=this.i(h);return b?c?(0,A.$si)(b,c):b:void 0}getKeysForOverrideIdentifier(c){const h=[];for(const b of this.overrides)b.identifiers.includes(c)&&h.push(...b.keys);return E.$Lb(h)}getAllOverrideIdentifiers(){const c=[];for(const h of this.overrides)c.push(...h.identifiers);return E.$Lb(c)}override(c){let h=this.a.get(c);return h||(h=this.g(c),this.a.set(c,h)),h}merge(...c){const h=$.$8m(this.contents),b=$.$8m(this.overrides),m=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const k of c)if(I.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(h,k.contents);for(const d of k.overrides){const[w]=b.filter(y=>E.$tb(y.identifiers,d.identifiers));w?(this.h(w.contents,d.contents),w.keys.push(...d.keys),w.keys=E.$Lb(w.keys)):b.push($.$8m(d))}for(const d of k.keys)m.indexOf(d)===-1&&m.push(d)}return new p(h,m,b,I.every(k=>k instanceof p)?void 0:I)}g(c){const h=this.i(c);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const b={};for(const m of E.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let I=this.contents[m];const k=h[m];k&&(typeof I=="object"&&typeof k=="object"?(I=$.$8m(I),this.h(I,k)):I=k),b[m]=I}return new p(b,this.keys,this.overrides)}h(c,h){for(const b of Object.keys(h)){if(b in c&&D.$Af(c[b])&&D.$Af(h[b])){this.h(c[b],h[b]);continue}c[b]=$.$8m(h[b])}}i(c){let h=null,b=null;const m=I=>{I&&(b?this.h(b,I):b=$.$8m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===c?h=I.contents:I.identifiers.includes(c)&&m(I.contents);return m(h),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,h){this.j(c,h,!0)}setValue(c,h){this.j(c,h,!1)}removeValue(c){const h=this.keys.indexOf(c);h!==-1&&(this.keys.splice(h,1),(0,A.$ri)(this.contents,c),S.$wn.test(c)&&this.overrides.splice(this.overrides.findIndex(b=>E.$tb(b.identifiers,(0,S.$xn)(c))),1))}j(c,h,b){(0,A.$qi)(this.contents,c,h,m=>console.error(m)),b=b||this.keys.indexOf(c)===-1,b&&this.keys.push(c),S.$wn.test(c)&&this.overrides.push({identifiers:(0,S.$xn)(c),keys:Object.keys(this.contents[c]),contents:(0,A.$pi)(this.contents[c],m=>console.error(m))})}}e.$Cn=p;class f{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,h){if(!D.$Hf(c)){const b=this.g(c);this.parseRaw(b,h)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,h){this.a=c;const{contents:b,keys:m,overrides:I,restricted:k,hasExcludedProperties:d}=this.h(c,h);this.b=new p(b,m,I,d?[c]:void 0),this.c=k||[]}g(c){let h={},b=null,m=[];const I=[],k=[];function d(y){Array.isArray(m)?m.push(y):b!==null&&(m[b]=y)}const w={onObjectBegin:()=>{const y={};d(y),I.push(m),m=y,b=null},onObjectProperty:y=>{b=y},onObjectEnd:()=>{m=I.pop()},onArrayBegin:()=>{const y=[];d(y),I.push(m),m=y,b=null},onArrayEnd:()=>{m=I.pop()},onLiteralValue:d,onError:(y,C,B)=>{k.push({error:y,offset:C,length:B})}};if(c)try{P.$5m(c,w),h=m[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return h}h(c,h){const b=o.$hn.as(S.$mn.Configuration).getConfigurationProperties(),m=this.i(c,b,!0,h);c=m.raw;const I=(0,A.$pi)(c,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(c),d=this.j(c,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:I,keys:k,overrides:d,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(c,h,b,m){let I=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:I};const k={},d=[];for(const w in c)if(S.$wn.test(w)&&b){const y=this.i(c[w],h,!1,m);k[w]=y.raw,I=I||y.hasExcludedProperties,d.push(...y.restricted)}else{const y=h[w],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&d.push(w),!m.exclude?.includes(w)&&(m.include?.includes(w)||(C===void 0||m.scopes===void 0||m.scopes.includes(C))&&!(m.skipRestricted&&y?.restricted))?k[w]=c[w]:I=!0}return{raw:k,restricted:d,hasExcludedProperties:I}}j(c,h){const b=[];for(const m of Object.keys(c))if(S.$wn.test(m)){const I={};for(const k in c[m])I[k]=c[m][k];b.push({identifiers:(0,S.$xn)(m),keys:Object.keys(I),contents:(0,A.$pi)(I,h)})}return b}}e.$Dn=f;class t extends M.$Rc{constructor(c,h,b,m){super(),this.c=c,this.f=h,this.g=m,this.b=this.B(new L.$Nd),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&b.isEqual(I.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$En=t;class i{constructor(c,h,b,m,I,k,d,w,y,C,B,j,V){this.a=c,this.b=h,this.c=b,this.overrideIdentifiers=m,this.d=I,this.f=k,this.g=d,this.h=w,this.i=y,this.j=C,this.k=B,this.l=j,this.m=V}get value(){return v(this.c)}n(c,h,b){const m=c.inspect(h,b);return{get value(){return v(m.value)},get override(){return v(m.override)},get merged(){return v(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(c,h,b,m,I=new p,k=new p,d=new R.$zc,w=new p,y=new R.$zc){this.c=c,this.d=h,this.f=b,this.g=m,this.h=I,this.i=k,this.j=d,this.l=w,this.m=y,this.a=null,this.b=new R.$zc,this.n=null}getValue(c,h,b){return this.q(c,h,b).getValue(c)}updateValue(c,h,b={}){let m;b.resource?(m=this.m.get(b.resource),m||(m=new p,this.m.set(b.resource,m))):m=this.l,h===void 0?m.removeValue(c):m.setValue(c,h),b.resource||(this.a=null)}inspect(c,h,b){const m=this.q(c,h,b),I=this.u(h.resource,b),k=h.resource?this.m.get(h.resource)||this.l:this.l,d=new Set;for(const w of m.overrides)for(const y of w.identifiers)m.getOverrideValue(c,y)!==void 0&&d.add(y);return new i(c,h,m.getValue(c),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,I||void 0,k)}keys(c){const h=this.u(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,h){this.j.set(c,h),this.b.delete(c)}deleteFolderConfiguration(c){this.p.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,h){const b=[];if(!h){const{added:m,updated:I,removed:k}=l(this.c,c);h=[...m,...I,...k]}for(const m of h)for(const I of(0,S.$xn)(m)){const k=this.c.getKeysForOverrideIdentifier(I),d=c.getKeysForOverrideIdentifier(I),w=[...d.filter(y=>k.indexOf(y)===-1),...k.filter(y=>d.indexOf(y)===-1),...k.filter(y=>!$.$_m(this.c.override(I).getValue(y),c.override(I).getValue(y)))];b.push([I,w])}return this.updateDefaultConfiguration(c),{keys:h,overrides:b}}compareAndUpdatePolicyConfiguration(c){const{added:h,updated:b,removed:m}=l(this.d,c),I=[...h,...b,...m];return I.length&&this.updatePolicyConfiguration(c),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:h,updated:b,removed:m,overrides:I}=l(this.applicationConfiguration,c),k=[...h,...b,...m];return k.length&&this.updateApplicationConfiguration(c),{keys:k,overrides:I}}compareAndUpdateLocalUserConfiguration(c){const{added:h,updated:b,removed:m,overrides:I}=l(this.localUserConfiguration,c),k=[...h,...b,...m];return k.length&&this.updateLocalUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateRemoteUserConfiguration(c){const{added:h,updated:b,removed:m,overrides:I}=l(this.remoteUserConfiguration,c),k=[...h,...b,...m];return k.length&&this.updateRemoteUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateWorkspaceConfiguration(c){const{added:h,updated:b,removed:m,overrides:I}=l(this.workspaceConfiguration,c),k=[...h,...b,...m];return k.length&&this.updateWorkspaceConfiguration(c),{keys:k,overrides:I}}compareAndUpdateFolderConfiguration(c,h){const b=this.p.get(c),{added:m,updated:I,removed:k,overrides:d}=l(b,h),w=[...m,...I,...k];return(w.length||!b)&&this.updateFolderConfiguration(c,h),{keys:w,overrides:d}}compareAndDeleteFolderConfiguration(c){const h=this.p.get(c);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:b,updated:m,removed:I,overrides:k}=l(h,void 0);return{keys:[...b,...m,...I],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(c,h,b){let m=this.r(h,b);return h.overrideIdentifier&&(m=m.override(h.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(m=m.merge(this.d)),m}r({resource:c},h){let b=this.s();if(h&&c){const m=h.getFolder(c);m&&(b=this.t(m.uri)||b);const I=this.m.get(c);I&&(b=b.merge(I))}return b}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(c){let h=this.b.get(c);if(!h){const b=this.s(),m=this.j.get(c);m?(h=b.merge(m),this.b.set(c,h)):h=b}return h}u(c,h){if(h&&c){const b=h.getFolder(c);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,h)=>{const{contents:b,overrides:m,keys:I}=this.j.get(h);return c.push([h,{contents:b,overrides:m,keys:I}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(h=>c.add(h)),this.userConfiguration.keys.forEach(h=>c.add(h)),this.i.keys.forEach(h=>c.add(h)),this.j.forEach(h=>h.keys.forEach(b=>c.add(b))),[...c.values()]}v(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.i.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.j.forEach(h=>h.getAllOverrideIdentifiers().forEach(b=>c.add(b))),[...c.values()]}w(c){const h=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(b=>h.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(b=>h.add(b)),this.i.getKeysForOverrideIdentifier(c).forEach(b=>h.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(c).forEach(m=>h.add(m))),[...h.values()]}static parse(c){const h=this.x(c.defaults),b=this.x(c.policy),m=this.x(c.application),I=this.x(c.user),k=this.x(c.workspace),d=c.folders.reduce((w,y)=>(w.set(g.URI.revive(y[0]),this.x(y[1])),w),new R.$zc);return new n(h,b,m,I,new p,k,d,new p,new R.$zc)}static x(c){return new p(c.contents,c.keys,c.overrides)}}e.$Fn=n;function u(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const c=new Set,h=new Map;for(const m of s)m.keys.forEach(I=>c.add(I)),m.overrides.forEach(([I,k])=>{const d=(0,R.$wc)(h,I,new Set);k.forEach(w=>d.add(w))});const b=[];return h.forEach((m,I)=>b.push([I,[...m.values()]])),{keys:[...c.values()],overrides:b}}e.$Gn=u;class a{constructor(c,h,b,m){this.change=c,this.f=h,this.g=b,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of c.keys)this.affectedKeys.add(I);for(const[,I]of c.overrides)for(const k of I)this.affectedKeys.add(k);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(c,h){const b=this.a+c,m=this.d.indexOf(b);if(m<0)return!1;const I=m+b.length;if(I>=this.d.length)return!1;const k=this.d.charCodeAt(I);if(k!==this.b&&k!==this.c)return!1;if(h){const d=this.previousConfiguration?this.previousConfiguration.getValue(c,h,this.f?.workspace):void 0,w=this.g.getValue(c,h,this.h);return!$.$_m(d,w)}return!0}}e.$Hn=a;function l(s,c){const{added:h,removed:b,updated:m}=r(c?.rawConfiguration,s?.rawConfiguration),I=[],k=s?.getAllOverrideIdentifiers()||[],d=c?.getAllOverrideIdentifiers()||[];if(c){const w=d.filter(y=>!k.includes(y));for(const y of w)I.push([y,c.getKeysForOverrideIdentifier(y)])}if(s){const w=k.filter(y=>!d.includes(y));for(const y of w)I.push([y,s.getKeysForOverrideIdentifier(y)])}if(c&&s){for(const w of k)if(d.includes(w)){const y=r({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:c.getOverrideValue(void 0,w)||{},keys:c.getKeysForOverrideIdentifier(w)});I.push([w,[...y.added,...y.removed,...y.updated]])}}return{added:h,removed:b,updated:m,overrides:I}}function r(s,c){const h=s?c?s.keys.filter(I=>c.keys.indexOf(I)===-1):[...s.keys]:[],b=c?s?c.keys.filter(I=>s.keys.indexOf(I)===-1):[...c.keys]:[],m=[];if(s&&c){for(const I of c.keys)if(s.keys.indexOf(I)!==-1){const k=(0,A.$si)(c.contents,I),d=(0,A.$si)(s.contents,I);$.$_m(k,d)||m.push(I)}}return{added:h,removed:b,updated:m}}}),define(Ae[100],Re([1,0,11,4]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,L.$Qh)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=M;class R{constructor(S,o){this.host=S,this.port=o,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class D extends E.$ab{static isNotAvailable(S){return S instanceof D&&S._code===$.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof D&&S._code===$.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof D&&S._code===$.NoResolverFound}static isInvalidAuthority(S){return S instanceof D&&S._code===$.InvalidAuthority}static isHandled(S){return S instanceof D&&S.isHandled}constructor(S,o=$.Unknown,v){super(S),this._message=S,this._code=o,this._detail=v,this.isHandled=o===$.NotAvailable&&v===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Tk=D;function g(A){const S=A.indexOf("+");return S===-1?A:A.substring(0,S)}e.$Uk=g}),define(Ae[57],Re([1,0,14]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function L(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}e.$Vk=L;function P(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$Wk=P;function M(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Xk=M;function R(g){const{host:A,port:S}=D(g);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:S}}e.$Yk=R;function $(g,A){let{host:S,port:o}=D(g);return typeof o>"u"&&(o=A),{host:S,port:o}}e.$Zk=$;function D(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const o=g.match(/(.*):(\d+)$/);return o?{host:o[1],port:parseInt(o[2],10)}:{host:g,port:void 0}}}),define(Ae[22],Re([1,0,13,4,57]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.TargetPlatform=e.ExtensionType=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l="extensions.user.cache",e.$2l="extensions.builtin.cache",e.$3l="undefined_publisher",e.$4l=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$5l=M,e.$6l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const n=typeof t=="string"?t:t.value,u=typeof i=="string"?i:i.value;return E.$2e(n,u)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$7l=D;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$8l=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$9l=A;function S(f){return o(f)}e.$0l=S;function o(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$$l=o;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$_l=v;function p(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.$Wk)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.$am=p,e.$bm=(0,L.$Qh)("IBuiltinExtensionsScannerService")}),define(Ae[101],Re([1,0,11,22]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const D of R){const g=this.readActivationEvents(D);g.length>0&&($[L.$7l.toKey(D.identifier)]=g)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let D=0;D<$.length;D++)$[D]==="onUri"&&($[D]=`onUri:${L.$7l.toKey(R.identifier)}`);if(!R.contributes)return $;for(const D in R.contributes){const g=this.a.get(D);if(!g)continue;const A=R.contributes[D],S=Array.isArray(A)?A:[A];try{g(S,$)}catch(o){(0,E.$Z)(o)}}return $}}e.$9E=P,e.$0E=new P}),define(Ae[192],Re([1,0,21,74,38]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=void 0;function M(D){if(E.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function R(D,g,A,S,o,v,p,f,t){const i=Object.create(null);i["common.machineId"]=v,i["common.sqmId"]=p,i.sessionID=(0,P.$eg)()+Date.now(),i.commitHash=S,i.version=o,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,E.$i)(E.$u),i["common.nodePlatform"]=L.$cc,i["common.nodeArch"]=A,i["common.product"]=t||"desktop",f&&(i["common.msftInternal"]=f);let n=0;const u=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$m&&(i["common.snap"]="true");const a=M(g);return a&&(i["common.platformDetail"]=a),i}e.$io=R;function $(D){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return D.some(S=>A===S)}e.$jo=$}),define(Ae[193],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,E.$Qh)("telemetryService"),e.$el=(0,E.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ae[58],Re([1,0,26,16,5,40,57,192,193]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=void 0;class g{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$ko=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$lo=A,e.$mo=new A;class S{async publicLog(b,m,I){}async publicLogError(b,m,I){}}e.$no=S,e.$oo="telemetry",e.$po="extensionTelemetryLog",e.$qo={log:()=>null,flush:()=>Promise.resolve(null)};function o(h,b){return P.Event.debounce(b.onDidChangeConfiguration,(I,k)=>{const d=I?new Set([...I.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:d}},1e3,!0)(I=>{I.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,M.$ni)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$ro=o;function v(h,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!h.enableTelemetry)}e.$so=v;function p(h,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.$to=p;function f(h){const b=h.getValue(D.$ll),m=h.getValue(D.$ml);if(h.getValue(D.$nl)===!1||m===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$uo=f;function t(h){const b={},m={},I={};u(h,I);for(let k in I){k=k.length>150?k.substr(k.length-149):k;const d=I[k];typeof d=="number"?m[k]=d:typeof d=="boolean"?m[k]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${d.length}`),b[k]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(b[k]=d)}return{properties:b,measurements:m}}e.$vo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(h){if(!h)return"none";const b=(0,R.$Wk)(h);return i.has(b)?b:"other"}e.$wo=n;function u(h,b,m=0,I){if(h)for(const k of Object.getOwnPropertyNames(h)){const d=h[k],w=I?I+k:k;Array.isArray(d)?b[w]=(0,E.$an)(d):d instanceof Date?b[w]=d.toISOString():(0,L.$Af)(d)?m<2?u(d,b,m+1,w+"."):b[w]=(0,E.$an)(d):b[w]=d}}function a(h,b){const m=h.msftInternalDomains||[],I=b.getValue("telemetry.internalTesting");return(0,$.$jo)(m)||I}e.$xo=a;function l(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.$yo=l;function r(h,b){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let m=h;const I=[];for(const y of b)for(;;){const C=y.exec(h);if(!C)break;I.push([C.index,y.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(m="";;){const y=d.exec(h);if(!y)break;const C=I.some(([B,j])=>y.index<j&&B<d.lastIndex);!k.test(y[0])&&!C&&(m+=h.substring(w,y.index)+"<REDACTED: user-file-path>",w=d.lastIndex)}return w<h.length&&(m+=h.substr(w)),m}function s(h){if(!h)return h;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of b)if(m.regex.test(h))return`<REDACTED: ${m.label}>`;return h}function c(h,b){return(0,E.$0m)(h,m=>{if(m instanceof g||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let I=m.replaceAll("%20"," ");I=r(I,b);for(const k of b)I=I.replace(k,"");return I=s(I),I}})}e.$zo=c}),define(Ae[194],Re([1,0,13,96,22,21,2,11,74,58]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;function A(c,h){return c.uuid&&h.uuid?c.uuid===h.uuid:c.id===h.id?!0:(0,E.$We)(c.id,h.id)===0}e.$Ao=A;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class o{static create(h){const b=h.manifest?h.manifest.version:h.version,m=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new o(h.identifier,b,m)}static parse(h){const b=S.exec(h);return b&&b[1]&&b[2]?new o({id:b[1]},b[2],b[4]||void 0):null}constructor(h,b,m="undefined"){this.version=b,this.targetPlatform=m,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof o?A(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$Bo=o;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(c){const h=v.exec(c);return h&&h[1]?[t(h[1]),h[2]]:[t(c),void 0]}e.$Co=p;function f(c,h){return`${c}.${h}`}e.$Do=f;function t(c){return c.toLowerCase()}e.$Eo=t;function i(c,h){return t(f(c??P.$3l,h))}e.$Fo=i;function n(c,h){const b=[],m=I=>{for(const k of b)if(k.some(d=>A(h(d),h(I))))return k;return null};for(const I of c){const k=m(I);k?k.push(I):b.push([I])}return b}e.$Go=n;function u(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$Ho=u;function a(c){return{id:new g.$ko(c.identifier.id),name:new g.$ko(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Io=a,e.$Jo=new P.$7l("pprice.better-merge");function l(c,h){const b=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const I=m.shift();if(I&&b.every(k=>!A(k.identifier,{id:I}))){const k=c.filter(d=>A(d.identifier,{id:I}));k.length===1&&(b.push(k[0]),m.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.$Ko=l;async function r(c,h){if(!M.$l)return!1;let b;try{b=(await c.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await c.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){h.debug("Error while getting the os-release file.",(0,$.$9)(I))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(c,h){const b=await r(c,h),m=(0,L.$7n)(b?"alpine":M.$u,D.$dc);return h.debug("ComputeTargetPlatform:",m),m}e.$Lo=s}),define(Ae[195],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.$or=e.$nr=e.$mr=e.$lr=void 0;function E(D){return[...D.entries()]}e.$lr=E;function L(D){return D?[...D.entries()]:[]}e.$mr=L;function P(D){return new Map(D)}e.$nr=P;function M(D){return new Map(D??[])}e.$or=M;function R(D){return Array.from(D.entries()).map(g=>[g[0],E(g[1].map),L(g[1].descriptionMap)])}e.$pr=R;function $(D){return new Map(D.map(g=>[g[0],{map:P(g[1]),descriptionMap:M(g[2])}]))}e.$qr=$}),define(Ae[196],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pb=void 0;class E{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,R=5){const $=M(D=>{const g=typeof D=="string"?D:D.data;let A=this.a.get(P);if(A){A.data.push(g);return}const S=setTimeout(()=>this.flushBuffer(P),R);A={data:[g],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(P),$.dispose()}},this.a.set(P,A)});return $}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$$pb=E}),define(Ae[197],Re([1,0,12,90,45,5,16,2,155,73,30]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.IconFontDefinition=e.IconContribution=e.$6v=void 0,e.$6v={IconContribution:"base.contributions.icons"};var S;(function(a){function l(r,s){let c=r.defaults;for(;P.ThemeIcon.isThemeIcon(c);){const h=p.getIcon(c.id);if(!h)return;c=h.defaults}return c}a.getDefinition=l})(S||(e.IconContribution=S={}));var o;(function(a){function l(s){return{weight:s.weight,style:s.style,src:s.src.map(c=>({format:c.format,location:c.location.toString()}))}}a.toJSONObject=l;function r(s){const c=h=>(0,R.$yf)(h)?h:void 0;if(s&&Array.isArray(s.src)&&s.src.every(h=>(0,R.$yf)(h.format)&&(0,R.$yf)(h.location)))return{weight:c(s.weight),style:c(s.style),src:s.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}a.fromJSONObject=r})(o||(e.IconFontDefinition=o={}));class v{constructor(){this.a=new M.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,r,s,c){const h=this.b[l];if(h){if(s&&!h.description){h.description=s,this.d.properties[l].markdownDescription=`${s} $(${l})`;const I=this.e.enum.indexOf(l);I!==-1&&(this.e.enumDescriptions[I]=s),this.a.fire()}return h}const b={id:l,description:s,defaults:r,deprecationMessage:c};this.b[l]=b;const m={$ref:"#/definitions/icons"};return c&&(m.deprecationMessage=c),s&&(m.markdownDescription=`${s}: $(${l})`),this.d.properties[l]=m,this.e.enum.push(l),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const r=this.e.enum.indexOf(l);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,r){const s=this.f[l];return s||(this.f[l]=r,this.a.fire(),r)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(h,b)=>h.id.localeCompare(b.id),r=h=>{for(;P.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(h=>this.b[h]);for(const h of c.filter(b=>!!b.description).sort(l))s.push(`|<i class="${r(h)}"></i>|${h.id}|${P.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const h of c.filter(b=>!P.ThemeIcon.isThemeIcon(b.defaults)).sort(l))s.push(`|<i class="${r(h)}"></i>|${h.id}|`);return s.join(`
`)}}const p=new v;A.$hn.add(e.$6v.IconContribution,p);function f(a,l,r,s){return p.registerIcon(a,l,r,s)}e.$7v=f;function t(){return p}e.$8v=t;function i(){const a=(0,L.$Tj)();for(const l in a){const r="\\"+a[l].toString(16);p.registerIcon(l,{fontCharacter:r})}}i(),e.$9v="vscode://schemas/icons";const n=A.$hn.as(g.$in.JSONContribution);n.registerSchema(e.$9v,p.getIconSchema());const u=new E.$7g(()=>n.notifySchemaChanged(e.$9v),200);p.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$0v=f("widget-close",L.$Vj.close,(0,D.localize)(2,null)),e.$$v=f("goto-previous-location",L.$Vj.arrowUp,(0,D.localize)(3,null)),e.$_v=f("goto-next-location",L.$Vj.arrowDown,(0,D.localize)(4,null)),e.$aw=P.ThemeIcon.modify(L.$Vj.sync,"spin"),e.$bw=P.ThemeIcon.modify(L.$Vj.loading,"spin")}),define(Ae[198],Re([1,0,5,40,4,15]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iv=e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.ProvidedOnAutoForward=e.$av=e.TunnelPrivacyId=e.TunnelProtocol=e.$_u=e.$$u=void 0,e.$$u=(0,P.$Qh)("tunnelService"),e.$_u=(0,P.$Qh)("sharedTunnelsService");var R;(function(t){t.Http="http",t.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function D(t){return!!t.forwardPort}e.$av=D;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$bv=A,e.$cv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(t){return e.$cv.indexOf(t)>=0}e.$dv=S,e.$ev=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(t){return e.$ev.indexOf(t)>=0}e.$fv=o;function v(t,i,n,u){if(n===1)return!1;if(n===2&&o(i)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(a?.length===4&&parseInt(a[1])>=18)return!1}return t<1024}e.$gv=v;class p{constructor(i,n,u){this.remoteAddress=i,this.localAddress=n,this.b=u,this.a=new E.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$hv=p;let f=class{constructor(i,n){this.j=i,this.k=n,this.a=new E.$Nd,this.onTunnelOpened=this.a.event,this.b=new E.$Nd,this.onTunnelClosed=this.b.event,this.c=new E.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],n=Array.from(this.e.values());for(const u of n){const a=Array.from(u.values());for(const l of a){const r=await l.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:n}of i.values())await n.then(u=>typeof u!="string"?u?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,n,u,a,l){this.p(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:u,privacy:a,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(o(i)||S(i))&&(i=e.$cv[0]);const u=this.r(i,n);if(u)return++u.refcount,u.value}openTunnel(i,n,u,a,l,r=!1,s,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${u} on local port ${l}.`);const h=this.f??i;if(!h)return;if(n||(n="localhost"),a||(a=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.s(h,n,u,a,l,r,s,c);return b?b.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,u),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(m);return(m.tunnelRemoteHost!==n||m.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.e.get(i.tunnelRemoteHost);if(n){const u=n.get(i.tunnelRemotePort);u&&(u.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,u))}}}}async o(i,n,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const a=u.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(n),a}}async closeTunnel(i,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const u=this.e.get(i);if(u&&u.has(n)){const a=u.get(n);a.refcount=0,await this.o(i,n,a)}}p(i,n,u){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(n,{refcount:1,value:u})}async q(i,n){const u=this.e.get(i);if(u){const a=u.get(n),l=a?await a.value:void 0;(!l||typeof l=="string")&&u.delete(n),u.size===0&&this.e.delete(i)}}r(i,n){const u=[i];S(i)?(u.push(...e.$cv),u.push(...e.$ev)):o(i)&&u.push(...e.$ev);const a=u.map(l=>this.e.get(l));for(const l of a){const r=l?.get(n);if(r)return r}}canTunnel(i){return!!A(i)}t(i,n,u,a,l,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${u} on local port ${a}.`);const c=u;this.i.add(c);const h=a===void 0?u:a,b={elevationRequired:l?this.isPortPrivileged(h):!1},m={remoteAddress:{host:n,port:u},localAddressPort:a,privacy:r,public:r?r!==$.Private:void 0,protocol:s},I=i.forwardPort(m,b);return I?(this.p(n,u,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),I}};e.$iv=f,e.$iv=f=Ke([Ve(0,M.$$i),Ve(1,L.$ki)],f)}),define(Ae[199],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$jv=void 0,e.$jv=(0,E.$Qh)("editSessionIdentityService");var L;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Ae[200],Re([1,0,14]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=void 0;function L(D){return D.scheme!==E.Schemas.file&&D.scheme!==E.Schemas.vscodeRemote}e.$YJ=L;function P(D){if(D.folders.length)return D.folders.every(g=>L(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&L(D.configuration))return D.configuration}e.$ZJ=P;function M(D){return P(D)?.scheme}e.$1J=M;function R(D){return P(D)?.authority}e.$2J=R;function $(D){return P(D)!==void 0}e.$3J=$}),define(Ae[47],Re([1,0,156,19,51,24,2,4,14]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,$.$Qh)("contextService");function g(h){const b=h;return typeof b?.id=="string"&&R.URI.isUri(b.uri)}e.$1h=g;function A(h){return typeof h?.id=="string"&&!g(h)&&!o(h)}e.$2h=A,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function S(h,b){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,L.$mc)(h)}:b?e.$3h:e.$4h;const m=h;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$5h=S;function o(h){const b=h;return typeof b?.id=="string"&&R.URI.isUri(b.configPath)}e.$6h=o;function v(h){const b=h;if(b?.uri)return{id:b.id,uri:R.URI.revive(b.uri)};const m=h;if(m?.configPath)return{id:m.id,configPath:R.URI.revive(m.configPath)};if(h?.id)return{id:h.id}}e.$7h=v;var p;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function f(h){const b=h;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.$8h=f;function t(h){const b=h;return!!(b&&typeof b=="object"&&R.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.$9h=t;class i{constructor(b,m,I,k,d){this.h=b,this.j=I,this.k=k,this.l=d,this.c=P.$Wh.forUris(this.l,()=>!0),this.folders=m}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=P.$Wh.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=i;class n{constructor(b,m){this.raw=m,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,M.$vg)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=n;function u(h){return new n({uri:h,index:0,name:(0,M.$rg)(h)},{uri:h.toString()})}e.$_h=u,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,E.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function a(h,b){return M.$mg.isEqualOrParent(h,b.untitledWorkspacesHome)}e.$ei=a;function l(h){let b;return R.URI.isUri(h)?b=h:b=h.configuration,b?.scheme===D.Schemas.tmp}e.$fi=l,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(h){return h.id===e.$gi}e.$hi=r;function s(h,b){return!a(h,b)&&!l(h)}e.$ii=s;function c(h){return(typeof h=="string"?(0,L.$nc)(h):(0,M.$tg)(h))===e.$bi}e.$ji=c}),define(Ae[75],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;class E{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Pcc=E}),define(Ae[42],Re([1,0,14,24,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.$Rcc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new L.$kg($=>{const D=this.b.get($.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos($,D){D===null?this.b.delete($.scheme):this.b.set($.scheme,D)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Rcc=M,e.$Scc=(0,P.$Qh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=void 0,e.$KM=(0,E.$Qh)("IExtHostInitDataService")}),define(Ae[201],Re([1,0,162,15,188,27]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let R=class extends P.$RN{constructor(D,g,A){const S=A.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",o=A.remote.isRemote?(0,E.localize)(0,null):D?(0,E.localize)(1,null):(0,E.localize)(2,null);super(g.createLogger(S,{name:o}))}};e.$1ec=R,e.$1ec=R=Ke([Ve(1,L.$_i),Ve(2,M.$KM)],R)}),define(Ae[202],Re([1,0,12]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=e.$idc=void 0;class L{constructor(R,$,D){this.h=new Map,this.a=R,this.b=$,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new E.$7g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const S of g.values())S.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let D=this.f[R];return typeof D>"u"&&(D=$),D}update(R,$){this.f[R]=$;const D=this.h.get(R);if(D!==void 0)return D.p;const g=new E.$dh;return this.h.set(R,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$idc=L;class P extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$jdc=P}),define(Ae[203],Re([1,0,5,2]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class P{constructor(R){this.c=R,this.a=new E.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,D,g){const S=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged($.value,D,g);this.b.fire(S)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire($.apiNotebook)}}e.$Hec=P}),define(Ae[17],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=void 0,e.$uM=(0,E.$Qh)("IExtHostRpcService");class L{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$vM=L}),define(Ae[204],Re([1,0,22,5]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class P{#e;constructor(R,$){this.b=new L.$Nd,this.onDidChange=this.b.event,this.a=E.$7l.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$udc=P}),define(Ae[59],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=e.$3cc=void 0,e.$3cc=(0,E.$Qh)("IURITransformerService");class L{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$4cc=L}),define(Ae[205],Re([1,0,23]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cb=e.$5cb=void 0;class L{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function P($,D){if(D.serializeBuffersForPostMessage){const g=new L,S=JSON.stringify($,(v,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p)};if(ArrayBuffer.isView(p)){const f=M(p);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p.buffer),view:{type:f,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),o=g.buffers.map(v=>{const p=new Uint8Array(v);return E.$be.wrap(p)});return{message:S,buffers:o}}else return{message:JSON.stringify($),buffers:[]}}e.$5cb=P;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,D){const g=D.map(o=>{const v=new ArrayBuffer(o.byteLength);return new Uint8Array(v).set(o.buffer),v}),A=D.length?(o,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const p=v,{index:f}=p,t=g[f];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return v}:void 0;return{message:JSON.parse($,A),arrayBuffers:g}}e.$6cb=R}),define(Ae[102],Re([1,0,172,16,2,6,4,30,41,14,39,134,31]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uE=e.$tE=e.$sE=e.EditorsOrder=e.$rE=e.CloseDirection=e.$qE=e.$pE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.EditorInputCapabilities=e.$gE=e.SaveReason=e.Verbosity=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=void 0,e.$7D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$8D={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$9D="workbench.editor.sidebysideEditor",e.$0D="workbench.editors.textDiffEditor",e.$$D="workbench.editors.binaryResourceDiffEditor";var v;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var p;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function f(ce){const ve=ce;return!!ve&&typeof ve.getSelection=="function"&&!!ve.onDidChangeSelection}e.$_D=f;function t(ce,ve,_){for(const W of _.visibleEditorPanes)if(W.group.id===ve&&ce.matches(W.input))return W.getViewState()}e.$aE=t;function i(ce){if(m(ce))return!1;const ve=ce;return P.URI.isUri(ve?.resource)}e.$bE=i;function n(ce){if(m(ce))return!1;const ve=ce;return ve?.original!==void 0&&ve.modified!==void 0}e.$cE=n;function u(ce){if(m(ce)||n(ce))return!1;const ve=ce;return ve?.primary!==void 0&&ve.secondary!==void 0}e.$dE=u;function a(ce){if(m(ce))return!1;const ve=ce;return ve?ve.resource===void 0||ve.resource.scheme===g.Schemas.untitled||ve.forceUntitled===!0:!1}e.$eE=a;function l(ce){if(m(ce))return!1;const ve=ce;return P.URI.isUri(ve?.base?.resource)&&P.URI.isUri(ve?.input1?.resource)&&P.URI.isUri(ve?.input2?.resource)&&P.URI.isUri(ve?.result?.resource)}e.$fE=l;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class c{constructor(){this.a=new Map}registerSource(ve,_){let W=this.a.get(ve);return W||(W={source:ve,label:_},this.a.set(ve,W)),W.source}getSourceLabel(ve){return this.a.get(ve)?.label??ve}}e.$gE=new c;var h;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(h||(e.EditorInputCapabilities=h={}));class b extends M.$Rc{}e.$hE=b;function m(ce){return ce instanceof b}e.$iE=m;function I(ce){const ve=ce;return P.URI.isUri(ve?.preferredResource)}function k(ce){const ve=ce;return m(ve?.primary)&&m(ve?.secondary)}e.$jE=k;function d(ce){const ve=ce;return m(ve?.modified)&&m(ve?.original)}e.$kE=d;function w(ce,ve,_,W,ae){return oe(W,[(0,S.$Ai)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const we={..._,limits:{size:Number.MAX_VALUE}};ce.openEditor(ve,we)}}),(0,S.$Ai)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:o.default.Warning})}e.$lE=w;function y(ce){return m(ce?.editor)}e.$mE=y;function C(ce){const ve=ce;return y(ce)&&ve?.group!==void 0}e.$nE=C;function B(ce){const ve=ce;return typeof ve?.groupId=="number"&&m(ve.editor)}e.$oE=B;var j;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(j||(e.EditorCloseContext=j={}));var V;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=4]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=5]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=6]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=8]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=10]="EDITOR_PIN",ce[ce.EDITOR_STICKY=11]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=12]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(V||(e.GroupModelChangeKind=V={}));var z;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class F{getOriginalUri(ve,_){if(!ve)return;if(l(ve))return e.$qE.getOriginalUri(ve.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:we}=this.a(ve);if(ae&&we){if(_?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===z.ANY)return this.getOriginalUri(ae,{filterByScheme:_.filterByScheme})??this.getOriginalUri(we,{filterByScheme:_.filterByScheme});ve=_.supportSideBySide===z.PRIMARY?ae:we}}if(n(ve)||u(ve)||l(ve))return;const W=I(ve)?ve.preferredResource:ve.resource;return!W||!_||!_.filterByScheme?W:this.b(W,_.filterByScheme)}a(ve){return k(ve)||u(ve)?{primary:ve.primary,secondary:ve.secondary}:d(ve)||n(ve)?{primary:ve.modified,secondary:ve.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ve,_){if(!ve)return;if(l(ve))return e.$qE.getCanonicalUri(ve.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:we}=this.a(ve);if(ae&&we){if(_?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===z.ANY)return this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:_.filterByScheme});ve=_.supportSideBySide===z.PRIMARY?ae:we}}if(n(ve)||u(ve)||l(ve))return;const W=ve.resource;return!W||!_||!_.filterByScheme?W:this.b(W,_.filterByScheme)}b(ve,_){if(Array.isArray(_)){if(_.some(W=>ve.scheme===W))return ve}else if(_===ve.scheme)return ve}}var O;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function x(ce,ve,_,W){if(!ce.isSticky(ve))return!1;switch(W.preventPinnedEditorClose){case"keyboardAndMouse":return _===O.MOUSE||_===O.KEYBOARD;case"mouse":return _===O.MOUSE;case"keyboard":return _===O.KEYBOARD}return!1}e.$pE=x,e.$qE=new F;var Z;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class De{constructor(){this.c=new Map,this.d=new Map}start(ve){const _=this.a=ve.get(R.$Ph);for(const[W,ae]of this.c)this.e(W,ae,_);this.c.clear()}e(ve,_,W){const ae=W.createInstance(_);this.d.set(ve,ae)}registerFileEditorFactory(ve){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ve}getFileEditorFactory(){return(0,L.$Jf)(this.b)}registerEditorSerializer(ve,_){if(this.c.has(ve)||this.d.has(ve))throw new Error(`A editor serializer with type ID '${ve}' was already registered.`);return this.a?this.e(ve,_,this.a):this.c.set(ve,_),(0,M.$Pc)(()=>{this.c.delete(ve),this.d.delete(ve)})}getEditorSerializer(ve){return this.d.get(typeof ve=="string"?ve:ve.typeId)}}$.$hn.add(e.$7D.EditorFactory,new De);async function ke(ce,ve,_){return!ce||!ce.length?[]:await Promise.all(ce.map(async W=>{const ae=P.URI.revive(W.fileUri);if(!ae){_.info("Cannot resolve the path because it is not valid.",W);return}if(!await ve.canHandleResource(ae)){_.info("Cannot resolve the path because it cannot be handled",W);return}let ne=W.exists,he=W.type;if(typeof ne!="boolean"||typeof he!="number")try{he=(await ve.stat(ae)).isDirectory?D.FileType.Directory:D.FileType.Unknown,ne=!0}catch(ye){_.error(ye),ne=!1}if(!ne&&W.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",W);return}if(he===D.FileType.Directory){_.info("Cannot resolve the path because it is a directory",W);return}const le={...W.options,pinned:!0};return ne?{resource:ae,options:le}:{resource:ae,options:le,forceUntitled:!0}}))}e.$rE=ke;var Ie;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Ie||(e.EditorsOrder=Ie={}));function de(ce){const ve=ce;if(!ve)return!1;const _=ve;if(_.modified)return de(_.modified);const W=ve;return!!(W.contributionsState&&W.viewState&&Array.isArray(W.cursorState))}e.$sE=de;function be(ce){return(0,A.$Ci)(ce)}e.$tE=be;function oe(ce,ve,_){const W=(0,A.$Di)(ce,ve);return W.forceMessage=_?.forceMessage,W.forceSeverity=_?.forceSeverity,W.allowDialog=_?.allowDialog,W}e.$uE=oe}),define(Ae[206],Re([1,0,5,173,4,6,28,30,18,26,90,197]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DE=e.$CE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$BE=e.$AE=e.ViewContentGroups=e.$zE=e.$yE=e.ViewContainerLocation=e.Extensions=e.$xE=e.$wE=e.$vE=void 0,e.$vE="views",e.$wE=(0,L.localize)(0,null),e.$xE=(0,S.$7v)("default-view-icon",A.$Vj.window,(0,L.localize)(1,null));var o;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(o||(e.Extensions=o={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$yE=[0,1,2];function p(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$zE=p;class f extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Qb)([...this.g.values()])}registerViewContainer(c,h,b){const m=this.get(c.id);if(m)return m;const I=c;return I.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,R.$wc)(this.g,h,[]).push(I),b?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:h}),I}deregisterViewContainer(c){for(const h of this.g.keys()){const b=this.g.get(h),m=b?.indexOf(c);if(m!==-1){b?.splice(m,1),b.length===0&&this.g.delete(h),this.f.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(b=>b?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(h=>this.getViewContainerLocation(h)===c)}}$.$hn.add(o.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,c){const h=s.group??t.More,b=c.group??t.More;return h!==b?h.localeCompare(b):(s.order??5)-(c.order??5)}class n extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:b})=>this.r(h,b)),this.c.fire(c)}deregisterViews(c,h){const b=this.s(c,h);b.length&&this.f.fire({views:b,viewContainer:h})}moveViews(c,h){for(const b of this.m.keys())if(b!==h){const m=this.s(c,b);m.length&&(this.r(m,h),this.g.fire({views:m,from:b,to:h}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const h of this.j){const b=(this.m.get(h)||[]).filter(m=>m.id===c)[0];if(b)return b}return null}getViewContainer(c){for(const h of this.j)if((this.m.get(h)||[]).filter(m=>m.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this.n.add(c,h),this.h.fire(c),(0,M.$Pc)(()=>{this.n.delete(c,h),this.h.fire(c)})}registerViewWelcomeContent2(c,h){const b=new Map;for(const[m,I]of h)this.n.add(c,I),b.set(m,(0,M.$Pc)(()=>{this.n.delete(c,I),this.h.fire(c)}));return this.h.fire(c),b}getViewWelcomeContent(c){const h=[];return this.n.forEach(c,b=>h.push(b)),h.sort(i)}r(c,h){let b=this.m.get(h);b||(b=[],this.m.set(h,b),this.j.push(h));for(const m of c){if(this.getView(m.id)!==null)throw new Error((0,L.localize)(2,null,m.id));b.push(m)}}s(c,h){const b=this.m.get(h);if(!b)return[];const m=[],I=[];for(const k of b)c.includes(k)?m.push(k):I.push(k);return m.length&&(I.length?this.m.set(h,I):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),m}}$.$hn.add(o.ViewsRegistry,new n),e.$AE=(0,P.$Qh)("viewsService"),e.$BE=(0,P.$Qh)("viewDescriptorService");var u;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(u||(e.ViewVisibilityState=u={}));var a;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class l{constructor(c,h){this.c=!1,this.d=!1,(0,g.$$m)(this,c),this.d=!!h,this.resolve=async b=>{if(h&&!this.c){const m=await h(b);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$CE=l;class r extends Error{constructor(c){super((0,L.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$DE=r}),define(Ae[207],Re([1,0,2,29,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$5E=e.$4E=void 0;function M(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof E.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(L.$us.isIRange)}e.$4E=M;function R(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(M)}e.$5E=R;var $;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var D;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(D||(e.InteractiveSessionCopyKind=D={})),e.$6E=(0,P.$Qh)("IChatService")}),define(Ae[208],Re([1,0,5,12,174]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Nd,this.n=new E.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,D,g,A){const S={command:$};if(D&&Object.keys(D).length>0&&(S.arguments=D),this.s("request",S),typeof A=="number"){const o=setTimeout(()=>{clearTimeout(o);const v=this.f.get(S.seq);if(v){this.f.delete(S.seq);const p={type:"response",seq:0,request_seq:S.seq,success:!1,command:$,message:(0,P.localize)(0,null,A,$)};v(p)}},A)}return g&&this.f.set(S.seq,g),S.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,D){return $.type!=="event"||D.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,L.$Ug)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const D=$,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s($,D){D.type=$,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((D,g)=>$.set(g,D)),await(0,L.$Ug)(500),$.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$ydb=M}),define(Ae[209],Re([1,0,175,34,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$gH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$fH=e.MemoryRangeType=e.$eH=e.State=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=void 0,e.$bG="workbench.view.debug",e.$cG="workbench.debug.variablesView",e.$dG="workbench.debug.watchExpressionsView",e.$eG="workbench.debug.callStackView",e.$fG="workbench.debug.loadedScriptsView",e.$gG="workbench.debug.breakPointsView",e.$hG="workbench.debug.disassemblyView",e.$iG="workbench.panel.repl",e.$jG="workbench.panel.repl.view",e.$kG=new L.$8i("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$lG=new L.$8i("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$mG=new L.$8i("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$nG="debugUx",e.$oG=new L.$8i(e.$nG,"default",{type:"string",description:E.localize(3,null)}),e.$pG=new L.$8i("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$qG=new L.$8i("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$rG=new L.$8i("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$sG=new L.$8i("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$tG=new L.$8i("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$uG=new L.$8i("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$vG=new L.$8i("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$wG=new L.$8i("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$xG=new L.$8i("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$yG=new L.$8i("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$zG=new L.$8i("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$AG=new L.$8i("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$BG=new L.$8i("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$CG=new L.$8i("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$DG=new L.$8i("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$EG=new L.$8i("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$FG=new L.$8i("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$GG=new L.$8i("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$HG=new L.$8i("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$IG=new L.$8i("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$JG=new L.$8i("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$KG=new L.$8i("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$LG=new L.$8i("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$MG=new L.$8i("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$NG=new L.$8i("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$OG=new L.$8i("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$PG=new L.$8i("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$QG=new L.$8i("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$RG=new L.$8i("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$SG=new L.$8i("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$TG=new L.$8i("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$UG=new L.$8i("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$VG=new L.$8i("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$WG=new L.$8i("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$XG=new L.$8i("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$YG=new L.$8i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$ZG=new L.$8i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$1G=new L.$8i("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$2G=new L.$8i("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$3G=new L.$8i("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$4G=new L.$8i("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$5G=new L.$8i("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$6G=new L.$8i("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$7G=new L.$8i("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$8G=new L.$8i("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$9G=new L.$8i("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$0G=new L.$8i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$$G=new L.$8i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=o=>E.localize(52,null,o);e.$_G=M,e.$aH="editor.contrib.debug",e.$bH="editor.contrib.breakpoint",e.$cH="debug",e.$dH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(o){o[o.Inactive=0]="Inactive",o[o.Initializing=1]="Initializing",o[o.Stopped=2]="Stopped",o[o.Running=3]="Running"})(R||(e.State=R={}));function $(o){switch(o){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$eH=$;var D;(function(o){o[o.Valid=0]="Valid",o[o.Unreadable=1]="Unreadable",o[o.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$fH="vscode-debug-memory";var g;(function(o){o[o.Initial=1]="Initial",o[o.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function(o){o.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$gH=(0,P.$Qh)("debugService");var S;(function(o){o[o.CONDITION=0]="CONDITION",o[o.HIT_COUNT=1]="HIT_COUNT",o[o.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Ae[210],Re([1,0,13,2,19,26,14,29,20,18]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=void 0;const A=/{([^}]+)}/g;function S(k,d,w){return k.replace(A,function(y,C){return d&&C.length>0&&C[0]!=="_"?y:w&&w.hasOwnProperty(C)?w[C]:y})}e.$CF=S;function o(k){const d={};for(const w of Object.keys(k))w.startsWith("!")||(d[w]=k[w]);return d}e.$DF=o;function v(k){return k.configuration.request==="attach"&&!p(k)&&(!k.parentSession||v(k.parentSession))}e.$EF=v;function p(k){let d=k.configuration.type;if(d)return d==="vslsShare"&&(d=k.configuration.adapterProxy.configuration.type),(0,E.$2e)(d,"extensionhost")||(0,E.$2e)(d,"pwa-extensionhost")?k:k.parentSession?p(k.parentSession):void 0}e.$FF=p;function f(k){return k.type&&(k.label||k.program||k.runtime)}e.$GF=f;function t(k,d,w){let y,C=0;const B=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=B.exec(k);){const V=j.index+1,z=V+j[0].length;if(V<=d&&z>=w){y=j[0],C=V;break}}if(y){const V=/\w+/g;let z=null;for(;(z=V.exec(y))&&!(z.index+1+C+z[0].length>=w););z&&(y=y.substring(0,V.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}e.$HF=t;async function i(k,d,w,y){if(k.evaluatableExpressionProvider.has(d)){const C=k.evaluatableExpressionProvider.ordered(d),B=(0,g.$Gb)(await Promise.all(C.map(async j=>{try{return await j.provideEvaluatableExpression(d,w,y??D.CancellationToken.None)}catch{return}})));if(B.length>0){let j=B[0].expression;const V=B[0].range;return j||(j=d.getLineContent(w.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:j}}}else{const C=d.getLineContent(w.lineNumber),{start:B,end:j}=t(C,w.column,w.column),V=C.substring(B-1,j);return{matchingExpression:V,range:new $.$us(w.lineNumber,B,w.lineNumber,B+V.length)}}return null}e.$IF=i;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(k){return!!(k&&k.match(n))}e.$JF=u;function a(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(u(k.path))return L.URI.parse(k.path);if((0,P.$hc)(k.path))return L.URI.file(k.path)}return k.path}function l(k){if(typeof k.path=="object"){const d=L.URI.revive(k.path);if(d)return d.scheme===R.Schemas.file?d.fsPath:d.toString()}return k.path}function r(k,d){const w=d?a:l,y=(0,M.$8m)(k);return c(y,(C,B)=>{C&&B&&(B.path=w(B))}),y}e.$KF=r;function s(k,d){const w=d?a:l,y=(0,M.$8m)(k);return c(y,(C,B)=>{!C&&B&&(B.path=w(B))}),y}e.$LF=s;function c(k,d){switch(k.type){case"event":{const w=k;switch(w.event){case"output":d(!1,w.body.source);break;case"loadedSource":d(!1,w.body.source);break;case"breakpoint":d(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=k;switch(w.command){case"setBreakpoints":d(!0,w.arguments.source);break;case"breakpointLocations":d(!0,w.arguments.source);break;case"source":d(!0,w.arguments.source);break;case"gotoTargets":d(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(y=>d(!1,y));break;default:break}break}case"response":{const w=k;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(y=>d(!1,y.source));break;case"loadedSources":w.body.sources.forEach(y=>d(!1,y));break;case"scopes":w.body.scopes.forEach(y=>d(!1,y.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(y=>d(!1,y.source));break;case"setBreakpoints":w.body.breakpoints.forEach(y=>d(!1,y.source));break;case"disassemble":w.body?.instructions.forEach(C=>d(!1,C.location));break;default:break}break}}}function h(k){return k.filter(d=>!d.presentation?.hidden).sort((d,w)=>d.presentation?w.presentation?d.presentation.group?w.presentation.group?d.presentation.group!==w.presentation.group?d.presentation.group.localeCompare(w.presentation.group):b(d.presentation.order,w.presentation.order):-1:w.presentation.group?1:b(d.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$MF=h;function b(k,d){return typeof k!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:k-d}async function m(k,d){const w=k.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(w!=="none"&&(await d.saveAll(),w==="allEditorsInActiveGroup")){const y=d.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await d.save({editor:y.input,groupId:y.group.id})}await k.reloadConfiguration()}e.$NF=m;const I=(k,d)=>!k||!d?k===d:k.name===d.name&&k.path===d.path&&k.sourceReference===d.sourceReference;e.$OF=I}),define(Ae[76],Re([1,0,23,33,68,69,14,19,21,34]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zI=e.$yI=e.$xI=e.$wI=e.CellStatusbarAlignment=e.$vI=e.$uI=e.$tI=e.NotebookEditorPriority=e.$sI=e.$rI=e.$qI=e.$pI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$oI=e.$nI=e.$mI=e.$lI=e.CellKind=e.$kI=e.$jI=e.$iI=void 0,e.$iI="workbench.editor.notebook",e.$jI="workbench.editor.notebookTextDiffEditor",e.$kI="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$lI=["application/json","application/javascript","text/html","image/svg+xml",M.$Qr.latex,M.$Qr.markdown,"image/png","image/jpeg",M.$Qr.text],e.$mI=[M.$Qr.latex,M.$Qr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Qr.text],e.$nI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$oI="_notAvailable";var S;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var o;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(o||(e.NotebookCellExecutionState=o={}));var v;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var p;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var f;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var u;(function(O){O.scheme=R.Schemas.vscodeNotebookCell;const x=["W","X","Y","Z","a","b","c","d","e","f"],Z=new RegExp(`^[${x.join("")}]+`),De=7;function ke(ve,_){const W=_.toString(De),we=`${W.length<x.length?x[W.length-1]:"z"}${W}s${(0,E.$ve)(E.$be.fromString(ve.scheme),!0,!0)}`;return ve.with({scheme:O.scheme,fragment:we})}O.generate=ke;function Ie(ve){if(ve.scheme!==O.scheme)return;const _=ve.fragment.indexOf("s");if(_<0)return;const W=parseInt(ve.fragment.substring(0,_).replace(Z,""),De),ae=(0,E.$ue)(ve.fragment.substring(_+1)).toString();if(!isNaN(W))return{handle:W,notebook:ve.with({scheme:ae,fragment:null})}}O.parse=Ie;function de(ve,_){return ve.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${ve.scheme!==R.Schemas.file?ve.scheme:""}`})}O.generateCellOutputUri=de;function be(ve){if(ve.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ve.fragment);if(!_)return;const W=_[1]&&_[1]!==""?_[1]:void 0,ae=_[2];return{outputId:W,notebook:ve.with({scheme:ae||R.Schemas.file,fragment:null})}}O.parseCellOutputUri=be;function oe(ve,_,W){return O.generate(ve,_).with({scheme:W})}O.generateCellPropertyUri=oe;function ce(ve,_){if(ve.scheme===_)return O.parse(ve.with({scheme:O.scheme}))}O.parseCellPropertyUri=ce})(u||(e.CellUri=u={}));const a=O=>D.$j?O.replace(/\//g,"\\"):O;class l{constructor(x=[],Z=e.$lI){this.e=Z,this.d=[...new Set(x)].map(De=>({pattern:De,matches:L.$xj(a(De))}))}sort(x){const Z=new Map(P.Iterable.map(x,ke=>[ke,a(ke)]));let De=[];for(const{matches:ke}of this.d)for(const[Ie,de]of Z)if(ke(de)){De.push(Ie),Z.delete(Ie);break}return Z.size&&(De=De.concat([...Z.keys()].sort((ke,Ie)=>this.e.indexOf(ke)-this.e.indexOf(Ie)))),De}prioritize(x,Z){const De=this.f(x);if(De===-1){this.d.unshift({pattern:x,matches:L.$xj(a(x))});return}const ke=new Set(Z.map(de=>this.f(de,De)));ke.delete(-1);const Ie=Array.from(ke).sort();this.d.splice(De+1,0,...Ie.map(de=>this.d[de]));for(let de=Ie.length-1;de>=0;de--)this.d.splice(Ie[de],1)}toArray(){return this.d.map(x=>x.pattern)}f(x,Z=this.d.length){const De=a(x);for(let ke=0;ke<Z;ke++)if(this.d[ke].matches(De))return ke;return-1}}e.$pI=l;function r(O,x,Z,De=(ke,Ie)=>ke===Ie){const ke=[];function Ie(oe,ce,ve){if(ce===0&&ve.length===0)return;const _=ke[ke.length-1];_&&_.start+_.deleteCount===oe?(_.deleteCount+=ce,_.toInsert.push(...ve)):ke.push({start:oe,deleteCount:ce,toInsert:ve})}let de=0,be=0;for(;;){if(de===O.length){Ie(de,0,x.slice(be));break}if(be===x.length){Ie(de,O.length-de,[]);break}const oe=O[de],ce=x[be];if(De(oe,ce)){de+=1,be+=1;continue}Z(ce)?(Ie(de,1,[]),de+=1):(Ie(de,0,[ce]),be+=1)}return ke}e.$qI=r,e.$rI=new g.$8i("notebookEditorCursorAtBoundary","none"),e.$sI=new g.$8i("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function c(O){const x=O;return!!((typeof x.include=="string"||L.$yj(x.include))&&(typeof x.exclude=="string"||L.$yj(x.exclude)))}e.$tI=c;function h(O,x,Z){if(Array.isArray(O.viewType)&&O.viewType.indexOf(x)>=0||O.viewType===x)return!0;if(O.filenamePattern){const De=c(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,ke=c(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(L.$wj(De,(0,$.$mc)(Z.fsPath).toLowerCase()))return!(ke&&L.$wj(ke,(0,$.$mc)(Z.fsPath).toLowerCase()))}return!1}e.$uI=h,e.$vI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var b;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class m{static{this.d="notebook/"}static create(x){return`${m.d}${x}`}static parse(x){if(x.startsWith(m.d))return x.substring(m.d.length)}}e.$wI=m;function I(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$xI=I;const k=new TextDecoder;function d(O){const x=[];let Z=!1;for(const de of O)(x.length===0||Z)&&(x.push(de),Z=!0);let De=C(x);const ke=E.$be.concat(x.map(de=>E.$be.wrap(de))),Ie=F(ke);return De=De||Ie.byteLength!==ke.byteLength,{data:Ie,didCompression:De}}e.$yI=d,e.$zI=`${String.fromCharCode(27)}[A`;const w=e.$zI.split("").map(O=>O.charCodeAt(0)),y=10;function C(O){let x=!1;return O.forEach((Z,De)=>{if(De===0||Z.length<e.$zI.length)return;const ke=O[De-1],Ie=Z.subarray(0,e.$zI.length);if(Ie[0]===w[0]&&Ie[1]===w[1]&&Ie[2]===w[2]){const de=ke.lastIndexOf(y);if(de===-1)return;x=!0,O[De-1]=ke.subarray(0,de),O[De]=Z.subarray(e.$zI.length)}}),x}function B(O){let x=O;do O=x,x=O.replace(/[^\n]\x08/gm,"");while(x.length<O.length);return O}function j(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const x=O.match(/^(.*)\r+/m)[1];let Z=O.match(/\r+(.*)$/m)[1];Z=Z+x.slice(Z.length,x.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return O}const V="\b".charCodeAt(0),z="\r".charCodeAt(0);function F(O){return!O.buffer.includes(V)&&!O.buffer.includes(z)?O:E.$be.fromString(j(B(k.decode(O.buffer))))}}),define(Ae[7],Re([1,0,18,11,53,28,69,13,16,2,38,22,41,100,76]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p){"use strict";var f,t,i,n,u,a,l,r,s,c,h,b,m,I,k,d,w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$jM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.TestRunProfileKind=e.TestResultState=e.$2L=e.$1L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$ZL=e.$YL=e.$XL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$WL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.ColorThemeKind=e.$QL=e.$PL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$OL=e.DebugConsoleMode=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$IL=e.$HL=e.FileChangeType=e.$GL=e.$FL=e.$EL=e.$DL=e.InlineCompletionTriggerKind=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.ConfigurationTarget=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$gL=e.ViewBadge=e.ProgressLocation=e.$fL=e.$eL=e.TaskScope=e.ShellQuoting=e.$dL=e.$cL=e.$bL=e.TaskPanelKind=e.TaskRevealKind=e.$aL=e.TerminalLocation=e.$_K=e.$$K=e.$0K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$9K=e.$8K=e.$7K=e.$6K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$5K=e.StatusBarAlignment=e.ViewColumn=e.$4K=e.$3K=e.$2K=e.$1K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$ZK=e.$YK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.LanguageStatusSeverity=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.CodeActionTriggerKind=e.$MK=e.$LK=e.SymbolTag=e.SymbolKind=e.$KK=e.DocumentHighlightKind=e.$JK=e.$IK=e.$HK=e.$GK=e.DiagnosticSeverity=e.DiagnosticTag=e.$FK=e.$EK=e.FileEditType=e.$DK=e.$CK=e.$BK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(U){return Object.assign(U,{apply:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(U,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(U,[]);{const[Se,...He]=re;return Reflect.construct(U,He,Se.constructor)}}})}var B;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(B||(e.TerminalOutputAnchor=B={}));var j;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(j||(e.TerminalQuickFixType=j={}));let V=f=class{static from(...N){let re=N;return new f(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$uK=V,e.$uK=V=f=Ke([C],V);let z=t=class{static Min(...N){if(N.length===0)throw new TypeError;let re=N[0];for(let Se=1;Se<N.length;Se++){const He=N[Se];He.isBefore(re)&&(re=He)}return re}static Max(...N){if(N.length===0)throw new TypeError;let re=N[0];for(let Se=1;Se<N.length;Se++){const He=N[Se];He.isAfter(re)&&(re=He)}return re}static isPosition(N){if(!N)return!1;if(N instanceof t)return!0;const{line:re,character:Se}=N;return typeof re=="number"&&typeof Se=="number"}static of(N){if(N instanceof t)return N;if(this.isPosition(N))return new t(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,re){if(N<0)throw(0,L.$6)("line must be non-negative");if(re<0)throw(0,L.$6)("character must be non-negative");this.c=N,this.e=re}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,re=0){if(N===null||re===null)throw(0,L.$6)();let Se;return typeof N>"u"?Se=0:typeof N=="number"?Se=N:(Se=typeof N.lineDelta=="number"?N.lineDelta:0,re=typeof N.characterDelta=="number"?N.characterDelta:0),Se===0&&re===0?this:new t(this.line+Se,this.character+re)}with(N,re=this.character){if(N===null||re===null)throw(0,L.$6)();let Se;return typeof N>"u"?Se=this.line:typeof N=="number"?Se=N:(Se=typeof N.line=="number"?N.line:this.line,re=typeof N.character=="number"?N.character:this.character),Se===this.line&&re===this.character?this:new t(Se,re)}toJSON(){return{line:this.line,character:this.character}}};e.$vK=z,e.$vK=z=t=Ke([C],z);let F=i=class{static isRange(N){return N instanceof i?!0:N?z.isPosition(N.start)&&z.isPosition(N.end):!1}static of(N){if(N instanceof i)return N;if(this.isRange(N))return new i(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,re,Se,He){let Xe,st;if(typeof N=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof He=="number"?(Xe=new z(N,re),st=new z(Se,He)):z.isPosition(N)&&z.isPosition(re)&&(Xe=z.of(N),st=z.of(re)),!Xe||!st)throw new Error("Invalid arguments");Xe.isBefore(st)?(this.c=Xe,this.e=st):(this.c=st,this.e=Xe)}contains(N){return i.isRange(N)?this.contains(N.start)&&this.contains(N.end):z.isPosition(N)?!(z.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const re=z.Max(N.start,this.c),Se=z.Min(N.end,this.e);if(!re.isAfter(Se))return new i(re,Se)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const re=z.Min(N.start,this.c),Se=z.Max(N.end,this.end);return new i(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,re=this.end){if(N===null||re===null)throw(0,L.$6)();let Se;return N?z.isPosition(N)?Se=N:(Se=N.start||this.start,re=N.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new i(Se,re)}toJSON(){return[this.start,this.end]}};e.$wK=F,e.$wK=F=i=Ke([C],F);let O=n=class extends F{static isSelection(N){return N instanceof n?!0:N?F.isRange(N)&&z.isPosition(N.anchor)&&z.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,re,Se,He){let Xe,st;if(typeof N=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof He=="number"?(Xe=new z(N,re),st=new z(Se,He)):z.isPosition(N)&&z.isPosition(re)&&(Xe=z.of(N),st=z.of(re)),!Xe||!st)throw new Error("Invalid arguments");super(Xe,st),this.f=Xe,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$xK=O,e.$xK=O=n=Ke([C],O);const x=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,L.$6)("connectionToken")};class Z{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,re,Se){if(typeof N!="string"||N.length===0)throw(0,L.$6)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,L.$6)("port");typeof Se<"u"&&x(Se),this.host=N,this.port=Math.round(re),this.connectionToken=Se}}e.$yK=Z;class De{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,re){this.makeConnection=N,this.connectionToken=re,typeof re<"u"&&x(re)}}e.$zK=De;class ke extends Error{static NotAvailable(N,re){return new ke(N,v.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(N){return new ke(N,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,re=v.RemoteAuthorityResolverErrorCode.Unknown,Se){super(N),this._message=N,this._code=re,this._detail=Se,Object.setPrototypeOf(this,ke.prototype)}}e.$AK=ke;var Ie;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Ie||(e.EndOfLine=Ie={}));var de;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(de||(e.EnvironmentVariableMutatorType=de={}));let be=u=class{static isTextEdit(N){return N instanceof u?!0:N?F.isRange(N)&&typeof N.newText=="string":!1}static replace(N,re){return new u(N,re)}static insert(N,re){return u.replace(new F(N,N),re)}static delete(N){return u.replace(N,"")}static setEndOfLine(N){const re=new u(new F(new z(0,0),new z(0,0)),"");return re.newEol=N,re}get range(){return this.c}set range(N){if(N&&!F.isRange(N))throw(0,L.$6)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,L.$6)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,L.$6)("newEol");this.f=N}constructor(N,re){this.c=N,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$BK=be,e.$BK=be=u=Ke([C],be);let oe=a=class{static isNotebookCellEdit(N){return N instanceof a?!0:N?xt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,re){return new a(N,re)}static insertCells(N,re){return new a(new xt(N,N),re)}static deleteCells(N){return new a(N,[])}static updateCellMetadata(N,re){const Se=new a(new xt(N,N),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(N){const re=new a(new xt(0,0),[]);return re.newNotebookMetadata=N,re}constructor(N,re){this.range=N,this.newCells=re}};e.$CK=oe,e.$CK=oe=a=Ke([C],oe);class ce{static isSnippetTextEdit(N){return N instanceof ce?!0:N?F.isRange(N.range)&&W.isSnippetString(N.snippet):!1}static replace(N,re){return new ce(N,re)}static insert(N,re){return ce.replace(new F(N,N),re)}constructor(N,re){this.range=N,this.snippet=re}}e.$DK=ce;var ve;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let _=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,re,Se,He){this.c.push({_type:1,from:N,to:re,options:Se,metadata:He})}createFile(N,re,Se){this.c.push({_type:1,from:void 0,to:N,options:re,metadata:Se})}deleteFile(N,re,Se){this.c.push({_type:1,from:N,to:void 0,options:re,metadata:Se})}e(N,re,Se){this.c.push({_type:3,metadata:Se,uri:N,edit:{editType:5,metadata:re},notebookMetadata:re})}f(N,re,Se,He){const Xe=re.start,st=re.end;(Xe!==st||Se.length>0)&&this.c.push({_type:5,uri:N,index:Xe,count:st-Xe,cells:Se,metadata:He})}g(N,re,Se,He){this.c.push({_type:3,metadata:He,uri:N,edit:{editType:3,index:re,metadata:Se}})}replace(N,re,Se,He){this.c.push({_type:2,uri:N,edit:new be(re,Se),metadata:He})}insert(N,re,Se,He){this.replace(N,new F(re,re),Se,He)}delete(N,re,Se){this.replace(N,re,"",Se)}has(N){return this.c.some(re=>re._type===2&&re.uri.toString()===N.toString())}set(N,re){if(re)for(const Se of re){if(!Se)continue;let He,Xe;Array.isArray(Se)?(He=Se[0],Xe=Se[1]):He=Se,oe.isNotebookCellEdit(He)?He.newCellMetadata?this.g(N,He.range.start,He.newCellMetadata,Xe):He.newNotebookMetadata?this.e(N,He.newNotebookMetadata,Xe):this.f(N,He.range,He.newCells,Xe):ce.isSnippetTextEdit(He)?this.c.push({_type:6,uri:N,range:He.range,edit:He.snippet,metadata:Xe}):this.c.push({_type:2,uri:N,edit:He,metadata:Xe})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===N.toString()&&(this.c[Se]=void 0);break}}(0,E.$Hb)(this.c)}}get(N){const re=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===N.toString()&&re.push(Se.edit);return re}entries(){const N=new M.$zc;for(const re of this.c)if(re._type===2){let Se=N.get(re.uri);Se||(Se=[re.uri,[]],N.set(re.uri,Se)),Se[1].push(re.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$EK=_,e.$EK=_=Ke([C],_);let W=l=class{static isSnippetString(N){return N instanceof l?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=l.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,re=this.e++){if(typeof N=="function"){const Se=new l;Se.e=this.e,N(Se),this.e=Se.e,N=Se.value}else N=l.c(N);return this.value+="${",this.value+=re,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,re=this.e++){const Se=N.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(N,re){if(typeof re=="function"){const Se=new l;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$FK=W,e.$FK=W=l=Ke([C],W);var ae;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ae||(e.DiagnosticTag=ae={}));var we;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(we||(e.DiagnosticSeverity=we={}));let ne=r=class{static isLocation(N){return N instanceof r?!0:N?F.isRange(N.range)&&g.URI.isUri(N.uri):!1}constructor(N,re){if(this.uri=N,re)if(F.isRange(re))this.range=F.of(re);else if(z.isPosition(re))this.range=new F(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$GK=ne,e.$GK=ne=r=Ke([C],ne);let he=class{static is(N){return N?typeof N.message=="string"&&N.location&&F.isRange(N.location.range)&&g.URI.isUri(N.location.uri):!1}constructor(N,re){this.location=N,this.message=re}static isEqual(N,re){return N===re?!0:!N||!re?!1:N.message===re.message&&N.location.range.isEqual(re.location.range)&&N.location.uri.toString()===re.location.uri.toString()}};e.$HK=he,e.$HK=he=Ke([C],he);let le=class{constructor(N,re,Se=we.Error){if(!F.isRange(N))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=N,this.message=re,this.severity=Se}toJSON(){return{severity:we[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,re){return N===re?!0:!N||!re?!1:N.message===re.message&&N.severity===re.severity&&N.code===re.code&&N.severity===re.severity&&N.source===re.source&&N.range.isEqual(re.range)&&(0,E.$tb)(N.tags,re.tags)&&(0,E.$tb)(N.relatedInformation,re.relatedInformation,he.isEqual)}};e.$IK=le,e.$IK=le=Ke([C],le);let ye=class{constructor(N,re){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=re}};e.$JK=ye,e.$JK=ye=Ke([C],ye);var ee;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(ee||(e.DocumentHighlightKind=ee={}));let fe=class{constructor(N,re=ee.Text){this.range=N,this.kind=re}toJSON(){return{range:this.range,kind:ee[this.kind]}}};e.$KK=fe,e.$KK=fe=Ke([C],fe);var ie;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var se;(function(U){U[U.Deprecated=1]="Deprecated"})(se||(e.SymbolTag=se={}));let me=s=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,re,Se,He,Xe){this.name=N,this.kind=re,this.containerName=Xe,typeof Se=="string"&&(this.containerName=Se),He instanceof ne?this.location=He:Se instanceof F&&(this.location=new ne(He,Se)),s.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$LK=me,e.$LK=me=s=Ke([C],me);let Pe=c=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(c.validate)}constructor(N,re,Se,He,Xe){this.name=N,this.detail=re,this.kind=Se,this.range=He,this.selectionRange=Xe,this.children=[],c.validate(this)}};e.$MK=Pe,e.$MK=Pe=c=Ke([C],Pe);var T;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let q=class{constructor(N,re){this.title=N,this.kind=re}};e.$NK=q,e.$NK=q=Ke([C],q);let G=class{static{h=this}static{this.c="."}constructor(N){this.value=N}append(N){return new h(this.value?this.value+h.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+h.c)}};e.$OK=G,e.$OK=G=h=Ke([C],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let Q=class{constructor(N,re){if(this.range=N,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$PK=Q,e.$PK=Q=Ke([C],Q);class K{constructor(N,re,Se,He,Xe,st){this.kind=N,this.name=re,this.detail=Se,this.uri=He,this.range=Xe,this.selectionRange=st}}e.$QK=K;class Y{constructor(N,re){this.fromRanges=re,this.from=N}}e.$RK=Y;class ue{constructor(N,re){this.fromRanges=re,this.to=N}}e.$SK=ue;var Ne;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Be=class{constructor(N,re){this.range=N,this.command=re}get isResolved(){return!!this.command}};e.$TK=Be,e.$TK=Be=Ke([C],Be);let Je=b=class{#e;static isMarkdownString(N){return N instanceof b?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,re=!1){this.#e=new P.$4j(N,{supportThemeIcons:re})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,re){return this.#e.appendCodeblock(re??"",N),this}};e.$UK=Je,e.$UK=Je=b=Ke([C],Je);let Ge=class{constructor(N,re){this.label=N,this.documentation=re}};e.$VK=Ge,e.$VK=Ge=Ke([C],Ge);let _e=class{constructor(N,re){this.label=N,this.documentation=re,this.parameters=[]}};e.$WK=_e,e.$WK=_e=Ke([C],_e);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$XK=Ye,e.$XK=Ye=Ke([C],Ye);var xe;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(N){this.value=N}};e.$YK=tt,e.$YK=tt=Ke([C],tt);let Ue=class{constructor(N,re,Se){this.position=N,this.label=re,this.kind=Se}};e.$ZK=Ue,e.$ZK=Ue=Ke([C],Ue);var ut;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut||(e.CompletionTriggerKind=ut={}));var X;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(X||(e.CompletionItemKind=X={}));var J;(function(U){U[U.Deprecated=1]="Deprecated"})(J||(e.CompletionItemTag=J={}));let Ee=class{constructor(N,re){this.label=N,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&X[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$1K=Ee,e.$1K=Ee=Ke([C],Ee);let je=class{constructor(N=[],re=!1){this.items=N,this.isIncomplete=re}};e.$2K=je,e.$2K=je=Ke([C],je);let Oe=class{constructor(N,re,Se){this.insertText=N,this.range=re,this.command=Se}};e.$3K=Oe,e.$3K=Oe=Ke([C],Oe);let Ze=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$4K=Ze,e.$4K=Ze=Ke([C],Ze);var nt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var $t;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function bt(U,N){return`${S.$7l.toKey(U)}.${N}`}e.$5K=bt;var Pt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Kt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var vt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var zt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(zt||(e.TextDocumentChangeReason=zt={}));var Nt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(U){function N(re){switch(re){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=N}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Gt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(U){function N(re){switch(re){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=N}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(N,re){if(re&&!g.URI.isUri(re))throw(0,L.$6)("target");if(!F.isRange(N)||N.isEmpty)throw(0,L.$6)("range");this.range=N,this.target=re}};e.$6K=Bt,e.$6K=Bt=Ke([C],Bt);let kt=class{constructor(N,re,Se,He){this.red=N,this.green=re,this.blue=Se,this.alpha=He}};e.$7K=kt,e.$7K=kt=Ke([C],kt);let Ft=class{constructor(N,re){if(re&&!(re instanceof kt))throw(0,L.$6)("color");if(!F.isRange(N)||N.isEmpty)throw(0,L.$6)("range");this.range=N,this.color=re}};e.$8K=Ft,e.$8K=Ft=Ke([C],Ft);let jt=class{constructor(N){if(!N||typeof N!="string")throw(0,L.$6)("label");this.label=N}};e.$9K=jt,e.$9K=jt=Ke([C],jt);var Qt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Qt||(e.ColorFormat=Qt={}));var Wt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Vt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Ot{constructor(N,re,Se){if(this.startIndex=N,this.length=re,this.tooltip=Se,typeof N!="number"||N<0)throw(0,L.$6)("startIndex");if(typeof re!="number"||re<1)throw(0,L.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,L.$6)("tooltip")}}e.$0K=Ot;class at{constructor(N){this.uri=N}}e.$$K=at;class dt{constructor(N){this.terminalCommand=N}}e.$_K=dt;var At;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class qt{constructor(N){if(this.options=N,typeof N!="object")throw(0,L.$6)("options")}}e.$aL=qt;var Rt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ot;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(ot||(e.TaskPanelKind=ot={}));let wt=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(N){switch(N){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(N,re){if(this.label=re,typeof N!="string"||typeof re!="string")throw(0,L.$6)("name");this.c=N}get id(){return this.c}};e.$bL=wt,e.$bL=wt=m=Ke([C],wt);function Tt(U){let N="";for(let re=0;re<U.length;re++)N+=U[re].replace(/,/g,",,")+",";return N}let Ct=class{constructor(N,re,Se){if(typeof N!="string")throw(0,L.$6)("process");this.e=[],this.c=N,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,L.$6)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const re of this.e)N.push(re);return Tt(N)}};e.$cL=Ct,e.$cL=Ct=Ke([C],Ct);let We=class{constructor(N,re,Se){if(this.f=[],Array.isArray(re)){if(!N)throw(0,L.$6)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,L.$6)("command");this.e=N,this.f=re,this.g=Se}else{if(typeof N!="string")throw(0,L.$6)("commandLine");this.c=N,this.g=re}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,L.$6)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,L.$6)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)N.push(typeof re=="string"?re:re.value);return Tt(N)}};e.$dL=We,e.$dL=We=Ke([C],We);var Jt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Ce;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Ce||(e.TaskScope=Ce={}));class Le{constructor(N){this.c=N}computeId(){return"customExecution"+(0,A.$eg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$eL=Le;let $e=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,re,Se,He,Xe,st){this.j=!1,this.k=this.definition=N;let lt;typeof re=="string"?(this.m=this.name=re,this.t=this.source=Se,this.execution=He,lt=Xe,this.j=!0):re===Ce.Global||re===Ce.Workspace?(this.target=re,this.m=this.name=Se,this.t=this.source=He,this.execution=Xe,lt=st):(this.target=re,this.m=this.name=Se,this.t=this.source=He,this.execution=Xe,lt=st),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof Le?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,A.$eg)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,L.$6)("Kind can't be undefined or null");this.z(),this.k=N}get scope(){return this.l}set target(N){this.z(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,L.$6)("name");this.z(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.z(),this.n=N;const re=this.k.type;(I.g===re||I.e===re||I.f===re||I.c===re)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.z(),this.o=N,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.z(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,L.$6)("source must be a string of length > 0");this.z(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.z(),this.u=N}get detail(){return this.y}set detail(N){N===null&&(N=void 0),this.y=N}get presentationOptions(){return this.w}set presentationOptions(N){N==null&&(N=Object.create(null)),this.z(),this.w=N}get runOptions(){return this.x}set runOptions(N){N==null&&(N=Object.create(null)),this.z(),this.x=N}};e.$fL=$e,e.$fL=$e=I=Ke([C],$e);var H;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(H||(e.ProgressLocation=H={}));var Me;(function(U){function N(re){const Se=re;return(0,D.$Cf)(Se.value)?Se.tooltip&&!(0,D.$yf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}U.isViewBadge=N})(Me||(e.ViewBadge=Me={}));let ze=k=class{static isTreeItem(N,re){const Se=N;if(Se.checkboxState!==void 0){const He=(0,D.$Cf)(Se.checkboxState)?Se.checkboxState:(0,D.$Af)(Se.checkboxState)&&(0,D.$Cf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Xe=!(0,D.$Cf)(Se.checkboxState)&&(0,D.$Af)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==qe.Checked&&He!==qe.Unchecked||Xe!==void 0&&!(0,D.$yf)(Xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(N instanceof k)return!0;if(Se.label!==void 0&&!(0,D.$yf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,D.$yf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,D.$yf)(Se.iconPath)&&!g.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,D.$yf)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,D.$yf)(He.light)&&!g.URI.isUri(He.light)&&!(0,D.$yf)(He.dark)&&!g.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,D.$yf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!g.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,D.$yf)(Se.tooltip)&&!(Se.tooltip instanceof Je)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Qe.None&&Se.collapsibleState>Qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,D.$yf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(N,re=Qe.None){this.collapsibleState=re,g.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$gL=ze,e.$gL=ze=k=Ke([C],ze);var Qe;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Qe||(e.TreeItemCollapsibleState=Qe={}));var qe;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$hL=et,e.$hL=et=Ke([C],et);class Et extends et{}e.$iL=Et;class Dt extends Et{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$jL=Dt;class gt{constructor(N,re,Se,He){this.name=N,this.uri=re,this._itemId=Se,this.c=He}data(){return this.c()}}e.$kL=gt;let ht=class{#e=new Map;constructor(N){for(const[re,Se]of N??[]){const He=this.#e.get(this.#t(re));He?He.push(Se):this.#e.set(this.#t(re),[Se])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,re){this.#e.set(this.#t(N),[re])}forEach(N,re){for(const[Se,He]of this.#e)for(const Xe of He)N.call(re,Xe,Se,this)}*[Symbol.iterator](){for(const[N,re]of this.#e)for(const Se of re)yield[N,Se]}#t(N){return N.toLowerCase()}};e.$lL=ht,e.$lL=ht=Ke([C],ht);let ft=class{constructor(N){this.insertText=N}};e.$mL=ft,e.$mL=ft=Ke([C],ft);let ui=class{constructor(N,re){this.label=re,this.insertText=N}};e.$nL=ui,e.$nL=ui=Ke([C],ui);let St=class{constructor(N,re){this.id=N,this.color=re}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$oL=St,e.$oL=St=Ke([C],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(N){this.id=N}};e.$pL=Si,e.$pL=Si=Ke([C],Si);var li;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let $i=class{get base(){return this.c}set base(N){this.c=N,this.e=g.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,re){if(typeof N!="string"&&(!N||!g.URI.isUri(N)&&!g.URI.isUri(N.uri)))throw(0,L.$6)("base");if(typeof re!="string")throw(0,L.$6)("pattern");typeof N=="string"?this.baseUri=g.URI.file(N):g.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$qL=$i,e.$qL=$i=Ke([C],$i);const It=new WeakMap;function gn(U,N){It.set(U,N)}e.$rL=gn;let ri=class{constructor(N,re,Se,He){this.enabled=typeof N=="boolean"?N:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,A.$eg)()),this.c}};e.$sL=ri,e.$sL=ri=Ke([C],ri);let yt=class extends ri{constructor(N,re,Se,He,Xe){if(super(re,Se,He,Xe),N===null)throw(0,L.$6)("location");this.location=N}};e.$tL=yt,e.$tL=yt=Ke([C],yt);let pi=class extends ri{constructor(N,re,Se,He,Xe){super(re,Se,He,Xe),this.functionName=N}};e.$uL=pi,e.$uL=pi=Ke([C],pi);let vi=class extends ri{constructor(N,re,Se,He,Xe,st,lt){if(super(He,Xe,st,lt),!re)throw(0,L.$6)("dataId");this.label=N,this.dataId=re,this.canPersist=Se}};e.$vL=vi,e.$vL=vi=Ke([C],vi);let si=class{constructor(N,re,Se){this.command=N,this.args=re||[],this.options=Se}};e.$wL=si,e.$wL=si=Ke([C],si);let Ii=class{constructor(N,re){this.port=N,this.host=re}};e.$xL=Ii,e.$xL=Ii=Ke([C],Ii);let Ci=class{constructor(N){this.path=N}};e.$yL=Ci,e.$yL=Ci=Ke([C],Ci);let Mt=class{constructor(N){this.implementation=N}};e.$zL=Mt,e.$zL=Mt=Ke([C],Mt);let bi=class{constructor(N,re,Se){this.session=N,this.threadId=re,this.frameId=Se}};e.$AL=bi,e.$AL=bi=Ke([C],bi);let Pi=class{constructor(N,re){this.session=N,this.threadId=re}};e.$BL=Pi,e.$BL=Pi=Ke([C],Pi);let oi=class{constructor(N,re){this.range=N,this.expression=re}};e.$CL=oi,e.$CL=oi=Ke([C],oi);var hi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(hi||(e.InlineCompletionTriggerKind=hi={}));let ct=class{constructor(N,re){this.range=N,this.text=re}};e.$DL=ct,e.$DL=ct=Ke([C],ct);let Ai=class{constructor(N,re,Se=!0){this.range=N,this.variableName=re,this.caseSensitiveLookup=Se}};e.$EL=Ai,e.$EL=Ai=Ke([C],Ai);let Yt=class{constructor(N,re){this.range=N,this.expression=re}};e.$FL=Yt,e.$FL=Yt=Ke([C],Yt);let ii=class{constructor(N,re){this.frameId=N,this.stoppedLocation=re}};e.$GL=ii,e.$GL=ii=Ke([C],ii);var Ri;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=d=class extends Error{static FileExists(N){return new d(N,o.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(N){return new d(N,o.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(N){return new d(N,o.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(N){return new d(N,o.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(N){return new d(N,o.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(N){return new d(N,o.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(N,re=o.FileSystemProviderErrorCode.Unknown,Se){super(g.URI.isUri(N)?N.toString(!0):N),this.code=Se?.name??"Unknown",(0,o.$ok)(this,re),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$HL=Mi,e.$HL=Mi=d=Ke([C],Mi);let Li=class{constructor(N,re,Se){this.start=N,this.end=re,this.kind=Se}};e.$IL=Li,e.$IL=Li=Ke([C],Li);var Zi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Zi||(e.FoldingRangeKind=Zi={}));var Fi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Xi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Xi||(e.CommentMode=Xi={}));var Ti;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(N,re=[]){this.tokenTypes=N,this.tokenModifiers=re}}e.$JL=mn;function Ni(U){return typeof U>"u"||(0,D.$zf)(U)}class di{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let re=0,Se=N.tokenTypes.length;re<Se;re++)this.j.set(N.tokenTypes[re],re);for(let re=0,Se=N.tokenModifiers.length;re<Se;re++)this.k.set(N.tokenModifiers[re],re)}}push(N,re,Se,He,Xe){if(typeof N=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.n(N,re,Se,He,Xe);if(F.isRange(N)&&typeof re=="string"&&Ni(Se))return this.m(N,re,Se);throw(0,L.$6)()}m(N,re,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const He=N.start.line,Xe=N.start.character,st=N.end.character-N.start.character,lt=this.j.get(re);let Ut=0;if(Se)for(const Xt of Se){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);Ut|=1<<ei>>>0}this.n(He,Xe,st,lt,Ut)}n(N,re,Se,He,Xe){if(this.f&&(N<this.c||N===this.c&&re<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this.g[5*ti],Qi=this.g[5*ti+1];ni===0?(ni=Xt,Qi+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Qi,Xt=ni,ei=Qi}}let st=N,lt=re;this.f&&this.h>0&&(st-=this.c,st===0&&(lt-=this.e)),this.g[this.h++]=st,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=He,this.g[this.h++]=Xe,this.c=N,this.e=re}static o(N){const re=[],Se=N.length/5|0;for(let lt=0;lt<Se;lt++)re[lt]=lt;re.sort((lt,Ut)=>{const Xt=N[5*lt],ei=N[5*Ut];if(Xt===ei){const ti=N[5*lt+1],ni=N[5*Ut+1];return ti-ni}return Xt-ei});const He=new Uint32Array(N.length);let Xe=0,st=0;for(let lt=0;lt<Se;lt++){const Ut=5*re[lt],Xt=N[Ut+0],ei=N[Ut+1],ti=N[Ut+2],ni=N[Ut+3],Qi=N[Ut+4],Cn=Xt-Xe,Tn=Cn===0?ei-st:ei,Ji=5*lt;He[Ji+0]=Cn,He[Ji+1]=Tn,He[Ji+2]=ti,He[Ji+3]=ni,He[Ji+4]=Qi,Xe=Xt,st=ei}return He}build(N){return this.f?new Oi(new Uint32Array(this.g),N):new Oi(di.o(this.g),N)}}e.$KL=di;class Oi{constructor(N,re){this.resultId=re,this.data=N}}e.$LL=Oi;class $n{constructor(N,re,Se){this.start=N,this.deleteCount=re,this.data=Se}}e.$ML=$n;class fi{constructor(N,re){this.resultId=re,this.edits=N}}e.$NL=fi;var Yi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let Ui=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$OL=Ui,e.$OL=Ui=Ke([C],Ui);var xi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var gi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var _i;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class pn{static validate(N){if(typeof N.badge=="string"){let re=(0,$.$_e)(N.badge,0);if(re<N.badge.length&&(re+=(0,$.$_e)(N.badge,re)),N.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!St.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,re,Se){this.badge=N,this.tooltip=re,this.color=Se}}e.$PL=pn;let zi=class{constructor(N){this.kind=N}};e.$QL=zi,e.$QL=zi=Ke([C],zi);var mi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class xt{static isNotebookRange(N){return N instanceof xt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,re){if(N<0)throw(0,L.$6)("start must be positive");if(re<0)throw(0,L.$6)("end must be positive");N<=re?(this.c=N,this.e=re):(this.c=re,this.e=N)}with(N){let re=this.c,Se=this.e;return N.start!==void 0&&(re=N.start),N.end!==void 0&&(Se=N.end),re===this.c&&Se===this.e?this:new xt(re,Se)}}e.$RL=xt;class wi{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(re=>wi.isNotebookCellData(re))}static isNotebookCellData(N){return!0}constructor(N,re,Se,He,Xe,st,lt){this.kind=N,this.value=re,this.languageId=Se,this.mime=He,this.outputs=Xe??[],this.metadata=st,this.executionSummary=lt,wi.validate(this)}}e.$SL=wi;class en{constructor(N){this.cells=N}}e.$TL=en;class Zt{static isNotebookCellOutputItem(N){return N instanceof Zt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const re={name:N.name,message:N.message,stack:N.stack};return Zt.json(re,"application/vnd.code.notebook.error")}static stdout(N){return Zt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Zt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,re="application/octet-stream"){return new Zt(N,re)}static#e=new TextEncoder;static text(N,re=R.$Qr.text){const Se=Zt.#e.encode(String(N));return new Zt(Se,re)}static json(N,re="text/x-json"){const Se=JSON.stringify(N,void 0,"	");return Zt.text(Se,re)}constructor(N,re){this.data=N,this.mime=re;const Se=(0,R.$Ur)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$UL=Zt;class yi{static isNotebookCellOutput(N){return N instanceof yi?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,re=!1){const Se=new Set,He=new Set;for(let Xe=0;Xe<N.length;Xe++){const st=N[Xe],lt=(0,R.$Ur)(st.mime);if(!Se.has(lt)||(0,p.$xI)(lt)){Se.add(lt);continue}He.add(Xe),re&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return He.size===0?N:N.filter((Xe,st)=>!He.has(st))}constructor(N,re,Se){this.items=yi.ensureUniqueMimeTypes(N,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,A.$eg)(),this.metadata=re??Se)}}e.$VL=yi;var tn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(N,re){this.text=N,this.alignment=re}}e.$WL=sn;var Te;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Te||(e.NotebookControllerAffinity=Te={}));var _t;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(N,re=[]){this.uri=N,this.provides=(0,E.$2b)(re)}}e.$XL=on;class mt{constructor(N){this.label=N}}e.$YL=mt;let Bi=class{constructor(N,re){this.label=N,this.timestamp=re}};e.$ZL=Bi,e.$ZL=Bi=Ke([C],Bi);var an;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var ji;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(ji||(e.ExtensionRuntime=ji={}));var cn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class Di{constructor(N,re){this.ranges=N,this.wordPattern=re}}e.$1L=Di;class vn{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$2L=vn;var un;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let ki=class{constructor(N=void 0,re=void 0,Se=void 0,He=!1){this.include=N,this.exclude=re,this.profile=Se,this.continuous=He}};e.$3L=ki,e.$3L=ki=Ke([C],ki);let Wi=w=class{static diff(N,re,Se){const He=new w(N);return He.expectedOutput=re,He.actualOutput=Se,He}constructor(N){this.message=N}};e.$4L=Wi,e.$4L=Wi=w=Ke([C],Wi);let Vi=class{constructor(N){this.id=N}};e.$5L=Vi,e.$5L=Vi=Ke([C],Vi);let ci=class{constructor(N,re){this.covered=N,this.total=re}};e.$6L=ci,e.$6L=ci=Ke([C],ci);let qi=y=class{static fromDetails(N,re){const Se=new ci(0,0),He=new ci(0,0),Xe=new ci(0,0);for(const lt of re)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const Ut of lt.branches)He.total+=1,He.covered+=Ut.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=lt.executionCount>0?1:0;const st=new y(N,Se,He.total>0?He:void 0,Xe.total>0?Xe:void 0);return st.detailedCoverage=re,st}constructor(N,re,Se,He){this.uri=N,this.statementCoverage=re,this.branchCoverage=Se,this.functionCoverage=He}};e.$7L=qi,e.$7L=qi=y=Ke([C],qi);let Ki=class{constructor(N,re,Se=[]){this.executionCount=N,this.location=re,this.branches=Se}};e.$8L=Ki,e.$8L=Ki=Ke([C],Ki);let Hi=class{constructor(N,re){this.executionCount=N,this.location=re}};e.$9L=Hi,e.$9L=Hi=Ke([C],Hi);let Gi=class{constructor(N,re){this.executionCount=N,this.location=re}};e.$0L=Gi,e.$0L=Gi=Ke([C],Gi);var hn;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class te{constructor(N,re,Se,He,Xe,st){this.kind=N,this.name=re,this.detail=Se,this.uri=He,this.range=Xe,this.selectionRange=st}}e.$$L=te;class ge{constructor(N){this.uri=N}}e.$_L=ge;class Fe{constructor(N,re){this.original=N,this.modified=re}}e.$aM=Fe;class rt{constructor(N,re,Se,He){this.base=N,this.input1=re,this.input2=Se,this.result=He}}e.$bM=rt;class pt{constructor(N,re){this.uri=N,this.viewType=re}}e.$cM=pt;class Lt{constructor(N){this.viewType=N}}e.$dM=Lt;class Pn{constructor(N,re){this.uri=N,this.notebookType=re}}e.$eM=Pn;class An{constructor(N,re,Se){this.original=N,this.modified=re,this.notebookType=Se}}e.$fM=An;class Rn{constructor(){}}e.$gM=Rn;class Mn{constructor(N,re){this.uri=N,this.inputBoxUri=re}}e.$hM=Mn;class Ln{constructor(N){this.providerId=N}}e.$iM=Ln;var bn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var yn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Fn{constructor(N,re){this.role=N,this.content=re}}e.$jM=Fn;var kn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(Ae[103],Re([1,0,55,14,13,297,147,7,18]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=e.$wM=void 0;const g=new Map;function A(p,f){f?g.set(p,f):g.delete(p)}e.$wM=A;function S(p){return g.get(p)}class o extends M.$Wu{constructor(f,t,i,n,u,a,l,r){super(t,i,n,u),this.c=f,this.m=a,this.q=l,this.notebook=r,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$tb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===L.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,i){return f.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,E.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,E.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,n=t.start.line,u=t.end.line,a=[];a.push(this.f[n].substring(t.start.character));for(let l=n+1;l<u;l++)a.push(this.f[l]);return a.push(this.f[u].substring(0,t.end.character)),a.join(i)}t(f){let t;if(f instanceof $.$vK?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new v(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),i=this.f[t.index].length;return new $.$vK(t.index,Math.min(t.remainder,i))}w(f){if(!(f instanceof $.$wK))throw new Error("Invalid argument");const t=this.x(f.start),i=this.x(f.end);return t===f.start&&i===f.end?f:new $.$wK(t.line,t.character,i.line,i.character)}x(f){if(!(f instanceof $.$vK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:i}=f,n=!1;if(t<0)t=0,i=0,n=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,n=!0;else{const u=this.f[t].length;i<0?(i=0,n=!0):i>u&&(i=u,n=!0)}return n?new $.$vK(t,i):f}y(f,t){const i=this.x(f);if(!t)t=S(this.m);else if((0,P.$Oe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const n=(0,R.$9r)(i.character+1,(0,R.$7r)(t),this.f[i.line],0);if(n)return new $.$wK(i.line,n.startColumn-1,i.line,n.endColumn-1)}}e.$xM=o;class v{constructor(f,t,i){this.a=f,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$wK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$wK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$yM=v}),define(Ae[211],Re([1,0,7,17,5]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;let M=class{constructor($){this.a=new E.$QL(E.ColorThemeKind.Dark),this.b=new P.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange($){let D;switch($){case"light":D=E.ColorThemeKind.Light;break;case"hcDark":D=E.ColorThemeKind.HighContrast;break;case"hcLight":D=E.ColorThemeKind.HighContrastLight;break;default:D=E.ColorThemeKind.Dark}this.a=new E.$QL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$qec=M,e.$qec=M=Ke([Ve(0,L.$uM)],M)}),define(Ae[212],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BI=e.CellExecutionUpdateType=void 0;var L;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$BI=(0,E.$Qh)("INotebookExecutionService")}),define(Ae[213],Re([1,0,6,29,144,93]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oOb=void 0;class R extends E.$Rc{constructor(D,g,A){super(),this._source=D,this.b=g,this.c=A,this.a=void 0}f(D){const g=D.getLineCount();return new L.$us(1,1,g,this.g(D,g))}g(D,g){if(g<1||g>D.getLineCount())throw new Error("Illegal value for lineNumber");return D.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const D=new P.$HB;D.acceptChunk(this._source);const g=D.finish(!0),{textBuffer:A,disposable:S}=g.create(1);this.b=A,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(D=>{const g=new P.$HB;g.acceptChunk(D);const A=g.finish(!0),{textBuffer:S,disposable:o}=A.create(1);return this.B(o),S})),this.a}findInInputs(D){const A=new M.$vB(D,!1,!1,null).parseSearchRequest();if(!A)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,A,!0,5e3)}findInOutputs(D){const A=new M.$vB(D,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(S=>{const o=S.findMatchesLineByLine(this.f(S),A,!0,5e3);if(o.length!==0)return{textBuffer:S,matches:o}}).filter(S=>!!S):[]}}e.$oOb=R}),define(Ae[48],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var L;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class P{static fromExtHostTestItem(R,$,D=R.parent){if(R._isRoot)return new P([$]);const g=[R.id];for(let A=D;A&&A.id!==$;A=A.parent)g.push(A.id);return g.push($),new P(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new P(R.split("\0"))}static join(R,$){return new P([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:P.isChild(R,$)?2:P.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$iJ=P}),define(Ae[60],Re([1,0,2,29,48]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$oJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$nJ=e.$mJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$lJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$kJ=e.$jJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var R;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$jJ=[2,4,8,16,32,64];const D=k=>"runId"in k;e.$kJ=D;var g;(function(k){k.serialize=d=>({range:d.range.toJSON(),uri:d.uri.toJSON()}),k.deserialize=d=>({range:L.$us.lift(d.range),uri:E.URI.revive(d.uri)})})(g||(e.IRichLocation=g={}));var A;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(A||(e.TestMessageType=A={}));var S;(function(k){k.serialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.deserialize(d.location)})})(S||(e.ITestErrorMessage=S={}));const o=(k,d)=>`${d?"s":"e"}${k}`;e.$lJ=o;var v;(function(k){k.serialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.deserialize(d.location)})})(v||(e.ITestOutputMessage=v={}));var p;(function(k){k.serialize=d=>d.type===0?S.serialize(d):v.serialize(d),k.deserialize=d=>d.type===0?S.deserialize(d):v.deserialize(d)})(p||(e.ITestMessage=p={}));var f;(function(k){k.serializeWithoutMessages=d=>({state:d.state,duration:d.duration,messages:[]}),k.serialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(p.serialize)}),k.deserialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(p.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(k,d)=>k+t+d;e.$mJ=i;const n=k=>{const d=k.indexOf(t);return{ctrlId:k.slice(0,d),tagId:k.slice(d+1)}};e.$nJ=n;var u;(function(k){k.serialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?.toJSON(),range:d.range?.toJSON()||null,description:d.description,error:d.error,sortText:d.sortText}),k.deserialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?E.URI.revive(d.uri):void 0,range:d.range?L.$us.lift(d.range):null,description:d.description,error:d.error,sortText:d.sortText})})(u||(e.ITestItem=u={}));var a;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var l;(function(k){k.serialize=d=>({expand:d.expand,item:u.serialize(d.item)}),k.deserialize=d=>({controllerId:P.$iJ.root(d.item.extId),expand:d.expand,item:u.deserialize(d.item)})})(l||(e.InternalTestItem=l={}));var r;(function(k){k.serialize=d=>{let w;return d.item&&(w={},d.item.label!==void 0&&(w.label=d.item.label),d.item.tags!==void 0&&(w.tags=d.item.tags),d.item.busy!==void 0&&(w.busy=d.item.busy),d.item.uri!==void 0&&(w.uri=d.item.uri?.toJSON()),d.item.range!==void 0&&(w.range=d.item.range?.toJSON()),d.item.description!==void 0&&(w.description=d.item.description),d.item.error!==void 0&&(w.error=d.item.error),d.item.sortText!==void 0&&(w.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:w}},k.deserialize=d=>{let w;return d.item&&(w={},d.item.label!==void 0&&(w.label=d.item.label),d.item.tags!==void 0&&(w.tags=d.item.tags),d.item.busy!==void 0&&(w.busy=d.item.busy),d.item.range!==void 0&&(w.range=d.item.range?L.$us.lift(d.item.range):null),d.item.description!==void 0&&(w.description=d.item.description),d.item.error!==void 0&&(w.error=d.item.error),d.item.sortText!==void 0&&(w.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:w}}})(r||(e.ITestItemUpdate=r={}));const s=(k,d)=>{d.expand!==void 0&&(k.expand=d.expand),d.item!==void 0&&(k.item=k.item?Object.assign(k.item,d.item):d.item)};e.$oJ=s;var c;(function(k){k.serializeWithoutMessages=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serializeWithoutMessages)}),k.serialize=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serialize)}),k.deserialize=d=>({...l.deserialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.deserialize),retired:!0})})(c||(e.TestResultItem=c={}));var h;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(h||(e.DetailType=h={}));var b;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(b||(e.TestDiffOpType=b={}));var m;(function(k){k.deserialize=d=>d.op===0?{op:d.op,item:l.deserialize(d.item)}:d.op===1?{op:d.op,item:r.deserialize(d.item)}:d.op===2?{op:d.op,uri:E.URI.revive(d.uri),docv:d.docv}:d,k.serialize=d=>d.op===0?{op:d.op,item:l.serialize(d.item)}:d.op===1?{op:d.op,item:r.serialize(d.item)}:d})(m||(e.TestsDiffOp=m={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(d){const w=this.o();for(const y of d)switch(y.op){case 0:this.j(l.deserialize(y.item),w);break;case 1:this.k(r.deserialize(y.item),w);break;case 3:this.l(y.itemId,w);break;case 5:this.m(y.itemId);break;case 4:this.updatePendingRoots(y.amount);break;case 6:this.c.set(y.tag.id,y.tag);break;case 7:this.c.delete(y.id);break}w.complete?.()}j(d,w){const y=P.$iJ.parentId(d.item.extId)?.toString();let C;if(!y)C=this.p(d),this.f.add(C),this.d.set(d.item.extId,C);else if(this.d.has(y)){const B=this.d.get(y);B.children.add(d.item.extId),C=this.p(d,B),this.d.set(d.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(d)}`);return}return w.add?.(C),d.expand===2&&this.g++,C}k(d,w){const y=this.d.get(d.extId);if(y)return d.expand!==void 0&&(y.expand===2&&this.g--,d.expand===2&&this.g++),(0,e.$oJ)(y,d),w.update?.(y),y}l(d,w){const y=this.d.get(d);if(!y)return;const C=P.$iJ.parentId(y.item.extId)?.toString();C?this.d.get(C).children.delete(y.item.extId):this.f.delete(y);const B=[[d]];for(;B.length;)for(const j of B.pop()){const V=this.d.get(j);V&&(B.push(V.children),this.d.delete(j),w.remove?.(V,V!==y),V.expand===2&&this.g--)}}m(d){}updatePendingRoots(d){this.h+=d}o(){return{}}}e.$pJ=I}),define(Ae[77],Re([1,0,12,5,6,55,60,48]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.TestItemEventOp=void 0;var D;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(n,u)=>n===u,S=Object.entries({range:(n,u)=>n===u?!0:!n||!u?!1:n.equalsRange(u),busy:g,label:g,description:g,error:g,sortText:g,tags:(n,u)=>!(n.length!==u.length||n.some(a=>!u.includes(a)))}),o=(n,u)=>{let a;for(const[l,r]of S)r(n[l],u[l])||(a?a[l]=u[l]:a={[l]:u[l]});return a};class v extends P.$Rc{get root(){return this.s.root}constructor(u){super(),this.s=u,this.f=this.B(new E.$7g(()=>this.flushDiff(),200)),this.g=this.B(new L.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(u){this.h=u;for(const a of this.tree.values())this.I(a)}get resolveHandler(){return this.h}collectDiff(){const u=this.m;return this.m=[],u}pushDiff(u){switch(u.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===u.uri){a.docv=u.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===u.item.extId){(0,R.$oJ)(a.item,u.item);return}if(a.op===0&&a.item.item.extId===u.item.extId){(0,R.$oJ)(a.item,u.item);return}}break}}this.m.push(u),this.f.isScheduled()||this.f.schedule()}expand(u,a){const l=this.tree.get(u);if(l){if((l.expandLevels===void 0||a>l.expandLevels)&&(l.expandLevels=a),l.expand===1){const r=this.L(l);return r.isOpen()?this.J(l,a-1):r.wait().then(()=>this.J(l,a-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,a-1)):this.J(l,a-1)}}dispose(){for(const u of this.tree.values())this.s.getApiFor(u.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(u,a){switch(a.op){case 3:this.N($.$iJ.joinToString(u.fullId,a.id));break;case 0:this.y(a.item,u);break;case 5:for(const l of a.ops)this.u(u,l);break;case 1:this.z(a.new,a.old,u.fullId.toString());break;case 2:this.I(u);break;case 4:this.pushDiff({op:1,item:{extId:u.fullId.toString(),item:a.update}});break;case 6:this.w(u.actual.uri);break;default:(0,M.$3c)(a)}}w(u){u&&this.pushDiff({op:2,uri:u,docv:this.s.getDocumentVersion(u)})}y(u,a){const l=$.$iJ.fromExtHostTestItem(u,this.root.id,a?.actual),r=this.s.getApiFor(u);r.parent&&r.parent!==a?.actual&&this.s.getChildren(r.parent).delete(u.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:u,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},u.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(u,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(u)}}),this.H(u,s,a);return}if(s.actual===u){this.G(u,s,a);return}if(s.actual.uri?.toString()!==u.uri?.toString())return this.N(l.toString()),this.y(u,a);const c=this.s.getChildren(s.actual),h=s.actual,b=o(this.s.toITestItem(h),this.s.toITestItem(u));this.s.getApiFor(h).listener=void 0,s.actual=u,s.expand=0,b&&(b.hasOwnProperty("tags")&&(this.z(u.tags,h.tags,l.toString()),delete b.tags),this.u(s,{op:4,update:b})),this.H(u,s,a);for(const[m,I]of c)this.s.getChildren(u).get(I.id)||this.N($.$iJ.joinToString(l,I.id));this.w(s.actual.uri)}z(u,a,l){const r=new Set(a.map(s=>s.id));for(const s of u)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:l,item:{tags:u.map(s=>(0,R.$mJ)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(u){const a=this.j.get(u.id);a?a.refCount++:(this.j.set(u.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$mJ)(this.s.controllerId,u.id)}}))}D(u){const a=this.j.get(u);a&&!--a.refCount&&(this.j.delete(u),this.pushDiff({op:7,id:(0,R.$mJ)(this.s.controllerId,u)}))}F(u,a){this.s.getApiFor(u).parent=a&&a.actual!==this.root?a.actual:void 0}G(u,a,l){this.F(u,l);const r=this.s.getApiFor(u);r.parent=l?.actual,r.listener=s=>this.u(a,s),this.I(a)}H(u,a,l){this.G(u,a,l);for(const[r,s]of this.s.getChildren(u))this.y(s,a)}I(u){let a;this.h?u.resolveBarrier?a=u.resolveBarrier.isOpen()?3:2:a=u.actual.canResolveChildren?1:0:a=0,a!==u.expand&&(u.expand=a,this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:a}}),a===1&&u.expandLevels!==void 0&&this.L(u))}J(u,a){if(a<0)return;const l=[];for(const[r,s]of this.s.getChildren(u.actual)){const c=this.expand($.$iJ.joinToString(u.fullId,s.id),a);(0,E.$Gg)(c)&&l.push(c)}if(l.length)return Promise.all(l).then(()=>{})}L(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this.h){const s=new E.$Sg;return s.open(),s}u.expand=2,this.M(u);const a=u.resolveBarrier=new E.$Sg,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(u.actual===this.root?void 0:u.actual)}catch(s){l(s)}return(0,E.$Gg)(r)?r.catch(l).then(()=>{a.open(),this.I(u)}):(a.open(),this.I(u)),u.resolveBarrier}M(u){this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:u.expand}})}N(u){const a=this.tree.get(u);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:u});const l=[a];for(;l.length;){const r=l.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,c]of this.s.getChildren(r.actual))l.push(this.tree.get($.$iJ.joinToString(r.fullId,c.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.g.fire(u)}}e.$kM=v;class p extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.$lM=p;class f extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$mM=f;class t extends Error{constructor(u,a,l){super(`TestItem with ID "${u}" is from controller "${a}" and cannot be added as a child of an item from controller "${l}".`)}}e.$nM=t;const i=(n,u,a)=>{let l=new Map;return{get size(){return l.size},forEach(r,s){for(const c of l.values())r.call(s,c,this)},[Symbol.iterator](){return l.entries()},replace(r){const s=new Map,c=new Set(l.keys()),h={op:5,ops:[]};for(const b of r){if(!(b instanceof a))throw new f(b.id);const m=u(b).controllerId;if(m!==n.controllerId)throw new t(b.id,m,n.controllerId);if(s.has(b.id))throw new p(b.id);s.set(b.id,b),c.delete(b.id),h.ops.push({op:0,item:b})}for(const b of c.keys())h.ops.push({op:3,id:b});n.listener?.(h),l=s},add(r){if(!(r instanceof a))throw new f(r.id);l.set(r.id,r),n.listener?.({op:0,item:r})},delete(r){l.delete(r)&&n.listener?.({op:3,id:r})},get(r){return l.get(r)},toJSON(){return Array.from(l.values())}}};e.$oM=i}),define(Ae[104],Re([1,0,77]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=void 0;const L=new WeakMap,P=(R,$)=>{const D={controllerId:$};return L.set(R,D),D};e.$pM=P;const M=R=>{const $=L.get(R);if(!$)throw new E.$mM(R?.id||"<unknown>");return $};e.$qM=M}),define(Ae[78],Re([1,0,14,2]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wtb=e.$Vtb=e.$Utb=e.$Ttb=e.$Stb=void 0,e.$Stb="vscode-cdn.net",e.$Ttb=`vscode-resource.${e.$Stb}`,e.$Utb=`'self' https://*.${e.$Stb}`;function P($,D){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(D&&D.authority&&D.isRemote&&$.scheme===E.Schemas.file&&($=L.URI.from({scheme:E.Schemas.vscodeRemote,authority:D.authority,path:$.path})),L.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$Ttb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$Vtb=P;function M($){return $.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.$Wtb=R}),define(Ae[214],Re([1,0,5,6,78]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class M{constructor($,D,g){this.d=$,this.e=D,this.f=g,this.a=0,this.b=new L.$Qc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const A=D.getVisibleTextEditors();for(const S of this.c.values())A.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,D,g,A,S){let o;for(const u of this.e.getVisibleTextEditors(!0))if(u.value===$){o=u;break}if(!o)throw new Error("not a visible editor");const v=this,p=this.a++,f=new E.$Nd,t=new E.$Nd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(u){return(0,P.$Vtb)(u,v.f)}get cspSource(){return P.$Utb}set options(u){this.b=u,v.d.$setOptions(p,u)}get options(){return this.b}set html(u){this.a=u,v.d.$setHtml(p,u)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(u){return v.d.$postMessage(p,u)}},n=new class{constructor(){this.editor=$,this.line=D,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){v.c.has(p)&&(v.c.delete(p),v.d.$disposeEditorInset(p),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(p,o.id,o.value.document.uri,D+1,g,A||{},S.identifier,S.extensionLocation),this.c.set(p,{editor:$,inset:n,onDidReceiveMessage:f}),n}$onDidDispose($){const D=this.c.get($);D&&D.inset.dispose()}$onDidReceiveMessage($,D){this.c.get($)?.onDidReceiveMessage.fire(D)}}e.$1dc=M}),define(Ae[215],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.VariableKind=e.$gN=void 0,e.$gN=(0,E.$Qh)("configurationResolverService");var L;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class P extends Error{constructor(R,$){super($),this.variable=R}}e.$hN=P}),define(Ae[216],Re([1,0,19,74,16,26,21,94,178,215,13]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,p,f,t){this.h=new Map,this.a=v,this.b=p,this.g=f,t&&(this.c=t.then(i=>this.i(i)))}i(v){if(R.$j){const p=Object.create(null);return Object.keys(v).forEach(f=>{p[f.toLowerCase()]=v[f]}),p}return v}resolveWithEnvironment(v,p,f){return this.l({env:this.i(v),userHome:void 0},p?p.uri:void 0,f)}async resolveAsync(v,p){const f={env:await this.c,userHome:await this.g};return this.l(f,v?v.uri:void 0,p)}async j(v,p,f,t){const i=M.$8m(p);R.$j&&i.windows?Object.keys(i.windows).forEach(u=>i[u]=i.windows[u]):R.$k&&i.osx?Object.keys(i.osx).forEach(u=>i[u]=i.osx[u]):R.$l&&i.linux&&Object.keys(i.linux).forEach(u=>i[u]=i.linux[u]),delete i.windows,delete i.osx,delete i.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,i,f,t)}async resolveAnyAsync(v,p,f){return this.j(v,p,f)}async resolveAnyMap(v,p,f){const t=new Map;return{newConfig:await this.j(v,p,f,t),resolvedVariables:t}}resolveWithInteractionReplace(v,p,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,p,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,p){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,p)}async l(v,p,f,t,i){if(P.$yf(f))return this.m(v,p,f,t,i);if(Array.isArray(f))return Promise.all(f.map(n=>this.l(v,p,n,t,i)));if(P.$Af(f)){const n=Object.create(null),u=await Promise.all(Object.keys(f).map(async a=>[await this.m(v,p,a,t,i),await this.l(v,p,f[a],t,i)]));for(const[a,l]of u)n[a]=l;return n}return f}m(v,p,f,t,i){return(0,A.$Te)(f,S.VARIABLE_REGEXP,async(n,u)=>{if(u.includes(S.VARIABLE_LHS))return n;let a=await this.o(v,n,u,p,t);return i?.set(u,a),a!==n&&P.$yf(a)&&a.match(S.VARIABLE_REGEXP)&&(a=await this.m(v,p,a,t,i)),a})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,p,f,t,i){let n;const u=f.split(":");u.length>1&&(f=u[0],n=u[1]);const a=s=>{const c=this.a.getFilePath();if(c)return(0,$.$tv)(c);throw new g.$hN(s,(0,D.localize)(0,null,p))},l=s=>{const c=a(s);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,$.$tv)(h)}throw new g.$hN(s,(0,D.localize)(1,null,p,E.$mc(c)))},r=s=>{if(n){const c=this.a.getFolderUri(n);if(c)return c;throw new g.$hN(s,(0,D.localize)(2,null,p,n))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$hN(s,(0,D.localize)(3,null,p)):new g.$hN(s,(0,D.localize)(4,null,p))};switch(f){case"env":if(n){if(v.env){const s=v.env[R.$j?n.toLowerCase():n];if(P.$yf(s))return s}return""}throw new g.$hN(g.VariableKind.Env,(0,D.localize)(5,null,p));case"config":if(n){const s=this.a.getConfigurationValue(t,n);if(P.$Hf(s))throw new g.$hN(g.VariableKind.Config,(0,D.localize)(6,null,p,n));if(P.$Af(s))throw new g.$hN(g.VariableKind.Config,(0,D.localize)(7,null,p,n));return s}throw new g.$hN(g.VariableKind.Config,(0,D.localize)(8,null,p));case"command":return this.p(g.VariableKind.Command,p,n,i,"command");case"input":return this.p(g.VariableKind.Input,p,n,i,"input");case"extensionInstallFolder":if(n){const s=await this.a.getExtension(n);if(!s)throw new g.$hN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,p,n));return this.n(s.extensionLocation)}throw new g.$hN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,p));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,$.$tv)(this.n(r(g.VariableKind.WorkspaceFolder)));case"cwd":return t||n?(0,$.$tv)(this.n(r(g.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$tv)(E.$mc(this.n(r(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new g.$hN(g.VariableKind.UserHome,(0,D.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$hN(g.VariableKind.LineNumber,(0,D.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$hN(g.VariableKind.SelectedText,(0,D.localize)(13,null,p))}case"file":return a(g.VariableKind.File);case"fileWorkspaceFolder":return l(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||n?E.$kc(this.n(r(g.VariableKind.RelativeFile)),a(g.VariableKind.RelativeFile)):a(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$lc(a(g.VariableKind.RelativeFileDirname));if(t||n){const c=E.$kc(this.n(r(g.VariableKind.RelativeFileDirname)),s);return c.length===0?".":c}return s}case"fileDirname":return E.$lc(a(g.VariableKind.FileDirname));case"fileExtname":return E.$nc(a(g.VariableKind.FileExtname));case"fileBasename":return E.$mc(a(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$mc(a(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$nc(s).length)}case"fileDirnameBasename":return E.$mc(E.$lc(a(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":return E.sep;default:try{const s=n?`${f}:${n}`:f;return this.p(g.VariableKind.Unknown,p,s,i,void 0)}catch{return p}}}}p(v,p,f,t,i){if(f&&t){const n=i===void 0?t[f]:t[i+":"+f];if(typeof n=="string")return n;throw new g.$hN(v,(0,D.localize)(14,null,p))}return p}}e.$vN=S}),define(Ae[105],Re([1,0,4,102]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DC=e.$CC=e.OpenEditorContext=e.GroupsOrder=e.$BC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$AC=void 0,e.$AC=(0,E.$Qh)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var D;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g(p){const f=p;return(0,L.$iE)(f?.editor)&&(0,L.$iE)(f?.replacement)}e.$BC=g;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var S;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function o(p){const f=p;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$CC=o;function v(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$DC=v}),define(Ae[217],Re([1,0,4,105]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HC=e.$GC=e.$FC=e.$EC=void 0,e.$EC=(0,E.$Qh)("editorService"),e.$FC=-1,e.$GC=-2;function P(M){const R=M;return typeof M=="number"||(0,L.$CC)(R)}e.$HC=P}),define(Ae[218],Re([1,0,4,185]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=void 0,e.$MJ=(0,E.$Rh)(L.$Xh)}),define(Ae[106],Re([1,0,22,5,19,6]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$04b=e.$94b=e.$84b=e.$74b=e.$64b=void 0;class R{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$64b=R;class ${static isHostExtension(i,n,u){if(n.getExtensionDescription(i))return!1;const a=u.getExtensionDescription(i);return a?!!((a.main||a.browser)&&a.api==="none"):!1}constructor(i,n){this.j=i,this.c=new L.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(p),this.f=new E.$9l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const u of n)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=f(this.e,n),this.e=this.e.concat(i);const u=$.l(this.e);return this.e=f(this.e,u.map(a=>a.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,u)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,c){this.addNode(s),this.addNode(c),this.c.has(s)?this.c.get(s).push(c):this.c.set(s,[c])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,c){const h=n.getArcs(s);for(let b=0;b<h.length;b++)if(!c.has(h[b]))return!1;return!0}getNodes(){return this.e}},u=new E.$9l;for(const s of i)if(u.set(s.identifier,s),s.extensionDependencies)for(const c of s.extensionDependencies)n.addArc(E.$7l.toKey(s.identifier),E.$7l.toKey(c));const a=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>a.add(s));const l=n.getNodes().filter(s=>!a.has(s));let r;do{r=!1;for(let s=0;s<l.length;s++){const c=l[s];n.hasOnlyGoodArcs(c,a)&&(l.splice(s,1),s--,a.add(c),r=!0)}}while(r);return l.map(s=>u.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$74b=$;class D{constructor(i,n){this.versionId=i,this.extensions=n}}e.$84b=D;class g{constructor(i){this.d=new o,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new A(this,n)}deltaExtensions(i,n,u){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,u)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$94b=g;class A extends M.$Rc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$04b=A;class S{constructor(i){this.name=i,this.promise=new Promise((n,u)=>{this.c=n})}resolve(i){this.c(i)}}class o{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new S(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const u=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),a=()=>{n&&(clearTimeout(u),n=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(a))}}var v;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(v||(v={}));function p(t,i){const n=t.isBuiltin?0:t.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==u)return n-u;const a=P.$fc.basename(t.extensionLocation.path),l=P.$fc.basename(i.extensionLocation.path);return a<l?-1:a>l?1:0}function f(t,i){const n=new E.$8l(i);return t.filter(u=>!n.has(u.identifier))}}),define(Ae[79],Re([1,0,23]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$dm=e.$cm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(L||(e.UIKind=L={}));var P;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(g){const A=E.$be.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$cm=R;function $(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$dm=$;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[61],Re([1,0,4,5,15,27,79,57,58,26,2,6,166]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=e.$MM=e.$LM=void 0;let v=class extends S.$Rc{constructor(i,n){super(),this.s=i,this.t=n,this.a=this.B(new L.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:D.$po,name:(0,o.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(u=>{(0,P.$aj)(u)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,n,u){const a=this.getTelemetryDetails(),l=new p(n,u,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),r=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...r,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(i,n,u){this.f=i,this.g=n,this.c=u??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const n=Object.create(null);switch(n["common.extname"]=`${i.publisher}.${i.name}`,n["common.extversion"]=i.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$Wk)((0,D.$wo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const n=this.getTelemetryDetails();this.r.forEach((u,a)=>{const l=u.filter(r=>!r.isDisposed);l.length===0?this.r.delete(a):this.r.set(a,l)}),this.r.forEach(u=>{for(const a of u)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,n){const a=this.r.get(i.value)?.filter(r=>!r.isDisposed);if(!a)return this.r.delete(i.value),!1;let l=!1;for(const r of a)r.ignoreUnhandledExtHostErrors||(r.logError(n),l=!0);return l}};e.$LM=v,e.$LM=v=Ke([Ve(0,M.$KM),Ve(1,P.$_i)],v);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,n,u,a,l,r,s){this.g=u,this.h=a,this.i=l,this.j=r,this.a=new L.$Nd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,n){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let n="properties"in i?i.properties??{}:i;return n=(0,D.$zo)(n,[]),this.c&&(n=(0,g.$$m)(n,this.c)),this.b||(n=(0,g.$$m)(n,this.j)),"properties"in i?i.properties=n:i=n,i}k(i,n){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(i,n),this.h.trace(i,n))}logUsage(i,n){this.d.isUsageEnabled&&this.k(i,n)}logError(i,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,n);else{const u={name:i.name,message:i.message,stack:i.stack,cause:i.cause},a=(0,D.$zo)(u,[]),l=new Error(a.message,{cause:a.cause});l.stack=a.stack,l.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(l,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const i=this,n={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$MM=p;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$NM=f,e.$OM=(0,E.$Qh)("IExtHostTelemetry")}),define(Ae[25],Re([1,0,5,2,194,101,22,4]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=e.$vF=e.ActivationKind=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.ExtensionHostStartup=e.$pF=e.$oF=e.$nF=e.$mF=void 0,e.$mF=Object.freeze({identifier:new R.$7l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$nF="extensions.webWorker",e.$oF=(0,$.$Qh)("extensionService");class D{constructor(l){this.dependency=l}}e.$pF=D;var g;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,r,s){this.c=l,this.d=r.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$0E.createActivationEventsMap(this.d)}}set(l,r,s){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const c=[],h=[],b=[],m=[],I=S(this.d),k=S(r),d=(j,V)=>j.extensionLocation.toString()===V.extensionLocation.toString()||j.isBuiltin===V.isBuiltin||j.isUserBuiltin===V.isUserBuiltin||j.isUnderDevelopment===V.isUnderDevelopment;for(const j of this.d){const V=k.get(j.identifier);if(!V){c.push(j.identifier),I.delete(j.identifier);continue}if(!d(j,V)){c.push(j.identifier),I.delete(j.identifier);continue}}for(const j of r){const V=I.get(j.identifier);if(!V){h.push(j);continue}if(!d(V,j)){c.push(V.identifier),I.delete(V.identifier);continue}}const w=new R.$8l(this.e),y=new R.$8l(s);for(const j of this.e)y.has(j)||b.push(j);for(const j of s)w.has(j)||m.push(j);const C=M.$0E.createActivationEventsMap(h),B={versionId:l,toRemove:c,toAdd:h,addActivationEvents:C,myToRemove:b,myToAdd:m};return this.delta(B),B}delta(l){if(this.c>=l.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:c,myToAdd:h}=l,b=new R.$8l(r),m=new R.$8l(c);for(let I=0;I<this.d.length;I++)b.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)m.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of s)this.d.push(I);for(const I of h)this.e.push(I);return this.f=null,l}containsExtension(l){for(const r of this.e)if(R.$7l.equals(r,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const r of this.d){if(!this.containsExtension(r.identifier))continue;const s=M.$0E.readActivationEvents(r);for(const c of s)l.add(c)}return l}}e.$qF=A;function S(a){const l=new R.$9l;for(const r of a)l.set(r.identifier,r);return l}function o(a,l){return a.enabledApiProposals?a.enabledApiProposals.includes(l):!1}e.$rF=o;function v(a,l){if(!o(a,l))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$sF=v;class p{constructor(l,r,s,c){this.codeLoadingTime=l,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=c}}e.$tF=p;class f{constructor(l,r){this.description=l,this.value=r}}e.$uF=f;var t;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,P.$Fo)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$vF=i;function n(a,l){return{identifier:new R.$7l((0,P.$Do)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!l,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$wF=n;class u{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$xF=u}),define(Ae[219],Re([1,0,11,106,22,25,15,12]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=e.$cdc=e.$bdc=e.$adc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,n,u,a){this.startup=i,this.codeLoadingTime=n,this.activateCallTime=u,this.activateResolvedTime=a}}e.$adc=D;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,n){return i===-1||n===-1?-1:n-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$bdc=g;class A{constructor(i,n,u,a,l,r){this.activationFailed=i,this.activationFailedError=n,this.activationTimes=u,this.module=a,this.exports=l,this.subscriptions=r}}e.$cdc=A;class S extends A{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ddc=S;class o extends A{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$edc=o;class v extends A{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,n,u,a){this.g=a,this.a=i,this.b=n,this.c=u,this.d=new P.$9l,this.f=Object.create(null)}dispose(){for(const[i,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const i=[];for(const[n,u]of this.d)i.push(u.wait());await Promise.all(i)}isActivated(i){const n=this.d.get(i);return!!(n&&n.value)}getActivatedExtension(i){const n=this.d.get(i);if(!n||!n.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return n.value}async activateByEvent(i,n){if(this.f[i])return;const u=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(u.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,n){const u=this.a.getExtensionDescription(i);if(!u)throw new Error(`Extension '${i}' is not known`);return this.h([{id:u.identifier,reason:n}])}async h(i){const n=i.filter(u=>!this.isActivated(u.id)).map(u=>this.j(u));await Promise.all(n.map(u=>u.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const n=this.a.getExtensionDescription(i.id);if(!n){const l=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new v(l));return this.c.onExtensionActivationError(i.id,l,new M.$pF(i.id.value)),r}const u=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const l of a){if(this.m(l))continue;const r=this.d.get(l);if(r){u.push(r);continue}if(this.l(l)){u.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;u.push(this.j({id:s.identifier,reason:i.reason}));continue}const c=n.displayName||n.identifier.value,h=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${l}'`),b=this.k(i,n.displayName,[],new v(h));return this.c.onExtensionActivationError(n.identifier,h,new M.$pF(l)),b}return this.k(i,n.displayName,u,null)}k(i,n,u,a){const l=new f(i.id,n,i.reason,u,a,this.c,this.g);return this.d.set(i.id,l),l}l(i){return L.$74b.isHostExtension(i,this.a,this.b)}m(i){const n=this.b.getExtensionDescription(i);return n?!n.main&&!n.browser:!1}};e.$fdc=p,e.$fdc=p=Ke([Ve(3,R.$$i)],p);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,n,u,a,l,r,s){this.c=i,this.d=n,this.f=u,this.g=a,this.h=l,this.j=r,this.k=s,this.a=new $.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const n=this.g[i];if(n.value&&!n.value.activationFailed){this.g.splice(i,1),i--;continue}if(n.value&&n.value.activationFailed){const u=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);u.detail=n.value.activationFailedError,this.h=new v(u),this.j.onExtensionActivationError(this.c,u,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const n=new Error;if(i&&i.name&&(n.name=i.name),i&&i.message?n.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(n.stack=i.stack),this.h=new v(n),this.b&&E.$3(i))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};f=Ke([Ve(6,R.$$i)],f)}),define(Ae[8],Re([1,0,18,23,126,220,53,28,120,52,69,26,16,2,29,80,98,104,102,76,48,60,217,7,25]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$tM=e.$sM=e.MarkdownString=e.$rM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Ce){function Le(H){const{selectionStartLineNumber:Me,selectionStartColumn:ze,positionLineNumber:Qe,positionColumn:qe}=H,et=new s.$vK(Me-1,ze-1),Et=new s.$vK(Qe-1,qe-1);return new s.$xK(et,Et)}Ce.to=Le;function $e(H){const{anchor:Me,active:ze}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Ce.from=$e})(h||(e.Selection=h={}));var b;(function(Ce){function Le(H){if(!H)return;const{start:Me,end:ze}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Ce.from=Le;function $e(H){if(!H)return;const{startLineNumber:Me,startColumn:ze,endLineNumber:Qe,endColumn:qe}=H;return new s.$wK(Me-1,ze-1,Qe-1,qe-1)}Ce.to=$e})(b||(e.Range=b={}));var m;(function(Ce){function Le($e){switch($e){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Le})(m||(e.TokenType=m={}));var I;(function(Ce){function Le(H){return new s.$vK(H.lineNumber-1,H.column-1)}Ce.to=Le;function $e(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=$e})(I||(e.Position=I={}));var k;(function(Ce){function Le(Me,ze,Qe){return(0,E.$Gb)((0,E.$2b)(Me).map(qe=>$e(qe,ze,Qe)))}Ce.from=Le;function $e(Me,ze,Qe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Qe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,ze),pattern:X.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Qe?.isBuiltin}}function H(Me,ze){return ze&&typeof Me=="string"?ze.transformOutgoingScheme(Me):Me}})(k||(e.DocumentSelector=k={}));var d;(function(Ce){function Le(H){switch(H){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Le;function $e(H){switch(H){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=$e})(d||(e.DiagnosticTag=d={}));var w;(function(Ce){function Le(H){let Me;return H.code&&((0,o.$yf)(H.code)||(0,o.$Cf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...b.from(H.range),message:H.message,source:H.source,code:Me,severity:C.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(y.from),tags:Array.isArray(H.tags)?(0,E.$Gb)(H.tags.map(d.from)):void 0}}Ce.from=Le;function $e(H){const Me=new s.$IK(b.to(H),H.message,C.to(H.severity));return Me.source=H.source,Me.code=(0,o.$yf)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(y.to),Me.tags=H.tags&&(0,E.$Gb)(H.tags.map(d.to)),Me}Ce.to=$e})(w||(e.Diagnostic=w={}));var y;(function(Ce){function Le(H){return{...b.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Le;function $e(H){return new s.$HK(new s.$GK(H.resource,b.to(H)),H.message)}Ce.to=$e})(y||(e.DiagnosticRelatedInformation=y={}));var C;(function(Ce){function Le(H){switch(H){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Le;function $e(H){switch(H){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=$e})(C||(e.DiagnosticSeverity=C={}));var B;(function(Ce){function Le(H){return typeof H=="number"&&H>=s.ViewColumn.One?H-1:H===s.ViewColumn.Beside?r.$GC:r.$FC}Ce.from=Le;function $e(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=$e})(B||(e.ViewColumn=B={}));function j(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!j(Ce[0])}e.$rM=V;var z;(function(Ce){function Le(qe){return qe.map(Ce.from)}Ce.fromMany=Le;function $e(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function H(qe){let et;if($e(qe)){const{language:ht,value:ft}=qe;et={value:"```"+ht+`
`+ft+"\n```\n"}}else s.$UK.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const Et=Object.create(null);et.uris=Et;const Dt=ht=>{try{let ft=v.URI.parse(ht,!0);ft=ft.with({query:Me(ft.query,Et)}),Et[ht]=ft}catch{}return""},gt=new D.marked.Renderer;return gt.link=Dt,gt.image=ht=>typeof ht=="string"?Dt(R.$$j(ht).href):"",(0,D.marked)(et.value,{renderer:gt}),et}Ce.from=H;function Me(qe,et){if(!qe)return qe;let Et;try{Et=(0,g.$mh)(qe)}catch{}if(!Et)return qe;let Dt=!1;return Et=(0,S.$0m)(Et,gt=>{if(v.URI.isUri(gt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ht]=gt,Dt=!0,ht}else return}),Dt?JSON.stringify(Et):qe}function ze(qe){const et=new s.$UK(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?v.URI.from(qe.baseUri):void 0,et}Ce.to=ze;function Qe(qe){if(qe)return typeof qe=="string"?qe:Ce.from(qe)}Ce.fromStrict=Qe})(z||(e.MarkdownString=z={}));function F(Ce){return V(Ce)?Ce.map(Le=>({range:b.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?z.fromMany(Le.hoverMessage):Le.hoverMessage?z.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Ce.map(Le=>({range:b.from(Le)}))}e.$sM=F;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?v.URI.file(Ce):Ce}e.$tM=O;var x;(function(Ce){function Le($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?O($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}Ce.from=Le})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var Z;(function(Ce){function Le($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?O($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?x.from($e.before):void 0,after:$e.after?x.from($e.after):void 0}}Ce.from=Le})(Z||(e.ThemableDecorationRenderOptions=Z={}));var De;(function(Ce){function Le($e){if(typeof $e>"u")return $e;switch($e){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Le})(De||(e.DecorationRangeBehavior=De={}));var ke;(function(Ce){function Le($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?De.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?Z.from($e.light):void 0,dark:$e.dark?Z.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?O($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?x.from($e.before):void 0,after:$e.after?x.from($e.after):void 0}}Ce.from=Le})(ke||(e.DecorationRenderOptions=ke={}));var Ie;(function(Ce){function Le(H){return{text:H.newText,eol:H.newEol&&xe.from(H.newEol),range:b.from(H.range)}}Ce.from=Le;function $e(H){const Me=new s.$BK(b.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:xe.to(H.eol),Me}Ce.to=$e})(Ie||(e.TextEdit=Ie={}));var de;(function(Ce){function Le(H,Me){const ze={edits:[]};if(H instanceof s.$EK){const Qe=new $.$Ac;for(const qe of H._allEntries())qe._type===1&&v.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of H._allEntries())if(qe._type===1){let et;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?et={type:"base64",value:(0,L.$ve)(L.$be.wrap(qe.options.contents))}:et={type:"dataTransferItem",id:qe.options.contents._itemId}),ze.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:et},metadata:qe.metadata})}else qe._type===2?ze.edits.push({resource:qe.uri,textEdit:Ie.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?ze.edits.push({resource:qe.uri,textEdit:{range:b.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?ze.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&ze.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(bt.from)}})}return ze}Ce.from=Le;function $e(H){const Me=new s.$EK,ze=new $.$zc;for(const Qe of H.edits)if(Qe.textEdit){const qe=Qe,et=v.URI.revive(qe.resource),Et=b.to(qe.textEdit.range),Dt=qe.textEdit.text,gt=qe.textEdit.insertAsSnippet;let ht;gt?ht=s.$DK.replace(Et,new s.$FK(Dt)):ht=s.$BK.replace(Et,Dt);const ft=ze.get(et);ft?ft.push(ht):ze.set(et,[ht])}else Me.renameFile(v.URI.revive(Qe.oldResource),v.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of ze)Me.set(Qe,qe);return Me}Ce.to=$e})(de||(e.WorkspaceEdit=de={}));var be;(function(Ce){const Le=Object.create(null);Le[s.SymbolKind.File]=0,Le[s.SymbolKind.Module]=1,Le[s.SymbolKind.Namespace]=2,Le[s.SymbolKind.Package]=3,Le[s.SymbolKind.Class]=4,Le[s.SymbolKind.Method]=5,Le[s.SymbolKind.Property]=6,Le[s.SymbolKind.Field]=7,Le[s.SymbolKind.Constructor]=8,Le[s.SymbolKind.Enum]=9,Le[s.SymbolKind.Interface]=10,Le[s.SymbolKind.Function]=11,Le[s.SymbolKind.Variable]=12,Le[s.SymbolKind.Constant]=13,Le[s.SymbolKind.String]=14,Le[s.SymbolKind.Number]=15,Le[s.SymbolKind.Boolean]=16,Le[s.SymbolKind.Array]=17,Le[s.SymbolKind.Object]=18,Le[s.SymbolKind.Key]=19,Le[s.SymbolKind.Null]=20,Le[s.SymbolKind.EnumMember]=21,Le[s.SymbolKind.Struct]=22,Le[s.SymbolKind.Event]=23,Le[s.SymbolKind.Operator]=24,Le[s.SymbolKind.TypeParameter]=25;function $e(Me){return typeof Le[Me]=="number"?Le[Me]:6}Ce.from=$e;function H(Me){for(const ze in Le)if(Le[ze]===Me)return Number(ze);return s.SymbolKind.Property}Ce.to=H})(be||(e.SymbolKind=be={}));var oe;(function(Ce){function Le(H){switch(H){case s.SymbolTag.Deprecated:return 1}}Ce.from=Le;function $e(H){switch(H){case 1:return s.SymbolTag.Deprecated}}Ce.to=$e})(oe||(e.SymbolTag=oe={}));var ce;(function(Ce){function Le(H){return{name:H.name,kind:be.from(H.kind),tags:H.tags&&H.tags.map(oe.from),containerName:H.containerName,location:we.from(H.location)}}Ce.from=Le;function $e(H){const Me=new s.$LK(H.name,be.to(H.kind),H.containerName,we.to(H.location));return Me.tags=H.tags&&H.tags.map(oe.to),Me}Ce.to=$e})(ce||(e.WorkspaceSymbol=ce={}));var ve;(function(Ce){function Le(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:b.from(H.range),selectionRange:b.from(H.selectionRange),kind:be.from(H.kind),tags:H.tags?.map(oe.from)??[]};return H.children&&(Me.children=H.children.map(Le)),Me}Ce.from=Le;function $e(H){const Me=new s.$MK(H.name,H.detail,be.to(H.kind),b.to(H.range),b.to(H.selectionRange));return(0,E.$Kb)(H.tags)&&(Me.tags=H.tags.map(oe.to)),H.children&&(Me.children=H.children.map($e)),Me}Ce.to=$e})(ve||(e.DocumentSymbol=ve={}));var _;(function(Ce){function Le(H){const Me=new s.$QK(be.to(H.kind),H.name,H.detail||"",v.URI.revive(H.uri),b.to(H.range),b.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Le;function $e(H,Me,ze){if(Me=Me??H._sessionId,ze=ze??H._itemId,Me===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:ze,name:H.name,detail:H.detail,kind:be.from(H.kind),uri:H.uri,range:b.from(H.range),selectionRange:b.from(H.selectionRange),tags:H.tags?.map(oe.from)}}Ce.from=$e})(_||(e.CallHierarchyItem=_={}));var W;(function(Ce){function Le($e){return new s.$RK(_.to($e.from),$e.fromRanges.map(H=>b.to(H)))}Ce.to=Le})(W||(e.CallHierarchyIncomingCall=W={}));var ae;(function(Ce){function Le($e){return new s.$SK(_.to($e.to),$e.fromRanges.map(H=>b.to(H)))}Ce.to=Le})(ae||(e.CallHierarchyOutgoingCall=ae={}));var we;(function(Ce){function Le(H){return{range:H.range&&b.from(H.range),uri:H.uri}}Ce.from=Le;function $e(H){return new s.$GK(v.URI.revive(H.uri),b.to(H.range))}Ce.to=$e})(we||(e.location=we={}));var ne;(function(Ce){function Le(H){const Me=H,ze=H;return{originSelectionRange:Me.originSelectionRange?b.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:ze.uri,range:b.from(Me.targetRange?Me.targetRange:ze.range),targetSelectionRange:Me.targetSelectionRange?b.from(Me.targetSelectionRange):void 0}}Ce.from=Le;function $e(H){return{targetUri:v.URI.revive(H.uri),targetRange:b.to(H.range),targetSelectionRange:H.targetSelectionRange?b.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?b.to(H.originSelectionRange):void 0}}Ce.to=$e})(ne||(e.DefinitionLink=ne={}));var he;(function(Ce){function Le(H){return{range:b.from(H.range),contents:z.fromMany(H.contents)}}Ce.from=Le;function $e(H){return new s.$JK(H.contents.map(z.to),b.to(H.range))}Ce.to=$e})(he||(e.Hover=he={}));var le;(function(Ce){function Le(H){return{range:b.from(H.range),expression:H.expression}}Ce.from=Le;function $e(H){return new s.$CL(b.to(H.range),H.expression)}Ce.to=$e})(le||(e.EvaluatableExpression=le={}));var ye;(function(Ce){function Le(H){if(H instanceof s.$DL)return{type:"text",range:b.from(H.range),text:H.text};if(H instanceof s.$EL)return{type:"variable",range:b.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof s.$FL)return{type:"expression",range:b.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Le;function $e(H){switch(H.type){case"text":return{range:b.to(H.range),text:H.text};case"variable":return{range:b.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:b.to(H.range),expression:H.expression}}}Ce.to=$e})(ye||(e.InlineValue=ye={}));var ee;(function(Ce){function Le(H){return{frameId:H.frameId,stoppedLocation:b.from(H.stoppedLocation)}}Ce.from=Le;function $e(H){return new s.$GL(H.frameId,b.to(H.stoppedLocation))}Ce.to=$e})(ee||(e.InlineValueContext=ee={}));var fe;(function(Ce){function Le(H){return{range:b.from(H.range),kind:H.kind}}Ce.from=Le;function $e(H){return new s.$KK(b.to(H.range),H.kind)}Ce.to=$e})(fe||(e.DocumentHighlight=fe={}));var ie;(function(Ce){function Le($e){switch($e){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Le})(ie||(e.CompletionTriggerKind=ie={}));var se;(function(Ce){function Le($e){return{triggerKind:ie.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}Ce.to=Le})(se||(e.CompletionContext=se={}));var me;(function(Ce){function Le(H){switch(H){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Le;function $e(H){switch(H){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=$e})(me||(e.CompletionItemTag=me={}));var Pe;(function(Ce){const Le=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function $e(ze){return Le.get(ze)??9}Ce.from=$e;const H=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(ze){return H.get(ze)??s.CompletionItemKind.Property}Ce.to=Me})(Pe||(e.CompletionItemKind=Pe={}));var T;(function(Ce){function Le($e,H){const Me=new s.$1K($e.label);return Me.insertText=$e.insertText,Me.kind=Pe.to($e.kind),Me.tags=$e.tags?.map(me.to),Me.detail=$e.detail,Me.documentation=R.$6j($e.documentation)?z.to($e.documentation):$e.documentation,Me.sortText=$e.sortText,Me.filterText=$e.filterText,Me.preselect=$e.preselect,Me.commitCharacters=$e.commitCharacters,p.$us.isIRange($e.range)?Me.range=b.to($e.range):typeof $e.range=="object"&&(Me.range={inserting:b.to($e.range.insert),replacing:b.to($e.range.replace)}),Me.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&1),typeof $e.insertTextRules<"u"&&$e.insertTextRules&4?Me.insertText=new s.$FK($e.insertText):(Me.insertText=$e.insertText,Me.textEdit=Me.range instanceof s.$wK?new s.$BK(Me.range,Me.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Me.additionalTextEdits=$e.additionalTextEdits.map(ze=>Ie.to(ze))),Me.command=H&&$e.command?H.fromInternal($e.command):void 0,Me}Ce.to=Le})(T||(e.CompletionItem=T={}));var q;(function(Ce){function Le(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:z.fromStrict(H.documentation)}}Ce.from=Le;function $e(H){return{label:H.label,documentation:R.$6j(H.documentation)?z.to(H.documentation):H.documentation}}Ce.to=$e})(q||(e.ParameterInformation=q={}));var G;(function(Ce){function Le(H){return{label:H.label,documentation:z.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(q.from):[],activeParameter:H.activeParameter}}Ce.from=Le;function $e(H){return{label:H.label,documentation:R.$6j(H.documentation)?z.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(q.to):[],activeParameter:H.activeParameter}}Ce.to=$e})(G||(e.SignatureInformation=G={}));var Q;(function(Ce){function Le(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.from):[]}}Ce.from=Le;function $e(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.to):[]}}Ce.to=$e})(Q||(e.SignatureHelp=Q={}));var K;(function(Ce){function Le($e,H){const Me=new s.$ZK(I.to(H.position),typeof H.label=="string"?H.label:H.label.map(Y.to.bind(void 0,$e)),H.kind&&ue.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(Ie.to),Me.tooltip=R.$6j(H.tooltip)?z.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ce.to=Le})(K||(e.InlayHint=K={}));var Y;(function(Ce){function Le($e,H){const Me=new s.$YK(H.label);return Me.tooltip=R.$6j(H.tooltip)?z.to(H.tooltip):H.tooltip,f.Command.is(H.command)&&(Me.command=$e.fromInternal(H.command)),H.location&&(Me.location=we.to(H.location)),Me}Ce.to=Le})(Y||(e.InlayHintLabelPart=Y={}));var ue;(function(Ce){function Le(H){return H}Ce.from=Le;function $e(H){return H}Ce.to=$e})(ue||(e.InlayHintKind=ue={}));var Ne;(function(Ce){function Le(H){return{range:b.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Le;function $e(H){let Me;if(H.url)try{Me=typeof H.url=="string"?v.URI.parse(H.url,!0):v.URI.revive(H.url)}catch{}return new s.$6K(b.to(H.range),Me)}Ce.to=$e})(Ne||(e.DocumentLink=Ne={}));var Be;(function(Ce){function Le(H){const Me=new s.$9K(H.label);return H.textEdit&&(Me.textEdit=Ie.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(ze=>Ie.to(ze))),Me}Ce.to=Le;function $e(H){return{label:H.label,textEdit:H.textEdit?Ie.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>Ie.from(Me)):void 0}}Ce.from=$e})(Be||(e.ColorPresentation=Be={}));var Je;(function(Ce){function Le(H){return new s.$7K(H[0],H[1],H[2],H[3])}Ce.to=Le;function $e(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=$e})(Je||(e.Color=Je={}));var Ge;(function(Ce){function Le(H){return{range:b.from(H.range)}}Ce.from=Le;function $e(H){return new s.$PK(b.to(H.range))}Ce.to=$e})(Ge||(e.SelectionRange=Ge={}));var _e;(function(Ce){function Le($e){switch($e){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Le})(_e||(e.TextDocumentSaveReason=_e={}));var Ye;(function(Ce){function Le(H){switch(H){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Le;function $e(H){switch(H){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=$e})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var xe;(function(Ce){function Le(H){if(H===s.EndOfLine.CRLF)return 1;if(H===s.EndOfLine.LF)return 0}Ce.from=Le;function $e(H){if(H===1)return s.EndOfLine.CRLF;if(H===0)return s.EndOfLine.LF}Ce.to=$e})(xe||(e.EndOfLine=xe={}));var it;(function(Ce){function Le($e){if(typeof $e=="object")return $e.viewId;switch($e){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Le})(it||(e.ProgressLocation=it={}));var tt;(function(Ce){function Le(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=Ue.from(H.kind)),Me}Ce.from=Le;function $e(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=Ue.to(H.kind)),Me}Ce.to=$e})(tt||(e.FoldingRange=tt={}));var Ue;(function(Ce){function Le(H){if(H)switch(H){case s.FoldingRangeKind.Comment:return f.$jt.Comment;case s.FoldingRangeKind.Imports:return f.$jt.Imports;case s.FoldingRangeKind.Region:return f.$jt.Region}}Ce.from=Le;function $e(H){if(H)switch(H.value){case f.$jt.Comment.value:return s.FoldingRangeKind.Comment;case f.$jt.Imports.value:return s.FoldingRangeKind.Imports;case f.$jt.Region.value:return s.FoldingRangeKind.Region}}Ce.to=$e})(Ue||(e.FoldingRangeKind=Ue={}));var ut;(function(Ce){function Le($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?b.from($e.selection):void 0,override:typeof $e.override=="boolean"?n.$8D.id:void 0}}Ce.from=Le})(ut||(e.TextEditorOpenOptions=ut={}));var X;(function(Ce){function Le(ze){return ze instanceof s.$qL?ze.toJSON():typeof ze=="string"?ze:$e(ze)||H(ze)?new s.$qL(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Ce.from=Le;function $e(ze){const Qe=ze;return Qe?v.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function H(ze){const Qe=ze;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Me(ze){return typeof ze=="string"?ze:new s.$qL(v.URI.revive(ze.baseUri),ze.pattern)}Ce.to=Me})(X||(e.GlobPattern=X={}));var J;(function(Ce){function Le($e){if($e){if(Array.isArray($e))return $e.map(Le);if(typeof $e=="string")return $e;{const H=$e;return{language:H.language,scheme:H.scheme,pattern:X.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Le})(J||(e.LanguageSelector=J={}));var Ee;(function(Ce){function Le(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Me=>Array.isArray(Me)&&Me.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&v.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(Qe=>Qe instanceof s.$wK)))}Ce.is=Le;function $e(H){return{documents:H.documents.map(Me=>Me.map(ze=>({uri:v.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(Qe=>b.from(Qe))})))}}Ce.from=$e})(Ee||(e.MappedEditsContext=Ee={}));var je;(function(Ce){function Le(H){return{start:H.start,end:H.end}}Ce.from=Le;function $e(H){return new s.$RL(H.start,H.end)}Ce.to=$e})(je||(e.NotebookRange=je={}));var Oe;(function(Ce){function Le(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Le;function $e(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=$e})(Oe||(e.NotebookCellExecutionSummary=Oe={}));var Ze;(function(Ce){function Le($e){if($e===u.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if($e===u.NotebookCellExecutionState.Pending)return;if($e===u.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}Ce.to=Le})(Ze||(e.NotebookCellExecutionState=Ze={}));var nt;(function(Ce){function Le(H){switch(H){case s.NotebookCellKind.Markup:return u.CellKind.Markup;case s.NotebookCellKind.Code:default:return u.CellKind.Code}}Ce.from=Le;function $e(H){switch(H){case u.CellKind.Markup:return s.NotebookCellKind.Markup;case u.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=$e})(nt||(e.NotebookCellKind=nt={}));var $t;(function(Ce){function Le(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const ze of H.cells)s.$SL.validate(ze),Me.cells.push(bt.from(ze));return Me}Ce.from=Le;function $e(H){const Me=new s.$TL(H.cells.map(bt.to));return(0,o.$Lf)(H.metadata)||(Me.metadata=H.metadata),Me}Ce.to=$e})($t||(e.NotebookData=$t={}));var bt;(function(Ce){function Le(H){return{cellKind:nt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Oe.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Kt.from):[]}}Ce.from=Le;function $e(H){return new s.$SL(nt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Kt.to):void 0,H.metadata,H.internalMetadata?Oe.to(H.internalMetadata):void 0)}Ce.to=$e})(bt||(e.NotebookCellData=bt={}));var Pt;(function(Ce){function Le(H){return{mime:H.mime,valueBytes:L.$be.wrap(H.data)}}Ce.from=Le;function $e(H){return new s.$UL(H.valueBytes.buffer,H.mime)}Ce.to=$e})(Pt||(e.NotebookCellOutputItem=Pt={}));var Kt;(function(Ce){function Le(H){return{outputId:H.id,items:H.items.map(Pt.from),metadata:H.metadata}}Ce.from=Le;function $e(H){const Me=H.items.map(Pt.to);return new s.$VL(Me,H.outputId,H.metadata)}Ce.to=$e})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ce){function Le(Me){return H(Me)?{include:X.from(Me.include)??void 0,exclude:X.from(Me.exclude)??void 0}:X.from(Me)??void 0}Ce.from=Le;function $e(Me){return H(Me)?{include:X.to(Me.include),exclude:X.to(Me.exclude)}:X.to(Me)}Ce.to=$e;function H(Me){const ze=Me;return ze?!(0,o.$Hf)(ze.include)&&!(0,o.$Hf)(ze.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var vt;(function(Ce){function Le($e,H,Me){const ze=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(ze,Me),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}Ce.from=Le})(vt||(e.NotebookStatusBarItem=vt={}));var zt;(function(Ce){function Le($e,H,Me){const ze=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:H.toInternal(ze,Me),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}Ce.from=Le})(zt||(e.NotebookKernelSourceAction=zt={}));var Nt;(function(Ce){function Le($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}Ce.from=Le})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Gt;(function(Ce){function Le(H){return{uri:H.uri,provides:H.provides}}Ce.from=Le;function $e(H){return new s.$XL(v.URI.revive(H.uri),H.provides)}Ce.to=$e})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Ce){function Le(H){return{message:z.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:b.from(H.location.range),uri:H.location.uri}}}Ce.from=Le;function $e(H){const Me=new s.$4L(typeof H.message=="string"?H.message:z.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?we.to(H.location):void 0,Me}Ce.to=$e})(Bt||(e.TestMessage=Bt={}));var kt;(function(Ce){Ce.namespace=l.$mJ,Ce.denamespace=l.$nJ})(kt||(e.TestTag=kt={}));var Ft;(function(Ce){function Le(H){const Me=(0,i.$qM)(H).controllerId;return{extId:a.$iJ.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:v.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(ze=>kt.namespace(Me,ze.id)),range:p.$us.lift(b.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&z.fromStrict(H.error)||null}}Ce.from=Le;function $e(H){return{parent:void 0,error:void 0,id:a.$iJ.fromString(H.extId).localId,label:H.label,uri:v.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:ze}=kt.denamespace(Me);return new s.$5L(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=$e})(Ft||(e.TestItem=Ft={})),function(Ce){function Le(H){return{id:H.id}}Ce.from=Le;function $e(H){return new s.$5L(H.id)}Ce.to=$e}(kt||(e.TestTag=kt={}));var jt;(function(Ce){const Le=(H,Me)=>{const ze=[];for(const[qe,et]of Me)a.$iJ.compare(et.item.extId,qe)===2&&(Me.delete(qe),ze.push(et));const Qe={...Ft.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(Bt.to)})),children:ze.map(qe=>Le(qe,Me))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function $e(H){const Me=[],ze=new Map;for(const Qe of H.items){ze.set(Qe.item.extId,Qe);const qe=a.$iJ.root(Qe.item.extId);H.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Qe.item.extId))&&Me.push(Qe)}return{completedAt:H.completedAt,results:Me.map(Qe=>Le(Qe,ze))}}Ce.to=$e})(jt||(e.TestResults=jt={}));var Qt;(function(Ce){function Le(ze){return{covered:ze.covered,total:ze.covered}}function $e(ze){return"line"in ze?I.from(ze):b.from(ze)}function H(ze){return"branches"in ze?{count:ze.executionCount,location:$e(ze.location),type:1,branches:ze.branches.length?ze.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&$e(Qe.location)})):void 0}:{type:0,count:ze.executionCount,location:$e(ze.location)}}Ce.fromDetailed=H;function Me(ze){return{uri:ze.uri,statement:Le(ze.statementCoverage),branch:ze.branchCoverage&&Le(ze.branchCoverage),function:ze.functionCoverage&&Le(ze.functionCoverage),details:ze.detailedCoverage?.map(H)}}Ce.fromFile=Me})(Qt||(e.TestCoverage=Qt={}));var Wt;(function(Ce){function Le($e){switch($e){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Le})(Wt||(e.CodeActionTriggerKind=Wt={}));var Vt;(function(Ce){function Le(H){const Me=new s.$$L(be.to(H.kind),H.name,H.detail||"",v.URI.revive(H.uri),b.to(H.range),b.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Le;function $e(H,Me,ze){if(Me=Me??H._sessionId,ze=ze??H._itemId,Me===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:ze,kind:be.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:b.from(H.range),selectionRange:b.from(H.selectionRange),tags:H.tags?.map(oe.from)}}Ce.from=$e})(Vt||(e.TypeHierarchyItem=Vt={}));var Ot;(function(Ce){function Le($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}Ce.from=Le})(Ot||(e.ViewBadge=Ot={}));var at;(function(Ce){function Le(ze,Qe,qe){const et=Qe.fileData;return et?new s.$jL(new s.$kL(et.name,v.URI.revive(et.uri),et.id,(0,M.$cb)(()=>qe(et.id)))):ze===A.$Qr.uriList&&Qe.uriListData?new s.$iL(Me(Qe.uriListData)):new s.$iL(Qe.asString)}Ce.to=Le;async function $e(ze,Qe){const qe=await Qe.asString();if(ze===A.$Qr.uriList)return{asString:qe,fileData:void 0,uriListData:H(qe)};const et=Qe.asFile();return{asString:qe,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=$e;function H(ze){return P.$4s.split(ze).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return v.URI.parse(Qe)}catch{}return Qe})}function Me(ze){return P.$4s.create(ze.map(Qe=>typeof Qe=="string"?Qe:v.URI.revive(Qe)))}})(at||(e.DataTransferItem=at={}));var dt;(function(Ce){function Le(H,Me){const ze=H.items.map(([Qe,qe])=>[Qe,at.to(Qe,qe,Me)]);return new s.$lL(ze)}Ce.toDataTransfer=Le;async function $e(H){const Me={items:[]},ze=[];for(const[Qe,qe]of H)ze.push((async()=>{Me.items.push([Qe,await at.from(Qe,qe)])})());return await Promise.all(ze),Me}Ce.from=$e})(dt||(e.DataTransfer=dt={}));var At;(function(Ce){function Le(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Le;function $e(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=$e})(At||(e.ChatReplyFollowup=At={}));var qt;(function(Ce){function Le($e){return typeof $e=="string"?{title:$e,message:$e,kind:"reply"}:"commandId"in $e?{kind:"command",title:$e.title??"",commandId:$e.commandId??"",when:$e.when??"",args:$e.args}:At.from($e)}Ce.from=Le})(qt||(e.ChatFollowup=qt={}));var Rt;(function(Ce){function Le(H){const Me=new s.$jM(ot.to(H.role),H.content);return Me.name=H.name,Me}Ce.to=Le;function $e(H){return{role:ot.from(H.role),content:H.content,name:H.name}}Ce.from=$e})(Rt||(e.ChatMessage=Rt={}));var ot;(function(Ce){function Le(H){switch(H){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Le;function $e(H){switch(H){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=$e})(ot||(e.ChatMessageRole=ot={}));var wt;(function(Ce){function Le(Me){const ze={};for(const Qe of Object.keys(Me))ze[Qe]=Me[Qe].map(Ce.to);return ze}Ce.objectTo=Le;function $e(Me){return{level:Tt.to(Me.level),value:Me.value,description:Me.description}}Ce.to=$e;function H(Me){return{level:Tt.from(Me.level),value:Me.value,description:Me.description}}Ce.from=H})(wt||(e.ChatVariable=wt={}));var Tt;(function(Ce){function Le(H){switch(H){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Le;function $e(H){switch(H){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=$e})(Tt||(e.ChatVariableLevel=Tt={}));var Ct;(function(Ce){function Le($e){switch($e){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Le})(Ct||(e.InteractiveEditorResponseFeedbackKind=Ct={}));var We;(function(Ce){function Le($e,H){return"placeholder"in H&&"resolvedContent"in H?{placeholder:H.placeholder}:"responseId"in H?{requestId:H.responseId}:"markdownContent"in H?((0,c.$sF)($e,"chatAgents2Additions"),{content:z.from(H.markdownContent)}):"content"in H?typeof H.content=="string"?H:((0,c.$sF)($e,"chatAgents2Additions"),{content:z.from(H.content)}):"documents"in H?{documents:H.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(ze=>b.from(ze))}))}:"reference"in H?{reference:"uri"in H.reference?{uri:H.reference.uri,range:b.from(H.reference.range)}:H.reference}:"inlineReference"in H?{inlineReference:"uri"in H.inlineReference?{uri:H.inlineReference.uri,range:b.from(H.inlineReference.range)}:H.inlineReference,title:H.title}:("agentName"in H&&(0,c.$sF)($e,"chatAgents2Additions"),H)}Ce.from=Le})(We||(e.ChatResponseProgress=We={}));var Jt;(function(Ce){function Le($e,H,Me){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand}:"uri"in $e?{uri:$e.uri}:H.toInternal($e,Me)}Ce.from=Le})(Jt||(e.TerminalQuickFix=Jt={}))}),define(Ae[221],Re([1,0,2,11,7,8,187]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class ${constructor(g,A,S,o={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=S,this.g=o,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,S,o)=>{const p={dispose:this.a.push([A,S,g])};return Array.isArray(o)&&o.push(p),p}}async $participateInSave(g,A){const S=E.URI.revive(g);let o=!1;const v=setTimeout(()=>o=!0,this.g.timeout),p=[];try{for(const f of[...this.a]){if(o)break;const t=this.d.getDocument(S),i=await this.h(f,{document:t,reason:M.TextDocumentSaveReason.to(A)});p.push(i)}}finally{clearTimeout(v)}return p}h([g,A,S],o){const v=this.b.get(g);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(S,g,A,o).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,S,o){const v=[],p=Date.now(),{document:f,reason:t}=o,{version:i}=f,n=Object.freeze({document:f,reason:t,waitUntil(u){if(Object.isFrozen(v))throw(0,L.$7)("waitUntil can not be called async");v.push(Promise.resolve(u))}});try{A.apply(S,[n])}catch(u){return Promise.reject(u)}return Object.freeze(v),new Promise((u,a)=>{const l=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(v).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(l),u(r)}).catch(r=>{clearTimeout(l),a(r)})}).then(u=>{const a={edits:[]};for(const l of u)if(Array.isArray(l)&&l.every(r=>r instanceof P.$BK))for(const{newText:r,newEol:s,range:c}of l)a.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:c&&M.Range.from(c),text:r,eol:s&&M.EndOfLine.from(s)}});if(a.edits.length!==0)return i===f.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$_cc=$}),define(Ae[222],Re([1,0,14,2,8,7,76]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=e.$mec=void 0;class ${constructor(S,o,v,p){this.start=S,this.deletedCount=o,this.deletedItems=v,this.items=p}asApiEvent(){return{range:new M.$RL(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(S,o){return{EOL:o.eol,lines:o.source,languageId:o.language,uri:o.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,o,v){this.notebook=S,this.h=o,this.j=v,this.handle=v.handle,this.uri=L.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(P.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,o=this.h.getDocument(this.uri);if(!o)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:o.document,get mime(){return S.g},set mime(p){S.g=p},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(v)}return this.f}setOutputs(S){this.a=S.map(P.NotebookCellOutput.to)}setOutputItems(S,o,v){const p=v.map(P.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===S);if(f&&(o||(f.items.length=0),f.items.push(...p),f.items.length>1&&f.items.every(t=>R.$xI(t.mime)))){const t=new Map,i=[];f.items.forEach(n=>{let u;t.has(n.mime)?u=t.get(n.mime):(u=[],t.set(n.mime,u),i.push(n.mime)),u.push(n.data)}),f.items.length=0,i.forEach(n=>{const u=R.$yI(t.get(n));f.items.push({mime:n,data:u.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$mec=D;class g{static{this.a=0}constructor(S,o,v,p,f){this.k=S,this.l=o,this.m=v,this.uri=p,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,o={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(v){return v=S.n(v),S.b[v].apiCell},getCells(v){return(v?S.p(v):S.b).map(f=>f.apiCell)},save(){return S.q()}};this.e=Object.freeze(o)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,o,v){this.g=S.versionId,this.h=o,this.acceptDocumentPropertiesChanged({metadata:v});const p={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},f=[];for(const i of S.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),f.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),f.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const n=f[i],u=t.get(n.cell);if(u===void 0){const a=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});t.set(n.cell,a-1)}else p.cellChanges[u]={...p.cellChanges[u],...n}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let o=S.start|0,v=S.end|0;return o<0&&(o=0),v>this.b.length&&(v=this.b.length),S.with({start:o,end:v})}p(S){S=this.o(S);const o=[];for(let v=S.start;v<S.end;v++)o.push(this.b[v]);return o}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,o,v){if(this.j)return;const p=[],f=[],t=[];if(S.reverse().forEach(i=>{const u=i[2].map(r=>{const s=new D(this,this.l,r);return o||f.push(D.asModelAddData(this.apiNotebook,r)),s}),a=new $(i[0],i[1],[],u),l=this.b.splice(i[0],i[1],...u);for(const r of l)t.push(r.uri),a.deletedItems.push(r.apiCell);p.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),v)for(const i of p)v.push(i.asApiEvent())}s(S,o,v,p){const f=this.b.splice(S,o);this.b.splice(v,0,...f);const t=[new $(S,o,f.map(i=>i.apiCell),[]),new $(v,0,[],f)];for(const i of t)p.push(i.asApiEvent())}t(S,o){this.b[S].setOutputs(o)}u(S,o,v,p){this.b[S].setOutputItems(o,v,p)}v(S,o){const v=this.b[S];v.apiCell.document.languageId!==o&&this.m.$acceptModelLanguageChanged(v.uri,o)}w(S,o){const v=this.b[S];v.apiCell.mime=o}x(S,o){this.b[S].setMetadata(o)}y(S,o){this.b[S].setInternalMetadata(o)}getCellFromApiCell(S){return this.b.find(o=>o.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(o=>o.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$nec=g}),define(Ae[223],Re([1,0,5,2,8,7]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class R{constructor(D,g,A,S={timeout:1500,errors:3}){this.b=D,this.c=g,this.d=A,this.f=S,this.a=new E.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,A,S)=>{const o=function(p){g.call(A,p)};return o.extension=D,this.a.event(o,void 0,S)}}async $participateInSave(D,g,A){const S=L.URI.revive(D),o=this.c.getNotebookDocument(S);if(!o)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:o.apiNotebook,reason:P.TextDocumentSaveReason.to(g)},A,async(f,t)=>{const i=Date.now(),n=await await Promise.resolve(f);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof M.$EK?v.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const p={edits:[]};for(const f of v){const{edits:t}=P.WorkspaceEdit.from(f);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$Nec=R}),define(Ae[107],Re([1,0,11,8,7]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,D,g,A,S,o){this.id=$,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=A,this.c=o}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(D){this.selections=[D]},get selections(){return $.a},set selections(D){if(!Array.isArray(D)||!D.every(P.$RL.isNotebookRange))throw(0,E.$6)("selections");$.a=D,$.g(D)},get visibleRanges(){return $.b},revealRange(D,g){$.f.$tryRevealRange($.id,L.NotebookRange.from(D),g??P.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(L.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$oec=M}),define(Ae[224],Re([1,0,11,5,15,8]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;let R=class{constructor(D,g){this.c=D,this.d=g,this.a=new L.$Nd({onListenerError:E.$1}),this.b=new L.$Nd({onListenerError:E.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const A=this.d.getEditorById(D);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(M.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(M.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(M.ViewColumn.to(D[g]))}};e.$Gec=R,e.$Gec=R=Ke([Ve(0,P.$$i)],R)}),define(Ae[225],Re([1,0,8,54,164,20,67,11]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class D{constructor(o){this.b=0,this.c=new Map,this.a=o}async withProgress(o,v,p){const f=this.b++,{title:t,location:i,cancellable:n}=v,u={label:(0,P.localize)(0,null,o.displayName||o.name),id:o.identifier.value};return this.a.$startProgress(f,{location:E.ProgressLocation.from(i),title:t,source:u,cancellable:n},o.isUnderDevelopment?void 0:o.identifier.value).catch($.$1),this.d(f,p,!!n)}d(o,v,p){let f;p&&(f=new M.$Xd,this.c.set(o,f));const t=n=>{this.a.$progressEnd(n),this.c.delete(n),f?.dispose()};let i;try{i=v(new A(this.a,o),p&&f?f.token:M.CancellationToken.None)}catch(n){throw t(o),n}return i.then(n=>t(o),n=>t(o)),i}$acceptProgressCanceled(o){const v=this.c.get(o);v&&(v.cancel(),this.c.delete(o))}}e.$Kdc=D;function g(S,o){return S.message=o.message,typeof o.increment=="number"&&(typeof S.increment=="number"?S.increment+=o.increment:S.increment=o.increment),S}class A extends L.$6u{constructor(o,v){super(p=>this.throttledReport(p)),this.c=o,this.d=v}throttledReport(o){this.c.$progressReport(this.d,o)}}Ke([(0,R.$kh)(100,(S,o)=>g(S,o),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ae[108],Re([1,0,29,104,48,77,60,8,2]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=e.$HM=e.$GM=void 0;const g=(u,a,l,r)=>{let s=a;return{enumerable:!0,configurable:!1,get(){return s},set(c){if(!l(s,c)){const h=s;s=c,u.listener?.(r(c,h))}}}},A=(u,a)=>u===a,S={range:(u,a)=>u===a?!0:!u||!a?!1:u.isEqual(a),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(u,a)=>!(u.length!==a.length||u.some(l=>!a.find(r=>l.id===r.id)))},o=u=>a=>({op:4,update:u(a)}),v=(u,a)=>({range:(()=>{let l;const r=o(s=>({range:E.$us.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return l},set(s){u.listener?.({op:6}),S.range(l,s)||(l=s,u.listener?.(r(s)))}}})(),label:g(u,a,S.label,o(l=>({label:l}))),description:g(u,void 0,S.description,o(l=>({description:l}))),sortText:g(u,void 0,S.sortText,o(l=>({sortText:l}))),canResolveChildren:g(u,!1,S.canResolveChildren,l=>({op:2,state:l})),busy:g(u,!1,S.busy,o(l=>({busy:l}))),error:g(u,void 0,S.error,o(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:g(u,[],S.tags,(l,r)=>({op:1,new:l.map($.TestTag.from),old:r.map($.TestTag.from)}))}),p=u=>{const a=P.$iJ.fromString(u.extId),l=new t(a.controllerId,a.localId,u.label,D.URI.revive(u.uri)||void 0);return l.range=$.Range.to(u.range||void 0),l.description=u.description||void 0,l.sortText=u.sortText||void 0,l.tags=u.tags.map(r=>$.TestTag.to({id:(0,R.$nJ)(r).tagId})),l},f=u=>{let a;for(const l of u.tests){const r=p(l.item);(0,L.$qM)(r).parent=a,a=r}return a};e.$GM=f;class t{constructor(a,l,r,s){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const c=(0,L.$pM)(this,a);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof i?void 0:c.parent}},children:{value:(0,M.$oM)(c,L.$qM,t),enumerable:!0,writable:!1},...v(c,r)})}}e.$HM=t;class i extends t{constructor(a,l){super(a,a,l,void 0),this._isRoot=!0}}e.$IM=i;class n extends M.$kM{constructor(a,l,r){super({controllerId:a,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:L.$qM,getChildren:s=>s.children,root:new i(a,l),toITestItem:$.TestItem.from})}}e.$JM=n}),define(Ae[109],Re([1,0,55,11,89,8,7]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=void 0;class ${static{this.c=new P.$zM("TextEditorDecorationType")}constructor(o,v,p){const f=$.c.nextId();o.$registerTextEditorDecorationType(v.identifier,f,M.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:f,dispose(){o.$removeTextEditorDecorationType(f)}})}}e.$BM=$;class D{constructor(o,v){this.g=[],this.h=void 0,this.j=!1,this.c=o,this.d=o.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(o,v){this.k();let p=null;if(o instanceof R.$vK)p=new R.$wK(o,o);else if(o instanceof R.$wK)p=o;else throw new Error("Unrecognized location");this.l(p,v,!1)}insert(o,v){this.k(),this.l(new R.$wK(o,o),v,!0)}delete(o){this.k();let v=null;if(o instanceof R.$wK)v=o;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(o,v,p){const f=this.c.validateRange(o);this.g.push({range:f,text:v,forceMoveMarkers:p})}setEndOfLine(o){if(this.k(),o!==R.EndOfLine.LF&&o!==R.EndOfLine.CRLF)throw(0,L.$6)("endOfLine");this.h=o}}class g{constructor(o,v,p,f){this.c=o,this.d=v,this._accept(p),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(o){this.f=o.tabSize,this.g=o.indentSize,this.h=o.insertSpaces,this.j=o.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(o.lineNumbers)}l(o){if(o==="auto")return"auto";if(typeof o=="number"){const v=Math.floor(o);return v>0?v:null}if(typeof o=="string"){const v=parseInt(o,10);return isNaN(v)?null:v>0?v:null}return null}m(o){const v=this.l(o);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(o){if(o==="tabSize")return"tabSize";if(typeof o=="number"){const v=Math.floor(o);return v>0?v:null}if(typeof o=="string"){const v=parseInt(o,10);return isNaN(v)?null:v>0?v:null}return null}o(o){const v=this.n(o);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(o){return o==="auto"?"auto":o==="false"?!1:!!o}q(o){const v=this.p(o);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(o){this.j!==o&&(this.j=o,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:o})))}t(o){this.k!==o&&(this.k=o,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(o)})))}assign(o){const v={};let p=!1;if(typeof o.tabSize<"u"){const f=this.l(o.tabSize);f==="auto"?(p=!0,v.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,p=!0,v.tabSize=f)}if(typeof o.indentSize<"u"){const f=this.n(o.indentSize);f==="tabSize"?(p=!0,v.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,p=!0,v.indentSize=f)}if(typeof o.insertSpaces<"u"){const f=this.p(o.insertSpaces);f==="auto"?(p=!0,v.insertSpaces=f):this.h!==f&&(this.h=f,p=!0,v.insertSpaces=f)}typeof o.cursorStyle<"u"&&this.j!==o.cursorStyle&&(this.j=o.cursorStyle,p=!0,v.cursorStyle=o.cursorStyle),typeof o.lineNumbers<"u"&&this.k!==o.lineNumbers&&(this.k=o.lineNumbers,p=!0,v.lineNumbers=M.TextEditorLineNumbersStyle.from(o.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(o,v){v.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${o}' failed:'`),this.e.warn(p)})}}e.$CM=g;class A{constructor(o,v,p,f,t,i,n,u){this.id=o,this.j=v,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,p),this.e=n,this.f=u;const a=this;this.value=Object.freeze({get document(){return f.value},set document(l){throw new L.$8("document")},get selection(){return a.c&&a.c[0]},set selection(l){if(!(l instanceof R.$xK))throw(0,L.$6)("selection");a.c=[l],a.l()},get selections(){return a.c},set selections(l){if(!Array.isArray(l)||l.some(r=>!(r instanceof R.$xK)))throw(0,L.$6)("selections");a.c=l,a.l()},get visibleRanges(){return a.e},set visibleRanges(l){throw new L.$8("visibleRanges")},get options(){return a.d.value},set options(l){a.g||a.d.assign(l)},get viewColumn(){return a.f},set viewColumn(l){throw new L.$8("viewColumn")},edit(l,r={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(f.value,r);return l(s),a.m(s)},insertSnippet(l,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!r||Array.isArray(r)&&r.length===0)c=a.c.map(h=>M.Range.from(h));else if(r instanceof R.$vK){const{lineNumber:h,column:b}=M.Position.from(r);c=[{startLineNumber:h,startColumn:b,endLineNumber:h,endColumn:b}]}else if(r instanceof R.$wK)c=[M.Range.from(r)];else{c=[];for(const h of r)if(h instanceof R.$wK)c.push(M.Range.from(h));else{const{lineNumber:b,column:m}=M.Position.from(h);c.push({startLineNumber:b,startColumn:m,endLineNumber:b,endColumn:m})}}return v.$tryInsertSnippet(o,f.value.version,l.value,c,s)},setDecorations(l,r){const s=r.length===0;s&&!a.h.has(l.key)||(s?a.h.delete(l.key):a.h.add(l.key),a.n(()=>{if(M.$rM(r))return v.$trySetDecorations(o,l.key,M.$sM(r));{const c=new Array(4*r.length);for(let h=0,b=r.length;h<b;h++){const m=r[h];c[4*h]=m.start.line+1,c[4*h+1]=m.start.character+1,c[4*h+2]=m.end.line+1,c[4*h+3]=m.end.character+1}return v.$trySetDecorationsFast(o,l.key,c)}}))},revealRange(l,r){a.n(()=>v.$tryRevealRange(o,M.Range.from(l),r||R.TextEditorRevealType.Default))},show(l){v.$tryShowEditor(o,M.ViewColumn.from(l))},hide(){v.$tryHideEditor(o)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(o){(0,E.ok)(!this.g),this.d._accept(o)}_acceptVisibleRanges(o){(0,E.ok)(!this.g),this.e=o}_acceptViewColumn(o){(0,E.ok)(!this.g),this.f=o}_acceptSelections(o){(0,E.ok)(!this.g),this.c=o}async l(){const o=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,o)),this.value}m(o){const v=o.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const p=v.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const n=p[t].end;if(p[t+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=v.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,f,{setEndOfLine:typeof v.setEndOfLine=="number"?M.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(o){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$DM=A}),define(Ae[226],Re([1,0,168,24,2,5,6,206,12,7,16,18,8,53,20,132,25]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;function i(a,l){if((0,A.$yf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let r;return Array.isArray(a.highlights)&&(r=a.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:a.label,highlights:r}}}class n extends R.$Rc{constructor(l,r,s){super(),this.f=l,this.g=r,this.h=s,this.a=new Map,this.b=new f.$f8;function c(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:h=>c(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(b=>c(b)?this.r(b):b):h})}registerTreeDataProvider(l,r,s){const c=this.createTreeView(l,{treeDataProvider:r},s);return{dispose:()=>c.dispose()}}createTreeView(l,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=r.dragAndDropController?.dropMimeTypes??[],h=r.dragAndDropController?.dragMimeTypes??[],b=!!r.dragAndDropController?.handleDrag,m=!!r.dragAndDropController?.handleDrop,I=this.m(l,r,s),k={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:c,dragMimeTypes:h,hasHandleDrag:b,hasHandleDrop:m,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(l,k),w={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$sF)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$sF)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(y){(0,v.$6j)(y)&&(0,t.$sF)(s,"treeViewMarkdownMessage"),I.message=y},get title(){return I.title},set title(y){I.title=y},get description(){return I.description},set description(y){I.description=y},get badge(){return I.badge},set badge(y){y!==void 0&&g.ViewBadge.isViewBadge(y)?I.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(I.badge=void 0)},reveal:(y,C)=>I.reveal(y,C),dispose:async()=>{await d,this.a.delete(l),I.dispose()}};return this.B(w),w}$getChildren(l,r){const s=this.a.get(l);return s?s.getChildren(r):Promise.reject(new $.$DE(l))}async $handleDrop(l,r,s,c,h,b,m,I){const k=this.a.get(l);if(!k)return Promise.reject(new $.$DE(l));const d=o.DataTransfer.toDataTransfer(s,async w=>(await this.f.$resolveDropFileData(l,r,w)).buffer);return m===l&&I&&await this.j(d,k,I,h,b),k.onDrop(d,c,h)}async j(l,r,s,c,h){const b=this.b.removeDragOperationTransfer(h);if(b)(await b)?.forEach((m,I)=>{m&&l.set(I,m)});else if(h&&r.handleDrag){const m=r.handleDrag(s,l,c);this.b.addDragOperationTransfer(h,m),await m}return l}async $handleDrag(l,r,s,c){const h=this.a.get(l);if(!h)return Promise.reject(new $.$DE(l));const b=await this.j(new g.$lL,h,r,c,s);if(!(!b||c.isCancellationRequested))return o.DataTransfer.from(b)}async $hasResolve(l){const r=this.a.get(l);if(!r)throw new $.$DE(l);return r.hasResolve}$resolve(l,r,s){const c=this.a.get(l);if(!c)throw new $.$DE(l);return c.resolveTreeItem(r,s)}$setExpanded(l,r,s){const c=this.a.get(l);if(!c)throw new $.$DE(l);c.setExpanded(r,s)}$setSelectionAndFocus(l,r,s){const c=this.a.get(l);if(!c)throw new $.$DE(l);c.setSelectionAndFocus(r,s)}$setVisible(l,r){const s=this.a.get(l);if(!s){if(!r)return;throw new $.$DE(l)}s.setVisible(r)}$changeCheckboxState(l,r){const s=this.a.get(l);if(!s)throw new $.$DE(l);s.setCheckboxState(r)}m(l,r,s){const c=this.B(new u(l,r,this.f,this.g.converter,this.h,s));return this.a.set(l,c),c}r(l){const r=this.a.get(l.$treeViewId);return r&&"$treeItemHandle"in l?r.getExtensionElement(l.$treeItemHandle):r&&"$focusedTreeItem"in l&&l.$focusedTreeItem?r.focusedElement:null}}e.$Rdc=n;class u extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.$Hf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,r,s,c,h,b){if(super(),this.I=l,this.J=s,this.L=c,this.M=h,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$Xd,b.contributes&&b.contributes.views)for(const d in b.contributes.views)for(const w of b.contributes.views[d])w.id===l&&(this.P=w.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.F.fire({message:!1,element:d})));let m,I;const k=M.Event.debounce(this.F.event,(d,w)=>(d||(d={message:!1,elements:[]}),w.element!==!1&&(m||(m=new Promise(y=>I=y),this.G=this.G.then(()=>m)),Array.isArray(w.element)?d.elements.push(...w.element):d.elements.push(w.element)),w.message&&(d.message=!0),d),200,!0);this.B(k(({message:d,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const y=I;return m=null,this.$(w).then(()=>y())})),d&&this.J.$setMessage(this.I,o.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const r=l?this.getExtensionElement(l):void 0;if(l&&!r)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.X(l);return s||(s=await this.Y(r)),s?s.map(c=>c.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,r){r=r||{select:!0,focus:!1};const s=(0,A.$Hf)(r.select)?!0:r.select,c=(0,A.$Hf)(r.focus)?!1:r.focus,h=(0,A.$Hf)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(b=>this.W(l,b[b.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:b.map(I=>I.item)},{select:s,focus:c,expand:h})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:s,focus:c,expand:h})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=o.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,r){const s=this.getExtensionElement(l);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(l,r){const s=!(0,S.$tb)(this.s,l);this.s=l;const c=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const r=(await Promise.all(l.map(async s=>{const c=this.getExtensionElement(s.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(l,r,s){const c=[];for(const h of l){const b=this.getExtensionElement(h);b&&c.push(b)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,r,s){const c=r?this.getExtensionElement(r):void 0;if(!(!c&&r||!this.g?.handleDrop))return(0,D.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(c,l,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,r){if(!this.f.resolveTreeItem)return;const s=this.j.get(l);if(s){const c=this.m.get(s);if(c){const h=await this.f.resolveTreeItem(c.extensionItem,s,r)??c.extensionItem;return this.hb(h),c.item.tooltip=this.eb(h.tooltip),c.item.command=this.fb(c.disposableStore,h.command),c.item}}}S(l){return this.U(l).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(c=>(s.push(c),s))):Promise.resolve([]))}U(l){const r=this.m.get(l);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,D.$Mg)(()=>this.f.getParent(l))}W(l,r){const s=this.m.get(l);return s?Promise.resolve(s):(0,D.$Mg)(()=>this.f.getTreeItem(l)).then(c=>this.kb(l,c,r,!0)).then(c=>this.getChildren(r?r.item.handle:void 0).then(()=>{const h=this.getExtensionElement(c);if(h){const b=this.m.get(h);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let r;if(typeof l=="string"){const s=this.getExtensionElement(l);r=s?this.m.get(s):void 0}else r=l;return r&&r.children||void 0}return this.h}async Y(l){this.rb(l);const r=new p.$Xd(this.Z.token);try{const s=l?this.m.get(l):void 0,c=await this.f.getChildren(l);if(r.token.isCancellationRequested)return;const h=await Promise.all((0,S.$Gb)(c||[]).map(async b=>{const m=await this.f.getTreeItem(b);return m&&!r.token.isCancellationRequested?this.db(b,m,s):null}));return r.token.isCancellationRequested?void 0:(0,S.$Gb)(h)}finally{r.dispose()}}$(l){if(l.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$Xd,this.tb(),this.J.$refresh(this.I);{const s=this.ab(l);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(l){const r=new Set,s=l.map(h=>this.m.get(h));for(const h of s)if(h&&!r.has(h.item.handle)){let b=h;for(;b&&b.parent&&s.findIndex(m=>b&&b.parent&&m&&m.item.handle===b.parent.item.handle)===-1;){const m=this.j.get(b.parent.item.handle);b=m?this.m.get(m):void 0}b&&!b.parent&&r.add(h.item.handle)}const c=[];return r.forEach(h=>{const b=this.j.get(h);if(b){const m=this.m.get(b);m&&(!m.parent||!r.has(m.parent.item.handle))&&c.push(h)}}),c}bb(l){const r={};return Promise.all(l.map(s=>this.cb(s).then(c=>{c&&(r[s]=c.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(l){const r=this.getExtensionElement(l);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,D.$Mg)(()=>this.f.getTreeItem(r)).then(c=>{if(c){const h=this.ib(r,c,s.parent);return this.pb(r,h,s,s.parent),s.dispose(),h}return null})}return Promise.resolve(null)}db(l,r,s){const c=this.ib(l,r,s);if(r.id&&this.j.has(c.item.handle))throw new Error((0,E.localize)(0,null,r.id));return this.ob(l,c),this.qb(c,s),c}eb(l){return g.$UK.isMarkdownString(l)?o.MarkdownString.from(l):l}fb(l,r){return r?{...this.L.toInternal(r,l),originalId:r.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let r,s,c;return typeof l.checkboxState=="number"?r=l.checkboxState:(r=l.checkboxState.state,s=l.checkboxState.tooltip,c=l.checkboxState.accessibilityInformation),{isChecked:r===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:c}}hb(l){if(!g.$gL.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,r,s){this.hb(r);const c=this.B(new R.$Qc),h=this.kb(l,r,s),b=this.lb(r);return{item:{handle:h,parentHandle:s?s.item.handle:void 0,label:i(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(c,r.command),contextValue:r.contextValue,icon:b,iconDark:this.mb(r)||b,themeIcon:this.jb(r),collapsibleState:(0,A.$Hf)(r.collapsibleState)?g.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(l){return l.iconPath instanceof g.$oL?l.iconPath:void 0}kb(l,{id:r,label:s,resourceUri:c},h,b){if(r)return`${u.b}/${r}`;const m=i(s,this.N),I=h?h.item.handle:u.a;let k=m?m.label:c?(0,L.$sg)(c):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const d=this.m.has(l)?this.m.get(l).item.handle:void 0,w=this.X(h)||[];let y,C=0;do{if(y=`${I}/${C}:${k}`,b||!this.j.has(y)||d===y)break;C++}while(C<=w.length);return y}lb(l){if(l.iconPath&&!(l.iconPath instanceof g.$oL))return typeof l.iconPath=="string"||P.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof g.$oL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return P.URI.isUri(l)?l:P.URI.file(l)}ob(l,r){this.j.set(r.item.handle,l),this.m.set(l,r)}pb(l,r,s,c){this.j.delete(r.item.handle),this.m.delete(l),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(l,r);const h=this.X(c)||[],b=h.filter(m=>m.item.handle===s.item.handle)[0];b&&h.splice(h.indexOf(b),1,r)}qb(l,r){r?(r.children||(r.children=[]),r.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const r=this.m.get(l);if(r){if(r.children)for(const s of r.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}r.children=void 0}}else this.tb()}sb(l){const r=this.m.get(l);if(r){if(r.children)for(const s of r.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}this.m.delete(l),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[227],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[228],Re([1,0,180,11,31,96,73,30,22,227,190,101]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=void 0;const o=$.$hn.as(R.$in.JSONContribution);class v{constructor(l,r,s){this.a=l,this.b=r,this.c=s}d(l,r){this.a({type:l,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(P.default.Error,l)}warn(l){this.d(P.default.Warning,l)}info(l){this.d(P.default.Info,l)}}e.$gF=v;class p{static a(l){const r=new D.$8l;for(let s=0,c=l.length;s<c;s++)r.add(l[s].description.identifier);return r}static compute(l,r){if(!l||!l.length)return new p(r,[]);if(!r||!r.length)return new p([],l);const s=this.a(l),c=this.a(r),h=r.filter(m=>!s.has(m.description.identifier)),b=l.filter(m=>!c.has(m.description.identifier));return new p(h,b)}constructor(l,r){this.added=l,this.removed=r}}e.$hF=p;class f{constructor(l,r){this.name=l,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=p.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,L.$Z)(l)}}}e.$iF=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$jF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$6l},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"*",description:E.localize(42,null),body:"*"}]}},badges:{type:"array",description:E.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(44,null)},href:{type:"string",description:E.localize(45,null)},description:{type:"string",description:E.localize(46,null)}}}},markdown:{type:"string",description:E.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Yn}},extensionPack:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$Yn}},extensionKind:{description:E.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(52,null)},{body:["workspace"],description:E.localize(53,null)},{body:["ui","workspace"],description:E.localize(54,null)},{body:["workspace","ui"],description:E.localize(55,null)},{body:[],description:E.localize(56,null)}]},capabilities:{description:E.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(60,null),E.localize(61,null),E.localize(62,null)]},description:{type:"string",markdownDescription:E.localize(63,null)}}},untrustedWorkspaces:{description:E.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(66,null),E.localize(67,null),E.localize(68,null)]},restrictedConfigurations:{description:E.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(70,null)}}}}},sponsor:{description:E.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(73,null),type:"string"},"vscode:uninstall":{description:E.localize(74,null),type:"string"}}},icon:{type:"string",description:E.localize(75,null)},l10n:{type:"string",description:E.localize(76,null)},pricing:{type:"string",markdownDescription:E.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const r=new f(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,r),l.activationEventsGenerator&&S.$0E.register(l.extensionPoint,l.activationEventsGenerator),e.$jF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,o.registerSchema(i,e.$jF),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$kF=n;const u={ExtensionsRegistry:"ExtensionsRegistry"};$.$hn.add(u.ExtensionsRegistry,new n),e.$lF=$.$hn.as(u.ExtensionsRegistry),o.registerSchema(i,e.$jF),o.registerSchema(A.$rj,{properties:{extensionEnabledApiProposals:{description:E.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[229],Re([1,0,176,16,26,228,34,5]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3F=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var g;(function(o){function v(p,f,t){if(!p)return;const i=L.$yf(p.type)?p.type:void 0;if(!i||i.length===0){t.error(E.localize(3,null));return}const n=[];if(Array.isArray(p.required))for(const u of p.required)L.$yf(u)&&n.push(u);return{extensionId:f.value,taskType:i,required:n,properties:p.properties?P.$8m(p.properties):{},when:p.when?R.$Oi.deserialize(p.when):void 0}}o.from=v})(g||(g={}));const A=M.$lF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(o,v)=>{for(const p of o)p.type&&v.push(`onTaskType:${p.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:D}});class S{constructor(){this.d=new $.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,p)=>{A.setHandler((f,t)=>{this.c=void 0;try{for(const i of t.removed){const n=i.value;for(const u of n)this.a&&u.type&&this.a[u.type]&&delete this.a[u.type]}for(const i of t.added){const n=i.value;for(const u of n){const a=g.from(u,i.description.identifier,i.collector);a&&(this.a[a.taskType]=a)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const p of this.all()){const f={type:"object",additionalProperties:!1};p.required.length>0&&(f.required=p.required.slice(0)),p.properties!==void 0?f.properties=P.$8m(p.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[p.taskType]},v.push(f)}this.c={oneOf:v}}return this.c}}e.$3F=new S}),define(Ae[230],Re([1,0,177,16,24,26,34,229]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$aG=e.JsonSchemaVersion=e.ExecutionEngine=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$7F=e.ShellQuoting=e.$6F=e.$5F=e.$4F=void 0,e.$4F="settings",e.$5F=new R.$8i("taskRunning",!1,E.localize(0,null)),e.$6F={value:E.localize(1,null),original:"Tasks"};var D;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$7F="$customized",function(F){function O(x){if(!x)return F.Strong;switch(x.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=O}(D||(e.ShellQuoting=D={}));var g;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(A||(e.RevealKind=A={})),function(F){function O(x){switch(x.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=O}(A||(e.RevealKind=A={}));var S;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(F){function O(x){switch(x.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=O}(S||(e.RevealProblemKind=S={}));var o;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(o||(e.PanelKind=o={})),function(F){function O(x){switch(x.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=O}(o||(e.PanelKind=o={}));var v;(function(F){F.defaults={echo:!0,reveal:A.Always,revealProblems:S.Never,focus:!1,panel:o.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var p;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(F){function O(Z){switch(Z.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=O;function x(Z){switch(Z){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=x}(p||(e.RuntimeType=p={}));var f;(function(F){function O(x){return L.$yf(x)?x:x.value}F.value=O})(f||(e.CommandString=f={}));var t;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function O(Z){return Z===F.Clean._id||Z===F.Build._id||Z===F.Rebuild._id||Z===F.Test._id}F.is=O;function x(Z){if(Z!==void 0)return L.$yf(Z)?O(Z)?{_id:Z,isDefault:!1}:void 0:Z}F.from=x})(t||(e.TaskGroup=t={}));var i;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function O(x){switch(x){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=O})(n||(e.TaskSourceKind=n={}));var u;(function(F){F.parallel="parallel",F.sequence="sequence"})(u||(e.DependsOrder=u={}));var a;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var l;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class r{constructor(O,x,Z,De,ke,Ie){this._label="",this._id=O,x&&(this._label=x),Z&&(this.type=Z),this.runOptions=De,this.configurationProperties=ke,this._source=Ie}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,x=!1){if(O===void 0)return!1;if(L.$yf(O))return O===this._label||O===this.configurationProperties.identifier||x&&O===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$8F=r;class s extends r{constructor(O,x,Z,De,ke,Ie,de,be){super(O,Z,void 0,de,be,x),this.command={},this._source=x,this.hasDefinedMatchers=Ie,ke&&(this.command=ke)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let x;switch(this.command?this.command.runtime:void 0){case p.Shell:x="shell";break;case p.Process:x="process";break;case p.CustomExecution:x="customExecution";break;case void 0:x="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:x,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$4F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let x=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(x+=this._source.kind);const Z={type:e.$7F,folder:O,id:x};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$9F=s;class c extends r{constructor(O,x,Z,De,ke,Ie,de){super(O,Z,De,Ie,de,x),this._source=x,this.configures=ke}static is(O){return O instanceof c}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$4F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let x=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(x+=this._source.kind);const Z={type:e.$7F,folder:O,id:x};return JSON.stringify(Z)}}e.$0F=c;class h extends r{constructor(O,x,Z,De,ke,Ie,de,be,oe){super(O,Z,De,be,oe,x),this.defines=ke,this.hasDefinedMatchers=de,this.command=Ie,this.icon=oe.icon,this.hide=oe.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof h}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new h(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$$F=h;class b extends r{constructor(O,x,Z,De,ke,Ie){super(O,Z,De,ke,Ie,x),this._source=x}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new b(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$_F=b;var m;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(F){F._default=F.Terminal}(m||(e.ExecutionEngine=m={}));var I;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class k{constructor(O){this.c=new Map;for(let x=0;x<O.length;x++)this.c.set(O[x].uri.toString(),x)}compare(O,x){const Z=O.getWorkspaceFolder(),De=x.getWorkspaceFolder();if(Z&&De){let ke=this.c.get(Z.uri.toString());ke=ke===void 0?0:ke+1;let Ie=this.c.get(De.uri.toString());return Ie=Ie===void 0?0:Ie+1,ke===Ie?O._label.localeCompare(x._label):ke-Ie}else return!Z&&De?-1:Z&&!De?1:0}}e.$aG=k;var d;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(d||(e.TaskEventKind=d={}));var w;(function(F){F.SingleRun="singleRun",F.Background="background"})(w||(e.TaskRunType=w={}));var y;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(F){function O(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?"background":"singleRun",group:be.configurationProperties.group,__task:be}}function x(be,oe,ce){return{...O(be),kind:"start",terminalId:oe,resolvedVariables:ce}}F.start=x;function Z(be,oe,ce){return{...O(be),kind:"processStarted",terminalId:oe,processId:ce}}F.processStarted=Z;function De(be,oe,ce){return{...O(be),kind:"processEnded",terminalId:oe,exitCode:ce}}F.processEnded=De;function ke(be,oe,ce){return{...O(be),kind:"terminated",exitReason:ce,terminalId:oe}}F.terminated=ke;function Ie(be,oe,ce){return{...O(oe),kind:be,terminalId:ce}}F.general=Ie;function de(){return{kind:"changed"}}F.changed=de})(C||(e.TaskEvent=C={}));var B;(function(F){function O(Z){const De=Object.keys(Z).sort();let ke="";for(const Ie of De){let de=Z[Ie];de instanceof Object?de=O(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),ke+=Ie+","+de+","}return ke}function x(Z){const ke={_key:O(Z),type:Z.taskType};return Object.assign(ke,Z),ke}F.create=x})(B||(e.KeyedTaskIdentifier=B={}));var j;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(j||(e.TaskSettingId=j={}));var V;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var z;(function(F){function O(x,Z){const De=$.$3F.get(x.type);if(De===void 0){const be=M.$8m(x);return delete be._key,B.create(be)}const ke=Object.create(null);ke.type=De.taskType;const Ie=new Set;De.required.forEach(be=>Ie.add(be));const de=De.properties;for(const be of Object.keys(de)){const oe=x[be];if(oe!=null)ke[be]=oe;else if(Ie.has(be)){const ce=de[be];if(ce.default!==void 0)ke[be]=M.$8m(ce.default);else switch(ce.type){case"boolean":ke[be]=!1;break;case"number":case"integer":ke[be]=0;break;case"string":ke[be]="";break;default:Z.error(E.localize(2,null,JSON.stringify(x,void 0,0),be));return}}}return B.create(ke)}F.createTaskIdentifier=O})(z||(e.TaskDefinition=z={}))}),define(Ae[231],Re([1,0,11]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_4b=e.$$4b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$Z)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$$4b=L;class P extends L{constructor(){super(),this.h=!0,this.i=new E.$4}}e.$_4b=P}),define(Ae[49],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.$pv=e.$ov=void 0;class E{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++E.count}}e.$ov=E;const L=[];function P($){const D=new E($);return L[D.nid]=D,D}e.$pv=P;function M($){return L[$].sid}e.$qv=M;class R{constructor(D){this.value=D}}e.$rv=R}),define(Ae[3],Re([1,0,49]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$rK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var P;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class S{static{this.a=0}static mixin(t){return t._id=S.a++,t}}e.$rK=S;var o;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(o||(e.ISuggestDataDtoField=o={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var p;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$sK={MainThreadAuthentication:(0,E.$pv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$pv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$pv)("MainThreadChatProvider"),MainThreadChatAgents:(0,E.$pv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,E.$pv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$pv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$pv)("MainThreadClipboard"),MainThreadCommands:(0,E.$pv)("MainThreadCommands"),MainThreadComments:(0,E.$pv)("MainThreadComments"),MainThreadConfiguration:(0,E.$pv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$pv)("MainThreadConsole"),MainThreadDebugService:(0,E.$pv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$pv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$pv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$pv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$pv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$pv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$pv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$pv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$pv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$pv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$pv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$pv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$pv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$pv)("MainThreadLanguages"),MainThreadLogger:(0,E.$pv)("MainThreadLogger"),MainThreadMessageService:(0,E.$pv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$pv)("MainThreadOutputService"),MainThreadProgress:(0,E.$pv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$pv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$pv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$pv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$pv)("MainThreadSecretState"),MainThreadStorage:(0,E.$pv)("MainThreadStorage"),MainThreadSpeech:(0,E.$pv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$pv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$pv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$pv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$pv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$pv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$pv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$pv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$pv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$pv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$pv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$pv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$pv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$pv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$pv)("MainThreadSCM"),MainThreadSearch:(0,E.$pv)("MainThreadSearch"),MainThreadShare:(0,E.$pv)("MainThreadShare"),MainThreadTask:(0,E.$pv)("MainThreadTask"),MainThreadWindow:(0,E.$pv)("MainThreadWindow"),MainThreadLabelService:(0,E.$pv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$pv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$pv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$pv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$pv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$pv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$pv)("MainThreadInteractive"),MainThreadChat:(0,E.$pv)("MainThreadChat"),MainThreadInlineChat:(0,E.$pv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$pv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$pv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$pv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$pv)("MainThreadTimeline"),MainThreadTesting:(0,E.$pv)("MainThreadTesting"),MainThreadLocalization:(0,E.$pv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$pv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$pv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$pv)("MainThreadIssueReporter")},e.$tK={ExtHostCommands:(0,E.$pv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$pv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$pv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$pv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$pv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$pv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$pv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$pv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$pv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$pv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$pv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$pv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$pv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$pv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$pv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$pv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$pv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$pv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$pv)("ExtHostStatusBar"),ExtHostShare:(0,E.$pv)("ExtHostShare"),ExtHostExtensionService:(0,E.$pv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$pv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$pv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$pv)("ExtHostSCM"),ExtHostSearch:(0,E.$pv)("ExtHostSearch"),ExtHostTask:(0,E.$pv)("ExtHostTask"),ExtHostWorkspace:(0,E.$pv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$pv)("ExtHostWindow"),ExtHostWebviews:(0,E.$pv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$pv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$pv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$pv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$pv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$pv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$pv)("ExtHostProgress"),ExtHostComments:(0,E.$pv)("ExtHostComments"),ExtHostSecretState:(0,E.$pv)("ExtHostSecretState"),ExtHostStorage:(0,E.$pv)("ExtHostStorage"),ExtHostUrls:(0,E.$pv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$pv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$pv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$pv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$pv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$pv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$pv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$pv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$pv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$pv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$pv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$pv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$pv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$pv)("ExtHostChat"),ExtHostChatAgents:(0,E.$pv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,E.$pv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$pv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$pv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$pv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$pv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$pv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$pv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$pv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$pv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$pv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$pv)("ExtHostTimeline"),ExtHostTesting:(0,E.$pv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$pv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$pv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$pv)("ExtHostIssueReporter")}}),define(Ae[232],Re([1,0,3,7]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$sK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,D){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(R);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation($,D)??[]}getRelatedInformation(R,$,D){return this.c.$getAiRelatedInformation($,D)}registerRelatedInformationProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiRelatedInformationProvider(g,$),new L.$uK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Tec=P}),define(Ae[81],Re([1,0,4,15,3,17]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=e.$Vcc=void 0,e.$Vcc=(0,E.$Qh)("IExtHostApiDeprecationService");let R=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(P.$sK.MainThreadTelemetry)}report(D,g,A){const S=this.d(D,g);this.a.has(S)||(this.a.add(S),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};e.$Wcc=R,e.$Wcc=R=Ke([Ve(0,M.$uM),Ve(1,L.$$i)],R),e.$Xcc=Object.freeze(new class{report($,D,g){}})}),define(Ae[233],Re([1,0,5,3,7,22]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;class R{constructor(g){this.b=new Map,this.c=[],this.d=new E.$Nd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=g.getProxy(L.$sK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,S,o={}){const v=M.$7l.toKey(g.identifier),p=[...S].sort().join(" ");return await this.f.getOrCreate(`${v} ${A} ${p}`,async()=>{await this.a.$ensureProvider(A);const f=g.displayName||g.name;return this.a.$getSession(A,S,v,f,o)})}async getSessions(g,A,S){const o=M.$7l.toKey(g.identifier),v=[...S].sort().join(" ");return await this.g.getOrCreate(`${o} ${v}`,async()=>{await this.a.$ensureProvider(A);const p=g.displayName||g.name;return this.a.$getSessions(A,S,o,p)})}async removeSession(g,A){const S=this.b.get(g);return S?S.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,S,o){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:S,options:o??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===g)||this.c.push({id:g,label:A});const v=S.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(g,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,o?.supportsMultipleAccounts??!1),new P.$uK(()=>{v.dispose(),this.b.delete(g);const p=this.c.findIndex(f=>f.id===g);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,S){const o=this.b.get(g);if(o)return Promise.resolve(o.provider.createSession(A,S));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$rec=R;class ${constructor(){this.a=new Map}getOrCreate(g,A){const S=this.a.get(g);if(S)return S;const o=A().finally(()=>this.a.delete(g));return this.a.set(g,o),o}}}),define(Ae[234],Re([1,0,3,17,8]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;let M=class{constructor($,D){this.a=$.getProxy(E.$sK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,D,g){const A=P.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$xec=M,e.$xec=M=Ke([Ve(0,L.$uM)],M)}),define(Ae[235],Re([1,0,12,5,68,6,50,157,3,8]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class A{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=A.a++}}class S{static{this.a=0}constructor(v,p){this.h=p,this.b=new Map,this.d=new Map,this.e=new L.$Nd,this.onDidPerformUserAction=this.e.event,this.g=v.getProxy(D.$sK.MainThreadChat)}registerChatProvider(v,p,f){const t=new A(v,f);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,p),(0,M.$Pc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(v,p){const f=P.Iterable.find(this.d.keys(),t=>this.d.get(t)===v)??0;typeof f=="number"&&this.g.$transferChatSession(f,p)}sendInteractiveRequestToProvider(v,p){this.g.$sendRequestToProvider(v,p)}async $prepareChat(v,p,f){const t=this.b.get(v);if(!t)return;const i=await t.provider.prepareSession(p,f);if(!i)return;const n=S.a++;return this.d.set(n,i),{id:n,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(v,p){const f=this.b.get(v);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:Array.isArray(i)?i.map(n=>g.ChatReplyFollowup.from(n)):g.MarkdownString.from(i))}async $provideFollowups(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,f))?.map(u=>g.ChatFollowup.from(u))}async $provideSampleQuestions(v,p){const f=this.b.get(v);if(!f||!f.provider.provideSampleQuestions)return;const t=await f.provider.provideSampleQuestions(p);if(t)return t?.map(i=>g.ChatReplyFollowup.from(i))}$removeRequest(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,f)}async $provideReply(v,p,f,t){const i=this.b.get(v);if(!i)return;const n=this.d.get(p);if(!n)return;const u={session:n,message:f.message,variables:{}};if(f.variables)for(const h of Object.keys(f.variables))u.variables[h]=f.variables[h].map(g.ChatVariable.to);const a=R.$Jd.create(!1);let l;const r={report:h=>{if(t.isCancellationRequested)return;typeof l>"u"&&(l=a.elapsed());const b=g.ChatResponseProgress.from(i.extension,h);if("placeholder"in h&&"resolvedContent"in h){const m=Promise.all([this.g.$acceptResponseProgress(v,p,b),h.resolvedContent]);(0,E.$Ig)(m,t).then(I=>{if(!I)return;const[k,d]=I;this.g.$acceptResponseProgress(v,p,d,k??void 0)})}else this.g.$acceptResponseProgress(v,p,b)}};let s;try{s=await i.provider.provideResponseWithProgress(u,r,t),s||(s={errorDetails:{message:(0,$.localize)(0,null)}})}catch(h){s={errorDetails:{message:(0,$.localize)(1,null,h.message),responseIsIncomplete:!0}},this.h.error(h)}try{if(n.saveState&&this.d.has(p)){const h=n.saveState();this.g.$acceptChatState(p,h)}}catch(h){this.h.warn(h)}const c={firstProgress:l??0,totalElapsed:a.elapsed()};return{errorDetails:s.errorDetails,timings:c}}async $provideSlashCommands(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,f))?.map(u=>({...u,kind:g.CompletionItemKind.from(u.kind)}))}$releaseSession(v){this.d.delete(v)}async $onDidPerformUserAction(v){this.e.fire(v)}}e.$Lec=S}),define(Ae[236],Re([1,0,12,6,54,3,8,7]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class D{static{this.a=0}constructor(S,o,v){this.d=o,this.e=v,this.b=new Map,this.c=S.getProxy(M.$sK.MainThreadChatAgents)}registerAgent(S,o,v,p){const f=D.a++;return this.b.set(f,{extension:S,agent:v}),this.c.$registerAgent(f,o,p),(0,L.$Pc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(S,o,v,p,f){const t=this.b.get(S);if(!t){this.e.warn(`[CHAT](${S}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function n(){if(i)throw new Error("Only valid while executing the command")}const u=new E.$dh;f.onCancellationRequested(()=>u.complete()),setTimeout(()=>u.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,u.p);const a=t.agent({role:$.ChatMessageRole.User,content:v},{history:p.history.map(R.ChatMessage.to)},new P.$6u(l=>{n(),this.c.$handleProgressChunk(o,{content:g(l.message)?l.message:l.message.value})}),f);try{return await(0,E.$Ig)(Promise.resolve(a).then(l=>{if(l&&"followUp"in l)return{followUp:l?.followUp?.map(s=>R.ChatFollowup.from(s))}}),f)}finally{i=!0,u.complete()}}}e.$Vec=D;function g(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Ae[237],Re([1,0,12,20,39,5,50,16,2,158,54,3,8,7,207,25]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class t{static{this.a=0}constructor(u,a,l){this.i=a,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=u.getProxy(S.$sK.MainThreadChatAgents2)}createChatAgent(u,a,l){const r=t.a++,s=new i(u,a,this.d,r,l);return this.b.set(r,s),this.d.$registerAgent(r,a,{}),s.apiAgent}async $invokeAgent(u,a,l,r,s,c){this.g.delete(a);const h=this.b.get(u);if(!h)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let b=!1;function m(){if(b)throw new Error("Only valid while executing the command")}const I=new E.$dh;c.onCancellationRequested(()=>I.complete()),setTimeout(()=>I.complete(),10*1e3),this.i.allowListExtensionWhile(h.extension.identifier,I.p);const k=r.command?await h.validateSlashCommand(r.command):void 0,d=R.$Jd.create(!1);let w;try{const y=h.invoke({prompt:r.message,variables:o.ChatVariable.objectTo(r.variables),slashCommand:k},{history:s.history.map(o.ChatMessage.to)},new A.$6u(C=>{m(),typeof w>"u"&&"content"in C&&(w=d.elapsed());const B=o.ChatResponseProgress.from(h.extension,C);if("placeholder"in C&&"resolvedContent"in C){const j=Promise.all([this.d.$handleProgressChunk(l,B),C.resolvedContent]);(0,E.$Ig)(j,c).then(V=>{if(!V)return;const[z,F]=V;this.d.$handleProgressChunk(l,F,z??void 0)})}else this.d.$handleProgressChunk(l,B)}),c);return await(0,E.$Ig)(Promise.resolve(y).then(C=>{if(C){this.g.set(a,C);let B=this.h.get(a);B||(B=new Map,this.h.set(a,B)),B.set(l,C);const j={firstProgress:w,totalElapsed:d.elapsed()};return{errorDetails:C.errorDetails,timings:j}}else this.g.delete(a)}),c)}catch(y){return this.j.error(y,h.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,P.$Bi)(y)),responseIsIncomplete:!0}}}finally{b=!0,I.complete()}}$releaseSession(u){this.g.delete(u),this.h.delete(u)}async $provideSlashCommands(u,a){const l=this.b.get(u);return l?l.provideSlashCommand(a):[]}$provideFollowups(u,a,l){const r=this.b.get(u);if(!r)return Promise.resolve([]);const s=this.g.get(a);return s?r.provideFollowups(s,l):Promise.resolve([])}$acceptFeedback(u,a,l,r){const s=this.b.get(u);if(!s)return;const c=this.h.get(a)?.get(l);if(!c)return;let h;switch(r){case p.InteractiveSessionVoteDirection.Down:h=v.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:h=v.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:c,kind:h}))}$acceptAction(u,a,l,r){const s=this.b.get(u);if(!s)return;const c=this.h.get(a)?.get(l);c&&r.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:r.action,result:c}))}}e.$Wec=t;class i{constructor(u,a,l,r,s){this.extension=u,this.n=a,this.o=l,this.q=r,this.r=s,this.l=new M.$Nd,this.m=new M.$Nd}acceptFeedback(u){this.l.fire(u)}acceptAction(u){this.m.fire(u)}async validateSlashCommand(u){this.b||(await this.provideSlashCommand(L.CancellationToken.None),(0,$.$If)(this.b));const a=this.b.find(l=>l.name===u);if(!a)throw new Error(`Unknown slashCommand: ${u}`);return a}async provideSlashCommand(u){if(!this.a)return[];const a=await this.a.provideSlashCommands(u);return a?(this.b=a,a.map(l=>({name:l.name,description:l.description,followupPlaceholder:l.followupPlaceholder,shouldRepopulate:l.shouldRepopulate}))):[]}async provideFollowups(u,a){if(!this.d)return[];const l=await this.d.provideFollowups(u,a);return l?l.map(r=>o.ChatFollowup.from(r)):[]}get apiAgent(){let u=!1,a=!1;const l=()=>{u||a||(a=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof D.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$oL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),a=!1}))},r=this;return{get name(){return r.n},get description(){return r.g??""},set description(s){r.g=s,l()},get fullName(){return r.h??r.extension.displayName??r.extension.name},set fullName(s){r.h=s,l()},get iconPath(){return r.i},set iconPath(s){r.i=s,l()},get slashCommandProvider(){return r.a},set slashCommandProvider(s){r.a=s,l()},get followupProvider(){return r.d},set followupProvider(s){r.d=s,l()},get isDefault(){return(0,f.$sF)(r.extension,"defaultChatAgent"),r.j},set isDefault(s){(0,f.$sF)(r.extension,"defaultChatAgent"),r.j=s,l()},get isSecondary(){return(0,f.$sF)(r.extension,"defaultChatAgent"),r.k},set isSecondary(s){(0,f.$sF)(r.extension,"defaultChatAgent"),r.k=s,l()},get onDidReceiveFeedback(){return r.l.event},onDidPerformAction:(0,f.$rF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){u=!0,r.a=void 0,r.d=void 0,r.l.dispose(),r.o.$unregisterAgent(r.q)}}}invoke(u,a,l,r){return this.r(u,a,l,r)}}}),define(Ae[238],Re([1,0,20,6,3,8,54,22,12,5]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;class A{constructor(p,f){this.stream=new D.$hh,this.stream=f??new D.$hh;const t=this;this.apiObj={option:p,response:t.stream.asyncIterable}}}class S{constructor(p,f){this.a=new g.$Nd,this.b=new Map,this.c=new D.$hh,this.d=!1;const t=this;this.apiObject={result:p,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){f.cancel()}},p.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(p){if(this.d)return;let f=this.b.get(p.index);f||(this.b.size===0?f=new A(p.index,this.c):f=new A(p.index),this.b.set(p.index,f),this.a.fire(f.apiObj)),f.stream.emitOne(p.part)}}class o{static{this.a=1}constructor(p,f){this.d=f,this.c=new Map,this.e=new Map,this.f=new $.$9l,this.b=p.getProxy(P.$sK.MainThreadChatProvider)}registerProvider(p,f,t,i){const n=o.a++;return this.c.set(n,{extension:p,provider:t}),this.b.$registerProvider(n,f,{extension:p,displayName:i.name??p.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(p,f,t,i,n){const u=this.c.get(p);if(!u)return;const a=new R.$6u(async l=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${u.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:l.index,part:l.part})});return u.provider.provideChatResponse(t.map(M.ChatMessage.to),i,a,n)}allowListExtensionWhile(p,f){this.f.set(p,f),f.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,f){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(p)},makeRequest(i,n,u){if(!t.f.has(p))throw new Error("Access to chat has been revoked");const a=new E.$Xd(u),l=Math.random()*1e6|0,r=t.b.$fetchResponse(p,f,l,i.map(M.ChatMessage.from),n??{},a.token),s=new S(r,a);return t.e.set(l,{res:s}),r.finally(()=>{t.e.delete(l)}),s.apiObject}}}async $handleResponseFragment(p,f){const t=this.e.get(p);t&&t.res.handleFragment(f)}}e.$Qec=o}),define(Ae[239],Re([1,0,6,3,11,8]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;class R{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(L.$sK.MainThreadChatVariables)}async $resolveVariable(D,g,A){const S=this.b.get(D);if(S)try{const o=await S.resolver.resolve(S.data.name,{message:g},A);if(o)return o.map(M.ChatVariable.from)}catch(o){(0,P.$1)(o)}}registerVariableResolver(D,g,A,S){const o=R.a++;return this.b.set(o,{extension:D.identifier,data:{name:g,description:A},resolver:S}),this.c.$registerVariable(o,{name:g,description:A}),(0,E.$Pc)(()=>{this.b.delete(o),this.c.$unregisterVariable(o)})}}e.$Sec=R}),define(Ae[240],Re([1,0,3]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;class L{constructor(M){const R=M.getProxy(E.$sK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$1cc=L}),define(Ae[32],Re([1,0,16,7,8,26,3,18,15,52,29,131,2,6,4,17,108,23,49,39,50,58,61]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=void 0;let s=class{#e;#t;#i;constructor(k,d,w){this.b=new Map,this.c=new Map,this.#e=k.getProxy(R.$sK.MainThreadCommands),this.d=d,this.#i=w,this.#t=k.getProxy(R.$sK.MainThreadTelemetry),this.converter=new c(this,y=>{const C=this.c.get(y);return C?.result===b.Void?C:void 0},d),this.f=[{processArgument(y){return(0,g.$nh)(y)}},{processArgument(y){return(0,M.$0m)(y,function(C){if(A.$us.isIRange(C))return P.Range.to(C);if(S.$ts.isIPosition(C))return P.Position.to(C);if(A.$us.isIRange(C.range)&&o.URI.isUri(C.uri))return P.location.to(C);if(C instanceof i.$be)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const d=this.registerCommand(!1,k.id,async(...w)=>{const y=k.args.map((B,j)=>{if(!B.validate(w[j]))throw new Error(`Invalid argument '${B.name}' when running '${k.id}', received: ${typeof w[j]=="object"?JSON.stringify(w[j],null,"	"):w[j]} `);return B.convert(w[j])}),C=await this.executeCommand(k.internalId,...y);return k.result.convert(C,w,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new L.$uK(()=>{d.dispose(),this.c.delete(k.id)})}registerCommand(k,d,w,y,C,B){if(this.d.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this.b.has(d))throw new Error(`command '${d}' already exists`);return this.b.set(d,{callback:w,thisArg:y,metadata:C,extension:B}),k&&this.#e.$registerCommand(d),new L.$uK(()=>{this.b.delete(d)&&k&&this.#e.$unregisterCommand(d)})}executeCommand(k,...d){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,d,!0)}async g(k,d,w){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,d,!1);{let y=!1;const C=(0,M.$0m)(d,function(B){if(B instanceof L.$vK)return P.Position.from(B);if(B instanceof L.$wK)return P.Range.from(B);if(B instanceof L.$GK)return P.location.from(B);if(L.$RL.isNotebookRange(B))return P.NotebookRange.from(B);if(B instanceof ArrayBuffer)return y=!0,i.$be.wrap(new Uint8Array(B));if(B instanceof Uint8Array)return y=!0,i.$be.wrap(B);if(B instanceof i.$be)return y=!0,B;if(!Array.isArray(B))return B});try{const B=await this.#e.$executeCommand(k,y?new n.$rv(C):C,w);return(0,g.$nh)(B)}catch(B){if(B instanceof Error&&B.message==="$executeCommand:retry")return this.g(k,d,!1);throw B}}}async h(k,d,w){const y=this.b.get(k);if(!y)throw new Error("Unknown command");const{callback:C,thisArg:B,metadata:j}=y;if(j?.args)for(let z=0;z<j.args.length;z++)try{(0,E.$Pf)(d[z],j.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${j.args[z].name}' - ${j.args[z].description}`)}const V=a.$Jd.create();try{return await C.apply(B,d)}catch(z){if(k===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...d);F&&(k=F.command)}if(this.d.error(z,k,y.extension?.identifier),!w)throw z;if(y.extension?.identifier){const F=this.#i.onExtensionError(y.extension.identifier,z);this.d.trace("forwarded error to extension?",F,y.extension?.identifier)}throw new class extends Error{constructor(){super((0,u.$Bi)(z)),this.id=k,this.source=y.extension?.displayName??y.extension?.name}}}finally{this.j(y,k,V.elapsed())}}j(k,d,w){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new l.$ko(d),duration:w})}$executeContributedCommand(k,...d){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const w=this.b.get(k);return w?(d=d.map(y=>this.f.reduce((C,B)=>B.processArgument(C,w.extension?.identifier),y)),this.h(k,d,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(d=>(k&&(d=d.filter(w=>w[0]!=="_")),d))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[d,w]of this.b){const{metadata:y}=w;y&&(k[d]=y)}return Promise.resolve(k)}};e.$PM=s,e.$PM=s=Ke([Ve(0,f.$uM),Ve(1,D.$$i),Ve(2,r.$OM)],s),e.$QM=(0,p.$Qh)("IExtHostCommands");class c{constructor(k,d,w){this.d=k,this.f=d,this.g=w,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,d){if(!k)return;const w={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return w;const y=this.f(k.command);if(y)w.id=y.internalId,w.arguments=y.args.map((C,B)=>C.convert(k.arguments&&k.arguments[B]));else if((0,$.$Kb)(k.arguments)){const C=`${k.command} /${++this.c}`;this.b.set(C,k),d.add((0,v.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),w.$ident=C,w.id=this.delegatingCommandId,w.arguments=[C],this.g.trace("CommandsConverter#CREATE",k.command,C)}return w}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const d=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],d?d.command:"MISSING"),d?this.d.executeCommand(d.command,...d.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$RM=c;class h{static{this.Uri=new h("uri","Uri of a text document",k=>o.URI.isUri(k),k=>k)}static{this.Position=new h("position","A position in a text document",k=>L.$vK.isPosition(k),P.Position.from)}static{this.Range=new h("range","A range in a text document",k=>L.$wK.isRange(k),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",k=>L.$xK.isSelection(k),P.Selection.from)}static{this.Number=new h("number","",k=>typeof k=="number",k=>k)}static{this.String=new h("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=h.Arr(h.String)}static Arr(k){return new h(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,d=>Array.isArray(d)&&d.every(w=>k.validate(w)),d=>d.map(w=>k.convert(w)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",k=>k instanceof L.$QK,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",k=>k instanceof L.$$L,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",k=>k instanceof t.$HM,P.TestItem.from)}constructor(k,d,w,y){this.name=k,this.description=d,this.validate=w,this.convert=y}optional(){return new h(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,d){return new h(k??this.name,d??this.description,this.validate,this.convert)}}e.$SM=h;class b{static{this.Void=new b("no result",k=>k)}constructor(k,d){this.description=k,this.convert=d}}e.$TM=b;class m{constructor(k,d,w,y,C){this.id=k,this.internalId=d,this.description=w,this.args=y,this.result=C}}e.$UM=m}),define(Ae[241],Re([1,0,18,14,2,80,95,34,99,32,8,7]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;const o=[new g.$UM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of DocumentHighlight-instances.",p(A.DocumentHighlight.to))),new g.$UM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$SM.Uri],new g.$TM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,E.$Jb)(t))return;class n extends S.$LK{static to(a){const l=new n(a.name,A.SymbolKind.to(a.kind),a.containerName||"",new S.$GK(i[0],A.Range.to(a.range)));return l.detail=a.detail,l.range=l.location.range,l.selectionRange=A.Range.to(a.selectionRange),l.children=a.children?a.children.map(n.to):[],l}}return t.map(n.to)})),new g.$UM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$SM.Uri,new g.$SM("options","Formatting options",t=>!0,t=>t)],new g.$TM("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$UM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$SM.Uri,g.$SM.Range,new g.$SM("options","Formatting options",t=>!0,t=>t)],new g.$TM("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$UM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$SM.Uri,g.$SM.Position,new g.$SM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$SM("options","Formatting options",t=>!0,t=>t)],new g.$TM("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$UM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$UM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$UM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$UM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$UM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Location-instances.",p(A.location.to))),new g.$UM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of Hover-instances.",p(A.Hover.to))),new g.$UM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$SM.Uri,new g.$SM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>S.$vK.isPosition(i)),t=>t.map(A.Position.from))],new g.$TM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let n;for(const u of i.reverse())n=new S.$PK(A.Range.to(u),n);return n}))),new g.$UM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$SM.String.with("query","Search string")],new g.$TM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new g.$UM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new g.$UM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$SM.CallHierarchyItem],new g.$TM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new g.$UM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$SM.CallHierarchyItem],new g.$TM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new g.$UM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new g.$UM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$SM.Uri,g.$SM.Position,g.$SM.String.with("newName","The new symbol name")],new g.$TM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new g.$UM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$SM.Uri,g.$SM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$TM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new g.$UM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$SM.Uri],new g.$TM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$JL(t.tokenTypes,t.tokenModifiers)})),new g.$UM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$SM.Uri],new g.$TM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$p$)(t);if(i.type==="full")return new S.$LL(i.data,void 0)})),new g.$UM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$SM.Uri,g.$SM.Range.optional()],new g.$TM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$JL(t.tokenTypes,t.tokenModifiers)})),new g.$UM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$SM.Uri,g.$SM.Range],new g.$TM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$p$)(t);if(i.type==="full")return new S.$LL(i.data,void 0)})),new g.$UM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$SM.Uri,g.$SM.Position,g.$SM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$SM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$TM("A promise that resolves to a CompletionList-instance.",(t,i,n)=>{if(!t)return new S.$2K([]);const u=t.suggestions.map(a=>A.CompletionItem.to(a,n));return new S.$2K(u,t.incomplete)})),new g.$UM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$SM.Uri,g.$SM.Position,g.$SM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$TM("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new g.$UM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$SM.Uri,g.$SM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$TM("A promise that resolves to an array of CodeLens-instances.",(t,i,n)=>p(u=>new S.$TK(A.Range.to(u.range),u.command&&n.fromInternal(u.command)))(t))),new g.$UM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$SM.Uri,new g.$SM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.$wK.isRange(t),t=>S.$xK.isSelection(t)?A.Selection.from(t):A.Range.from(t)),g.$SM.String.with("kind","Code action kind to return code actions for").optional(),g.$SM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$TM("A promise that resolves to an array of Command-instances.",(t,i,n)=>p(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return n.fromInternal(u.command)}else{const a=new S.$NK(u.title,u.kind?new S.$OK(u.kind):void 0);return u.edit&&(a.edit=A.WorkspaceEdit.to(u.edit)),u.command&&(a.command=n.fromInternal(u.command)),a.isPreferred=u.isPreferred,a}})(t))),new g.$UM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$SM.Uri],new g.$TM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new S.$8K(A.Range.to(i.range),A.Color.to(i.color))):[])),new g.$UM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$SM("color","The color to show and insert",t=>t instanceof S.$7K,A.Color.from),new g.$SM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new g.$TM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new g.$UM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$SM.Uri,g.$SM.Range],new g.$TM("A promise that resolves to an array of Inlay objects",(t,i,n)=>t.map(A.InlayHint.to.bind(void 0,n)))),new g.$UM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$SM.Uri],new g.$TM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(A.FoldingRange.to)})),new g.$UM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$TM("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>A.NotebookExclusiveDocumentPattern.to(i))})))),new g.$UM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$SM.Uri,g.$SM.Range,new g.$SM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof S.$wK,t=>A.InlineValueContext.from(t))],new g.$TM("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new g.$UM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$SM("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,D.$CU)(t,L.Schemas.http,L.Schemas.https),t=>t),new g.$SM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),g.$SM.String.with("label","").optional()],g.$TM.Void),new g.$UM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$SM.Uri.with("resource","Resource to open"),g.$SM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$SM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],g.$TM.Void),new g.$UM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$SM.Uri.with("left","Left-hand side resource of the diff editor"),g.$SM.Uri.with("right","Right-hand side resource of the diff editor"),g.$SM.String.with("title","Human readable title for the diff editor").optional(),new g.$SM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],g.$TM.Void),new g.$UM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$SM.Uri,g.$SM.Position],new g.$TM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$UM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$SM.TypeHierarchyItem],new g.$TM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$UM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$SM.TypeHierarchyItem],new g.$TM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$UM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$SM.TestItem],g.$TM.Void),new g.$UM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$SM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$TM.Void),new g.$UM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$SM.String.with("name","The context key name"),new g.$SM("value","The context key value",()=>!0,t=>t)],g.$TM.Void),new g.$UM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$SM.Uri,g.$SM.StringArray,new g.$SM("MappedEditsContext","Mapped Edits Context",t=>A.MappedEditsContext.is(t),t=>A.MappedEditsContext.from(t))],new g.$TM("A promise that resolves to a workspace edit or null",t=>t?A.WorkspaceEdit.to(t):null))];class v{static register(i){o.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Pi)}}e.$Zcc=v;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const n of t)M.$ft(n)?i.push(A.DefinitionLink.to(n)):i.push(A.location.to(n));return i}}),define(Ae[242],Re([1,0,12,67,5,6,2,80,22,8,7,3,25]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=void 0;function v(p,f,t){const i=p.getProxy(S.$sK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$9l,f.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const I=this.b.get(m.handle);return I?I.value:m}else if(m&&m.$mid===7){const I=this.b.get(m.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.commentThreadHandle);return k?k.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);return k?m.$mid===8?k.value:{thread:k.value,text:m.text}:m}else if(m&&m.$mid===10){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.commentUniqueId,w=k.getCommentByUniqueId(d);return w||m}else if(m&&m.$mid===11){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.text,w=m.commentUniqueId,y=k.getCommentByUniqueId(w);return y?(typeof y.body=="string"?y.body=d:y.body=new A.$UK(d),y):m}return m}})}createCommentController(m,I,k){const d=n.a++,w=new a(m,d,I,k);this.b.set(w.handle,w);const y=this.c.get(m.identifier)||[];return y.push(w),this.c.set(m.identifier,y),w.value}async $createCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$createCommentThreadTemplate(I,k)}async $updateCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$updateCommentThreadTemplate(I,k)}$deleteCommentThread(m,I){this.b.get(m)?.$deleteCommentThread(I)}$provideCommentingRanges(m,I,k){const d=this.b.get(m);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=t.getDocument(R.URI.revive(I));return(0,E.$Mg)(async()=>{const y=await d.commentingRangeProvider.provideCommentingRanges(w,k);let C;return Array.isArray(y)?C={ranges:y,fileComments:!1}:y?C={ranges:y.ranges||[],fileComments:y.fileComments||!1}:C=y??void 0,C}).then(y=>{let C;return y&&(C={ranges:y.ranges.map(B=>g.Range.from(B)),fileComments:y.fileComments}),C})}$toggleReaction(m,I,k,d,w){const y=this.b.get(m);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,E.$Mg)(()=>{const C=y.getCommentThread(I);if(C){const B=C.getCommentByUniqueId(d.uniqueIdInThread);if(y!==void 0&&B&&y.reactionHandler)return y.reactionHandler(B,s(w))}return Promise.resolve(void 0)})}}class u{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,I,k,d,w,y,C,B){this.m=I,this.n=k,this.o=d,this.p=w,this.q=y,this.extensionDescription=C,this.r=B,this.handle=u.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(V){j.range=V},get comments(){return j.comments},set comments(V){j.comments=V},get collapsibleState(){return j.collapsibleState},set collapsibleState(V){j.collapsibleState=V},get canReply(){return j.canReply},set canReply(V){j.canReply=V},get contextValue(){return j.contextValue},set contextValue(V){j.contextValue=V},get label(){return j.label},set label(V){j.label=V},get state(){return j.state},set state(V){j.state=V},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=k=>Object.prototype.hasOwnProperty.call(this.b,k),I={};m("range")&&(I.range=g.Range.from(this.p)),m("label")&&(I.label=this.label),m("contextValue")&&(I.contextValue=this.contextValue??null),m("comments")&&(I.comments=this.q.map(k=>l(this,k,this.k,this.extensionDescription))),m("collapsibleState")&&(I.collapseState=c(this.g)),m("canReply")&&(I.canReply=this.canReply),m("state")&&(I.state=h(this.h)),m("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(m){for(const I of this.k){const k=I[0],d=I[1];if(m===d)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,L.$jh)(100)],u.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,I,k,d){this.f=m,this.g=I,this.h=k,this.i=d,this.a=new Map,i.$registerCommentController(this.handle,k,d,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(y){w.options=y},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(y){w.commentingRangeProvider=y},get reactionHandler(){return w.reactionHandler},set reactionHandler(y){w.reactionHandler=y},createCommentThread(y,C,B){return w.createCommentThread(y,C,B).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,I,k){I===void 0&&(0,o.$sF)(this.f,"fileComments");const d=new u(this.id,this.handle,void 0,m,I,k,this.f,!1);return this.a.set(d.handle,d),d}$createCommentThreadTemplate(m,I){const k=new u(this.id,this.handle,void 0,R.URI.revive(m),g.Range.to(I),[],this.f,!0);return k.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(m,I){const k=this.a.get(m);k&&(k.range=g.Range.to(I))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function l(b,m,I,k){let d=I.get(m);return d||(d=++b.commentHandle,I.set(m,d)),m.state!==void 0&&(0,o.$sF)(k,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:d,body:typeof m.body=="string"?m.body:g.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(w=>r(w)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function r(b){return{label:b.label,iconPath:b.iconPath?g.$tM(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted}}function s(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?R.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1}}function c(b){if(b!==void 0)switch(b){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(b){if(b!==void 0)switch(b){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$2cc=v}),define(Ae[243],Re([1,0,26,3,27,17]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;let R=class{constructor(A,S){this.a=A.getProxy(L.$sK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,S){const o=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){o.e(A,S,v,arguments)}})}e(A,S,o,v){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:D(v,this.b)}),this.c&&this.f(A,o,v)}};e.$Zec=R,e.$Zec=R=Ke([Ve(0,M.$uM),Ve(1,P.$KM)],R);const $=1e5;function D(g,A){const S=[];if(g.length)for(let o=0;o<g.length;o++){let v=g[o];if(typeof v>"u")v="undefined";else if(v instanceof Error){const p=v;p.stack?v=p.stack:v=p.toString()}S.push(v)}if(A){const o=new Error().stack;o&&S.push({__$stack:o.split(`
`).slice(3).join(`
`)})}try{const o=(0,E.$an)(S);return o.length>$?"Output omitted for a large object that exceeds the limits":o}catch(o){return`Output omitted for an object that cannot be inspected ('${o.toString()}')`}}}),define(Ae[110],Re([1,0,2,3,7,4,17,15,18,13,19,25]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=void 0;let v=class{static{o=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(L.$sK.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=o.c++;this.f.set(i,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const n=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(u=>{if(!u){this.g.$onDidChange(i,null);return}const a=(0,D.$2b)(u);if(a.length<=o.d){this.g.$onDidChange(i,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,a.length);const l=a.map(c=>({uri:c,rank:(0,g.$Ge)(c.path,"/")})),r=(0,D.$yb)(l,(c,h)=>c.rank-h.rank||(0,g.$Ue)(c.uri.path,h.uri.path)),s=[];e:for(const c of r){let h;for(const b of c){const m=(0,A.$lc)(b.uri.path);if(h!==m&&(h=m,s.push(b.uri)>=o.d))break e}}this.g.$onDidChange(i,s)});return new P.$uK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(f,t,i){if(!this.f.has(f))return Object.create(null);const n=Object.create(null),{provider:u,extensionDescription:a}=this.f.get(f);return await Promise.all(t.map(async l=>{try{const{uri:r,id:s}=l,c=await Promise.resolve(u.provideFileDecoration(E.URI.revive(r),i));if(!c)return;try{P.$PL.validate(c),c.badge&&typeof c.badge!="string"&&(0,S.$sF)(a,"codiconDecoration"),n[s]=[c.propagate,c.tooltip,c.badge,c.color]}catch(h){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${h}`)}}catch(r){this.h.error(r)}})),n}};e.$3dc=v,e.$3dc=v=o=Ke([Ve(0,R.$uM),Ve(1,$.$$i)],v),e.$4dc=(0,M.$Qh)("IExtHostDecorations")}),define(Ae[244],Re([1,0,159,98,2,3,7,8,5,15,28,42]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=e.$Tcc=void 0;class v{#e;#t;#i;constructor(t,i,n,u,a,l,r,s){this.d=t,this.e=i,this.f=n,this.g=u,this.h=a,this.c=!1,this.f=Math.max(u,n),this.#i=new A.$zc(c=>l.getComparisonKey(c)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let n=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),n=[t]}else if(Array.isArray(t)){n=[];let l;t=[...t].sort(v.k);for(const r of t){const[s,c]=r;if((!l||s.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=s,n.push(s),this.#i.set(s,[])),c)this.#i.get(s)?.push(...c);else{const h=this.#i.get(s);h&&(h.length=0)}}}if(this.#t.fire(n),!this.#e)return;const u=[];let a=0;for(const l of n){let r=[];const s=this.#i.get(l);if(s)if(s.length>this.g){r=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const b of s)if(b.severity===c[h]&&r.push({...$.Diagnostic.from(b),modelVersionId:this.h(l)})===this.g)break e;r.push({severity:L.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(c=>({...$.Diagnostic.from(c),modelVersionId:this.h(l)}));if(u.push([l,r]),a+=r.length,a>this.f)break}this.#e.$changeMany(this.e,u)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[n,u]of this)t.call(i,n,u,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Tcc=v;let p=class{static{o=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*o.d}static _mapper(t){const i=new A.$zc;for(const n of t)i.set(n,n);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,n,u){this.j=i,this.k=n,this.l=u,this.g=new Map,this.h=new D.$Rd({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,o._mapper),this.f=t.getProxy(M.$sK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:n,f:u,h:a,j:l,k:r,l:s}=this,c=new class{$changeMany(m,I){u.$changeMany(m,I),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,I.length===0?"CLEARING":I)}$clear(m){u.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){u.dispose()}};let h;if(!i)i="_generated_diagnostic_collection_name_#"+o.c++,h=i;else if(!n.has(i))h=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do h=i+o.c++;while(n.has(h))}return new class extends v{constructor(){super(i,h,o.e,o.d,m=>s.getDocument(m)?.version,r.extUri,c,a),n.set(h,this)}dispose(){super.dispose(),n.delete(h)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,n=[];for(const u of this.g.values())u.forEach((a,l)=>{let r=i.get(a.toString());typeof r>"u"&&(r=n.length,i.set(a.toString(),r),n.push([a,[]])),n[r][1]=n[r][1].concat(...l)});return n}}m(t){let i=[];for(const n of this.g.values())n.has(t)&&(i=i.concat(n.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",n=new v(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,u=>{},this.k.extUri,void 0,this.h);this.g.set(i,n),this.n=n}for(const[i,n]of t)this.n.set(P.URI.revive(i),n.map($.Diagnostic.to))}};e.$Ucc=p,e.$Ucc=p=o=Ke([Ve(1,g.$$i),Ve(2,S.$Scc)],p)}),define(Ae[245],Re([1,0,2,3,25]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class M{constructor($){this.a=$.getProxy(L.$sK.MainThreadDialogs)}showOpenDialog($,D){return D?.allowUIResources&&(0,P.$sF)($,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(D=>D?E.URI.revive(D):void 0)}}e.$0cc=M}),define(Ae[246],Re([1,0,11,2,7,3,14,20,13]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class g{static{this.a=0}constructor(S,o,v){this.d=o,this.e=v,this.b=new Map,this.c=S.getProxy(M.$sK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,o){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const v=g.a++;this.b.set(v,o),this.c.$registerTextContentProvider(v,S);let p;return typeof o.onDidChange=="function"&&(p=o.onDidChange(f=>{if(f.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(v,f).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(f);if(!i)return;const n=(0,D.$Pe)(t);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(f,t)},E.$Z)})),new P.$uK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(S,o){const v=this.b.get(S);return v?Promise.resolve(v.provideTextDocumentContent(L.URI.revive(o),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.$$cc=g}),define(Ae[247],Re([1,0,5,6,2,3,103,8,16,26,7,11]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;class o{constructor(p,f){this.a=new E.$Nd({onListenerError:S.$1}),this.b=new E.$Nd({onListenerError:S.$1}),this.c=new E.$Nd({onListenerError:S.$1}),this.d=new E.$Nd({onListenerError:S.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Qc,this.h=new Map,this.f=p.getProxy(M.$sK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const n=P.URI.revive(i);return(0,D.$Jf)(this.g.getDocument(n))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>P.URI.revive(f))}$acceptModelLanguageChanged(p,f){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(f),this.a.fire(i.document)}$acceptModelSaved(p){const f=P.URI.revive(p),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,f){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,t){const i=P.URI.revive(p),n=this.g.getDocument(i);if(!n)throw new Error("unknown document");n._acceptIsDirty(t),n.onEvents(f);let u;f.isUndoing?u=A.TextDocumentChangeReason.Undo:f.isRedoing&&(u=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$9m)({document:n.document,contentChanges:f.changes.map(a=>({range:$.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:u}))}setWordDefinitionFor(p,f){(0,R.$wM)(p,f)}}e.$Qcc=o}),define(Ae[62],Re([1,0,55,5,6,2,4,3,103,17,109,8,15,28,14,68,44]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;class i{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(a,l){this.h=a,this.i=l,this.a=null,this.b=new Map,this.c=new v.$zc,this.d=new L.$Nd,this.e=new L.$Nd,this.f=new L.$Nd,this.g=new L.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const l=[],r=[],s=[];if(a.removedDocuments)for(const c of a.removedDocuments){const h=M.URI.revive(c),b=this.c.get(h);b?.unref()&&(this.c.delete(h),l.push(b.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const h=M.URI.revive(c.uri);let b=this.c.get(h);if(b&&h.scheme!==p.Schemas.vscodeNotebookCell&&h.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);b||(b=new i(new D.$xM(this.h.getProxy($.$sK.MainThreadDocuments),h,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(h,b),r.push(b.value)),b.ref()}if(a.removedEditors)for(const c of a.removedEditors){const h=this.b.get(c);this.b.delete(c),h&&s.push(h)}if(a.addedEditors)for(const c of a.addedEditors){const h=M.URI.revive(c.documentUri);E.ok(this.c.has(h),`document '${h}' does not exist`),E.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const b=this.c.get(h).value,m=new A.$DM(c.id,this.h.getProxy($.$sK.MainThreadTextEditors),this.i,new t.$U(()=>b.document),c.selections.map(S.Selection.to),c.options,c.visibleRanges.map(I=>S.Range.to(I)),typeof c.editorPosition=="number"?S.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,m)}a.newActiveEditor!==void 0&&(E.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,P.$Mc)(l),(0,P.$Mc)(s),a.removedDocuments&&this.e.fire(l),a.addedDocuments&&this.d.fire(r),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return f.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const l=this.b.get(this.a);return a?l:l?.value}allEditors(){return[...this.b.values()]}};e.$EM=n,e.$EM=n=Ke([Ve(0,g.$uM),Ve(1,o.$$i)],n),e.$FM=(0,R.$Qh)("IExtHostDocumentsAndEditors")}),define(Ae[63],Re([1,0,248,5,16,2,4,3,17,8,7]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=e.$8dc=void 0,e.$8dc=(0,R.$Qh)("IExtHostEditorTabs");class S{constructor(t,i,n){this.e=n,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$_L(M.URI.revive(this.b.input.uri));case 2:return new A.$aM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$bM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$cM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$dM(this.b.input.viewType);case 4:return new A.$eM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$fM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$gM;case 9:return new A.$hM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$iM(this.b.input.providerId);default:return}}}class o{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const n of t.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return g.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(n=>n.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(n=>n.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const n=new S(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,n),t.tabDto.isActive&&(this.d=n.tabId),n}else if(t.kind===1){const n=this.c.splice(t.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(t.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,n),n}const i=this.c.find(n=>n.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let v=class{constructor(t){this.b=new L.$Nd,this.c=new L.$Nd,this.e=[],this.a=t.getProxy($.$sK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(n=>n.apiObject))},get activeTabGroup(){const n=t.d;return(0,P.$Jf)(t.e.find(a=>a.groupId===n)?.apiObject)},close:async(n,u)=>{const a=Array.isArray(n)?n:[n];return a.length?p(a[0])?this.j(a,u):this.i(a,u):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(c=>c.groupId)),n=new Set(t.map(c=>c.groupId)),u=(0,E.$K)(i,n),a=this.e.filter(c=>u.removed.includes(c.groupId)).map(c=>c.apiObject),l=[],r=[];this.e=t.map(c=>{const h=new o(c,()=>this.d);return u.added.includes(h.groupId)?l.push(h.apiObject):r.push(h.apiObject),h});const s=(0,P.$Jf)(t.find(c=>c.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:l,closed:a,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(n=>n.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(u=>u.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const n=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(t){for(const i of this.e)for(const n of i.tabs)if(n.apiObject===t)return n}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const n=[];for(const u of t){const a=this.g(u);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this.a.$closeTab(n,i)}async j(t,i){const n=[];for(const u of t){const a=this.h(u);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this.a.$closeGroup(n,i)}};e.$9dc=v,e.$9dc=v=Ke([Ve(0,D.$uM)],v);function p(f){return f.tabs!==void 0}}),define(Ae[249],Re([1,0,3,7]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$sK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(R);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector($,D);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiEmbeddingVectorProvider($,g),new L.$uK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Uec=P}),define(Ae[250],Re([1,0,2,3,6,7,8,298,13,23,25,53]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class o{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let i,n,u=14,a=14;for(const l of f){let r=i?(0,D.$4e)(i,l):0;for(r===0?n=1:n=a;r<l.length;r++)r+1===l.length?(u=a,a=9):a+=1,t.push([n,l.toUpperCase().charCodeAt(r),a]),t.push([n,l.toLowerCase().charCodeAt(r),a]),n=a;i=l,a=u}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$sZ(t)}}provideDocumentLinks(f){this.c();const t=[],i=$.$tZ.computeLinks({getLineContent(n){return f.lineAt(n-1).text},getLineCount(){return f.lineCount}},this.b);for(const n of i){const u=R.DocumentLink.to(n);u.target&&t.push(u)}return t}}class v{constructor(f,t){this.i=t,this.b=new o,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(L.$sK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,i,n={}){if(v.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const u=this.h++;this.b.add(t),this.d.add(t),this.c.set(u,i);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof i.copy=="function"&&(a+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,A.$sF)(f,"fsChunks"),a+=4);let l;n.isReadonly&&(0,S.$6j)(n.isReadonly)&&((0,A.$sF)(f,"readonlyMessage"),l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(u,t,a,l).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=i.onDidChangeFile(s=>{const c=[];for(const h of s){const{uri:b,type:m}=h;if(b.scheme!==t)continue;let I;switch(m){case M.FileChangeType.Changed:I=0;break;case M.FileChangeType.Created:I=1;break;case M.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:b,type:I})}this.a.$onFileSystemChange(u,c)});return(0,P.$Pc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(u),this.a.$unregisterProvider(u)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:i,mtime:n,size:u,permissions:a}=f;return{type:t,ctime:i,mtime:n,size:u,permissions:a}}$stat(f,t){return Promise.resolve(this.l(f).stat(E.URI.revive(t))).then(i=>v.k(i))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(E.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(E.URI.revive(t))).then(i=>g.$be.wrap(i))}$writeFile(f,t,i,n){return Promise.resolve(this.l(f).writeFile(E.URI.revive(t),i.buffer,n))}$delete(f,t,i){return Promise.resolve(this.l(f).delete(E.URI.revive(t),i))}$rename(f,t,i,n){return Promise.resolve(this.l(f).rename(E.URI.revive(t),E.URI.revive(i),n))}$copy(f,t,i,n){const u=this.l(f);if(!u.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(u.copy(E.URI.revive(t),E.URI.revive(i),n))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(E.URI.revive(t)))}$watch(f,t,i,n){const u=this.l(f).watch(E.URI.revive(i),n);this.f.set(t,u)}$unwatch(f,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(f,t,i){const n=this.l(f);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(t),i))}$close(f,t){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,n){const u=this.l(f);if(!u.read)throw new Error('FileSystemProvider does not implement "read"');const a=g.$be.alloc(n);return Promise.resolve(u.read(t,i,a.buffer,0,n)).then(l=>a.slice(0,l))}$write(f,t,i,n){const u=this.l(f);if(!u.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(u.write(t,i,n.buffer,0,n.byteLength))}l(f){const t=this.c.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Edc=v}),define(Ae[64],Re([1,0,3,41,7,23,4,17,42,6,12,24,14]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0;let p=v=class{constructor(t,i){this.b=new Map,this.c=new A.$4g,this.a=t.getProxy(E.$sK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(u){try{let a;const l=n.b.get(u.scheme);return l?(await n.a.$ensureActivation(u.scheme),a=await l.impl.stat(u)):a=await n.a.$stat(u),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===L.FilePermission.Readonly?1:void 0}}catch(a){v.e(a)}},async readDirectory(u){try{const a=n.b.get(u.scheme);return a?(await n.a.$ensureActivation(u.scheme),(await a.impl.readDirectory(u)).slice()):await n.a.$readdir(u)}catch(a){return v.e(a)}},async createDirectory(u){try{const a=n.b.get(u.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(u.scheme),await n.d(a.impl,a.extUri,u)):await n.a.$mkdir(u)}catch(a){return v.e(a)}},async readFile(u){try{const a=n.b.get(u.scheme);return a?(await n.a.$ensureActivation(u.scheme),(await a.impl.readFile(u)).slice()):(await n.a.$readFile(u)).buffer}catch(a){return v.e(a)}},async writeFile(u,a){try{const l=n.b.get(u.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(u.scheme),await n.d(l.impl,l.extUri,l.extUri.dirname(u)),await n.c.queueFor(u).queue(()=>Promise.resolve(l.impl.writeFile(u,a,{create:!0,overwrite:!0})))):await n.a.$writeFile(u,M.$be.wrap(a))}catch(l){return v.e(l)}},async delete(u,a){try{const l=n.b.get(u.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(u.scheme),await l.impl.delete(u,{recursive:!1,...a})):await n.a.$delete(u,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(l){return v.e(l)}},async rename(u,a,l){try{return await n.a.$rename(u,a,{overwrite:!1,...l})}catch(r){return v.e(r)}},async copy(u,a,l){try{return await n.a.$copy(u,a,{overwrite:!1,...l})}catch(r){return v.e(r)}},isWritableFileSystem(u){const a=i.getCapabilities(u);if(typeof a=="number")return!(a&2048)}})}async d(t,i,n){const u=[];for(;!i.isEqual(n,i.dirname(n));)try{if(!((await t.stat(n)).type&L.FileType.Directory))throw P.$HL.FileExists(`Unable to create folder '${n.scheme===o.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(L.$pk(a)!==L.FileSystemProviderErrorCode.FileNotFound)throw a;u.push(i.basename(n)),n=i.dirname(n)}for(let a=u.length-1;a>=0;a--){n=i.joinPath(n,u[a]);try{await t.createDirectory(n)}catch(l){if(L.$pk(l)!==L.FileSystemProviderErrorCode.FileExists)throw l}}}static e(t){if(t instanceof P.$HL)throw t;if(t instanceof L.$lk)switch(t.code){case L.FileSystemProviderErrorCode.FileExists:throw P.$HL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$HL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$HL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$HL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$HL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$HL.Unavailable(t.message);default:throw new P.$HL(t.message,t.name)}if(!(t instanceof Error))throw new P.$HL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.$HL.Unavailable(t.message);switch(t.name){case L.FileSystemProviderErrorCode.FileExists:throw P.$HL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$HL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$HL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$HL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$HL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$HL.Unavailable(t.message);default:throw new P.$HL(t.message,t.name)}}addFileSystemProvider(t,i,n){return this.b.set(t,{impl:i,extUri:n?.isCaseSensitive?S.$lg:S.$ng,isReadonly:!!n?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??S.$lg}};e.$kdc=p,e.$kdc=p=v=Ke([Ve(0,$.$uM),Ve(1,D.$Scc)],p),e.$ldc=(0,R.$Qh)("IExtHostConsumerFileSystem")}),define(Ae[251],Re([1,0,5,33,2,3,8,7,44]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,p,f,t,i,n){this.a=Math.random(),this.b=new E.$Nd,this.c=new E.$Nd,this.d=new E.$Nd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const u=(0,L.$xj)(i),a=typeof i=="string",l=n?.correlate,r=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(l&&typeof s.session>"u")){if(!n?.ignoreCreateEvents)for(const c of s.created){const h=P.URI.revive(c);u(h.fsPath)&&(!a||p.getWorkspaceFolder(h))&&this.b.fire(h)}if(!n?.ignoreChangeEvents)for(const c of s.changed){const h=P.URI.revive(c);u(h.fsPath)&&(!a||p.getWorkspaceFolder(h))&&this.c.fire(h)}if(!n?.ignoreDeleteEvents)for(const c of s.deleted){const h=P.URI.revive(c);u(h.fsPath)&&(!a||p.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=$.$uK.from(this.i(v,f,i,n,n?.correlate),this.b,this.c,this.d,r)}i(v,p,f,t,i){const n=$.$uK.from();if(typeof f=="string")return n;const u=v.getProxy(M.$sK.MainThreadFileSystemEventService);let a=!1;return(f.pattern.includes(L.$tj)||f.pattern.includes(L.$uj))&&(a=!0),u.$watch(p.identifier.value,this.a,f.baseUri,{recursive:a,excludes:t?.excludes??[]},!!i),$.$uK.from({dispose:()=>u.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new D.$U(()=>this.a.created.map(P.URI.revive)),this.c=new D.$U(()=>this.a.changed.map(P.URI.revive)),this.d=new D.$U(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(v,p,f){this.j=v,this.k=p,this.l=f,this.a=new E.$Nd,this.b=new E.$Nd,this.c=new E.$Nd,this.d=new E.$Nd,this.g=new E.$Pd,this.h=new E.$Pd,this.i=new E.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,p,f,t){return new g(this.j,v,p,this.a.event,R.GlobPattern.from(f),t)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,p){switch(v){case 2:this.b.fire(Object.freeze({files:p.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,p){return(f,t,i)=>{const n=function(a){f.call(t,a)};return n.extension=v,p.event(n,void 0,i)}}async $onWillRunFileOperation(v,p,f,t){switch(v){case 2:return await this.n(this.g,{files:p.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},f,t);case 1:return await this.n(this.i,{files:p.map(i=>P.URI.revive(i.target))},f,t);case 0:case 3:return await this.n(this.h,{files:p.map(i=>P.URI.revive(i.target))},f,t)}}async n(v,p,f,t){const i=new Set,n=[];if(await v.fireAsync(p,t,async(a,l)=>{const r=Date.now(),s=await Promise.resolve(a);s instanceof $.$EK&&(n.push([l.extension,s]),i.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-r>f&&this.k.warn("SLOW file-participant",l.extension.identifier)}),t.isCancellationRequested||n.length===0)return;const u={edits:[]};for(const[,a]of n){const{edits:l}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(l)}return{edit:u,extensionNames:Array.from(i)}}}e.$Fdc=S}),define(Ae[252],Re([1,0,6,2,3,8,7,32,12]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;class g{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=g.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class S{static{this.a=0}constructor(v,p,f,t){this.f=f,this.g=t,this.b=new Map,this.d=new Map,this.e=v.getProxy(P.$sK.MainThreadInlineChat),p.registerApiCommand(new $.$UM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$SM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$TM.Void))}registerProvider(v,p,f){const t=new g(v,p);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,f.label,v.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,E.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(v,p,f,t){const i=this.b.get(v);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(p)),u=M.Selection.to(f),a=await i.provider.prepareInteractiveEditorSession({document:n,selection:u},t);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(u))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=S.a++;return this.d.set(l,new A(a)),{id:l,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(r=>({command:r.command,detail:r.detail,refer:r.refer,executeImmediately:r.executeImmediately})),wholeRange:M.Range.from(a.wholeRange),message:a.message}}async $provideResponse(v,p,f,t){const i=this.b.get(v);if(!i)return;const n=this.d.get(p.id);if(!n)return;const u={prompt:f.prompt,selection:M.Selection.to(f.selection),wholeRange:M.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let a=!1;const l={report:async m=>{if(!f.live&&m.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||t.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:m.message,edits:m.edits?.map(M.TextEdit.from),editsShouldBeInstant:m.editsShouldBeInstant,slashCommand:m.slashCommand?.command,markdownFragment:R.$UK.isMarkdownString(m.content)?m.content.value:m.content})}},r=Promise.resolve(i.provider.provideInteractiveEditorResponse(n.session,u,l,t));let s;try{s=await(0,D.$Ig)(r,t)}finally{a=!0}if(!s)return;const c=n.responses.push(s)-1,h={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(S.h(s))return{...h,id:c,type:"message",message:M.MarkdownString.from(s.contents)};const{edits:b}=s;return b instanceof R.$EK?{...h,id:c,type:"bulkEdit",edits:M.WorkspaceEdit.from(b)}:{...h,id:c,type:"editorEdit",edits:b.map(M.TextEdit.from)}}$handleFeedback(v,p,f,t){const i=this.b.get(v),n=this.d.get(p),u=n?.responses[f];if(i&&u){const a=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(n.session,u,a)}}$releaseSession(v,p){}static h(v){return typeof v=="object"&&typeof v.contents=="object"}}e.$Mec=S}),define(Ae[253],Re([1,0,2,32]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;class P{constructor(R,$,D,g,A){this.a=$,this.b=D,this.c=g;const S=new L.$UM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$SM("showOptions","Show Options",o=>!0,o=>o),new L.$SM("resource","Interactive resource Uri",o=>!0,o=>o),new L.$SM("controllerId","Notebook controller Id",o=>!0,o=>o),new L.$SM("title","Interactive editor title",o=>!0,o=>o)],new L.$TM("Notebook and input URI",o=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",o.notebookEditorId),o.notebookEditorId!==void 0){const v=this.a.getEditorById(o.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:E.URI.revive(o.notebookUri),inputUri:E.URI.revive(o.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",o.notebookUri,o.inputUri),{notebookUri:E.URI.revive(o.notebookUri),inputUri:E.URI.revive(o.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,$,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:D,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Iec=P}),define(Ae[254],Re([1,0,3,7]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$sK.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(R);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueData($);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueTemplate($);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(R,$){const D=R.identifier.value;return this.a.set(D,$),this.c.$registerIssueUriRequestHandler(D),new L.$uK(()=>{this.c.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}registerIssueDataProvider(R,$){const D=R.identifier.value;return this.b.set(D,$),this.c.$registerIssueDataProvider(D),new L.$uK(()=>{this.c.$unregisterIssueDataProvider(D),this.b.delete(D)})}}e.$Oec=P}),define(Ae[255],Re([1,0,6,3]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(L.$sK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$2dc=P}),define(Ae[256],Re([1,0,2,26,8,7,80,3,13,29,18,16,299,20,22,6,95,89,75,50,11,12,25,161]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class c{constructor(T,q){this.d=T,this.e=q}async provideDocumentSymbols(T,q){const G=this.d.getDocument(T),Q=await this.e.provideDocumentSymbols(G,q);if(!(0,A.$Jb)(Q))return Q[0]instanceof M.$MK?Q.map(P.DocumentSymbol.from):c.f(Q)}static f(T){T=T.slice(0).sort((Q,K)=>{let Y=Q.location.range.start.compareTo(K.location.range.start);return Y===0&&(Y=K.location.range.end.compareTo(Q.location.range.end)),Y});const q=[],G=[];for(const Q of T){const K={name:Q.name||"!!MISSING: name!!",kind:P.SymbolKind.from(Q.kind),tags:Q.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:P.Range.from(Q.location.range),selectionRange:P.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(K),q.push(K);break}const Y=G[G.length-1];if(g.$us.containsRange(Y.range,K.range)&&!g.$us.equalsRange(Y.range,K.range)){Y.children?.push(K),G.push(K);break}G.pop()}}return q}}class h{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(T,q,G){this.g=T,this.h=q,this.j=G,this.e=new n.$Pcc("CodeLens"),this.f=new Map}async provideCodeLenses(T,q){const G=this.g.getDocument(T),Q=await this.j.provideCodeLenses(G,q);if(!Q||q.isCancellationRequested)return;const K=this.e.add(Q),Y=new f.$Qc;this.f.set(K,Y);const ue={cacheId:K,lenses:[]};for(let Ne=0;Ne<Q.length;Ne++)ue.lenses.push({cacheId:[K,Ne],range:P.Range.from(Q[Ne].range),command:this.h.toInternal(Q[Ne].command,Y)});return ue}async resolveCodeLens(T,q){const G=T.cacheId&&this.e.get(...T.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,q),Q||(Q=G),q.isCancellationRequested)return;const K=T.cacheId&&this.f.get(T.cacheId[0]);if(K)return T.command=this.h.toInternal(Q.command??h.d,K),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}function b(Pe){return Array.isArray(Pe)?Pe.map(P.DefinitionLink.from):Pe?[P.DefinitionLink.from(Pe)]:[]}class m{constructor(T,q){this.d=T,this.e=q}async provideDefinition(T,q,G){const Q=this.d.getDocument(T),K=P.Position.to(q),Y=await this.e.provideDefinition(Q,K,G);return b(Y)}}class I{constructor(T,q){this.d=T,this.e=q}async provideDeclaration(T,q,G){const Q=this.d.getDocument(T),K=P.Position.to(q),Y=await this.e.provideDeclaration(Q,K,G);return b(Y)}}class k{constructor(T,q){this.d=T,this.e=q}async provideImplementation(T,q,G){const Q=this.d.getDocument(T),K=P.Position.to(q),Y=await this.e.provideImplementation(Q,K,G);return b(Y)}}class d{constructor(T,q){this.d=T,this.e=q}async provideTypeDefinition(T,q,G){const Q=this.d.getDocument(T),K=P.Position.to(q),Y=await this.e.provideTypeDefinition(Q,K,G);return b(Y)}}class w{constructor(T,q){this.d=T,this.e=q}async provideHover(T,q,G){const Q=this.d.getDocument(T),K=P.Position.to(q),Y=await this.e.provideHover(Q,K,G);if(!(!Y||(0,A.$Jb)(Y.contents)))return Y.range||(Y.range=Q.getWordRangeAtPosition(K)),Y.range||(Y.range=new M.$wK(K,K)),P.Hover.from(Y)}}class y{constructor(T,q){this.d=T,this.e=q}async provideEvaluatableExpression(T,q,G){const Q=this.d.getDocument(T),K=P.Position.to(q),Y=await this.e.provideEvaluatableExpression(Q,K,G);if(Y)return P.EvaluatableExpression.from(Y)}}class C{constructor(T,q){this.d=T,this.e=q}async provideInlineValues(T,q,G,Q){const K=this.d.getDocument(T),Y=await this.e.provideInlineValues(K,P.Range.to(q),P.InlineValueContext.to(G),Q);if(Array.isArray(Y))return Y.map(ue=>P.InlineValue.from(ue))}}class B{constructor(T,q){this.d=T,this.e=q}async provideDocumentHighlights(T,q,G){const Q=this.d.getDocument(T),K=P.Position.to(q),Y=await this.e.provideDocumentHighlights(Q,K,G);if(Array.isArray(Y))return Y.map(P.DocumentHighlight.from)}}class j{constructor(T,q){this.d=T,this.e=q}async provideLinkedEditingRanges(T,q,G){const Q=this.d.getDocument(T),K=P.Position.to(q),Y=await this.e.provideLinkedEditingRanges(Q,K,G);if(Y&&Array.isArray(Y.ranges))return{ranges:(0,A.$Gb)(Y.ranges.map(P.Range.from)),wordPattern:Y.wordPattern}}}class V{constructor(T,q){this.d=T,this.e=q}async provideReferences(T,q,G,Q){const K=this.d.getDocument(T),Y=P.Position.to(q),ue=await this.e.provideReferences(K,Y,G,Q);if(Array.isArray(ue))return ue.map(P.location.from)}}class z{static{this.d=1e3}constructor(T,q,G,Q,K,Y,ue){this.g=T,this.h=q,this.j=G,this.k=Q,this.l=K,this.m=Y,this.n=ue,this.e=new n.$Pcc("CodeAction"),this.f=new Map}async provideCodeActions(T,q,G,Q){const K=this.g.getDocument(T),Y=o.$ws.isISelection(q)?P.Selection.to(q):P.Range.to(q),ue=[];for(const Ye of this.j.getDiagnostics(T))if(Y.intersection(Ye.range)&&ue.push(Ye)>z.d)break;const Ne={diagnostics:ue,only:G.only?new M.$OK(G.only):void 0,triggerKind:P.CodeActionTriggerKind.to(G.trigger)},Be=await this.k.provideCodeActions(K,Y,Ne,Q);if(!(0,A.$Kb)(Be)||Q.isCancellationRequested)return;const Je=this.e.add(Be),Ge=new f.$Qc;this.f.set(Je,Ge);const _e=[];for(let Ye=0;Ye<Be.length;Ye++){const xe=Be[Ye];xe&&(z.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,Ge)})):(Ne.only&&(xe.kind?Ne.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Je,Ye],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,Ge),diagnostics:xe.diagnostics&&xe.diagnostics.map(P.Diagnostic.from),edit:xe.edit&&P.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,isAI:(0,r.$rF)(this.m,"codeActionAI")?xe.isAI:!1,disabled:xe.disabled?.reason})))}return{cacheId:Je,actions:_e}}async resolveCodeAction(T,q){const[G,Q]=T,K=this.e.get(G,Q);if(!K||z.o(K))return{};if(!this.k.resolveCodeAction)return{};const Y=await this.k.resolveCodeAction(K,q)??K;let ue;Y.edit&&(ue=P.WorkspaceEdit.from(Y.edit,void 0));let Ne;if(Y.command){const Be=this.f.get(G);Be&&(Ne=this.h.toInternal(Y.command,Be))}return{edit:ue,command:Ne}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class F{static toInternalProviderId(T,q){return T+"."+q}constructor(T,q,G,Q,K){this.d=T,this.e=q,this.f=G,this.g=Q,this.h=K}async prepareDocumentPaste(T,q,G,Q){if(!this.f.prepareDocumentPaste)return;const K=this.e.getDocument(T),Y=q.map(Be=>P.Range.to(Be)),ue=P.DataTransfer.toDataTransfer(G,()=>{throw new a.$0});if(await this.f.prepareDocumentPaste(K,Y,ue,Q),Q.isCancellationRequested)return;const Ne=Array.from(ue).filter(([,Be])=>!(Be instanceof M.$iL));return P.DataTransfer.from(Ne)}async providePasteEdits(T,q,G,Q,K){if(!this.f.provideDocumentPasteEdits)return;const Y=this.e.getDocument(q),ue=G.map(Je=>P.Range.to(Je)),Ne=P.DataTransfer.toDataTransfer(Q,async Je=>(await this.d.$resolvePasteFileData(this.g,T,Je)).buffer),Be=await this.f.provideDocumentPasteEdits(Y,ue,Ne,K);if(Be)return{label:Be.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Be.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:F.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?P.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class O{constructor(T,q){this.d=T,this.e=q}async provideDocumentFormattingEdits(T,q,G){const Q=this.d.getDocument(T),K=await this.e.provideDocumentFormattingEdits(Q,q,G);if(Array.isArray(K))return K.map(P.TextEdit.from)}}class x{constructor(T,q){this.d=T,this.e=q}async provideDocumentRangeFormattingEdits(T,q,G,Q){const K=this.d.getDocument(T),Y=P.Range.to(q),ue=await this.e.provideDocumentRangeFormattingEdits(K,Y,G,Q);if(Array.isArray(ue))return ue.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,q,G,Q){(0,S.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const K=this.d.getDocument(T),Y=q.map(P.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(K,Y,G,Q);if(Array.isArray(ue))return ue.map(P.TextEdit.from)}}class Z{constructor(T,q){this.d=T,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,q,G,Q,K){const Y=this.d.getDocument(T),ue=P.Position.to(q),Ne=await this.e.provideOnTypeFormattingEdits(Y,ue,G,Q,K);if(Array.isArray(Ne))return Ne.map(P.TextEdit.from)}}class De{constructor(T,q){this.e=T,this.f=q,this.d=new n.$Pcc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,q){const G=await this.e.provideWorkspaceSymbols(T,q);if(!(0,A.$Kb)(G))return{symbols:[]};const Q=this.d.add(G),K={cacheId:Q,symbols:[]};for(let Y=0;Y<G.length;Y++){const ue=G[Y];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}K.symbols.push({...P.WorkspaceSymbol.from(ue),cacheId:[Q,Y]})}return K}async resolveWorkspaceSymbol(T,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const G=this.d.get(...T.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,q);return Q&&(0,L.$$m)(T,P.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class ke{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,q,G){this.d=T,this.e=q,this.f=G}async provideRenameEdits(T,q,G,Q){const K=this.d.getDocument(T),Y=P.Position.to(q);try{const ue=await this.e.provideRenameEdits(K,Y,G,Q);return ue?P.WorkspaceEdit.from(ue):void 0}catch(ue){const Ne=ke.g(ue);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(T,q,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(T),K=P.Position.to(q);try{const Y=await this.e.prepareRename(Q,K,G);let ue,Ne;if(M.$wK.isRange(Y)?(ue=Y,Ne=Q.getText(Y)):(0,S.$Af)(Y)&&(ue=Y.range,Ne=Y.placeholder),!ue||!Ne)return;if(ue.start.line>K.line||ue.end.line<K.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(ue),text:Ne}}catch(Y){const ue=ke.g(Y);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(Y)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Ie{constructor(T,q){this.resultId=T,this.tokens=q}}class de{constructor(T,q){this.f=T,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,q,G){const Q=this.f.getDocument(T),K=q!==0?this.d.get(q):null;let Y=typeof K?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,K.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return K&&this.d.delete(q),Y?(Y=de.h(Y),this.o(de.n(K,Y),Y)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return de.j(T)?de.k(T)?T:new M.$LL(new Uint32Array(T.data),T.resultId):de.l(T)?de.m(T)?T:new M.$NL(T.edits.map(q=>new M.$ML(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const q of T.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(T,q){if(!de.j(q)||!T||!T.tokens)return q;const G=T.tokens,Q=G.length,K=q.data,Y=K.length;let ue=0;const Ne=Math.min(Q,Y);for(;ue<Ne&&G[ue]===K[ue];)ue++;if(ue===Q&&ue===Y)return new M.$NL([],q.resultId);let Be=0;const Je=Ne-ue;for(;Be<Je&&G[Q-Be-1]===K[Y-Be-1];)Be++;return new M.$NL([{start:ue,deleteCount:Q-ue-Be,data:K.subarray(ue,Y-Be)}],q.resultId)}o(T,q){if(de.j(T)){const G=this.e++;return this.d.set(G,new Ie(T.resultId,T.data)),(0,t.$o$)({id:G,type:"full",data:T.data})}if(de.l(T)){const G=this.e++;return de.j(q)?this.d.set(G,new Ie(q.resultId,q.data)):this.d.set(G,new Ie(T.resultId)),(0,t.$o$)({id:G,type:"delta",deltas:(T.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class be{constructor(T,q){this.d=T,this.e=q}async provideDocumentRangeSemanticTokens(T,q,G){const Q=this.d.getDocument(T),K=await this.e.provideDocumentRangeSemanticTokens(Q,P.Range.to(q),G);return K?this.f(K):null}f(T){return(0,t.$o$)({id:0,type:"full",data:T.data})}}class oe{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,q,G,Q,K){this.f=T,this.g=q,this.h=G,this.j=Q,this.k=K,this.d=new n.$Pcc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,q,G,Q){const K=this.f.getDocument(T),Y=P.Position.to(q),ue=K.getWordRangeAtPosition(Y)||new M.$wK(Y,Y),Ne=ue.with({end:Y}),Be=new u.$Jd,Je=await this.h.provideCompletionItems(K,Y,Q,P.CompletionContext.to(G));if(!Je||Q.isCancellationRequested)return;const Ge=Array.isArray(Je)?new M.$2K(Je):Je,_e=oe.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Ye=new f.$Qc;this.e.set(_e,Ye);const xe=[],it={x:_e,b:xe,a:{replace:P.Range.from(ue),insert:P.Range.from(Ne)},c:Ge.isIncomplete||void 0,d:Be.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const Ue=Ge.items[tt],ut=this.l(Ue,[_e,tt],Ne,ue);xe.push(ut)}return it}async resolveCompletionItem(T,q){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...T);if(!G)return;const Q=this.l(G,T),K=await this.h.resolveCompletionItem(G,q);if(!K)return;const Y=this.l(K,T);return(Q.h!==Y.h||Q.i!==Y.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==Y.n||Q.o!==Y.o||!(0,L.$_m)(Q.p,Y.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:Y.d,c:Y.c,l:Y.l,h:Y.h,i:Y.i,n:Y.n,o:Y.o,p:Y.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,q,G,Q){const K=this.e.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const Y=this.g.toInternal(T.command,K),ue={x:q,a:T.label,b:T.kind!==void 0?P.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(P.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:P.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(P.TextEdit.from),n:Y?.$ident,o:Y?.id,p:Y?.$ident?void 0:Y?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=T.textEdit.newText):typeof T.insertText=="string"?ue.h=T.insertText:T.insertText instanceof M.$FK&&(ue.h=T.insertText.value,ue.i|=4);let Ne;return T.textEdit?Ne=T.textEdit.range:T.range&&(Ne=T.range),M.$wK.isRange(Ne)?ue.j=P.Range.from(Ne):Ne&&(!G?.isEqual(Ne.inserting)||!Q?.isEqual(Ne.replacing))&&(ue.j={insert:P.Range.from(Ne.inserting),replace:P.Range.from(Ne.replacing)}),ue}}class ce{async provideInlineCompletions(T,q,G,Q){}disposeCompletions(T){}handleDidShowCompletionItem(T,q,G){}handlePartialAccept(T,q,G){}}class ve extends ce{constructor(T,q,G,Q){super(),this.f=T,this.g=q,this.h=G,this.j=Q,this.d=new _,this.e=(0,r.$rF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$rF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,q,G,Q){const K=this.g.getDocument(T),Y=P.Position.to(q),ue=await this.h.provideInlineCompletionItems(K,Y,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:P.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!ue||Q.isCancellationRequested)return;const Ne=Array.isArray(ue)?ue:ue.items,Be=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Je=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ne}),items:Ne.map((Ye,xe)=>{let it;Ye.command&&(Ge||(Ge=new f.$Qc),it=this.j.toInternal(Ye.command,Ge));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?P.Range.from(Ye.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:Be.map(Ye=>(Ge||(Ge=new f.$Qc),this.j.toInternal(Ye,Ge))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,q,G){const Q=this.d.get(T)?.items[q];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(T,q,G){const Q=this.d.get(T)?.items[q];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const q=this.e++;return this.d.set(q,T),q}disposeReferenceId(T){const q=this.d.get(T);return this.d.delete(T),q}get(T){return this.d.get(T)}}class W{constructor(T,q){this.e=T,this.f=q,this.d=new n.$Pcc("SignatureHelp")}async provideSignatureHelp(T,q,G,Q){const K=this.e.getDocument(T),Y=P.Position.to(q),ue=this.g(G),Ne=await this.f.provideSignatureHelp(K,Y,Q,ue);if(Ne){const Be=this.d.add([Ne]);return{...P.SignatureHelp.from(Ne),id:Be}}}g(T){let q;if(T.activeSignatureHelp){const G=P.SignatureHelp.to(T.activeSignatureHelp),Q=this.d.get(T.activeSignatureHelp.id,0);Q?(q=Q,q.activeSignature=G.activeSignature,q.activeParameter=G.activeParameter):q=G}return{...T,activeSignatureHelp:q}}releaseSignatureHelp(T){this.d.delete(T)}}class ae{constructor(T,q,G,Q,K){this.f=T,this.g=q,this.h=G,this.j=Q,this.k=K,this.d=new n.$Pcc("InlayHints"),this.e=new Map}async provideInlayHints(T,q,G){const Q=this.f.getDocument(T),K=P.Range.to(q),Y=await this.h.provideInlayHints(Q,K,G);if(!Array.isArray(Y)||Y.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(G.isCancellationRequested)return;const ue=this.d.add(Y);this.e.set(ue,new f.$Qc);const Ne={hints:[],cacheId:ue};for(let Be=0;Be<Y.length;Be++)this.l(Y[Be],K)&&Ne.hints.push(this.m(Y[Be],[ue,Be]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),Ne}async resolveInlayHint(T,q){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.h.resolveInlayHint(G,q);if(Q&&this.l(Q))return this.m(Q,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,q){return T.label.length===0||Array.isArray(T.label)&&T.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(q&&!q.contains(T.position))}m(T,q){const G=this.e.get(q[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:q,tooltip:P.MarkdownString.fromStrict(T.tooltip),position:P.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(P.TextEdit.from),kind:T.kind&&P.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?Q.label=T.label:Q.label=T.label.map(K=>{const Y={label:K.value};return Y.tooltip=P.MarkdownString.fromStrict(K.tooltip),M.$GK.isLocation(K.location)&&(Y.location=P.location.from(K.location)),K.command&&(Y.command=this.g.toInternal(K.command,G)),Y}),Q}}class we{constructor(T,q){this.e=T,this.f=q,this.d=new n.$Pcc("DocumentLink")}async provideLinks(T,q){const G=this.e.getDocument(T),Q=await this.f.provideDocumentLinks(G,q);if(!(!Array.isArray(Q)||Q.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(we.g).map(P.DocumentLink.from)};{const K=this.d.add(Q),Y={links:[],cacheId:K};for(let ue=0;ue<Q.length;ue++){if(!we.g(Q[ue]))continue;const Ne=P.DocumentLink.from(Q[ue]);Ne.cacheId=[K,ue],Y.links.push(Ne)}return Y}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,q){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.f.resolveDocumentLink(G,q);if(!(!Q||!we.g(Q)))return P.DocumentLink.from(Q)}releaseLinks(T){this.d.delete(T)}}class ne{constructor(T,q){this.d=T,this.e=q}async provideColors(T,q){const G=this.d.getDocument(T),Q=await this.e.provideDocumentColors(G,q);return Array.isArray(Q)?Q.map(Y=>({color:P.Color.from(Y.color),range:P.Range.from(Y.range)})):[]}async provideColorPresentations(T,q,G){const Q=this.d.getDocument(T),K=P.Range.to(q.range),Y=P.Color.to(q.color),ue=await this.e.provideColorPresentations(Y,{document:Q,range:K},G);if(Array.isArray(ue))return ue.map(P.ColorPresentation.from)}}class he{constructor(T,q){this.d=T,this.e=q}async provideFoldingRanges(T,q,G){const Q=this.d.getDocument(T),K=await this.e.provideFoldingRanges(Q,q,G);if(Array.isArray(K))return K.map(P.FoldingRange.from)}}class le{constructor(T,q,G){this.d=T,this.e=q,this.f=G}async provideSelectionRanges(T,q,G){const Q=this.d.getDocument(T),K=q.map(P.Position.to),Y=await this.e.provideSelectionRanges(Q,K,G);if(!(0,A.$Kb)(Y))return[];if(Y.length!==K.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Ne=0;Ne<K.length;Ne++){const Be=[];ue.push(Be);let Je=K[Ne],Ge=Y[Ne];for(;;){if(!Ge.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(P.SelectionRange.from(Ge)),!Ge.parent)break;Je=Ge.range,Ge=Ge.parent}}return ue}}class ye{constructor(T,q){this.f=T,this.g=q,this.d=new i.$zM(""),this.e=new Map}async prepareSession(T,q,G){const Q=this.f.getDocument(T),K=P.Position.to(q),Y=await this.g.prepareCallHierarchy(Q,K,G);if(!Y)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(Y)?Y.map(Ne=>this.h(ue,Ne)):[this.h(ue,Y)]}async provideCallsTo(T,q,G){const Q=this.j(T,q);if(!Q)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(K)return K.map(Y=>({from:this.h(T,Y.from),fromRanges:Y.fromRanges.map(ue=>P.Range.from(ue))}))}async provideCallsFrom(T,q,G){const Q=this.j(T,q);if(!Q)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(K)return K.map(Y=>({to:this.h(T,Y.to),fromRanges:Y.fromRanges.map(ue=>P.Range.from(ue))}))}releaseSession(T){this.e.delete(T)}h(T,q){const G=this.e.get(T),Q=P.CallHierarchyItem.from(q,T,G.size.toString(36));return G.set(Q._itemId,q),Q}j(T,q){return this.e.get(T)?.get(q)}}class ee{constructor(T,q){this.f=T,this.g=q,this.d=new i.$zM(""),this.e=new Map}async prepareSession(T,q,G){const Q=this.f.getDocument(T),K=P.Position.to(q),Y=await this.g.prepareTypeHierarchy(Q,K,G);if(!Y)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(Y)?Y.map(Ne=>this.h(ue,Ne)):[this.h(ue,Y)]}async provideSupertypes(T,q,G){const Q=this.j(T,q);if(!Q)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySupertypes(Q,G);if(K)return K.map(Y=>this.h(T,Y))}async provideSubtypes(T,q,G){const Q=this.j(T,q);if(!Q)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySubtypes(Q,G);if(K)return K.map(Y=>this.h(T,Y))}releaseSession(T){this.e.delete(T)}h(T,q){const G=this.e.get(T),Q=P.TypeHierarchyItem.from(q,T,G.size.toString(36));return G.set(Q._itemId,q),Q}j(T,q){return this.e.get(T)?.get(q)}}class fe{static toInternalProviderId(T,q){return T+"."+q}constructor(T,q,G,Q,K){this.d=T,this.e=q,this.f=G,this.g=Q,this.h=K}async provideDocumentOnDropEdits(T,q,G,Q,K){const Y=this.e.getDocument(q),ue=P.Position.to(G),Ne=P.DataTransfer.toDataTransfer(Q,async Je=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Je)).buffer),Be=await this.f.provideDocumentDropEdits(Y,ue,Ne,K);if(Be)return{label:Be.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Be.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:fe.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?P.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class ie{constructor(T,q){this.d=T,this.e=q}async provideMappedEdits(T,q,G,Q){const K=E.URI.revive(T),Y=this.d.getDocument(K),ue=G.documents.map(Je=>Je.map(Ge=>({uri:E.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>P.Range.to(_e))}))),Ne={documents:ue,selections:ue[0]?.[0]?.ranges??[]},Be=await this.e.provideMappedEdits(Y,q,Ne,Q);return Be?P.WorkspaceEdit.from(Be):null}}class se{constructor(T,q){this.adapter=T,this.extension=q}}class me{static{this.d=0}constructor(T,q,G,Q,K,Y,ue,Ne){this.g=q,this.h=G,this.j=Q,this.k=K,this.l=Y,this.m=ue,this.n=Ne,this.f=new Map,this.e=T.getProxy($.$sK.MainThreadLanguageFeatures)}o(T,q){return P.DocumentSelector.from(T,this.g,q)}p(T){return new M.$uK(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return me.d++}async s(T,q,G,Q,K,Y=!1){const ue=this.f.get(T);if(!ue||!(ue.adapter instanceof q))return Q;const Ne=Date.now();Y||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Be=G(ue.adapter,ue.extension);return Promise.resolve(Be).catch(Je=>{(0,a.$3)(Je)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Je),this.n.onExtensionError(ue.extension.identifier,Je))}).finally(()=>{Y||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),v.CancellationToken.isCancellationToken(K)?(0,l.$Jg)(Be,K):Be}t(T,q){const G=this.q();return this.f.set(G,new se(T,q)),G}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,q,G,Q){const K=this.t(new c(this.h,G),T),Y=Q&&Q.label||me.u(T);return this.e.$registerDocumentSymbolProvider(K,this.o(q,T),Y),this.p(K)}$provideDocumentSymbols(T,q,G){return this.s(T,c,Q=>Q.provideDocumentSymbols(E.URI.revive(q),G),void 0,G)}registerCodeLensProvider(T,q,G){const Q=this.q(),K=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new se(new h(this.h,this.j.converter,G),T)),this.e.$registerCodeLensSupport(Q,this.o(q,T),K);let Y=this.p(Q);if(K!==void 0){const ue=G.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(K));Y=M.$uK.from(Y,ue)}return Y}$provideCodeLenses(T,q,G){return this.s(T,h,Q=>Q.provideCodeLenses(E.URI.revive(q),G),void 0,G)}$resolveCodeLens(T,q,G){return this.s(T,h,Q=>Q.resolveCodeLens(q,G),void 0,void 0)}$releaseCodeLenses(T,q){this.s(T,h,G=>Promise.resolve(G.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(T,q,G){const Q=this.t(new m(this.h,G),T);return this.e.$registerDefinitionSupport(Q,this.o(q,T)),this.p(Q)}$provideDefinition(T,q,G,Q){return this.s(T,m,K=>K.provideDefinition(E.URI.revive(q),G,Q),[],Q)}registerDeclarationProvider(T,q,G){const Q=this.t(new I(this.h,G),T);return this.e.$registerDeclarationSupport(Q,this.o(q,T)),this.p(Q)}$provideDeclaration(T,q,G,Q){return this.s(T,I,K=>K.provideDeclaration(E.URI.revive(q),G,Q),[],Q)}registerImplementationProvider(T,q,G){const Q=this.t(new k(this.h,G),T);return this.e.$registerImplementationSupport(Q,this.o(q,T)),this.p(Q)}$provideImplementation(T,q,G,Q){return this.s(T,k,K=>K.provideImplementation(E.URI.revive(q),G,Q),[],Q)}registerTypeDefinitionProvider(T,q,G){const Q=this.t(new d(this.h,G),T);return this.e.$registerTypeDefinitionSupport(Q,this.o(q,T)),this.p(Q)}$provideTypeDefinition(T,q,G,Q){return this.s(T,d,K=>K.provideTypeDefinition(E.URI.revive(q),G,Q),[],Q)}registerHoverProvider(T,q,G,Q){const K=this.t(new w(this.h,G),T);return this.e.$registerHoverProvider(K,this.o(q,T)),this.p(K)}$provideHover(T,q,G,Q){return this.s(T,w,K=>K.provideHover(E.URI.revive(q),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(T,q,G,Q){const K=this.t(new y(this.h,G),T);return this.e.$registerEvaluatableExpressionProvider(K,this.o(q,T)),this.p(K)}$provideEvaluatableExpression(T,q,G,Q){return this.s(T,y,K=>K.provideEvaluatableExpression(E.URI.revive(q),G,Q),void 0,Q)}registerInlineValuesProvider(T,q,G,Q){const K=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,Y=this.t(new C(this.h,G),T);this.e.$registerInlineValuesProvider(Y,this.o(q,T),K);let ue=this.p(Y);if(K!==void 0){const Ne=G.onDidChangeInlineValues(Be=>this.e.$emitInlineValuesEvent(K));ue=M.$uK.from(ue,Ne)}return ue}$provideInlineValues(T,q,G,Q,K){return this.s(T,C,Y=>Y.provideInlineValues(E.URI.revive(q),G,Q,K),void 0,K)}registerDocumentHighlightProvider(T,q,G){const Q=this.t(new B(this.h,G),T);return this.e.$registerDocumentHighlightProvider(Q,this.o(q,T)),this.p(Q)}$provideDocumentHighlights(T,q,G,Q){return this.s(T,B,K=>K.provideDocumentHighlights(E.URI.revive(q),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(T,q,G){const Q=this.t(new j(this.h,G),T);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(q,T)),this.p(Q)}$provideLinkedEditingRanges(T,q,G,Q){return this.s(T,j,async K=>{const Y=await K.provideLinkedEditingRanges(E.URI.revive(q),G,Q);if(Y)return{ranges:Y.ranges,wordPattern:Y.wordPattern?me.w(Y.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(T,q,G){const Q=this.t(new V(this.h,G),T);return this.e.$registerReferenceSupport(Q,this.o(q,T)),this.p(Q)}$provideReferences(T,q,G,Q,K){return this.s(T,V,Y=>Y.provideReferences(E.URI.revive(q),G,Q,K),void 0,K)}registerCodeActionProvider(T,q,G,Q){const K=new f.$Qc,Y=this.t(new z(this.h,this.j.converter,this.k,G,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(Y,this.o(q,T),{providedKinds:Q?.providedCodeActionKinds?.map(ue=>ue.value),documentation:Q?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,K)}))},me.u(T),!!G.resolveCodeAction),K.add(this.p(Y)),K}$provideCodeActions(T,q,G,Q,K){return this.s(T,z,Y=>Y.provideCodeActions(E.URI.revive(q),G,Q,K),void 0,K)}$resolveCodeAction(T,q,G){return this.s(T,z,Q=>Q.resolveCodeAction(q,G),{},void 0)}$releaseCodeActions(T,q){this.s(T,z,G=>Promise.resolve(G.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(T,q,G){const Q=this.t(new O(this.h,G),T);return this.e.$registerDocumentFormattingSupport(Q,this.o(q,T),T.identifier,T.displayName||T.name),this.p(Q)}$provideDocumentFormattingEdits(T,q,G,Q){return this.s(T,O,K=>K.provideDocumentFormattingEdits(E.URI.revive(q),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(T,q,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",K=this.t(new x(this.h,G),T);return this.e.$registerRangeFormattingSupport(K,this.o(q,T),T.identifier,T.displayName||T.name,Q),this.p(K)}$provideDocumentRangeFormattingEdits(T,q,G,Q,K){return this.s(T,x,Y=>Y.provideDocumentRangeFormattingEdits(E.URI.revive(q),G,Q,K),void 0,K)}$provideDocumentRangesFormattingEdits(T,q,G,Q,K){return this.s(T,x,Y=>Y.provideDocumentRangesFormattingEdits(E.URI.revive(q),G,Q,K),void 0,K)}registerOnTypeFormattingEditProvider(T,q,G,Q){const K=this.t(new Z(this.h,G),T);return this.e.$registerOnTypeFormattingSupport(K,this.o(q,T),Q,T.identifier),this.p(K)}$provideOnTypeFormattingEdits(T,q,G,Q,K,Y){return this.s(T,Z,ue=>ue.provideOnTypeFormattingEdits(E.URI.revive(q),G,Q,K,Y),void 0,Y)}registerWorkspaceSymbolProvider(T,q){const G=this.t(new De(q,this.l),T);return this.e.$registerNavigateTypeSupport(G,typeof q.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(T,q,G){return this.s(T,De,Q=>Q.provideWorkspaceSymbols(q,G),{symbols:[]},G)}$resolveWorkspaceSymbol(T,q,G){return this.s(T,De,Q=>Q.resolveWorkspaceSymbol(q,G),void 0,void 0)}$releaseWorkspaceSymbols(T,q){this.s(T,De,G=>G.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(T,q,G){const Q=this.t(new ke(this.h,G,this.l),T);return this.e.$registerRenameSupport(Q,this.o(q,T),ke.supportsResolving(G)),this.p(Q)}$provideRenameEdits(T,q,G,Q,K){return this.s(T,ke,Y=>Y.provideRenameEdits(E.URI.revive(q),G,Q,K),void 0,K)}$resolveRenameLocation(T,q,G,Q){return this.s(T,ke,K=>K.resolveRenameLocation(E.URI.revive(q),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(T,q,G,Q){const K=this.t(new de(this.h,G),T),Y=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(K,this.o(q,T),Q,Y);let ue=this.p(K);if(Y){const Ne=G.onDidChangeSemanticTokens(Be=>this.e.$emitDocumentSemanticTokensEvent(Y));ue=M.$uK.from(ue,Ne)}return ue}$provideDocumentSemanticTokens(T,q,G,Q){return this.s(T,de,K=>K.provideDocumentSemanticTokens(E.URI.revive(q),G,Q),null,Q)}$releaseDocumentSemanticTokens(T,q){this.s(T,de,G=>G.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,q,G,Q){const K=this.t(new be(this.h,G),T);return this.e.$registerDocumentRangeSemanticTokensProvider(K,this.o(q,T),Q),this.p(K)}$provideDocumentRangeSemanticTokens(T,q,G,Q){return this.s(T,be,K=>K.provideDocumentRangeSemanticTokens(E.URI.revive(q),G,Q),null,Q)}registerCompletionItemProvider(T,q,G,Q){const K=this.t(new oe(this.h,this.j.converter,G,this.m,T),T);return this.e.$registerCompletionsProvider(K,this.o(q,T),Q,oe.supportsResolving(G),T.identifier),this.p(K)}$provideCompletionItems(T,q,G,Q,K){return this.s(T,oe,Y=>Y.provideCompletionItems(E.URI.revive(q),G,Q,K),void 0,K)}$resolveCompletionItem(T,q,G){return this.s(T,oe,Q=>Q.resolveCompletionItem(q,G),void 0,G)}$releaseCompletionItems(T,q){this.s(T,oe,G=>G.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(T,q,G,Q){const K=new ve(T,this.h,G,this.j.converter),Y=this.t(K,T);return this.e.$registerInlineCompletionsSupport(Y,this.o(q,T),K.supportsHandleEvents,p.$7l.toKey(T.identifier.value),Q?.yieldTo?.map(ue=>p.$7l.toKey(ue))||[]),this.p(Y)}$provideInlineCompletions(T,q,G,Q,K){return this.s(T,ce,Y=>Y.provideInlineCompletions(E.URI.revive(q),G,Q,K),void 0,K)}$handleInlineCompletionDidShow(T,q,G,Q){this.s(T,ce,async K=>{K.handleDidShowCompletionItem(q,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,q,G,Q){this.s(T,ce,async K=>{K.handlePartialAccept(q,G,Q)},void 0,void 0)}$freeInlineCompletionsList(T,q){this.s(T,ce,async G=>{G.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(T,q,G,Q){const K=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,Y=this.t(new W(this.h,G),T);return this.e.$registerSignatureHelpProvider(Y,this.o(q,T),K),this.p(Y)}$provideSignatureHelp(T,q,G,Q,K){return this.s(T,W,Y=>Y.provideSignatureHelp(E.URI.revive(q),G,Q,K),void 0,K)}$releaseSignatureHelp(T,q){this.s(T,W,G=>G.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(T,q,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,K=this.t(new ae(this.h,this.j.converter,G,this.l,T),T);this.e.$registerInlayHintsProvider(K,this.o(q,T),typeof G.resolveInlayHint=="function",Q,me.u(T));let Y=this.p(K);if(Q!==void 0){const ue=G.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(Q));Y=M.$uK.from(Y,ue)}return Y}$provideInlayHints(T,q,G,Q){return this.s(T,ae,K=>K.provideInlayHints(E.URI.revive(q),G,Q),void 0,Q)}$resolveInlayHint(T,q,G){return this.s(T,ae,Q=>Q.resolveInlayHint(q,G),void 0,G)}$releaseInlayHints(T,q){this.s(T,ae,G=>G.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(T,q,G){const Q=this.t(new we(this.h,G),T);return this.e.$registerDocumentLinkProvider(Q,this.o(q,T),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(T,q,G){return this.s(T,we,Q=>Q.provideLinks(E.URI.revive(q),G),void 0,G,q.scheme==="output")}$resolveDocumentLink(T,q,G){return this.s(T,we,Q=>Q.resolveLink(q,G),void 0,void 0,!0)}$releaseDocumentLinks(T,q){this.s(T,we,G=>G.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(T,q,G){const Q=this.t(new ne(this.h,G),T);return this.e.$registerDocumentColorProvider(Q,this.o(q,T)),this.p(Q)}$provideDocumentColors(T,q,G){return this.s(T,ne,Q=>Q.provideColors(E.URI.revive(q),G),[],G)}$provideColorPresentations(T,q,G,Q){return this.s(T,ne,K=>K.provideColorPresentations(E.URI.revive(q),G,Q),void 0,Q)}registerFoldingRangeProvider(T,q,G){const Q=this.q(),K=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new se(new he(this.h,G),T)),this.e.$registerFoldingRangeProvider(Q,this.o(q,T),T.identifier,K);let Y=this.p(Q);if(K!==void 0){const ue=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(K));Y=M.$uK.from(Y,ue)}return Y}$provideFoldingRanges(T,q,G,Q){return this.s(T,he,K=>K.provideFoldingRanges(E.URI.revive(q),G,Q),void 0,Q)}registerSelectionRangeProvider(T,q,G){const Q=this.t(new le(this.h,G,this.l),T);return this.e.$registerSelectionRangeProvider(Q,this.o(q,T)),this.p(Q)}$provideSelectionRanges(T,q,G,Q){return this.s(T,le,K=>K.provideSelectionRanges(E.URI.revive(q),G,Q),[],Q)}registerCallHierarchyProvider(T,q,G){const Q=this.t(new ye(this.h,G),T);return this.e.$registerCallHierarchyProvider(Q,this.o(q,T)),this.p(Q)}$prepareCallHierarchy(T,q,G,Q){return this.s(T,ye,K=>Promise.resolve(K.prepareSession(E.URI.revive(q),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(T,q,G,Q){return this.s(T,ye,K=>K.provideCallsTo(q,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(T,q,G,Q){return this.s(T,ye,K=>K.provideCallsFrom(q,G,Q),void 0,Q)}$releaseCallHierarchy(T,q){this.s(T,ye,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(T,q,G){const Q=this.t(new ee(this.h,G),T);return this.e.$registerTypeHierarchyProvider(Q,this.o(q,T)),this.p(Q)}$prepareTypeHierarchy(T,q,G,Q){return this.s(T,ee,K=>Promise.resolve(K.prepareSession(E.URI.revive(q),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(T,q,G,Q){return this.s(T,ee,K=>K.provideSupertypes(q,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(T,q,G,Q){return this.s(T,ee,K=>K.provideSubtypes(q,G,Q),void 0,Q)}$releaseTypeHierarchy(T,q){this.s(T,ee,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(T,q,G,Q){const K=this.q();this.f.set(K,new se(new fe(this.e,this.h,G,K,T),T));const Y=(0,r.$rF)(T,"dropMetadata")&&Q?fe.toInternalProviderId(T.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(K,this.o(q,T),Y,(0,r.$rF)(T,"dropMetadata")?Q:void 0),this.p(K)}$provideDocumentOnDropEdits(T,q,G,Q,K,Y){return this.s(T,fe,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(q,E.URI.revive(G),Q,K,Y)),void 0,void 0)}registerMappedEditsProvider(T,q,G){const Q=this.t(new ie(this.h,G),T);return this.e.$registerMappedEditsProvider(Q,this.o(q,T)),this.p(Q)}$provideMappedEdits(T,q,G,Q,K){return this.s(T,ie,Y=>Promise.resolve(Y.provideMappedEdits(q,G,Q,K)),null,K)}registerDocumentPasteEditProvider(T,q,G,Q){const K=this.q();this.f.set(K,new se(new F(this.e,this.h,G,K,T),T));const Y=F.toInternalProviderId(T.identifier.value,Q.id);return this.e.$registerPasteEditProvider(K,this.o(q,T),Y,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(K)}$prepareDocumentPaste(T,q,G,Q,K){return this.s(T,F,Y=>Y.prepareDocumentPaste(E.URI.revive(q),G,Q,K),void 0,K)}$providePasteEdits(T,q,G,Q,K,Y){return this.s(T,F,ue=>ue.providePasteEdits(q,E.URI.revive(G),Q,K,Y),void 0,Y)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:me.w(T.decreaseIndentPattern),increaseIndentPattern:me.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?me.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?me.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:me.w(T.beforeText),afterText:T.afterText?me.w(T.afterText):void 0,previousLineText:T.previousLineText?me.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(me.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(q=>M.SyntaxTokenType.toString(q)):void 0}}static D(T){return T.map(me.C)}setLanguageConfiguration(T,q,G){const{wordPattern:Q}=G;if(Q&&(0,D.$Oe)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(q,Q):this.h.setWordDefinitionFor(q,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const K=this.q(),Y={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(K,q,Y),this.p(K)}$setWordDefinitions(T){for(const q of T)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Ycc=me}),define(Ae[257],Re([1,0,3,8,7,31,12,6,25]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;class g{constructor(S,o,v,p){this.c=o,this.d=v,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$sK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,o){await this.a.$changeLanguage(S,o);const v=this.c.getDocumentData(S);if(!v)throw new Error(`document '${S.toString()}' NOT found`);return v.document}async tokenAtPosition(S,o){const v=S.version,p=L.Position.from(o),f=await this.a.$tokensAtPosition(S.uri,p),t={type:P.StandardTokenType.Other,range:S.getWordRangeAtPosition(o)??new P.$wK(o.line,o.character,o.line,o.character)};if(!f)return t;const i={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!i.range.contains(o)||v!==S.version?t:i}createLanguageStatusItem(S,o,v){const p=this.f++,f=this.a,t=this.g,i=`${S.identifier.value}/${o}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${o}' ALREADY exists`);t.add(i);const n={selector:v,id:o,name:S.displayName??S.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let u;const a=new $.$Qc,l=()=>{if(u?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${o}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}u=(0,R.$Vg)(()=>{a.clear(),this.a.$setLanguageStatus(p,{id:i,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?M.default.Error:n.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},r={dispose(){a.dispose(),u?.dispose(),f.$removeLanguageStatus(p),t.delete(i)},get id(){return n.id},get name(){return n.name},set name(s){n.name=s,l()},get selector(){return n.selector},set selector(s){n.selector=s,l()},get text(){return n.text},set text(s){n.text=s,l()},set text2(s){(0,D.$sF)(S,"languageStatusText"),n.text=s,l()},get text2(){return(0,D.$sF)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(s){n.detail=s,l()},get severity(){return n.severity},set severity(s){n.severity=s,l()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(s){n.accessibilityInformation=s,l()},get command(){return n.command},set command(s){n.command=s,l()},get busy(){return n.busy},set busy(s){n.busy=s,l()}};return l(),r}}e.$Gdc=g}),define(Ae[82],Re([1,0,21,13,2,4,15,3,27,17]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=void 0;let A=class{constructor(o,v,p){this.f=p,this.d=new Map,this.a=v.getProxy($.$sK.MainThreadLocalization),this.b=o.environment.appLanguage,this.c=this.b===E.$g}getMessage(o,v){const{message:p,args:f,comment:t}=v;if(this.c)return(0,L.$De)(p,f??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const n=this.d.get(o)?.contents[i];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,L.$De)(n??p,f??{})}getBundle(o){return this.d.get(o)?.contents}getBundleUri(o){return this.d.get(o)?.uri}async initializeLocalizedMessages(o){if(this.c||!o.l10n&&!o.isBuiltin||this.d.has(o.identifier.value))return;let v;const p=await this.g(o);if(!p){this.f.error(`No bundle location found for extension ${o.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(p),t=JSON.parse(f);v=o.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${o.identifier.value} from ${p}: ${f.message}`);return}v&&this.d.set(o.identifier.value,{contents:v,uri:p})}async g(o){if(o.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(o.identifier.value,this.b);return P.URI.revive(v)}return o.l10n?P.URI.joinPath(o.extensionLocation,o.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$vdc=A,e.$vdc=A=Ke([Ve(0,D.$KM),Ve(1,g.$uM),Ve(2,R.$$i)],A),e.$wdc=(0,M.$Qh)("IExtHostLocalizationService")}),define(Ae[258],Re([1,0,15,3,27,17,2,52]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;let D=class extends E.$jj{constructor(S,o){super(o.logLevel,o.logsLocation,o.loggers.map(v=>(0,$.$nh)(v))),this.r=S.getProxy(L.$sK.MainThreadLogger)}$setLogLevel(S,o){o?this.setLogLevel(R.URI.revive(o),S):this.setLogLevel(S)}setVisibility(S,o){super.setVisibility(S,o),this.r.$setVisibility(S,o)}s(S,o,v){return new g(this.r,S,o,v)}};e.$Yec=D,e.$Yec=D=Ke([Ve(0,M.$uM),Ve(1,P.$KM)],D);class g extends E.$ej{constructor(S,o,v,p){super(p?.logLevel==="always"),this.r=S,this.s=o,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(o,p).then(()=>{this.u(this.n),this.m=!0})}g(S,o){const v=[[S,o]];this.m?this.u(v):this.n.push(...v)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Ae[83],Re([1,0,3,4,6,17,23]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=void 0,e.$xdc=(0,L.$Qh)("IExtHostManagedSockets");let $=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$sK.MainThreadManagedSockets)}setFactory(S,o){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(S,o),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const o=++this.b,v=await this.c.makeConnection(),p=new P.$Qc;return this.d.set(o,new g(o,v,p)),p.add((0,P.$Pc)(()=>this.d.delete(o))),p.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(o),p.dispose()})),p.add(v.onDidClose(f=>{this.a.$onDidManagedSocketClose(o,f?.stack??f?.message),p.dispose()})),p.add(v.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(o,R.$be.wrap(f)))),o}$remoteSocketWrite(S,o){this.d.get(S)?.actual.send(o.buffer)}$remoteSocketEnd(S){const o=this.d.get(S);o&&(o.actual.end(),o.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$ydc=$,e.$ydc=$=Ke([Ve(0,M.$uM)],$);class D{constructor(S,o){this.socketFactoryId=S,this.makeConnection=o}}class g extends P.$Rc{constructor(S,o,v){super(),this.socketId=S,this.actual=o,this.B(v)}}}),define(Ae[259],Re([1,0,3,15,25]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;function M($){return $&&$.title}let R=class{constructor(D,g){this.b=g,this.a=D.getProxy(E.$sK.MainThreadMessageService)}showMessage(D,g,A,S,o){const v={source:{identifier:D.identifier,label:D.displayName||D.name}};let p;typeof S=="string"||M(S)?p=[S,...o]:(v.modal=S?.modal,v.useCustom=S?.useCustom,v.detail=S?.detail,p=o),v.useCustom&&(0,P.$sF)(D,"resolvers");const f=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:u}=i;f.push({title:n,isCloseAffordance:!!u,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,A,v,f).then(t=>{if(typeof t=="number")return p[t]})}};e.$Hdc=R,e.$Hdc=R=Ke([Ve(1,L.$$i)],R)}),define(Ae[260],Re([1,0,18,12,20,5,6,28,2,22,15,3,32,8,7,78,212,25,49]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=e.$Dec=void 0;let u=class{constructor(m,I,k,d,w){this.l=I,this.m=k,this.n=d,this.o=w,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(S.$sK.MainThreadNotebookKernels);const y=new o.$UM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new o.$SM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const B=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:B}}else if(C&&"notebookEditor"in C){const B=this.m.getIdByEditor(C.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return C})],o.$TM.Void);this.n.registerApiCommand(y)}createNotebookController(m,I,k,d,w,y){for(const be of this.i.values())if(be.controller.id===I&&g.$7l.equals(m.identifier,be.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const C=this.j++,B=this;this.o.trace(`NotebookController[${C}], CREATED by ${m.identifier.value}, ${I}`);const j=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${m.identifier}'`);let V=!1;const z=new M.$Nd,F=new M.$Nd,O={id:h(m.identifier,I),notebookType:k,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:d||m.identifier.value,preloads:y?y.map(v.NotebookRendererScript.from):[]};let x=w??j,Z;this.a.$addKernel(C,O).catch(be=>{console.log(be),V=!0});let De=0;const ke=()=>{if(V)return;const be=++De;Promise.resolve().then(()=>{be===De&&this.a.$updateKernel(C,O)})},Ie=new $.$zc,de={get id(){return I},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return O.label},set label(be){O.label=be??m.displayName??m.name,ke()},get detail(){return O.detail??""},set detail(be){O.detail=be,ke()},get description(){return O.description??""},set description(be){O.description=be,ke()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(be){O.supportedLanguages=be,ke()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(be){O.supportsExecutionOrder=be,ke()},get rendererScripts(){return O.preloads?O.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(be){x=be??j},get interruptHandler(){return Z},set interruptHandler(be){Z=be,O.supportsInterrupt=!!be,ke()},createNotebookCellExecution(be){if(V)throw new Error("notebook controller is DISPOSED");if(!Ie.has(be.notebook.uri))throw B.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ie.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.notebook.uri.toString()}`);return B._createNotebookCellExecution(be,h(m.identifier,this.id))},createNotebookExecution(be){if((0,i.$sF)(m,"notebookExecution"),V)throw new Error("notebook controller is DISPOSED");if(!Ie.has(be.uri))throw B.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ie.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.uri.toString()}`);return B._createNotebookExecution(be,h(m.identifier,this.id))},dispose:()=>{V||(this.o.trace(`NotebookController[${C}], DISPOSED`),V=!0,this.i.delete(C),z.dispose(),F.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(be,oe){oe===p.NotebookControllerAffinity2.Hidden&&(0,i.$sF)(m,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(C,be.uri,oe)},onDidReceiveMessage:F.event,postMessage(be,oe){return(0,i.$sF)(m,"notebookMessaging"),B.a.$postMessage(C,oe&&B.m.getIdByEditor(oe),be)},asWebviewUri(be){return(0,i.$sF)(m,"notebookMessaging"),(0,f.$Vtb)(be,B.l.remote)}};return this.i.set(C,{extensionId:m.identifier,controller:de,onDidReceiveMessage:F,onDidChangeSelection:z,associatedNotebooks:Ie}),de}getIdByController(m){for(const[I,k]of this.i)if(k.controller===m)return h(k.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,I){const k=this.f++,d=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(k,I);const w={dispose:()=>{this.e.delete(k),d.a.$removeKernelDetectionTask(k)}};return this.e.set(k,w),w}registerKernelSourceActionProvider(m,I,k){const d=this.h++,w=typeof k.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,y=this;this.g.set(d,k),this.o.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,I);let C;return w!==void 0&&(C=k.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(d),y.a.$removeKernelSourceActionProvider(d,d),C?.dispose()}}}async $provideKernelSourceActions(m,I){const k=this.g.get(m);if(k){const d=new R.$Qc;return(await k.provideNotebookKernelSourceActions(I)??[]).map(y=>v.NotebookKernelSourceAction.from(y,this.n.converter,d))}return[]}$acceptNotebookAssociation(m,I,k){const d=this.i.get(m);if(d){const w=this.m.getNotebookDocument(D.URI.revive(I));k?d.associatedNotebooks.set(w.uri,!0):d.associatedNotebooks.delete(w.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,w.uri.toString(),k),d.onDidChangeSelection.fire({selected:k,notebook:w.apiNotebook})}}async $executeCells(m,I,k){const d=this.i.get(m);if(!d)return;const w=this.m.getNotebookDocument(D.URI.revive(I)),y=[];for(const C of k){const B=w.getCell(C);B&&y.push(B.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,w.uri.toString(),y.length),await d.controller.executeHandler.call(d.controller,y,w.apiNotebook,d.controller)}catch(C){this.o.error(`NotebookController[${m}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(m,I,k){const d=this.i.get(m);if(!d)return;const w=this.m.getNotebookDocument(D.URI.revive(I));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,w.apiNotebook);else for(const y of k){const C=w.getCell(y);C&&this.b.get(C.uri)?.cancel()}if(d.controller.interruptHandler){const y=this.c.get(w.uri);k.length&&Array.isArray(y)&&y.length&&y.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(m,I,k){const d=this.i.get(m);if(!d)return;const w=this.m.getEditorById(I);d.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:k}))}$cellExecutionChanged(m,I,k){const w=this.m.getNotebookDocument(D.URI.revive(m)).getCell(I);if(w){const y=k?v.NotebookCellExecutionState.to(k):p.NotebookCellExecutionState.Idle;y!==void 0&&this.k.fire({cell:w.apiCell,state:y})}}_createNotebookCellExecution(m,I){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const w=new l(I,d,this.a);this.b.set(d.uri,w);const y=w.onDidChangeState(()=>{w.state===a.Resolved&&(w.dispose(),y.dispose(),this.b.delete(d.uri))});return w.asApiObject()}_createNotebookExecution(m,I){const k=this.m.getNotebookDocument(m.uri),d=m.getCells().find(C=>{const B=k.getCellFromApiCell(C);return B&&this.b.has(B.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const w=new s(I,k,this.a),y=w.onDidChangeState(()=>{w.state===r.Resolved&&(w.dispose(),y.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[w,y]),w.asApiObject()}};e.$Dec=u,e.$Dec=u=Ke([Ve(4,A.$$i)],u);var a;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(a||(a={}));class l extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.m=I,this.n=k,this.b=l.a++,this.c=new M.$Nd,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new P.$Xd),this.h=new c(10,d=>this.s(d)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const I=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new n.$rv(I))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let I=this.m;if(m&&(I=this.m.notebook.getCellFromApiCell(m)),!I)throw new Error("INVALID cell");return I.handle}y(m){return m.map(I=>{const k=p.$VL.ensureUniqueMimeTypes(I.items,!0);return k===I.items?v.NotebookCellOutput.from(I):v.NotebookCellOutput.from({items:k,id:I.id,metadata:I.metadata})})}async z(m,I,k){const d=this.w(I),w=this.y((0,E.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:d,append:k,outputs:w})}async C(m,I,k){return m=p.$VL.ensureUniqueMimeTypes((0,E.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(v.NotebookCellOutputItem.from),outputId:I.id,append:k})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(k){m.j=k,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(k){if(m.f===a.Resolved||m.f===a.Started)throw new Error("Cannot call start again");m.f=a.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,d){if(m.f===a.Resolved)throw new Error("Cannot call resolve twice");m.f=a.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new n.$rv({runEndTime:d,lastRunSuccess:k}))},clearOutput(k){return m.t(),m.z([],k,!1)},appendOutput(k,d){return m.t(),m.z(k,d,!0)},replaceOutput(k,d){return m.t(),m.z(k,d,!1)},appendOutputItems(k,d){return m.t(),m.C(k,d,!0)},replaceOutputItems(k,d){return m.t(),m.C(k,d,!1)}})}}var r;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(r||(r={}));class s extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.h=I,this.j=k,this.b=s.a++,this.c=new M.$Nd,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new P.$Xd),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(m,I){this.e=m,this.f=I,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new L.$dh,this.b=Date.now(),(0,L.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>m.complete())}}function h(b,m){return`${b.value}/${m}`}e.$Eec=h}),define(Ae[261],Re([1,0,5,3,107]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class M{constructor($,D){this.c=D,this.a=new Map,this.b=$.getProxy(L.$sK.MainThreadNotebookRenderers)}$postRendererMessage($,D,g){const A=this.c.getEditorById($);this.a.get(D)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging($,D){if(!$.contributes?.notebookRenderer?.some(A=>A.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(A,S,o)=>this.d(D).event(A,S,o),postMessage:(A,S)=>{P.$oec.apiEditorsToExtHost.has(A)&&([A,S]=[S,A]);const o=S&&P.$oec.apiEditorsToExtHost.get(S);return this.b.$postMessage(o?.id,D,A)}}}d($){let D=this.a.get($);return D||(D=new E.$Nd({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete($)}}),this.a.set($,D),D)}}e.$Fec=M}),define(Ae[262],Re([1,0,6,16,2,25,3]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class ${constructor(g){this.b=new Map,this.a=g.getProxy(R.$sK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,S){if((0,M.$sF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,S),this.a.$registerProfileContentHandler(A,S.name,S.description,g.identifier.value),(0,E.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,S,o){const v=this.b.get(g);if(!v)throw new Error(`Unknown handler with id: ${g}`);return v.saveProfile(A,S,o)}async $readProfile(g,A,S){const o=this.b.get(g);if(!o)throw new Error(`Unknown handler with id: ${g}`);return o.readProfile((0,L.$yf)(A)?A:P.URI.revive(A),S)}}e.$Jec=$}),define(Ae[263],Re([1,0,2,3,12,8]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;class R{static{this.a=0}constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(L.$sK.MainThreadQuickDiff)}$provideOriginalResource(D,g,A){const S=E.URI.revive(g),o=this.c.get(D);return o?(0,P.$Mg)(()=>o.provideOriginalResource(S,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,A,S){const o=R.a++;return this.c.set(o,g),this.b.$registerQuickDiffProvider(o,M.DocumentSelector.from(D,this.d),A,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(o),this.c.delete(o)}}}}e.$Kec=R}),define(Ae[264],Re([1,0,20,5,6,3,2,7,11,18,31,45,25,8]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;function p(f,t,i){const n=f.getProxy(M.$sK.MainThreadQuickOpen);class u{constructor(I,k){this.e=new Map,this.f=0,this.a=I,this.b=k}showQuickPick(I,k,d,w=E.CancellationToken.None){this.c=void 0;const y=Promise.resolve(k),C=++this.f,B=n.$show(C,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},w),j={},V=B.then(()=>j);return Promise.race([V,y]).then(z=>{if(z===j)return;const F=(0,o.$rF)(I,"quickPickItemTooltip");return y.then(O=>{const x=[];for(let Z=0;Z<O.length;Z++){const De=O[Z];if(typeof De=="string")x.push({label:De,handle:Z});else if(De.kind===$.QuickPickItemKind.Separator)x.push({type:"separator",label:De.label});else{De.tooltip&&!F&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const ke=De.iconPath?c(De.iconPath):void 0;x.push({label:De.label,iconPath:ke?.iconPath,iconClass:ke?.iconClass,description:De.description,detail:De.detail,picked:De.picked,alwaysShow:De.alwaysShow,tooltip:F?v.MarkdownString.fromStrict(De.tooltip):void 0,handle:Z})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=Z=>{d.onDidSelectItem(O[Z])}),n.$setItems(C,x),B.then(Z=>{if(typeof Z=="number")return O[Z];if(Array.isArray(Z))return Z.map(De=>O[De])})})}).then(void 0,z=>{if(!(0,D.$3)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(I){this.c?.(I)}showInput(I,k=E.CancellationToken.None){return this.d=I?.validateInput,n.$input(I,typeof this.d=="function",k).then(void 0,d=>{if(!(0,D.$3)(d))return Promise.reject(d)})}async $validateInput(I){if(!this.d)return;const k=await this.d(I);if(!k||typeof k=="string")return k;let d;switch(k.severity){case $.InputBoxValidationSeverity.Info:d=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:d=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:d=A.default.Error;break;default:d=k.message?A.default.Error:A.default.Ignore;break}return{content:k.message,severity:d}}async showWorkspaceFolderPick(I,k=E.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!d)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(y=>y.uri.toString()===d.uri.toString())}createQuickPick(I){const k=new h(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(I){const k=new b(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(I,k){this.e.get(I)?._fireDidChangeValue(k)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeActive(k)}$onDidChangeSelection(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeSelection(k)}$onDidTriggerButton(I,k){this.e.get(I)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(I,k,d){const w=this.e.get(I);w instanceof h&&w._fireDidTriggerItemButton(k,d)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class a{static{this.a=1}constructor(I,k){this.x=I,this.y=k,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$Nd,this.q=new L.$Nd,this.r=new L.$Nd,this.s=new L.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((k,d)=>{const w=k===$.$OL.Back?-1:d;this.o.set(w,k)}),this.z({buttons:I.map((k,d)=>({...c(k.iconPath),tooltip:k.tooltip,handle:k===$.$OL.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const k=this.o.get(I);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(I){if(!this.v){for(const k of Object.keys(I)){const d=I[k];this.u[k]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function l(m){if(m instanceof $.$oL)return{id:m.id};const I=s(m),k=r(m);return{dark:typeof I=="string"?R.URI.file(I):I,light:typeof k=="string"?R.URI.file(k):k}}function r(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function c(m){const I=l(m);let k,d;return"id"in I?d=S.ThemeIcon.asClassName(I):k=I,{iconPath:k,iconClass:d}}class h extends a{constructor(I,k){super(I.identifier,k),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$Nd,this.L=[],this.M=new L.$Nd,this.N=new L.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((w,y)=>{this.C.set(y,w),this.D.set(w,y)});const k=(0,o.$rF)(this.O,"quickPickItemTooltip"),d=[];for(let w=0;w<I.length;w++){const y=I[w];if(y.kind===$.QuickPickItemKind.Separator)d.push({type:"separator",label:y.label});else{y.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?c(y.iconPath):void 0;d.push({handle:w,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:k?v.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((B,j)=>({...c(B.iconPath),tooltip:B.tooltip,handle:j}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(I,k){const d=this.C.get(I);if(!d||!d.buttons||!d.buttons.length)return;const w=d.buttons[k];w&&this.N.fire({button:w,item:d})}}class b extends a{constructor(I,k){super(I.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:A.default.Error}):this.z({validationMessage:I.message,severity:I.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new u(t,i)}e.$Ldc=p}),define(Ae[265],Re([1,0,2,5,67,6,12,3,18,138,15,22,45,8,25,14]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=void 0;function i(y){if(y)return typeof y.iconPath=="string"?E.URI.file(y.iconPath):E.URI.isUri(y.iconPath)||o.ThemeIcon.isThemeIcon(y.iconPath)?y.iconPath:void 0}function n(y){if(y?.icon){if(E.URI.isUri(y.icon))return y.icon;if(o.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function u(y){if(y.icon){if(E.URI.isUri(y.icon))return y.icon;if(o.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function a(y,C){if(!y.iconPath&&!C.iconPath)return 0;if(y.iconPath){if(!C.iconPath)return 1}else return-1;const B=typeof y.iconPath=="string"?y.iconPath:E.URI.isUri(y.iconPath)?y.iconPath.fsPath:y.iconPath.id,j=typeof C.iconPath=="string"?C.iconPath:E.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,g.$sq)(B,j)}function l(y,C){let B=0;if(y.strikeThrough!==C.strikeThrough)return y.strikeThrough?1:-1;if(y.faded!==C.faded)return y.faded?1:-1;if(y.tooltip!==C.tooltip)return(y.tooltip||"").localeCompare(C.tooltip||"");if(B=a(y,C),B!==0)return B;if(y.light&&C.light)B=a(y.light,C.light);else{if(y.light)return 1;if(C.light)return-1}if(B!==0)return B;if(y.dark&&C.dark)B=a(y.dark,C.dark);else{if(y.dark)return 1;if(C.dark)return-1}return B}function r(y,C){if(y.command!==C.command)return y.command<C.command?-1:1;if(y.title!==C.title)return y.title<C.title?-1:1;if(y.tooltip!==C.tooltip){if(y.tooltip!==void 0&&C.tooltip!==void 0)return y.tooltip<C.tooltip?-1:1;if(y.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(y.arguments===C.arguments)return 0;if(y.arguments)if(C.arguments){if(y.arguments.length!==C.arguments.length)return y.arguments.length-C.arguments.length}else return 1;else return-1;for(let B=0;B<y.arguments.length;B++){const j=y.arguments[B],V=C.arguments[B];if(j!==V)return j<V?-1:1}return 0}function s(y,C){let B=(0,g.$sq)(y.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(B!==0)return B;if(y.command&&C.command)B=r(y.command,C.command);else{if(y.command)return 1;if(C.command)return-1}if(B!==0)return B;if(y.decorations&&C.decorations)B=l(y.decorations,C.decorations);else{if(y.decorations)return 1;if(C.decorations)return-1}return B}function c(y,C){for(let B=0;B<y.length;B++)if(y[B]!==C[B])return!1;return!0}function h(y,C){return y.command===C.command&&y.title===C.title&&y.tooltip===C.tooltip&&(y.arguments&&C.arguments?c(y.arguments,C.arguments):y.arguments===C.arguments)}function b(y,C){return(0,D.$tb)(y,C,h)}function m(y,C){return y===C?!0:!y||!C?!1:y.id===C.id&&y.label===C.label&&y.upstream?.id===C.upstream?.id&&y.upstream?.label===C.upstream?.label}class I{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,p.$sF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,p.$sF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,p.$sF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,p.$sF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=C;const B=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:n(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,B??null)}get document(){return(0,p.$sF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,B,j,V,z,F){this.m=C,this.n=B,this.o=z,this.p=F,this.d="",this.e=new L.$Nd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=j,this.#e=V}showValidationMessage(C,B){(0,p.$sF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,B)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$Mdc=I;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,B,j,V,z){this.q=C,this.s=B,this.t=j,this.u=V,this.v=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,B){const j=this.h.get(C);return j?(0,R.$Mg)(()=>this.s.executeCommand(j.command,...j.arguments||[],B)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(s),j=(0,D.$Cb)(this.o,C,s).map(F=>{const O=F.toInsert.map(x=>{const Z=this.e++;this.g.set(Z,x);const De=x.resourceUri;let ke;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const we=new M.$Qc;ke=this.s.converter.toInternal(x.command,we),this.j.set(Z,we)}else this.h.set(Z,x.command);const Ie=i(x.decorations),de=x.decorations&&i(x.decorations.light)||Ie,be=x.decorations&&i(x.decorations.dark)||Ie,oe=[de,be],ce=x.decorations&&x.decorations.tooltip||"",ve=x.decorations&&!!x.decorations.strikeThrough,_=x.decorations&&!!x.decorations.faded,W=x.contextValue||"";return{rawResource:[Z,De,oe,ce,ve,_,W,ke],handle:Z}});return{start:F.start,deleteCount:F.deleteCount,toInsert:O}}),V=j.map(({start:F,deleteCount:O,toInsert:x})=>[F,O,x.map(Z=>Z.rawResource)]),z=j.reverse();for(const{start:F,deleteCount:O,toInsert:x}of z){const Z=x.map(ke=>ke.handle),De=this.n.splice(F,O,...Z);for(const ke of De)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=C,V}dispose(){this.l=!0,this.m.fire()}}class d{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let B;(0,p.$rF)(this.y,"quickDiffProvider")&&(B=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:B})}get historyProvider(){return(0,p.$sF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,p.$sF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{m(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,p.$sF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const B=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,B??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new M.$Qc,this.p=C;const B=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:B})}get actionButton(){return(0,p.$sF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,p.$sF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=C;const B=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(j=>j.map(V=>this.z.converter.toInternal(V,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:B??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&b(this.u,C))return;this.t.value=new M.$Qc,this.u=C;const B=(C||[]).map(j=>this.z.converter.toInternal(j,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:B})}get selected(){return this.v}constructor(C,B,j,V,z,F,O){this.y=C,this.z=V,this.A=z,this.B=F,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new L.$Nd,this.onDidChangeSelection=this.w.event,this.x=d.d++,this.D=new Map,this.E=new Set,this.#e=j;const x=E.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${z}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new I(C,V,B,this.#e,this.x,x),this.#e.$registerSourceControl(this.x,z,F,O,x)}createResourceGroup(C,B){const j=new k(this.#e,this.z,this.x,C,B),V=L.Event.once(j.onDidDispose)(()=>this.D.delete(j));return this.D.set(j,V),this.eventuallyAddResourceGroups(),j}eventuallyAddResourceGroups(){const C=[],B=[];for(const[j,V]of this.D){V.dispose();const z=j.onDidUpdateResourceStates(()=>{this.E.add(j),this.eventuallyUpdateResourceStates()});L.Event.once(j.onDidDispose)(()=>{this.E.delete(j),z.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.x,j.handle)}),C.push([j.handle,j.id,j.label,j.features]);const F=j._takeResourceStateSnapshot();F.length>0&&B.push([j.handle,F]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.x,C,B),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(B=>{const j=B._takeResourceStateSnapshot();j.length!==0&&C.push([B.handle,j])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$jh)(100)],d.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$jh)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,B,j,V){this.l=B,this.m=j,this.n=V,this.g=new Map,this.h=new S.$9l,this.j=new L.$Nd,this.e=C.getProxy($.$sK.MainThreadSCM),this.f=C.getProxy($.$sK.MainThreadTelemetry),B.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const F=this.g.get(z.sourceControlHandle);if(!F)return z;const O=F.getResourceGroup(z.groupHandle);return O?O.getResourceState(z.handle):z}else if(z&&z.$mid===4){const F=this.g.get(z.sourceControlHandle);return F?F.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const F=this.g.get(z.handle);return F||z}return z}})}createSourceControl(C,B,j,V){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,B,j,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const z=t.d++,F=new d(C,this.m,this.e,this.l,B,j,V);this.g.set(z,F);const O=this.h.get(C.identifier)||[];return O.push(F),this.h.set(C.identifier,O),F}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const B=this.h.get(C.identifier),j=B&&B[B.length-1];return j&&j.inputBox}$provideOriginalResource(C,B,j){const V=E.URI.revive(B);this.n.trace("ExtHostSCM#$provideOriginalResource",C,V.toString());const z=this.g.get(C);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Mg)(()=>z.quickDiffProvider.provideOriginalResource(V,j)).then(F=>F||null)}$onInputBoxValueChange(C,B){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const j=this.g.get(C);return j&&j.inputBox.$onInputBoxValueChange(B),Promise.resolve(void 0)}$executeResourceCommand(C,B,j,V){this.n.trace("ExtHostSCM#$executeResourceCommand",C,B,j);const z=this.g.get(C);if(!z)return Promise.resolve(void 0);const F=z.getResourceGroup(B);return F?F.$executeResourceCommand(j,V):Promise.resolve(void 0)}$validateInput(C,B,j){this.n.trace("ExtHostSCM#$validateInput",C);const V=this.g.get(C);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Mg)(()=>V.inputBox.validateInput(B,j)).then(z=>{if(!z)return Promise.resolve(void 0);const F=v.MarkdownString.fromStrict(z.message);return F?Promise.resolve([F,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,B,j){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(B,j)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,B,j,V){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(B,j,V)??void 0}async $provideHistoryItems(C,B,j,V){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(B,j,V))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:u(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(C,B,j){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(B,j)??void 0}};e.$Ndc=w,e.$Ndc=w=t=Ke([Ve(3,A.$$i)],w)}),define(Ae[84],Re([1,0,3,5,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=e.$sdc=void 0;class M{constructor($){this.b=new L.$Nd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$sK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,D){return this.a.$getPassword($,D)}store($,D,g){return this.a.$setPassword($,D,g)}delete($,D){return this.a.$deletePassword($,D)}}e.$sdc=M,e.$tdc=(0,P.$Qh)("IExtHostSecretState")}),define(Ae[266],Re([1,0,3,8,2]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class M{static{this.a=0}constructor($,D){this.d=D,this.c=new Map,this.b=$.getProxy(E.$sK.MainThreadShare)}async $provideShare($,D,g){return await this.c.get($)?.provideShare({selection:L.Range.to(D.selection),resourceUri:P.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider($,D){const g=M.a++;return this.c.set(g,D),this.b.$registerShareProvider(g,L.DocumentSelector.from($,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$Pec=M}),define(Ae[267],Re([1,0,20,6,3]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(P.$sK.MainThreadSpeech)}async $createSpeechToTextSession($,D){const g=this.c.get($);if(!g)return;const A=new L.$Qc,S=new E.$Xd;this.d.set(D,S);const o=A.add(g.provideSpeechToTextSession(S.token));A.add(o.onDidChange(v=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(D,v)})),A.add(S.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,D,g){const A=M.a++;return this.c.set(A,g),this.b.$registerProvider(A,D,{extension:$,displayName:$.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Rec=M}),define(Ae[268],Re([1,0,7,3,165,6,8,16]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$pL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$pL("statusBarItem.warningForeground")]])}#e;#t;constructor(o,v,p,f,t,i=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=o,this.#t=v,t&&f){this.c=(0,E.$5K)(f.identifier,t);const u=p.get(this.c);u&&(i=u.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=u.priority,this.j=!0,this.name=u.name,this.text=u.text,this.tooltip=u.tooltip,this.command=u.command,this.accessibilityInformation=u.accessibilityInformation)}else this.c=String(D.a++);this.e=f,this.f=t,this.g=i,this.h=this.u(n)}u(o){if((0,$.$Cf)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(o){this.k=o,this.v()}set name(o){this.m=o,this.v()}set tooltip(o){this.l=o,this.v()}set color(o){this.n=o,this.v()}set backgroundColor(o){o&&!D.b.has(o.id)&&(o=void 0),this.o=o,this.v()}set command(o){this.r?.fromApi!==o&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof o=="string"?this.r={fromApi:o,internal:this.#t.toInternal({title:"",command:o},this.p)}:o?this.r={fromApi:o,internal:this.#t.toInternal(o,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(o){this.t=o,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let o;this.e?this.f?o=`${this.e.identifier.value}.${this.f}`:o=this.e.identifier.value:o=this.f;let v;this.m?v=this.m:v=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=D.b.get(this.o.id));const f=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,o,this.e?.identifier.value,v,this.k,f,this.r?.internal,p,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Odc=D;class g{constructor(o){this.b=[],this.a=o.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(o){const v={message:o};return this.b.unshift(v),this.c(),new E.$uK(()=>{const p=this.b.indexOf(v);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(o,v){this.e=new Map,this.a=o.getProxy(L.$sK.MainThreadStatusBar),this.b=v,this.c=new g(this)}$acceptStaticEntries(o){for(const v of o)this.e.set(v.entryId,v)}createStatusBarEntry(o,v,p,f){return new D(this.a,this.b,this.e,o,v,p,f)}setStatusBarMessage(o,v){const p=this.c.setMessage(o);let f;return typeof v=="number"?f=setTimeout(()=>p.dispose(),v):typeof v<"u"&&v.then(()=>p.dispose(),()=>p.dispose()),new E.$uK(()=>{p.dispose(),clearTimeout(f)})}}e.$Pdc=A}),define(Ae[85],Re([1,0,3,5,4]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=e.$gdc=void 0;class M{constructor($,D){this.c=D,this.b=new L.$Nd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$sK.MainThreadStorage)}registerExtensionStorageKeysToSync($,D){this.a.$registerExtensionStorageKeysToSync($,D)}async initializeExtensionStorage($,D,g){const A=await this.a.$initializeExtensionStorage($,D);let S;return A&&(S=this.d($,D,A)),S||g}setValue($,D,g){return this.a.$setValue($,D,g)}$acceptValue($,D,g){const A=this.d($,D,g);A&&this.b.fire({shared:$,key:D,value:A})}d($,D,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${$}): ${A}`)}}}e.$gdc=M,e.$hdc=(0,P.$Qh)("IExtHostStorage")}),define(Ae[86],Re([1,0,4,27,15,64,2]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=void 0,e.$mdc=(0,E.$Qh)("IExtensionStoragePaths");let $=class{constructor(g,A,S){this.d=A,this.f=S,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(o=>this.c=o)}async g(g){return R.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(g){if(this.c)return R.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return R.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ndc=$,e.$ndc=$=Ke([Ve(0,L.$KM),Ve(1,P.$$i),Ve(2,M.$ldc)],$)}),define(Ae[65],Re([1,0,5,3,4,2,17,6,7,167,11,195,20,38,196,45,12,8,32]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=e.$pdc=e.$odc=void 0,e.$odc=(0,P.$Qh)("IExtHostTerminalService");class u{constructor(d,w,y,C){this.l=d,this._id=w,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(j=>this.f=j);const B=this;this.value={get name(){return B.n||""},get processId(){return B.b},get creationOptions(){return B.m},get exitStatus(){return B.h},get state(){return B.j},get selection(){return B.k},sendText(j,V=!0){B.q(),B.l.$sendText(B._id,j,V)},show(j){B.q(),B.l.$show(B._id,j)},hide(){B.q(),B.l.$hide(B._id)},dispose(){B.a||(B.a=!0,B.l.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(d,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??w?.cwd??void 0,env:d.env??void 0,icon:b(d.iconPath)??void 0,color:f.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(d.location,w?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,w,y,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:y,color:f.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o(d,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(d,w){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in d?{viewColumn:i.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.n=d}setExitStatus(d,w){this.h=Object.freeze({code:d,reason:w})}setDimensions(d,w){return d===this.d&&w===this.g||d===0||w===0?!1:(this.d=d,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(d){this.k=d}_setProcessId(d){this.f?(this.f(d),this.f=void 0):this.b.then(w=>{w!==d&&(this.b=Promise.resolve(d))})}}e.$pdc=u;class a{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new E.$Nd,this.onProcessData=this.a.event,this.b=new E.$Nd,this.d=new E.$Nd,this.onDidChangeProperty=this.d.event,this.f=new E.$Nd,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,w){this.g.setDimensions?.({columns:d,rows:w})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,r=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,w,y){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Nd,this.onDidChangeShell=this.N.event,this.O=new E.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(L.$sK.MainThreadTerminalService),this.y=new p.$$pb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:C=>{const B=j=>{const V=j;return this.W(V.instanceId)?.value};switch(C?.$mid){case 15:return B(C);default:{if(Array.isArray(C))for(let j=0;j<C.length&&C[j].$mid===15;j++)C[j]=B(C[j]);return C}}}}),this.B({dispose:()=>{for(const[C,B]of this.g)B.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,w){const y=new u(this.a,(0,v.$eg)(),d,d.name),C=new a(d.pty);return y.createExtensionTerminal(d.location,this.R(d,w).resolvedExtHostIdentifier,b(d.iconPath),m(d.color)).then(B=>{const j=this.S(B,C);this.h[B]=j}),this.f.push(y),y.value}R(d,w){if(w=w||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const y=d.location.parentTerminal;if(y){const C=this.f.find(B=>B.value===y);C&&(w.resolvedExtHostIdentifier=C._id)}}else d.location&&typeof d.location!="object"?w.location=d.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(d,w){if(!this.W(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const C=new a(w),B=this.S(d,C);this.h[d]=B}async $acceptActiveTerminalChanged(d){const w=this.b;if(d===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const y=this.W(d);y&&(this.b=y,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,w){const y=this.W(d);y&&this.O.fire({terminal:y.value,data:w})}async $acceptTerminalDimensions(d,w,y){const C=this.W(d);C&&C.setDimensions(w,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(d,w){const y=this.W(d);y&&this.P.fire({terminal:y.value,...w})}async $acceptTerminalMaximumDimensions(d,w,y){this.g.get(d)?.resize(w,y)}async $acceptTerminalTitleChange(d,w){const y=this.W(d);y&&(y.name=w)}async $acceptTerminalClosed(d,w,y){const C=this.Y(this.f,d);if(C!==null){const B=this.f.splice(C,1)[0];B.setExitStatus(w,y),this.H.fire(B.value)}}$acceptTerminalOpened(d,w,y,C){if(w){const V=this.Y(this.f,w);if(V!==null){this.f[V]._id=d,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const B={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:M.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},j=new u(this.a,d,B,y);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(d,w){this.W(d)?._setProcessId(w)}async $startExtensionTerminal(d,w){const y=this.W(d);if(!y)return{message:(0,g.localize)(0,null,d)};y.isOpen||await new Promise(B=>{const j=this.onDidOpenTerminal(async V=>{V===y.value&&(j.dispose(),B())})});const C=this.g.get(d);C?C.startSendingEvents(w):this.j[d]={initialDimensions:w}}S(d,w){const y=new $.$Qc;y.add(w.onProcessReady(B=>this.a.$sendProcessReady(d,B.pid,B.cwd,B.windowsPty))),y.add(w.onDidChangeProperty(B=>this.a.$sendProcessProperty(d,B))),this.y.startBuffering(d,w.onProcessData),y.add(w.onProcessExit(B=>this.U(d,B))),this.g.set(d,w);const C=this.j[d];return C&&w instanceof a&&(w.startSendingEvents(C.initialDimensions),delete this.j[d]),y}$acceptProcessAckDataEvent(d,w){this.g.get(d)?.acknowledgeDataEvent(w)}$acceptProcessInput(d,w){this.g.get(d)?.input(w)}$acceptTerminalInteraction(d){const w=this.W(d);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(d,w){this.W(d)?.setSelection(w)}$acceptProcessResize(d,w,y){try{this.g.get(d)?.resize(w,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(d,w){this.g.get(d)?.shutdown(w)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(w=>this.a.$sendProcessProperty(d,{type:"cwd",value:w}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new D.$uK(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,w,y){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,y),this.a.$registerProfileProvider(w,d.identifier.value),new D.$uK(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(d,w,y){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,y),this.a.$registerQuickFixProvider(d,w),new D.$uK(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,w){const y=new o.$Xd().token;if(y.isCancellationRequested)return;const C=this.D.get(d);if(!C)return;const B=await C.provideTerminalQuickFixes(w,y);if(B===null||Array.isArray(B)&&B.length===0)return;const j=new $.$Qc;if(this.w.value=j,!Array.isArray(B))return B?i.TerminalQuickFix.from(B,this.Q.converter,j):void 0;const V=[];for(const z of B){const F=i.TerminalQuickFix.from(z,this.Q.converter,j);F&&V.push(F)}return V}async $createContributedProfileTerminal(d,w){const y=new o.$Xd().token;let C=await this.C.get(d)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,w);return}this.createTerminalFromOptions(C.options,w)}}async $provideLinks(d,w){const y=this.W(d);if(!y)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const B=new o.$Xd;this.G.set(d,B);const j=[],V={terminal:y.value,line:w},z=[];for(const x of this.z)z.push(t.Promises.withAsyncBody(async Z=>{B.token.onCancellationRequested(()=>Z({provider:x,links:[]}));const De=await x.provideTerminalLinks(V,B.token)||[];B.token.isCancellationRequested||Z({provider:x,links:De})}));const F=await Promise.all(z);if(B.token.isCancellationRequested)return[];const O=new Map;for(const x of F)x&&x.links.length>0&&j.push(...x.links.map(Z=>{const De={id:l++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return O.set(De.id,{provider:x.provider,link:Z}),De}));return this.F.set(d,O),j}$activateLink(d,w){const y=this.F.get(d)?.get(w);y&&y.provider.handleTerminalLink(y.link)}U(d,w){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const y=this.h[d];y&&(y.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,w)}W(d){return this.X(this.f,d)}X(d,w){const y=this.Y(d,w);return y!==null?d[y]:null}Y(d,w){const y=d.findIndex(C=>C._id===w);return y===-1?null:y}getEnvironmentVariableCollection(d){let w=this.n.get(d.identifier.value);return w||(w=new s,this.$(d.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(d,w){const y=(0,S.$lr)(w.map),C=(0,S.$mr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(d,w.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(d){d.forEach(w=>{const y=w[0],C=new s(w[1]);this.$(y,C)})}$acceptDefaultProfile(d,w){const y=this.s;this.s=d,this.u=w,y?.path!==d.path&&this.N.fire(d.path)}$(d,w){this.n.set(d,w),w.onDidChangeCollection(()=>{this.Z(d,w)})}};e.$qdc=r,e.$qdc=r=Ke([Ve(1,n.$QM),Ve(2,R.$uM)],r);class s{get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Nd,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const w=this.h(d);let y=this.a.get(w);return y||(y=new c(this,d),this.a.set(w,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(d,w,y,C){this.f(d,{value:w,type:D.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(d,w,y,C){this.f(d,{value:w,type:D.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(d,w,y,C){this.f(d,{value:w,type:D.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(d,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(d,w.scope),C=this.map.get(y),B=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==w.value||C.type!==w.type||C.options?.applyAtProcessCreation!==B.applyAtProcessCreation||C.options?.applyAtShellIntegration!==B.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const j=this.g(d,w.scope),V={variable:d,...w,options:B};this.map.set(j,V),this.d.fire()}}get(d,w){const y=this.g(d,w),C=this.map.get(y);return C?I(C):void 0}g(d,w){const y=this.h(w);return y.length?`${d}:::${y}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const w=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(d)&&w.set(C.variable,I(C));return w}delete(d,w){const y=this.g(d,w);this.map.delete(y),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[w,y]of this.map)y.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(w);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,w){const y=this.h(w),C=this.descriptionMap.get(y);if(!C||C.description!==d){let B;typeof d=="string"?B=d:B=d?.value.split(`

`)[0];const j={description:B,scope:w};this.descriptionMap.set(y,j),this.d.fire()}}getDescription(d){const w=this.h(d);return this.descriptionMap.get(w)?.description}k(d){const w=this.h(d);this.descriptionMap.delete(w)}}class c{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,w){this.b=d,this.d=w,this.a=new E.$Nd}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,w,y){this.b.replace(d,w,y,this.d)}append(d,w,y){this.b.append(d,w,y,this.d)}prepend(d,w,y){this.b.prepend(d,w,y,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,w){this.b.getVariableMap(this.d).forEach((y,C)=>d.call(w,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends r{constructor(d,w){super(!1,d,w)}createTerminal(d,w,y){throw new A.$$}createTerminalFromOptions(d,w){throw new A.$$}};e.$rdc=h,e.$rdc=h=Ke([Ve(0,n.$QM),Ve(1,R.$uM)],h);function b(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function m(k){return f.ThemeColor.isThemeColor(k)?k:void 0}function I(k){const d={...k};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Ae[269],Re([1,0,300,12,23,20,5,220,97,6,26,16,38,3,17,108,8,7,48,77,60]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=e.$Aec=e.$zec=e.$yec=void 0;let l=class{constructor(j,V,z){this.j=z,this.c=new R.$Nd,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=j.getProxy(v.$sK.MainThreadTesting),this.h=new w(this.f),this.g=new h(this.f),V.registerArgumentProcessor({processArgument:F=>{switch(F?.$mid){case 16:{const O=F,x=O.tests[O.tests.length-1].item.extId;return this.d.get(n.$iJ.root(x))?.collection.tree.get(x)?.actual??(0,f.$GM)(F)}case 18:{const{extId:O,message:x}=F;return{test:this.d.get(n.$iJ.root(O))?.collection.tree.get(O)?.actual,message:t.TestMessage.to(x)}}default:return F}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await V.executeCommand("_testing.getExplorerSelection"),O=x=>{const Z=this.d.get(n.$iJ.root(x));if(Z)return n.$iJ.isRoot(x)?Z.controller:Z.collection.tree.get(x)?.actual};return{include:F?.include.map(O).filter(S.$Gf)||[],exclude:F?.exclude.map(O).filter(S.$Gf)||[]}})}createTestController(j,V,z,F){if(this.d.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const O=new g.$Qc,x=O.add(new f.$JM(V,z,this.j));x.root.label=z;const Z=new Map,De=this.f,ke={items:x.root.children,get label(){return z},set label(de){z=de,x.root.label=de,De.$updateController(V,{label:z})},get refreshHandler(){return F},set refreshHandler(de){F=de,De.$updateController(V,{canRefresh:!!de})},get id(){return V},createRunProfile:(de,be,oe,ce,ve,_)=>{let W=(0,D.$Ei)(de);for(;Z.has(W);)W++;return new y(this.f,Z,V,W,de,be,oe,ce,ve,_)},createTestItem(de,be,oe){return new f.$HM(V,de,be,oe)},createTestRun:(de,be,oe=!0)=>this.g.createTestRun(j,V,x,de,be,oe),invalidateTestResults:de=>{if(de===void 0)this.f.$markTestRetired(void 0);else{const be=de instanceof Array?de:[de];this.f.$markTestRetired(be.map(oe=>n.$iJ.fromExtHostTestItem(oe,V).toString()))}},set resolveHandler(de){x.resolveHandler=de},get resolveHandler(){return x.resolveHandler},dispose:()=>{O.dispose()}};De.$registerTestController(V,z,!!F),O.add((0,g.$Pc)(()=>De.$unregisterTestController(V)));const Ie={controller:ke,collection:x,profiles:Z,extension:j};return this.d.set(V,Ie),O.add((0,g.$Pc)(()=>this.d.delete(V))),O.add(x.onDidGenerateDiff(de=>De.$publishDiff(V,de.map(a.TestsDiffOp.serialize)))),ke}createTestObserver(){return this.h.checkout()}async runTests(j,V=M.CancellationToken.None){const z=b(j);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.d.get(z.controllerId);if(!F)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(O=>n.$iJ.fromExtHostTestItem(O,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:C[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:j.exclude?.map(O=>O.id)},V)}$syncTests(){for(const{collection:j}of this.d.values())j.flushDiff();return Promise.resolve()}$provideFileCoverage(j,V,z){return(0,E.$qb)(this.g.trackers,O=>O.id===j?O.getCoverage(V):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(j,V,z,F){return(0,E.$qb)(this.g.trackers,x=>x.id===j?x.getCoverage(V):void 0)?.resolveFileCoverage(z,F)??Promise.resolve([])}$configureRunProfile(j,V){this.d.get(j)?.profiles.get(V)?.configureHandler?.()}async $refreshTests(j,V){await this.d.get(j)?.controller.refreshHandler?.(V)}$publishTestResults(j){this.results=Object.freeze(j.map(V=>(0,A.$9m)(t.TestResults.to(V))).concat(this.results).sort((V,z)=>z.completedAt-V.completedAt).slice(0,32)),this.c.fire()}async $expandTest(j,V){const z=this.d.get(n.$iJ.fromString(j).controllerId)?.collection;z&&(await z.expand(j,V<0?1/0:V),z.flushDiff())}$acceptDiff(j){this.h.applyDiff(j.map(a.TestsDiffOp.deserialize))}async $runControllerTests(j,V){return Promise.all(j.map(z=>this.k(z,!1,V)))}async $startContinuousRun(j,V){const z=new M.$Xd(V),F=await Promise.all(j.map(O=>this.k(O,!0,z.token)));return!V.isCancellationRequested&&!F.some(O=>O.error)&&await new Promise(O=>V.onCancellationRequested(O)),z.dispose(!0),F}async k(j,V,z){const F=this.d.get(j.controllerId);if(!F)return{};const{collection:O,profiles:x,extension:Z}=F,De=x.get(j.profileId);if(!De)return{};const ke=j.testIds.map(oe=>O.tree.get(oe)).filter(S.$Gf),Ie=j.excludeExtIds.map(oe=>F.collection.tree.get(oe)).filter(S.$Gf).filter(oe=>ke.some(ce=>ce.fullId.compare(oe.fullId)===2));if(!ke.length)return{};const de=new i.$3L(ke.some(oe=>oe.actual instanceof f.$IM)?void 0:ke.map(oe=>oe.actual),Ie.map(oe=>oe.actual),De,V),be=(0,a.$kJ)(j)&&this.g.prepareForMainThreadTestRun(de,m.fromInternal(j,F.collection),Z,z);try{return await De.runHandler(de,z),{}}catch(oe){return{error:String(oe)}}finally{be&&(be.hasRunningTasks&&!z.isCancellationRequested&&await R.Event.toPromise(be.onEnd),be.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.g.cancelAllRuns():this.g.cancelRunById(j)}};e.$yec=l,e.$yec=l=Ke([Ve(0,p.$uM)],l);const r=1e4;var s;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(s||(s={}));class c extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(j,V,z){super(),this.m=j,this.s=V,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Nd),this.onEnd=this.j.event,this.h=this.B(new M.$Xd(z));const F=this.B(new L.$7g(()=>this.u(),r));this.B(this.h.token.onCancellationRequested(()=>F.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(j){return this.f.get(j)?.coverage}createRun(j){const V=this.m.id,z=this.m.controllerId,F=(0,o.$eg)(),O=new I(this.s,V,F),x=Ie=>(de,...be)=>{if(De){console.warn(`Setting the state of test "${de.id}" is a no-op after the run ends.`);return}this.m.isIncluded(de)&&(this.y(de),Ie(de,...be))},Z=(Ie,de)=>{const be=de instanceof Array?de.map(t.TestMessage.from):[t.TestMessage.from(de)];if(Ie.uri&&Ie.range){const oe={range:t.Range.from(Ie.range),uri:Ie.uri};for(const ce of be)ce.location=ce.location||oe}this.s.$appendTestMessagesInRun(V,F,n.$iJ.fromExtHostTestItem(Ie,z).toString(),be)};let De=!1;const ke={isPersisted:this.m.isPersisted,token:this.h.token,name:j,get coverageProvider(){return O.coverageProvider},set coverageProvider(Ie){O.coverageProvider=Ie},enqueued:x(Ie=>{this.s.$updateTestStateInRun(V,F,n.$iJ.fromExtHostTestItem(Ie,z).toString(),1)}),skipped:x(Ie=>{this.s.$updateTestStateInRun(V,F,n.$iJ.fromExtHostTestItem(Ie,z).toString(),5)}),started:x(Ie=>{this.s.$updateTestStateInRun(V,F,n.$iJ.fromExtHostTestItem(Ie,z).toString(),2)}),errored:x((Ie,de,be)=>{Z(Ie,de),this.s.$updateTestStateInRun(V,F,n.$iJ.fromExtHostTestItem(Ie,z).toString(),6,be)}),failed:x((Ie,de,be)=>{Z(Ie,de),this.s.$updateTestStateInRun(V,F,n.$iJ.fromExtHostTestItem(Ie,z).toString(),4,be)}),passed:x((Ie,de)=>{this.s.$updateTestStateInRun(V,F,n.$iJ.fromExtHostTestItem(Ie,this.m.controllerId).toString(),3,de)}),appendOutput:(Ie,de,be)=>{De||(be&&(this.m.isIncluded(be)?this.y(be):be=void 0),this.s.$appendOutputToRun(V,F,P.$be.fromString(Ie),de&&t.location.from(de),be&&n.$iJ.fromExtHostTestItem(be,z).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(V,F),this.f.delete(F),this.f.size||this.w())}};return this.f.set(F,{run:ke,coverage:O}),this.s.$startedTestRunTask(V,{id:F,name:j,running:!0}),ke}u(){for(const{run:j}of this.f.values())j.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(j){if(!(j instanceof f.$HM))throw new u.$mM(j.id);if(this.g.has(n.$iJ.fromExtHostTestItem(j,this.m.controllerId).toString()))return;const V=[],z=this.m.colllection.root;for(;;){const F=t.TestItem.from(j);if(V.unshift(F),this.g.has(F.extId)||(this.g.add(F.extId),j===z))break;j=j.parent||z}this.s.$addTestsToRun(this.m.controllerId,this.m.id,V)}dispose(){this.w(),super.dispose()}}class h{get trackers(){return this.c.values()}constructor(j){this.d=j,this.c=new Map}prepareForMainThreadTestRun(j,V,z,F){return this.f(j,V,z,F)}cancelRunById(j){for(const V of this.c.values())if(V.id===j){V.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,V,z,F,O,x){const Z=this.c.get(F);if(Z)return Z.createRun(O);const De=m.fromPublic(V,z,F,x),ke=b(F);this.d.$startedExtensionTestRun({controllerId:V,continuous:!!F.continuous,profile:ke&&{group:C[ke.kind],id:ke.profileId},exclude:F.exclude?.map(de=>n.$iJ.fromExtHostTestItem(de,z.root.id).toString())??[],id:De.id,include:F.include?.map(de=>n.$iJ.fromExtHostTestItem(de,z.root.id).toString())??[z.root.id],persist:x});const Ie=this.f(F,De,j);return R.Event.once(Ie.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),Ie.dispose()}),Ie.createRun(O)}f(j,V,z,F){const O=new c(V,this.d,F);return this.c.set(j,O),R.Event.once(O.onEnd)(()=>this.c.delete(j)),O}}e.$zec=h;const b=B=>{if(B.profile){if(!(B.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class m{static fromPublic(j,V,z,F){return new m(j,(0,o.$eg)(),z.include?.map(O=>n.$iJ.fromExtHostTestItem(O,j).toString())??[j],z.exclude?.map(O=>n.$iJ.fromExtHostTestItem(O,j).toString())??[],F,V)}static fromInternal(j,V){return new m(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,V)}constructor(j,V,z,F,O,x){this.controllerId=j,this.id=V,this.isPersisted=O,this.colllection=x,this.c=z.map(Z=>Z+"\0"),this.d=F.map(Z=>Z+"\0")}isIncluded(j){const V=n.$iJ.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const z of this.d)if(V===z||V.startsWith(z))return!1;for(const z of this.c)if(V===z||V.startsWith(z))return!0;return!1}}e.$Aec=m;class I{set coverageProvider(j){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");j&&(this.c=j,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(j,V,z){this.f=j,this.g=V,this.h=z}async provideFileCoverage(j){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(j))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(V){throw this.d=void 0,V}}async resolveFileCoverage(j,V){const z=await this.d;let F=z?.[j];return!this.c||!z||!F?[]:(F.detailedCoverage||(F=z[j]=await this.c.resolveFileCoverage?.(F,V)??F),F.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class k{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(j){this.h=j,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,t.TestItem.toPlain(j.item)),this.c.has(j)||this.d.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.d.delete(j);const V=n.$iJ.parentId(j.item.extId);if(V&&this.g.has(V.toString())){this.g.add(j.item.extId);return}this.f.add(j)}getChangeEvent(){const{c:j,d:V,f:z}=this;return{get added(){return[...j].map(F=>F.revived)},get updated(){return[...V].map(F=>F.revived)},get removed(){return[...z].map(F=>F.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class d extends a.$pJ{constructor(){super(...arguments),this.q=new R.$Nd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(j){return this.d.get(j)}getMirroredTestDataByReference(j){return this.d.get(j.id)}p(j,V){return{...j,revived:t.TestItem.toPlain(j.item),depth:V?V.depth+1:0,children:new Set}}o(){return new k(this.q)}}class w{constructor(j){this.d=j}checkout(){this.c||(this.c=this.f());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(V=>V.revived)},dispose:(0,$.$cb)(()=>{--j.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}f(){const j=new d;return this.d.$subscribeToDiffs(),{observers:0,tests:j}}}class y{#e;#t;get label(){return this.d}set label(j){j!==this.d&&(this.d=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(j){j!==this.g&&(this.g=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:j}))}get isDefault(){return this.f}set isDefault(j){j!==this.f&&(this.f=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?t.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}constructor(j,V,z,F,O,x,Z,De=!1,ke=void 0,Ie=!1){this.controllerId=z,this.profileId=F,this.d=O,this.kind=x,this.runHandler=Z,this.f=De,this._tag=ke,this.g=Ie,this.#e=j,this.#t=V,V.set(F,this);const de=C[x];if(typeof de!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);this.#e.$publishTestRunProfile({profileId:F,controllerId:z,tag:ke?t.TestTag.namespace(this.controllerId,ke.id):null,label:O,group:de,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:Ie})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Bec=y;const C={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[270],Re([1,0,18,11,5,3,109,8,7]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class g{constructor(S,o){this.i=o,this.a=new P.$Nd({onListenerError:L.$1}),this.b=new P.$Nd({onListenerError:L.$1}),this.c=new P.$Nd({onListenerError:L.$1}),this.d=new P.$Nd({onListenerError:L.$1}),this.f=new P.$Nd({onListenerError:L.$1}),this.g=new P.$Nd({onListenerError:L.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(M.$sK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const o=this.i.allEditors();return S?o:o.map(v=>v.value)}async showTextDocument(S,o,v){let p;typeof o=="number"?p={position:$.ViewColumn.from(o),preserveFocus:v}:typeof o=="object"?p={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selection:typeof o.selection=="object"?$.Range.from(o.selection):void 0,pinned:typeof o.preview=="boolean"?!o.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(S.uri,p),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,o){return new R.$BM(this.h,S,o).value}$acceptEditorPropertiesChanged(S,o){const v=this.i.getEditor(S);if(!v)throw new Error("unknown text editor");if(o.options&&v._acceptOptions(o.options),o.selections){const p=o.selections.selections.map($.Selection.to);v._acceptSelections(p)}if(o.visibleRanges){const p=E.$Gb(o.visibleRanges.map($.Range.to));v._acceptVisibleRanges(p)}if(o.options&&this.b.fire({textEditor:v.value,options:{...o.options,lineNumbers:$.TextEditorLineNumbersStyle.to(o.options.lineNumbers)}}),o.selections){const p=D.TextEditorSelectionChangeKind.fromValue(o.selections.source),f=o.selections.selections.map($.Selection.to);this.a.fire({textEditor:v.value,selections:f,kind:p})}if(o.visibleRanges){const p=E.$Gb(o.visibleRanges.map($.Range.to));this.c.fire({textEditor:v.value,visibleRanges:p})}}$acceptEditorPositionData(S){for(const o in S){const v=this.i.getEditor(o);if(!v)throw new Error("Unknown text editor");const p=$.ViewColumn.to(S[o]);v.value.viewColumn!==p&&(v._acceptViewColumn(p),this.d.fire({textEditor:v.value,viewColumn:p}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$Qdc=g}),define(Ae[271],Re([1,0,2,4,3,6,7,8,22,16]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=void 0,e.$sec=(0,L.$Qh)("IExtHostTimeline");class A{constructor(v,p){this.b=new Map,this.c=new Map,this.a=v.getProxy(P.$sK.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$7l.equals(t,this.b.get(f.source)?.extension)){const i=f.uri===void 0?void 0:E.URI.revive(f.uri);return this.c.get(f.source)?.get(S(i))?.get(f.handle)}else return;return f}})}async $getTimeline(v,p,f,t){return this.b.get(v)?.provider.provideTimeline(E.URI.revive(p),f,t)}registerTimelineProvider(v,p,f,t){const i=new M.$Qc,n=this.d(p.id,t,i).bind(this);let u;p.onDidChange&&(u=p.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:p.id}),this));const a=this.c;return this.f({...p,scheme:v,onDidChange:void 0,async provideTimeline(l,r,s){r?.resetCache&&(i.clear(),a.get(p.id)?.clear());const c=await p.provideTimeline(l,r,s);if(c==null)return;const h=n(l,r);return{...c,source:p.id,items:c.items.map(h)}},dispose(){for(const l of a.values())l.get(p.id)?.clear();u?.dispose(),i.dispose()}},f)}d(v,p,f){return(t,i)=>{let n;if(i?.cacheResults){let u=this.c.get(v);u===void 0&&(u=new Map,this.c.set(v,u));const a=S(t);n=u.get(a),n===void 0&&(n=new Map,u.set(a,n))}return u=>{const{iconPath:a,...l}=u,r=`${v}|${u.id??u.timestamp}`;n?.set(r,u);let s,c,h;u.iconPath&&(a instanceof R.$oL?h={id:a.id,color:a.color}:E.URI.isUri(a)?(s=a,c=a):{light:s,dark:c}=a);let b;return R.$UK.isMarkdownString(l.tooltip)?b=$.MarkdownString.from(l.tooltip):(0,g.$yf)(l.tooltip)?b=l.tooltip:R.$UK.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=$.MarkdownString.from(l.detail)):(0,g.$yf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=l.detail),{...l,id:l.id??void 0,handle:r,source:v,command:u.command?p.toInternal(u.command,f):void 0,icon:s,iconDark:c,themeIcon:h,tooltip:b,accessibilityInformation:u.accessibilityInformation}}}}f(v,p){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:p}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$tec=A;function S(o){return o?.toString()}}),define(Ae[87],Re([1,0,20,5,6,169,4,15,198,3,27,17,7]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dwb=e.$Cwb=e.TunnelDtoConverter=void 0;class v extends D.$hv{}var p;(function(t){function i(u){return{remoteAddress:u.remoteAddress,localAddress:u.localAddress,public:!!u.public,privacy:u.privacy??(u.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:u.protocol}}t.fromApiTunnel=i;function n(u){return{remoteAddress:{host:u.tunnelRemoteHost,port:u.tunnelRemotePort},localAddress:u.localAddress,public:u.privacy!==D.TunnelPrivacyId.ConstantPrivate&&u.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:u.privacy,protocol:u.protocol}}t.fromServiceTunnel=n})(p||(e.TunnelDtoConverter=p={})),e.$Cwb=(0,R.$Qh)("IExtHostTunnelService");let f=class extends P.$Rc{constructor(i,n,u){super(),this.s=u,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(g.$sK.MainThreadTunnelService)}async openTunnel(i,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const u=await this.a.$openTunnel(n,i.displayName);if(u){const a=new v(u.remoteAddress,u.localAddress,()=>this.a.$closeTunnel(u.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,n){const u=this.u();return this.r.set(u,{selector:i,provider:n}),this.a.$registerPortsAttributesProvider(i,u),new o.$uK(()=>{this.r.delete(u),this.a.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(i,n,u,a,l){const r=[];for(const c of i){const h=this.r.get(c);if(!h)return[];r.push(...await Promise.all(n.map(async b=>{let m;try{m=await h.provider.providePortAttributes({port:b,pid:u,commandLine:a},l)}catch{m=await h.provider.providePortAttributes(b,u,a,l)}return{providedAttributes:m,port:b}})))}const s=r.filter(c=>!!c.providedAttributes);return s.length>0?s.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,l)=>await i.provideTunnel(a,l,new E.$Xd().token)??void 0;const u=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(u),Promise.resolve((0,P.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,n){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const u=i.tunnelFactory??(n?this.w(n):void 0);if(u){this.b=u;let a=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:a}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,P.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,n){if(this.g.has(i.host)){const u=this.g.get(i.host);u.has(i.port)&&(n&&u.get(i.port).disposeListener.dispose(),await u.get(i.port).tunnel.dispose(),u.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this.b(i,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const a=await u;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const l=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:a,disposeListener:l}),p.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),u instanceof Error)return u.message}}async $applyCandidateFilter(i){const n=await Promise.all(i.map(a=>this.f(a.host,a.port,a.detail??""))),u=i.filter((a,l)=>n[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(a=>a.port).join(", ")} to ${u.map(a=>a.port).join(", ")}`),u}};e.$Dwb=f,e.$Dwb=f=Ke([Ve(0,S.$uM),Ve(1,A.$KM),Ve(2,$.$$i)],f)}),define(Ae[272],Re([1,0,6,14,2,3]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(M.$sK.MainThreadUriOpeners)}registerExternalUriOpener(D,g,A,S){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const o=S.schemes.find(v=>!R.a.has(v));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,S.schemes,D,S.label),(0,E.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener with id: ${D}`);const o=P.URI.revive(g);return S.canOpenExternalUri(o,A)}async $openUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener id: '${D}'`);return S.openExternalUri(P.URI.revive(g.resolvedUri),{sourceUri:P.URI.revive(g.sourceUri)},A)}}e.$Cec=R}),define(Ae[273],Re([1,0,3,2,6,11,22]),function(pe,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class ${static{this.a=0}constructor(g){this.c=new R.$8l,this.d=new Map,this.b=g.getProxy(E.$sK.MainThreadUrls)}registerUriHandler(g,A){const S=g.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const o=$.a++;return this.c.add(S),this.d.set(o,A),this.b.$registerUriHandler(o,S,g.displayName||g.name),(0,P.$Pc)(()=>{this.c.delete(S),this.d.delete(o),this.b.$unregisterUriHandler(o)})}$handleExternalUri(g,A){const S=this.d.get(g);if(!S)return Promise.resolve(void 0);try{S.handleUri(L.URI.revive(A))}catch(o){(0,M.$Z)(o)}return Promise.resolve(void 0)}async createAppUri(g){return L.URI.revive(await this.b.$createAppUri(g))}}e.$Sdc=$}),define(Ae[66],Re([1,0,5,6,14,26,2,183,205,78,3]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=e.$Vdc=e.$Udc=e.$Tdc=void 0;class S{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(a,l,r,s,c,h,b){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new E.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Nd,this._onDidDispose=this.#h.event,this.#e=a,this.#t=l,this.#r=r,this.#l=s,this.#u=c,this.#n=h,this.#c=o(h),this.#d=v(h),this.#i=b}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#a=!0,(0,g.$Vtb)(a,this.#l)}get cspSource(){const a=this.#n.extensionLocation;if(a.scheme===P.Schemas.https||a.scheme===P.Schemas.http){let l=a.toString();return l.endsWith("/")||(l+="/"),l+" "+g.$Utb}return g.$Utb}get html(){return this.a(),this.#s}set html(a){this.a(),this.#s!==a&&(this.#s=a,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#r}set options(a){this.a(),M.$_m(this.#r,a)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,a)),this.#r=a}async postMessage(a){if(this.#o)return!1;const l=(0,D.$5cb)(a,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const l=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,b,m,I)=>{const k=R.URI.from({scheme:b||"file",path:decodeURIComponent(m)}),d=(0,g.$Vtb)(k,{isRemote:l,authority:r}).toString();return`${c}${d}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,b,m,I)=>{const k=R.URI.from({scheme:b||"file",path:decodeURIComponent(m)}),d=(0,g.$Vtb)(k,{isRemote:l,authority:r}).toString();return`${c}${d}${I}`})}}e.$Tdc=S;function o(u){try{const a=(0,$.$Oo)((0,$.$No)(u.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$Udc=o;function v(u){try{const a=(0,$.$Oo)((0,$.$No)(u.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class p extends L.$Rc{constructor(a,l,r,s,c){super(),this.c=l,this.f=r,this.g=s,this.h=c,this.b=new Map,this.a=a.getProxy(A.$sK.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,l,r){const s=this.j(a);if(s){const{message:c}=(0,D.$6cb)(l,r.value);s._onMessageEmitter.fire(c)}}$onMissingCsp(a,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,l,r){const s=new S(a,this.a,i(l),this.c,this.f,r,this.h);this.b.set(a,s);const c=s._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return s}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$Vdc=p;function f(u){return{id:u.identifier,location:u.extensionLocation}}e.$Wdc=f;function t(u,a,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||n(u,a)}}e.$Xdc=t;function i(u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots?.map(a=>R.URI.from(a))}}function n(u,a){return[...(a?.getWorkspaceFolders()||[]).map(l=>l.uri),u.extensionLocation]}}),define(Ae[274],Re([1,0,20,97,6,14,24,2,8,66,75,3,7]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;class v{constructor(s,c){this.document=s,this.b=c,this.a=1,this.c=new A.$Pcc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,c){await this.f(s).undo(),c||this.disposeBackup()}async redo(s,c){await this.f(s).redo(),c||this.disposeBackup()}disposeEdits(s){for(const c of s)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this.a++;return(0,R.$vg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const c=this.c.get(s,0);if(!c)throw new Error("No edit found");return c}}class p{constructor(){this.a=new Map}get(s,c){return this.a.get(this.b(s,c))}add(s,c,h){const b=this.b(s,c.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${s} resource:${c.uri}`);const m=new v(c,h);return this.a.set(b,m),m}delete(s,c){const h=this.b(s,c.uri);this.a.delete(h)}b(s,c){return`${s}@@@${c}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,c,h){return this.b(0,s,c,h)}addCustomProvider(s,c,h){return this.b(1,s,c,h)}get(s){return this.a.get(s)}b(s,c,h,b){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:s,extension:h,provider:b}),new o.$uK(()=>this.a.delete(c))}}class i{constructor(s,c,h,b,m){this.d=c,this.f=h,this.g=b,this.h=m,this.b=new t,this.c=new p,this.a=s.getProxy(S.$sK.MainThreadCustomEditors)}registerCustomEditorProvider(s,c,h,b){const m=new P.$Qc;return u(h)?(m.add(this.b.addTextProvider(c,s,h)),this.a.$registerTextEditorProvider((0,g.$Wdc)(s),c,b.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,g.$Udc)(s))):(m.add(this.b.addCustomProvider(c,s,h)),n(h)&&m.add(h.onDidChangeCustomDocument(I=>{const k=this.i(c,I.document.uri);if(a(I)){const d=k.addEdit(I);this.a.$onDidEdit(I.document.uri,c,d,I.label)}else this.a.$onContentChange(I.document.uri,c)})),this.a.$registerCustomEditorProvider((0,g.$Wdc)(s),c,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,g.$Udc)(s))),o.$uK.from(m,new o.$uK(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(s,c,h,b,m){const I=this.b.get(c);if(!I)throw new Error(`No provider found for '${c}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${c}'`);const k=$.URI.revive(s),d=await I.provider.openCustomDocument(k,{backupId:h,untitledDocumentData:b?.buffer},m);let w;return n(I.provider)&&this.f&&(w=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(c,d,w),{editable:n(I.provider)}}async $disposeCustomDocument(s,c){const h=this.b.get(c);if(!h)throw new Error(`No provider found for '${c}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${c}'`);const b=$.URI.revive(s),{document:m}=this.i(c,b);this.c.delete(c,m),m.dispose()}async $resolveCustomEditor(s,c,h,b,m,I){const k=this.b.get(h);if(!k)throw new Error(`No provider found for '${h}'`);const d=D.ViewColumn.to(m),w=this.g.createNewWebview(c,b.contentOptions,k.extension),y=this.h.createNewWebviewPanel(c,h,b.title,d,b.options,w,b.active),C=$.URI.revive(s);switch(k.type){case 1:{const{document:B}=this.i(h,C);return k.provider.resolveCustomEditor(B,y,I)}case 0:{const B=this.d.getDocument(C);return k.provider.resolveCustomTextEditor(B,y,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,c,h){this.i(c,s).disposeEdits(h)}async $onMoveCustomEditor(s,c,h){const b=this.b.get(h);if(!b)throw new Error(`No provider found for '${h}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const I=$.URI.revive(c),k=this.d.getDocument(I);await b.provider.moveCustomTextEditor(k,m,E.CancellationToken.None)}async $undo(s,c,h,b){return this.i(c,s).undo(h,b)}async $redo(s,c,h,b){return this.i(c,s).redo(h,b)}async $revert(s,c,h){const b=this.i(c,s);await this.j(c).revertCustomDocument(b.document,h),b.disposeBackup()}async $onSave(s,c,h){const b=this.i(c,s);await this.j(c).saveCustomDocument(b.document,h),b.disposeBackup()}async $onSaveAs(s,c,h,b){const m=this.i(c,s);return this.j(c).saveCustomDocumentAs(m.document,$.URI.revive(h),b)}async $backup(s,c,h){const b=this.i(c,s),I=await this.j(c).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},h);return b.updateBackup(I),I.id}i(s,c){const h=this.c.get(s,$.URI.revive(c));if(!h)throw new Error("No custom document found");return h}j(s){const h=this.b.get(s)?.provider;if(!h||!n(h))throw new Error("Custom document is not editable");return h}}e.$wec=i;function n(r){return!!r.onDidChangeCustomDocument}function u(r){return typeof r.resolveCustomTextEditor=="function"}function a(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function l(r){const s=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,L.$Ei)(s)+""}}),define(Ae[275],Re([1,0,5,6,2,38,8,66,3,7]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class A extends L.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(p,f,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new E.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=f,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#s}set iconPath(p){this.c(),this.#s!==p&&(this.#s=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(p){this.#c||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#a=p.active,this.#o=p.visible,this.#r=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!f})}c(){if(this.#c)throw new Error("Webview is disposed")}}class S extends L.$Rc{static c(){return(0,M.$eg)()}constructor(p,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=p.getProxy(D.$sK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,f,t,i,n={}){const u=typeof i=="object"?i.viewColumn:i,a={viewColumn:R.ViewColumn.from(u),preserveFocus:typeof i=="object"&&!!i.preserveFocus},l=(0,$.$Udc)(p),r=S.c();this.f.$createWebviewPanel((0,$.$Wdc)(p),r,f,{title:t,panelOptions:o(n),webviewOptions:(0,$.$Xdc)(p,this.m,n),serializeBuffersForPostMessage:l},a);const s=this.j.createNewWebview(r,n,p);return this.createNewWebviewPanel(r,f,t,u,n,s,!0)}$onDidChangeWebviewPanelViewStates(p){const f=Object.keys(p);f.sort((t,i)=>{const n=p[t],u=p[i];return n.active?1:u.active?-1:+n.visible-+u.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const n=p[t];i._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:p}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,$.$Udc)(p)}),new g.$uK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(p,f,t,i){const n=this.h.get(f);if(!n)throw new Error(`No serializer found for '${f}'`);const{serializer:u,extension:a}=n,l=this.j.createNewWebview(p,t.webviewOptions,a),r=this.createNewWebviewPanel(p,f,t.title,i,t.panelOptions,l,t.active);await u.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(p,f,t,i,n,u,a){const l=new A(p,this.f,u,{viewType:f,title:t,viewColumn:i,panelOptions:n,active:a});return this.g.set(p,l),l}getWebviewPanel(p){return this.g.get(p)}}e.$vec=S;function o(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ae[276],Re([1,0,5,6,66,8,3,7]),function(pe,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class D extends L.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(S,o,v,p,f,t){super(),this.#u=!1,this.#a=this.B(new E.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new E.$Nd),this.onDidDispose=this.#c.event,this.#i=v,this.#s=p,this.#e=S,this.#t=o,this.#l=f,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#r}set description(S){this.a(),this.#r!==S&&(this.#r=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#u||(this.#n=S,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(S){this.a(),!(S?.value===this.#o?.value&&S?.tooltip===this.#o?.tooltip)&&(this.#o=M.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(S,o){this.d=o,this.b=new Map,this.c=new Map,this.a=S.getProxy(R.$sK.MainThreadWebviewViews)}registerWebviewViewProvider(S,o,v,p){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:v,extension:S}),this.a.$registerWebviewViewProvider((0,P.$Wdc)(S),o,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Udc)(S)}),new $.$uK(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(S,o,v,p,f){const t=this.b.get(o);if(!t)throw new Error(`No view provider found for '${o}'`);const{provider:i,extension:n}=t,u=this.d.createNewWebview(S,{},n),a=new D(S,this.a,o,v,u,!0);this.c.set(S,a),await i.resolveWebviewView(a,{state:p},f)}async $onDidChangeWebviewViewVisibility(S,o){this.e(S)._setVisible(o)}async $disposeWebviewView(S){const o=this.e(S);this.c.delete(S),o.dispose(),this.d.deleteWebview(S)}e(S){const o=this.c.get(S);if(!o)throw new Error("No webview found");return o}}e.$uec=g}),define(Ae[111],Re([1,0,5,3,2,14,13,4,17,25]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=e.$Ydc=void 0;let S=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const p=this.d;return{get focused(){return p.focused},get active(){return(0,g.$sF)(v,"windowActivity"),p.active}}}constructor(v){this.c=new E.$Nd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(L.$sK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:f})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,p){p!==this.d[v]&&(this.d={...this.d,[v]:p},this.c.fire(this.d))}openUri(v,p){let f;if(typeof v=="string"){f=v;try{v=P.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Be)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,f,p)}async asExternalUri(v,p){if((0,R.$Be)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(v,p);return P.URI.from(f)}};e.$Ydc=S,e.$Ydc=S=A=Ke([Ve(0,D.$uM)],S),e.$Zdc=(0,$.$Qh)("IExtHostWindow")}),define(Ae[277],Re([1,0,243,27,17]),function(pe,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;let M=class extends E.$Zec{constructor($,D){super($,D)}f($,D,g){D.apply(console,g)}};e.$7gc=M,e.$7gc=M=Ke([Ve(0,P.$uM),Ve(1,L.$KM)],M)}),define(Ae[278],Re([1,0,12,23,20,11,5,6,139,231,49]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$c5b=e.ResponsiveState=e.RequestInitiator=e.$b5b=e.$a5b=void 0;function o(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const v="$$ref$$",p={[v]:-1};class f{constructor(C,B){this.jsonString=C,this.referencedBuffers=B}}function t(y,C=null,B=!1){const j=[];return{jsonString:(B?o:JSON.stringify)(y,(z,F)=>{if(typeof F>"u")return p;if(typeof F=="object"){if(F instanceof L.$be){const O=j.push(F)-1;return{[v]:O}}if(C)return C(z,F)}return F}),referencedBuffers:j}}e.$a5b=t;function i(y,C,B){return JSON.parse(y,(j,V)=>{if(V){const z=V[v];if(typeof z=="number")return C[z];if(B&&V.$mid===1)return B.transformIncoming(V)}return V})}e.$b5b=i;function n(y,C){return JSON.stringify(y,C)}function u(y){return y?(C,B)=>B&&B.$mid===1?y.transformOutgoing(B):B:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var l;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const r=()=>{},s=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class h extends $.$Rc{static{S=s}static{this.a=3*1e3}constructor(C,B=null,j=null){super(),this[S]=!0,this.b=this.B(new R.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=B,this.g=j,this.h=u(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,z=A.$ov.count;V<z;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$7g(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const B=this.w[C];delete this.w[C],B.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,D.$Pm)(C,this.g):C}getProxy(C){const{nid:B,sid:j}=C;return this.s[B]||(this.s[B]=this.J(B,j)),this.s[B]}J(C,B){const j={get:(V,z)=>(typeof z=="string"&&!V[z]&&z.charCodeAt(0)===36&&(V[z]=(...F)=>this.U(C,z,F)),z===c?B:V[z])};return new Proxy(Object.create(null),j)}set(C,B){return this.m[C.nid]=B,B}assertRegistered(C){for(let B=0,j=C.length;B<j;B++){const V=C[B];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(C){if(this.j)return;const B=C.byteLength,j=m.read(C,0),V=j.readUInt8(),z=j.readUInt32();switch(V){case 1:case 2:{let{rpcId:F,method:O,args:x}=k.deserializeRequestJSONArgs(j);this.g&&(x=(0,D.$Pm)(x,this.g)),this.M(B,z,F,O,x,V===2);break}case 3:case 4:{let{rpcId:F,method:O,args:x}=k.deserializeRequestMixedArgs(j);this.g&&(x=(0,D.$Pm)(x,this.g)),this.M(B,z,F,O,x,V===4);break}case 5:{this.f?.logIncoming(B,z,0,"ack"),this.G(z);break}case 6:{this.N(B,z);break}case 7:{this.O(B,z,void 0);break}case 9:{let F=k.deserializeReplyOKJSON(j);this.g&&(F=(0,D.$Pm)(F,this.g)),this.O(B,z,F);break}case 10:{const F=k.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(B,z,F);break}case 8:{const F=k.deserializeReplyOKVSBuffer(j);this.O(B,z,F);break}case 11:{let F=k.deserializeReplyErrError(j);this.g&&(F=(0,D.$Pm)(F,this.g)),this.P(B,z,F);break}case 12:{this.P(B,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,B,j,V,z,F){this.f?.logIncoming(C,B,1,`receiveRequest ${(0,A.$qv)(j)}.${V}(`,z);const O=String(B);let x,Z;if(F){const ke=new P.$Xd;z.push(ke.token),x=this.Q(j,V,z),Z=()=>ke.cancel()}else x=this.Q(j,V,z),Z=r;this.u[O]=Z;const De=k.serializeAcknowledged(B);this.f?.logOutgoing(De.byteLength,B,1,"ack"),this.c.send(De),x.then(ke=>{delete this.u[O];const Ie=k.serializeReplyOK(B,ke,this.h);this.f?.logOutgoing(Ie.byteLength,B,1,"reply:",ke),this.c.send(Ie)},ke=>{delete this.u[O];const Ie=k.serializeReplyErr(B,ke);this.f?.logOutgoing(Ie.byteLength,B,1,"replyErr:",ke),this.c.send(Ie)})}N(C,B){this.f?.logIncoming(C,B,1,"receiveCancel");const j=String(B);this.u[j]?.()}O(C,B,j){this.f?.logIncoming(C,B,0,"receiveReply:",j);const V=String(B);if(!this.w.hasOwnProperty(V))return;const z=this.w[V];delete this.w[V],z.resolveOk(j)}P(C,B,j){this.f?.logIncoming(C,B,0,"receiveReplyErr:",j);const V=String(B);if(!this.w.hasOwnProperty(V))return;const z=this.w[V];delete this.w[V];let F;j&&(j.$isError?(F=new Error,F.name=j.name,F.message=j.message,F.stack=j.stack):F=j),z.resolveErr(F)}Q(C,B,j){try{return Promise.resolve(this.S(C,B,j))}catch(V){return Promise.reject(V)}}S(C,B,j){const V=this.m[C];if(!V)throw new Error("Unknown actor "+(0,A.$qv)(C));const z=V[B];if(typeof z!="function")throw new Error("Unknown method "+B+" on actor "+(0,A.$qv)(C));return z.apply(V,j)}U(C,B,j){if(this.j)return new g.$_4b;let V=null;if(j.length>0&&P.CancellationToken.isCancellationToken(j[j.length-1])&&(V=j.pop()),V&&V.isCancellationRequested)return Promise.reject(M.$5());const z=k.serializeRequestArguments(j,this.h),F=++this.t,O=String(F),x=new g.$$4b,Z=new $.$Qc;V&&Z.add(V.onCancellationRequested(()=>{const ke=k.serializeCancel(F);this.f?.logOutgoing(ke.byteLength,F,0,"cancel"),this.c.send(k.serializeCancel(F))})),this.w[O]=new b(x,Z),this.F(F);const De=k.serializeRequest(F,C,B,z,!!V);return this.f?.logOutgoing(De.byteLength,F,0,`request: ${(0,A.$qv)(C)}.${B}(`,j),this.c.send(De),x}}e.$c5b=h;class b{constructor(C,B){this.a=C,this.b=B}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class m{static alloc(C,B,j){const V=new m(L.$be.alloc(j+1+4),0);return V.writeUInt8(C),V.writeUInt32(B),V}static read(C,B){return new m(C,B)}get buffer(){return this.a}constructor(C,B){this.a=C,this.b=B}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+C).toString();return this.b+=C,j}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+C).toString();return this.b+=C,j}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+C);return this.b+=C,B}static sizeMixedArray(C){let B=0;B+=1;for(let j=0,V=C.length;j<V;j++){const z=C[j];switch(B+=1,z.type){case 1:B+=this.sizeLongString(z.value);break;case 2:B+=this.sizeVSBuffer(z.value);break;case 3:B+=this.sizeUInt32,B+=this.sizeLongString(z.value);for(let F=0;F<z.buffers.length;++F)B+=this.sizeVSBuffer(z.buffers[F]);break;case 4:break}}return B}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let B=0,j=C.length;B<j;B++){const V=C[B];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let z=0;z<V.buffers.length;++z)this.writeBuffer(V.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const B=new Array(C);for(let j=0;j<C;j++)switch(this.readUInt8()){case 1:B[j]=this.readLongString();break;case 2:B[j]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),F=this.readLongString(),O=[];for(let x=0;x<z;++x)O.push(this.readVSBuffer());B[j]=new A.$rv(i(F,O,null));break}case 4:B[j]=void 0;break}return B}}var I;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(I||(I={}));class k{static a(C){for(let B=0,j=C.length;B<j;B++)if(C[B]instanceof L.$be||C[B]instanceof A.$rv||typeof C[B]>"u")return!0;return!1}static serializeRequestArguments(C,B){if(this.a(C)){const j=[];for(let V=0,z=C.length;V<z;V++){const F=C[V];if(F instanceof L.$be)j[V]={type:2,value:F};else if(typeof F>"u")j[V]={type:4};else if(F instanceof A.$rv){const{jsonString:O,referencedBuffers:x}=t(F.value,B);j[V]={type:3,value:L.$be.fromString(O),buffers:x}}else j[V]={type:1,value:L.$be.fromString(n(F,B))}}return{type:1,args:j}}return{type:0,args:n(C,B)}}static serializeRequest(C,B,j,V,z){switch(V.type){case 0:return this.b(C,B,j,V.args,z);case 1:return this.c(C,B,j,V.args,z)}}static b(C,B,j,V,z){const F=L.$be.fromString(j),O=L.$be.fromString(V);let x=0;x+=m.sizeUInt8(),x+=m.sizeShortString(F),x+=m.sizeLongString(O);const Z=m.alloc(z?2:1,C,x);return Z.writeUInt8(B),Z.writeShortString(F),Z.writeLongString(O),Z.buffer}static deserializeRequestJSONArgs(C){const B=C.readUInt8(),j=C.readShortString(),V=C.readLongString();return{rpcId:B,method:j,args:JSON.parse(V)}}static c(C,B,j,V,z){const F=L.$be.fromString(j);let O=0;O+=m.sizeUInt8(),O+=m.sizeShortString(F),O+=m.sizeMixedArray(V);const x=m.alloc(z?4:3,C,O);return x.writeUInt8(B),x.writeShortString(F),x.writeMixedArray(V),x.buffer}static deserializeRequestMixedArgs(C){const B=C.readUInt8(),j=C.readShortString(),V=C.readMixedArray(),z=new Array(V.length);for(let F=0,O=V.length;F<O;F++){const x=V[F];typeof x=="string"?z[F]=JSON.parse(x):z[F]=x}return{rpcId:B,method:j,args:z}}static serializeAcknowledged(C){return m.alloc(5,C,0).buffer}static serializeCancel(C){return m.alloc(6,C,0).buffer}static serializeReplyOK(C,B,j){if(typeof B>"u")return this.d(C);if(B instanceof L.$be)return this.e(C,B);if(B instanceof A.$rv){const{jsonString:V,referencedBuffers:z}=t(B.value,j,!0);return this.g(C,V,z)}else return this.f(C,o(B,j))}static d(C){return m.alloc(7,C,0).buffer}static e(C,B){let j=0;j+=m.sizeVSBuffer(B);const V=m.alloc(8,C,j);return V.writeVSBuffer(B),V.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,B){const j=L.$be.fromString(B);let V=0;V+=m.sizeLongString(j);const z=m.alloc(9,C,V);return z.writeLongString(j),z.buffer}static g(C,B,j){const V=L.$be.fromString(B);let z=0;z+=m.sizeUInt32,z+=m.sizeLongString(V);for(const O of j)z+=m.sizeVSBuffer(O);const F=m.alloc(10,C,z);F.writeUInt32(j.length),F.writeLongString(V);for(const O of j)F.writeBuffer(O);return F.buffer}static deserializeReplyOKJSON(C){const B=C.readLongString();return JSON.parse(B)}static deserializeReplyOKJSONWithBuffers(C,B){const j=C.readUInt32(),V=C.readLongString(),z=[];for(let F=0;F<j;++F)z.push(C.readVSBuffer());return new A.$rv(i(V,z,B))}static serializeReplyErr(C,B){const j=B?o(M.$2(B),null):void 0;if(typeof j!="string")return this.h(C);const V=L.$be.fromString(j);let z=0;z+=m.sizeLongString(V);const F=m.alloc(11,C,z);return F.writeLongString(V),F.buffer}static deserializeReplyErrError(C){const B=C.readLongString();return JSON.parse(B)}static h(C){return m.alloc(12,C,0).buffer}}var d;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var w;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(w||(w={}))}),define(Ae[279],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;const E=function(M){const R=$=>{globalThis.removeEventListener("message",R);const D=$.data;Object.defineProperties(globalThis,{postMessage:{value(g,A){D.postMessage(g,A)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class L extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${E})('${R}'))`,g=new Blob([D],{type:"application/javascript"}),A=URL.createObjectURL(g),S=new MessageChannel,o=A,v={type:"_newWorker",id:o,port:S.port2,url:A,options:$};M(v,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:o}),URL.revokeObjectURL(A),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(p){S.port1.onmessage=p}},onmessageerror:{get(){return S.port1.onmessageerror},set(p){S.port1.onmessageerror=p}}}),S.port1.addEventListener("messageerror",p=>{const f=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(f)}),S.port1.addEventListener("message",p=>{const f=new MessageEvent("message",{data:p.data});this.dispatchEvent(f)}),S.port1.start()}}e.$9gc=L}),define(Ae[280],Re([1,0,5,30,34,4]),function(pe,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=e.OutputChannelUpdateMode=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=void 0,e.$AJ="text/x-code-output",e.$BJ="output",e.$CJ="Log",e.$DJ="text/x-code-log-output",e.$EJ="log",e.$FJ="workbench.panel.output",e.$GJ=new P.$8i("inOutput",!1),e.$HJ=new P.$8i("activeLogOutput",!1),e.$IJ=new P.$8i("outputView.scrollLock",!1),e.$JJ=(0,M.$Qh)("outputService");var R;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$KJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}L.$hn.add(e.$KJ.OutputChannels,new $),e.$LJ=new P.$8i("activeOutputChannel","")}),define(Ae[112],Re([1,0,3,4,17,22,15,280,64,27,42,136,23,16,41,5,6]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=void 0;class i extends R.$ej{get disposed(){return this.n}constructor(l,r,s,c,h){super(),this.id=l,this.name=r,this.r=s,this.s=c,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const r=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(l,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:r))}hide(){this.s.$close(this.id)}g(l,r){this.m+=o.$be.fromString(r).byteLength,(0,R.log)(this.r,l,r),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends i{appendLine(l){this.append(l)}}let u=class{constructor(l,r,s,c,h,b){this.i=r,this.j=s,this.k=c,this.l=h,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(E.$sK.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,S.$fm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(l,r,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const c=typeof r=="object"&&r.log,h=(0,v.$yf)(r)?r:void 0;if((0,v.$yf)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const m=this.i.environment.extensionLogLevel?.find(([k])=>M.$7l.equals(s.identifier,k))?.[1];m&&(b=(0,R.$oj)(m));const I=c?this.o(l,b,s):this.n(l,h,s);return I.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),c?this.r(l,b??this.m.getLevel(),I):this.q(l,I)}async n(l,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,h=this.k.extUri.joinPath(c,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(l,h,r,s.identifier.value);return new i(m,l,b,this.a,s)}async o(l,r,s){const c=await this.p(s),h=l.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(c,`${h}.log`),m=`${s.identifier.value}.${h}`,I=this.l.createLogger(b,{id:m,name:l,logLevel:r,extensionId:s.identifier.value});return new n(m,l,I,this.a,s)}p(l){let r=this.d.get(l.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(c){if((0,p.$pk)(c)!==p.FileSystemProviderErrorCode.FileExists)throw c}return s})())}return r}q(l,r){let s=!1;const c=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return l},append(h){c(),r.then(b=>b.append(h))},appendLine(h){c(),r.then(b=>b.appendLine(h))},clear(){c(),r.then(h=>h.clear())},replace(h){c(),r.then(b=>b.replace(h))},show(h,b){c(),r.then(m=>m.show(h,b))},hide(){c(),r.then(h=>h.hide())},dispose(){s=!0,r.then(h=>h.dispose())}}}r(l,r,s){const c=new t.$Qc,h=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},b=c.add(new f.$Nd);function m(I){r=I,b.fire(I)}return s.then(I=>{c.add(I),I.logLevel!==r&&m(I.logLevel),c.add(I.onDidChangeLogLevel(k=>m(k)))}),{...this.q(l,s),get logLevel(){return r},onDidChangeLogLevel:b.event,trace(I,...k){h(),s.then(d=>d.trace(I,...k))},debug(I,...k){h(),s.then(d=>d.debug(I,...k))},info(I,...k){h(),s.then(d=>d.info(I,...k))},warn(I,...k){h(),s.then(d=>d.warn(I,...k))},error(I,...k){h(),s.then(d=>d.error(I,...k))},dispose(){c.dispose()}}}};e.$Idc=u,e.$Idc=u=Ke([Ve(0,P.$uM),Ve(1,g.$KM),Ve(2,D.$ldc),Ve(3,A.$Scc),Ve(4,R.$_i),Ve(5,R.$$i)],u),e.$Jdc=(0,L.$Qh)("IExtHostOutputService")}),define(Ae[113],Re([1,0,4,12]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0,e.$um=(0,E.$Qh)("remoteAgentService"),e.$vm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const D=await P.getRoundTripTime();if(D===void 0)return;M=Math.min(M,D/2),await(0,L.$Ug)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,D)=>$+D,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,D)=>$+D,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[281],Re([1,0,171,56,30,47,40,6,5,113,21]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=void 0,e.$kH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$lH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$mH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$nH={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new D.$Nd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const o=new S;P.$hn.add(e.$nH.ConfigurationMigration,o);let v=class extends $.$Rc{constructor(t,i){super(),this.a=t,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const u of n.added)await this.f(u,o.migrations)})),this.c(o.migrations),this.B(o.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(t){await this.f(void 0,t);for(const i of this.b.getWorkspace().folders)await this.f(i,t)}async f(t,i){await Promise.all(i.map(n=>this.g(n,{resource:t?.uri})))}async g(t,i){const n=this.a.inspect(t.key,i);if(await this.h(t,i,n,"userValue",2),await this.h(t,i,n,"userLocalValue",3),await this.h(t,i,n,"userRemoteValue",4),await this.h(t,i,n,"workspaceFolderValue",6),await this.h(t,i,n,"workspaceValue",5),typeof i.overrideIdentifier>"u"&&typeof n.overrideIdentifiers<"u")for(const u of n.overrideIdentifiers)await this.g(t,{resource:i.resource,overrideIdentifier:u})}async h(t,i,n,u,a){const l=n[u];if(typeof l>"u")return;const r=h=>this.a.inspect(h,i)[u],s=await t.migrateFn(l,r),c=Array.isArray(s)?s:[[t.key,s]];await Promise.allSettled(c.map(async([h,b])=>this.a.updateValue(h,b.value,i,a)))}};e.$oH=v,e.$oH=v=Ke([Ve(0,R.$ki),Ve(1,M.$Zh)],v);let p=class extends $.$Rc{constructor(t){super(),(async()=>{if(!A.$j&&(await t.getEnvironment())?.os!==1)return;P.$hn.as(L.$mn.Configuration).registerConfiguration({...e.$mH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$pH=p,e.$pH=p=Ke([Ve(0,g.$um)],p)}),define(Ae[282],Re([1,0,33,14,19,24,179,281,56,4,30]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcb=e.$lcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$kcb=e.$jcb=void 0,e.$jcb=(0,g.$Qh)("editorResolverService"),e.$kcb="workbench.editorAssociations";const S=A.$hn.as(D.$mn.Configuration),o={...$.$lH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(o);var v;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(v||(e.RegisteredEditorPriority=v={}));var p;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function f(i){switch(i){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$lcb=f;function t(i,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const l=typeof i=="string"&&i.indexOf(P.$fc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$sg)(n);return E.$wj(typeof i=="string"?i.toLowerCase():i,l.toLowerCase())}e.$mcb=t}),define(Ae[283],Re([1,0,46,14,19,21,24,2,4,200,47,218,113]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.$4J=void 0,e.$4J=(0,D.$Qh)("pathService");let p=v=class{constructor(t,i,n,u){this.d=t,this.e=i,this.f=n,this.g=u,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??t})()}hasValidBasename(t,i,n){return typeof i=="string"||typeof i>"u"?this.a.then(u=>this.h(t,u,i)):this.h(t,i,n)}h(t,i,n){return t.scheme===L.Schemas.file||t.scheme===L.Schemas.vscodeRemote?(0,E.$Vf)(n??(0,R.$sg)(t),i===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,g.$1J)(i.getWorkspace());if(n)return n;const u=i.getWorkspace().folders[0];if(u)return u.uri.scheme;const a=i.getWorkspace().configuration;return a?a.scheme:L.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?P.$ec:P.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const u=t.indexOf("/",2);u===-1?(i=t.substring(2),t="/"):(i=t.substring(2,u),t=t.substring(u)||"/")}return $.URI.from({scheme:L.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$5J=p,e.$5J=p=v=Ke([Ve(1,o.$um),Ve(2,S.$MJ),Ve(3,A.$Zh)],p)}),define(Ae[114],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$KI=e.$JI=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$JI=E;class L{constructor(R,$,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(D,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$KI=L;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ae[43],Re([1,0,18,33,26,46,13,4,19,11,114,12]),function(pe,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.SearchErrorCode=e.$ZI=e.$YI=e.SearchSortOrder=e.ViewMode=e.$XI=e.$WI=e.$VI=e.$UI=e.SearchCompletionExitCode=e.$TI=e.$SI=e.$RI=e.QueryType=e.SearchProviderType=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$LI="workbench.view.search",e.$MI="workbench.panel.search",e.$NI="workbench.view.search",e.$OI="search-result",e.$PI="search.exclude";const o="\u27EA ",v=" characters skipped \u27EB",p=(o.length+v.length+5)*2;e.$QI=(0,$.$Qh)("searchService");var f;(function(de){de[de.file=0]="file",de[de.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(de){de[de.File=1]="File",de[de.Text=2]="Text"})(t||(e.QueryType=t={}));function i(de){return!!de.preview}e.$RI=i;function n(de){return!!de.resource}e.$SI=n;function u(de){return!!de.message}e.$TI=u;var a;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class l{constructor(be){this.resource=be,this.results=[]}}e.$UI=l;class r{constructor(be,oe,ce,ve){this.ranges=oe,this.webviewIndex=ve;const _=Array.isArray(oe)?oe:[oe];if(ce&&ce.matchLines===1&&s(_)){be=(0,R.$rf)(be,ce.matchLines);let W="",ae=0,we=0;const ne=Math.floor(ce.charsPerLine/5),he=[];for(const le of _){const ye=Math.max(le.startColumn-ne,0),ee=le.startColumn+ce.charsPerLine;if(ye>we+ne+p){const fe=o+(ye-we)+v;W+=fe+be.slice(ye,ee),ae+=ye-(we+fe.length)}else W+=be.slice(we,ee);he.push(new h(0,le.startColumn-ae,le.endColumn-ae)),we=ee}this.preview={text:W,matches:Array.isArray(this.ranges)?he:he[0]}}else{const W=Array.isArray(oe)?oe[0].startLineNumber:oe.startLineNumber;this.preview={text:be,matches:(0,E.$1b)(oe,ae=>new c(ae.startLineNumber-W,ae.startColumn,ae.endLineNumber-W,ae.endColumn))}}}}e.$VI=r;function s(de){const be=de[0].startLineNumber;for(const oe of de)if(oe.startLineNumber!==be||oe.endLineNumber!==be)return!1;return!0}class c{constructor(be,oe,ce,ve){this.startLineNumber=be,this.startColumn=oe,this.endLineNumber=ce,this.endColumn=ve}}e.$WI=c;class h extends c{constructor(be,oe,ce){super(be,oe,be,ce)}}e.$XI=h;var b;(function(de){de.List="list",de.Tree="tree"})(b||(e.ViewMode=b={}));var m;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function I(de,be=!0){const oe=de&&de.files&&de.files.exclude,ce=be&&de&&de.search&&de.search.exclude;if(!oe&&!ce)return;if(!oe||!ce)return oe||ce;let ve=Object.create(null);return ve=P.$$m(ve,P.$8m(oe)),ve=P.$$m(ve,P.$8m(ce),!0),ve}e.$YI=I;function k(de,be){return de.excludePattern&&L.$wj(de.excludePattern,be)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&L.$wj(de.includePattern,be)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(oe=>{const ce=oe.folder.fsPath;if(M.$Xf(be,ce)){const ve=D.$kc(ce,be);return!oe.includePattern||!!L.$wj(oe.includePattern,ve)}else return!1}):!1:!0}e.$ZI=k;var d;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class w extends Error{constructor(be,oe){super(be),this.code=oe}}e.$1I=w;function y(de){const be=de.message;if((0,g.$3)(de))return new w(be,d.canceled);try{const oe=JSON.parse(be);return new w(oe.message,oe.code)}catch{return new w(be,d.other)}}e.$2I=y;function C(de){const be={message:de.message,code:de.code};return new Error(JSON.stringify(be))}e.$3I=C;function B(de){return de.type==="error"?!0:de.type==="success"}e.$4I=B;function j(de){return de.type==="success"}e.$5I=j;function V(de){return!!de.path}e.$6I=V;function z(de,be){const oe=de.searchPath?de.searchPath:de.relativePath;return(0,R.$of)(oe,be)}e.$7I=z;class F{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$8I=F;function O(de,be){const oe={...de||{},...be||{}};return Object.keys(oe).filter(ce=>{const ve=oe[ce];return typeof ve=="boolean"&&ve})}e.$9I=O;class x{constructor(be,oe){this.c=null,this.a={...be.excludePattern||{},...oe.excludePattern||{}},this.b=L.$xj(this.a);let ce=be.includePattern;oe.includePattern&&(ce?ce={...ce,...oe.includePattern}:ce=oe.includePattern),ce&&(this.c=L.$xj(ce))}matchesExcludesSync(be,oe,ce){return!!(this.b&&this.b(be,oe,ce))}includedInQuerySync(be,oe,ce){return!(this.b&&this.b(be,oe,ce)||this.c&&!this.c(be,oe,ce))}includedInQuery(be,oe,ce){const ve=this.b(be,oe,ce),_=()=>this.c?!!this.c(be,oe,ce):!0;return(0,S.$Gg)(ve)?ve.then(W=>W?!1:_()):_()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$0I=x;function Z(de){for(const be in de)if(typeof de[be]!="boolean")return!0;return!1}function De(de){if(!de)return;let be;return oe=>(be||(be=(de()||Promise.resolve([])).then(ce=>ce?Ie(ce):{})),be.then(ce=>!!ce[oe]))}e.$$I=De;function ke(de){if(!de)return;let be;return oe=>{if(!be){const ce=de();be=ce?Ie(ce):{}}return!!be[oe]}}e.$_I=ke;function Ie(de){const be={};for(const oe of de)be[oe]=!0;return be}}),define(Ae[35],Re([1,0,18,12,20,5,6,51,14,121,24,13,2,170,4,15,189,47,42,27,17,8,7,59,43,3,52]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=void 0;function m(j,V,z){return new A.$kg(F=>w(F,z)).isEqual(j,V)}function I(j,V,z){return m(j.uri,V.uri,z)?0:(0,S.$Ue)(j.uri.toString(),V.uri.toString())}function k(j,V,z){return j.index!==V.index?j.index<V.index?-1:1:m(j.uri,V.uri,z)?(0,S.$Ue)(j.name,V.name):(0,S.$Ue)(j.uri.toString(),V.uri.toString())}function d(j,V,z,F){const O=j.slice(0).sort((Z,De)=>z(Z,De,F)),x=V.slice(0).sort((Z,De)=>z(Z,De,F));return(0,E.$Db)(O,x,(Z,De)=>z(Z,De,F))}function w(j,V){const z=V.getCapabilities(j.scheme);return!(z&&z&1024)}class y extends i.$0h{static toExtHostWorkspace(V,z,F,O){if(!V)return{workspace:null,added:[],removed:[]};const{id:x,name:Z,folders:De,configuration:ke,transient:Ie,isUntitled:de}=V,be=[],oe=z;z?De.forEach((W,ae)=>{const we=o.URI.revive(W.uri),ne=y.o(F||z,we,O);ne?(ne.name=W.name,ne.index=W.index,be.push(ne)):be.push({uri:we,name:W.name,index:ae})}):be.push(...De.map(({uri:W,name:ae,index:we})=>({uri:o.URI.revive(W),name:ae,index:we}))),be.sort((W,ae)=>W.index<ae.index?-1:1);const ce=new y(x,Z,be,!!Ie,ke?o.URI.revive(ke):null,!!de,W=>w(W,O)),{added:ve,removed:_}=d(oe?oe.workspaceFolders:[],ce.workspaceFolders,I,O);return{workspace:ce,added:ve,removed:_}}static o(V,z,F){for(let O=0;O<V.folders.length;O++){const x=V.workspaceFolders[O];if(m(x.uri,z,F))return x}}constructor(V,z,F,O,x,Z,De){super(V,F.map(ke=>new i.$$h(ke)),O,x,De),this.t=z,this.u=Z,this.q=[],this.s=$.$Wh.forUris(De),F.forEach(ke=>{this.q.push(ke),this.s.set(ke.uri,ke)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,z){return z&&this.s.get(V)&&(V=(0,A.$ug)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let C=class{constructor(V,z,F,O,x){this.c=new M.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Pd,this.B=new Map,this.h=O,this.s=F,this.t=x,this.j=new g.$Rl,this.k=new L.$Sg,this.o=V.getProxy(h.$sK.MainThreadWorkspace),this.q=V.getProxy(h.$sK.MainThreadMessageService);const Z=z.workspace;this.l=Z?new y(Z.id,Z.name,[],!!Z.transient,Z.configuration?o.URI.revive(Z.configuration):null,!!Z.isUntitled,De=>w(De,F)):void 0}$initializeWorkspace(V,z){this.v=z,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?o.URI.from({scheme:D.Schemas.untitled,path:(0,A.$sg)((0,A.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,z,F,...O){const x=[];if(Array.isArray(O)&&O.forEach(de=>{o.URI.isUri(de.uri)&&!x.some(be=>m(be.uri,de.uri,this.s))&&x.push({uri:de.uri,name:de.name||(0,A.$rg)(de.uri)})}),this.n||[z,F].some(de=>typeof de!="number"||de<0)||F===0&&x.length===0)return!1;const Z=this.x?this.x.workspaceFolders:[];if(z+F>Z.length)return!1;const De=Z.slice(0);De.splice(z,F,...x.map(de=>({uri:de.uri,name:de.name||(0,A.$rg)(de.uri),index:void 0})));for(let de=0;de<De.length;de++){const be=De[de];if(De.some((oe,ce)=>ce!==de&&m(be.uri,oe.uri,this.s)))return!1}De.forEach((de,be)=>de.index=be);const{added:ke,removed:Ie}=d(Z,De,k,this.s);if(ke.length===0&&Ie.length===0)return!1;if(this.o){const de=V.displayName||V.name;this.o.$updateWorkspaceFolders(de,z,F,x).then(void 0,be=>{this.n=void 0;const oe={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,v.localize)(0,null,de,be.toString()),oe,[])})}return this.y(De),!0}getWorkspaceFolder(V,z){if(this.x)return this.x.getWorkspaceFolder(V,z)}async getWorkspaceFolder2(V,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,z)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,z){let F,O="";if(typeof V=="string"?(F=o.URI.file(V),O=V):typeof V<"u"&&(F=V,O=V.fsPath),!F)return O;const x=this.getWorkspaceFolder(F,!0);if(!x)return O;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let Z=(0,A.$xg)(x.uri,F);return z&&x.name&&(Z=`${x.name}/${Z}`),Z}y(V){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:z,added:F,removed:O}=y.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:O}))}findFiles(V,z,F,O,x=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let Z;if(z===null?Z=!1:z&&(typeof z=="string"?Z=z:Z=z.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:De,folder:ke}=B(l.GlobPattern.from(V));return this.o.$startFileSearch(De??null,ke??null,Z??null,F??null,x).then(Ie=>Array.isArray(Ie)?Ie.map(de=>o.URI.revive(de)):[])}async findTextInFiles(V,z,F,O,x=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const Z=this.j.getNext(),De=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:ke,folder:Ie}=B(l.GlobPattern.from(z.include)),de=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,be={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:De,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:ke,excludePattern:de},oe=!1;if(this.u[Z]=ce=>{if(oe)return;const ve=o.URI.revive(ce.resource);ce.results.forEach(_=>{const W=(0,b.$nh)(_);(0,c.$RI)(W)?F({uri:ve,preview:{text:W.preview.text,matches:(0,E.$1b)(W.preview.matches,ae=>new r.$wK(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))},ranges:(0,E.$1b)(W.ranges,ae=>new r.$wK(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))}):F({uri:ve,text:W.text,lineNumber:W.lineNumber})})},x.isCancellationRequested)return{};try{const ce=await this.o.$startTextSearch(V,Ie??null,be,Z,x);return delete this.u[Z],ce||{}}catch(ce){throw delete this.u[Z],ce}}$handleTextSearchResult(V,z){this.u[z]?.(V)}async save(V){const z=await this.o.$save(V,{saveAs:!1});return o.URI.revive(z)}async saveAs(V){const z=await this.o.$save(V,{saveAs:!0});return o.URI.revive(z)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,z){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,z);const F=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,F),(0,R.$Pc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(V,z){this.h.info("Getting edit session identifier for workspaceFolder",V);const F=await this.resolveWorkspaceFolder(o.URI.revive(V));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const O=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!O),!O)return;const x=await O.provideEditSessionIdentity(F,z);if(this.h.info("Provider returned edit session identifier: ",x),!!x)return x}async $provideEditSessionIdentityMatch(V,z,F,O){this.h.info("Getting edit session identifier for workspaceFolder",V);const x=await this.resolveWorkspaceFolder(o.URI.revive(V));if(!x){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const Z=this.w.get(x.uri.scheme);if(this.h.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!Z),!Z)return;const De=await Z.provideEditSessionIdentityMatch?.(z,F,O);if(this.h.info("Provider returned edit session identifier match result: ",De),!!De)return De}getOnWillCreateEditSessionIdentityEvent(V){return(z,F,O)=>{const x=function(De){z.call(F,De)};return x.extension=V,this.A.event(x,void 0,O)}}async $onWillCreateEditSessionIdentity(V,z,F){const O=await this.resolveWorkspaceFolder(o.URI.revive(V));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},z,async(x,Z)=>{const De=Date.now();await Promise.resolve(x),Date.now()-De>F&&this.h.warn("SLOW edit session create-participant",Z.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(V,z){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,z);const F=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerCanonicalUriProvider(O,F),(0,R.$Pc)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(V,z,F){const O=this.B.get(V.scheme);if(!O)return;const x=await O.provideCanonicalUri?.(o.URI.revive(V),z,F);if(x)return x}async $provideCanonicalUri(V,z,F){return this.provideCanonicalUri(o.URI.revive(V),{targetScheme:z},F)}};e.$5cc=C,e.$5cc=C=Ke([Ve(0,a.$uM),Ve(1,u.$KM),Ve(2,n.$Scc),Ve(3,f.$$i),Ve(4,s.$3cc)],C),e.$6cc=(0,p.$Qh)("IExtHostWorkspace");function B(j){let V,z;return j&&(typeof j=="string"?V=j:(V=j.pattern,z=o.URI.revive(j.baseUri))),{includePattern:V,folder:z}}}),define(Ae[36],Re([1,0,26,5,35,3,7,191,56,16,12,4,17,15,2]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.$7cc=void 0;function f(s,c){if(c){const h=c.split(".");let b=s;for(let m=0;b&&m<h.length;m++)b=b[h[m]];return b}}function t(s){return s instanceof p.URI}function i(s){return s&&s.uri instanceof p.URI&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function u(s){return s&&s.uri instanceof p.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function a(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(n(s))return{overrideIdentifier:s.languageId};if(u(s))return{resource:s.uri};if(s===null)return{resource:null}}let l=class{constructor(c,h,b){this.a=c.getProxy(M.$sK.MainThreadConfiguration),this.c=h,this.b=b,this.d=new A.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new r(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,h){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(c,h))}};e.$7cc=l,e.$7cc=l=Ke([Ve(0,o.$uM),Ve(1,P.$6cc),Ve(2,v.$$i)],l);class r{constructor(c,h,b,m){this.a=new L.$Nd,this.b=c,this.f=m,this.c=h,this.e=$.$Fn.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,h){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Fn.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(h,b))}getConfiguration(c,h,b){const m=a(h)||{},I=this.g(c?f(this.e.getValue(void 0,m,this.c.workspace),c):this.e.getValue(void 0,m,this.c.workspace));c&&this.h(c,m,b?.identifier);function k(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(w){return typeof f(I,w)<"u"},get:(w,y)=>{this.h(c?`${c}.${w}`:w,m,b?.identifier);let C=f(I,w);if(typeof C>"u")C=y;else{let B;const j=(V,z)=>{if((0,g.$Af)(V)){let F;const O=()=>{B=B||(0,E.$8m)(I),F=F||f(B,z)};return new Proxy(V,{get:(x,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return O(),()=>F;if(B)return F=F||f(B,z),F[Z];const De=x[Z];return typeof Z=="string"?j(De,`${z}.${Z}`):De},set:(x,Z,De)=>(O(),F&&(F[Z]=De),!0),deleteProperty:(x,Z)=>(O(),F&&delete F[Z],!0),defineProperty:(x,Z,De)=>(O(),F&&Object.defineProperty(F,Z,De),!0)})}return Array.isArray(V)?(0,E.$8m)(V):V};C=j(C,w)}return C},update:(w,y,C,B)=>{w=c?`${c}.${w}`:w;const j=k(C);return y!==void 0?this.b.$updateConfigurationOption(j,w,y,m,B):this.b.$removeConfigurationOption(j,w,m,B)},inspect:w=>{w=c?`${c}.${w}`:w;const y=this.e.inspect(w,m,this.c.workspace);if(y)return{key:w,defaultValue:(0,E.$8m)(y.policy?.value??y.default?.value),globalValue:(0,E.$8m)(y.user?.value??y.application?.value),workspaceValue:(0,E.$8m)(y.workspace?.value),workspaceFolderValue:(0,E.$8m)(y.workspaceFolder?.value),defaultLanguageValue:(0,E.$8m)(y.default?.override),globalLanguageValue:(0,E.$8m)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,E.$8m)(y.workspace?.override),workspaceFolderLanguageValue:(0,E.$8m)(y.workspaceFolder?.override),languageIds:(0,E.$8m)(y.overrideIdentifiers)}}};return typeof I=="object"&&(0,E.$$m)(d,I,!1),Object.freeze(d)}g(c){const h=b=>(0,g.$Af)(b)?new Proxy(b,{get:(m,I)=>h(m[I]),set:(m,I,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(m,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(m,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return h(c)}h(c,h,b){const m=D.$wn.test(c)?4:this.d.get(c),I=b?`[${b.value}] `:"";if(m===4){typeof h?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){h?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,h){const b=new $.$Hn(c,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,I)=>b.affectsConfiguration(m,a(I))})}k(c){return c.reduce((h,b)=>(h.set(b[0],b[1]),h),new Map)}}e.$8cc=r,e.$9cc=(0,S.$Qh)("IExtHostConfiguration")}),define(Ae[115],Re([1,0,2,12,5,3,7,35,62,36,20,65,17,27,4,14,21,15,81,230,11]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=e.$5dc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(j){function V(F){if(F!=null)return F}j.from=V;function z(F){if(F!=null)return F}j.to=z})(l||(l={}));var r;(function(j){function V(F){if(F!=null)return F}j.from=V;function z(F){if(F!=null)return F}j.to=z})(r||(r={}));var s;(function(j){function V(F){if(F!=null)return F}j.from=V;function z(F){if(F!=null)return F}j.to=z})(s||(s={}));var c;(function(j){function V(O){if(O){const x=O;return x&&!!x.process}else return!1}j.is=V;function z(O){if(O==null)return;const x={process:O.process,args:O.args};return O.options&&(x.options=s.from(O.options)),x}j.from=z;function F(O){if(O!=null)return new R.$cL(O.process,O.args,O.options)}j.to=F})(c||(c={}));var h;(function(j){function V(F){if(F!=null)return F}j.from=V;function z(F){if(F!=null)return F}j.to=z})(h||(h={}));var b;(function(j){function V(O){if(O){const x=O;return x&&(!!x.commandLine||!!x.command)}else return!1}j.is=V;function z(O){if(O==null)return;const x={};return O.commandLine!==void 0?x.commandLine=O.commandLine:(x.command=O.command,x.args=O.args),O.options&&(x.options=h.from(O.options)),x}j.from=z;function F(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$dL(O.commandLine,O.options):new R.$dL(O.command,O.args?O.args:[],O.options)}j.to=F})(b||(b={}));var m;(function(j){function V(O){if(O){const x=O;return x&&x.customExecution==="customExecution"}else return!1}j.is=V;function z(O){return{customExecution:"customExecution"}}j.from=z;function F(O,x){return x.get(O)}j.to=F})(m||(e.CustomExecutionDTO=m={}));var I;(function(j){function V(z,F){let O;return z.scope!==void 0&&typeof z.scope!="number"?O=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&F&&F.workspaceFile?O=F.workspaceFile:O=u.$4F),{id:z._id,workspaceFolder:O}}j.from=V})(I||(e.TaskHandleDTO=I={}));var k;(function(j){function V(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}j.from=V})(k||(k={}));var d;(function(j){function V(O,x){if(O==null)return[];const Z=[];for(const De of O){const ke=z(De,x);ke&&Z.push(ke)}return Z}j.fromMany=V;function z(O,x){if(O==null)return;let Z;O.execution instanceof R.$cL?Z=c.from(O.execution):O.execution instanceof R.$dL?Z=b.from(O.execution):O.execution&&O.execution instanceof R.$eL&&(Z=m.from(O.execution));const De=l.from(O.definition);let ke;return O.scope?typeof O.scope=="number"?ke=O.scope:ke=O.scope.uri:ke=R.TaskScope.Workspace,!De||!ke?void 0:{_id:O._id,definition:De,name:O.name,source:{extensionId:x.identifier.value,label:O.source,scope:ke},execution:Z,isBackground:O.isBackground,group:k.from(O.group),presentationOptions:r.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}j.from=z;async function F(O,x,Z){if(O==null)return;let De;c.is(O.execution)?De=c.to(O.execution):b.is(O.execution)?De=b.to(O.execution):m.is(O.execution)&&(De=m.to(O._id,Z));const ke=l.to(O.definition);let Ie;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Ie=O.source.scope:Ie=await x.resolveWorkspaceFolder(E.URI.revive(O.source.scope)):Ie=R.TaskScope.Workspace),!ke||!Ie)return;const de=new R.$fL(ke,Ie,O.name,O.source.label,De,O.problemMatchers);return O.isBackground!==void 0&&(de.isBackground=O.isBackground),O.group!==void 0&&(de.group=R.$bL.from(O.group._id),de.group&&O.group.isDefault&&(de.group=new R.$bL(de.group.id,de.group.label),O.group.isDefault===!0&&(de.group.isDefault=O.group.isDefault))),O.presentationOptions&&(de.presentationOptions=r.to(O.presentationOptions)),O._id&&(de._id=O._id),O.detail&&(de.detail=O.detail),de}j.to=F})(d||(e.TaskDTO=d={}));var w;(function(j){function V(F){return F}j.from=V;function z(F){if(F)return Object.assign(Object.create(null),F)}j.to=z})(w||(w={}));class y{#e;constructor(V,z,F){this._id=z,this.a=F,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let C=class{constructor(V,z,F,O,x,Z,De,ke){this.q=new P.$Nd,this.r=new P.$Nd,this.s=new P.$Nd,this.t=new P.$Nd,this.a=V.getProxy(M.$sK.MainThreadTask),this.b=F,this.c=O,this.d=x,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=De,this.g=ke,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,z,F){if(!F)return new R.$uK(()=>{});const O=this.w();return this.j.set(O,{type:z,provider:F,extension:V}),this.a.$registerTaskProvider(O,z),new R.$uK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(V,z){this.a.$registerTaskSystem(V,z)}fetchTasks(V){return this.a.$fetchTasks(w.from(V)).then(async z=>{const F=[];for(const O of z){const x=await d.to(O,this.b,this.m);x&&F.push(x)}return F})}get taskExecutions(){const V=[];return this.k.forEach(z=>V.push(z)),V}terminateTask(V){if(!(V instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,z,F){const O=this.m.get(V.id);O&&(this.o.set(V.id,O),this.e.attachPtyToTerminal(z,await O.callback(F))),this.p=V.id,this.q.fire({execution:await this.y(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){const z=await this.y(V);this.l.delete(V.id),this.k.delete(V.id),this.A(V),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const z=await this.y(V.id);this.s.fire({execution:z,processId:V.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(V){const z=await this.y(V.id);this.t.fire({execution:z,exitCode:V.exitCode})}$provideTasks(V,z){const F=this.j.get(V);if(!F)return Promise.reject(new Error("no handler found"));const O=[],x=(0,L.$Mg)(()=>F.provider.provideTasks(A.CancellationToken.None)).then(Z=>this.u(z,O,F,Z));return new Promise(Z=>{x.then(De=>{Promise.all(O).then(()=>{Z(De)})})})}async $resolveTask(V,z){const F=this.j.get(V);if(!F)return Promise.reject(new Error("no handler found"));if(z.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${F.type}].`);const O=await d.to(z,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const x=await F.provider.resolveTask(O,A.CancellationToken.None);if(!x)return;this.z(x,F);const Z=d.from(x,F.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(Z.execution)&&await this.x(Z,x,!0),await this.v(Z)}w(){return this.h++}async x(V,z,F){const O=await this.a.$createTaskId(V);!F&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,z.execution)),this.m.set(O,z.execution)}async y(V,z){if(typeof V=="string"){const x=this.l.get(V);if(!x)throw new a.$ab("Unexpected: The specified task is missing an execution");return x}const F=this.l.get(V.id);if(F)return F;const O=new Promise((x,Z)=>{function De(ke,Ie,de){de?x(new y(ke,Ie.id,de)):Z("Unexpected: Task does not exist.")}z?De(this,V,z):d.to(V.task,this.b,this.m).then(ke=>De(this,V,ke))});return this.l.set(V.id,O),O.then(x=>(this.k.set(V.id,x),x),x=>Promise.reject(x))}z(V,z){V._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const F=this.n.values();let O=F.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=F.next()}};e.$5dc=C,e.$5dc=C=Ke([Ve(0,o.$uM),Ve(1,v.$KM),Ve(2,$.$6cc),Ve(3,D.$FM),Ve(4,g.$9cc),Ve(5,S.$odc),Ve(6,i.$$i),Ve(7,n.$Vcc)],C);let B=class extends C{constructor(V,z,F,O,x,Z,De,ke){super(V,z,F,O,x,Z,De,ke),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(V,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const F=d.from(z,V);if(F===void 0)throw new Error("Task is not valid");if(m.is(F.execution))await this.x(F,z,!1);else throw new a.$$;const O=await this.y(await this.a.$getTaskExecution(F),z);return this.a.$executeTask(F).catch(x=>{throw new Error(x)}),O}u(V,z,F,O){const x=[];if(O)for(const Z of O){this.z(Z,F),(!Z.definition||!V[Z.definition.type])&&this.f.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const De=d.from(Z,F.extension);De&&m.is(De.execution)?(x.push(De),z.push(this.x(De,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:x,extension:F.extension}}async v(V){if(m.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,z,F){}};e.$6dc=B,e.$6dc=B=Ke([Ve(0,o.$uM),Ve(1,v.$KM),Ve(2,$.$6cc),Ve(3,D.$FM),Ve(4,g.$9cc),Ve(5,S.$odc),Ve(6,i.$$i),Ve(7,n.$Vcc)],B),e.$7dc=(0,p.$Qh)("IExtHostTask")}),define(Ae[284],Re([1,0,43,29]),function(pe,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.$pK=e.$oK=void 0;function P(R){return"cellResults"in R}e.$oK=P,e.$pK="rawCell#";function M(R,$){let D=-1;const g=[];let A=[];return R.forEach(o=>{o.range.startLineNumber!==D&&A.length>0&&(g.push([...A]),A=[]),A.push(o),D=o.range.endLineNumber}),A.length>0&&g.push([...A]),g.map(o=>{const v=[],p=o[0].range.startLineNumber,f=o[o.length-1].range.endLineNumber;for(let t=p;t<=f;t++)v.push($.getLineContent(t));return new E.$VI(v.join(`
`)+`
`,o.map(t=>new L.$us(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$qK=M}),define(Ae[285],Re([1,0,163,23,5,6,28,13,16,2,41,75,3,32,8,7,49,222,107,11,26,14,213,284,282]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,I,k,d,w,y){this.q=k,this.r=d,this.s=w,this.t=y,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new P.$Nd({onListenerError:u.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Nd({onListenerError:u.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Nd({onListenerError:u.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Nd({onListenerError:u.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$Pcc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(o.$sK.MainThreadNotebook),this.c=m.getProxy(o.$sK.MainThreadNotebookDocuments),this.d=m.getProxy(o.$sK.MainThreadNotebookEditors),this.i=I.converter,I.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const B=C.notebookEditor?.notebookUri,j=C.cell.handle,z=this.g.get(B)?.getCell(j);if(z)return z.apiCell}if(C&&C.$mid===14){const B=C.uri,j=this.g.get(B);if(j)return j.apiNotebook}return C}}),h.B(I)}getEditorById(m){const I=this.h.get(m);if(!I)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return I}getIdByEditor(m){for(const[I,k]of this.h)if(k.apiEditor===m)return I}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,I){const k=this.g.get(m);if(!k&&!I)throw new Error(`NO notebook document for '${m}'`);return k}static u(m,I){if(!I)return;const k=I.filenamePattern.map(d=>p.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(I.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${I.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:I.displayName,filenamePattern:k,exclusive:I.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,I,k){const d=h.a++,w=typeof k.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(d,k),this.b.$registerNotebookCellStatusBarItemProvider(d,w,I);let y;return w!==void 0&&(y=k.onDidChangeCellStatusBarItems(C=>this.b.$emitCellStatusBarEvent(w))),new f.$uK(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,w),y?.dispose()})}async createNotebookDocument(m){const I=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&p.NotebookData.from(m.content)});return g.URI.revive(I)}async openNotebookDocument(m){const I=this.g.get(m);if(I)return I.apiNotebook;const k=await this.c.$tryOpenNotebook(m),d=this.g.get(g.URI.revive(k));return(0,D.$Jf)(d?.apiNotebook)}async showNotebookDocument(m,I){g.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let k;typeof I=="object"?k={position:p.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selections:I.selections&&I.selections.map(p.NotebookRange.from),pinned:typeof I.preview=="boolean"?!I.preview:void 0}:k={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,k),w=d&&this.h.get(d)?.apiEditor;if(w)return w;throw d?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,I,k,d){const w=this.f.get(m),y=g.URI.revive(I),C=this.g.get(y);if(!C||!w)return;const B=C.getCellFromIndex(k);if(!B)return;const j=await w.provideCellStatusBarItems(B.apiCell,d);if(!j)return;const V=new M.$Qc,z=this.p.add([V]),O=(Array.isArray(j)?j:[j]).map(x=>p.NotebookStatusBarItem.from(x,this.i,V));return{cacheId:z,items:O}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,I,k,d,w){if((0,$.$Be)(I))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:I,serializer:k,options:d}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},I,p.NotebookDocumentContentOptions.from(d),h.u(m,w)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,I,k){const d=this.x.get(m);if(!d)throw new Error("NO serializer found");const w=await d.serializer.deserializeNotebook(I.buffer,k);return new t.$rv(p.NotebookData.from(w))}async $notebookToData(m,I,k){const d=this.x.get(m);if(!d)throw new Error("NO serializer found");const w=await d.serializer.serializeNotebook(p.NotebookData.to(I.value),k);return L.$be.wrap(w)}async $saveNotebook(m,I,k,d,w){const y=g.URI.revive(I),C=this.x.get(m);if(!C)throw new Error("NO serializer found");const B=this.g.get(y);if(!B)throw new Error("Document NOT found");if(B.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$uk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,d);const j={metadata:(0,a.$dn)(B.apiNotebook.metadata,x=>!(C.options?.transientDocumentMetadata??{})[x]),cells:[]};for(const x of B.apiNotebook.getCells()){const Z=new f.$SL(x.kind,x.document.getText(),x.document.languageId,x.mime,C.options?.transientOutputs?[]:[...x.outputs],x.metadata,x.executionSummary);Z.metadata=(0,a.$dn)(x.metadata,De=>!(C.options?.transientCellMetadata??{})[De]),j.cells.push(Z)}const V=await C.serializer.serializeNotebook(j,w);await this.s.value.writeFile(y,V);const z=this.s.getFileSystemProviderExtUri(y.scheme),F=await this.s.value.stat(y);return{name:z.basename(y),isFile:(F.type&A.FileType.File)!==0,isDirectory:(F.type&A.FileType.Directory)!==0,isSymbolicLink:(F.type&A.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((F.permissions??0)&A.FilePermission.Locked),etag:A.$Fk({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(m,I,k,d,w){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const C=new R.$Ac;await(async(F,O,x)=>{await Promise.all(F.map(async Z=>await Promise.all(Z.filenamePatterns.map(De=>{const ke={...x,type:1,filePattern:De};return this.t.doInternalFileSearchWithCustomCallback(ke,O,Ie=>{Ie.forEach(de=>{C.has(de)||d.some(oe=>Z.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(ce=>(0,c.$mcb)(ce,de)))||C.add(de)})})}))))})(k,w,I);const j=new R.$zc;let V=!1;const z=Array.from(C).map(async F=>{const O=[];try{if(w.isCancellationRequested)return;if(I.maxResults&&[...j.values()].reduce((ke,Ie)=>ke+Ie.cellResults.length,0)>I.maxResults){V=!0;return}const x=[],Z=this.g.get(F);if(Z)Z.apiNotebook.getCells().forEach(Ie=>x.push({input:Ie.document.getText(),outputs:Ie.outputs.flatMap(de=>de.items.map(be=>be.data.toString()))}));else{const ke=await this.s.value.readFile(F),Ie=L.$be.fromString(ke.toString()),de=await y.deserializeNotebook(Ie.buffer,w);if(w.isCancellationRequested)return;p.NotebookData.from(de).cells.forEach(oe=>x.push({input:oe.source,outputs:oe.outputs.flatMap(ce=>ce.items.map(ve=>ve.valueBytes.toString()))}))}if(w.isCancellationRequested)return;x.forEach((ke,Ie)=>{const de=I.contentPattern.pattern,be=new r.$oOb(ke.input,void 0,ke.outputs),oe=be.findInInputs(de),ce=be.findInOutputs(de),ve=ce.flatMap(_=>(0,s.$qK)(_.matches,_.textBuffer)).map((_,W)=>(_.webviewIndex=W,_));if(oe.length>0||ce.length>0){const _={index:Ie,contentResults:(0,s.$qK)(oe,be.inputTextBuffer),webviewResults:ve};O.push(_)}});const De={resource:F,cellResults:O};j.set(F,De);return}catch{return}});return await Promise.all(z),{limitHit:V,results:[...j.values()]}}async y(m,I){const k=await this.s.value.stat(m);if(typeof I?.mtime=="number"&&typeof I.etag=="string"&&I.etag!==A.$Ek&&typeof k.mtime=="number"&&typeof k.size=="number"&&I.mtime<k.mtime&&I.etag!==A.$Fk({mtime:I.mtime,size:k.size}))throw new A.$uk((0,E.localize)(1,null),3,I)}z(m){return m.scheme===l.Schemas.file?m.fsPath:m.toString()}A(m,I,k){if(this.h.has(I))throw new Error(`editor with id ALREADY EXSIST: ${I}`);const d=new n.$oec(I,this.d,m,k.visibleRanges.map(p.NotebookRange.to),k.selections.map(p.NotebookRange.to),typeof k.viewColumn=="number"?p.ViewColumn.to(k.viewColumn):void 0);this.h.set(I,d)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const k of m.value.removedDocuments){const d=g.URI.revive(k),w=this.g.get(d);w&&(w.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(w.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===d.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const k=[];for(const d of m.value.addedDocuments){const w=g.URI.revive(d.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const y=new i.$nec(this.c,this.q,this.r,w,d);k.push(...d.cells.map(C=>i.$mec.asModelAddData(y.apiNotebook,C))),this.g.get(w)?.dispose(),this.g.set(w,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const k of m.value.addedEditors){if(this.h.has(k.id))return;const d=g.URI.revive(k.documentUri),w=this.g.get(d);w&&this.A(w,k.id,k)}const I=[];if(m.value.removedEditors)for(const k of m.value.removedEditors){const d=this.h.get(k);d&&(this.h.delete(k),this.k?.id===d.id&&(this.k=void 0),I.push(d))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const k=new Set;this.l.forEach(d=>k.add(d.id));for(const d of this.h.values()){const w=k.has(d.id);d._acceptVisibility(w)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const I=v.$SM.String.with("notebookType","A notebook type"),k=new v.$UM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[I,new v.$SM("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>L.$be.wrap(w))],new v.$TM("Notebook Data",w=>p.NotebookData.to(w.value))),d=new v.$UM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[I,new v.$SM("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new t.$rv(p.NotebookData.from(w)))],new v.$TM("Bytes",w=>w.buffer));m.registerApiCommand(k),m.registerApiCommand(d)}}e.$pec=h}),define(Ae[286],Re([1,0,19,20,39,33,24,50,43]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class g{constructor(o,v,p){this.k=o,this.l=v,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=o.filePattern,this.b=o.includePattern&&M.$xj(o.includePattern),this.c=o.maxResults||void 0,this.d=o.exists,this.h=new Set,this.j=o.excludePattern&&M.$xj(o.excludePattern)}cancel(){this.g=!0,this.h.forEach(o=>o.cancel()),this.h=new Set}search(o){const v=this.k.folderQueries||[];return new Promise((p,f)=>{const t=i=>{this.f++,o(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const n=i.toString(),u=E.$mc(n);this.j&&this.j(n,u)||this.v(t,{base:i,basename:u})}),Promise.all(v.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{f(new Error((0,P.$Bi)(i)))})})}async p(o,v){const p=new L.$Xd,f=this.q(o),t=this.r(),i=new D.$0I(this.k,o),n=!i.hasSiblingExcludeClauses();let u;try{this.h.add(p),u=$.$Jd.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,p.token),l=u.elapsed(),r=$.$Jd.create();return this.g&&!this.e||(a&&a.forEach(s=>{const c=E.$fc.relative(o.folder.path,s.path);if(n){const h=E.$mc(s.path);this.v(v,{base:o.folder,relativePath:c,basename:h});return}this.s(t,o.folder,c,v)}),this.g&&!this.e)?null:(this.u(t,i,v),{providerTime:l,postProcessTime:r.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(o){const v=(0,D.$9I)(this.k.includePattern,o.includePattern),p=(0,D.$9I)(this.k.excludePattern,o.excludePattern);return{folder:o.folder,excludes:p,includes:v,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!o.disregardParentIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}s({pathToEntries:o},v,p,f){if(p===this.a){const i=E.$mc(this.a);this.v(f,{base:v,relativePath:this.a,basename:i})}function t(i){const n=E.$mc(i),u=E.$lc(i);let a=o[u];a||(a=o[u]=[],t(u)),a.push({base:v,relativePath:i,basename:n})}t(p)}u({rootEntries:o,pathToEntries:v},p,f){const t=this,i=this.a;function n(u){const a=(0,D.$_I)(()=>u.map(l=>l.basename));for(let l=0,r=u.length;l<r;l++){const s=u[l],{relativePath:c,basename:h}=s;if(p.matchesExcludesSync(c,h,i!==h?a:void 0))continue;const b=v[c];if(b)n(b);else{if(c===i)continue;t.v(f,s)}if(t.e)break}}n(o)}v(o,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||o(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(o,v,p,f){const t=this.c(o.cacheKey),i=new g(o,v,t&&t.token);let n=0;const u=a=>{n+=a.length,p(a.map(l=>this.d(l)))};return this.e(i,A.a,u,f).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(o){this.c(o)?.cancel()}c(o){if(o)return this.b.has(o)||this.b.set(o,new L.$Xd),this.b.get(o)}d(o){return o.relativePath?{resource:R.$vg(o.base,o.relativePath)}:{resource:o.base}}e(o,v,p,f){const t=f.onCancellationRequested(()=>{o.cancel()}),i=u=>{u&&(n.push(u),v>0&&n.length>=v&&(p(n),n=[]))};let n=[];return o.search(i).then(u=>(n.length&&p(n),t.dispose(),u),u=>(n.length&&p(n),t.dispose(),Promise.reject(u)))}}e.$eec=A}),define(Ae[287],Re([1,0,18,248,33,94,28,14,19,24,13,16,2,93,181,40,15,47,105,283,43]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7J=e.$6J=void 0;let l=class{constructor(w,y,C,B,j){this.a=w,this.b=y,this.c=C,this.d=B,this.e=j}text(w,y,C={}){w=this.f(w,C);const B=this.a.getValue(),j=y&&y.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(y?.map(i.$_h),C),type:2,contentPattern:w,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:B.search.usePCRE2||j||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(w,y){const C=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const B={...w,wordSeparators:C.editor.wordSeparators};return this.j(w,y)&&(B.isCaseSensitive=!0),this.k(w)&&(B.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(B.notebookInfo||(B.notebookInfo={}),B.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),B}file(w,y={}){return{...this.h(w,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(w,y){return w?(w=Array.isArray(w)?w.map(b):b(w),y?this.parseSearchPaths(w):{pattern:s(...Array.isArray(w)?w:[w])}):{}}h(w=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),B=this.g(y.excludePattern,y.expandPatterns),j=w.length>1,V=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(O=>this.q(O,y,B)):w.map(O=>this.r(O,y,B,j))).filter(O=>!!O),z={_reason:y._reason,folderQueries:V,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:B.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const O=E.$Gb(E.$Qb(this.c.groups.map(De=>De.editors.map(ke=>ke.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const x=O.filter(De=>(0,a.$ZI)(z,De.fsPath)),Z=this.i(x);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...z,...Z}}const F=y.extraFileResources&&y.extraFileResources.filter(O=>(0,a.$ZI)(z,O.fsPath));return z.extraFileResources=F&&F.length?F:void 0,z}i(w){const y=[],C=new R.$zc,B={};let j=!1;return w.forEach(V=>{if(V.scheme===$.Schemas.walkThrough)return;if((0,g.$zg)(V)){const F=this.b.getWorkspaceFolder(V)?.uri??V.with({path:D.$lc(V.fsPath)});let O=C.get(F);O||(j=!0,O={folder:F,includePattern:{}},y.push(O),C.set(F,O));const x=D.$kc(F.fsPath,V.fsPath);(0,S.$Jf)(O.includePattern)[x.replace(/\\/g,"/")]=!0}else V.fsPath&&(j=!0,B[V.fsPath]=!0)}),{folderQueries:y,includePattern:B,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(w,y){if(y.isSmartCase){if(w.isRegExp){if(A.$pf(w.pattern,!0))return!0}else if(A.$pf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,v.$wB)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const y=Z=>D.$hc(Z)||/^\.\.?([\/\\]|$)/.test(Z),B=(Array.isArray(w)?w:c(w)).map(Z=>{const De=this.e.resolvedUserHome;return De?(0,M.$vv)(Z,De.scheme===$.Schemas.file?De.fsPath:De.path):Z}),j=L.$J(B,Z=>y(Z)?"searchPaths":"exprSegments"),V=(j.exprSegments||[]).map(Z=>A.$Ke(Z,"/")).map(Z=>A.$Ke(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),h(Z))),z={},F=this.m(j.searchPaths||[]);F&&F.length&&(z.searchPaths=F);const O=E.$Qb(V),x=s(...O);return x&&(z.pattern=x),z}l(w,y){return y.disregardExcludeSettings?void 0:(0,a.$YI)(w,!y.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const y=w.flatMap(B=>{let{pathPortion:j,globPortion:V}=r(B);return V&&(V=m(V)),this.n(j).flatMap(F=>this.o(F,V))}),C=new Map;return y.forEach(B=>{const j=B.searchPath.toString(),V=C.get(j);V?B.pattern&&(V.pattern=V.pattern||{},V.pattern[B.pattern]=!0):C.set(j,{searchPath:B.searchPath,pattern:B.pattern?s(B.pattern):void 0})}),Array.from(C.values())}n(w){if(D.$hc(w)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==$.Schemas.file?[{searchPath:y[0].uri.with({path:w})}]:[{searchPath:o.URI.file(D.$gc(w))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(w=b(w),w.startsWith("../")||w===".."){const B=D.$fc.resolve(y.path,w);return[{searchPath:y.with({path:B})}]}const C=m(w);return[{searchPath:y,pattern:C}]}else{if(w==="./"||w===".\\")return[];{const y=w.replace(/^\.[\/\\]/,""),B=this.b.getWorkspace().folders.map(j=>{const V=y.match(new RegExp(`^${A.$Fe(j.name)}(?:/(.*)|$)`));return V?{match:V,folder:j}:null}).filter(S.$Gf);if(B.length)return B.map(j=>{const V=j.match[1];return{searchPath:j.folder.uri,pattern:V&&m(V)}});{const j=w.match(/\.[\/\\](.+)[\/\\]?/),V=j?j[1]:w,z=p.localize(0,null,V);throw new Error(z)}}}}o(w,y){const C=w.pattern&&y?`${w.pattern}/${y}`:w.pattern||y,B=[{searchPath:w.searchPath,pattern:C}];return C&&!C.endsWith("**")&&B.push({searchPath:w.searchPath,pattern:C+"/**"}),B}q(w,y,C){const B=this.r((0,i.$_h)(w.searchPath),y,C,!1);return B?{...B,includePattern:w.pattern}:null}r(w,y,C,B){let j;const V=o.URI.isUri(w)?w:w.uri;if(C.searchPaths){const Z=C.searchPaths.filter(De=>(0,g.$og)(De.searchPath,V))[0];if(Z&&!Z.pattern)return null;Z&&(j=Z.pattern)}const z=this.a.getValue({resource:V}),O={...this.l(z,y)||{},...j||{}},x=o.URI.isUri(w)?(0,g.$sg)(w):w.name;return{folder:V,folderName:B?x:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};e.$6J=l,e.$6J=l=Ke([Ve(0,f.$ki),Ve(1,i.$Zh),Ve(2,n.$AC),Ve(3,t.$$i),Ve(4,u.$4J)],l);function r(d){const w=d.match(/[\*\{\}\(\)\[\]\?]/);if(w){const y=w.index,C=d.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let B=d.substr(0,C.index);return B.match(/[/\\]/)||(B+="/"),{pathPortion:B,globPortion:d.substr((C.index||0)+1)}}}return{pathPortion:d}}function s(...d){return d.length?d.reduce((w,y)=>(w[y]=!0,w),Object.create(null)):void 0}function c(d){return P.$vj(d,",").map(w=>w.trim()).filter(w=>!!w.length)}function h(d){return[`**/${d}/**`,`**/${d}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function b(d){return d.replace(/\\/g,"/")}function m(d){return b(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(d){return d.replace(/([?*[\]])/g,"[$1]")}function k(d,w){d=E.$Lb(d,B=>B.toString());const y=[],C=w.getWorkspace();return d&&d.forEach(B=>{let j;if(w.getWorkbenchState()===2)j=(0,g.$xg)(C.folders[0].uri,B),j&&j!=="."&&(j="./"+j);else{const V=w.getWorkspaceFolder(B);if(V){const z=V.name;if(C.folders.filter(O=>O.name===z).length===1){const O=(0,g.$xg)(V.uri,B);O===""?j=`./${V.name}`:j=`./${V.name}/${O}`}else j=B.fsPath}}j&&y.push(I(j))}),y}e.$7J=k}),define(Ae[288],Re([1,0,24,2,20,11,4,287,43,47]),function(pe,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rqb=e.$Qqb=void 0;const A=7e3;function S(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],u=[];for(const h of i)if(/^workspaceContains:/.test(h)){const b=h.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||f.forceUsingSearch?u.push(b):n.push(b)}if(n.length===0&&u.length===0)return Promise.resolve(void 0);let a;const l=new Promise((h,b)=>{a=h}),r=h=>a({activationEvent:h}),s=Promise.all(n.map(h=>o(f,h,r))).then(()=>{}),c=v(f,t.identifier,u,r);return Promise.all([s,c]).then(()=>{a(void 0)}),l}e.$Qqb=S;async function o(f,t,i){for(const n of f.folders)if(await f.exists(E.$vg(L.URI.revive(n),t))){i(`workspaceContains:${t}`);return}}async function v(f,t,i,n){if(i.length===0)return Promise.resolve(void 0);const u=new P.$Xd,a=f.checkExists(f.folders,i,u.token),l=setTimeout(async()=>{u.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},A);let r=!1;try{r=await a}catch(s){M.$3(s)||M.$Z(s)}u.dispose(),clearTimeout(l),r&&n(`workspaceContains:${i.join(",")}`)}function p(f,t,i,n){const u=f.get(R.$Ph),a=f.get(D.$QI),r=u.createInstance($.$6J).file(t.map(s=>(0,g.$_h)(L.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return a.fileSearch(r,n).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$Rqb=p}),define(Ae[37],Re([1,0,160,19,88,24,12,6,51,2,15,3,36,219,85,35,25,106,11,22,23,202,7,100,4,27,86,17,72,87,65,5,288,84,204,14,82,50,21,83]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,b,m,I,k,d,w,y,C,B,j,V,z,F,O){"use strict";var x;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=e.$Bdc=e.$Adc=e.$zdc=void 0,e.$zdc=(0,c.$Qh)("IHostUtils");let Z=x=class extends $.$Rc{constructor(_,W,ae,we,ne,he,le,ye,ee,fe,ie,se){super(),this.X=se,this.a=this.B(new w.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=ae,this.f=le,this.j=we,this.m=ne,this.s=he,this.t=ee,this.u=fe,this.w=ie,this.y=this.g.getProxy(S.$sK.MainThreadWorkspace),this.z=this.g.getProxy(S.$sK.MainThreadTelemetry),this.C=this.g.getProxy(S.$sK.MainThreadExtensionService),this.D=new R.$Sg,this.F=new R.$Sg,this.G=new R.$Sg,this.H=new R.$Sg,this.I=new ce(this.f.extensions.activationEvents),this.L=new i.$74b(this.I,this.f.extensions.allExtensions);const me=new u.$8l(this.f.extensions.myExtensions);this.J=new i.$74b(this.I,be(this.L,me)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Ie(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Ie(this.J)}`)),this.M=new p.$gdc(this.g,this.s),this.N=new C.$sdc(this.g),this.O=ye,this.h=_.createChild(new I.$Oh([p.$hdc,this.M],[C.$tdc,this.N])),this.P=this.B(new v.$fdc(this.J,this.L,{onExtensionActivationError:(Pe,T,q)=>{this.C.$onExtensionActivationError(Pe,n.$2(T),q)},actualActivateExtension:async(Pe,T)=>{if(i.$74b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,T),new v.$edc;const q=this.J.getExtensionDescription(Pe);return this.db(q,T)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(_){n.$Z(_)}}async Y(){this.O.onWillDeactivateAll();let _=[];try{_=this.J.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this.cb(ne))}catch{}await Promise.all(_)}terminate(_,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${_}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(we=>{this.s.error(we)}),this.g.dispose();const ae=this.Y();Promise.race([(0,R.$Ug)(5e3),ae]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(_){return this.G.isOpen()?this.P.isActivated(_):!1}async getExtension(_){const W=await this.C.$getExtension(_);return W&&{...W,identifier:new u.$7l(W.identifier.value),extensionLocation:g.URI.revive(W.extensionLocation)}}Z(_,W){return this.P.activateByEvent(_,W)}$(_,W){return this.P.activateById(_,W)}activateByIdWithErrors(_,W){return this.$(_,W).then(()=>{const ae=this.P.getActivatedExtension(_);if(ae.activationFailed)return Promise.reject(ae.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(_=>this.J)}getExtensionExports(_){if(this.G.isOpen())return this.P.getActivatedExtension(_).exports;try{return this.P.getActivatedExtension(_).exports}catch{return null}}async ab(_){if(_.scheme===j.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(_.fsPath);return g.URI.file(W)}return _}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(_=>new oe(_))),this.Q}async bb(_){const W=D.$Wh.forUris(ae=>M.$mg.ignorePathCasing(ae));return await Promise.all(_.map(async ae=>{if(this.ub(ae)){const we=await this.ab(ae.extensionLocation);W.set(we,ae)}})),W}cb(_){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(_))return W;const ae=this.P.getActivatedExtension(_);if(!ae)return W;try{typeof ae.module.deactivate=="function"&&(W=Promise.resolve(ae.module.deactivate()).then(void 0,we=>(this.s.error(we),Promise.resolve(void 0))))}catch(we){this.s.error(`An error occurred when deactivating the extension '${_.value}':`),this.s.error(we)}try{(0,$.$Mc)(ae.subscriptions)}catch(we){this.s.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.s.error(we)}return W}async db(_,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(_.identifier):await this.C.$onWillActivateExtension(_.identifier),this.fb(_,W).then(ae=>{const we=ae.activationTimes;return this.C.$onDidActivateExtension(_.identifier,we.codeLoadingTime,we.activateCallTime,we.activateResolvedTime,W),this.eb(_,W,"success",we),ae},ae=>{throw this.eb(_,W,"failure"),ae})}eb(_,W,ae,we){const ne=ke(_,W);this.z.$publicLog2("extensionActivationTimes",{...ne,...we||{},outcome:ae})}fb(_,W){const ae=ke(_,W);this.z.$publicLog2("activatePlugin",ae);const we=this.ub(_);if(!we)return Promise.resolve(new v.$ddc(v.$adc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${_.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const ne=new v.$bdc(W.startup);return Promise.all([this.vb(_,(0,M.$vg)(_.extensionLocation,we),ne),this.gb(_)]).then(he=>(P.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),x.hb(this.s,_.identifier,he[0],he[1],ne))).then(he=>(P.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),he))}gb(_){const W=new l.$jdc(_,this.M),ae=new l.$idc(_.identifier.value,!1,this.M),we=new B.$udc(_,this.N),ne=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,he=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([W.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const le=this;let ye,ee;const fe=(0,t.$rF)(_,"ipc")?this.f.messagePorts?.get(u.$7l.toKey(_.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:ae,secrets:we,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(ie){return L.$ic(_.extensionLocation.fsPath,ie)},get storagePath(){return le.O.workspaceValue(_)?.fsPath},get globalStoragePath(){return le.O.globalValue(_).fsPath},get logPath(){return L.$ic(le.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return g.URI.joinPath(le.f.logsLocation,_.identifier.value)},get storageUri(){return le.O.workspaceValue(_)},get globalStorageUri(){return le.O.globalValue(_)},get extensionMode(){return ne},get extension(){return ye===void 0&&(ye=new de(le,_.identifier,_,he,!1)),ye},get extensionRuntime(){return(0,t.$sF)(_,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.u.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!ee){if(!fe)return;const ie=w.Event.buffer(w.Event.fromDOMEventEmitter(fe,"message",se=>se.data));fe.start(),ee={onDidReceiveMessage:ie,postMessage:fe.postMessage.bind(fe)}}return ee}})})}static hb(_,W,ae,we,ne){return ae=ae||{activate:void 0,deactivate:void 0},this.ib(_,W,ae,we,ne).then(he=>new v.$cdc(!1,null,ne.build(),ae,he,we.subscriptions))}static ib(_,W,ae,we,ne){if(typeof ae.activate=="function")try{ne.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${W.value}`);const he=typeof global=="object"?global:self,le=ae.activate.apply(he,[we]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(le).then(ye=>(ne.activateResolveStop(),ye))}catch(he){return Promise.reject(he)}else return Promise.resolve(ae)}jb(_,W){this.$(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:W}).then(void 0,ae=>{this.s.error(ae)})}kb(_,W=0){const we=Date.now();(0,F.$B)(()=>{for(let ne=W;ne<_.length;ne+=1){const he=_[ne];for(const le of he.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-we>50){this.kb(_,ne);break}else this.jb(he,le)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(_=>{const W=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ae=this.J.getAllExtensionDescriptions();if(W)this.kb(ae);else for(const we of ae)if(we.activationEvents)for(const ne of we.activationEvents)ne==="onStartupFinished"&&this.jb(we,ne)})}mb(){const _=this.Z("*",!0).then(void 0,he=>{this.s.error(he)});this.B(this.j.onDidChangeWorkspace(he=>this.nb(he.added)));const W=this.j.workspace?this.j.workspace.folders:[],ae=this.nb(W),we=this.pb(),ne=Promise.all([we,_,ae]).then(()=>{});return Promise.race([ne,(0,R.$Ug)(1e4)]).then(()=>{this.lb()}),ne}nb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(_,W))).then(()=>{})}async ob(_,W){if(this.isActivated(W.identifier))return;const ae=!this.f.remote.isRemote&&!!this.f.remote.authority,we={logService:this.s,folders:_.map(he=>he.uri),forceUsingSearch:ae||!this.c.fsExists,exists:he=>this.c.fsExists(he.fsPath),checkExists:(he,le,ye)=>this.y.$checkExists(he,le,ye)},ne=await(0,y.$Qqb)(we,W);if(ne)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:ne.activationEvent}).then(void 0,he=>this.s.error(he))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(_){throw console.error(_),_}}async qb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:W}=this.f.environment;if(!_||!W)throw new Error(E.localize(0,null));const ae=await this.vb(null,W,new v.$bdc(!1));if(!ae||typeof ae.run!="function")throw new Error(E.localize(1,null,W.toString()));return new Promise((we,ne)=>{const he=(ee,fe)=>{ee?(F.$t&&this.s.error("Test runner called back with error",ee),ne(ee)):(F.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),we(typeof fe=="number"&&fe>0?1:0))},le=(0,M.$jg)(W),ye=ae.run(le,he);ye&&ye.then&&ye.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),we(0)}).catch(ee=>{F.$t&&this.s.error("Test runner finished with error",ee),ne(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,W){return this.R[_]=W,(0,$.$Pc)(()=>{delete this.R[_]})}async getRemoteExecServer(_){const{resolver:W}=await this.sb(_);return W?.resolveExecServer?.(_,{resolveAttempt:0})}async sb(_){const W=_.indexOf("+");if(W===-1)throw new r.$AK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ae=_.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ae}`,!1),{authorityPrefix:ae,resolver:this.R[ae]}}async $resolveAuthority(_,W){const ae=z.$Jd.create(!1),we=()=>`[resolveAuthority(${(0,s.$Uk)(_)},${W})][${ae.elapsed()}ms] `,ne=Q=>this.s.info(`${we()}${Q}`),he=Q=>this.s.warn(`${we()}${Q}`),le=(Q,K=void 0)=>this.s.error(`${we()}${Q}`,K),ye=Q=>{if(Q instanceof r.$AK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},ee=async Q=>{ne(`activating resolver for ${Q}...`);const{resolver:K,authorityPrefix:Y}=await this.sb(Q);if(!K)throw le(`no resolver for ${Y}`),new r.$AK(`No remote extension installed to resolve ${Y}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:Y,remoteAuthority:Q}},fe=_.split(/@|%40/g).reverse();ne(`activating remote resolvers ${fe.join(" -> ")}`);let ie;try{ie=await Promise.all(fe.map(ee)).catch(async Q=>{if(!(Q instanceof r.$AK)||Q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return he(`resolving nested authorities failed: ${Q.message}`),[await ee(_)]})}catch(Q){return ye(Q)}const se=new R.$6g;se.cancelAndSet(()=>ne("waiting..."),1e3);let me,Pe;for(const[Q,{authorityPrefix:K,resolver:Y,remoteAuthority:ue}]of ie.entries())try{if(Q===ie.length-1)ne("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),me=await Y.resolve(ue,{resolveAttempt:W,execServer:Pe}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),ne("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Y,r.$zK.isManagedResolvedAuthority(me)?me:void 0));else{if(ne(`invoking resolveExecServer() for ${ue}`),P.mark(`code/extHost/willResolveExecServer/${K}`),Pe=await Y.resolveExecServer?.(ue,{resolveAttempt:W,execServer:Pe}),!Pe)throw new r.$AK(`Exec server was not available for ${ue}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(Ne){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),le("returned an error",Ne),se.dispose(),ye(Ne)}se.dispose();const T={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures},q={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};ne(`returned ${r.$zK.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let G;if(r.$zK.isManagedResolvedAuthority(me)){const Q=W;this.X.setFactory(Q,me.makeConnection),G={authority:_,connectTo:new s.$Rk(Q),connectionToken:me.connectionToken}}else G={authority:_,connectTo:new s.$Sk(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:G,options:q,tunnelInformation:T}}}async $getCanonicalURI(_,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Uk)(_)})`);const{resolver:ae}=await this.sb(_);if(!ae)return null;const we=g.URI.revive(W);if(typeof ae.getCanonicalURI>"u")return we;const ne=await(0,R.$Mg)(()=>ae.getCanonicalURI(we));return ne||we}$startExtensionHost(_){_.toAdd.forEach(we=>we.extensionLocation=g.URI.revive(we.extensionLocation));const{globalRegistry:W,myExtensions:ae}=De(this.I,this.L,this.J,_);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(ae),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Ie(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Ie(this.J)}`)),this.rb()}$activateByEvent(_,W){return W===1?this.D.wait().then(ae=>this.Z(_,!1)):this.G.wait().then(ae=>this.Z(_,!1))}async $activate(_,W){return await this.G.wait(),this.J.getExtensionDescription(_)?(await this.$(_,W),!0):!1}async $deltaExtensions(_){_.toAdd.forEach(he=>he.extensionLocation=g.URI.revive(he.extensionLocation));const{globalRegistry:W,myExtensions:ae}=De(this.I,this.L,this.J,_),we=await this.bb(ae);return(await this.getExtensionPathIndex()).setSearchTree(we),this.L.set(W.getAllExtensionDescriptions()),this.J.set(ae),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Ie(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Ie(this.J)}`)),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const W=a.$be.alloc(_),ae=Math.random()%256;for(let we=0;we<_;we++)W.writeUInt8(ae,we);return W}async $updateRemoteConnectionData(_){this.W=_,this.a.fire()}};e.$Adc=Z,e.$Adc=Z=x=Ke([Ve(0,c.$Ph),Ve(1,e.$zdc),Ve(2,m.$uM),Ve(3,f.$6cc),Ve(4,o.$9cc),Ve(5,A.$$i),Ve(6,h.$KM),Ve(7,b.$mdc),Ve(8,k.$Cwb),Ve(9,d.$odc),Ve(10,V.$wdc),Ve(11,O.$xdc)],Z);function De(ve,_,W,ae){ve.addActivationEvents(ae.addActivationEvents);const we=new i.$74b(ve,_.getAllExtensionDescriptions());we.deltaExtensions(ae.toAdd,ae.toRemove);const ne=new u.$8l(W.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of ae.myToRemove)ne.delete(le);for(const le of ae.myToAdd)ne.add(le);const he=be(we,ne);return{globalRegistry:we,myExtensions:he}}function ke(ve,_){return{id:ve.identifier.value,name:ve.name,extensionVersion:ve.version,publisherDisplayName:ve.publisher,activationEvents:ve.activationEvents?ve.activationEvents.join(","):null,isBuiltin:ve.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}function Ie(ve){return ve.getAllExtensionDescriptions().map(_=>_.identifier.value).join(",")}e.$Bdc=(0,c.$Qh)("IExtHostExtensionService");class de{#e;#t;#i;constructor(_,W,ae,we,ne){this.#e=_,this.#t=W,this.#i=ae.identifier,this.id=ae.identifier.value,this.extensionUri=ae.extensionLocation,this.extensionPath=L.$gc((0,M.$jg)(ae.extensionLocation)),this.packageJSON=ae,this.extensionKind=we,this.isFromDifferentExtensionHost=ne}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Cdc=de;function be(ve,_){return ve.getAllExtensionDescriptions().filter(W=>_.has(W.identifier))}class oe{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$Ddc=oe;class ce{constructor(_){this.a=new u.$9l,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)??[]}addActivationEvents(_){for(const W of Object.keys(_))this.a.set(W,_[W])}}}),define(Ae[289],Re([1,0,88,2,3,36,25,22,17,27,4,37,15,13]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;let f=class{constructor(a,l,r,s,c,h,b){this.c=a,this.d=l,this.e=r,this.f=s,this.g=c,this.h=h,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new i(this.c,l,this.d,a,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,l,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const l of a.nodeModuleName)this.a.set(l,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(l=>a.alternativeModuleName(l))}};e.$2ec=f,e.$2ec=f=Ke([Ve(2,A.$Ph),Ve(3,M.$9cc),Ve(4,S.$Bdc),Ve(5,g.$KM),Ve(6,o.$$i)],f);let t=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&p.a.size){const l=(0,v.$Fe)(this.c(a.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${c}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const l=this.b.exec(this.c(a));if(!l)return;const[,r,s,c]=l,h=p.a.get(s);if(h!==void 0)return console.warn(`${s} as been renamed to ${h}, please update your imports`),r+h+c}c(a){return a.replace(/\\/g,"/")}};t=p=Ke([Ve(0,g.$KM)],t);class i{constructor(a,l,r,s,c){this.c=a,this.d=l,this.e=r,this.f=s,this.g=c,this.nodeModuleName="vscode",this.a=new $.$9l}load(a,l){const r=this.d.findSubstr(l);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((c,h)=>s+=`	${h} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$mF,this.e,this.f)}return this.b}}let n=class{constructor(a,l,r){this.e=a,this.f=l,this.nodeModuleName=["open","opn"],this.d=r.getProxy(P.$sK.MainThreadTelemetry);const s=r.getProxy(P.$sK.MainThreadWindow);this.c=(c,h)=>{const b=L.URI.parse(c);return h?this.g(c,h):b.scheme==="http"||b.scheme==="https"?s.$openUri(b,c,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?s.$openUri(b,c,{}):this.g(c,h)}}load(a,l,r){const s=this.e.findSubstr(l);return s&&(this.a=s.identifier.value,this.h()),this.b=r(a),this.c}g(a,l){return this.i(),this.b(a,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([Ve(2,D.$uM)],n)}),define(Ae[116],Re([1,0,44,6,19,74,4,62,63,37,7,35,216,36]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=e.$0dc=void 0,e.$0dc=(0,R.$Qh)("IExtHostVariableResolverProvider");class p extends o.$vN{constructor(i,n,u,a,l,r,s){function c(){if(u){const h=u.activeEditor();if(h)return h.document.uri;const b=a.tabGroups.all.find(m=>m.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof A.$aM||b.input instanceof A.$fM)return b.input.modified;if(b.input instanceof A.$_L||b.input instanceof A.$eM||b.input instanceof A.$cM)return b.input.uri}}}super({getFolderUri:h=>{const b=r.folders.filter(m=>m.name===h);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(h,b)=>l.getConfiguration(void 0,h).get(b),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=c();if(h)return P.$gc(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const h=c();if(h){const b=n.getWorkspaceFolder(h);if(b)return P.$gc(b.uri.fsPath)}}},getSelectedText:()=>{if(u){const h=u.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(u){const h=u.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>i.getExtension(h)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let f=class extends L.$Rc{constructor(i,n,u,a,l){super(),this.b=i,this.c=n,this.g=u,this.h=a,this.j=l,this.a=new E.$U(async()=>{const r=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,r,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$$dc=f,e.$$dc=f=Ke([Ve(0,g.$Bdc),Ve(1,S.$6cc),Ve(2,$.$FM),Ve(3,v.$9cc),Ve(4,D.$8dc)],f)}),define(Ae[117],Re([1,0,12,5,2,4,3,63,37,17,7,35,208,210,36,116]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=e.$cec=e.$bec=e.$aec=e.$_dc=void 0,e.$_dc=(0,M.$Qh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,c,h,b,m,I){this.E=c,this.F=h,this.G=b,this.H=m,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new L.$Nd,this.n=new L.$Nd,this.o=new L.$Nd,this.u=new L.$Nd,this.k=s.getProxy(R.$sK.MainThreadDebugService),this.y=new L.$Nd,this.A=new L.$Nd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(d=>{this.J(k)}),this.J(k)})}asDebugSourceUri(s,c){const h=s;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let b=`debug:${encodeURIComponent(h.path||"")}`,m="?";return c&&(b+=`${m}session=${encodeURIComponent(c.id)}`,m="&"),b+=`${m}ref=${h.sourceReference}`,P.URI.parse(b)}else{if(h.path)return P.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const c=[];for(const h of s.getAllExtensionDescriptions())if(h.contributes){const b=h.contributes.debuggers;if(b&&b.length>0)for(const m of b)(0,v.$GF)(m)&&c.push(m.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(c=>s.push(c)),s}addBreakpoints(s){const c=s.filter(m=>{const I=m.id;return this.w.has(I)?!1:(this.w.set(I,m),!0)});this.U(c,[],[]);const h=[],b=new Map;for(const m of c)if(m instanceof A.$tL){let I=b.get(m.location.uri.toString());I||(I={type:"sourceMulti",uri:m.location.uri,lines:[]},b.set(m.location.uri.toString(),I),h.push(I)),I.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof A.$uL&&h.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(h)}removeBreakpoints(s){const c=s.filter(I=>this.w.delete(I.id));this.U([],c,[]);const h=c.filter(I=>I instanceof A.$tL).map(I=>I.id),b=c.filter(I=>I instanceof A.$uL).map(I=>I.id),m=c.filter(I=>I instanceof A.$vL).map(I=>I.id);return this.k.$unregisterBreakpoints(h,b,m)}startDebugging(s,c,h){return this.k.$startDebugging(s?s.uri:void 0,c,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,c,h){if(!c)return new A.$uK(()=>{});const b=this.d++;return this.f.push({type:s,handle:b,provider:c}),this.k.$registerDebugConfigurationProvider(s,h,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,b),new A.$uK(()=>{this.f=this.f.filter(m=>m.provider!==c),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(s,c,h){if(!h)return new A.$uK(()=>{});if(!this.Q(s,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:c,handle:b,factory:h}),this.k.$registerDebugAdapterDescriptorFactory(c,b),new A.$uK(()=>{this.h=this.h.filter(m=>m.factory!==h),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(s,c){if(!c)return new A.$uK(()=>{});const h=this.i++;return this.j.push({type:s,handle:h,factory:c}),new A.$uK(()=>{this.j=this.j.filter(b=>b.factory!==c)})}async $runInTerminal(s,c){return Promise.resolve(void 0)}async $substituteVariables(s,c){let h;const b=await this.W(s);return b&&(h={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(h,c)}K(s,c){if(s.type==="implementation")return new a(s.implementation)}L(){}async $startDASession(s,c){const h=this,b=await this.V(c);return this.S(this.N(b.type),b).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const I=this.M(m),k=this.K(I,b);if(!k)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const d=k;return this.B.set(s,d),this.R(b).then(w=>(w&&this.C.set(s,w),d.onMessage(async y=>{if(y.type==="request"&&y.command==="handshake"){const C=y,B={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const j=await this.D.sign(C.arguments.value);B.body={signature:j},d.sendResponse(B)}else throw new Error("no signer")}catch(j){B.success=!1,B.message=j.message,d.sendResponse(B)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(y),y=(0,v.$LF)(y,!0),h.k.$acceptDAMessage(s,y)}),d.onError(y=>{w&&w.onError&&w.onError(y),this.k.$acceptDAError(s,y.name,y.message,y.stack)}),d.onExit(y=>{w&&w.onExit&&w.onExit(y??void 0,void 0),this.k.$acceptDAExit(s,y??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),d.startSession()))})}$sendDAMessage(s,c){c=(0,v.$KF)(c,!1);const h=this.C.get(s);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(c),this.B.get(s)?.sendMessage(c)}$stopDASession(s){const c=this.C.get(s);this.C.delete(s),c&&c.onWillStopSession&&c.onWillStopSession();const h=this.B.get(s);return this.B.delete(s),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const c=[],h=[],b=[];if(s.added)for(const m of s.added){const I=m.id;if(I&&!this.w.has(I)){let k;if(m.type==="function")k=new A.$uL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")k=new A.$vL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const d=P.URI.revive(m.uri);k=new A.$tL(new A.$GK(d,new A.$vK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,A.$rL)(k,I),this.w.set(I,k),c.push(k)}}if(s.removed)for(const m of s.removed){const I=this.w.get(m);I&&(this.w.delete(m),h.push(I))}if(s.changed){for(const m of s.changed)if(m.id){const I=this.w.get(m.id);if(I){if(I instanceof A.$uL&&m.type==="function"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.functionName=m.functionName}else if(I instanceof A.$tL&&m.type==="source"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.location=new A.$GK(P.URI.revive(m.uri),new A.$vK(m.line,m.character))}b.push(I)}}}this.U(c,h,b)}async $acceptStackFrameFocus(s){let c;const h=s.sessionId?await this.V(s.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?c=new A.$BL(h,s.threadId):c=new A.$AL(h,s.threadId,s.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(s,c,h){return(0,E.$Mg)(async()=>{const b=this.P(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(c);return b.provideDebugConfigurations(m,h)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(s,c,h,b){return(0,E.$Mg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(c);return m.resolveDebugConfiguration(I,h,b)})}$resolveDebugConfigurationWithSubstitutedVariables(s,c,h,b){return(0,E.$Mg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(c);return m.resolveDebugConfigurationWithSubstitutedVariables(I,h,b)})}async $provideDebugAdapter(s,c){const h=this.O(s);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.V(c);return this.S(h,b).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const c=await this.V(s);this.m.fire(c)}async $acceptDebugSessionTerminated(s){const c=await this.V(s);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,c){(await this.V(s))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(s,c){const b={session:await this.V(s),event:c.event,body:c.body};this.u.fire(b)}M(s){if(s instanceof A.$wL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$xL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$yL)return{type:"pipeServer",path:s.path};if(s instanceof A.$zL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const c=this.h.filter(h=>h.type===s);if(c.length>0)return c[0].factory}O(s){const c=this.h.filter(h=>h.handle===s);if(c.length>0)return c[0].factory}P(s){const c=this.f.filter(h=>h.handle===s);if(c.length>0)return c[0].provider}Q(s,c){if(s.contributes){const h=s.contributes.debuggers;if(h&&h.length>0){for(const b of h)if(b.label&&b.type&&b.type===c)return!0}}return!1}R(s){const h=s.configuration.type,b=this.j.filter(m=>m.type===h||m.type==="*").map(m=>(0,E.$Mg)(()=>m.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(b).then(m=>{const I=m.filter(k=>!!k);if(I.length>0)return new u(I)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,c){const h=c.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new A.$xL(h));if(s){const m=await this.F.getExtensionRegistry();return(0,E.$Mg)(()=>s.createDebugAdapterDescriptor(c,this.T(c,m))).then(I=>{if(I)return I})}const b=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,b))}T(s,c){}U(s,c,h){(s.length>0||c.length>0||h.length>0)&&this.y.fire(Object.freeze({added:s,removed:c,changed:h}))}async V(s){if(s)if(typeof s=="string"){const c=this.l.get(s);if(c)return c}else{let c=this.l.get(s.id);if(!c){const h=await this.W(s.folderUri),b=s.parent?this.l.get(s.parent):void 0;c=new i(this.k,s.id,s.type,s.name,h,s.configuration,b),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(s){if(s){const c=P.URI.revive(s);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$aec=t,e.$aec=t=Ke([Ve(0,g.$uM),Ve(1,S.$6cc),Ve(2,D.$Bdc),Ve(3,p.$9cc),Ve(4,$.$8dc),Ve(5,f.$0dc)],t);class i{constructor(s,c,h,b,m,I,k){this.d=s,this.f=c,this.g=h,this.h=b,this.i=m,this.j=I,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,c){return this.d.$customDebugAdapterRequest(this.f,s,c)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$bec=i;class n{constructor(s){this.value=Object.freeze({append(c){s.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$cec=n;class u{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(c=>c.onError?c.onError(s):void 0)}onExit(s,c){this.d.forEach(h=>h.onExit?h.onExit(s,c):void 0)}}class a extends o.$ydb{constructor(s){super(),this.h=s,s.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends t{constructor(s,c,h,b,m,I){super(s,c,h,b,m,I)}};e.$dec=l,e.$dec=l=Ke([Ve(0,g.$uM),Ve(1,S.$6cc),Ve(2,D.$Bdc),Ve(3,p.$9cc),Ve(4,$.$8dc),Ve(5,f.$0dc)],l)}),define(Ae[290],Re([1,0,11,88,2,3,278,15,71,72,27,186,17,59,37,61]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=e.$3ec=void 0;class t{static async installEarlyHandler(u){Error.stackTraceLimit=100;const a=u.get($.$$i),r=u.get(o.$uM).getProxy(M.$sK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{a.error(s);const c=E.$2(s);r.$onUnexpectedError(c)})}static async installFullHandler(u){const a=u.get($.$$i),l=u.get(o.$uM),r=u.get(p.$Bdc),s=u.get(f.$OM),c=l.getProxy(M.$sK.MainThreadExtensionService),h=l.getProxy(M.$sK.MainThreadErrors),b=await r.getExtensionPathIndex(),m=new WeakMap;function I(w,y){if(m.has(w))return m.get(w).stack;let C="",B,j;for(const z of y)C+=`
	at ${z.toString()}`,j=z.getFileName(),!B&&j&&(B=b.findSubstr(P.URI.file(j)));const V=`${w.name||"Error"}: ${w.message||""}${C}`;return m.set(w,{extensionIdentifier:B?.identifier,stack:V}),V}const k=Symbol("prepareStackTrace wrapped");let d=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(w){if(w===I||!w||w[k]){d=w||I;return}d=function(y,C){return I(y,C),w.call(Error,y,C)},Object.assign(d,{[k]:!0})}}),E.setUnexpectedErrorHandler(w=>{a.error(w);const y=E.$2(w),C=m.get(w);if(!C?.extensionIdentifier){h.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(C.extensionIdentifier,y);const B=s.onExtensionError(C.extensionIdentifier,w);a.trace("forwarded error to extension?",B,C)})}}e.$3ec=t;class i{constructor(u,a,l,r,s){this.a=l,this.b=new R.$c5b(u,null,r),a=i.e(a,this.b);const c=new g.$Oh(...(0,D.$yr)());c.set(A.$KM,{_serviceBrand:void 0,...a,messagePorts:s}),c.set(o.$uM,new o.$vM(this.b)),c.set(v.$3cc,new v.$4cc(r)),c.set(p.$zdc,l);const h=new S.$eq(c,!0);h.invokeFunction(t.installEarlyHandler),this.d=h.invokeFunction(b=>b.get($.$$i)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=h.invokeFunction(b=>b.get(p.$Bdc)),this.c.initialize(),h.invokeFunction(t.installFullHandler)}async asBrowserUri(u){const a=this.b.getProxy(M.$sK.MainThreadExtensionService);return P.URI.revive(await a.$asBrowserUri(u))}terminate(u){this.c.terminate(u)}static e(u,a){u.extensions.allExtensions.forEach(r=>{r.extensionLocation=P.URI.revive(a.transformIncomingURIs(r.extensionLocation))}),u.environment.appRoot=P.URI.revive(a.transformIncomingURIs(u.environment.appRoot));const l=u.environment.extensionDevelopmentLocationURI;return l&&(u.environment.extensionDevelopmentLocationURI=l.map(r=>P.URI.revive(a.transformIncomingURIs(r)))),u.environment.extensionTestsLocationURI=P.URI.revive(a.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=P.URI.revive(a.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=P.URI.revive(a.transformIncomingURIs(u.environment.workspaceStorageHome)),u.environment.extensionTelemetryLogResource=P.URI.revive(a.transformIncomingURIs(u.environment.extensionTelemetryLogResource)),u.nlsBaseUrl=P.URI.revive(a.transformIncomingURIs(u.nlsBaseUrl)),u.logsLocation=P.URI.revive(a.transformIncomingURIs(u.logsLocation)),u.workspace=a.transformIncomingURIs(u.workspace),u}}e.$4ec=i}),define(Ae[291],Re([1,0,18,12,20,39,14,19,24,2,43]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=e.$hec=e.$gec=e.$fec=void 0;class S{constructor(n,u,a,l){this.d=n,this.e=u,this.f=a,this.g=l,this.a=null,this.b=!1,this.c=0}search(n,u){const a=this.d.folderQueries||[],l=new P.$Xd(u);return new Promise((r,s)=>{this.a=new v(n);let c=!1;const h=(b,m)=>{if(!c&&!this.b){const I=this.h(b);f(b)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,c=!0,l.cancel(),b=this.j(b,this.d.maxResults-this.c));const k=this.h(b);this.c+=k,(k>0||!f(b))&&this.a.add(b,m)}};Promise.all(a.map((b,m)=>this.k(b,I=>h(I,m),l.token))).then(b=>{l.dispose(),this.a.flush();const m=b.some(I=>!!I&&!!I.limitHit);r({limitHit:this.b||m,messages:(0,E.$Qb)(b.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},b=>{l.dispose();const m=(0,M.$Bi)(b);s(new Error(m))})})}h(n){return f(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,u){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],l=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,u),preview:{matches:l.slice(0,u),text:n.preview.text},uri:n.uri}}async k(n,u,a){const l=new A.$0I(this.d,n),r=[],s={report:b=>{if(!this.l(b))return;const m=n.folder.scheme===R.Schemas.file?(0,A.$$I)(()=>this.f.readdir(D.$ug(b.uri))):void 0,I=D.$xg(n.folder,b.uri);if(I){const k=l.includedInQuery(I,$.$mc(I),m);(0,L.$Gg)(k)?r.push(k.then(d=>{d&&u(b)})):k&&u(b)}}},c=this.n(n),h=await this.e.provideTextSearchResults(o(this.d.contentPattern),c,s,a);return r.length&&await Promise.all(r),h}l(n){if(f(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const u=(0,A.$9I)(this.d.includePattern,n.includePattern),a=(0,A.$9I)(this.d.excludePattern,n.excludePattern),l={folder:g.URI.from(n.folder),excludes:a,includes:u,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$fec=S;function o(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new t(512,u=>this.g(u))}add(n,u){this.d&&(this.b!==u||!D.$og(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=u,this.d={resource:n.uri,results:[]}),this.d.results.push(p(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$gec=v;function p(i){return f(i)?{preview:{matches:(0,E.$1b)(i.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:i.preview.text},ranges:(0,E.$1b)(i.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.$hec=f;class t{static{this.a=4e3}static{this.b=50}constructor(n,u){this.g=n,this.h=u,this.c=0,this.d=[],this.e=0}addItem(n,u){n&&this.j(n,u)}addItems(n,u){n&&this.k(n,u)}j(n,u){this.d.push(n),this.e+=u,this.l()}k(n,u){this.d=this.d.concat(n),this.e+=u,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$iec=t}),define(Ae[118],Re([1,0,6,3,4,286,17,59,15,2,291]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=e.$jec=void 0,e.$jec=(0,P.$Qh)("IExtHostSearch");let S=class{constructor(f,t,i){this.k=f,this.l=t,this.n=i,this.c=this.k.getProxy(L.$sK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$eec}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.g.delete(f),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.i.delete(f),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,n){const u=o(i),a=this.h.get(f);if(a)return this.j.fileSearch(u,a,l=>{this.c.$handleFileMatch(f,t,l.map(r=>r.resource))},n);throw new Error("unknown provider: "+f)}async doInternalFileSearchWithCustomCallback(f,t,i){return{messages:[]}}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,n){const u=this.e.get(f);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const a=o(i);return this.q(a,u).search(r=>this.c.$handleTextMatch(f,t,r),n)}$enableExtensionHostSearch(){}q(f,t){return new A.$fec(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$kec=S,e.$kec=S=Ke([Ve(0,R.$uM),Ve(1,$.$3cc),Ve(2,D.$$i)],S);function o(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(f=>g.URI.revive(f))}}e.$lec=o;function v(p){return{...p,folder:g.URI.revive(p.folder)}}}),define(Ae[292],Re([1,0,20,11,5,31,2,146,92,129,142,41,3,79,241,240,32,242,36,244,245,246,221,247,62,37,250,251,256,257,259,112,225,264,265,268,85,65,270,226,8,7,58,273,66,111,35,22,214,255,57,110,115,117,118,15,59,17,27,285,211,87,81,233,271,86,64,276,274,275,234,42,269,272,84,63,61,260,114,261,14,99,224,203,253,6,25,209,82,199,262,263,235,252,223,254,83,266,238,267,239,232,249,236,237]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,b,m,I,k,d,w,y,C,B,j,V,z,F,O,x,Z,De,ke,Ie,de,be,oe,ce,ve,_,W,ae,we,ne,he,le,ye,ee,fe,ie,se,me,Pe,T,q,G,Q,K,Y,ue,Ne,Be,Je,Ge,_e,Ye,xe,it,tt,Ue,ut,X,J,Ee,je,Oe,Ze,nt,$t,bt,Pt,Kt,Ht,vt,zt,Nt,Gt,Bt,kt,Ft,jt,Qt,Wt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;function Ot(at){const dt=at.get(ee.$KM),At=at.get(Ne.$Scc),qt=at.get(G.$ldc),Rt=at.get(h.$Bdc),ot=at.get(be.$6cc),wt=at.get(Ye.$OM),Tt=at.get(n.$9cc),Ct=at.get(le.$3cc),We=at.get(ye.$uM),Jt=at.get(V.$hdc),Ce=at.get(q.$mdc),Le=at.get(he.$_i),$e=at.get(he.$$i),H=at.get(se.$Cwb),Me=at.get(me.$Vcc),ze=at.get(de.$Zdc),Qe=at.get(Ge.$tdc),qe=at.get(_e.$8dc),et=at.get(Nt.$xdc);We.set(o.$tK.ExtHostFileSystemInfo,At),We.set(o.$tK.ExtHostLogLevelServiceShape,Le),We.set(o.$tK.ExtHostWorkspace,ot),We.set(o.$tK.ExtHostConfiguration,Tt),We.set(o.$tK.ExtHostExtensionService,Rt),We.set(o.$tK.ExtHostStorage,Jt),We.set(o.$tK.ExtHostTunnelService,H),We.set(o.$tK.ExtHostWindow,ze),We.set(o.$tK.ExtHostSecretState,Qe),We.set(o.$tK.ExtHostTelemetry,wt),We.set(o.$tK.ExtHostEditorTabs,qe),We.set(o.$tK.ExtHostManagedSockets,et);const Et=We.set(o.$tK.ExtHostDecorations,at.get(W.$4dc)),Dt=We.set(o.$tK.ExtHostDocumentsAndEditors,at.get(c.$FM)),gt=We.set(o.$tK.ExtHostCommands,at.get(t.$QM)),ht=We.set(o.$tK.ExtHostTerminalService,at.get(z.$odc)),ft=We.set(o.$tK.ExtHostDebugService,at.get(we.$_dc)),ui=We.set(o.$tK.ExtHostSearch,at.get(ne.$jec)),St=We.set(o.$tK.ExtHostTask,at.get(ae.$7dc)),Si=We.set(o.$tK.ExtHostOutputService,at.get(w.$Jdc)),li=We.set(o.$tK.ExtHostLocalization,at.get(nt.$wdc)),$i=We.set(o.$tK.ExtHostUrls,new ke.$Sdc(We)),It=We.set(o.$tK.ExtHostDocuments,new s.$Qcc(We,Dt)),gn=We.set(o.$tK.ExtHostDocumentContentProviders,new l.$$cc(We,Dt,$e)),ri=We.set(o.$tK.ExtHostDocumentSaveParticipant,new r.$_cc($e,It,We.getProxy(o.$sK.MainThreadBulkEdits))),yt=We.set(o.$tK.ExtHostNotebook,new fe.$pec(We,gt,Dt,It,qt,ui)),pi=We.set(o.$tK.ExtHostNotebookDocuments,new J.$Hec(yt)),vi=We.set(o.$tK.ExtHostNotebookEditors,new X.$Gec($e,yt)),si=We.set(o.$tK.ExtHostNotebookKernels,new xe.$Dec(We,dt,yt,gt,$e)),Ii=We.set(o.$tK.ExtHostNotebookRenderers,new tt.$Fec(We,yt)),Ci=We.set(o.$tK.ExtHostNotebookDocumentSaveParticipant,new vt.$Nec($e,yt,We.getProxy(o.$sK.MainThreadBulkEdits))),Mt=We.set(o.$tK.ExtHostEditors,new F.$Qdc(We,Dt)),bi=We.set(o.$tK.ExtHostTreeViews,new O.$Rdc(We.getProxy(o.$sK.MainThreadTreeViews),gt,$e)),Pi=We.set(o.$tK.ExtHostEditorInsets,new ce.$1dc(We.getProxy(o.$sK.MainThreadEditorInsets),Mt,dt.remote)),oi=We.set(o.$tK.ExtHostDiagnostics,new u.$Ucc(We,$e,At,Dt)),hi=We.set(o.$tK.ExtHostLanguages,new k.$Gdc(We,It,gt.converter,Ct)),ct=We.set(o.$tK.ExtHostLanguageFeatures,new I.$Ycc(We,Ct,It,gt,oi,$e,Me,wt)),Ai=We.set(o.$tK.ExtHostFileSystem,new b.$Edc(We,ct)),Yt=We.set(o.$tK.ExtHostFileSystemEventService,new m.$Fdc(We,$e,Dt)),ii=We.set(o.$tK.ExtHostQuickOpen,(0,C.$Ldc)(We,ot,gt)),Ri=We.set(o.$tK.ExtHostSCM,new B.$Ndc(We,gt,It,$e)),Mi=We.set(o.$tK.ExtHostQuickDiff,new Pt.$Kec(We,Ct)),Li=We.set(o.$tK.ExtHostShare,new Gt.$Pec(We,Ct)),Zi=We.set(o.$tK.ExtHostComments,(0,i.$2cc)(We,gt,It)),Fi=We.set(o.$tK.ExtHostProgress,new y.$Kdc(We.getProxy(o.$sK.MainThreadProgress))),Xi=We.set(o.$tK.ExtHosLabelService,new ve.$2dc(We)),Ti=We.set(o.$tK.ExtHostTheming,new ie.$qec(We)),ai=We.set(o.$tK.ExtHostAuthentication,new Pe.$rec(We)),mn=We.set(o.$tK.ExtHostTimeline,new T.$tec(We,gt)),Ni=We.set(o.$tK.ExtHostWebviews,new Ie.$Vdc(We,dt.remote,ot,$e,Me)),di=We.set(o.$tK.ExtHostWebviewPanels,new Y.$vec(We,Ni,ot)),Oi=We.set(o.$tK.ExtHostCustomEditors,new K.$wec(We,It,Ce,Ni,di)),$n=We.set(o.$tK.ExtHostWebviewViews,new Q.$uec(We,Ni)),fi=We.set(o.$tK.ExtHostTesting,new Be.$yec(We,gt,Dt)),Yi=We.set(o.$tK.ExtHostUriOpeners,new Je.$Cec(We)),Ui=We.set(o.$tK.ExtHostProfileContentHandlers,new bt.$Jec(We));We.set(o.$tK.ExtHostInteractive,new Ee.$Iec(We,yt,Dt,gt,$e));const xi=We.set(o.$tK.ExtHostInlineChat,new Ht.$Mec(We,gt,It,$e)),gi=We.set(o.$tK.ExtHostChatProvider,new Bt.$Qec(We,$e)),_i=We.set(o.$tK.ExtHostChatAgents,new Wt.$Vec(We,gi,$e)),pn=We.set(o.$tK.ExtHostChatAgents2,new Vt.$Wec(We,gi,$e)),zi=We.set(o.$tK.ExtHostChatVariables,new Ft.$Sec(We)),mi=We.set(o.$tK.ExtHostChat,new Kt.$Lec(We,$e)),xt=We.set(o.$tK.ExtHostAiRelatedInformation,new jt.$Tec(We)),wi=We.set(o.$tK.ExtHostAiEmbeddingVector,new Qt.$Uec(We)),en=We.set(o.$tK.ExtHostIssueReporter,new zt.$Oec(We)),Zt=We.set(o.$tK.ExtHostStatusBar,new j.$Pdc(We,gt.converter)),yi=We.set(o.$tK.ExtHostSpeech,new kt.$Rec(We)),tn=Object.values(o.$tK);We.assertRegistered(tn);const nn=new ue.$xec(We,Dt),rn=new f.$1cc(We),Ei=new d.$Hdc(We,$e),sn=new a.$0cc(We);return p.$Zcc.register(gt),function(Te,_t,on){const mt=function(){let te=!Te.isUnderDevelopment;function ge(){te||($e.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")ge();else{const pt=rt;typeof pt.scheme>"u"&&ge(),typeof pt.exclusive=="boolean"&&(0,Oe.$sF)(Te,"documentFiltersExclusive")}return rt}}(),Bi={getSession(te,ge,Fe){return ai.getSession(Te,te,ge,Fe)},getSessions(te,ge){return(0,Oe.$sF)(Te,"authGetSessions"),ai.getSessions(Te,te,ge)},async hasSession(te,ge){return(0,Oe.$sF)(Te,"authSession"),!!await ai.getSession(Te,te,ge,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(te,ge,Fe,rt){return ai.registerAuthenticationProvider(te,ge,Fe,rt)}},an={registerCommand(te,ge,Fe){return gt.registerCommand(!0,te,ge,Fe,void 0,Te)},registerTextEditorCommand(te,ge,Fe){return gt.registerCommand(!0,te,(...rt)=>{const pt=Mt.getActiveTextEditor();if(!pt){$e.warn("Cannot execute "+te+" because there is no active text editor.");return}return pt.edit(Lt=>{ge.apply(Fe,[pt,Lt,...rt])}).then(Lt=>{Lt||$e.warn("Edits from command "+te+" were not applied.")},Lt=>{$e.warn("An error occurred while running command "+te,Lt)})},void 0,void 0,Te)},registerDiffInformationCommand:(te,ge,Fe)=>((0,Oe.$sF)(Te,"diffCommand"),gt.registerCommand(!0,te,async(...rt)=>{const pt=Dt.activeEditor(!0);if(!pt){$e.warn("Cannot execute "+te+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(pt.id);ge.apply(Fe,[Lt,...rt])},void 0,void 0,Te)),executeCommand(te,...ge){return gt.executeCommand(te,...ge)},getCommands(te=!1){return gt.getCommands(te)}},ji={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return ht.getDefaultShell(!1)},get onDidChangeShell(){return ht.onDidChangeShell},get isTelemetryEnabled(){return wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return wt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$sF)(Te,"telemetry"),wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$sF)(Te,"telemetry"),wt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$NM)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ge){return Ye.$MM.validateSender(te),wt.instantiateLogger(Te,te,ge)},openExternal(te,ge){return ze.openUri(te,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===dt.environment.appUriScheme)return $i.createAppUri(te);try{return await ze.asExternalUri(te,{allowTunneling:!!dt.remote.authority})}catch(ge){if((0,ut.$BU)(te,Ue.Schemas.http)||(0,ut.$BU)(te,Ue.Schemas.https))return te;throw ge}},get remoteName(){return(0,_.$Wk)(dt.remote.authority)},get remoteAuthority(){return(0,Oe.$sF)(Te,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return $e.getLevel()},get onDidChangeLogLevel(){return $e.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Oe.$sF)(Te,"handleIssueUri"),en.registerIssueUriRequestHandler(Te,te)},registerIssueDataProvider(te){return(0,Oe.$sF)(Te,"handleIssueUri"),en.registerIssueDataProvider(Te,te)},get appQuality(){return(0,Oe.$sF)(Te,"resolvers"),dt.quality},get appCommit(){return(0,Oe.$sF)(Te,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(ji);const cn={createTestController(te,ge,Fe){return fi.createTestController(Te,te,ge,Fe)},createTestObserver(){return(0,Oe.$sF)(Te,"testObserver"),fi.createTestObserver()},runTests(te){return(0,Oe.$sF)(Te,"testObserver"),fi.runTests(te)},get onDidChangeTestResults(){return(0,Oe.$sF)(Te,"testObserver"),fi.onResultsChanged},get testResults(){return(0,Oe.$sF)(Te,"testObserver"),fi.results}},Di=dt.remote.isRemote?Z.ExtensionKind.Workspace:Z.ExtensionKind.UI,vn={getExtension(te,ge){(0,Oe.$rF)(Te,"extensionsAny")||(ge=!1);const Fe=_t.mine.getExtensionDescription(te);if(Fe)return new h.$Cdc(Rt,Te.identifier,Fe,Di,!1);if(ge){const rt=_t.all.getExtensionDescription(te);if(rt)return new h.$Cdc(Rt,Te.identifier,rt,Di,!0)}},get all(){const te=[];for(const ge of _t.mine.getAllExtensionDescriptions())te.push(new h.$Cdc(Rt,Te.identifier,ge,Di,!1));return te},get allAcrossExtensionHosts(){(0,Oe.$sF)(Te,"extensionsAny");const te=new oe.$8l(_t.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Fe.identifier);ge.push(new h.$Cdc(Rt,Te.identifier,Fe,Di,rt))}return ge},get onDidChange(){return(0,Oe.$rF)(Te,"extensionsAny")?P.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Te.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(te,ge){return hi.changeLanguage(te.uri,ge)},match(te,ge){const Fe=It.getDocumentData(ge.uri)?.notebook;return(0,A.$EE)(x.LanguageSelector.from(te),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(te,ge,Fe){return ct.registerCodeActionProvider(Te,mt(te),ge,Fe)},registerDocumentPasteEditProvider(te,ge,Fe){return(0,Oe.$sF)(Te,"documentPaste"),ct.registerDocumentPasteEditProvider(Te,mt(te),ge,Fe)},registerCodeLensProvider(te,ge){return ct.registerCodeLensProvider(Te,mt(te),ge)},registerDefinitionProvider(te,ge){return ct.registerDefinitionProvider(Te,mt(te),ge)},registerDeclarationProvider(te,ge){return ct.registerDeclarationProvider(Te,mt(te),ge)},registerImplementationProvider(te,ge){return ct.registerImplementationProvider(Te,mt(te),ge)},registerTypeDefinitionProvider(te,ge){return ct.registerTypeDefinitionProvider(Te,mt(te),ge)},registerHoverProvider(te,ge){return ct.registerHoverProvider(Te,mt(te),ge,Te.identifier)},registerEvaluatableExpressionProvider(te,ge){return ct.registerEvaluatableExpressionProvider(Te,mt(te),ge,Te.identifier)},registerInlineValuesProvider(te,ge){return ct.registerInlineValuesProvider(Te,mt(te),ge,Te.identifier)},registerDocumentHighlightProvider(te,ge){return ct.registerDocumentHighlightProvider(Te,mt(te),ge)},registerLinkedEditingRangeProvider(te,ge){return ct.registerLinkedEditingRangeProvider(Te,mt(te),ge)},registerReferenceProvider(te,ge){return ct.registerReferenceProvider(Te,mt(te),ge)},registerRenameProvider(te,ge){return ct.registerRenameProvider(Te,mt(te),ge)},registerDocumentSymbolProvider(te,ge,Fe){return ct.registerDocumentSymbolProvider(Te,mt(te),ge,Fe)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Te,te)},registerDocumentFormattingEditProvider(te,ge){return ct.registerDocumentFormattingEditProvider(Te,mt(te),ge)},registerDocumentRangeFormattingEditProvider(te,ge){return ct.registerDocumentRangeFormattingEditProvider(Te,mt(te),ge)},registerOnTypeFormattingEditProvider(te,ge,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(Te,mt(te),ge,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(te,ge,Fe){return ct.registerDocumentSemanticTokensProvider(Te,mt(te),ge,Fe)},registerDocumentRangeSemanticTokensProvider(te,ge,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Te,mt(te),ge,Fe)},registerSignatureHelpProvider(te,ge,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Te,mt(te),ge,Fe):ct.registerSignatureHelpProvider(Te,mt(te),ge,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(te,ge,...Fe){return ct.registerCompletionItemProvider(Te,mt(te),ge,Fe)},registerInlineCompletionItemProvider(te,ge,Fe){return ge.handleDidShowCompletionItem&&(0,Oe.$sF)(Te,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$sF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Oe.$sF)(Te,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Te,mt(te),ge,Fe)},registerDocumentLinkProvider(te,ge){return ct.registerDocumentLinkProvider(Te,mt(te),ge)},registerColorProvider(te,ge){return ct.registerColorProvider(Te,mt(te),ge)},registerFoldingRangeProvider(te,ge){return ct.registerFoldingRangeProvider(Te,mt(te),ge)},registerSelectionRangeProvider(te,ge){return ct.registerSelectionRangeProvider(Te,te,ge)},registerCallHierarchyProvider(te,ge){return ct.registerCallHierarchyProvider(Te,te,ge)},registerTypeHierarchyProvider(te,ge){return ct.registerTypeHierarchyProvider(Te,te,ge)},setLanguageConfiguration:(te,ge)=>ct.setLanguageConfiguration(Te,te,ge),getTokenInformationAtPosition(te,ge){return(0,Oe.$sF)(Te,"tokenInformation"),hi.tokenAtPosition(te,ge)},registerInlayHintsProvider(te,ge){return ct.registerInlayHintsProvider(Te,te,ge)},createLanguageStatusItem(te,ge){return hi.createLanguageStatusItem(Te,te,ge)},registerDocumentDropEditProvider(te,ge,Fe){return ct.registerDocumentOnDropEditProvider(Te,te,ge,(0,Oe.$rF)(Te,"dropMetadata")?Fe:void 0)}},ln={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(te,ge,Fe){const rt=await(R.URI.isUri(te)?Promise.resolve(ki.openTextDocument(te)):Promise.resolve(te));return Mt.showTextDocument(rt,ge,Fe)},createTextEditorDecorationType(te){return Mt.createTextEditorDecorationType(Te,te)},onDidChangeActiveTextEditor(te,ge,Fe){return Mt.onDidChangeActiveTextEditor(te,ge,Fe)},onDidChangeVisibleTextEditors(te,ge,Fe){return Mt.onDidChangeVisibleTextEditors(te,ge,Fe)},onDidChangeTextEditorSelection(te,ge,Fe){return Mt.onDidChangeTextEditorSelection(te,ge,Fe)},onDidChangeTextEditorOptions(te,ge,Fe){return Mt.onDidChangeTextEditorOptions(te,ge,Fe)},onDidChangeTextEditorVisibleRanges(te,ge,Fe){return Mt.onDidChangeTextEditorVisibleRanges(te,ge,Fe)},onDidChangeTextEditorViewColumn(te,ge,Fe){return Mt.onDidChangeTextEditorViewColumn(te,ge,Fe)},onDidCloseTerminal(te,ge,Fe){return ht.onDidCloseTerminal(te,ge,Fe)},onDidOpenTerminal(te,ge,Fe){return ht.onDidOpenTerminal(te,ge,Fe)},onDidChangeActiveTerminal(te,ge,Fe){return ht.onDidChangeActiveTerminal(te,ge,Fe)},onDidChangeTerminalDimensions(te,ge,Fe){return(0,Oe.$sF)(Te,"terminalDimensions"),ht.onDidChangeTerminalDimensions(te,ge,Fe)},onDidChangeTerminalState(te,ge,Fe){return ht.onDidChangeTerminalState(te,ge,Fe)},onDidWriteTerminalData(te,ge,Fe){return(0,Oe.$sF)(Te,"terminalDataWriteEvent"),ht.onDidWriteTerminalData(te,ge,Fe)},onDidExecuteTerminalCommand(te,ge,Fe){return(0,Oe.$sF)(Te,"terminalExecuteCommandEvent"),ht.onDidExecuteTerminalCommand(te,ge,Fe)},get state(){return ze.getState(Te)},onDidChangeWindowState(te,ge,Fe){return ze.onDidChangeWindowState(te,ge,Fe)},showInformationMessage(te,...ge){return Ei.showMessage(Te,M.default.Info,te,ge[0],ge.slice(1))},showWarningMessage(te,...ge){return Ei.showMessage(Te,M.default.Warning,te,ge[0],ge.slice(1))},showErrorMessage(te,...ge){return Ei.showMessage(Te,M.default.Error,te,ge[0],ge.slice(1))},showQuickPick(te,ge,Fe){return ii.showQuickPick(Te,te,ge,Fe)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,ge){return ii.showInput(te,ge)},showOpenDialog(te){return sn.showOpenDialog(Te,te)},showSaveDialog(te){return sn.showSaveDialog(te)},createStatusBarItem(te,ge,Fe){let rt,pt,Lt;return typeof te=="string"?(rt=te,pt=ge,Lt=Fe):(pt=te,Lt=ge),Zt.createStatusBarEntry(Te,rt,pt,Lt)},setStatusBarMessage(te,ge){return Zt.setStatusBarMessage(te,ge)},withScmProgress(te){return Me.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Fi.withProgress(Te,{location:Z.ProgressLocation.SourceControl},(ge,Fe)=>te({report(rt){}}))},withProgress(te,ge){return Fi.withProgress(Te,te,ge)},createOutputChannel(te,ge){return Si.createOutputChannel(te,ge,Te)},createWebviewPanel(te,ge,Fe,rt){return di.createWebviewPanel(Te,te,ge,Fe,rt)},createWebviewTextEditorInset(te,ge,Fe,rt){return(0,Oe.$sF)(Te,"editorInsets"),Pi.createWebviewEditorInset(te,ge,Fe,rt,Te)},createTerminal(te,ge,Fe){return typeof te=="object"?"pty"in te?ht.createExtensionTerminal(te):ht.createTerminalFromOptions(te):ht.createTerminal(te,ge,Fe)},registerTerminalLinkProvider(te){return ht.registerLinkProvider(te)},registerTerminalProfileProvider(te,ge){return ht.registerProfileProvider(Te,te,ge)},registerTerminalQuickFixProvider(te,ge){return(0,Oe.$sF)(Te,"terminalQuickFixProvider"),ht.registerTerminalQuickFixProvider(te,Te.identifier.value,ge)},registerTreeDataProvider(te,ge){return bi.registerTreeDataProvider(te,ge,Te)},createTreeView(te,ge){return bi.createTreeView(te,ge,Te)},registerWebviewPanelSerializer:(te,ge)=>di.registerWebviewPanelSerializer(Te,te,ge),registerCustomEditorProvider:(te,ge,Fe={})=>Oi.registerCustomEditorProvider(Te,te,ge,Fe),registerFileDecorationProvider(te){return Et.registerFileDecorationProvider(te,Te)},registerUriHandler(te){return $i.registerUriHandler(Te,te)},createQuickPick(){return ii.createQuickPick(Te)},createInputBox(){return ii.createInputBox(Te)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(te,ge,Fe){return Ti.onDidChangeActiveColorTheme(te,ge,Fe)},registerWebviewViewProvider(te,ge,Fe){return $n.registerWebviewViewProvider(Te,te,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ge,Fe){return yt.onDidChangeActiveNotebookEditor(te,ge,Fe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ge,Fe){return vi.onDidChangeNotebookEditorSelection(te,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(te,ge,Fe){return vi.onDidChangeNotebookEditorVisibleRanges(te,ge,Fe)},showNotebookDocument(te,ge){return yt.showNotebookDocument(te,ge)},registerExternalUriOpener(te,ge,Fe){return(0,Oe.$sF)(Te,"externalUriOpener"),Yi.registerExternalUriOpener(Te.identifier,te,ge,Fe)},registerProfileContentHandler(te,ge){return(0,Oe.$sF)(Te,"profileContentHandlers"),Ui.registrProfileContentHandler(Te,te,ge)},registerQuickDiffProvider(te,ge,Fe,rt){return(0,Oe.$sF)(Te,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(te),ge,Fe,rt)},get tabGroups(){return qe.tabGroups},registerShareProvider(te,ge){return(0,Oe.$sF)(Te,"shareProvider"),Li.registerShareProvider(mt(te),ge)}},ki={get rootPath(){return Me.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw new L.$8("rootPath")},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw new L.$8("name")},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw new L.$8("workspaceFile")},updateWorkspaceFolders:(te,ge,...Fe)=>ot.updateWorkspaceFolders(Te,te,ge||0,...Fe),onDidChangeWorkspaceFolders:function(te,ge,Fe){return ot.onDidChangeWorkspace(te,ge,Fe)},asRelativePath:(te,ge)=>ot.getRelativePath(te,ge),findFiles:(te,ge,Fe,rt)=>ot.findFiles(te,ge,Fe,Te.identifier,rt),findTextInFiles:(te,ge,Fe,rt)=>{(0,Oe.$sF)(Te,"findTextInFiles");let pt,Lt;return typeof ge=="object"?(pt=ge,Lt=Fe):(pt={},Lt=ge,rt=Fe),ot.findTextInFiles(te,pt||{},Lt,Te.identifier,rt)},save:te=>((0,Oe.$sF)(Te,"saveEditor"),ot.save(te)),saveAs:te=>((0,Oe.$sF)(Te,"saveEditor"),ot.saveAs(te)),saveAll:te=>ot.saveAll(te),applyEdit(te,ge){return nn.applyWorkspaceEdit(te,Te,ge)},createFileSystemWatcher:(te,ge,Fe,rt)=>{let pt;return typeof ge=="boolean"?pt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!rt,correlate:!1}:ge&&((0,Oe.$sF)(Te,"createFileSystemWatcher"),pt={...ge,correlate:!0}),Yt.createFileSystemWatcher(ot,Te,te,pt)},get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new L.$8("textDocuments")},openTextDocument(te){let ge;const Fe=te;if(typeof te=="string")ge=Promise.resolve(R.URI.file(te));else if(R.URI.isUri(te))ge=Promise.resolve(te);else if(!Fe||typeof Fe=="object")ge=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(rt=>It.ensureDocumentData(rt).then(pt=>pt.document))},onDidOpenTextDocument:(te,ge,Fe)=>It.onDidAddDocument(te,ge,Fe),onDidCloseTextDocument:(te,ge,Fe)=>It.onDidRemoveDocument(te,ge,Fe),onDidChangeTextDocument:(te,ge,Fe)=>It.onDidChangeDocument(te,ge,Fe),onDidSaveTextDocument:(te,ge,Fe)=>It.onDidSaveDocument(te,ge,Fe),onWillSaveTextDocument:(te,ge,Fe)=>ri.getOnWillSaveTextDocumentEvent(Te)(te,ge,Fe),get notebookDocuments(){return yt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ge){let Fe;if(R.URI.isUri(te))Fe=te,await yt.openNotebookDocument(te);else if(typeof te=="string")Fe=R.URI.revive(await yt.createNotebookDocument({viewType:te,content:ge}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,ge,Fe){return pi.onDidSaveNotebookDocument(te,ge,Fe)},onDidChangeNotebookDocument(te,ge,Fe){return pi.onDidChangeNotebookDocument(te,ge,Fe)},onWillSaveNotebookDocument(te,ge,Fe){return Ci.getOnWillSaveNotebookDocumentEvent(Te)(te,ge,Fe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(te,ge,Fe,rt){return yt.registerNotebookSerializer(Te,te,ge,Fe,(0,Oe.$rF)(Te,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,ge,Fe)=>on.onDidChangeConfiguration(te,ge,Fe),getConfiguration(te,ge){return ge=arguments.length===1?void 0:ge,on.getConfiguration(te,ge,Te)},registerTextDocumentContentProvider(te,ge){return gn.registerTextDocumentContentProvider(te,ge)},registerTaskProvider:(te,ge)=>(Me.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Te,te,ge)),registerFileSystemProvider(te,ge,Fe){return(0,je.$Oc)(Ai.registerFileSystemProvider(Te,te,ge,Fe),qt.addFileSystemProvider(te,ge,Fe))},get fs(){return qt.value},registerFileSearchProvider:(te,ge)=>((0,Oe.$sF)(Te,"fileSearchProvider"),ui.registerFileSearchProvider(te,ge)),registerTextSearchProvider:(te,ge)=>((0,Oe.$sF)(Te,"textSearchProvider"),ui.registerTextSearchProvider(te,ge)),registerRemoteAuthorityResolver:(te,ge)=>((0,Oe.$sF)(Te,"resolvers"),Rt.registerRemoteAuthorityResolver(te,ge)),registerResourceLabelFormatter:te=>((0,Oe.$sF)(Te,"resolvers"),Xi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Oe.$sF)(Te,"resolvers"),Rt.getRemoteExecServer(te)),onDidCreateFiles:(te,ge,Fe)=>Yt.onDidCreateFile(te,ge,Fe),onDidDeleteFiles:(te,ge,Fe)=>Yt.onDidDeleteFile(te,ge,Fe),onDidRenameFiles:(te,ge,Fe)=>Yt.onDidRenameFile(te,ge,Fe),onWillCreateFiles:(te,ge,Fe)=>Yt.getOnWillCreateFileEvent(Te)(te,ge,Fe),onWillDeleteFiles:(te,ge,Fe)=>Yt.getOnWillDeleteFileEvent(Te)(te,ge,Fe),onWillRenameFiles:(te,ge,Fe)=>Yt.getOnWillRenameFileEvent(Te)(te,ge,Fe),openTunnel:te=>((0,Oe.$sF)(Te,"tunnels"),H.openTunnel(Te,te).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Oe.$sF)(Te,"tunnels"),H.getTunnels()},onDidChangeTunnels:(te,ge,Fe)=>((0,Oe.$sF)(Te,"tunnels"),H.onDidChangeTunnels(te,ge,Fe)),registerPortAttributesProvider:(te,ge)=>((0,Oe.$sF)(Te,"portsAttributes"),H.registerPortsAttributesProvider(te,ge)),registerTunnelProvider:(te,ge)=>((0,Oe.$sF)(Te,"tunnelFactory"),H.registerTunnelProvider(te,ge)),registerTimelineProvider:(te,ge)=>((0,Oe.$sF)(Te,"timeline"),mn.registerTimelineProvider(te,ge,Te.identifier,gt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>((0,Oe.$sF)(Te,"workspaceTrust"),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ge,Fe)=>ot.onDidGrantWorkspaceTrust(te,ge,Fe),registerEditSessionIdentityProvider:(te,ge)=>((0,Oe.$sF)(Te,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(te,ge)),onWillCreateEditSessionIdentity:(te,ge,Fe)=>((0,Oe.$sF)(Te,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(Te)(te,ge,Fe)),registerCanonicalUriProvider:(te,ge)=>((0,Oe.$sF)(Te,"canonicalUriProvider"),ot.registerCanonicalUriProvider(te,ge)),getCanonicalUri:(te,ge,Fe)=>((0,Oe.$sF)(Te,"canonicalUriProvider"),ot.provideCanonicalUri(te,ge,Fe))},Wi={get inputBox(){return Me.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Te)},createSourceControl(te,ge,Fe){return Ri.createSourceControl(Te,te,ge,Fe)}},Vi={createCommentController(te,ge){return Zi.createCommentController(Te,te,ge)}},ci={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(te,ge,Fe){return ft.onDidStartDebugSession(te,ge,Fe)},onDidTerminateDebugSession(te,ge,Fe){return ft.onDidTerminateDebugSession(te,ge,Fe)},onDidChangeActiveDebugSession(te,ge,Fe){return ft.onDidChangeActiveDebugSession(te,ge,Fe)},onDidReceiveDebugSessionCustomEvent(te,ge,Fe){return ft.onDidReceiveDebugSessionCustomEvent(te,ge,Fe)},onDidChangeBreakpoints(te,ge,Fe){return ft.onDidChangeBreakpoints(te,ge,Fe)},onDidChangeStackFrameFocus(te,ge,Fe){return(0,Oe.$sF)(Te,"debugFocus"),ft.onDidChangeStackFrameFocus(te,ge,Fe)},registerDebugConfigurationProvider(te,ge,Fe){return ft.registerDebugConfigurationProvider(te,ge,Fe||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ge){return ft.registerDebugAdapterDescriptorFactory(Te,te,ge)},registerDebugAdapterTrackerFactory(te,ge){return ft.registerDebugAdapterTrackerFactory(te,ge)},startDebugging(te,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ft.startDebugging(te,ge,{parentSession:Fe}):ft.startDebugging(te,ge,Fe||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,ge){return ft.asDebugSourceUri(te,ge)}},qi={registerTaskProvider:(te,ge)=>St.registerTaskProvider(Te,te,ge),fetchTasks:te=>St.fetchTasks(te),executeTask:te=>St.executeTask(Te,te),get taskExecutions(){return St.taskExecutions},onDidStartTask:(te,ge,Fe)=>St.onDidStartTask(te,ge,Fe),onDidEndTask:(te,ge,Fe)=>St.onDidEndTask(te,ge,Fe),onDidStartTaskProcess:(te,ge,Fe)=>St.onDidStartTaskProcess(te,ge,Fe),onDidEndTaskProcess:(te,ge,Fe)=>St.onDidEndTaskProcess(te,ge,Fe)},Ki={createNotebookController(te,ge,Fe,rt,pt){return si.createNotebookController(Te,te,ge,Fe,rt,(0,Oe.$rF)(Te,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ge)=>yt.registerNotebookCellStatusBarItemProvider(Te,te,ge),createRendererMessaging(te){return Ii.createRendererMessaging(Te,te)},createNotebookControllerDetectionTask(te){return(0,Oe.$sF)(Te,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Te,te)},registerKernelSourceActionProvider(te,ge){return(0,Oe.$sF)(Te,"notebookKernelSource"),si.registerKernelSourceActionProvider(Te,te,ge)},onDidChangeNotebookCellExecutionState(te,ge,Fe){return(0,Oe.$sF)(Te,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,ge,Fe)}},Hi={t(...te){if(typeof te[0]=="string"){const ge=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return li.getMessage(Te.identifier.value,{message:ge,args:Fe})}return li.getMessage(Te.identifier.value,te[0])},get bundle(){return li.getBundle(Te.identifier.value)},get uri(){return li.getBundleUri(Te.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(te,ge){return(0,Oe.$sF)(Te,"interactive"),xi.registerProvider(Te,te,ge={label:ge?.label??Te.displayName??Te.name})},registerInteractiveSessionProvider(te,ge){return(0,Oe.$sF)(Te,"interactive"),mi.registerChatProvider(Te,te,ge)},sendInteractiveRequestToProvider(te,ge){return(0,Oe.$sF)(Te,"interactive"),mi.sendInteractiveRequestToProvider(te,ge)},get onDidPerformUserAction(){return(0,Oe.$sF)(Te,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(te,ge){return(0,Oe.$sF)(Te,"interactive"),mi.transferChatSession(te,ge)}},hn={getRelatedInformation(te,ge){return(0,Oe.$sF)(Te,"aiRelatedInformation"),xt.getRelatedInformation(Te,te,ge)},registerRelatedInformationProvider(te,ge){return(0,Oe.$sF)(Te,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Te,te,ge)},registerEmbeddingVectorProvider(te,ge){return(0,Oe.$sF)(Te,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Te,te,ge)}},dn={registerChatResponseProvider(te,ge,Fe){return(0,Oe.$sF)(Te,"chatProvider"),gi.registerProvider(Te.identifier,te,ge,Fe)},requestChatAccess(te){return(0,Oe.$sF)(Te,"chatRequestAccess"),gi.requestChatResponseProvider(Te.identifier,te)},registerVariable(te,ge,Fe){return(0,Oe.$sF)(Te,"chatVariables"),zi.registerVariableResolver(Te,te,ge,Fe)},registerMappedEditsProvider(te,ge){return(0,Oe.$sF)(Te,"mappedEditsProvider"),ct.registerMappedEditsProvider(Te,te,ge)},createChatAgent(te,ge){return(0,Oe.$sF)(Te,"chatAgents2"),pn.createChatAgent(Te,te,ge)},registerAgent(te,ge,Fe){return(0,Oe.$sF)(Te,"chatAgents"),_i.registerAgent(Te.identifier,te,ge,Fe)}},fn={registerSpeechProvider(te,ge){return(0,Oe.$sF)(Te,"speech"),yi.registerProvider(Te.identifier,te,ge)}};return{version:dt.version,ai:hn,authentication:Bi,commands:an,comments:Vi,chat:dn,debug:ci,env:ji,extensions:vn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:qi,tests:cn,window:ln,workspace:ki,Breakpoint:Z.$sL,TerminalOutputAnchor:Z.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Z.ChatAgentResultFeedbackKind,ChatMessage:Z.$jM,ChatMessageRole:Z.ChatMessageRole,ChatVariableLevel:Z.ChatVariableLevel,CallHierarchyIncomingCall:Z.$RK,CallHierarchyItem:Z.$QK,CallHierarchyOutgoingCall:Z.$SK,CancellationError:L.$4,CancellationTokenSource:E.$Xd,CandidatePortSource:o.CandidatePortSource,CodeAction:Z.$NK,CodeActionKind:Z.$OK,CodeActionTriggerKind:Z.CodeActionTriggerKind,CodeLens:Z.$TK,Color:Z.$7K,ColorInformation:Z.$8K,ColorPresentation:Z.$9K,ColorThemeKind:Z.ColorThemeKind,CommentMode:Z.CommentMode,CommentState:Z.CommentState,CommentThreadCollapsibleState:Z.CommentThreadCollapsibleState,CommentThreadState:Z.CommentThreadState,CompletionItem:Z.$1K,CompletionItemKind:Z.CompletionItemKind,CompletionItemTag:Z.CompletionItemTag,CompletionList:Z.$2K,CompletionTriggerKind:Z.CompletionTriggerKind,ConfigurationTarget:Z.ConfigurationTarget,CustomExecution:Z.$eL,DebugAdapterExecutable:Z.$wL,DebugAdapterInlineImplementation:Z.$zL,DebugAdapterNamedPipeServer:Z.$yL,DebugAdapterServer:Z.$xL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Z.DebugConsoleMode,DecorationRangeBehavior:Z.DecorationRangeBehavior,Diagnostic:Z.$IK,DiagnosticRelatedInformation:Z.$HK,DiagnosticSeverity:Z.DiagnosticSeverity,DiagnosticTag:Z.DiagnosticTag,Disposable:Z.$uK,DocumentHighlight:Z.$KK,DocumentHighlightKind:Z.DocumentHighlightKind,DocumentLink:Z.$6K,DocumentSymbol:Z.$MK,EndOfLine:Z.EndOfLine,EnvironmentVariableMutatorType:Z.EnvironmentVariableMutatorType,EvaluatableExpression:Z.$CL,InlineValueText:Z.$DL,InlineValueVariableLookup:Z.$EL,InlineValueEvaluatableExpression:Z.$FL,InlineCompletionTriggerKind:Z.InlineCompletionTriggerKind,EventEmitter:P.$Nd,ExtensionKind:Z.ExtensionKind,ExtensionMode:Z.ExtensionMode,ExternalUriOpenerPriority:Z.ExternalUriOpenerPriority,FileChangeType:Z.FileChangeType,FileDecoration:Z.$PL,FileDecoration2:Z.$PL,FileSystemError:Z.$HL,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Z.$IL,FoldingRangeKind:Z.FoldingRangeKind,FunctionBreakpoint:Z.$uL,InlineCompletionItem:Z.$3K,InlineCompletionList:Z.$4K,Hover:Z.$JK,IndentAction:g.IndentAction,Location:Z.$GK,MarkdownString:Z.$UK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:Z.$VK,PortAutoForwardAction:Z.PortAutoForwardAction,Position:Z.$vK,ProcessExecution:Z.$cL,ProgressLocation:Z.ProgressLocation,QuickInputButtons:Z.$OL,Range:Z.$wK,RelativePattern:Z.$qL,Selection:Z.$xK,SelectionRange:Z.$PK,SemanticTokens:Z.$LL,SemanticTokensBuilder:Z.$KL,SemanticTokensEdit:Z.$ML,SemanticTokensEdits:Z.$NL,SemanticTokensLegend:Z.$JL,ShellExecution:Z.$dL,ShellQuoting:Z.ShellQuoting,SignatureHelp:Z.$XK,SignatureHelpTriggerKind:Z.SignatureHelpTriggerKind,SignatureInformation:Z.$WK,SnippetString:Z.$FK,SourceBreakpoint:Z.$tL,StandardTokenType:Z.StandardTokenType,StatusBarAlignment:Z.StatusBarAlignment,SymbolInformation:Z.$LK,SymbolKind:Z.SymbolKind,SymbolTag:Z.SymbolTag,Task:Z.$fL,TaskGroup:Z.$bL,TaskPanelKind:Z.TaskPanelKind,TaskRevealKind:Z.TaskRevealKind,TaskScope:Z.TaskScope,TerminalLink:Z.$0K,TerminalQuickFixExecuteTerminalCommand:Z.$_K,TerminalQuickFixOpener:Z.$$K,TerminalLocation:Z.TerminalLocation,TerminalProfile:Z.$aL,TerminalExitReason:Z.TerminalExitReason,TextDocumentSaveReason:Z.TextDocumentSaveReason,TextEdit:Z.$BK,SnippetTextEdit:Z.$DK,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:Z.TextEditorLineNumbersStyle,TextEditorRevealType:Z.TextEditorRevealType,TextEditorSelectionChangeKind:Z.TextEditorSelectionChangeKind,SyntaxTokenType:Z.SyntaxTokenType,TextDocumentChangeReason:Z.TextDocumentChangeReason,ThemeColor:Z.$pL,ThemeIcon:Z.$oL,TreeItem:Z.$gL,TreeItemCheckboxState:Z.TreeItemCheckboxState,TreeItemCollapsibleState:Z.TreeItemCollapsibleState,TypeHierarchyItem:Z.$$L,UIKind:v.UIKind,Uri:R.URI,ViewColumn:Z.ViewColumn,WorkspaceEdit:Z.$EK,DocumentDropEdit:Z.$mL,DocumentPasteEdit:Z.$nL,InlayHint:Z.$ZK,InlayHintLabelPart:Z.$YK,InlayHintKind:Z.InlayHintKind,RemoteAuthorityResolverError:Z.$AK,ResolvedAuthority:Z.$yK,ManagedResolvedAuthority:Z.$zK,SourceControlInputBoxValidationType:Z.SourceControlInputBoxValidationType,ExtensionRuntime:Z.ExtensionRuntime,TimelineItem:Z.$ZL,NotebookRange:Z.$RL,NotebookCellKind:Z.NotebookCellKind,NotebookCellExecutionState:Z.NotebookCellExecutionState,NotebookCellData:Z.$SL,NotebookData:Z.$TL,NotebookRendererScript:Z.$XL,NotebookCellStatusBarAlignment:Z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Z.NotebookEditorRevealType,NotebookCellOutput:Z.$VL,NotebookCellOutputItem:Z.$UL,NotebookCellStatusBarItem:Z.$WL,NotebookControllerAffinity:Z.NotebookControllerAffinity,NotebookControllerAffinity2:Z.NotebookControllerAffinity2,NotebookEdit:Z.$CK,NotebookKernelSourceAction:Z.$YL,PortAttributes:Z.$2L,LinkedEditingRanges:Z.$1L,TestResultState:Z.TestResultState,TestRunRequest:Z.$3L,TestMessage:Z.$4L,TestMessage2:Z.$4L,TestTag:Z.$5L,TestRunProfileKind:Z.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Z.$lL,DataTransferItem:Z.$hL,CoveredCount:Z.$6L,FileCoverage:Z.$7L,StatementCoverage:Z.$8L,BranchCoverage:Z.$9L,FunctionCoverage:Z.$0L,WorkspaceTrustState:Z.WorkspaceTrustState,LanguageStatusSeverity:Z.LanguageStatusSeverity,QuickPickItemKind:Z.QuickPickItemKind,InputBoxValidationSeverity:Z.InputBoxValidationSeverity,TabInputText:Z.$_L,TabInputTextDiff:Z.$aM,TabInputTextMerge:Z.$bM,TabInputCustom:Z.$cM,TabInputNotebook:Z.$eM,TabInputNotebookDiff:Z.$fM,TabInputWebview:Z.$dM,TabInputTerminal:Z.$gM,TabInputInteractiveWindow:Z.$hM,TabInputChat:Z.$iM,TelemetryTrustedValue:De.$ko,LogLevel:he.LogLevel,EditSessionIdentityMatch:$t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Z.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Z.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Z.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Z.$AL,ThreadFocus:Z.$BL,RelatedInformationType:Z.RelatedInformationType,SpeechToTextStatus:Z.SpeechToTextStatus}}}e.$Xec=Ot}),define(Ae[293],Re([1,0,71,112,35,110,36,32,62,65,115,117,118,85,87,81,111,64,42,84,61,63,258,15,116,82,83]),function(pe,e,E,L,P,M,R,$,D,g,A,S,o,v,p,f,t,i,n,u,a,l,r,s,c,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$xr)(h.$wdc,h.$vdc,1),(0,E.$xr)(s.$_i,r.$Yec,1),(0,E.$xr)(f.$Vcc,f.$Wcc,1),(0,E.$xr)($.$QM,$.$PM,0),(0,E.$xr)(R.$9cc,R.$7cc,0),(0,E.$xr)(i.$ldc,i.$kdc,0),(0,E.$xr)(S.$_dc,S.$dec,0),(0,E.$xr)(M.$4dc,M.$3dc,0),(0,E.$xr)(D.$FM,D.$EM,0),(0,E.$xr)(b.$xdc,b.$ydc,0),(0,E.$xr)(n.$Scc,n.$Rcc,0),(0,E.$xr)(L.$Jdc,L.$Idc,1),(0,E.$xr)(o.$jec,o.$kec,0),(0,E.$xr)(v.$hdc,v.$gdc,0),(0,E.$xr)(A.$7dc,A.$6dc,0),(0,E.$xr)(g.$odc,g.$rdc,0),(0,E.$xr)(p.$Cwb,p.$Dwb,0),(0,E.$xr)(t.$Zdc,t.$Ydc,0),(0,E.$xr)(P.$6cc,P.$5cc,0),(0,E.$xr)(u.$tdc,u.$sdc,0),(0,E.$xr)(a.$OM,a.$LM,0),(0,E.$xr)(l.$8dc,l.$9dc,0),(0,E.$xr)(c.$0dc,c.$$dc,0)}),define(Ae[294],Re([1,0,292,37,2,289,7,12,277]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;class g extends M.$2ec{j(){}getModule(v,p){for(const f of this.b){const t=f(v);if(t){v=t;break}}if(this.a.has(v))return this.a.get(v).load(v,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends L.$Adc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$7gc);const v=this.h.invokeFunction(E.$Xec);this.r=this.h.createInstance(g,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,p,f){p=p.with({path:S(p.path,".js")});const t=v?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this.C.$asBrowserUri(p)),n=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),n.status!==200)throw new Error(n.statusText);const u=await n.text(),a=`${p.toString(!0)}#vscode-extension`,l=`${u}
//# sourceURL=${a}`;let r;try{r=new Function("module","exports","require",l)}catch(b){throw console.error(t?`Loading code for extension ${t} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${p.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}v&&await this.w.initializeLocalizedMessages(v);const s={},c={exports:s},h=b=>{const m=this.r.getModule(b,p);if(m===void 0)throw new Error(`Cannot load module '${b}'`);return m};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(c,s,h),c.exports!==s?c.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+v;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Ug)(10)}}e.$8gc=A;function S(o,v){return o.endsWith(v)?o:o+v}}),define(Ae[295],Re([1,0,70,71,15,37,201,86,294]),function(pe,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.$xr)(P.$$i,new E.$Nh(R.$1ec,[!0],!0)),(0,L.$xr)(M.$Bdc,D.$8gc,0),(0,L.$xr)($.$mdc,$.$ndc,0)}),define(Ae[301],Re([1,0,23,5,79,290,279,19,88,14,2,293,295]),function(pe,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const o=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(r){return/^(file|vscode-remote):/i.test(r)}const p=fetch.bind(self);function f(r){self.fetch=async function(s,c){return s instanceof Request||v(String(s))&&(s=(await r(A.URI.parse(String(s)))).toString(!0)),p(s,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,c,h,b,m){(async()=>(v(c.toString())&&(c=(await r(A.URI.parse(c.toString()))).toString(!0)),super.open(s,c,h??!0,b,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,c){if(/^file:/i.test(s.toString()))s=g.$cg.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(d){function w(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const y=fetch.bind(self);self.fetch=function(B,j){return B instanceof Request?y(B,j):y(w(B),j)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,j,V,z,F){return super.open(B,w(j),V??!0,z,F)}};const C=importScripts.bind(self);self.importScripts=(...B)=>{C(...B.map(w))},C(d)}.toString()}('${s}'))`;c=c||{},c.name=c.name||$.$mc(s.toString());const m=new Blob([b],{type:"application/javascript"}),I=URL.createObjectURL(m);return new r(I,c)}}else self.Worker=class extends R.$9gc{constructor(r,s){super(o,r,{name:$.$mc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){S()}};class i{constructor(){const s=new MessageChannel,c=new L.$Nd;let h=!1;o(s.port2,[s.port2]),s.port1.onmessage=b=>{const{data:m}=b;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const I=E.$be.wrap(new Uint8Array(m,0,m.byteLength));if((0,P.$dm)(I,2)){h=!0,u("received terminate message from renderer");return}c.fire(I)},this.protocol={onMessage:c.event,send:b=>{if(!h){const m=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function n(r){return new Promise(s=>{const c=r.onMessage(h=>{c.dispose();const b=JSON.parse(h.toString());r.send((0,P.$cm)(0)),s({protocol:r,initData:b})});r.send((0,P.$cm)(1))})}let u=r=>S();function a(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function l(){D.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(s){a(s)&&n(r.protocol).then(c=>{D.mark("code/extHost/didWaitForInitData");const h=new M.$4ec(c.protocol,c.initData,t,null,s.data);f(b=>h.asBrowserUri(b)),u=b=>h.terminate(b)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec3f042f9d6b042b9b2e83082ca53f18fee92070/core/vs/workbench/api/worker/extensionHostWorker.js.map
