/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],K=function(z){for(var e=[],P=0,k=z.length;P<k;P++)e[P]=q[z[P]];return e};define(q[21],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class P{static get(){const v=new Map,I=new Map,s=new Map,d=new Map;function t(c,n){c.has(n.detail)||c.set(n.detail,-n.timestamp)}function r(c,n){const i=c.get(n.detail);i&&(i>=0||c.set(n.detail,i+n.timestamp))}let h=[];typeof z=="function"&&typeof z.getStats=="function"&&(h=z.getStats().slice(0).sort((c,n)=>c.timestamp-n.timestamp));for(const c of h)switch(c.type){case 10:t(v,c);break;case 11:case 12:r(v,c);break;case 21:t(I,c);break;case 22:r(I,c);break;case 33:t(s,c);break;case 34:r(s,c);break;case 31:t(d,c);break;case 32:r(d,c);break}let o=0;s.forEach(c=>o+=c);function g(c){const n=[];return c.forEach((i,a)=>n.push([a,i])),n}return{amdLoad:g(v),amdInvoke:g(I),nodeRequire:g(s),nodeEval:g(d),nodeRequireTotal:o}}static toMarkdownTable(v,I){let s="";const d=[];return v.forEach((t,r)=>{d[r]=t.length}),I.forEach(t=>{t.forEach((r,h)=>{typeof r>"u"&&(r=t[h]="-");const o=r.toString().length;d[h]=Math.max(o,d[h])})}),v.forEach((t,r)=>{s+=`| ${t+" ".repeat(d[r]-t.toString().length)} `}),s+=`|
`,v.forEach((t,r)=>{s+=`| ${"-".repeat(d[r])} `}),s+=`|
`,I.forEach(t=>{t.forEach((r,h)=>{typeof r<"u"&&(s+=`| ${r+" ".repeat(d[h]-r.toString().length)} `)}),s+=`|
`}),s}}e.$T=P}),define(q[4],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qd=e.$pd=e.$od=void 0;let P;function k(i){P=i}e.$od=k;function v(){return P}e.$pd=v;class I{constructor(){this.a=0,this.d=new WeakMap}b(a){return s([d(c("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[d(" "),r(h(a.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),r(h(a.newValue,60),{color:"green"})]:[d(" (unchanged)")]:[d(" "),r(h(a.newValue,60),{color:"green"}),d(" (initial)")]}handleObservableChanged(a,w){console.log(...this.b([t("observable value changed"),r(a.debugName,{color:"BlueViolet"}),...this.c(w)]))}formatChanges(a){if(a.size!==0)return r(" (changed deps: "+[...a].map(w=>w.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const w=a.handleChange;this.d.set(a,new Set),a.handleChange=(C,B)=>(this.d.get(a).add(C),w.apply(a,[C,B]))}handleDerivedRecomputed(a,w){const C=this.d.get(a);console.log(...this.b([t("derived recomputed"),r(a.debugName,{color:"BlueViolet"}),...this.c(w),this.formatChanges(C),{data:[{fn:a._computeFn}]}])),C.clear()}handleFromEventObservableTriggered(a,w){console.log(...this.b([t("observable from event triggered"),r(a.debugName,{color:"BlueViolet"}),...this.c(w),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const w=a.handleChange;this.d.set(a,new Set),a.handleChange=(C,B)=>(this.d.get(a).add(C),w.apply(a,[C,B]))}handleAutorunTriggered(a){const w=this.d.get(a);console.log(...this.b([t("autorun"),r(a.debugName,{color:"BlueViolet"}),this.formatChanges(w),{data:[{fn:a._runFn}]}])),w.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let w=a.getDebugName();w===void 0&&(w=""),console.log(...this.b([t("transaction"),r(w,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$qd=I;function s(i){const a=new Array,w=[];let C="";function B(T){if("length"in T)for(const $ of T)$&&B($);else"text"in T?(C+=`%c${T.text}`,a.push(T.style),T.data&&w.push(...T.data)):"data"in T&&w.push(...T.data)}B(i);const j=[C,...a];return j.push(...w),j}function d(i){return r(i,{color:"black"})}function t(i){return r(n(`${i}: `,10),{color:"black",bold:!0})}function r(i,a={color:"black"}){function w(B){return Object.entries(B).reduce((j,[T,$])=>`${j}${T}:${$};`,"")}const C={color:a.color};return a.strikeThrough&&(C["text-decoration"]="line-through"),a.bold&&(C["font-weight"]="bold"),{text:i,style:w(C)}}function h(i,a){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=a?`"${i}"`:`"${i.substr(0,a-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?o(i,a):g(i,a);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function o(i,a){let w="[ ",C=!0;for(const B of i){if(C||(w+=", "),w.length-5>a){w+="...";break}C=!1,w+=`${h(B,a-w.length)}`}return w+=" ]",w}function g(i,a){let w="{ ",C=!0;for(const[B,j]of Object.entries(i)){if(C||(w+=", "),w.length-5>a){w+="...";break}C=!1,w+=`${B}: ${h(j,a-w.length)}`}return w+=" }",w}function c(i,a){let w="";for(let C=1;C<=a;C++)w+=i;return w}function n(i,a){for(;i.length<a;)i+=" ";return i}}),define(q[5],K([0,1,4]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=void 0;let k;function v(f){k=f}e.$wd=v;class I{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,N){const l=N===void 0?void 0:m,S=N===void 0?m:N;return k({owner:l,debugName:()=>{const M=B(S);if(M!==void 0)return M;const O=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(O)return`${this.debugName}.${O[2]}`;if(!l)return`${this.debugName} (mapped)`}},M=>S(this.read(M),M))}}e.$xd=I;class s extends I{constructor(){super(...arguments),this.c=new Set}addObserver(m){const N=this.c.size;this.c.add(m),N===0&&this.f()}removeObserver(m){this.c.delete(m)&&this.c.size===0&&this.g()}f(){}g(){}}e.$yd=s;function d(f,m){const N=new h(f,m);try{f(N)}finally{N.finish()}}e.$zd=d;async function t(f,m){const N=new h(f,m);try{await f(N)}finally{N.finish()}}e.$Ad=t;function r(f,m,N){f?m(f):d(m,N)}e.$Bd=r;class h{constructor(m,N){this._fn=m,this.b=N,this.a=[],(0,P.$pd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():B(this._fn)}updateObserver(m,N){this.a.push({observer:m,observable:N}),m.beginUpdate(N)}finish(){const m=this.a;this.a=null;for(const{observer:N,observable:l}of m)N.endUpdate(l);(0,P.$pd)()?.handleEndTransaction()}}e.$Cd=h;const o=new Map,g=new WeakMap;function c(f,m,N,l,S){const M=g.get(f);if(M)return M;const D=n(f,m,N,l,S);if(D){let O=o.get(D)??0;O++,o.set(D,O);const b=O===1?D:`${D}#${O}`;return g.set(f,b),b}}e.$Dd=c;function n(f,m,N,l,S){const M=g.get(f);if(M)return M;const D=l?w(l)+".":"";let O;if(m!==void 0)if(typeof m=="function"){if(O=m(),O!==void 0)return D+O}else return D+m;if(N!==void 0&&(O=B(N),O!==void 0))return D+O;if(l!==void 0){for(const b in l)if(l[b]===S)return D+b}}const i=new Map,a=new WeakMap;function w(f){const m=a.get(f);if(m)return m;const N=C(f);let l=i.get(N)??0;l++,i.set(N,l);const S=l===1?N:`${N}#${l}`;return a.set(f,S),S}function C(f){const m=f.constructor;return m?m.name:"Object"}function B(f){const m=f.toString(),l=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(m);return(l?l[1]:void 0)?.trim()}e.$Ed=B;function j(f,m){return typeof f=="string"?new T(void 0,f,m):new T(f,void 0,m)}e.$Fd=j;class T extends s{get debugName(){return c(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(m,N,l){super(),this.b=m,this.d=N,this.a=l}get(){return this.a}set(m,N,l){if(this.a===m)return;let S;N||(N=S=new h(()=>{},()=>`Setting ${this.debugName}`));try{const M=this.a;this.e(m),(0,P.$pd)()?.handleObservableChanged(this,{oldValue:M,newValue:m,change:l,didChange:!0,hadValue:!0});for(const D of this.c)N.updateObserver(D,this),D.handleChange(this,l)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(m){this.a=m}}e.$Gd=T;function $(f,m){return typeof f=="string"?new E(void 0,f,m):new E(f,void 0,m)}e.$Hd=$;class E extends T{e(m){this.a!==m&&(this.a&&this.a.dispose(),this.a=m)}dispose(){this.a?.dispose()}}e.$Id=E}),define(q[9],K([0,1,42,2,5,4]),function(z,e,P,k,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=void 0;function s(n,i){return new g(n.debugName,i,void 0,void 0)}e.$7c=s;function d(n){return new g(void 0,n,void 0,void 0)}e.$8c=d;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$9c=t;function r(n,i){const a=new k.$Qc,w=t({debugName:n.debugName??(()=>(0,v.$Ed)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(C,B)=>{a.clear(),i(C,B,a)});return(0,k.$Pc)(()=>{w.dispose(),a.dispose()})}e.$0c=r;function h(n){const i=new k.$Qc,a=s({debugName:()=>(0,v.$Ed)(n)||"(anonymous)"},w=>{i.clear(),n(w,i)});return(0,k.$Pc)(()=>{a.dispose(),i.dispose()})}e.$$c=h;var o;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(o||(o={}));class g{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const a=this.h();if(a!==void 0)return a}const i=(0,v.$Ed)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,a,w,C){this.h=i,this._runFn=a,this.i=w,this.j=C,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,I.$pd)()?.handleAutorunCreated(this),this.k(),(0,k.$Ic)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,k.$Jc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,I.$pd)()?.handleAutorunTriggered(this);const a=this.g;this.g=this.i?.(),this._runFn(this,a)}}finally{(0,I.$pd)()?.handleAutorunFinished(this);for(const a of this.f)a.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,P.$5c)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,a){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:a,didChange:C=>C===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const a=i.get();return this.e.add(i),this.f.delete(i),a}}e.$_c=g,function(n){n.Observer=g}(d||(e.$8c=d={}));function c(n,i){let a;return s({debugName:()=>(0,v.$Ed)(i)},w=>{const C=n.read(w),B=a;a=C,i({lastValue:B,newValue:C})})}e.$ad=c}),define(q[10],K([0,1,6,2,5,4]),function(z,e,P,k,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vd=e.$ud=e.$td=e.$sd=e.$rd=void 0;const s=(c,n)=>c===n;function d(c,n){return n!==void 0?new g(c,void 0,n,void 0,void 0,void 0,s):new g(void 0,void 0,c,void 0,void 0,void 0,s)}e.$rd=d;function t(c,n){return new g(c.owner,c.debugName,n,void 0,void 0,void 0,c.equalityComparer??s)}e.$sd=t;function r(c,n){return new g(c.owner,c.debugName,n,c.createEmptyChangeSummary,c.handleChange,void 0,c.equalityComparer??s)}e.$td=r;function h(c,n){let i,a;n===void 0?(i=c,a=void 0):(a=c,i=n);const w=new k.$Qc;return new g(a,()=>(0,v.$Ed)(i)??"(anonymous)",C=>(w.clear(),i(C,w)),void 0,void 0,()=>w.dispose(),s)}e.$ud=h,(0,v.$wd)(t);var o;(function(c){c[c.initial=0]="initial",c[c.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",c[c.stale=2]="stale",c[c.upToDate=3]="upToDate"})(o||(o={}));class g extends v.$yd{get debugName(){return(0,v.$Dd)(this,this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,a,w,C,B=void 0,j){super(),this.m=n,this.n=i,this._computeFn=a,this.p=w,this.q=C,this.s=B,this.t=j,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,I.$pd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,a=this.h;this.e=3;const w=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,w)}finally{for(const B of this.k)B.removeObserver(this);this.k.clear()}const C=i&&!this.t(a,this.h);if((0,I.$pd)()?.handleDerivedRecomputed(this,{oldValue:a,newValue:this.h,change:void 0,didChange:C,hadValue:i}),C)for(const B of this.c)B.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const a of this.c)a.handlePossibleChange(this);if(i)for(const a of this.c)a.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const a of i)a.endUpdate(this)}if(this.i<0)throw new P.$bb}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const a=this.q?this.q({changedObservable:n,change:i,didChange:C=>C===n},this.l):!0,w=this.e===3;if(a&&(this.e===1||w)&&(this.e=2,w))for(const C of this.c)C.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$vd=g}),define(q[22],K([0,1,2,9,5,10,4]),function(z,e,P,k,v,I,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=void 0;function d(f){return new t(f)}e.$bd=d;class t extends v.$xd{constructor(m){super(),this.a=m}get debugName(){return this.toString()}get(){return this.a}addObserver(m){}removeObserver(m){}toString(){return`Const: ${this.a}`}}function r(f){const m=(0,v.$Fd)("promiseValue",{});return f.then(N=>{m.set({value:N},void 0)}),m}e.$cd=r;function h(f,m){return new Promise(N=>{let l=!1,S=!1;const M=(0,k.$8c)(D=>{const O=f.read(D);m(O)&&(l?M.dispose():S=!0,N(O))});l=!0,S&&M.dispose()})}e.$dd=h;function o(f,m){return new g(f,m)}e.$ed=o;class g extends v.$yd{constructor(m,N){super(),this.h=m,this._getValue=N,this.b=!1,this.k=l=>{const S=this._getValue(l),M=!this.b||this.a!==S;(0,s.$pd)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:S,change:void 0,didChange:M,hadValue:this.b}),M&&(this.a=S,this.b&&(0,v.$zd)(D=>{for(const O of this.c)D.updateObserver(O,this),O.handleChange(this,void 0)},()=>{const D=this.i();return"Event fired"+(D?`: ${D}`:"")}),this.b=!0)}}i(){return(0,v.$Ed)(this._getValue)}get debugName(){const m=this.i();return"From Event"+(m?`: ${m}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$fd=g,function(f){f.Observer=g}(o||(e.$ed=o={}));function c(f,m){return new n(f,m)}e.$gd=c;class n extends v.$yd{constructor(m,N){super(),this.debugName=m,this.b=N,this.h=()=>{(0,v.$zd)(l=>{for(const S of this.c)l.updateObserver(S,this),S.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(f){return typeof f=="string"?new a(f):new a(void 0,f)}e.$hd=i;class a extends v.$yd{get debugName(){return(0,v.$Dd)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(m,N){super(),this.a=m,this.b=N}trigger(m,N){if(!m){(0,v.$zd)(l=>{this.trigger(l,N)},()=>`Trigger signal ${this.debugName}`);return}for(const l of this.c)m.updateObserver(l,this),l.handleChange(this,N)}get(){}}function w(f,m,N){const l=(0,v.$Fd)("debounced",void 0);let S;return N.add((0,k.$8c)(M=>{const D=f.read(M);S&&clearTimeout(S),S=setTimeout(()=>{(0,v.$zd)(O=>{l.set(D,O)})},m)})),l}e.$id=w;function C(f,m,N){const l=(0,v.$Fd)("triggeredRecently",!1);let S;return N.add(f(()=>{l.set(!0,void 0),S&&clearTimeout(S),S=setTimeout(()=>{l.set(!1,void 0)},m)})),l}e.$jd=C;function B(f){const m=new T(!1);return f.addObserver(m),(0,P.$Pc)(()=>{f.removeObserver(m)})}e.$kd=B;function j(f){const m=new T(!0);return f.addObserver(m),f.reportChanges(),(0,P.$Pc)(()=>{f.removeObserver(m)})}e.$ld=j;class T{constructor(m){this.b=m,this.a=0}beginUpdate(m){this.a++}endUpdate(m){this.a--,this.a===0&&this.b&&m.reportChanges()}handlePossibleChange(m){}handleChange(m,N){}}function $(f){let m;return(0,I.$rd)(l=>(m=f(l,m),m))}e.$md=$;function E(f,m){let N;const l=(0,v.$Fd)("derivedObservableWithWritableCache.counter",0),S=(0,I.$rd)(f,M=>(l.read(M),N=m(M,N),N));return Object.assign(S,{clearCache:M=>{N=void 0,l.set(l.get()+1,M)}})}e.$nd=E}),define(q[11],K([0,1,5,10,9,22,4]),function(z,e,P,k,v,I,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.$Fd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.$Hd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.$zd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.$Bd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return k.$rd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return k.$sd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return k.$td}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return k.$ud}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$8c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$ad}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$9c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$$c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$7c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$0c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return I.$bd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return I.$id}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return I.$md}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return I.$nd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return I.$kd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return I.$ld}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return I.$ed}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return I.$cd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return I.$hd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return I.$gd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return I.$dd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return I.$jd}}),!1&&(0,s.$od)(new s.$qd)}),define(q[23],K([0,1,6,2]),function(z,e,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function v(j){const T=j;return T?typeof T.read=="function":!1}e.$Yd=v;function I(j){const T=j;return T?[T.on,T.pause,T.resume,T.destroy].every($=>typeof $=="function"):!1}e.$Zd=I;function s(j){const T=j;return T?I(T.stream)&&Array.isArray(T.buffer)&&typeof T.ended=="boolean":!1}e.$1d=s;function d(j,T){return new t(j,T)}e.$2d=d;class t{constructor(T,$){this.e=T,this.f=$,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(T){if(!this.a.destroyed){if(this.a.flowing)this.g(T);else if(this.b.data.push(T),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise($=>this.d.push($))}}error(T){this.a.destroyed||(this.a.flowing?this.h(T):this.b.error.push(T))}end(T){this.a.destroyed||(typeof T<"u"&&this.write(T),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(T){this.c.data.slice(0).forEach($=>$(T))}h(T){this.c.error.length===0?(0,P.$Z)(T):this.c.error.slice(0).forEach($=>$(T))}i(){this.c.end.slice(0).forEach(T=>T())}on(T,$){if(!this.a.destroyed)switch(T){case"data":this.c.data.push($),this.resume();break;case"end":this.c.end.push($),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push($),this.a.flowing&&this.k();break}}removeListener(T,$){if(this.a.destroyed)return;let E;switch(T){case"data":E=this.c.data;break;case"end":E=this.c.end;break;case"error":E=this.c.error;break}if(E){const f=E.indexOf($);f>=0&&E.splice(f,1)}}j(){if(this.b.data.length>0){const T=this.e(this.b.data);this.g(T),this.b.data.length=0;const $=[...this.d];this.d.length=0,$.forEach(E=>E())}}k(){if(this.c.error.length>0){for(const T of this.b.error)this.h(T);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(j,T){const $=[];let E;for(;(E=j.read())!==null;)$.push(E);return T($)}e.$3d=r;function h(j,T,$){const E=[];let f;for(;(f=j.read())!==null&&E.length<$;)E.push(f);return f===null&&E.length>0?T(E):{read:()=>{if(E.length>0)return E.shift();if(typeof f<"u"){const m=f;return f=void 0,m}return j.read()}}}e.$4d=h;function o(j,T){return new Promise(($,E)=>{const f=[];g(j,{onData:m=>{T&&f.push(m)},onError:m=>{T?E(m):$(void 0)},onEnd:()=>{$(T?T(f):void 0)}})})}e.$5d=o;function g(j,T,$){j.on("error",E=>{$?.isCancellationRequested||T.onError(E)}),j.on("end",()=>{$?.isCancellationRequested||T.onEnd()}),j.on("data",E=>{$?.isCancellationRequested||T.onData(E)})}e.$6d=g;function c(j,T){return new Promise(($,E)=>{const f=new k.$Qc,m=[],N=M=>{if(m.push(M),m.length>T)return f.dispose(),j.pause(),$({stream:j,buffer:m,ended:!1})},l=M=>(f.dispose(),E(M)),S=()=>(f.dispose(),$({stream:j,buffer:m,ended:!0}));f.add((0,k.$Pc)(()=>j.removeListener("error",l))),j.on("error",l),f.add((0,k.$Pc)(()=>j.removeListener("end",S))),j.on("end",S),f.add((0,k.$Pc)(()=>j.removeListener("data",N))),j.on("data",N)})}e.$7d=c;function n(j,T){const $=d(T);return $.end(j),$}e.$8d=n;function i(){const j=d(()=>{throw new Error("not supported")});return j.end(),j}e.$9d=i;function a(j){let T=!1;return{read:()=>T?null:(T=!0,j)}}e.$0d=a;function w(j,T,$){const E=d($);return g(j,{onData:f=>E.write(T.data(f)),onError:f=>E.error(T.error?T.error(f):f),onEnd:()=>E.end()}),E}e.$$d=w;function C(j,T,$){let E=!1;return{read:()=>{const f=T.read();return E?f:(E=!0,f!==null?$([j,f]):j)}}}e.$_d=C;function B(j,T,$){let E=!1;const f=d($);return g(T,{onData:m=>E?f.write(m):(E=!0,f.write($([j,m]))),onError:m=>f.error(m),onEnd:()=>{E||(E=!0,f.write(j)),f.end()}}),f}e.$ae=B}),define(q[12],K([0,1,43,23]),function(z,e,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const v=typeof Buffer<"u",I=new P.$U(()=>new Uint8Array(256));let s,d;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,U){return!(U?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(s||(s=new TextEncoder),new t(s.encode(b)))}static fromByteArray(b){const U=t.alloc(b.length);for(let W=0,V=b.length;W<V;W++)U.buffer[W]=b[W];return U}static concat(b,U){if(typeof U>"u"){U=0;for(let H=0,_=b.length;H<_;H++)U+=b[H].byteLength}const W=t.alloc(U);let V=0;for(let H=0,_=b.length;H<_;H++){const p=b[H];W.set(p,V),V+=p.byteLength}return W}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(b,U){return new t(this.buffer.subarray(b,U))}set(b,U){if(b instanceof t)this.buffer.set(b.buffer,U);else if(b instanceof Uint8Array)this.buffer.set(b,U);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),U);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,U){c(this.buffer,b,U)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,U){i(this.buffer,b,U)}readUInt8(b){return a(this.buffer,b)}writeUInt8(b,U){w(this.buffer,b,U)}indexOf(b,U=0){return r(this.buffer,b instanceof t?b.buffer:b,U)}}e.$be=t;function r(O,b,U=0){const W=b.byteLength,V=O.byteLength;if(W===0)return 0;if(W===1)return O.indexOf(b[0]);if(W>V-U)return-1;const H=I.value;H.fill(b.length);for(let X=0;X<b.length;X++)H[b[X]]=b.length-X-1;let _=U+b.length-1,p=_,G=-1;for(;_<V;)if(O[_]===b[p]){if(p===0){G=_;break}_--,p--}else _+=Math.max(b.length-p,H[O[_]]),p=b.length-1;return G}e.$ce=r;function h(O,b){return O[b+0]<<0>>>0|O[b+1]<<8>>>0}e.$de=h;function o(O,b,U){O[U+0]=b&255,b=b>>>8,O[U+1]=b&255}e.$ee=o;function g(O,b){return O[b]*2**24+O[b+1]*2**16+O[b+2]*2**8+O[b+3]}e.$fe=g;function c(O,b,U){O[U+3]=b,b=b>>>8,O[U+2]=b,b=b>>>8,O[U+1]=b,b=b>>>8,O[U]=b}e.$ge=c;function n(O,b){return O[b+0]<<0>>>0|O[b+1]<<8>>>0|O[b+2]<<16>>>0|O[b+3]<<24>>>0}e.$he=n;function i(O,b,U){O[U+0]=b&255,b=b>>>8,O[U+1]=b&255,b=b>>>8,O[U+2]=b&255,b=b>>>8,O[U+3]=b&255}e.$ie=i;function a(O,b){return O[b]}e.$je=a;function w(O,b,U){O[U]=b}e.$ke=w;function C(O){return k.$3d(O,b=>t.concat(b))}e.$le=C;function B(O){return k.$0d(O)}e.$me=B;function j(O){return k.$5d(O,b=>t.concat(b))}e.$ne=j;async function T(O){return O.ended?t.concat(O.buffer):t.concat([...O.buffer,await j(O.stream)])}e.$oe=T;function $(O){return k.$8d(O,b=>t.concat(b))}e.$pe=$;function E(O){return k.$$d(O,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$qe=E;function f(O){return k.$2d(b=>t.concat(b),O)}e.$re=f;function m(O,b){return k.$_d(O,b,U=>t.concat(U))}e.$se=m;function N(O,b){return k.$ae(O,b,U=>t.concat(U))}e.$te=N;function l(O){let b=0,U=0,W=0;const V=new Uint8Array(Math.floor(O.length/4*3)),H=p=>{switch(U){case 3:V[W++]=b|p,U=0;break;case 2:V[W++]=b|p>>>2,b=p<<6,U=3;break;case 1:V[W++]=b|p>>>4,b=p<<4,U=2;break;default:b=p<<2,U=1}};for(let p=0;p<O.length;p++){const G=O.charCodeAt(p);if(G>=65&&G<=90)H(G-65);else if(G>=97&&G<=122)H(G-97+26);else if(G>=48&&G<=57)H(G-48+52);else if(G===43||G===45)H(62);else if(G===47||G===95)H(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${O[p]}`)}}const _=W;for(;U>0;)H(0);return t.wrap(V).slice(0,_)}e.$ue=l;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:O},b=!0,U=!1){const W=U?M:S;let V="";const H=O.byteLength%3;let _=0;for(;_<O.byteLength-H;_+=3){const p=O[_+0],G=O[_+1],X=O[_+2];V+=W[p>>>2],V+=W[(p<<4|G>>>4)&63],V+=W[(G<<2|X>>>6)&63],V+=W[X&63]}if(H===1){const p=O[_+0];V+=W[p>>>2],V+=W[p<<4&63],b&&(V+="==")}else if(H===2){const p=O[_+0],G=O[_+1];V+=W[p>>>2],V+=W[(p<<4|G>>>4)&63],V+=W[G<<2&63],b&&(V+="=")}return V}e.$ve=D}),define(q[24],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(q[13],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.StringEOL=void 0;var P;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function k(v){let I=0,s=0,d=0,t=0;for(let r=0,h=v.length;r<h;r++){const o=v.charCodeAt(r);o===13?(I===0&&(s=r),I++,r+1<h&&v.charCodeAt(r+1)===10?(t|=2,r++):t|=3,d=r+1):o===10&&(t|=1,I===0&&(s=r),I++,d=r+1)}return I===0&&(s=v.length),[I,s,v.length-d,t]}e.$7s=k}),define(q[14],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var k;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(k||(e.FontStyle=k={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var I;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(I||(e.StandardTokenType=I={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class d{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){let o="mtk"+this.getForeground(r);const g=this.getFontStyle(r);return g&1&&(o+=" mtki"),g&2&&(o+=" mtkb"),g&4&&(o+=" mtku"),g&8&&(o+=" mtks"),o}static getInlineStyleFromMetadata(r,h){const o=this.getForeground(r),g=this.getFontStyle(r);let c=`color: ${h[o]};`;g&1&&(c+="font-style: italic;"),g&2&&(c+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(c+=`text-decoration:${n};`),c}static getPresentationFromMetadata(r){const h=this.getForeground(r),o=this.getFontStyle(r);return{foreground:h,italic:!!(o&1),bold:!!(o&2),underline:!!(o&4),strikethrough:!!(o&8)}}}e.$5s=d}),define(q[25],K([0,1,26]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=void 0;class k{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,d){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=d}replace(s,d,t){if(s>=this.a.length)return;if(d===0){this.insert(s,t);return}else if(t===0){this.delete(s,d);return}const r=this.a.slice(0,s),h=this.a.slice(s+d),o=v(t,this.b);this.a=r.concat(o,h)}delete(s,d){d===0||s>=this.a.length||this.a.splice(s,d)}insert(s,d){if(d===0||s>=this.a.length)return;const t=[];for(let r=0;r<d;r++)t[r]=this.b;this.a=(0,P.$Vb)(this.a,s,t)}}e.$LB=k;function v(I,s){const d=[];for(let t=0;t<I;t++)d[t]=s;return d}}),define(q[7],K([0,1,14]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0;class k{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,d){const t=k.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=s.length,r[1]=t,new k(r,s,d)}constructor(s,d,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=d,this.d=t}equals(s){return s instanceof k?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,d,t){if(this.c!==s.c||this.b!==s.b)return!1;const r=d<<1,h=r+(t<<1);for(let o=r;o<h;o++)if(this.a[o]!==s.a[o])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const d=this.a[(s<<1)+1],t=P.$5s.getLanguageId(d);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const d=this.a[(s<<1)+1];return P.$5s.getTokenType(d)}getForeground(s){const d=this.a[(s<<1)+1];return P.$5s.getForeground(d)}getClassName(s){const d=this.a[(s<<1)+1];return P.$5s.getClassNameFromMetadata(d)}getInlineStyle(s,d){const t=this.a[(s<<1)+1];return P.$5s.getInlineStyleFromMetadata(t,d)}getPresentation(s){const d=this.a[(s<<1)+1];return P.$5s.getPresentationFromMetadata(d)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return k.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,d,t){return new v(this,s,d,t)}static convertToEndOffset(s,d){const r=(s.length>>>1)-1;for(let h=0;h<r;h++)s[h<<1]=s[h+1<<1];s[r<<1]=d}static findIndexInTokensArray(s,d){if(s.length<=2)return 0;let t=0,r=(s.length>>>1)-1;for(;t<r;){const h=t+Math.floor((r-t)/2),o=s[h<<1];if(o===d)return h+1;o<d?t=h+1:o>d&&(r=h)}return t}withInserted(s){if(s.length===0)return this;let d=0,t=0,r="";const h=new Array;let o=0;for(;;){const g=d<this.b?this.a[d<<1]:-1,c=t<s.length?s[t]:null;if(g!==-1&&(c===null||g<=c.offset)){r+=this.c.substring(o,g);const n=this.a[(d<<1)+1];h.push(r.length,n),d++,o=g}else if(c){if(c.offset>o){r+=this.c.substring(o,c.offset);const n=this.a[(d<<1)+1];h.push(r.length,n),o=c.offset}r+=c.text,h.push(r.length,c.tokenMetadata),t++}else break}return new k(new Uint32Array(h),r,this.d)}}e.$8s=k;class v{constructor(s,d,t,r){this.a=s,this.b=d,this.c=t,this.d=r,this.e=s.findTokenIndexAtOffset(d),this.f=0;for(let h=this.e,o=s.getCount();h<o&&!(s.getStartOffset(h)>=t);h++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof v?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const d=this.a.getEndOffset(this.e+s);return Math.min(this.c,d)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,d){return this.a.getInlineStyle(this.e+s,d)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(q[27],K([0,1,7]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=e.$0s=e.$9s=void 0,e.$9s=new Uint32Array(0).buffer;class k{static deleteBeginning(s,d){return s===null||s===e.$9s?s:k.delete(s,0,d)}static deleteEnding(s,d){if(s===null||s===e.$9s)return s;const t=v(s),r=t[t.length-2];return k.delete(s,d,r)}static delete(s,d,t){if(s===null||s===e.$9s||d===t)return s;const r=v(s),h=r.length>>>1;if(d===0&&r[r.length-2]===t)return e.$9s;const o=P.$8s.findIndexInTokensArray(r,d),g=o>0?r[o-1<<1]:0,c=r[o<<1];if(t<c){const C=t-d;for(let B=o;B<h;B++)r[B<<1]-=C;return s}let n,i;g!==d?(r[o<<1]=d,n=o+1<<1,i=d):(n=o<<1,i=g);const a=t-d;for(let C=o+1;C<h;C++){const B=r[C<<1]-a;B>i&&(r[n++]=B,r[n++]=r[(C<<1)+1],i=B)}if(n===r.length)return s;const w=new Uint32Array(n);return w.set(r.subarray(0,n),0),w.buffer}static append(s,d){if(d===e.$9s)return s;if(s===e.$9s)return d;if(s===null)return s;if(d===null)return null;const t=v(s),r=v(d),h=r.length>>>1,o=new Uint32Array(t.length+r.length);o.set(t,0);let g=t.length;const c=t[t.length-2];for(let n=0;n<h;n++)o[g++]=r[n<<1]+c,o[g++]=r[(n<<1)+1];return o.buffer}static insert(s,d,t){if(s===null||s===e.$9s)return s;const r=v(s),h=r.length>>>1;let o=P.$8s.findIndexInTokensArray(r,d);o>0&&r[o-1<<1]===d&&o--;for(let g=o;g<h;g++)r[g<<1]+=t;return s}}e.$0s=k;function v(I){return I instanceof Uint32Array?I:new Uint32Array(I)}e.$$s=v}),define(q[28],K([0,1,26,12,44,13,27,15]),function(z,e,P,k,v,I,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=void 0;class t{static deserialize(h,o,g){const c=new Uint32Array(h.buffer),n=(0,k.$fe)(h,o);o+=4;const i=(0,k.$fe)(h,o);o+=4;const a=[];for(let w=0;w<i;w++){const C=(0,k.$fe)(h,o);o+=4,a.push(c.subarray(o/4,o/4+C/4)),o+=C}return g.push(new t(n,a)),o}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(h,o){this.a=h,this.b=o}getLineRange(){return new d.$Ds(this.a,this.a+this.b.length)}getLineTokens(h){return this.b[h-this.a]}appendLineTokens(h){this.b.push(h)}serializeSize(){let h=0;h+=4,h+=4;for(let o=0;o<this.b.length;o++){const g=this.b[o];if(!(g instanceof Uint32Array))throw new Error("Not supported!");h+=4,h+=g.byteLength}return h}serialize(h,o){(0,k.$ge)(h,this.a,o),o+=4,(0,k.$ge)(h,this.b.length,o),o+=4;for(let g=0;g<this.b.length;g++){const c=this.b[g];if(!(c instanceof Uint32Array))throw new Error("Not supported!");(0,k.$ge)(h,c.byteLength,o),o+=4,h.set(new Uint8Array(c.buffer),o),o+=c.byteLength}return o}applyEdit(h,o){const[g,c]=(0,I.$7s)(o);this.c(h),this.d(new v.$ts(h.startLineNumber,h.startColumn),g,c)}c(h){if(h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn)return;const o=h.startLineNumber-this.a,g=h.endLineNumber-this.a;if(g<0){const c=g-o;this.a-=c;return}if(!(o>=this.b.length)){if(o<0&&g>=this.b.length){this.a=0,this.b=[];return}if(o===g){this.b[o]=s.$0s.delete(this.b[o],h.startColumn-1,h.endColumn-1);return}if(o>=0)if(this.b[o]=s.$0s.deleteEnding(this.b[o],h.startColumn-1),g<this.b.length){const c=s.$0s.deleteBeginning(this.b[g],h.endColumn-1);this.b[o]=s.$0s.append(this.b[o],c),this.b.splice(o+1,g-o)}else this.b[o]=s.$0s.append(this.b[o],null),this.b=this.b.slice(0,o+1);else{const c=-o;this.a-=c,this.b[g]=s.$0s.deleteBeginning(this.b[g],h.endColumn-1),this.b=this.b.slice(g)}}}d(h,o,g){if(o===0&&g===0)return;const c=h.lineNumber-this.a;if(c<0){this.a+=o;return}if(!(c>=this.b.length)){if(o===0){this.b[c]=s.$0s.insert(this.b[c],h.column-1,g);return}this.b[c]=s.$0s.deleteEnding(this.b[c],h.column-1),this.b[c]=s.$0s.insert(this.b[c],h.column-1,g),this.e(h.lineNumber,o)}}e(h,o){if(o===0)return;const g=[];for(let c=0;c<o;c++)g[c]=null;this.b=P.$Vb(this.b,h,g)}}e.$_s=t}),define(q[16],K([0,1,12,28]),function(z,e,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class v{static deserialize(s){let d=0;const t=(0,P.$fe)(s,d);d+=4;const r=[];for(let h=0;h<t;h++)d=k.$_s.deserialize(s,d,r);return r}constructor(){this.a=[]}add(s,d){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(d);return}}this.a.push(new k.$_s(s,[d]))}finalize(){return this.a}serialize(){const s=this.b(),d=new Uint8Array(s);return this.c(d),d}b(){let s=0;s+=4;for(let d=0;d<this.a.length;d++)s+=this.a[d].serializeSize();return s}c(s){let d=0;(0,P.$ge)(s,this.a.length,d),d+=4;for(let t=0;t<this.a.length;t++)d=this.a[t].serialize(s,d)}}e.$MB=v}),define(q[29],K([0,1,30,3,31,45]),function(z,e,P,k,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function s(l){return l===47||l===92}e.$Qf=s;function d(l){return l.replace(/[\\/]/g,P.$fc.sep)}e.$Rf=d;function t(l){return l.indexOf("/")===-1&&(l=d(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Sf=t;function r(l,S=P.$fc.sep){if(!l)return"";const M=l.length,D=l.charCodeAt(0);if(s(D)){if(s(l.charCodeAt(1))&&!s(l.charCodeAt(2))){let b=3;const U=b;for(;b<M&&!s(l.charCodeAt(b));b++);if(U!==b&&!s(l.charCodeAt(b+1))){for(b+=1;b<M;b++)if(s(l.charCodeAt(b)))return l.slice(0,b+1).replace(/[\\/]/g,S)}}return S}else if(w(D)&&l.charCodeAt(1)===58)return s(l.charCodeAt(2))?l.slice(0,2)+S:l.slice(0,2);let O=l.indexOf("://");if(O!==-1){for(O+=3;O<M;O++)if(s(l.charCodeAt(O)))return l.slice(0,O+1)}return""}e.$Tf=r;function h(l){if(!k.$j||!l||l.length<5)return!1;let S=l.charCodeAt(0);if(S!==92||(S=l.charCodeAt(1),S!==92))return!1;let M=2;const D=M;for(;M<l.length&&(S=l.charCodeAt(M),S!==92);M++);return!(D===M||(S=l.charCodeAt(M+1),isNaN(S)||S===92))}e.$Uf=h;const o=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(l,S=k.$j){const M=S?o:g;return!(!l||l.length===0||/^\s+$/.test(l)||(M.lastIndex=0,M.test(l))||S&&c.test(l)||l==="."||l===".."||S&&l[l.length-1]==="."||S&&l.length!==l.trim().length||l.length>255)}e.$Vf=n;function i(l,S,M){const D=l===S;return!M||D?D:!l||!S?!1:(0,v.$2e)(l,S)}e.$Wf=i;function a(l,S,M,D=P.sep){if(l===S)return!0;if(!l||!S||S.length>l.length)return!1;if(M){if(!(0,v.$3e)(l,S))return!1;if(S.length===l.length)return!0;let b=S.length;return S.charAt(S.length-1)===D&&b--,l.charAt(b)===D}return S.charAt(S.length-1)!==D&&(S+=D),l.indexOf(S)===0}e.$Xf=a;function w(l){return l>=65&&l<=90||l>=97&&l<=122}e.$Yf=w;function C(l,S){return k.$j&&l.endsWith(":")&&(l+=P.sep),(0,P.$hc)(l)||(l=(0,P.$ic)(S,l)),l=(0,P.$gc)(l),k.$j?(l=(0,v.$Ke)(l,P.sep),l.endsWith(":")&&(l+=P.sep)):(l=(0,v.$Ke)(l,P.sep),l||(l=P.sep)),l}e.$Zf=C;function B(l){const S=(0,P.$gc)(l);return k.$j?l.length>3?!1:j(S)&&(l.length===2||S.charCodeAt(2)===92):S===P.$fc.sep}e.$1f=B;function j(l,S=k.$j){return S?w(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$2f=j;function T(l,S=k.$j){return j(l,S)?l[0]:void 0}e.$3f=T;function $(l,S,M){return S.length>l.length?-1:l===S?0:(M&&(l=l.toLowerCase(),S=S.toLowerCase()),l.indexOf(S))}e.$4f=$;function E(l){const S=l.split(":");let M,D,O;for(const b of S){const U=Number(b);(0,I.$Cf)(U)?D===void 0?D=U:O===void 0&&(O=U):M=M?[M,b].join(":"):b}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:D!==void 0?D:void 0,column:O!==void 0?O:D!==void 0?1:void 0}}e.$5f=E;const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",m="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function N(l,S,M=8){let D="";for(let b=0;b<M;b++){let U;b===0&&k.$j&&!S&&(M===3||M===4)?U=m:U=f,D+=U.charAt(Math.floor(Math.random()*U.length))}let O;return S?O=`${S}-${D}`:O=D,l?(0,P.$ic)(l,O):O}e.$6f=N}),define(q[17],K([0,1,6,3,8]),function(z,e,P,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var I;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(I||(e.Schemas=I={})),e.$7f="vscode-tkn",e.$8f="tkn";class s{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${I.vscodeRemoteResource}`}set(h,o,g){this.a[h]=o,this.b[h]=g}setConnectionToken(h,o){this.c[h]=o}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(a){return P.$Z(a),h}const o=h.authority;let g=this.a[o];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const c=this.b[o],n=this.c[o];let i=`path=${encodeURIComponent(h.path)}`;return typeof n=="string"&&(i+=`&${e.$8f}=${encodeURIComponent(n)}`),v.URI.from({scheme:k.$p?this.d:I.vscodeRemoteResource,authority:`${g}:${c}`,path:this.f,query:i})}}e.$9f=new s,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class d{static{this.a=e.$bg}asBrowserUri(h){const o=this.b(h,z);return this.uriToBrowserUri(o)}uriToBrowserUri(h){return h.scheme===I.vscodeRemote?e.$9f.rewrite(h):h.scheme===I.file&&(k.$n||k.$q&&k.$h.origin===`${I.vscodeFileResource}://${d.a}`)?h.with({scheme:I.vscodeFileResource,authority:h.authority||d.a,query:null,fragment:null}):h}asFileUri(h){const o=this.b(h,z);return this.uriToFileUri(o)}uriToFileUri(h){return h.scheme===I.vscodeFileResource?h.with({scheme:I.file,authority:h.authority!==d.a?h.authority:null,query:null,fragment:null}):h}b(h,o){return v.URI.isUri(h)?h:v.URI.parse(o.toUrl(h))}}e.$cg=new d;var t;(function(r){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(h.get("3"));const o="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:v.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const a=i?.get(o);if(a)return h.get(a)}r.getHeadersFromQuery=g;function c(n,i,a){if(!globalThis.crossOriginIsolated)return;const w=i&&a?"3":a?"2":"1";n instanceof URLSearchParams?n.set(o,w):n[o]=w}r.addSearchParam=c})(t||(e.COI=t={}))}),define(q[32],K([0,1,21,17,3,8]),function(z,e,P,k,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=void 0;class s{constructor(g,c,n){this.id=g,this.dependencies=c,this.callback=n}}class d{static{this.INSTANCE=new d}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,c,n)=>{typeof g!="string"&&(n=c,c=g,g=null),(typeof c!="object"||!Array.isArray(c))&&(n=c,c=null),this.c.push(new s(g,c,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const c=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!c)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h(g){return new Promise((c,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const a=()=>{i.removeEventListener("load",w),i.removeEventListener("error",C)},w=B=>{a(),c(this.c.pop())},C=B=>{a(),n(B)};i.addEventListener("load",w),i.addEventListener("error",C),this.f&&(g=this.f.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}i(g){return new Promise((c,n)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),c(this.c.pop())}catch(i){n(i)}})}async j(g){try{const c=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,a=I.URI.parse(g).fsPath,w=c.readFileSync(a).toString(),C=i.wrap(w.replace(/^#!.*/,""));return new n.Script(C).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const t=new Map;let r={};typeof globalThis.require=="object"&&(r=globalThis.require.paths??{});async function h(o,g,c){if(P.$S){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),r[o]&&(o=r[o]);const n=`${o}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const B=`${c&&!v.$p?k.$_f:k.$$f}/${n}`;i=k.$cg.asBrowserUri(B).toString(!0)}const a=d.INSTANCE.load(i);return t.set(n,a),a}else return await new Promise((n,i)=>{z([o],n,i)})}e.$IC=h}),define(q[18],K([0,1,29,17,30,3,31,8]),function(z,e,P,k,v,I,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function t(c){return(0,d.$vc)(c,!0)}e.$jg=t;class r{constructor(n){this.a=n}compare(n,i,a=!1){return n===i?0:(0,s.$Ue)(this.getComparisonKey(n,a),this.getComparisonKey(i,a))}isEqual(n,i,a=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,a)===this.getComparisonKey(i,a)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,a=!1){if(n.scheme===i.scheme){if(n.scheme===k.Schemas.file)return P.$Xf(t(n),t(i),this.a(n))&&n.query===i.query&&(a||n.fragment===i.fragment);if((0,e.$Ag)(n.authority,i.authority))return P.$Xf(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(a||n.fragment===i.fragment)}return!1}joinPath(n,...i){return d.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$sg)(n)||n.authority}basename(n){return v.$fc.basename(n.path)}extname(n){return v.$fc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===k.Schemas.file?i=d.URI.file(v.$lc(t(n))).path:(i=v.$fc.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===k.Schemas.file?i=d.URI.file(v.$gc(t(n))).path:i=v.$fc.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$Ag)(n.authority,i.authority))return;if(n.scheme===k.Schemas.file){const C=v.$kc(t(n),t(i));return I.$j?P.$Rf(C):C}let a=n.path||"/";const w=i.path||"/";if(this.a(n)){let C=0;for(const B=Math.min(a.length,w.length);C<B&&!(a.charCodeAt(C)!==w.charCodeAt(C)&&a.charAt(C).toLowerCase()!==w.charAt(C).toLowerCase());C++);a=w.substr(0,C)+a.substr(C)}return v.$fc.relative(a,w)}resolvePath(n,i){if(n.scheme===k.Schemas.file){const a=d.URI.file(v.$jc(t(n),i));return n.with({authority:a.authority,path:a.path})}return i=P.$Sf(i),n.with({path:v.$fc.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,s.$2e)(n,i)}hasTrailingPathSeparator(n,i=v.sep){if(n.scheme===k.Schemas.file){const a=t(n);return a.length>P.$Tf(a).length&&a[a.length-1]===i}else{const a=n.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=v.sep){return(0,e.$Bg)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=v.sep){let a=!1;if(n.scheme===k.Schemas.file){const w=t(n);a=w!==void 0&&w.length===P.$Tf(w).length&&w[w.length-1]===i}else{i="/";const w=n.path;a=w.length===1&&w.charCodeAt(w.length-1)===47}return!a&&!(0,e.$Bg)(n,i)?n.with({path:n.path+"/"}):n}}e.$kg=r,e.$lg=new r(()=>!1),e.$mg=new r(c=>c.scheme===k.Schemas.file?!I.$l:!0),e.$ng=new r(c=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function h(c,n){const i=[];for(let a=0;a<c.length;a++){const w=n(c[a]);c.some((C,B)=>B===a?!1:(0,e.$pg)(w,n(C)))||i.push(c[a])}return i}e.$Eg=h;var o;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function n(i){const a=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(B=>{const[j,T]=B.split(":");j&&T&&a.set(j,T)});const C=i.path.substring(0,i.path.indexOf(";"));return C&&a.set(c.META_DATA_MIME,C),a}c.parseMetaData=n})(o||(e.DataUri=o={}));function g(c,n,i){if(n){let a=c.path;return a&&a[0]!==v.$fc.sep&&(a=v.$fc.sep+a),c.with({scheme:i,authority:n,path:a})}return c.with({scheme:i})}e.$Fg=g}),define(q[19],K([0,1,46,6,33,2,18,3,24]),function(z,e,P,k,v,I,s,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function r(L){return!!L&&typeof L.then=="function"}e.$Gg=r;function h(L){const u=new P.$Xd,y=L(u.token),A=new Promise((R,F)=>{const Z=u.token.onCancellationRequested(()=>{Z.dispose(),u.dispose(),F(new k.$4)});Promise.resolve(y).then(Q=>{Z.dispose(),u.dispose(),R(Q)},Q=>{Z.dispose(),u.dispose(),F(Q)})});return new class{cancel(){u.cancel()}then(R,F){return A.then(R,F)}catch(R){return this.then(void 0,R)}finally(R){return A.finally(R)}}}e.$Hg=h;function o(L,u,y){return new Promise((A,R)=>{const F=u.onCancellationRequested(()=>{F.dispose(),A(y)});L.then(A,R).finally(()=>F.dispose())})}e.$Ig=o;function g(L,u){return new Promise((y,A)=>{const R=u.onCancellationRequested(()=>{R.dispose(),A(new k.$4)});L.then(y,A).finally(()=>R.dispose())})}e.$Jg=g;async function c(L){let u=-1;const y=L.map((A,R)=>A.then(F=>(u=R,F)));try{return await Promise.race(y)}finally{L.forEach((A,R)=>{R!==u&&A.cancel()})}}e.$Kg=c;function n(L,u,y){let A;const R=setTimeout(()=>{A?.(void 0),y?.()},u);return Promise.race([L.finally(()=>clearTimeout(R)),new Promise(F=>A=F)])}e.$Lg=n;function i(L){return new Promise((u,y)=>{const A=L();r(A)?A.then(u,y):u(A)})}e.$Mg=i;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const y=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(y,y).then(A)})}return new Promise((y,A)=>{this.b.then(y,A)})}return this.a=u(),new Promise((y,A)=>{this.a.then(R=>{this.a=null,y(R)},R=>{this.a=null,A(R)})})}dispose(){this.f=!0}}e.$Ng=a;class w{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$Og=w;class C{constructor(){this.a=new Map}queue(u,y){const R=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(u)===R&&this.a.delete(u)});return this.a.set(u,R),R}}e.$Pg=C;const B=(L,u)=>{let y=!0;const A=setTimeout(()=>{y=!1,u()},L);return{isTriggered:()=>y,dispose:()=>{clearTimeout(A),y=!1}}},j=L=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,L())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class T{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,y=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((R,F)=>{this.d=R,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=y===t.$Kd?j(A):B(y,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=T;class ${constructor(u){this.a=new T(u),this.b=new a}trigger(u,y){return this.a.trigger(()=>this.b.queue(u),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=$;class E{constructor(){this.a=!1,this.b=new Promise((u,y)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=E;class f extends E{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$Tg=f;function m(L,u){return u?new Promise((y,A)=>{const R=setTimeout(()=>{F.dispose(),y()},L),F=u.onCancellationRequested(()=>{clearTimeout(R),F.dispose(),A(new k.$4)})}):h(y=>m(L,y))}e.$Ug=m;function N(L,u=0,y){const A=setTimeout(()=>{L(),y&&R.dispose()},u),R=(0,I.$Pc)(()=>{clearTimeout(A),y?.deleteAndLeak(R)});return y?.add(R),R}e.$Vg=N;function l(L,u,y){let A=0;const R=setInterval(()=>{A++,(A>=y||L())&&F.dispose()},u),F=(0,I.$Pc)(()=>{clearInterval(R)});return F}e.$Wg=l;function S(L){const u=[];let y=0;const A=L.length;function R(){return y<A?L[y++]():null}function F(Z){Z!=null&&u.push(Z);const Q=R();return Q?Q.then(F):Promise.resolve(u)}return Promise.resolve(null).then(F)}e.$Xg=S;function M(L,u=A=>!!A,y=null){let A=0;const R=L.length,F=()=>{if(A>=R)return Promise.resolve(y);const Z=L[A++];return Promise.resolve(Z()).then(J=>u(J)?Promise.resolve(J):F())};return F()}e.$Yg=M;function D(L,u=A=>!!A,y=null){if(L.length===0)return Promise.resolve(y);let A=L.length;const R=()=>{A=-1;for(const F of L)F.cancel?.()};return new Promise((F,Z)=>{for(const Q of L)Q.then(J=>{--A>=0&&u(J)?(R(),F(J)):A===0&&F(y)}).catch(J=>{--A>=0&&(R(),Z(J))})})}e.$Zg=D;class O{constructor(u){this.a=0,this.d=u,this.f=[],this.b=0,this.g=new v.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(u){return this.a++,new Promise((y,A)=>{this.f.push({factory:u,c:y,e:A}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const u=this.f.shift();this.b++;const y=u.factory();y.then(u.c,u.e),y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=O;class b extends O{constructor(){super(1)}}e.$2g=b;class U{constructor(){this.a=new ee,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$3g=U;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new x;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueFor(u,y=s.$lg){const A=y.getComparisonKey(u);let R=this.a.get(A);if(!R){R=new b;const F=this.f++,Z=v.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(A),this.h(),this.d?.deleteAndDispose(F),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$Zc),this.d.set(F,Z),this.a.set(A,R)}return R}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=W;class V{constructor(u,y){this.a=-1,typeof u=="function"&&typeof y=="number"&&this.setIfNotSet(u,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},y)}setIfNotSet(u,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},y))}}e.$5g=V;class H{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(u,y){this.cancel(),this.a=setInterval(()=>{u()},y)}}e.$6g=H;class _{constructor(u,y){this.b=-1,this.a=u,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=_;class p{constructor(u,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=u,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=p;class G extends _{constructor(u,y){super(u,y),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$9g=G;class X extends I.$Rc{constructor(u,y){super(),this.g=u,this.h=y,this.a=[],this.b=this.B(new I.$Sc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of u)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=X,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=L=>{(0,d.$B)(()=>{if(u)return;const y=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,y-Date.now())}}))});let u=!1;return{dispose(){u||(u=!0)}}}:e.$$g=(L,u)=>{const y=requestIdleCallback(L,typeof u=="number"?{timeout:u}:void 0);let A=!1;return{dispose(){A||(A=!0,cancelIdleCallback(y))}}}}();class re{constructor(u){this.d=!1,this.a=()=>{try{this.f=u()}catch(y){this.g=y}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=re;async function ae(L,u,y){let A;for(let R=0;R<y;R++)try{return await L()}catch(F){A=F,await m(u)}throw A}e.$ah=ae;class ee{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,y,A){return this.a={taskId:u,cancel:()=>A?.(),promise:y},y.then(()=>this.d(u),()=>this.d(u)),y}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{let y,A;const R=new Promise((F,Z)=>{y=F,A=Z});this.b={run:u,promise:R,promiseResolve:y,promiseReject:A}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=ee;class he{constructor(u,y=()=>Date.now()){this.d=u,this.f=y,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$ch=he;var te;(function(L){L[L.Resolved=0]="Resolved",L[L.Rejected=1]="Rejected"})(te||(te={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,y)=>{this.a=u,this.b=y})}complete(u){return new Promise(y=>{this.a(u),this.d={outcome:0,value:u},y()})}error(u){return new Promise(y=>{this.b(u),this.d={outcome:1,value:u},y()})}cancel(){return this.error(new k.$4)}}e.$dh=x;var ne;(function(L){async function u(A){let R;const F=await Promise.all(A.map(Z=>Z.then(Q=>Q,Q=>{R||(R=Q)})));if(typeof R<"u")throw R;return F}L.settled=u;function y(A){return new Promise(async(R,F)=>{try{await A(R,F)}catch(Z){F(Z)}})}L.withAsyncBody=y})(ne||(e.Promises=ne={}));var ie;(function(L){L[L.Initial=0]="Initial",L[L.DoneOK=1]="DoneOK",L[L.DoneError=2]="DoneError"})(ie||(ie={}));class Y{static fromArray(u){return new Y(y=>{y.emitMany(u)})}static fromPromise(u){return new Y(async y=>{y.emitMany(await u)})}static fromPromises(u){return new Y(async y=>{await Promise.all(u.map(async A=>y.emitOne(await A)))})}static merge(u){return new Y(async y=>{await Promise.all(u.map(async A=>{for await(const R of A)y.emitOne(R)}))})}static{this.EMPTY=Y.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new v.$Nd,queueMicrotask(async()=>{const y={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(u(y)),this.j()}catch(A){this.k(A)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(u,y){return new Y(async A=>{for await(const R of u)A.emitOne(y(R))})}map(u){return Y.map(this,u)}static filter(u,y){return new Y(async A=>{for await(const R of u)y(R)&&A.emitOne(R)})}filter(u){return Y.filter(this,u)}static coalesce(u){return Y.filter(u,y=>!!y)}coalesce(){return Y.coalesce(this)}static async toPromise(u){const y=[];for await(const A of u)y.push(A);return y}toPromise(){return Y.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$eh=Y;class se extends Y{constructor(u,y){super(y),this.l=u}cancel(){this.l.cancel()}}e.$fh=se;function oe(L){const u=new P.$Xd,y=L(u.token);return new se(u,async A=>{const R=u.token.onCancellationRequested(()=>{R.dispose(),u.dispose(),A.reject(new k.$4)});try{for await(const F of y){if(u.token.isCancellationRequested)return;A.emitOne(F)}R.dispose(),u.dispose()}catch(F){R.dispose(),u.dispose(),A.reject(F)}})}e.$gh=oe;class ue{constructor(){this.a=new x,this.b=new Y(A=>{if(u){A.reject(u);return}return y&&A.emitMany(y),this.d=R=>A.reject(R),this.f=R=>A.emitOne(R),this.a.p});let u,y;this.f=A=>{y||(y=[]),y.push(A)},this.d=A=>{u||(u=A)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}e.$hh=ue}),define(q[20],K([0,1,34]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=void 0,e.$IB=new class{clone(){return this}equals(I){return this===I}};function k(I,s){return new P.$ct([new P.$bt(0,"",I)],s)}e.$JB=k;function v(I,s){const d=new Uint32Array(2);return d[0]=0,d[1]=(I<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new P.$dt(d,s===null?e.$IB:s)}e.$KB=v}),define(q[35],K([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(z,e,P,k,v,I,s,d,t,r,h,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SB=e.$RB=e.$QB=e.$PB=e.$OB=e.$NB=void 0;var c;(function(T){T[T.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(c||(c={}));class n{constructor($,E){this.tokenizationSupport=E,this.a=this.tokenizationSupport.getInitialState(),this.store=new a($)}getStartState($){return this.store.getStartState($,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$NB=n;class i extends n{constructor($,E,f,m){super($,E),this._textModel=f,this._languageIdCodec=m}updateTokensUntilLine($,E){const f=this._textModel.getLanguageId();for(;;){const m=this.getFirstInvalidLine();if(!m||m.lineNumber>E)break;const N=this._textModel.getLineContent(m.lineNumber),l=B(this._languageIdCodec,f,this.tokenizationSupport,N,!0,m.startState);$.add(m.lineNumber,l.tokens),this.store.setEndState(m.lineNumber,l.endState)}}getTokenTypeIfInsertingCharacter($,E){const f=this.getStartState($.lineNumber);if(!f)return 0;const m=this._textModel.getLanguageId(),N=this._textModel.getLineContent($.lineNumber),l=N.substring(0,$.column-1)+E+N.substring($.column-1),S=B(this._languageIdCodec,m,this.tokenizationSupport,l,!0,f),M=new g.$8s(S.tokens,l,this._languageIdCodec);if(M.getCount()===0)return 0;const D=M.findTokenIndexAtOffset($.column-1);return M.getStandardTokenType(D)}tokenizeLineWithEdit($,E,f){const m=$.lineNumber,N=$.column,l=this.getStartState(m);if(!l)return null;const S=this._textModel.getLineContent(m),M=S.substring(0,N-1)+f+S.substring(N-1+E),D=this._textModel.getLanguageIdAtPosition(m,0),O=B(this._languageIdCodec,D,this.tokenizationSupport,M,!0,l);return new g.$8s(O.tokens,M,this._languageIdCodec)}isCheapToTokenize($){const E=this.store.getFirstInvalidEndStateLineNumberOrMax();return $<E||$===E&&this._textModel.getLineLength($)<2048}tokenizeHeuristically($,E,f){if(f<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(E<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine($,f),{heuristicTokens:!1};let m=this.b(E);const N=this._textModel.getLanguageId();for(let l=E;l<=f;l++){const S=this._textModel.getLineContent(l),M=B(this._languageIdCodec,N,this.tokenizationSupport,S,!0,m);$.add(l,M.tokens),m=M.endState}return{heuristicTokens:!0}}b($){let E=this._textModel.getLineFirstNonWhitespaceColumn($);const f=[];let m=null;for(let S=$-1;E>1&&S>=1;S--){const M=this._textModel.getLineFirstNonWhitespaceColumn(S);if(M!==0&&M<E&&(f.push(this._textModel.getLineContent(S)),E=M,m=this.getStartState(S),m))break}m||(m=this.tokenizationSupport.getInitialState()),f.reverse();const N=this._textModel.getLanguageId();let l=m;for(const S of f)l=B(this._languageIdCodec,N,this.tokenizationSupport,S,!1,l).endState;return l}}e.$OB=i;class a{constructor($){this.d=$,this.a=new w,this.b=new C,this.b.addRange(new t.$Bs(1,$+1))}getEndState($){return this.a.getEndState($)}setEndState($,E){if(!E)throw new k.$bb("Cannot set null/undefined state");this.b.delete($);const f=this.a.setEndState($,E);return f&&$<this.d&&this.b.addRange(new t.$Bs($+1,$+2)),f}acceptChange($,E){this.d+=E-$.length,this.a.acceptChange($,E),this.b.addRangeAndResize(new t.$Bs($.startLineNumber,$.endLineNumberExclusive),E)}acceptChanges($){for(const E of $){const[f]=(0,s.$7s)(E.text);this.acceptChange(new d.$Ds(E.range.startLineNumber,E.range.endLineNumber+1),f+1)}}invalidateEndStateRange($){this.b.addRange(new t.$Bs($.startLineNumber,$.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState($,E){return $===1?E:this.getEndState($-1)}getFirstInvalidLine($){const E=this.getFirstInvalidEndStateLineNumber();if(E===null)return null;const f=this.getStartState(E,$);if(!f)throw new k.$bb("Start state must be defined");return{lineNumber:E,startState:f}}}e.$PB=a;class w{constructor(){this.a=new h.$LB(null)}getEndState($){return this.a.get($)}setEndState($,E){const f=this.a.get($);return f&&f.equals(E)?!1:(this.a.set($,E),!0)}acceptChange($,E){let f=$.length;E>0&&f>0&&(f--,E--),this.a.replace($.startLineNumber,f,E)}acceptChanges($){for(const E of $){const[f]=(0,s.$7s)(E.text);this.acceptChange(new d.$Ds(E.range.startLineNumber,E.range.endLineNumber+1),f+1)}}}e.$QB=w;class C{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const $=this.a[0];return $.start+1===$.endExclusive?this.a.shift():this.a[0]=new t.$Bs($.start+1,$.endExclusive),$.start}delete($){const E=this.a.findIndex(f=>f.contains($));if(E!==-1){const f=this.a[E];f.start===$?f.endExclusive===$+1?this.a.splice(E,1):this.a[E]=new t.$Bs($+1,f.endExclusive):f.endExclusive===$+1?this.a[E]=new t.$Bs(f.start,$):this.a.splice(E,1,new t.$Bs(f.start,$),new t.$Bs($+1,f.endExclusive))}}addRange($){t.$Bs.addRange($,this.a)}addRangeAndResize($,E){let f=0;for(;!(f>=this.a.length||$.start<=this.a[f].endExclusive);)f++;let m=f;for(;!(m>=this.a.length||$.endExclusive<this.a[m].start);)m++;const N=E-$.length;for(let l=m;l<this.a.length;l++)this.a[l]=this.a[l].delta(N);if(f===m){const l=new t.$Bs($.start,$.start+E);l.isEmpty||this.a.splice(f,0,l)}else{const l=Math.min($.start,this.a[f].start),S=Math.max($.endExclusive,this.a[m-1].endExclusive),M=new t.$Bs(l,S+N);M.isEmpty?this.a.splice(f,m-f):this.a.splice(f,m-f,M)}}toString(){return this.a.map($=>$.toString()).join(" + ")}}e.$RB=C;function B(T,$,E,f,m,N){let l=null;if(E)try{l=E.tokenizeEncoded(f,m,N.clone())}catch(S){(0,k.$Z)(S)}return l||(l=(0,r.$KB)(T.encodeLanguageId($),N)),g.$8s.convertToEndOffset(l.tokens,f.length),l}class j{constructor($,E){this.b=$,this.d=E,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,P.$$g)($=>{this.f=!1,this.h($)}))}h($){const E=Date.now()+$.timeRemaining(),f=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<E?(0,v.$B)(f):this.g())};f()}j(){const $=this.b._textModel.getLineCount(),E=new o.$MB,f=I.$Jd.create(!1);do if(f.elapsed()>1||this.l(E)>=$)break;while(this.k());this.d.setTokens(E.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l($){const E=this.b?.getFirstInvalidLine();return E?(this.b.updateTokensUntilLine($,E.lineNumber),E.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens($,E){this.b.store.invalidateEndStateRange(new d.$Ds($,E))}}e.$SB=j}),define(q[37],K([0,1,33,2,36,14,34]),function(z,e,P,k,v,I,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Eb=void 0;class d extends k.$Rc{constructor(r,h,o,g,c,n,i){super(),this.c=r,this.f=h,this.g=o,this.h=g,this.j=c,this.m=n,this.n=i,this.a=[],this.b=this.B(new P.$Nd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(r,h,o){throw new Error("Not supported!")}createBackgroundTokenizer(r,h){if(this.h)return this.h(r,h)}tokenizeEncoded(r,h,o){const g=Math.random()*1e4<1,c=this.n||g,n=c?new v.$Jd(!0):void 0,i=this.c.tokenizeLine2(r,o,500);if(c){const w=n.elapsed();(g||w>32)&&this.m(w,r.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${r.substring(0,100)}`),new s.$dt(i.tokens,o);if(this.g){const w=this.a,C=i.tokens;for(let B=0,j=C.length>>>1;B<j;B++){const T=C[(B<<1)+1],$=I.$5s.getLanguageId(T);w[$]||(w[$]=!0,this.b.fire($))}}let a;return o.equals(i.ruleStack)?a=o:a=i.ruleStack,new s.$dt(i.tokens,a)}}e.$2Eb=d}),define(q[38],K([0,1,20,2,11]),function(z,e,P,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Eb=void 0;class I extends k.$Rc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,t,r){super(),this.a=d,this.b=t,this.c=r,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(d,t,r){throw new Error("Not supported!")}tokenizeEncoded(d,t,r){return d.length>=this.c.get()?(0,P.$KB)(this.a,r):this.b.tokenizeEncoded(d,t,r)}createBackgroundTokenizer(d,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(d,t)}}e.$3Eb=I}),define(q[39],K([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(z,e,P,k,v,I,s,d,t,r,h,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Eb=void 0;class c extends d.$Wu{constructor(a,w,C,B,j,T,$,E){super(a,w,C,B),this.s=j,this.t=T,this.u=$,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new k.$7g(()=>this.w(),10),this.c.set(E,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(a,w){this.t=a,this.u=w,this.v()}onEvents(a){super.onEvents(a),this.a?.store.acceptChanges(a.changes),this.q.schedule()}acceptMaxTokenizationLineLength(a){this.c.set(a,void 0)}retokenize(a,w){this.a&&(this.a.store.invalidateEndStateRange(new s.$Ds(a,w)),this.q.schedule())}async v(){this.a=null;const a=this.t,w=this.u,C=await this.s.getOrCreateGrammar(a,w);if(!(this.b||a!==this.t||w!==this.u||!C)){if(C.grammar){const B=new g.$3Eb(this.u,new o.$2Eb(C.grammar,C.initialState,!1,void 0,()=>!1,(j,T,$)=>{this.s.reportTokenizationTime(j,a,C.sourceExtensionId,T,$)},!1),this.c);this.a=new t.$NB(this.f.length,B)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:w}=await(0,P.$IC)("vscode-textmate","release/main.js");this.m=w}const a=new Date().getTime();for(;;){let w=0;const C=new r.$MB,B=new n;for(;;){const $=this.a.getFirstInvalidLine();if($===null||w>200)break;w++;const E=this.f[$.lineNumber-1],f=this.a.tokenizationSupport.tokenizeEncoded(E,!0,$.startState);if(this.a.store.setEndState($.lineNumber,f.endState)){const N=this.m($.startState,f.endState);B.setState($.lineNumber,N)}else B.setState($.lineNumber,null);if(h.$8s.convertToEndOffset(f.tokens,E.length),C.add($.lineNumber,f.tokens),new Date().getTime()-a>20)break}if(w===0)break;const j=B.getStateDeltas();if(this.s.setTokensAndStates(this.h,C.serialize(),j),new Date().getTime()-a>20){(0,I.$B)(()=>this.w());return}}}}e.$8Eb=c;class n{constructor(){this.a=-1,this.b=[]}setState(a,w){a===this.a+1?this.b[this.b.length-1].stateDeltas.push(w):this.b.push({startLineNumber:a,stateDeltas:[w]}),this.a=a}getStateDeltas(){return this.b}}}),define(q[40],K([0,1,18]),function(z,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Eb=void 0;class k{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(I){if(this.a[I.scopeName]){const s=this.a[I.scopeName];P.$og(s.location,I.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${I.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${I.location.toString()}`)}this.a[I.scopeName]=I}getGrammarDefinition(I){return this.a[I]||null}}e.$5Eb=k}),define(q[41],K([0,1,2,40]),function(z,e,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Eb=e.$6Eb=void 0,e.$6Eb="No TM Grammar registered for this language.";class v extends P.$Rc{constructor(s,d,t,r){super(),this.a=s,this.b=t.INITIAL,this.c=new k.$5Eb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:r,loadGrammar:async h=>{const o=this.c.getGrammarDefinition(h);if(!o)return this.a.logTrace(`No grammar found for scope ${h}`),null;const g=o.location;try{const c=await this.a.readFile(g);return t.parseRawGrammar(c,g.path)}catch(c){return this.a.logError(`Unable to load and parse grammar for scope ${h} from ${g}`,c),null}},getInjections:h=>{const o=h.split(".");let g=[];for(let c=1;c<=o.length;c++){const n=o.slice(0,c).join(".");g=[...g,...this.f[n]||[]]}return g}}));for(const h of d){if(this.c.register(h),h.injectTo){for(const o of h.injectTo){let g=this.f[o];g||(this.f[o]=g=[]),g.push(h.scopeName)}if(h.embeddedLanguages)for(const o of h.injectTo){let g=this.g[o];g||(this.g[o]=g=[]),g.push(h.embeddedLanguages)}}h.language&&this.h.set(h.language,h.scopeName)}}has(s){return this.h.has(s)}setTheme(s,d){this.j.setTheme(s,d)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,d){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$6Eb);const r=this.c.getGrammarDefinition(t);if(!r)throw new Error(e.$6Eb);const h=r.embeddedLanguages;if(this.g[t]){const c=this.g[t];for(const n of c)for(const i of Object.keys(n))h[i]=n[i]}const o=Object.keys(h).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(t,d,{embeddedLanguages:h,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(c){throw c.message&&c.message.startsWith("No grammar provided for")?new Error(e.$6Eb):c}return{languageId:s,grammar:g,initialState:this.b,containsEmbeddedLanguages:o,sourceExtensionId:r.sourceExtensionId}}}e.$7Eb=v}),define(q[49],K([0,1,8,41,39]),function(z,e,P,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function I(d,t){return new s(d,t)}e.create=I;class s{constructor(t,r){this.f=r,this.b=new Map,this.c=[],this.a=t.host;const h=r.grammarDefinitions.map(o=>({location:P.URI.revive(o.location),language:o.language,scopeName:o.scopeName,embeddedLanguages:o.embeddedLanguages,tokenTypes:o.tokenTypes,injectTo:o.injectTo,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors,sourceExtensionId:o.sourceExtensionId}));this.d=this.g(h)}async g(t){const r=this.f.textmateMainUri,h=await new Promise((i,a)=>{z([r],i,a)}),o=await new Promise((i,a)=>{z([this.f.onigurumaMainUri],i,a)}),c=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await o.loadWASM(c);const n=Promise.resolve({createOnigScanner:i=>o.createOnigScanner(i),createOnigString:i=>o.createOnigString(i)});return new k.$7Eb({logTrace:i=>{},logError:(i,a)=>console.error(i,a),readFile:i=>this.a.readFile(i)},t,h,n)}acceptNewModel(t){const r=P.URI.revive(t.uri),h=this;this.b.set(t.controllerId,new v.$8Eb(r,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(o,g){const c=await h.d;return c?(h.c[g]||(h.c[g]=c.createGrammar(o,g)),h.c[g]):Promise.resolve(null)},setTokensAndStates(o,g,c){h.a.setTokensAndStates(t.controllerId,o,g,c)},reportTokenizationTime(o,g,c,n,i){h.a.reportTokenizationTime(o,g,c,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,r){this.b.get(t).onEvents(r)}retokenize(t,r,h){this.b.get(t).retokenize(r,h)}acceptModelLanguageChanged(t,r,h){this.b.get(t).onLanguageId(r,h)}acceptRemovedModel(t){const r=this.b.get(t);r&&(r.dispose(),this.b.delete(t))}async acceptTheme(t,r){(await this.d)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this.b.get(t).acceptMaxTokenizationLineLength(r)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ec3f042f9d6b042b9b2e83082ca53f18fee92070/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
